/*******************************************************************************
  MRF24WG RTOS Wrapper Functions

  File Name:
    drv_wifi_rtos_wrapper.h

  Summary:
    MRF24WG RTOS Wrapper Functions

  Description:
    -Provides access to MRF24WG WiFi controller
    -Reference: MRF24WG Datasheet, IEEE 802.11 Standard
 *******************************************************************************/

// DOM-IGNORE-BEGIN
/*******************************************************************************
Copyright (c) 2012 released Microchip Technology Inc. All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED AS IS WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
 *******************************************************************************/

#ifndef _DRV_WIFI_RTOS_WRAPPER_H
#define _DRV_WIFI_RTOS_WRAPPER_H

bool DRV_WIFI_SemInit(OSAL_SEM_HANDLE_TYPE *sem);
void DRV_WIFI_SemDeInit(OSAL_SEM_HANDLE_TYPE *sem);
void DRV_WIFI_SemTake(OSAL_SEM_HANDLE_TYPE* sem, uint16_t waitMS);
void DRV_WIFI_SemGive(OSAL_SEM_HANDLE_TYPE* sem);
void DRV_WIFI_ISR_SemGive(OSAL_SEM_HANDLE_TYPE* sem);
bool DRV_WIFI_MutexInit(OSAL_MUTEX_HANDLE_TYPE *mutex);
void DRV_WIFI_MutexDeInit(OSAL_MUTEX_HANDLE_TYPE *mutex);
void DRV_WIFI_MutexLock(OSAL_MUTEX_HANDLE_TYPE* mutex, uint16_t waitMS);
void DRV_WIFI_MutexUnlock(OSAL_MUTEX_HANDLE_TYPE* mutex);
bool DRV_WIFI_TaskSyncInit(void);

#endif /* _DRV_WIFI_RTOS_WRAPPER_H */

