/***************************************************************
 * File Name:   mpfs_img2.c
 * Description: Defines an MPFS2 image to be stored in program memory.
 * Processor:   PIC32
 * Compiler:    Microchip C32,XC32
 *
 * NOT FOR HAND MODIFICATION
 * This file is automatically generated by the MPFS2 Utility
 * ALL MODIFICATIONS WILL BE OVERWRITTEN BY THE MPFS2 GENERATOR
 * Generated Mon Nov 10 2014 04:41:54 
 *
 * Software License Agreement
 *
 * Copyright (C) 2012 Microchip Technology Inc.  All rights
 * reserved.
 *
 * Microchip licenses to you the right to use, modify, copy, and distribute
 * software only embedded on a Microchip microcontroller or digital signal 
 * controller that is integrated into your product or third party product
 * (pursuant to the sublicense terms in the accompanying license agreement)

 * You should refer to the license agreement accompanying this 
 * Software for additional information regarding your rights and 
 * obligations.
 *
 * THE SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT
 * WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT
 * LIMITATION, ANY WARRANTY OF MERCHANTABILITY, FITNESS FOR A 
 * PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT SHALL
 * MICROCHIP BE LIABLE FOR ANY INCIDENTAL, SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF
 * PROCUREMENT OF SUBSTITUTE GOODS, TECHNOLOGY OR SERVICES, ANY CLAIMS
 * BY THIRD PARTIES (INCLUDING BUT NOT LIMITED TO ANY DEFENSE 
 * THEREOF), ANY CLAIMS FOR INDEMNITY OR CONTRIBUTION, OR OTHER 
 * SIMILAR COSTS, WHETHER ASSERTED ON THE BASIS OF CONTRACT, TORT
 * (INCLUDING NEGLIGENCE), BREACH OF WARRANTY, OR OTHERWISE.
 *
 ***************************************************************/
#include <stdint.h>
#include "system_config.h"

/**************************************
 * MPFS2 Image Data
 **************************************/ 

<#if CONFIG_DRV_WIFI_HTTP_CUSTOM_TEMPLATE != "Easy Configuration Demo" && CONFIG_DRV_WIFI_HTTP_CUSTOM_TEMPLATE != "Wi-Fi G Demo">
const uint8_t __attribute__((space(prog),address(DRV_NVM_MEDIA_START_ADDRESS))) NVM_MEDIA_DATA[DRV_NVM_MEDIA_SIZE*1024] = { \
	0x4d,0x50,0x46,0x53,0x02,0x01,0x19,0x00,0x4a,0xce,0xea,0x81,0xf0,0x94,0x2a,0xba, /* MPFS....J....... */ \
	0xf0,0xd6,0x26,0x4f,0x6a,0xa6,0xa8,0x7f,0x26,0x2d,0x0a,0xa3,0x46,0xce,0x2a,0xcf, /* ..&Oj...&-..F... */ \
	0x08,0xcf,0x3e,0x67,0x98,0xdb,0xcc,0x83,0x44,0xd8,0x0a,0x85,0xea,0x8a,0xea,0x92, /* ..>g....D....... */ \
	0x0a,0x4f,0x26,0xb6,0x8a,0xb6,0x0a,0x2f,0x0a,0x57,0x60,0x02,0x00,0x00,0x9b,0x03, /* .O&..../.W`..... */ \
	0x00,0x00,0x5e,0x05,0x00,0x00,0x93,0x22,0x28,0x56,0x00,0x00,0x00,0x00,0x02,0x00, /* ..^...."(V...... */ \
	0x69,0x02,0x00,0x00,0xf9,0x08,0x00,0x00,0x26,0x08,0x00,0x00,0x93,0x22,0x28,0x56, /* i.......&...."(V */ \
	0x00,0x00,0x00,0x00,0x02,0x00,0x75,0x02,0x00,0x00,0x1f,0x11,0x00,0x00,0x3a,0x03, /* ......u.......:. */ \
	0x00,0x00,0xbf,0x5c,0x4a,0x56,0x00,0x00,0x00,0x00,0x00,0x00,0x81,0x02,0x00,0x00, /* ...\JV.......... */ \
	0x59,0x14,0x00,0x00,0xca,0x07,0x00,0x00,0x93,0x22,0x28,0x56,0x00,0x00,0x00,0x00, /* Y........"(V.... */ \
	0x02,0x00,0x8d,0x02,0x00,0x00,0x23,0x1c,0x00,0x00,0x9a,0x00,0x00,0x00,0xbf,0x5c, /* ......#........\ */ \
	0x4a,0x56,0x00,0x00,0x00,0x00,0x00,0x00,0x9a,0x02,0x00,0x00,0xbd,0x1c,0x00,0x00, /* JV.............. */ \
	0xa1,0x00,0x00,0x00,0x93,0x22,0x28,0x56,0x00,0x00,0x00,0x00,0x00,0x00,0xa5,0x02, /* ....."(V........ */ \
	0x00,0x00,0x5e,0x1d,0x00,0x00,0xbe,0x07,0x00,0x00,0x93,0x22,0x28,0x56,0x00,0x00, /* ..^........"(V.. */ \
	0x00,0x00,0x02,0x00,0xaf,0x02,0x00,0x00,0x1c,0x25,0x00,0x00,0x3d,0x10,0x00,0x00, /* .........%..=... */ \
	0x93,0x22,0x28,0x56,0x00,0x00,0x00,0x00,0x01,0x00,0xbb,0x02,0x00,0x00,0x59,0x35, /* ."(V..........Y5 */ \
	0x00,0x00,0xa2,0x04,0x00,0x00,0x94,0x22,0x28,0x56,0x00,0x00,0x00,0x00,0x00,0x00, /* ......."(V...... */ \
	0xc6,0x02,0x00,0x00,0xfb,0x39,0x00,0x00,0x03,0x0f,0x00,0x00,0xa1,0xf0,0x3a,0x56, /* .....9........:V */ \
	0x00,0x00,0x00,0x00,0x02,0x00,0xd0,0x02,0x00,0x00,0xfe,0x48,0x00,0x00,0x11,0x00, /* ...........H.... */ \
	0x00,0x00,0x93,0x22,0x28,0x56,0x00,0x00,0x00,0x00,0x02,0x00,0xd9,0x02,0x00,0x00, /* ..."(V.......... */ \
	0x0f,0x49,0x00,0x00,0x9d,0x03,0x00,0x00,0x93,0x22,0x28,0x56,0x00,0x00,0x00,0x00, /* .I......."(V.... */ \
	0x01,0x00,0xe2,0x02,0x00,0x00,0xac,0x4c,0x00,0x00,0xe2,0x04,0x00,0x00,0x93,0x22, /* .......L......." */ \
	0x28,0x56,0x00,0x00,0x00,0x00,0x01,0x00,0xeb,0x02,0x00,0x00,0x8e,0x51,0x00,0x00, /* (V...........Q.. */ \
	0xc2,0x05,0x00,0x00,0x94,0x22,0x28,0x56,0x00,0x00,0x00,0x00,0x01,0x00,0xf3,0x02, /* ....."(V........ */ \
	0x00,0x00,0x50,0x57,0x00,0x00,0x00,0x02,0x00,0x00,0x93,0x22,0x28,0x56,0x00,0x00, /* ..PW......."(V.. */ \
	0x00,0x00,0x00,0x00,0xfc,0x02,0x00,0x00,0x50,0x59,0x00,0x00,0xb7,0x00,0x00,0x00, /* ........PY...... */ \
	0x93,0x22,0x28,0x56,0x00,0x00,0x00,0x00,0x02,0x00,0x07,0x03,0x00,0x00,0x07,0x5a, /* ."(V...........Z */ \
	0x00,0x00,0xec,0x00,0x00,0x00,0x93,0x22,0x28,0x56,0x00,0x00,0x00,0x00,0x01,0x00, /* ......."(V...... */ \
	0x10,0x03,0x00,0x00,0xf3,0x5a,0x00,0x00,0x9f,0x03,0x00,0x00,0x93,0x22,0x28,0x56, /* .....Z......."(V */ \
	0x00,0x00,0x00,0x00,0x02,0x00,0x1b,0x03,0x00,0x00,0x92,0x5e,0x00,0x00,0x3f,0x05, /* ...........^..?. */ \
	0x00,0x00,0x93,0x22,0x28,0x56,0x00,0x00,0x00,0x00,0x02,0x00,0x2f,0x03,0x00,0x00, /* ..."(V....../... */ \
	0xd1,0x63,0x00,0x00,0x60,0x07,0x00,0x00,0x93,0x22,0x28,0x56,0x00,0x00,0x00,0x00, /* .c..`...."(V.... */ \
	0x02,0x00,0x42,0x03,0x00,0x00,0x31,0x6b,0x00,0x00,0xd9,0x03,0x00,0x00,0x93,0x22, /* ..B...1k......." */ \
	0x28,0x56,0x00,0x00,0x00,0x00,0x02,0x00,0x54,0x03,0x00,0x00,0x0a,0x6f,0x00,0x00, /* (V......T....o.. */ \
	0x08,0x00,0x00,0x00,0x93,0x22,0x28,0x56,0x00,0x00,0x00,0x00,0x02,0x00,0x67,0x03, /* ....."(V......g. */ \
	0x00,0x00,0x12,0x6f,0x00,0x00,0xf3,0x06,0x00,0x00,0x93,0x22,0x28,0x56,0x00,0x00, /* ...o......."(V.. */ \
	0x00,0x00,0x02,0x00,0x7a,0x03,0x00,0x00,0x05,0x76,0x00,0x00,0x53,0x07,0x00,0x00, /* ....z....v..S... */ \
	0x93,0x22,0x28,0x56,0x00,0x00,0x00,0x00,0x02,0x00,0x8a,0x03,0x00,0x00,0x58,0x7d, /* ."(V..........X} */ \
	0x00,0x00,0xb5,0x05,0x00,0x00,0x93,0x22,0x28,0x56,0x00,0x00,0x00,0x00,0x02,0x00, /* ......."(V...... */ \
	0x61,0x75,0x74,0x68,0x2e,0x68,0x74,0x6d,0x00,0x63,0x6f,0x6f,0x6b,0x69,0x65,0x73, /* auth.htm.cookies */ \
	0x2e,0x68,0x74,0x6d,0x00,0x44,0x79,0x6e,0x52,0x63,0x72,0x64,0x2e,0x62,0x69,0x6e, /* .htm.DynRcrd.bin */ \
	0x00,0x64,0x79,0x6e,0x76,0x61,0x72,0x73,0x2e,0x68,0x74,0x6d,0x00,0x46,0x69,0x6c, /* .dynvars.htm.Fil */ \
	0x65,0x52,0x63,0x72,0x64,0x2e,0x62,0x69,0x6e,0x00,0x66,0x6f,0x6f,0x74,0x65,0x72, /* eRcrd.bin.footer */ \
	0x2e,0x69,0x6e,0x63,0x00,0x66,0x6f,0x72,0x6d,0x73,0x2e,0x68,0x74,0x6d,0x00,0x68, /* .inc.forms.htm.h */ \
	0x61,0x72,0x6d,0x6f,0x6e,0x79,0x2e,0x67,0x69,0x66,0x00,0x68,0x65,0x61,0x64,0x65, /* armony.gif.heade */ \
	0x72,0x2e,0x69,0x6e,0x63,0x00,0x69,0x6e,0x64,0x65,0x78,0x2e,0x68,0x74,0x6d,0x00, /* r.inc.index.htm. */ \
	0x6c,0x65,0x64,0x73,0x2e,0x63,0x67,0x69,0x00,0x6d,0x63,0x68,0x70,0x2e,0x63,0x73, /* leds.cgi.mchp.cs */ \
	0x73,0x00,0x6d,0x63,0x68,0x70,0x2e,0x67,0x69,0x66,0x00,0x6d,0x63,0x68,0x70,0x2e, /* s.mchp.gif.mchp. */ \
	0x6a,0x73,0x00,0x73,0x6e,0x6d,0x70,0x2e,0x62,0x69,0x62,0x00,0x73,0x74,0x61,0x74, /* js.snmp.bib.stat */ \
	0x75,0x73,0x2e,0x78,0x6d,0x6c,0x00,0x74,0x65,0x6d,0x70,0x2e,0x63,0x70,0x66,0x00, /* us.xml.temp.cpf. */ \
	0x75,0x70,0x6c,0x6f,0x61,0x64,0x2e,0x68,0x74,0x6d,0x00,0x73,0x6e,0x6d,0x70,0x2f, /* upload.htm.snmp/ */ \
	0x73,0x6e,0x6d,0x70,0x63,0x6f,0x6e,0x66,0x69,0x67,0x2e,0x68,0x74,0x6d,0x00,0x70, /* snmpconfig.htm.p */ \
	0x72,0x6f,0x74,0x65,0x63,0x74,0x2f,0x63,0x6f,0x6e,0x66,0x69,0x67,0x2e,0x68,0x74, /* rotect/config.ht */ \
	0x6d,0x00,0x70,0x72,0x6f,0x74,0x65,0x63,0x74,0x2f,0x69,0x6e,0x64,0x65,0x78,0x2e, /* m.protect/index. */ \
	0x68,0x74,0x6d,0x00,0x70,0x72,0x6f,0x74,0x65,0x63,0x74,0x2f,0x72,0x65,0x62,0x6f, /* htm.protect/rebo */ \
	0x6f,0x74,0x2e,0x63,0x67,0x69,0x00,0x70,0x72,0x6f,0x74,0x65,0x63,0x74,0x2f,0x72, /* ot.cgi.protect/r */ \
	0x65,0x62,0x6f,0x6f,0x74,0x2e,0x68,0x74,0x6d,0x00,0x65,0x6d,0x61,0x69,0x6c,0x2f, /* eboot.htm.email/ */ \
	0x69,0x6e,0x64,0x65,0x78,0x2e,0x68,0x74,0x6d,0x00,0x64,0x79,0x6e,0x64,0x6e,0x73, /* index.htm.dyndns */ \
	0x2f,0x69,0x6e,0x64,0x65,0x78,0x2e,0x68,0x74,0x6d,0x00,0x7e,0x69,0x6e,0x63,0x3a, /* /index.htm.~inc: */ \
	0x68,0x65,0x61,0x64,0x65,0x72,0x2e,0x69,0x6e,0x63,0x7e,0x0d,0x0a,0x3c,0x64,0x69, /* header.inc~..<di */ \
	0x76,0x20,0x69,0x64,0x3d,0x22,0x63,0x6f,0x6e,0x74,0x65,0x6e,0x74,0x22,0x3e,0x0d, /* v id="content">. */ \
	0x0a,0x0d,0x0a,0x3c,0x68,0x31,0x3e,0x41,0x75,0x74,0x68,0x65,0x6e,0x74,0x69,0x63, /* ...<h1>Authentic */ \
	0x61,0x74,0x69,0x6f,0x6e,0x3c,0x2f,0x68,0x31,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70, /* ation</h1>....<p */ \
	0x3e,0x4d,0x61,0x6e,0x79,0x20,0x61,0x70,0x70,0x6c,0x69,0x63,0x61,0x74,0x69,0x6f, /* >Many applicatio */ \
	0x6e,0x73,0x20,0x6e,0x65,0x65,0x64,0x20,0x74,0x6f,0x20,0x72,0x65,0x73,0x74,0x72, /* ns need to restr */ \
	0x69,0x63,0x74,0x20,0x61,0x63,0x63,0x65,0x73,0x73,0x20,0x74,0x6f,0x20,0x61,0x75, /* ict access to au */ \
	0x74,0x68,0x6f,0x72,0x69,0x7a,0x65,0x64,0x20,0x75,0x73,0x65,0x72,0x73,0x2e,0x20, /* thorized users.  */ \
	0x20,0x54,0x68,0x65,0x20,0x48,0x54,0x54,0x50,0x20,0x0d,0x0a,0x73,0x65,0x72,0x76, /*  The HTTP ..serv */ \
	0x65,0x72,0x20,0x73,0x75,0x70,0x70,0x6f,0x72,0x74,0x73,0x20,0x42,0x61,0x73,0x69, /* er supports Basi */ \
	0x63,0x20,0x48,0x54,0x54,0x50,0x20,0x41,0x75,0x74,0x68,0x65,0x6e,0x74,0x69,0x63, /* c HTTP Authentic */ \
	0x61,0x74,0x69,0x6f,0x6e,0x20,0x74,0x6f,0x20,0x70,0x72,0x6f,0x76,0x69,0x64,0x65, /* ation to provide */ \
	0x20,0x74,0x68,0x69,0x73,0x20,0x66,0x75,0x6e,0x63,0x74,0x69,0x6f,0x6e,0x61,0x6c, /*  this functional */ \
	0x69,0x74,0x79,0x2e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70,0x3e,0x54, /* ity.</p>....<p>T */ \
	0x77,0x6f,0x20,0x66,0x75,0x6e,0x63,0x74,0x69,0x6f,0x6e,0x73,0x20,0x61,0x72,0x65, /* wo functions are */ \
	0x20,0x69,0x6e,0x76,0x6f,0x6c,0x76,0x65,0x64,0x20,0x77,0x69,0x74,0x68,0x20,0x61, /*  involved with a */ \
	0x75,0x74,0x68,0x65,0x6e,0x74,0x69,0x63,0x61,0x74,0x69,0x6f,0x6e,0x2c,0x20,0x62, /* uthentication, b */ \
	0x6f,0x74,0x68,0x20,0x6f,0x66,0x20,0x77,0x68,0x69,0x63,0x68,0x20,0x73,0x74,0x6f, /* oth of which sto */ \
	0x72,0x65,0x20,0x61,0x0d,0x0a,0x72,0x65,0x74,0x75,0x72,0x6e,0x20,0x76,0x61,0x6c, /* re a..return val */ \
	0x75,0x65,0x20,0x69,0x6e,0x20,0x70,0x65,0x72,0x20,0x48,0x54,0x54,0x50,0x20,0x63, /* ue in per HTTP c */ \
	0x6f,0x6e,0x6e,0x65,0x63,0x74,0x69,0x6f,0x6e,0x20,0x64,0x61,0x74,0x61,0x20,0x73, /* onnection data s */ \
	0x74,0x72,0x75,0x63,0x74,0x75,0x72,0x65,0x2e,0x20,0x20,0x54,0x68,0x65,0x20,0x4d, /* tructure.  The M */ \
	0x53,0x62,0x20,0x6f,0x66,0x20,0x74,0x68,0x69,0x73,0x20,0x76,0x61,0x6c,0x75,0x65, /* Sb of this value */ \
	0x0d,0x0a,0x69,0x6e,0x64,0x69,0x63,0x61,0x74,0x65,0x73,0x20,0x77,0x68,0x65,0x74, /* ..indicates whet */ \
	0x68,0x65,0x72,0x20,0x6f,0x72,0x20,0x6e,0x6f,0x74,0x20,0x61,0x63,0x63,0x65,0x73, /* her or not acces */ \
	0x73,0x20,0x69,0x73,0x20,0x61,0x6c,0x6c,0x6f,0x77,0x65,0x64,0x2e,0x20,0x20,0x54, /* s is allowed.  T */ \
	0x68,0x65,0x20,0x66,0x69,0x72,0x73,0x74,0x20,0x63,0x61,0x6c,0x6c,0x62,0x61,0x63, /* he first callbac */ \
	0x6b,0x2c,0x20,0x0d,0x0a,0x3c,0x63,0x6f,0x64,0x65,0x3e,0x54,0x43,0x50,0x49,0x50, /* k, ..<code>TCPIP */ \
	0x5f,0x48,0x54,0x54,0x50,0x5f,0x46,0x69,0x6c,0x65,0x41,0x75,0x74,0x68,0x65,0x6e, /* _HTTP_FileAuthen */ \
	0x74,0x69,0x63,0x61,0x74,0x65,0x3c,0x2f,0x63,0x6f,0x64,0x65,0x3e,0x2c,0x20,0x64, /* ticate</code>, d */ \
	0x65,0x74,0x65,0x72,0x6d,0x69,0x6e,0x65,0x73,0x20,0x69,0x66,0x20,0x74,0x68,0x65, /* etermines if the */ \
	0x20,0x72,0x65,0x71,0x75,0x65,0x73,0x74,0x65,0x64,0x20,0x70,0x61,0x67,0x65,0x20, /*  requested page  */ \
	0x72,0x65,0x71,0x75,0x69,0x72,0x65,0x73,0x0d,0x0a,0x76,0x61,0x6c,0x69,0x64,0x20, /* requires..valid  */ \
	0x63,0x72,0x65,0x64,0x65,0x6e,0x74,0x69,0x61,0x6c,0x73,0x20,0x74,0x6f,0x20,0x70, /* credentials to p */ \
	0x72,0x6f,0x63,0x65,0x65,0x64,0x2e,0x20,0x20,0x52,0x65,0x74,0x75,0x72,0x6e,0x20, /* roceed.  Return  */ \
	0x61,0x20,0x76,0x61,0x6c,0x75,0x65,0x20,0x6f,0x66,0x20,0x3c,0x63,0x6f,0x64,0x65, /* a value of <code */ \
	0x3e,0x30,0x78,0x38,0x30,0x3c,0x2f,0x63,0x6f,0x64,0x65,0x3e,0x20,0x6f,0x72,0x20, /* >0x80</code> or  */ \
	0x67,0x72,0x65,0x61,0x74,0x65,0x72,0x20,0x0d,0x0a,0x74,0x6f,0x20,0x61,0x6c,0x6c, /* greater ..to all */ \
	0x6f,0x77,0x20,0x61,0x63,0x63,0x65,0x73,0x73,0x20,0x75,0x6e,0x63,0x6f,0x6e,0x64, /* ow access uncond */ \
	0x69,0x74,0x69,0x6f,0x6e,0x61,0x6c,0x6c,0x79,0x2e,0x20,0x20,0x52,0x65,0x74,0x75, /* itionally.  Retu */ \
	0x72,0x6e,0x20,0x3c,0x63,0x6f,0x64,0x65,0x3e,0x30,0x78,0x37,0x39,0x3c,0x2f,0x63, /* rn <code>0x79</c */ \
	0x6f,0x64,0x65,0x3e,0x20,0x6f,0x72,0x20,0x6c,0x6f,0x77,0x65,0x72,0x20,0x74,0x6f, /* ode> or lower to */ \
	0x20,0x72,0x65,0x71,0x75,0x69,0x72,0x65,0x20,0x0d,0x0a,0x61,0x75,0x74,0x68,0x6f, /*  require ..autho */ \
	0x72,0x69,0x7a,0x61,0x74,0x69,0x6f,0x6e,0x2e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d, /* rization.</p>... */ \
	0x0a,0x54,0x68,0x65,0x20,0x73,0x65,0x63,0x6f,0x6e,0x64,0x2c,0x20,0x3c,0x63,0x6f, /* .The second, <co */ \
	0x64,0x65,0x3e,0x54,0x43,0x50,0x49,0x50,0x5f,0x48,0x54,0x54,0x50,0x5f,0x55,0x73, /* de>TCPIP_HTTP_Us */ \
	0x65,0x72,0x41,0x75,0x74,0x68,0x65,0x6e,0x74,0x69,0x63,0x61,0x74,0x65,0x3c,0x2f, /* erAuthenticate</ */ \
	0x63,0x6f,0x64,0x65,0x3e,0x20,0x64,0x65,0x74,0x65,0x72,0x6d,0x69,0x6e,0x65,0x73, /* code> determines */ \
	0x20,0x69,0x66,0x20,0x74,0x68,0x65,0x20,0x73,0x75,0x70,0x70,0x6c,0x69,0x65,0x64, /*  if the supplied */ \
	0x20,0x63,0x72,0x65,0x64,0x65,0x6e,0x74,0x69,0x61,0x6c,0x73,0x20,0x0d,0x0a,0x61, /*  credentials ..a */ \
	0x72,0x65,0x20,0x61,0x63,0x63,0x65,0x70,0x74,0x61,0x62,0x6c,0x65,0x20,0x66,0x6f, /* re acceptable fo */ \
	0x72,0x20,0x74,0x68,0x65,0x20,0x72,0x65,0x71,0x75,0x65,0x73,0x74,0x65,0x64,0x20, /* r the requested  */ \
	0x70,0x61,0x67,0x65,0x2e,0x20,0x20,0x59,0x6f,0x75,0x72,0x20,0x61,0x70,0x70,0x6c, /* page.  Your appl */ \
	0x69,0x63,0x61,0x74,0x69,0x6f,0x6e,0x20,0x73,0x68,0x6f,0x75,0x6c,0x64,0x20,0x72, /* ication should r */ \
	0x65,0x74,0x75,0x72,0x6e,0x20,0x61,0x20,0x76,0x61,0x6c,0x75,0x65,0x20,0x0d,0x0a, /* eturn a value .. */ \
	0x67,0x72,0x65,0x61,0x74,0x65,0x72,0x20,0x74,0x68,0x61,0x6e,0x20,0x3c,0x63,0x6f, /* greater than <co */ \
	0x64,0x65,0x3e,0x30,0x78,0x38,0x30,0x3c,0x2f,0x63,0x6f,0x64,0x65,0x3e,0x20,0x74, /* de>0x80</code> t */ \
	0x6f,0x20,0x70,0x65,0x72,0x6d,0x69,0x74,0x20,0x61,0x63,0x63,0x65,0x73,0x73,0x2c, /* o permit access, */ \
	0x20,0x6f,0x72,0x20,0x61,0x20,0x76,0x61,0x6c,0x75,0x65,0x20,0x6c,0x65,0x73,0x73, /*  or a value less */ \
	0x20,0x74,0x68,0x61,0x6e,0x20,0x0d,0x0a,0x3c,0x63,0x6f,0x64,0x65,0x3e,0x30,0x78, /*  than ..<code>0x */ \
	0x37,0x39,0x3c,0x2f,0x63,0x6f,0x64,0x65,0x3e,0x20,0x74,0x6f,0x20,0x72,0x65,0x6a, /* 79</code> to rej */ \
	0x65,0x63,0x74,0x20,0x74,0x68,0x65,0x20,0x70,0x61,0x73,0x73,0x77,0x6f,0x72,0x64, /* ect the password */ \
	0x20,0x73,0x75,0x70,0x70,0x6c,0x69,0x65,0x64,0x2e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a, /*  supplied.</p>.. */ \
	0x0d,0x0a,0x3c,0x70,0x3e,0x41,0x73,0x20,0x61,0x6e,0x20,0x65,0x78,0x61,0x6d,0x70, /* ..<p>As an examp */ \
	0x6c,0x65,0x2c,0x20,0x61,0x63,0x63,0x65,0x73,0x73,0x20,0x74,0x68,0x69,0x73,0x20, /* le, access this  */ \
	0x72,0x65,0x73,0x74,0x72,0x69,0x63,0x74,0x65,0x64,0x20,0x70,0x61,0x67,0x65,0x3a, /* restricted page: */ \
	0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x63,0x6c,0x61, /* </p>....<div cla */ \
	0x73,0x73,0x3d,0x22,0x65,0x78,0x61,0x6d,0x70,0x6c,0x65,0x62,0x6f,0x78,0x22,0x3e, /* ss="examplebox"> */ \
	0x0d,0x0a,0x3c,0x62,0x3e,0x55,0x73,0x65,0x72,0x20,0x4e,0x61,0x6d,0x65,0x3a,0x3c, /* ..<b>User Name:< */ \
	0x2f,0x62,0x3e,0x20,0x61,0x64,0x6d,0x69,0x6e,0x20,0x26,0x6e,0x62,0x73,0x70,0x3b, /* /b> admin &nbsp; */ \
	0x20,0x26,0x6e,0x62,0x73,0x70,0x3b,0x20,0x26,0x6e,0x62,0x73,0x70,0x3b,0x20,0x3c, /*  &nbsp; &nbsp; < */ \
	0x62,0x3e,0x50,0x61,0x73,0x73,0x77,0x6f,0x72,0x64,0x3a,0x3c,0x2f,0x62,0x3e,0x20, /* b>Password:</b>  */ \
	0x6d,0x69,0x63,0x72,0x6f,0x63,0x68,0x69,0x70,0x3c,0x62,0x72,0x20,0x2f,0x3e,0x0d, /* microchip<br />. */ \
	0x0a,0x3c,0x61,0x20,0x68,0x72,0x65,0x66,0x3d,0x22,0x2f,0x70,0x72,0x6f,0x74,0x65, /* .<a href="/prote */ \
	0x63,0x74,0x22,0x3e,0x41,0x63,0x63,0x65,0x73,0x73,0x20,0x52,0x65,0x73,0x74,0x72, /* ct">Access Restr */ \
	0x69,0x63,0x74,0x65,0x64,0x20,0x50,0x61,0x67,0x65,0x3c,0x2f,0x61,0x3e,0x0d,0x0a, /* icted Page</a>.. */ \
	0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x2f,0x64,0x69,0x76,0x3e, /* </div>....</div> */ \
	0x0d,0x0a,0x0d,0x0a,0x3c,0x73,0x63,0x72,0x69,0x70,0x74,0x20,0x74,0x79,0x70,0x65, /* ....<script type */ \
	0x3d,0x22,0x74,0x65,0x78,0x74,0x2f,0x6a,0x61,0x76,0x61,0x73,0x63,0x72,0x69,0x70, /* ="text/javascrip */ \
	0x74,0x22,0x3e,0x0d,0x0a,0x3c,0x21,0x2d,0x2d,0x0d,0x0a,0x64,0x6f,0x63,0x75,0x6d, /* t">..<!--..docum */ \
	0x65,0x6e,0x74,0x2e,0x67,0x65,0x74,0x45,0x6c,0x65,0x6d,0x65,0x6e,0x74,0x42,0x79, /* ent.getElementBy */ \
	0x49,0x64,0x28,0x27,0x68,0x65,0x6c,0x6c,0x6f,0x27,0x29,0x2e,0x69,0x6e,0x6e,0x65, /* Id('hello').inne */ \
	0x72,0x48,0x54,0x4d,0x4c,0x20,0x3d,0x20,0x22,0x7e,0x68,0x65,0x6c,0x6c,0x6f,0x6d, /* rHTML = "~hellom */ \
	0x73,0x67,0x7e,0x22,0x3b,0x0d,0x0a,0x2d,0x2d,0x3e,0x0d,0x0a,0x3c,0x2f,0x73,0x63, /* sg~";..-->..</sc */ \
	0x72,0x69,0x70,0x74,0x3e,0x0d,0x0a,0x7e,0x69,0x6e,0x63,0x3a,0x66,0x6f,0x6f,0x74, /* ript>..~inc:foot */ \
	0x65,0x72,0x2e,0x69,0x6e,0x63,0x7e,0x0d,0x0a,0x7e,0x69,0x6e,0x63,0x3a,0x68,0x65, /* er.inc~..~inc:he */ \
	0x61,0x64,0x65,0x72,0x2e,0x69,0x6e,0x63,0x7e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20, /* ader.inc~..<div  */ \
	0x69,0x64,0x3d,0x22,0x63,0x6f,0x6e,0x74,0x65,0x6e,0x74,0x22,0x3e,0x0d,0x0a,0x0d, /* id="content">... */ \
	0x0a,0x3c,0x68,0x31,0x3e,0x43,0x6f,0x6f,0x6b,0x69,0x65,0x73,0x3c,0x2f,0x68,0x31, /* .<h1>Cookies</h1 */ \
	0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70,0x3e,0x43,0x6f,0x6f,0x6b,0x69,0x65,0x73,0x20, /* >....<p>Cookies  */ \
	0x61,0x72,0x65,0x20,0x73,0x6d,0x61,0x6c,0x6c,0x20,0x74,0x65,0x78,0x74,0x20,0x73, /* are small text s */ \
	0x74,0x72,0x69,0x6e,0x67,0x73,0x20,0x74,0x68,0x61,0x74,0x20,0x61,0x72,0x65,0x20, /* trings that are  */ \
	0x73,0x74,0x6f,0x72,0x65,0x64,0x20,0x69,0x6e,0x20,0x74,0x68,0x65,0x20,0x62,0x72, /* stored in the br */ \
	0x6f,0x77,0x73,0x65,0x72,0x2e,0x20,0x20,0x54,0x68,0x65,0x73,0x65,0x20,0x73,0x74, /* owser.  These st */ \
	0x72,0x69,0x6e,0x67,0x73,0x0d,0x0a,0x61,0x72,0x65,0x20,0x73,0x65,0x74,0x20,0x62, /* rings..are set b */ \
	0x79,0x20,0x74,0x68,0x65,0x20,0x73,0x65,0x72,0x76,0x65,0x72,0x2c,0x20,0x61,0x6e, /* y the server, an */ \
	0x64,0x20,0x72,0x65,0x74,0x75,0x72,0x6e,0x65,0x64,0x20,0x61,0x73,0x20,0x70,0x61, /* d returned as pa */ \
	0x72,0x61,0x6d,0x65,0x74,0x65,0x72,0x73,0x20,0x66,0x6f,0x72,0x20,0x61,0x6c,0x6c, /* rameters for all */ \
	0x20,0x66,0x75,0x74,0x75,0x72,0x65,0x20,0x72,0x65,0x71,0x75,0x65,0x73,0x74,0x73, /*  future requests */ \
	0x20,0x75,0x6e,0x74,0x69,0x6c,0x0d,0x0a,0x74,0x68,0x65,0x20,0x73,0x65,0x73,0x73, /*  until..the sess */ \
	0x69,0x6f,0x6e,0x20,0x65,0x6e,0x64,0x73,0x2e,0x20,0x20,0x54,0x68,0x65,0x79,0x20, /* ion ends.  They  */ \
	0x63,0x61,0x6e,0x20,0x62,0x65,0x20,0x75,0x73,0x65,0x64,0x20,0x74,0x6f,0x20,0x73, /* can be used to s */ \
	0x74,0x6f,0x72,0x65,0x20,0x73,0x65,0x73,0x73,0x69,0x6f,0x6e,0x20,0x73,0x74,0x61, /* tore session sta */ \
	0x74,0x65,0x20,0x69,0x6e,0x66,0x6f,0x72,0x6d,0x61,0x74,0x69,0x6f,0x6e,0x2c,0x20, /* te information,  */ \
	0x61,0x6e,0x64,0x20,0x61,0x72,0x65,0x0d,0x0a,0x76,0x61,0x6c,0x69,0x64,0x20,0x75, /* and are..valid u */ \
	0x6e,0x74,0x69,0x6c,0x20,0x74,0x68,0x65,0x20,0x62,0x72,0x6f,0x77,0x73,0x65,0x72, /* ntil the browser */ \
	0x20,0x69,0x73,0x20,0x63,0x6c,0x6f,0x73,0x65,0x64,0x2e,0x3c,0x2f,0x70,0x3e,0x0d, /*  is closed.</p>. */ \
	0x0a,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x63,0x6c,0x61,0x73,0x73,0x3d,0x22,0x65, /* ...<div class="e */ \
	0x78,0x61,0x6d,0x70,0x6c,0x65,0x62,0x6f,0x78,0x22,0x3e,0x0d,0x0a,0x3c,0x74,0x61, /* xamplebox">..<ta */ \
	0x62,0x6c,0x65,0x20,0x61,0x6c,0x69,0x67,0x6e,0x3d,0x22,0x63,0x65,0x6e,0x74,0x65, /* ble align="cente */ \
	0x72,0x22,0x3e,0x0d,0x0a,0x3c,0x74,0x72,0x3e,0x3c,0x74,0x64,0x3e,0x3c,0x62,0x3e, /* r">..<tr><td><b> */ \
	0x4e,0x61,0x6d,0x65,0x3a,0x3c,0x2f,0x62,0x3e,0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x74, /* Name:</b></td><t */ \
	0x64,0x3e,0x7e,0x63,0x6f,0x6f,0x6b,0x69,0x65,0x6e,0x61,0x6d,0x65,0x7e,0x3c,0x2f, /* d>~cookiename~</ */ \
	0x74,0x64,0x3e,0x3c,0x2f,0x74,0x72,0x3e,0x0d,0x0a,0x3c,0x74,0x72,0x3e,0x3c,0x74, /* td></tr>..<tr><t */ \
	0x64,0x3e,0x3c,0x62,0x3e,0x46,0x61,0x76,0x6f,0x72,0x69,0x74,0x65,0x3a,0x3c,0x2f, /* d><b>Favorite:</ */ \
	0x62,0x3e,0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x74,0x64,0x3e,0x7e,0x63,0x6f,0x6f,0x6b, /* b></td><td>~cook */ \
	0x69,0x65,0x66,0x61,0x76,0x7e,0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x2f,0x74,0x72,0x3e, /* iefav~</td></tr> */ \
	0x0d,0x0a,0x3c,0x2f,0x74,0x61,0x62,0x6c,0x65,0x3e,0x0d,0x0a,0x3c,0x2f,0x64,0x69, /* ..</table>..</di */ \
	0x76,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70,0x3e,0x54,0x68,0x65,0x72,0x65,0x20,0x61, /* v>....<p>There a */ \
	0x72,0x65,0x20,0x6e,0x75,0x6d,0x65,0x72,0x6f,0x75,0x73,0x20,0x75,0x73,0x65,0x73, /* re numerous uses */ \
	0x20,0x66,0x6f,0x72,0x20,0x63,0x6f,0x6f,0x6b,0x69,0x65,0x73,0x2e,0x20,0x20,0x49, /*  for cookies.  I */ \
	0x6e,0x20,0x74,0x68,0x69,0x73,0x20,0x65,0x78,0x61,0x6d,0x70,0x6c,0x65,0x2c,0x20, /* n this example,  */ \
	0x74,0x68,0x65,0x20,0x75,0x73,0x65,0x72,0x27,0x73,0x20,0x6e,0x61,0x6d,0x65,0x20, /* the user's name  */ \
	0x69,0x73,0x0d,0x0a,0x73,0x74,0x6f,0x72,0x65,0x64,0x20,0x61,0x73,0x20,0x61,0x20, /* is..stored as a  */ \
	0x63,0x6f,0x6f,0x6b,0x69,0x65,0x2e,0x20,0x20,0x41,0x6c,0x6c,0x20,0x66,0x75,0x74, /* cookie.  All fut */ \
	0x75,0x72,0x65,0x20,0x70,0x61,0x67,0x65,0x20,0x6c,0x6f,0x61,0x64,0x73,0x20,0x77, /* ure page loads w */ \
	0x69,0x6c,0x6c,0x20,0x73,0x68,0x6f,0x77,0x20,0x74,0x68,0x69,0x73,0x20,0x6e,0x61, /* ill show this na */ \
	0x6d,0x65,0x20,0x69,0x6e,0x20,0x74,0x68,0x65,0x20,0x74,0x6f,0x70,0x20,0x6c,0x65, /* me in the top le */ \
	0x66,0x74,0x0d,0x0a,0x63,0x6f,0x72,0x6e,0x65,0x72,0x2c,0x20,0x61,0x73,0x20,0x77, /* ft..corner, as w */ \
	0x65,0x6c,0x6c,0x20,0x61,0x73,0x20,0x69,0x6e,0x20,0x74,0x68,0x65,0x20,0x62,0x6f, /* ell as in the bo */ \
	0x78,0x20,0x61,0x62,0x6f,0x76,0x65,0x2e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a, /* x above.</p>.... */ \
	0x3c,0x66,0x6f,0x72,0x6d,0x20,0x61,0x63,0x74,0x69,0x6f,0x6e,0x3d,0x22,0x63,0x6f, /* <form action="co */ \
	0x6f,0x6b,0x69,0x65,0x73,0x2e,0x68,0x74,0x6d,0x22,0x20,0x6d,0x65,0x74,0x68,0x6f, /* okies.htm" metho */ \
	0x64,0x3d,0x22,0x67,0x65,0x74,0x22,0x3e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x63, /* d="get">..<div c */ \
	0x6c,0x61,0x73,0x73,0x3d,0x22,0x65,0x78,0x61,0x6d,0x70,0x6c,0x65,0x62,0x6f,0x78, /* lass="examplebox */ \
	0x22,0x3e,0x0d,0x0a,0x3c,0x74,0x61,0x62,0x6c,0x65,0x20,0x61,0x6c,0x69,0x67,0x6e, /* ">..<table align */ \
	0x3d,0x22,0x63,0x65,0x6e,0x74,0x65,0x72,0x22,0x3e,0x0d,0x0a,0x3c,0x74,0x72,0x3e, /* ="center">..<tr> */ \
	0x3c,0x74,0x64,0x3e,0x3c,0x62,0x3e,0x46,0x69,0x72,0x73,0x74,0x20,0x4e,0x61,0x6d, /* <td><b>First Nam */ \
	0x65,0x3a,0x3c,0x2f,0x62,0x3e,0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x74,0x64,0x3e,0x3c, /* e:</b></td><td>< */ \
	0x69,0x6e,0x70,0x75,0x74,0x20,0x74,0x79,0x70,0x65,0x3d,0x22,0x74,0x65,0x78,0x74, /* input type="text */ \
	0x22,0x20,0x6e,0x61,0x6d,0x65,0x3d,0x22,0x6e,0x61,0x6d,0x65,0x22,0x20,0x73,0x69, /* " name="name" si */ \
	0x7a,0x65,0x3d,0x22,0x32,0x30,0x22,0x20,0x6d,0x61,0x78,0x6c,0x65,0x6e,0x67,0x74, /* ze="20" maxlengt */ \
	0x68,0x3d,0x22,0x31,0x36,0x22,0x20,0x2f,0x3e,0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x2f, /* h="16" /></td></ */ \
	0x74,0x72,0x3e,0x0d,0x0a,0x3c,0x74,0x72,0x3e,0x3c,0x74,0x64,0x3e,0x3c,0x62,0x3e, /* tr>..<tr><td><b> */ \
	0x46,0x61,0x76,0x6f,0x72,0x69,0x74,0x65,0x3a,0x3c,0x2f,0x62,0x3e,0x3c,0x2f,0x74, /* Favorite:</b></t */ \
	0x64,0x3e,0x3c,0x74,0x64,0x3e,0x3c,0x73,0x65,0x6c,0x65,0x63,0x74,0x20,0x6e,0x61, /* d><td><select na */ \
	0x6d,0x65,0x3d,0x22,0x66,0x61,0x76,0x22,0x3e,0x3c,0x6f,0x70,0x74,0x69,0x6f,0x6e, /* me="fav"><option */ \
	0x20,0x76,0x61,0x6c,0x75,0x65,0x3d,0x22,0x50,0x49,0x43,0x33,0x32,0x22,0x3e,0x50, /*  value="PIC32">P */ \
	0x49,0x43,0x33,0x32,0x3c,0x2f,0x6f,0x70,0x74,0x69,0x6f,0x6e,0x3e,0x3c,0x2f,0x73, /* IC32</option></s */ \
	0x65,0x6c,0x65,0x63,0x74,0x3e,0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x2f,0x74,0x72,0x3e, /* elect></td></tr> */ \
	0x0d,0x0a,0x3c,0x74,0x72,0x3e,0x3c,0x74,0x64,0x3e,0x3c,0x2f,0x74,0x64,0x3e,0x3c, /* ..<tr><td></td>< */ \
	0x74,0x64,0x3e,0x3c,0x69,0x6e,0x70,0x75,0x74,0x20,0x74,0x79,0x70,0x65,0x3d,0x22, /* td><input type=" */ \
	0x73,0x75,0x62,0x6d,0x69,0x74,0x22,0x20,0x76,0x61,0x6c,0x75,0x65,0x3d,0x22,0x53, /* submit" value="S */ \
	0x65,0x74,0x20,0x43,0x6f,0x6f,0x6b,0x69,0x65,0x73,0x22,0x20,0x2f,0x3e,0x3c,0x2f, /* et Cookies" /></ */ \
	0x74,0x64,0x3e,0x3c,0x2f,0x74,0x72,0x3e,0x0d,0x0a,0x3c,0x2f,0x74,0x61,0x62,0x6c, /* td></tr>..</tabl */ \
	0x65,0x3e,0x0d,0x0a,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x3c,0x2f,0x66,0x6f, /* e>..</div>..</fo */ \
	0x72,0x6d,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70,0x3e,0x43,0x6f,0x6f,0x6b,0x69,0x65, /* rm>....<p>Cookie */ \
	0x73,0x20,0x61,0x72,0x65,0x20,0x73,0x65,0x74,0x20,0x62,0x79,0x20,0x73,0x74,0x6f, /* s are set by sto */ \
	0x72,0x69,0x6e,0x67,0x20,0x6e,0x75,0x6c,0x6c,0x2d,0x74,0x65,0x72,0x6d,0x69,0x6e, /* ring null-termin */ \
	0x61,0x74,0x65,0x64,0x20,0x6e,0x61,0x6d,0x65,0x2f,0x76,0x61,0x6c,0x75,0x65,0x20, /* ated name/value  */ \
	0x70,0x61,0x69,0x72,0x73,0x20,0x69,0x6e,0x20,0x74,0x68,0x65,0x20,0x63,0x75,0x72, /* pairs in the cur */ \
	0x72,0x65,0x6e,0x74,0x20,0x48,0x54,0x54,0x50,0x20,0x63,0x6f,0x6e,0x6e,0x65,0x63, /* rent HTTP connec */ \
	0x74,0x69,0x6f,0x6e,0x0d,0x0a,0x64,0x61,0x74,0x61,0x20,0x62,0x75,0x66,0x66,0x65, /* tion..data buffe */ \
	0x72,0x2e,0x20,0x54,0x68,0x65,0x20,0x6e,0x75,0x6d,0x62,0x65,0x72,0x20,0x6f,0x66, /* r. The number of */ \
	0x20,0x63,0x6f,0x6f,0x6b,0x69,0x65,0x73,0x20,0x74,0x68,0x61,0x74,0x20,0x61,0x72, /*  cookies that ar */ \
	0x65,0x20,0x73,0x65,0x74,0x20,0x69,0x73,0x20,0x61,0x6c,0x73,0x6f,0x20,0x73,0x74, /* e set is also st */ \
	0x6f,0x72,0x65,0x64,0x2e,0x0d,0x0a,0x54,0x68,0x65,0x79,0x20,0x63,0x61,0x6e,0x20, /* ored...They can  */ \
	0x62,0x65,0x20,0x73,0x65,0x74,0x20,0x69,0x6e,0x20,0x65,0x69,0x74,0x68,0x65,0x72, /* be set in either */ \
	0x20,0x3c,0x63,0x6f,0x64,0x65,0x3e,0x54,0x43,0x50,0x49,0x50,0x5f,0x48,0x54,0x54, /*  <code>TCPIP_HTT */ \
	0x50,0x5f,0x47,0x65,0x74,0x45,0x78,0x65,0x63,0x75,0x74,0x65,0x3c,0x2f,0x63,0x6f, /* P_GetExecute</co */ \
	0x64,0x65,0x3e,0x20,0x6f,0x72,0x20,0x3c,0x63,0x6f,0x64,0x65,0x3e,0x54,0x43,0x50, /* de> or <code>TCP */ \
	0x49,0x50,0x5f,0x48,0x54,0x54,0x50,0x5f,0x50,0x6f,0x73,0x74,0x45,0x78,0x65,0x63, /* IP_HTTP_PostExec */ \
	0x75,0x74,0x65,0x3c,0x2f,0x63,0x6f,0x64,0x65,0x3e,0x2e,0x3c,0x2f,0x70,0x3e,0x0d, /* ute</code>.</p>. */ \
	0x0a,0x0d,0x0a,0x3c,0x70,0x3e,0x43,0x6f,0x6f,0x6b,0x69,0x65,0x73,0x20,0x61,0x72, /* ...<p>Cookies ar */ \
	0x65,0x20,0x72,0x65,0x74,0x72,0x69,0x65,0x76,0x65,0x64,0x20,0x69,0x6e,0x20,0x74, /* e retrieved in t */ \
	0x68,0x65,0x20,0x73,0x61,0x6d,0x65,0x20,0x6d,0x61,0x6e,0x6e,0x65,0x72,0x20,0x61, /* he same manner a */ \
	0x73,0x20,0x47,0x45,0x54,0x20,0x66,0x6f,0x72,0x6d,0x20,0x61,0x72,0x67,0x75,0x6d, /* s GET form argum */ \
	0x65,0x6e,0x74,0x73,0x2e,0x20,0x20,0x54,0x68,0x65,0x79,0x20,0x61,0x72,0x65,0x20, /* ents.  They are  */ \
	0x73,0x74,0x6f,0x72,0x65,0x64,0x0d,0x0a,0x69,0x6e,0x20,0x74,0x68,0x65,0x20,0x63, /* stored..in the c */ \
	0x75,0x72,0x72,0x65,0x6e,0x74,0x20,0x48,0x54,0x54,0x50,0x20,0x63,0x6f,0x6e,0x6e, /* urrent HTTP conn */ \
	0x65,0x63,0x74,0x69,0x6f,0x6e,0x20,0x64,0x61,0x74,0x61,0x20,0x62,0x75,0x66,0x66, /* ection data buff */ \
	0x65,0x72,0x20,0x61,0x6e,0x64,0x20,0x63,0x61,0x6e,0x20,0x62,0x65,0x20,0x6c,0x6f, /* er and can be lo */ \
	0x63,0x61,0x74,0x65,0x64,0x20,0x75,0x73,0x69,0x6e,0x67,0x20,0x74,0x68,0x65,0x20, /* cated using the  */ \
	0x3c,0x63,0x6f,0x64,0x65,0x3e,0x54,0x43,0x50,0x49,0x50,0x5f,0x48,0x54,0x54,0x50, /* <code>TCPIP_HTTP */ \
	0x5f,0x41,0x72,0x67,0x47,0x65,0x74,0x3c,0x2f,0x63,0x6f,0x64,0x65,0x3e,0x0d,0x0a, /* _ArgGet</code>.. */ \
	0x66,0x75,0x6e,0x63,0x74,0x69,0x6f,0x6e,0x73,0x2e,0x20,0x20,0x53,0x69,0x6e,0x63, /* functions.  Sinc */ \
	0x65,0x20,0x74,0x68,0x65,0x79,0x20,0x61,0x72,0x65,0x20,0x73,0x74,0x6f,0x72,0x65, /* e they are store */ \
	0x64,0x20,0x69,0x6e,0x20,0x74,0x68,0x65,0x20,0x73,0x61,0x6d,0x65,0x20,0x61,0x72, /* d in the same ar */ \
	0x72,0x61,0x79,0x20,0x61,0x73,0x20,0x47,0x45,0x54,0x20,0x61,0x72,0x67,0x75,0x6d, /* ray as GET argum */ \
	0x65,0x6e,0x74,0x73,0x2c,0x20,0x74,0x68,0x65,0x20,0x74,0x6f,0x74,0x61,0x6c,0x0d, /* ents, the total. */ \
	0x0a,0x6c,0x65,0x6e,0x67,0x74,0x68,0x20,0x6f,0x66,0x20,0x63,0x6f,0x6f,0x6b,0x69, /* .length of cooki */ \
	0x65,0x73,0x20,0x61,0x6e,0x64,0x20,0x76,0x61,0x72,0x69,0x61,0x62,0x6c,0x65,0x20, /* es and variable  */ \
	0x61,0x72,0x67,0x75,0x6d,0x65,0x6e,0x74,0x73,0x20,0x63,0x61,0x6e,0x6e,0x6f,0x74, /* arguments cannot */ \
	0x20,0x65,0x78,0x63,0x65,0x65,0x64,0x20,0x74,0x68,0x65,0x20,0x38,0x30,0x20,0x62, /*  exceed the 80 b */ \
	0x79,0x74,0x65,0x20,0x62,0x75,0x66,0x66,0x65,0x72,0x20,0x6c,0x69,0x6d,0x69,0x74, /* yte buffer limit */ \
	0x2e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70,0x20,0x63,0x6c,0x61,0x73, /* .</p>....<p clas */ \
	0x73,0x3d,0x22,0x65,0x78,0x65,0x72,0x63,0x69,0x73,0x65,0x22,0x3e,0x3c,0x62,0x3e, /* s="exercise"><b> */ \
	0x45,0x78,0x65,0x72,0x63,0x69,0x73,0x65,0x3a,0x3c,0x2f,0x62,0x3e,0x20,0x53,0x65, /* Exercise:</b> Se */ \
	0x74,0x20,0x61,0x20,0x73,0x65,0x63,0x6f,0x6e,0x64,0x20,0x63,0x6f,0x6f,0x6b,0x69, /* t a second cooki */ \
	0x65,0x20,0x6e,0x61,0x6d,0x65,0x64,0x20,0x3c,0x63,0x6f,0x64,0x65,0x3e,0x66,0x61, /* e named <code>fa */ \
	0x76,0x3c,0x2f,0x63,0x6f,0x64,0x65,0x3e,0x20,0x77,0x69,0x74,0x68,0x20,0x74,0x68, /* v</code> with th */ \
	0x65,0x0d,0x0a,0x76,0x61,0x6c,0x75,0x65,0x20,0x6f,0x66,0x20,0x74,0x68,0x65,0x20, /* e..value of the  */ \
	0x3c,0x63,0x6f,0x64,0x65,0x3e,0x66,0x61,0x76,0x6f,0x72,0x69,0x74,0x65,0x3c,0x2f, /* <code>favorite</ */ \
	0x63,0x6f,0x64,0x65,0x3e,0x20,0x66,0x69,0x65,0x6c,0x64,0x20,0x61,0x6e,0x64,0x20, /* code> field and  */ \
	0x68,0x61,0x76,0x65,0x20,0x69,0x74,0x20,0x64,0x69,0x73,0x70,0x6c,0x61,0x79,0x65, /* have it displaye */ \
	0x64,0x20,0x69,0x6e,0x20,0x74,0x68,0x65,0x20,0x67,0x72,0x61,0x79,0x20,0x62,0x6f, /* d in the gray bo */ \
	0x78,0x20,0x61,0x62,0x6f,0x76,0x65,0x2e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a, /* x above.</p>.... */ \
	0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x73,0x63,0x72,0x69,0x70, /* </div>....<scrip */ \
	0x74,0x20,0x74,0x79,0x70,0x65,0x3d,0x22,0x74,0x65,0x78,0x74,0x2f,0x6a,0x61,0x76, /* t type="text/jav */ \
	0x61,0x73,0x63,0x72,0x69,0x70,0x74,0x22,0x3e,0x0d,0x0a,0x3c,0x21,0x2d,0x2d,0x0d, /* ascript">..<!--. */ \
	0x0a,0x64,0x6f,0x63,0x75,0x6d,0x65,0x6e,0x74,0x2e,0x67,0x65,0x74,0x45,0x6c,0x65, /* .document.getEle */ \
	0x6d,0x65,0x6e,0x74,0x42,0x79,0x49,0x64,0x28,0x27,0x68,0x65,0x6c,0x6c,0x6f,0x27, /* mentById('hello' */ \
	0x29,0x2e,0x69,0x6e,0x6e,0x65,0x72,0x48,0x54,0x4d,0x4c,0x20,0x3d,0x20,0x22,0x7e, /* ).innerHTML = "~ */ \
	0x68,0x65,0x6c,0x6c,0x6f,0x6d,0x73,0x67,0x7e,0x22,0x3b,0x0d,0x0a,0x2d,0x2d,0x3e, /* hellomsg~";..--> */ \
	0x0d,0x0a,0x3c,0x2f,0x73,0x63,0x72,0x69,0x70,0x74,0x3e,0x0d,0x0a,0x7e,0x69,0x6e, /* ..</script>..~in */ \
	0x63,0x3a,0x66,0x6f,0x6f,0x74,0x65,0x72,0x2e,0x69,0x6e,0x63,0x7e,0x0d,0x0a,0x1e, /* c:footer.inc~... */ \
	0x00,0x00,0x00,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x2e,0x05,0x00, /* ................ */ \
	0x00,0x01,0x00,0x00,0x00,0x4c,0x05,0x00,0x00,0x02,0x00,0x00,0x00,0x2e,0x00,0x00, /* .....L.......... */ \
	0x00,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xa9,0x01,0x00,0x00,0x03, /* ................ */ \
	0x00,0x00,0x00,0xe2,0x01,0x00,0x00,0x04,0x00,0x00,0x00,0xf6,0x07,0x00,0x00,0x01, /* ................ */ \
	0x00,0x00,0x00,0x14,0x08,0x00,0x00,0x02,0x00,0x00,0x00,0x5e,0x00,0x00,0x00,0x02, /* ...........^.... */ \
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xd3,0x01,0x00,0x00,0x05,0x00,0x00, /* ................ */ \
	0x00,0xfa,0x01,0x00,0x00,0x05,0x00,0x00,0x00,0x06,0x02,0x00,0x00,0x05,0x00,0x00, /* ................ */ \
	0x00,0xf9,0x02,0x00,0x00,0x06,0x00,0x00,0x00,0x95,0x03,0x00,0x00,0x05,0x00,0x00, /* ................ */ \
	0x00,0x9d,0x03,0x00,0x00,0x05,0x00,0x00,0x00,0xa5,0x05,0x00,0x00,0x07,0x00,0x00, /* ................ */ \
	0x00,0xae,0x05,0x00,0x00,0x08,0x00,0x00,0x00,0x9a,0x07,0x00,0x00,0x01,0x00,0x00, /* ................ */ \
	0x00,0xb8,0x07,0x00,0x00,0x02,0x00,0x00,0x00,0x3e,0x00,0x00,0x00,0x02,0x00,0x00, /* .........>...... */ \
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xa4,0x04,0x00,0x00,0x09,0x00,0x00,0x00,0xd7, /* ................ */ \
	0x04,0x00,0x00,0x0a,0x00,0x00,0x00,0x3b,0x05,0x00,0x00,0x0b,0x00,0x00,0x00,0x6e, /* .......;.......n */ \
	0x05,0x00,0x00,0x0c,0x00,0x00,0x00,0x8e,0x07,0x00,0x00,0x01,0x00,0x00,0x00,0xac, /* ................ */ \
	0x07,0x00,0x00,0x02,0x00,0x00,0x00,0x3e,0x00,0x00,0x00,0x02,0x00,0x00,0x00,0x00, /* .......>........ */ \
	0x00,0x00,0x00,0x00,0x00,0x85,0x03,0x00,0x00,0x0d,0x00,0x00,0x00,0xcc,0x03,0x00, /* ................ */ \
	0x00,0x06,0x00,0x00,0x00,0x1f,0x04,0x00,0x00,0x0e,0x00,0x00,0x00,0x6a,0x04,0x00, /* .............j.. */ \
	0x00,0x0f,0x00,0x00,0x00,0xd1,0x0e,0x00,0x00,0x01,0x00,0x00,0x00,0xf1,0x0e,0x00, /* ................ */ \
	0x00,0x02,0x00,0x00,0x00,0x0e,0x00,0x00,0x00,0x02,0x00,0x09,0x00,0x00,0x00,0x10, /* ................ */ \
	0x00,0x00,0x00,0x3e,0x00,0x00,0x00,0x02,0x00,0x12,0x00,0x00,0x00,0x10,0x00,0x00, /* ...>............ */ \
	0x00,0x29,0x00,0x00,0x00,0x08,0x00,0x00,0x00,0x40,0x00,0x00,0x00,0x07,0x00,0x00, /* .).......@...... */ \
	0x00,0x57,0x00,0x00,0x00,0x11,0x00,0x00,0x00,0x6e,0x00,0x00,0x00,0x12,0x00,0x00, /* .W.......n...... */ \
	0x00,0x85,0x00,0x00,0x00,0x13,0x00,0x00,0x00,0x9c,0x00,0x00,0x00,0x14,0x00,0x00, /* ................ */ \
	0x00,0x26,0x00,0x00,0x00,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xb2, /* .&.............. */ \
	0x01,0x00,0x00,0x15,0x00,0x00,0x00,0x6f,0x03,0x00,0x00,0x01,0x00,0x00,0x00,0x8d, /* .......o........ */ \
	0x03,0x00,0x00,0x02,0x00,0x00,0x00,0x4e,0x00,0x00,0x00,0x02,0x00,0x00,0x00,0x00, /* .......N........ */ \
	0x00,0x00,0x00,0x00,0x00,0xbc,0x00,0x00,0x00,0x16,0x00,0x00,0x00,0x9d,0x02,0x00, /* ................ */ \
	0x00,0x17,0x00,0x00,0x00,0xff,0x02,0x00,0x00,0x18,0x00,0x00,0x00,0x61,0x03,0x00, /* .............a.. */ \
	0x00,0x19,0x00,0x00,0x00,0xc7,0x03,0x00,0x00,0x1a,0x00,0x00,0x00,0x2a,0x04,0x00, /* ................ */ \
	0x00,0x1b,0x00,0x00,0x00,0x8d,0x04,0x00,0x00,0x1c,0x00,0x00,0x00,0x2d,0x05,0x00, /* .............-.. */ \
	0x00,0x02,0x00,0x00,0x00,0x66,0x00,0x00,0x00,0x02,0x00,0x00,0x00,0x00,0x00,0x00, /* .....f.......... */ \
	0x00,0x00,0x00,0xbe,0x00,0x00,0x00,0x1d,0x00,0x00,0x00,0x98,0x02,0x00,0x00,0x1e, /* ................ */ \
	0x00,0x00,0x00,0xf6,0x02,0x00,0x00,0x1f,0x00,0x00,0x00,0x81,0x03,0x00,0x00,0x20, /* ...............  */ \
	0x00,0x00,0x00,0xf5,0x03,0x00,0x00,0x21,0x00,0x00,0x00,0x52,0x04,0x00,0x00,0x22, /* .......!...R..." */ \
	0x00,0x00,0x00,0xb4,0x04,0x00,0x00,0x23,0x00,0x00,0x00,0x1b,0x05,0x00,0x00,0x24, /* .......#.......$ */ \
	0x00,0x00,0x00,0x7e,0x05,0x00,0x00,0x25,0x00,0x00,0x00,0x2e,0x07,0x00,0x00,0x01, /* ...~...%........ */ \
	0x00,0x00,0x00,0x4e,0x07,0x00,0x00,0x02,0x00,0x00,0x00,0x1e,0x00,0x00,0x00,0x02, /* ...N............ */ \
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xa7,0x03,0x00,0x00,0x01,0x00,0x00, /* ................ */ \
	0x00,0xc7,0x03,0x00,0x00,0x02,0x00,0x00,0x00,0x0e,0x00,0x00,0x00,0x02,0x00,0x00, /* ................ */ \
	0x00,0x00,0x00,0x26,0x00,0x00,0x00,0x26,0x00,0x00,0x00,0x02,0x00,0x00,0x00,0x00, /* ...&...&........ */ \
	0x00,0x00,0x00,0x00,0x00,0x12,0x01,0x00,0x00,0x27,0x00,0x00,0x00,0x28,0x01,0x00, /* .........'...(.. */ \
	0x00,0x27,0x00,0x00,0x00,0xe1,0x06,0x00,0x00,0x02,0x00,0x00,0x00,0x36,0x00,0x00, /* .'...........6.. */ \
	0x00,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x66,0x00,0x00,0x00,0x28, /* ...........f...( */ \
	0x00,0x00,0x00,0xc2,0x00,0x00,0x00,0x1d,0x00,0x00,0x00,0x0b,0x04,0x00,0x00,0x29, /* ...............) */ \
	0x00,0x00,0x00,0x23,0x07,0x00,0x00,0x01,0x00,0x00,0x00,0x41,0x07,0x00,0x00,0x02, /* ...#.......A.... */ \
	0x00,0x00,0x00,0x66,0x00,0x00,0x00,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, /* ...f............ */ \
	0x00,0x64,0x00,0x00,0x00,0x28,0x00,0x00,0x00,0xb0,0x00,0x00,0x00,0x2a,0x00,0x00, /* .d...(.......... */ \
	0x00,0xc1,0x00,0x00,0x00,0x2b,0x00,0x00,0x00,0xaa,0x02,0x00,0x00,0x2c,0x00,0x00, /* .....+.......,.. */ \
	0x00,0xf0,0x02,0x00,0x00,0x2d,0x00,0x00,0x00,0x34,0x03,0x00,0x00,0x2e,0x00,0x00, /* .....-...4...... */ \
	0x00,0xd8,0x03,0x00,0x00,0x2f,0x00,0x00,0x00,0x46,0x04,0x00,0x00,0x30,0x00,0x00, /* ...../...F...0.. */ \
	0x00,0xac,0x04,0x00,0x00,0x31,0x00,0x00,0x00,0x85,0x05,0x00,0x00,0x01,0x00,0x00, /* .....1.......... */ \
	0x00,0xa3,0x05,0x00,0x00,0x02,0x00,0x00,0x00,0x7e,0x69,0x6e,0x63,0x3a,0x68,0x65, /* .........~inc:he */ \
	0x61,0x64,0x65,0x72,0x2e,0x69,0x6e,0x63,0x7e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20, /* ader.inc~..<div  */ \
	0x69,0x64,0x3d,0x22,0x63,0x6f,0x6e,0x74,0x65,0x6e,0x74,0x22,0x3e,0x0d,0x0a,0x0d, /* id="content">... */ \
	0x0a,0x3c,0x68,0x31,0x3e,0x44,0x79,0x6e,0x61,0x6d,0x69,0x63,0x20,0x56,0x61,0x72, /* .<h1>Dynamic Var */ \
	0x69,0x61,0x62,0x6c,0x65,0x73,0x3c,0x2f,0x68,0x31,0x3e,0x0d,0x0a,0x3c,0x70,0x3e, /* iables</h1>..<p> */ \
	0x4f,0x6e,0x65,0x20,0x6f,0x66,0x20,0x74,0x68,0x65,0x20,0x6d,0x6f,0x73,0x74,0x20, /* One of the most  */ \
	0x62,0x61,0x73,0x69,0x63,0x20,0x6e,0x65,0x65,0x64,0x73,0x20,0x69,0x73,0x20,0x74, /* basic needs is t */ \
	0x6f,0x20,0x70,0x72,0x6f,0x76,0x69,0x64,0x65,0x20,0x73,0x74,0x61,0x74,0x75,0x73, /* o provide status */ \
	0x20,0x69,0x6e,0x66,0x6f,0x72,0x6d,0x61,0x74,0x69,0x6f,0x6e,0x20,0x62,0x61,0x63, /*  information bac */ \
	0x6b,0x20,0x74,0x6f,0x20,0x74,0x68,0x65,0x20,0x75,0x73,0x65,0x72,0x20,0x6f,0x66, /* k to the user of */ \
	0x20,0x0d,0x0a,0x79,0x6f,0x75,0x72,0x20,0x77,0x65,0x62,0x20,0x61,0x70,0x70,0x6c, /*  ..your web appl */ \
	0x69,0x63,0x61,0x74,0x69,0x6f,0x6e,0x2e,0x20,0x20,0x54,0x68,0x65,0x20,0x48,0x54, /* ication.  The HT */ \
	0x54,0x50,0x20,0x73,0x65,0x72,0x76,0x65,0x72,0x20,0x70,0x72,0x6f,0x76,0x69,0x64, /* TP server provid */ \
	0x65,0x73,0x20,0x66,0x6f,0x72,0x20,0x74,0x68,0x69,0x73,0x20,0x75,0x73,0x69,0x6e, /* es for this usin */ \
	0x67,0x20,0x3c,0x69,0x3e,0x64,0x79,0x6e,0x61,0x6d,0x69,0x63,0x20,0x0d,0x0a,0x76, /* g <i>dynamic ..v */ \
	0x61,0x72,0x69,0x61,0x62,0x6c,0x65,0x20,0x73,0x75,0x62,0x73,0x74,0x69,0x74,0x75, /* ariable substitu */ \
	0x74,0x69,0x6f,0x6e,0x20,0x63,0x61,0x6c,0x6c,0x62,0x61,0x63,0x6b,0x73,0x3c,0x2f, /* tion callbacks</ */ \
	0x69,0x3e,0x2e,0x20,0x20,0x54,0x68,0x65,0x73,0x65,0x20,0x63,0x6f,0x6d,0x6d,0x61, /* i>.  These comma */ \
	0x6e,0x64,0x73,0x20,0x69,0x6e,0x20,0x79,0x6f,0x75,0x72,0x20,0x48,0x54,0x4d,0x4c, /* nds in your HTML */ \
	0x20,0x63,0x6f,0x64,0x65,0x20,0x77,0x69,0x6c,0x6c,0x0d,0x0a,0x61,0x6c,0x65,0x72, /*  code will..aler */ \
	0x74,0x20,0x74,0x68,0x65,0x20,0x73,0x65,0x72,0x76,0x65,0x72,0x20,0x74,0x6f,0x20, /* t the server to  */ \
	0x65,0x78,0x65,0x63,0x75,0x74,0x65,0x20,0x61,0x20,0x63,0x61,0x6c,0x6c,0x62,0x61, /* execute a callba */ \
	0x63,0x6b,0x20,0x66,0x75,0x6e,0x63,0x74,0x69,0x6f,0x6e,0x20,0x61,0x74,0x20,0x74, /* ck function at t */ \
	0x68,0x61,0x74,0x20,0x70,0x6f,0x69,0x6e,0x74,0x2e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a, /* hat point.</p>.. */ \
	0x3c,0x70,0x3e,0x54,0x6f,0x20,0x69,0x6e,0x73,0x65,0x72,0x74,0x20,0x61,0x20,0x64, /* <p>To insert a d */ \
	0x79,0x6e,0x61,0x6d,0x69,0x63,0x20,0x76,0x61,0x72,0x69,0x61,0x62,0x6c,0x65,0x2c, /* ynamic variable, */ \
	0x20,0x70,0x6c,0x61,0x63,0x65,0x20,0x74,0x68,0x65,0x20,0x6e,0x61,0x6d,0x65,0x20, /*  place the name  */ \
	0x6f,0x66,0x20,0x74,0x68,0x65,0x20,0x76,0x61,0x72,0x69,0x61,0x62,0x6c,0x65,0x20, /* of the variable  */ \
	0x69,0x6e,0x73,0x69,0x64,0x65,0x20,0x6f,0x66,0x20,0x74,0x68,0x65,0x20,0x74,0x69, /* inside of the ti */ \
	0x6c,0x64,0x65,0x0d,0x0a,0x28,0x3c,0x63,0x6f,0x64,0x65,0x3e,0x7e,0x7e,0x3c,0x2f, /* lde..(<code>~~</ */ \
	0x63,0x6f,0x64,0x65,0x3e,0x29,0x20,0x63,0x68,0x61,0x72,0x61,0x63,0x74,0x65,0x72, /* code>) character */ \
	0x2c,0x20,0x6c,0x69,0x6b,0x65,0x20,0x74,0x68,0x69,0x73,0x3a,0x20,0x3c,0x63,0x6f, /* , like this: <co */ \
	0x64,0x65,0x3e,0x7e,0x7e,0x6d,0x79,0x56,0x61,0x72,0x69,0x61,0x62,0x6c,0x65,0x7e, /* de>~~myVariable~ */ \
	0x7e,0x3c,0x2f,0x63,0x6f,0x64,0x65,0x3e,0x2e,0x20,0x20,0x57,0x68,0x65,0x6e,0x20, /* ~</code>.  When  */ \
	0x74,0x68,0x61,0x74,0x20,0x0d,0x0a,0x73,0x65,0x71,0x75,0x65,0x6e,0x63,0x65,0x20, /* that ..sequence  */ \
	0x69,0x73,0x20,0x66,0x6f,0x75,0x6e,0x64,0x2c,0x20,0x74,0x68,0x65,0x20,0x73,0x65, /* is found, the se */ \
	0x72,0x76,0x65,0x72,0x20,0x77,0x69,0x6c,0x6c,0x20,0x63,0x61,0x6c,0x6c,0x20,0x74, /* rver will call t */ \
	0x68,0x65,0x20,0x66,0x75,0x6e,0x63,0x74,0x69,0x6f,0x6e,0x20,0x3c,0x63,0x6f,0x64, /* he function <cod */ \
	0x65,0x3e,0x54,0x43,0x50,0x49,0x50,0x5f,0x48,0x54,0x54,0x50,0x5f,0x50,0x72,0x69, /* e>TCPIP_HTTP_Pri */ \
	0x6e,0x74,0x5f,0x6d,0x79,0x56,0x61,0x72,0x69,0x61,0x62,0x6c,0x65,0x28,0x29,0x3c, /* nt_myVariable()< */ \
	0x2f,0x63,0x6f,0x64,0x65,0x3e,0x2e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c, /* /code>.</p>....< */ \
	0x70,0x3e,0x46,0x6f,0x72,0x20,0x65,0x78,0x61,0x6d,0x70,0x6c,0x65,0x2c,0x20,0x68, /* p>For example, h */ \
	0x65,0x72,0x65,0x27,0x73,0x20,0x74,0x68,0x65,0x20,0x62,0x75,0x69,0x6c,0x64,0x20, /* ere's the build  */ \
	0x64,0x61,0x74,0x65,0x20,0x6f,0x66,0x20,0x74,0x68,0x65,0x20,0x48,0x45,0x58,0x20, /* date of the HEX  */ \
	0x66,0x69,0x6c,0x65,0x20,0x70,0x72,0x6f,0x67,0x72,0x61,0x6d,0x6d,0x65,0x64,0x20, /* file programmed  */ \
	0x69,0x6e,0x20,0x79,0x6f,0x75,0x72,0x20,0x70,0x61,0x72,0x74,0x3a,0x3c,0x2f,0x70, /* in your part:</p */ \
	0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x63,0x6c,0x61,0x73,0x73,0x3d, /* >....<div class= */ \
	0x22,0x65,0x78,0x61,0x6d,0x70,0x6c,0x65,0x62,0x6f,0x78,0x20,0x63,0x6f,0x64,0x65, /* "examplebox code */ \
	0x22,0x3e,0x7e,0x62,0x75,0x69,0x6c,0x64,0x64,0x61,0x74,0x65,0x7e,0x3c,0x2f,0x64, /* ">~builddate~</d */ \
	0x69,0x76,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70,0x3e,0x59,0x6f,0x75,0x20,0x63,0x61, /* iv>....<p>You ca */ \
	0x6e,0x20,0x61,0x6c,0x73,0x6f,0x20,0x70,0x61,0x73,0x73,0x20,0x70,0x61,0x72,0x61, /* n also pass para */ \
	0x6d,0x65,0x74,0x65,0x72,0x73,0x20,0x74,0x6f,0x20,0x64,0x79,0x6e,0x61,0x6d,0x69, /* meters to dynami */ \
	0x63,0x20,0x76,0x61,0x72,0x69,0x61,0x62,0x6c,0x65,0x73,0x20,0x62,0x79,0x20,0x70, /* c variables by p */ \
	0x6c,0x61,0x63,0x69,0x6e,0x67,0x20,0x6e,0x75,0x6d,0x65,0x72,0x69,0x63,0x20,0x76, /* lacing numeric v */ \
	0x61,0x6c,0x75,0x65,0x73,0x20,0x69,0x6e,0x73,0x69,0x64,0x65,0x20,0x0d,0x0a,0x6f, /* alues inside ..o */ \
	0x66,0x20,0x70,0x61,0x72,0x65,0x6e,0x74,0x68,0x65,0x73,0x69,0x73,0x20,0x61,0x66, /* f parenthesis af */ \
	0x74,0x65,0x72,0x20,0x74,0x68,0x65,0x20,0x76,0x61,0x72,0x69,0x61,0x62,0x6c,0x65, /* ter the variable */ \
	0x20,0x6e,0x61,0x6d,0x65,0x2e,0x20,0x20,0x3c,0x63,0x6f,0x64,0x65,0x3e,0x7e,0x7e, /*  name.  <code>~~ */ \
	0x6c,0x65,0x64,0x28,0x32,0x29,0x7e,0x7e,0x3c,0x2f,0x63,0x6f,0x64,0x65,0x3e,0x20, /* led(2)~~</code>  */ \
	0x77,0x69,0x6c,0x6c,0x20,0x70,0x72,0x69,0x6e,0x74,0x20,0x74,0x68,0x65,0x20,0x76, /* will print the v */ \
	0x61,0x6c,0x75,0x65,0x0d,0x0a,0x6f,0x66,0x20,0x74,0x68,0x65,0x20,0x73,0x65,0x63, /* alue..of the sec */ \
	0x6f,0x6e,0x64,0x20,0x4c,0x45,0x44,0x2e,0x20,0x20,0x54,0x68,0x65,0x20,0x6e,0x75, /* ond LED.  The nu */ \
	0x6d,0x65,0x72,0x69,0x63,0x20,0x76,0x61,0x6c,0x75,0x65,0x73,0x20,0x61,0x72,0x65, /* meric values are */ \
	0x20,0x70,0x61,0x73,0x73,0x65,0x64,0x20,0x61,0x73,0x20,0x75,0x69,0x6e,0x74,0x31, /*  passed as uint1 */ \
	0x36,0x5f,0x74,0x20,0x76,0x61,0x6c,0x75,0x65,0x73,0x20,0x74,0x6f,0x20,0x79,0x6f, /* 6_t values to yo */ \
	0x75,0x72,0x20,0x63,0x61,0x6c,0x6c,0x62,0x61,0x63,0x6b,0x20,0x66,0x75,0x6e,0x63, /* ur callback func */ \
	0x74,0x69,0x6f,0x6e,0x2e,0x0d,0x0a,0x59,0x6f,0x75,0x20,0x63,0x61,0x6e,0x20,0x70, /* tion...You can p */ \
	0x61,0x73,0x73,0x20,0x61,0x73,0x20,0x6d,0x61,0x6e,0x79,0x20,0x70,0x61,0x72,0x61, /* ass as many para */ \
	0x6d,0x65,0x74,0x65,0x72,0x73,0x20,0x61,0x73,0x20,0x79,0x6f,0x75,0x20,0x77,0x69, /* meters as you wi */ \
	0x73,0x68,0x20,0x74,0x6f,0x20,0x74,0x68,0x65,0x73,0x65,0x20,0x66,0x75,0x6e,0x63, /* sh to these func */ \
	0x74,0x69,0x6f,0x6e,0x73,0x2c,0x20,0x61,0x6e,0x64,0x20,0x69,0x66,0x20,0x79,0x6f, /* tions, and if yo */ \
	0x75,0x72,0x20,0x43,0x20,0x63,0x6f,0x64,0x65,0x20,0x68,0x61,0x73,0x20,0x0d,0x0a, /* ur C code has .. */ \
	0x63,0x6f,0x6e,0x73,0x74,0x61,0x6e,0x74,0x73,0x20,0x64,0x65,0x66,0x69,0x6e,0x65, /* constants define */ \
	0x64,0x2c,0x20,0x74,0x68,0x6f,0x73,0x65,0x20,0x77,0x69,0x6c,0x6c,0x20,0x62,0x65, /* d, those will be */ \
	0x20,0x70,0x61,0x72,0x73,0x65,0x64,0x20,0x61,0x73,0x20,0x77,0x65,0x6c,0x6c,0x2e, /*  parsed as well. */ \
	0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70,0x3e,0x41,0x73,0x20,0x61,0x6e, /* </p>....<p>As an */ \
	0x20,0x65,0x78,0x61,0x6d,0x70,0x6c,0x65,0x2c,0x20,0x68,0x65,0x72,0x65,0x20,0x69, /*  example, here i */ \
	0x73,0x20,0x61,0x20,0x62,0x69,0x6e,0x61,0x72,0x79,0x20,0x72,0x65,0x70,0x72,0x65, /* s a binary repre */ \
	0x73,0x65,0x6e,0x74,0x61,0x74,0x69,0x6f,0x6e,0x20,0x77,0x68,0x69,0x63,0x68,0x20, /* sentation which  */ \
	0x4c,0x45,0x44,0x73,0x20,0x61,0x72,0x65,0x20,0x6f,0x6e,0x20,0x61,0x6e,0x64,0x20, /* LEDs are on and  */ \
	0x6f,0x66,0x66,0x20,0x6f,0x6e,0x20,0x74,0x68,0x65,0x20,0x62,0x6f,0x61,0x72,0x64, /* off on the board */ \
	0x20,0x26,0x23,0x34,0x30,0x3b,0x69,0x6e,0x20,0x74,0x68,0x65,0x20,0x63,0x75,0x72, /*  &#40;in the cur */ \
	0x72,0x65,0x6e,0x74,0x20,0x48,0x61,0x72,0x6d,0x6f,0x6e,0x79,0x20,0x72,0x65,0x6c, /* rent Harmony rel */ \
	0x65,0x61,0x73,0x65,0x2c,0x20,0x74,0x68,0x69,0x73,0x20,0x70,0x61,0x72,0x74,0x20, /* ease, this part  */ \
	0x69,0x73,0x20,0x6f,0x6e,0x6c,0x79,0x20,0x77,0x6f,0x72,0x6b,0x69,0x6e,0x67,0x20, /* is only working  */ \
	0x6f,0x6e,0x20,0x45,0x78,0x70,0x6c,0x6f,0x72,0x65,0x72,0x20,0x31,0x36,0x20,0x62, /* on Explorer 16 b */ \
	0x6f,0x61,0x72,0x64,0x26,0x23,0x34,0x31,0x3b,0x3a,0x3c,0x2f,0x70,0x3e,0x0d,0x0a, /* oard&#41;:</p>.. */ \
	0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x63,0x6c,0x61,0x73,0x73,0x3d,0x22,0x65,0x78, /* ..<div class="ex */ \
	0x61,0x6d,0x70,0x6c,0x65,0x62,0x6f,0x78,0x20,0x63,0x6f,0x64,0x65,0x22,0x20,0x73, /* amplebox code" s */ \
	0x74,0x79,0x6c,0x65,0x3d,0x22,0x6c,0x65,0x74,0x74,0x65,0x72,0x2d,0x73,0x70,0x61, /* tyle="letter-spa */ \
	0x63,0x69,0x6e,0x67,0x3a,0x20,0x31,0x30,0x70,0x78,0x22,0x3e,0x0d,0x0a,0x7e,0x6c, /* cing: 10px">..~l */ \
	0x65,0x64,0x28,0x32,0x29,0x7e,0x20,0x7e,0x6c,0x65,0x64,0x28,0x31,0x29,0x7e,0x20, /* ed(2)~ ~led(1)~  */ \
	0x3f,0x0d,0x0a,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70,0x20, /* ?..</div>....<p  */ \
	0x63,0x6c,0x61,0x73,0x73,0x3d,0x22,0x65,0x78,0x65,0x72,0x63,0x69,0x73,0x65,0x22, /* class="exercise" */ \
	0x3e,0x3c,0x62,0x3e,0x45,0x78,0x65,0x72,0x63,0x69,0x73,0x65,0x3a,0x3c,0x2f,0x62, /* ><b>Exercise:</b */ \
	0x3e,0x20,0x54,0x72,0x79,0x20,0x74,0x6f,0x20,0x61,0x64,0x64,0x20,0x74,0x68,0x65, /* > Try to add the */ \
	0x20,0x6c,0x61,0x73,0x74,0x20,0x28,0x4c,0x53,0x42,0x29,0x20,0x4c,0x45,0x44,0x20, /*  last (LSB) LED  */ \
	0x74,0x6f,0x20,0x74,0x68,0x65,0x20,0x6f,0x75,0x74,0x70,0x75,0x74,0x20,0x61,0x62, /* to the output ab */ \
	0x6f,0x76,0x65,0x2e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70,0x3e,0x46, /* ove.</p>....<p>F */ \
	0x6f,0x72,0x20,0x73,0x68,0x6f,0x72,0x74,0x20,0x6f,0x75,0x74,0x70,0x75,0x74,0x73, /* or short outputs */ \
	0x20,0x28,0x6c,0x65,0x73,0x73,0x20,0x74,0x68,0x61,0x6e,0x20,0x31,0x36,0x20,0x62, /*  (less than 16 b */ \
	0x79,0x74,0x65,0x73,0x29,0x20,0x79,0x6f,0x75,0x20,0x6e,0x65,0x65,0x64,0x20,0x6f, /* ytes) you need o */ \
	0x6e,0x6c,0x79,0x20,0x74,0x6f,0x20,0x63,0x61,0x6c,0x6c,0x20,0x74,0x68,0x65,0x20, /* nly to call the  */ \
	0x61,0x70,0x70,0x72,0x6f,0x70,0x72,0x69,0x61,0x74,0x65,0x20,0x0d,0x0a,0x3c,0x63, /* appropriate ..<c */ \
	0x6f,0x64,0x65,0x3e,0x54,0x43,0x50,0x49,0x50,0x5f,0x54,0x43,0x50,0x5f,0x50,0x75, /* ode>TCPIP_TCP_Pu */ \
	0x74,0x3c,0x2f,0x63,0x6f,0x64,0x65,0x3e,0x20,0x66,0x75,0x6e,0x63,0x74,0x69,0x6f, /* t</code> functio */ \
	0x6e,0x20,0x61,0x6e,0x64,0x20,0x72,0x65,0x74,0x75,0x72,0x6e,0x2e,0x20,0x20,0x46, /* n and return.  F */ \
	0x6f,0x72,0x20,0x6c,0x6f,0x6e,0x67,0x65,0x72,0x20,0x6f,0x75,0x74,0x70,0x75,0x74, /* or longer output */ \
	0x73,0x20,0x74,0x68,0x65,0x20,0x6f,0x75,0x74,0x70,0x75,0x74,0x20,0x73,0x74,0x61, /* s the output sta */ \
	0x74,0x65,0x20,0x6d,0x75,0x73,0x74,0x20,0x62,0x65,0x20,0x0d,0x0a,0x6d,0x61,0x6e, /* te must be ..man */ \
	0x61,0x67,0x65,0x64,0x20,0x74,0x68,0x72,0x6f,0x75,0x67,0x68,0x20,0x73,0x75,0x63, /* aged through suc */ \
	0x63,0x65,0x73,0x73,0x69,0x76,0x65,0x20,0x63,0x61,0x6c,0x6c,0x73,0x2c,0x20,0x77, /* cessive calls, w */ \
	0x68,0x69,0x63,0x68,0x20,0x70,0x72,0x65,0x76,0x65,0x6e,0x74,0x73,0x20,0x74,0x68, /* hich prevents th */ \
	0x65,0x20,0x6c,0x69,0x6d,0x69,0x74,0x65,0x64,0x20,0x62,0x75,0x66,0x66,0x65,0x72, /* e limited buffer */ \
	0x20,0x73,0x70,0x61,0x63,0x65,0x20,0x66,0x72,0x6f,0x6d,0x20,0x62,0x65,0x69,0x6e, /*  space from bein */ \
	0x67,0x20,0x0d,0x0a,0x6f,0x76,0x65,0x72,0x72,0x75,0x6e,0x2e,0x3c,0x2f,0x70,0x3e, /* g ..overrun.</p> */ \
	0x0d,0x0a,0x0d,0x0a,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x73, /* ....</div>....<s */ \
	0x63,0x72,0x69,0x70,0x74,0x20,0x74,0x79,0x70,0x65,0x3d,0x22,0x74,0x65,0x78,0x74, /* cript type="text */ \
	0x2f,0x6a,0x61,0x76,0x61,0x73,0x63,0x72,0x69,0x70,0x74,0x22,0x3e,0x0d,0x0a,0x3c, /* /javascript">..< */ \
	0x21,0x2d,0x2d,0x0d,0x0a,0x64,0x6f,0x63,0x75,0x6d,0x65,0x6e,0x74,0x2e,0x67,0x65, /* !--..document.ge */ \
	0x74,0x45,0x6c,0x65,0x6d,0x65,0x6e,0x74,0x42,0x79,0x49,0x64,0x28,0x27,0x68,0x65, /* tElementById('he */ \
	0x6c,0x6c,0x6f,0x27,0x29,0x2e,0x69,0x6e,0x6e,0x65,0x72,0x48,0x54,0x4d,0x4c,0x20, /* llo').innerHTML  */ \
	0x3d,0x20,0x22,0x7e,0x68,0x65,0x6c,0x6c,0x6f,0x6d,0x73,0x67,0x7e,0x22,0x3b,0x0d, /* = "~hellomsg~";. */ \
	0x0a,0x2d,0x2d,0x3e,0x0d,0x0a,0x3c,0x2f,0x73,0x63,0x72,0x69,0x70,0x74,0x3e,0x0d, /* .-->..</script>. */ \
	0x0a,0x7e,0x69,0x6e,0x63,0x3a,0x66,0x6f,0x6f,0x74,0x65,0x72,0x2e,0x69,0x6e,0x63, /* .~inc:footer.inc */ \
	0x7e,0x0d,0x0a,0x0f,0x00,0x00,0x00,0x0a,0x2f,0x9e,0x02,0x00,0x00,0x06,0x00,0x00, /* ~......./....... */ \
	0x00,0x0a,0x4f,0x4c,0x02,0x00,0x00,0x03,0x00,0x00,0x00,0x0a,0x57,0xd4,0x02,0x00, /* ..OL........W... */ \
	0x00,0x0c,0x00,0x00,0x00,0xea,0x81,0x1e,0x00,0x00,0x00,0x05,0x00,0x00,0x00,0xcc, /* ................ */ \
	0x83,0x34,0x01,0x00,0x00,0x07,0x00,0x00,0x00,0x0a,0x85,0x72,0x01,0x00,0x00,0x04, /* .4.........r.... */ \
	0x00,0x00,0x00,0xea,0x8a,0x98,0x01,0x00,0x00,0x09,0x00,0x00,0x00,0xea,0x92,0xe6, /* ................ */ \
	0x01,0x00,0x00,0x0c,0x00,0x00,0x00,0x0a,0xa3,0xe8,0x00,0x00,0x00,0x07,0x00,0x00, /* ................ */ \
	0x00,0x6a,0xa6,0xaa,0x00,0x00,0x00,0x07,0x00,0x00,0x00,0x26,0xb6,0x6a,0x02,0x00, /* .j.........&.j.. */ \
	0x00,0x01,0x00,0x00,0x00,0x8a,0xb6,0x78,0x02,0x00,0x00,0x04,0x00,0x00,0x00,0x2a, /* .......x........ */ \
	0xba,0x4c,0x00,0x00,0x00,0x0b,0x00,0x00,0x00,0x46,0xce,0x26,0x01,0x00,0x00,0x01, /* .L.......F.&.... */ \
	0x00,0x00,0x00,0x4a,0xce,0x00,0x00,0x00,0x00,0x03,0x00,0x00,0x00,0x3c,0x64,0x69, /* ...J.........<di */ \
	0x76,0x20,0x63,0x6c,0x61,0x73,0x73,0x3d,0x22,0x73,0x70,0x61,0x63,0x65,0x72,0x22, /* v class="spacer" */ \
	0x3e,0x26,0x6e,0x62,0x73,0x70,0x3b,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x3c, /* >&nbsp;</div>..< */ \
	0x64,0x69,0x76,0x20,0x69,0x64,0x3d,0x22,0x66,0x6f,0x6f,0x74,0x65,0x72,0x22,0x3e, /* div id="footer"> */ \
	0x43,0x6f,0x70,0x79,0x72,0x69,0x67,0x68,0x74,0x20,0x26,0x63,0x6f,0x70,0x79,0x3b, /* Copyright &copy; */ \
	0x20,0x32,0x30,0x31,0x34,0x20,0x4d,0x69,0x63,0x72,0x6f,0x63,0x68,0x69,0x70,0x20, /*  2014 Microchip  */ \
	0x54,0x65,0x63,0x68,0x6e,0x6f,0x6c,0x6f,0x67,0x79,0x2c,0x20,0x49,0x6e,0x63,0x2e, /* Technology, Inc. */ \
	0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x2f,0x64,0x69,0x76,0x3e, /* </div>....</div> */ \
	0x3c,0x2f,0x64,0x69,0x76,0x3e,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x3c,0x2f,0x64,0x69, /* </div></div></di */ \
	0x76,0x3e,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x2f,0x62,0x6f, /* v></div>....</bo */ \
	0x64,0x79,0x3e,0x0d,0x0a,0x3c,0x2f,0x68,0x74,0x6d,0x6c,0x3e,0x0d,0x0a,0x7e,0x69, /* dy>..</html>..~i */ \
	0x6e,0x63,0x3a,0x68,0x65,0x61,0x64,0x65,0x72,0x2e,0x69,0x6e,0x63,0x7e,0x0d,0x0a, /* nc:header.inc~.. */ \
	0x3c,0x64,0x69,0x76,0x20,0x69,0x64,0x3d,0x22,0x63,0x6f,0x6e,0x74,0x65,0x6e,0x74, /* <div id="content */ \
	0x22,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x68,0x31,0x3e,0x46,0x6f,0x72,0x6d,0x20,0x50, /* ">....<h1>Form P */ \
	0x72,0x6f,0x63,0x65,0x73,0x73,0x69,0x6e,0x67,0x3c,0x2f,0x68,0x31,0x3e,0x0d,0x0a, /* rocessing</h1>.. */ \
	0x0d,0x0a,0x3c,0x70,0x3e,0x59,0x6f,0x75,0x72,0x20,0x61,0x70,0x70,0x6c,0x69,0x63, /* ..<p>Your applic */ \
	0x61,0x74,0x69,0x6f,0x6e,0x20,0x77,0x69,0x6c,0x6c,0x20,0x6c,0x69,0x6b,0x65,0x6c, /* ation will likel */ \
	0x79,0x20,0x6e,0x65,0x65,0x64,0x20,0x74,0x6f,0x20,0x61,0x63,0x63,0x65,0x70,0x74, /* y need to accept */ \
	0x20,0x64,0x61,0x74,0x61,0x20,0x66,0x72,0x6f,0x6d,0x20,0x74,0x68,0x65,0x20,0x75, /*  data from the u */ \
	0x73,0x65,0x72,0x2e,0x20,0x20,0x46,0x6f,0x72,0x6d,0x73,0x20,0x61,0x6c,0x6c,0x6f, /* ser.  Forms allo */ \
	0x77,0x0d,0x0a,0x79,0x6f,0x75,0x20,0x74,0x6f,0x20,0x64,0x6f,0x20,0x6a,0x75,0x73, /* w..you to do jus */ \
	0x74,0x20,0x74,0x68,0x61,0x74,0x2e,0x20,0x20,0x46,0x6f,0x72,0x6d,0x73,0x20,0x63, /* t that.  Forms c */ \
	0x61,0x6e,0x20,0x62,0x65,0x20,0x73,0x75,0x62,0x6d,0x69,0x74,0x74,0x65,0x64,0x20, /* an be submitted  */ \
	0x69,0x6e,0x20,0x6f,0x6e,0x65,0x20,0x6f,0x66,0x20,0x74,0x77,0x6f,0x20,0x6d,0x65, /* in one of two me */ \
	0x74,0x68,0x6f,0x64,0x73,0x20,0x28,0x3c,0x69,0x3e,0x47,0x45,0x54,0x3c,0x2f,0x69, /* thods (<i>GET</i */ \
	0x3e,0x20,0x61,0x6e,0x64,0x0d,0x0a,0x3c,0x69,0x3e,0x50,0x4f,0x53,0x54,0x3c,0x2f, /* > and..<i>POST</ */ \
	0x69,0x3e,0x29,0x2c,0x20,0x61,0x6e,0x64,0x20,0x74,0x68,0x69,0x73,0x20,0x73,0x65, /* i>), and this se */ \
	0x72,0x76,0x65,0x72,0x20,0x73,0x75,0x70,0x70,0x6f,0x72,0x74,0x73,0x20,0x62,0x6f, /* rver supports bo */ \
	0x74,0x68,0x2e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x68,0x36,0x3e,0x3c, /* th.</p>....<h6>< */ \
	0x2f,0x68,0x36,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70,0x3e,0x54,0x68,0x65,0x20,0x3c, /* /h6>....<p>The < */ \
	0x62,0x3e,0x47,0x45,0x54,0x3c,0x2f,0x62,0x3e,0x20,0x6d,0x65,0x74,0x68,0x6f,0x64, /* b>GET</b> method */ \
	0x20,0x61,0x70,0x70,0x65,0x6e,0x64,0x73,0x20,0x74,0x68,0x65,0x20,0x64,0x61,0x74, /*  appends the dat */ \
	0x61,0x20,0x74,0x6f,0x20,0x74,0x68,0x65,0x20,0x65,0x6e,0x64,0x20,0x6f,0x66,0x20, /* a to the end of  */ \
	0x74,0x68,0x65,0x20,0x55,0x52,0x49,0x2e,0x20,0x20,0x59,0x6f,0x75,0x27,0x6c,0x6c, /* the URI.  You'll */ \
	0x20,0x73,0x65,0x65,0x20,0x74,0x68,0x69,0x73,0x0d,0x0a,0x64,0x61,0x74,0x61,0x20, /*  see this..data  */ \
	0x66,0x6f,0x6c,0x6c,0x6f,0x77,0x69,0x6e,0x67,0x20,0x74,0x68,0x65,0x20,0x71,0x75, /* following the qu */ \
	0x65,0x73,0x74,0x69,0x6f,0x6e,0x20,0x6d,0x61,0x72,0x6b,0x20,0x28,0x3f,0x29,0x20, /* estion mark (?)  */ \
	0x69,0x6e,0x20,0x79,0x6f,0x75,0x72,0x20,0x62,0x72,0x6f,0x77,0x73,0x65,0x72,0x27, /* in your browser' */ \
	0x73,0x20,0x61,0x64,0x64,0x72,0x65,0x73,0x73,0x20,0x62,0x61,0x72,0x2e,0x20,0x20, /* s address bar.   */ \
	0x46,0x6f,0x72,0x20,0x4d,0x69,0x63,0x72,0x6f,0x63,0x68,0x69,0x70,0x27,0x73,0x0d, /* For Microchip's. */ \
	0x0a,0x65,0x6d,0x62,0x65,0x64,0x64,0x65,0x64,0x20,0x73,0x65,0x72,0x76,0x65,0x72, /* .embedded server */ \
	0x2c,0x20,0x74,0x68,0x69,0x73,0x20,0x64,0x61,0x74,0x61,0x20,0x69,0x73,0x20,0x6c, /* , this data is l */ \
	0x69,0x6d,0x69,0x74,0x65,0x64,0x20,0x74,0x6f,0x20,0x61,0x72,0x6f,0x75,0x6e,0x64, /* imited to around */ \
	0x20,0x38,0x30,0x20,0x62,0x79,0x74,0x65,0x73,0x2e,0x20,0x20,0x48,0x6f,0x77,0x65, /*  80 bytes.  Howe */ \
	0x76,0x65,0x72,0x2c,0x20,0x74,0x68,0x69,0x73,0x20,0x73,0x6f,0x72,0x74,0x20,0x6f, /* ver, this sort o */ \
	0x66,0x0d,0x0a,0x73,0x75,0x62,0x6d,0x69,0x73,0x73,0x69,0x6f,0x6e,0x20,0x69,0x73, /* f..submission is */ \
	0x20,0x67,0x65,0x6e,0x65,0x72,0x61,0x6c,0x6c,0x79,0x20,0x65,0x61,0x73,0x69,0x65, /*  generally easie */ \
	0x72,0x20,0x74,0x6f,0x20,0x70,0x72,0x6f,0x63,0x65,0x73,0x73,0x2e,0x20,0x44,0x61, /* r to process. Da */ \
	0x74,0x61,0x20,0x73,0x65,0x6e,0x74,0x20,0x76,0x69,0x61,0x20,0x47,0x45,0x54,0x20, /* ta sent via GET  */ \
	0x69,0x73,0x20,0x61,0x75,0x74,0x6f,0x6d,0x61,0x74,0x69,0x63,0x61,0x6c,0x6c,0x79, /* is automatically */ \
	0x0d,0x0a,0x64,0x65,0x63,0x6f,0x64,0x65,0x64,0x2c,0x20,0x61,0x6e,0x64,0x20,0x73, /* ..decoded, and s */ \
	0x74,0x6f,0x72,0x65,0x64,0x20,0x69,0x6e,0x20,0x74,0x68,0x65,0x20,0x63,0x75,0x72, /* tored in the cur */ \
	0x72,0x65,0x6e,0x74,0x20,0x48,0x54,0x54,0x50,0x20,0x63,0x6f,0x6e,0x6e,0x65,0x63, /* rent HTTP connec */ \
	0x74,0x69,0x6f,0x6e,0x20,0x64,0x61,0x74,0x61,0x20,0x62,0x75,0x66,0x66,0x65,0x72, /* tion data buffer */ \
	0x2e,0x20,0x20,0x59,0x6f,0x75,0x72,0x20,0x61,0x70,0x70,0x6c,0x69,0x63,0x61,0x74, /* .  Your applicat */ \
	0x69,0x6f,0x6e,0x20,0x77,0x69,0x6c,0x6c,0x0d,0x0a,0x68,0x61,0x6e,0x64,0x6c,0x65, /* ion will..handle */ \
	0x20,0x74,0x68,0x65,0x20,0x64,0x61,0x74,0x61,0x20,0x69,0x6e,0x20,0x74,0x68,0x65, /*  the data in the */ \
	0x20,0x3c,0x63,0x6f,0x64,0x65,0x3e,0x54,0x43,0x50,0x49,0x50,0x5f,0x48,0x54,0x54, /*  <code>TCPIP_HTT */ \
	0x50,0x5f,0x47,0x65,0x74,0x45,0x78,0x65,0x63,0x75,0x74,0x65,0x3c,0x2f,0x63,0x6f, /* P_GetExecute</co */ \
	0x64,0x65,0x3e,0x20,0x63,0x61,0x6c,0x6c,0x62,0x61,0x63,0x6b,0x2e,0x20,0x3c,0x63, /* de> callback. <c */ \
	0x6f,0x64,0x65,0x3e,0x54,0x43,0x50,0x49,0x50,0x5f,0x48,0x54,0x54,0x50,0x5f,0x41, /* ode>TCPIP_HTTP_A */ \
	0x72,0x67,0x47,0x65,0x74,0x3c,0x2f,0x63,0x6f,0x64,0x65,0x3e,0x0d,0x0a,0x66,0x75, /* rgGet</code>..fu */ \
	0x6e,0x63,0x74,0x69,0x6f,0x6e,0x20,0x70,0x72,0x6f,0x76,0x69,0x64,0x65,0x73,0x20, /* nction provides  */ \
	0x61,0x6e,0x20,0x65,0x61,0x73,0x79,0x20,0x6d,0x65,0x74,0x68,0x6f,0x64,0x20,0x74, /* an easy method t */ \
	0x6f,0x20,0x72,0x65,0x74,0x72,0x69,0x65,0x76,0x65,0x20,0x73,0x75,0x62,0x6d,0x69, /* o retrieve submi */ \
	0x74,0x74,0x65,0x64,0x20,0x76,0x61,0x6c,0x75,0x65,0x73,0x20,0x66,0x6f,0x72,0x20, /* tted values for  */ \
	0x70,0x72,0x6f,0x63,0x65,0x73,0x73,0x69,0x6e,0x67,0x2e,0x3c,0x2f,0x70,0x3e,0x0d, /* processing.</p>. */ \
	0x0a,0x0d,0x0a,0x3c,0x70,0x3e,0x41,0x73,0x20,0x61,0x6e,0x20,0x65,0x78,0x61,0x6d, /* ...<p>As an exam */ \
	0x70,0x6c,0x65,0x2c,0x20,0x74,0x68,0x69,0x73,0x20,0x47,0x45,0x54,0x20,0x66,0x6f, /* ple, this GET fo */ \
	0x72,0x6d,0x20,0x63,0x6f,0x6e,0x74,0x72,0x6f,0x6c,0x73,0x20,0x73,0x65,0x76,0x65, /* rm controls seve */ \
	0x72,0x61,0x6c,0x20,0x4c,0x45,0x44,0x73,0x20,0x6f,0x6e,0x20,0x74,0x68,0x65,0x20, /* ral LEDs on the  */ \
	0x64,0x65,0x6d,0x6f,0x20,0x62,0x6f,0x61,0x72,0x64,0x20,0x26,0x23,0x34,0x30,0x3b, /* demo board &#40; */ \
	0x69,0x6e,0x20,0x74,0x68,0x65,0x20,0x63,0x75,0x72,0x72,0x65,0x6e,0x74,0x20,0x48, /* in the current H */ \
	0x61,0x72,0x6d,0x6f,0x6e,0x79,0x20,0x31,0x2e,0x30,0x20,0x72,0x65,0x6c,0x65,0x61, /* armony 1.0 relea */ \
	0x73,0x65,0x2c,0x20,0x74,0x68,0x69,0x73,0x20,0x70,0x61,0x72,0x74,0x20,0x69,0x73, /* se, this part is */ \
	0x20,0x6f,0x6e,0x6c,0x79,0x20,0x77,0x6f,0x72,0x6b,0x69,0x6e,0x67,0x20,0x6f,0x6e, /*  only working on */ \
	0x20,0x45,0x78,0x70,0x6c,0x6f,0x72,0x65,0x72,0x20,0x31,0x36,0x20,0x62,0x6f,0x61, /*  Explorer 16 boa */ \
	0x72,0x64,0x26,0x23,0x34,0x31,0x3b,0x3a,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a, /* rd&#41;:</p>.... */ \
	0x3c,0x66,0x6f,0x72,0x6d,0x20,0x6d,0x65,0x74,0x68,0x6f,0x64,0x3d,0x22,0x67,0x65, /* <form method="ge */ \
	0x74,0x22,0x20,0x61,0x63,0x74,0x69,0x6f,0x6e,0x3d,0x22,0x66,0x6f,0x72,0x6d,0x73, /* t" action="forms */ \
	0x2e,0x68,0x74,0x6d,0x22,0x3e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x63,0x6c,0x61, /* .htm">..<div cla */ \
	0x73,0x73,0x3d,0x22,0x65,0x78,0x61,0x6d,0x70,0x6c,0x65,0x62,0x6f,0x78,0x22,0x3e, /* ss="examplebox"> */ \
	0x0d,0x0a,0x3c,0x62,0x3e,0x32,0x3a,0x3c,0x2f,0x62,0x3e,0x20,0x3c,0x73,0x65,0x6c, /* ..<b>2:</b> <sel */ \
	0x65,0x63,0x74,0x20,0x6e,0x61,0x6d,0x65,0x3d,0x22,0x6c,0x65,0x64,0x32,0x22,0x3e, /* ect name="led2"> */ \
	0x3c,0x6f,0x70,0x74,0x69,0x6f,0x6e,0x20,0x76,0x61,0x6c,0x75,0x65,0x3d,0x22,0x31, /* <option value="1 */ \
	0x22,0x20,0x7e,0x6c,0x65,0x64,0x53,0x65,0x6c,0x65,0x63,0x74,0x65,0x64,0x28,0x32, /* " ~ledSelected(2 */ \
	0x2c,0x74,0x72,0x75,0x65,0x29,0x7e,0x3e,0x4f,0x6e,0x3c,0x2f,0x6f,0x70,0x74,0x69, /* ,true)~>On</opti */ \
	0x6f,0x6e,0x3e,0x3c,0x6f,0x70,0x74,0x69,0x6f,0x6e,0x20,0x76,0x61,0x6c,0x75,0x65, /* on><option value */ \
	0x3d,0x22,0x30,0x22,0x20,0x7e,0x6c,0x65,0x64,0x53,0x65,0x6c,0x65,0x63,0x74,0x65, /* ="0" ~ledSelecte */ \
	0x64,0x28,0x32,0x2c,0x66,0x61,0x6c,0x73,0x65,0x29,0x7e,0x3e,0x4f,0x66,0x66,0x3c, /* d(2,false)~>Off< */ \
	0x2f,0x6f,0x70,0x74,0x69,0x6f,0x6e,0x3e,0x3c,0x2f,0x73,0x65,0x6c,0x65,0x63,0x74, /* /option></select */ \
	0x3e,0x26,0x6e,0x62,0x73,0x70,0x3b,0x0d,0x0a,0x3c,0x62,0x3e,0x31,0x3a,0x3c,0x2f, /* >&nbsp;..<b>1:</ */ \
	0x62,0x3e,0x20,0x3c,0x73,0x65,0x6c,0x65,0x63,0x74,0x20,0x6e,0x61,0x6d,0x65,0x3d, /* b> <select name= */ \
	0x22,0x6c,0x65,0x64,0x31,0x22,0x3e,0x3c,0x6f,0x70,0x74,0x69,0x6f,0x6e,0x20,0x76, /* "led1"><option v */ \
	0x61,0x6c,0x75,0x65,0x3d,0x22,0x31,0x22,0x20,0x7e,0x6c,0x65,0x64,0x53,0x65,0x6c, /* alue="1" ~ledSel */ \
	0x65,0x63,0x74,0x65,0x64,0x28,0x31,0x2c,0x74,0x72,0x75,0x65,0x29,0x7e,0x3e,0x4f, /* ected(1,true)~>O */ \
	0x6e,0x3c,0x2f,0x6f,0x70,0x74,0x69,0x6f,0x6e,0x3e,0x3c,0x6f,0x70,0x74,0x69,0x6f, /* n</option><optio */ \
	0x6e,0x20,0x76,0x61,0x6c,0x75,0x65,0x3d,0x22,0x30,0x22,0x20,0x7e,0x6c,0x65,0x64, /* n value="0" ~led */ \
	0x53,0x65,0x6c,0x65,0x63,0x74,0x65,0x64,0x28,0x31,0x2c,0x66,0x61,0x6c,0x73,0x65, /* Selected(1,false */ \
	0x29,0x7e,0x3e,0x4f,0x66,0x66,0x3c,0x2f,0x6f,0x70,0x74,0x69,0x6f,0x6e,0x3e,0x3c, /* )~>Off</option>< */ \
	0x2f,0x73,0x65,0x6c,0x65,0x63,0x74,0x3e,0x26,0x6e,0x62,0x73,0x70,0x3b,0x0d,0x0a, /* /select>&nbsp;.. */ \
	0x3c,0x62,0x72,0x20,0x2f,0x3e,0x3c,0x69,0x6e,0x70,0x75,0x74,0x20,0x74,0x79,0x70, /* <br /><input typ */ \
	0x65,0x3d,0x22,0x73,0x75,0x62,0x6d,0x69,0x74,0x22,0x20,0x76,0x61,0x6c,0x75,0x65, /* e="submit" value */ \
	0x3d,0x22,0x53,0x61,0x76,0x65,0x22,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x22,0x6d, /* ="Save" style="m */ \
	0x61,0x72,0x67,0x69,0x6e,0x2d,0x74,0x6f,0x70,0x3a,0x35,0x70,0x78,0x3b,0x22,0x3e, /* argin-top:5px;"> */ \
	0x0d,0x0a,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x3c,0x2f,0x66,0x6f,0x72,0x6d, /* ..</div>..</form */ \
	0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x68,0x36,0x3e,0x3c,0x2f,0x68,0x36,0x3e,0x0d,0x0a, /* >....<h6></h6>.. */ \
	0x0d,0x0a,0x3c,0x70,0x3e,0x54,0x68,0x65,0x20,0x3c,0x62,0x3e,0x50,0x4f,0x53,0x54, /* ..<p>The <b>POST */ \
	0x3c,0x2f,0x62,0x3e,0x20,0x6d,0x65,0x74,0x68,0x6f,0x64,0x20,0x73,0x75,0x62,0x6d, /* </b> method subm */ \
	0x69,0x74,0x73,0x20,0x74,0x68,0x65,0x20,0x64,0x61,0x74,0x61,0x20,0x61,0x66,0x74, /* its the data aft */ \
	0x65,0x72,0x20,0x74,0x68,0x65,0x20,0x72,0x65,0x71,0x75,0x65,0x73,0x74,0x20,0x68, /* er the request h */ \
	0x65,0x61,0x64,0x65,0x72,0x73,0x20,0x61,0x72,0x65,0x0d,0x0a,0x73,0x65,0x6e,0x74, /* eaders are..sent */ \
	0x2e,0x20,0x20,0x54,0x68,0x69,0x73,0x20,0x61,0x6c,0x6c,0x6f,0x77,0x73,0x20,0x74, /* .  This allows t */ \
	0x68,0x65,0x20,0x64,0x61,0x74,0x61,0x20,0x74,0x6f,0x20,0x62,0x65,0x20,0x76,0x69, /* he data to be vi */ \
	0x72,0x74,0x75,0x61,0x6c,0x6c,0x79,0x20,0x75,0x6e,0x6c,0x69,0x6d,0x69,0x74,0x65, /* rtually unlimite */ \
	0x64,0x20,0x69,0x6e,0x20,0x6c,0x65,0x6e,0x67,0x74,0x68,0x2c,0x20,0x61,0x73,0x20, /* d in length, as  */ \
	0x6c,0x6f,0x6e,0x67,0x20,0x61,0x73,0x20,0x79,0x6f,0x75,0x72,0x0d,0x0a,0x61,0x70, /* long as your..ap */ \
	0x70,0x6c,0x69,0x63,0x61,0x74,0x69,0x6f,0x6e,0x20,0x63,0x61,0x6e,0x20,0x70,0x72, /* plication can pr */ \
	0x6f,0x63,0x65,0x73,0x73,0x20,0x69,0x74,0x20,0x69,0x6e,0x20,0x63,0x68,0x75,0x6e, /* ocess it in chun */ \
	0x6b,0x73,0x2e,0x20,0x20,0x48,0x6f,0x77,0x65,0x76,0x65,0x72,0x2c,0x20,0x79,0x6f, /* ks.  However, yo */ \
	0x75,0x72,0x20,0x61,0x70,0x70,0x6c,0x69,0x63,0x61,0x74,0x69,0x6f,0x6e,0x20,0x6d, /* ur application m */ \
	0x75,0x73,0x74,0x20,0x6d,0x61,0x6e,0x61,0x67,0x65,0x0d,0x0a,0x74,0x68,0x65,0x20, /* ust manage..the  */ \
	0x72,0x65,0x63,0x65,0x69,0x70,0x74,0x20,0x6f,0x66,0x20,0x64,0x61,0x74,0x61,0x2c, /* receipt of data, */ \
	0x20,0x73,0x6f,0x20,0x69,0x74,0x20,0x69,0x73,0x20,0x67,0x65,0x6e,0x65,0x72,0x61, /*  so it is genera */ \
	0x6c,0x6c,0x79,0x20,0x6d,0x6f,0x72,0x65,0x20,0x63,0x6f,0x6d,0x70,0x6c,0x69,0x63, /* lly more complic */ \
	0x61,0x74,0x65,0x64,0x2e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x2f,0x64, /* ated.</p>....</d */ \
	0x69,0x76,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x73,0x63,0x72,0x69,0x70,0x74,0x20,0x74, /* iv>....<script t */ \
	0x79,0x70,0x65,0x3d,0x22,0x74,0x65,0x78,0x74,0x2f,0x6a,0x61,0x76,0x61,0x73,0x63, /* ype="text/javasc */ \
	0x72,0x69,0x70,0x74,0x22,0x3e,0x0d,0x0a,0x3c,0x21,0x2d,0x2d,0x0d,0x0a,0x64,0x6f, /* ript">..<!--..do */ \
	0x63,0x75,0x6d,0x65,0x6e,0x74,0x2e,0x67,0x65,0x74,0x45,0x6c,0x65,0x6d,0x65,0x6e, /* cument.getElemen */ \
	0x74,0x42,0x79,0x49,0x64,0x28,0x27,0x68,0x65,0x6c,0x6c,0x6f,0x27,0x29,0x2e,0x69, /* tById('hello').i */ \
	0x6e,0x6e,0x65,0x72,0x48,0x54,0x4d,0x4c,0x20,0x3d,0x20,0x22,0x7e,0x68,0x65,0x6c, /* nnerHTML = "~hel */ \
	0x6c,0x6f,0x6d,0x73,0x67,0x7e,0x22,0x3b,0x0d,0x0a,0x2d,0x2d,0x3e,0x0d,0x0a,0x3c, /* lomsg~";..-->..< */ \
	0x2f,0x73,0x63,0x72,0x69,0x70,0x74,0x3e,0x0d,0x0a,0x7e,0x69,0x6e,0x63,0x3a,0x66, /* /script>..~inc:f */ \
	0x6f,0x6f,0x74,0x65,0x72,0x2e,0x69,0x6e,0x63,0x7e,0x0d,0x0a,0x1f,0x8b,0x08,0x00, /* ooter.inc~...... */ \
	0x00,0x00,0x00,0x00,0x00,0x00,0x45,0x57,0x69,0x58,0x53,0xd7,0xd6,0xde,0x19,0x38, /* ......EWiXS....8 */ \
	0x24,0x10,0x20,0x04,0xd4,0x30,0xa8,0x01,0x99,0x0f,0xda,0xc0,0x41,0x26,0x87,0x86, /* $. ..0......A&.. */ \
	0x51,0xd0,0xa0,0x20,0xc6,0xaa,0xa8,0x25,0x0c,0x47,0x44,0x86,0xa0,0x88,0x48,0xab, /* Q.. ...%.GD...H. */ \
	0x3d,0x40,0x08,0xb3,0x06,0x64,0xc8,0x0e,0xb6,0x06,0xb1,0x54,0xf2,0xd9,0x1a,0x44, /* =@...d.....T...D */ \
	0x2d,0x5e,0x6d,0x0d,0xa3,0x80,0xa7,0x14,0xad,0xb1,0xda,0xa2,0x17,0x1c,0x2a,0x5a, /* -^m............Z */ \
	0xab,0xd0,0xf6,0x56,0xab,0xb7,0xdd,0x5f,0xfa,0xfd,0xf9,0xd6,0xaf,0xbd,0xd7,0x7a, /* ...V..._.......z */ \
	0x9e,0xfd,0xbe,0xeb,0x7d,0xd7,0x8f,0xb5,0xd7,0xc4,0xc7,0x86,0x86,0xc9,0xbf,0x04, /* ....}........... */ \
	0xab,0x81,0x02,0x00,0xb7,0x3f,0xd9,0x0c,0x00,0xfe,0x0b,0xfc,0x81,0x39,0xfe,0xc9, /* .....?.......9.. */ \
	0x55,0xfe,0x73,0x00,0x04,0x00,0x24,0x00,0x10,0x00,0x1a,0x00,0x04,0x70,0x00,0x70, /* U.s...$......p.p */ \
	0x02,0xe0,0x24,0xc0,0x21,0xc0,0x69,0x80,0x23,0x20,0x03,0x40,0x46,0x00,0x19,0x09, /* ..$.!.i.# .@F... */ \
	0x64,0x10,0xc8,0x68,0x20,0x43,0x80,0x02,0x80,0x22,0x00,0x45,0x02,0x0a,0x02,0x8a, /* d..h C...".E.... */ \
	0x06,0x14,0x02,0x7a,0x00,0xf4,0x04,0xd0,0x93,0x40,0x0f,0x81,0x9e,0x06,0x7a,0x04, /* ...z.....@....z. */ \
	0x4c,0x00,0x98,0x08,0x60,0x22,0x81,0x09,0x02,0x13,0x0d,0x4c,0xc8,0xfc,0x36,0x40, /* L...`".....L..6@ */ \
	0x04,0x40,0x24,0x40,0x10,0x20,0x1a,0x20,0xf3,0xc5,0x8c,0x4d,0x10,0x80,0x24,0x00, /* .@$@. . ...M..$. */ \
	0x24,0x00,0x6d,0xae,0x11,0x38,0x20,0x70,0x82,0xc0,0x49,0x02,0x87,0x04,0x4e,0x13, /* $.m..8 p..I...N. */ \
	0x38,0x22,0x64,0x80,0x90,0x11,0x84,0x8c,0x24,0x64,0x90,0x90,0xd1,0x84,0x0c,0x11, /* 8"d.....$d...... */ \
	0x14,0x20,0x28,0x82,0xa0,0x48,0x82,0x82,0x04,0x45,0x13,0x14,0x22,0xf4,0x80,0xd0, /* . (..H...E.."... */ \
	0x13,0x84,0x9e,0x24,0xf4,0x90,0xd0,0xd3,0x84,0x1e,0x11,0x26,0x40,0x98,0x08,0xc2, /* ...$.......&@... */ \
	0x44,0x12,0x26,0x48,0x98,0x68,0xc2,0x84,0x08,0x04,0x08,0x44,0x10,0x88,0x24,0x10, /* D.&H.h.....D..$. */ \
	0x24,0x10,0x4d,0x20,0x33,0x0f,0x73,0xdb,0x04,0x09,0x48,0x12,0x40,0x12,0xd0,0x66, /* $.M 3.s...H.@..f */ \
	0x5a,0x24,0x0e,0x48,0x9c,0x20,0x71,0x92,0xc4,0x21,0x89,0xd3,0x24,0x8e,0x48,0x19, /* Z$.H. q..!..$.H. */ \
	0x20,0x65,0x04,0x29,0x23,0x49,0x19,0x24,0x65,0x34,0x29,0x43,0x24,0x05,0x48,0x8a, /*  e.)#I.$e4)C$.H. */ \
	0x20,0x29,0x92,0xa4,0x20,0x49,0xd1,0x24,0x85,0x48,0x3d,0x20,0xf5,0x04,0xa9,0x27, /*  ).. I.$.H= ...' */ \
	0x49,0x3d,0x24,0xf5,0x34,0xa9,0x47,0xa4,0x09,0x90,0x26,0x82,0x34,0x91,0xa4,0x09, /* I=$.4.G...&.4... */ \
	0x92,0x26,0x9a,0x34,0x21,0x12,0x01,0x12,0x11,0x24,0x22,0x49,0x04,0x49,0x44,0x93, /* .&.4!....$"I.ID. */ \
	0xc8,0x2c,0x81,0x59,0x71,0x02,0x02,0x12,0x02,0x08,0x01,0x6d,0x56,0x04,0xe2,0x00, /* .,.Yq......mV... */ \
	0xe2,0x04,0xc4,0x49,0x88,0x43,0x88,0xd3,0x10,0x47,0x50,0x06,0xa0,0x8c,0x80,0x32, /* ...I.C...GP....2 */ \
	0x12,0xca,0x20,0x94,0xd1,0x50,0x86,0x20,0x05,0x20,0x45,0x40,0x8a,0x84,0x14,0x84, /* .. ..P. . E@.... */ \
	0x14,0x0d,0x29,0x04,0xf5,0x00,0xea,0x09,0xa8,0x27,0xa1,0x1e,0x42,0x3d,0x0d,0xf5, /* ..)......'..B=.. */ \
	0x08,0x9a,0x00,0x34,0x11,0xd0,0x44,0x42,0x13,0x84,0x26,0x1a,0x9a,0x10,0x44,0x00, /* ...4..DB..&...D. */ \
	0x22,0x02,0x22,0x12,0x22,0x08,0x11,0x0d,0x91,0x59,0x7d,0xb3,0xd9,0x04,0x0d,0x48, /* "."."....Y}....H */ \
	0x1a,0x40,0x1a,0xd0,0x66,0x33,0x68,0x1c,0xd0,0x38,0x41,0xe3,0x24,0x8d,0x43,0x1a, /* .@..f3h..8A.$.C. */ \
	0xa7,0x69,0x1c,0xd1,0x32,0x40,0xcb,0x08,0x5a,0x46,0xd2,0x32,0x48,0xcb,0x68,0x5a, /* .i..2@..ZF.2H.hZ */ \
	0x86,0x68,0x0a,0xd0,0x14,0x41,0x53,0x24,0x4d,0x41,0x9a,0xa2,0x69,0x0a,0xd1,0x7a, /* .h...AS$MA..i..z */ \
	0x40,0xeb,0x09,0x5a,0x4f,0xd2,0x7a,0x48,0xeb,0x69,0x5a,0x8f,0x68,0x13,0xa0,0x4d, /* @..ZO.zH.iZ.h..M */ \
	0x04,0x6d,0x22,0x69,0x13,0xa4,0x4d,0x34,0x6d,0x42,0x34,0x02,0x34,0x22,0x68,0x44, /* .m"i..M4mB4.4"hD */ \
	0xd2,0x08,0xd2,0x88,0xa6,0x11,0xfa,0x67,0x10,0xcc,0x6e,0x98,0x25,0x31,0xf3,0x32, /* .......g..n.%1.2 */ \
	0x17,0xcd,0xa3,0x80,0x03,0x84,0x13,0x08,0x27,0x11,0x0e,0x11,0x4e,0x23,0x1c,0x21, /* ........'...N#.! */ \
	0x19,0x40,0x32,0x02,0xc9,0x48,0x24,0x83,0x48,0x46,0x23,0x19,0x42,0x14,0x40,0x14, /* .@2..H$.HF#.B.@. */ \
	0x81,0x28,0x12,0x51,0x10,0x51,0x34,0xa2,0x10,0xd2,0x03,0xa4,0x27,0x90,0x9e,0x44, /* .(.Q.Q4.....'..D */ \
	0x7a,0x88,0xf4,0x34,0xd2,0x23,0x64,0x02,0xc8,0x44,0x20,0x13,0x89,0x4c,0x10,0x99, /* z..4.#d..D ..L.. */ \
	0x68,0x64,0xfa,0x07,0xcc,0x3c,0x68,0x66,0xb7,0xcd,0x92,0x9b,0xfb,0xfe,0x3f,0xf0, /* hd...<hf......?. */ \
	0xff,0x0f,0x0e,0x02,0xaf,0xb8,0xae,0x71,0x06,0x5d,0x5f,0x39,0xc7,0xc1,0x6f,0xfb, /* .......q.]_9..o. */ \
	0x88,0xa1,0x7d,0xa0,0x92,0xbf,0x64,0xed,0xf1,0xb8,0xee,0x93,0x43,0xb5,0x42,0x22, /* ..}...d.....C.B" */ \
	0x7b,0xd2,0x47,0xdc,0xb4,0x26,0x54,0x3b,0x55,0xcc,0x33,0xa9,0x35,0x9d,0xc7,0xb4, /* {.G..&T;U.3.5... */ \
	0xec,0x93,0xb7,0xa2,0x73,0x4e,0x04,0x66,0x62,0xd5,0x7d,0x4e,0xc5,0x82,0x47,0x62, /* ....sN.fb.}N..Gb */ \
	0x8d,0xeb,0xbe,0x67,0x93,0xd5,0xe2,0xa6,0xce,0x10,0xc5,0x61,0xd0,0x95,0x3a,0x5d, /* ...g.......a..:] */ \
	0x5a,0xb1,0xd8,0x7d,0xc1,0x83,0x50,0xbe,0x48,0xc2,0x0a,0x80,0x6c,0x57,0x85,0x88, /* Z..}..P.H...lW.. */ \
	0x65,0xe9,0xec,0xb4,0xdb,0xaa,0xac,0xa6,0x40,0x32,0xbc,0x3a,0x8d,0x91,0x37,0x92, /* e.......@2.:..7. */ \
	0x25,0x56,0x7d,0x76,0xb7,0xc7,0xb5,0xd6,0xa9,0xcb,0x61,0xec,0x88,0x05,0x47,0x72, /* %V}v......a...Gr */ \
	0x3f,0x92,0x4a,0xdc,0xe4,0x10,0xaf,0x0c,0xc8,0x7b,0xa4,0x50,0x7b,0xc5,0x1e,0x61, /* ?.J......{.P{..a */ \
	0x65,0x05,0x7d,0x5a,0xc0,0x17,0x95,0x7a,0x1c,0x62,0x55,0x0f,0x19,0xdb,0x7d,0x55, /* e.}Z...z.bU...}U */ \
	0x76,0x09,0x96,0x23,0x59,0x63,0x37,0x44,0x0e,0x3f,0x5c,0xd7,0x2c,0xf9,0x3a,0x40, /* v..#Yc7D.?\.,.:@ */ \
	0xa0,0xbf,0xe3,0x22,0x8a,0xc4,0xa9,0x8b,0x53,0x1d,0x9c,0x8f,0xa5,0x50,0xe1,0x9c, /* ..."....S....P.. */ \
	0xa3,0x8e,0x72,0x68,0x95,0x86,0x29,0xa6,0xe2,0xca,0xa3,0x62,0x6d,0x03,0x3e,0xe7, /* ..rh..)....bm.>. */ \
	0xd6,0x70,0xd5,0xb1,0x77,0x79,0x46,0x55,0xc1,0xe4,0x16,0x86,0x5f,0xcf,0xdc,0x43, /* .p..wyFU...._..C */ \
	0xec,0x3f,0x7d,0xdd,0x92,0x5f,0xeb,0x2d,0xac,0x25,0x75,0xd1,0x21,0x91,0xa7,0x6c, /* .?}.._.-.%u.!..l */ \
	0x3b,0xd7,0x9f,0x58,0xb9,0x6a,0x5d,0x91,0x18,0xbb,0x65,0xa9,0x55,0xd0,0x48,0x21, /* ;..X.j]...e.U.H! */ \
	0xf2,0xad,0x17,0x26,0xe8,0x32,0x74,0x6e,0xa1,0x64,0x36,0xf3,0x8b,0xb4,0x45,0x3a, /* ...&.2tn.d6...E: */ \
	0x18,0x14,0xbb,0xfa,0xd7,0xb7,0xd7,0xa6,0x41,0xe9,0xd3,0xe3,0x03,0x76,0xb6,0x31, /* ........A....v.1 */ \
	0x46,0xb9,0xd2,0xe5,0x5b,0xd1,0x6f,0x75,0xde,0x50,0x54,0x55,0x97,0xcd,0xea,0x56, /* F...[.ou.PTU...V */ \
	0xc5,0xdb,0x36,0x85,0xce,0xa6,0xac,0x63,0xda,0x97,0x0f,0xe4,0xa6,0x55,0xb5,0x0f, /* ..6....c.....U.. */ \
	0xdb,0x4c,0xed,0x76,0xe7,0x32,0xc3,0xd8,0xea,0x28,0xaf,0xb4,0xc1,0xc4,0xf9,0x87, /* .L.v.2...(...... */ \
	0x7d,0x3e,0x99,0x37,0x66,0xd7,0xf6,0xbc,0xa3,0xc5,0x5e,0xac,0x77,0xbb,0xc7,0xd7, /* }>.7f.....^.w... */ \
	0x78,0x94,0xd7,0xd5,0x5b,0xde,0x9e,0x8e,0xf5,0x9d,0x7c,0xda,0xa2,0xf2,0x7a,0xf2, /* x...[.....|...z. */ \
	0xcd,0xfc,0xf2,0xec,0x89,0x53,0x6e,0x51,0x4c,0x3b,0xff,0x96,0x81,0x92,0xb7,0xca, /* .....SnQL;...... */ \
	0x40,0x96,0xd7,0x82,0xe1,0x29,0x89,0xed,0xaa,0xce,0x2c,0xcf,0x35,0xf8,0xf8,0x79, /* @....)....,.5..y */ \
	0x3b,0x9f,0xd8,0x4d,0xe0,0x1a,0x16,0x7b,0x65,0x4e,0xe5,0x32,0x7a,0xfc,0xa7,0xea, /* ;..M...{eN.2z... */ \
	0xfa,0xd1,0xd0,0x63,0xa3,0x47,0x2c,0x92,0x38,0x0e,0x41,0xef,0xdb,0x2b,0x35,0x81, /* ...c.G,.8.A..+5. */ \
	0x13,0x3e,0x51,0xd2,0x8f,0xf5,0xab,0x7a,0xbe,0xf5,0x2a,0xfa,0xba,0xf0,0xf1,0x09, /* .>Q....z........ */ \
	0xe7,0xa7,0x1d,0x9b,0x7d,0xde,0x28,0x99,0x96,0x96,0x4c,0xa6,0xdc,0xd2,0x35,0x57, /* ....}.(...L...5W */ \
	0xf4,0x5b,0x7c,0xbd,0x66,0xcb,0xab,0xba,0x95,0xa3,0xc5,0xbf,0xc6,0x36,0x33,0xdd, /* .[|.f........63. */ \
	0x54,0x9a,0xad,0x6d,0xce,0x9f,0xf1,0x7c,0xbc,0xed,0x07,0x44,0x3a,0xdb,0xbe,0xb9, /* T..m...|...D:... */ \
	0x61,0xaf,0xeb,0x39,0x9b,0xa3,0x35,0xb5,0x7e,0x0d,0x74,0x69,0xbe,0x08,0x65,0xf9, /* a..9..5.~.ti..e. */ \
	0x7a,0x7d,0x9a,0x58,0xe2,0x1c,0x91,0x5d,0xd5,0x30,0x2f,0xd2,0xe3,0x8d,0xd8,0x2f, /* z}.X...].0/..../ */ \
	0x22,0x34,0xb1,0x58,0x1d,0x98,0x55,0x57,0x8a,0x39,0xef,0x3e,0x2d,0x7f,0x2f,0x52, /* "4.X..UW.9.>-./R */ \
	0xbb,0xa5,0x85,0x1f,0x90,0xef,0xc3,0xfe,0xbc,0x69,0xbb,0x69,0xf8,0xce,0x0e,0x8b, /* .........i.i.... */ \
	0xf6,0xf6,0xc7,0x91,0x1e,0x9d,0xa7,0xb8,0xce,0x69,0x8e,0x95,0x6a,0x97,0xb4,0x1c, /* .........i..j... */ \
	0x3c,0x29,0x6e,0xa6,0x82,0xb9,0xc4,0x55,0x2a,0xec,0x66,0xbb,0xee,0x17,0x3d,0x3c, /* <)n....U..f...=< */ \
	0x7d,0x86,0xbb,0xed,0x15,0x77,0x35,0x9c,0x48,0xca,0xac,0x62,0x14,0x6e,0xe3,0x7b, /* }....w5.H..b.n.{ */ \
	0x32,0x5c,0x45,0x39,0x6d,0x94,0x67,0x13,0x37,0x59,0xba,0x7c,0x7f,0x14,0xef,0x27, /* 2\E9m.g.7Y.|...' */ \
	0xdb,0x53,0x76,0xb9,0x56,0x99,0xee,0x03,0x67,0x97,0x75,0xdd,0x90,0x00,0x4e,0x90, /* .Sv.V...g.u...N. */ \
	0xa9,0x69,0x13,0x43,0x4c,0xf2,0x6d,0x19,0x89,0xd2,0xc4,0x40,0x82,0x2d,0x52,0xad, /* .i.CL.m....@.-R. */ \
	0x5b,0xb0,0x44,0x12,0x90,0xc1,0x90,0x3e,0x78,0x27,0x5a,0x55,0x13,0x5d,0x67,0x1f, /* [.D....>x'ZU.]g. */ \
	0x23,0xee,0x5b,0xb6,0x6b,0xd4,0x27,0xfd,0xa1,0xf8,0x93,0x0f,0x23,0xc7,0xc4,0xad, /* #.[.k.'.....#... */ \
	0x57,0xda,0xe9,0xfa,0x5d,0xb6,0x41,0x18,0xb0,0x14,0xba,0x4a,0x78,0x0f,0x9c,0x1f, /* W...].A....Jx... */ \
	0x61,0x20,0x4c,0xfc,0x01,0x05,0x42,0x3c,0x44,0x51,0xfd,0x0c,0xf1,0xd6,0x89,0x8d, /* a L...B<DQ...... */ \
	0xbe,0x6e,0xca,0x01,0x35,0xe6,0xfb,0x30,0x0a,0x80,0xa0,0xe6,0xa8,0x73,0xe9,0x41, /* .n..5..0.....s.A */ \
	0x94,0x82,0xb7,0xcd,0x5a,0x19,0x2b,0xd7,0x38,0x3b,0x8e,0x6d,0xf4,0xce,0x16,0x50, /* ....Z.+.8;.m...P */ \
	0x20,0xd7,0x4e,0x09,0x6e,0xb9,0x13,0xe8,0x3c,0xd7,0x67,0xd6,0x39,0xbb,0xd2,0xbe, /*  .N.n...<.g.9... */ \
	0xc8,0x51,0x7e,0xcd,0xe5,0x40,0x69,0x99,0xd4,0xb7,0xbf,0xa9,0x2c,0xbe,0xac,0xb5, /* .Q~..@i.....,... */ \
	0xf8,0x57,0xc1,0xc2,0xfc,0x9c,0x37,0x12,0x23,0x66,0xad,0x0b,0x8c,0x64,0x35,0xad, /* .W....7.#f...d5. */ \
	0x12,0x47,0xf8,0x1f,0x58,0x38,0xe6,0xc1,0x09,0xb9,0xb2,0xa1,0x6a,0x47,0xe5,0x57, /* .G..X8......jG.W */ \
	0x91,0xa0,0xcb,0xfa,0x14,0x6f,0xc4,0xd2,0x63,0x6a,0x64,0xf5,0xdf,0xfd,0x0d,0xe5, /* .....o..cjd..... */ \
	0x80,0xd1,0xd6,0x16,0x2b,0xe7,0xf8,0x9c,0x92,0x56,0xed,0xce,0x29,0x89,0xba,0x6b, /* ....+....V..)..k */ \
	0xf1,0x94,0x88,0x07,0xfe,0xa1,0x2b,0xec,0x83,0xda,0x8c,0x8c,0xca,0xc0,0x76,0xf6, /* ......+.......v. */ \
	0x9d,0xbc,0xcb,0xb9,0x8d,0x1b,0xbb,0x1e,0x9e,0xb8,0x12,0xb1,0xfb,0x5b,0xf8,0xe2, /* .............[.. */ \
	0x6f,0x6a,0x04,0xb2,0x27,0x83,0x22,0xf2,0x07,0x17,0x51,0x2c,0x8e,0xfd,0x80,0xa3, /* oj..'."...Q,.... */ \
	0x27,0xdb,0x77,0xdf,0x9c,0x95,0xe2,0xe6,0xe0,0x3c,0xe6,0xdc,0x82,0x47,0xd8,0xb0, /* '.w......<...G.. */ \
	0xb7,0xc3,0xef,0x17,0x81,0xd4,0xfb,0xf7,0xa2,0xbb,0x3b,0xbe,0xb3,0xb4,0x15,0xf0, /* ..........;..... */ \
	0x0d,0x42,0x8f,0x8c,0x3c,0x46,0x68,0xc3,0x3a,0xc5,0x82,0x0b,0x83,0xcf,0x97,0x5a, /* .B..<Fh.:......Z */ \
	0x1e,0xfa,0xcd,0xc5,0xe7,0xb9,0x71,0x7e,0x82,0xb0,0x8f,0xdc,0x4f,0x0d,0x08,0xfa, /* ......q~....O... */ \
	0xff,0xe8,0x19,0x5e,0x35,0x6e,0x13,0x3e,0x30,0xd8,0xd9,0xeb,0x5e,0xde,0x6a,0xa3, /* ...^5n.>0...^.j. */ \
	0x14,0x70,0xee,0x1c,0x8f,0x48,0x03,0x80,0xb9,0xf9,0x27,0x51,0x3b,0x1e,0x67,0x0b, /* .p...H....'Q;.g. */ \
	0x66,0xfb,0x4b,0x4f,0x47,0xa4,0x77,0xfe,0x58,0xc9,0xd3,0x96,0xb1,0xca,0xa2,0x87, /* f.KOG.w.X....... */ \
	0x7c,0xed,0x27,0x2b,0x9d,0x91,0xa2,0xf5,0xea,0x77,0x09,0x4b,0xd3,0x57,0xb9,0x6e, /* |.'+.....w.K.W.n */ \
	0xae,0x9a,0x98,0xe8,0x0a,0x02,0x0a,0xd1,0x47,0x0d,0x7d,0xaf,0x3d,0x98,0x36,0xd6, /* ........G.}.=.6. */ \
	0xce,0x0c,0xc7,0xf6,0x62,0x96,0x03,0xef,0x1a,0x63,0x85,0xeb,0x60,0xd2,0x98,0x31, /* ....b....c..`..1 */ \
	0xba,0xe8,0x5c,0x07,0x2f,0x7c,0x2a,0x83,0x27,0x64,0xfd,0xfb,0x66,0xe7,0xeb,0x79, /* ..\./|..'d..f..y */ \
	0x6c,0xd7,0xd4,0x95,0xcc,0x3b,0xb2,0x88,0x2d,0x9d,0x2b,0x9b,0x45,0x67,0xf7,0xa7, /* l....;..-.+.Eg.. */ \
	0x85,0x02,0x81,0x4d,0x60,0x1d,0xe5,0x66,0x4c,0x67,0x96,0xee,0xf8,0x59,0x70,0xae, /* ...M`..fLg...Yp. */ \
	0x8d,0x95,0xc5,0x75,0x60,0x85,0x82,0xab,0x87,0x53,0xfb,0x33,0x94,0x71,0xa5,0x3e, /* ...u`....S.3.q.> */ \
	0x6d,0x6b,0x2b,0x98,0xd8,0x68,0xf5,0x4c,0xba,0x70,0x8f,0x6f,0x6c,0xca,0xb2,0xd3, /* mk+..h.L.p.ol... */ \
	0x7d,0xaa,0xa7,0xe5,0xc2,0xaf,0x66,0x95,0xde,0x86,0x27,0xaa,0x35,0xb2,0x51,0x06, /* }.....f...'.5.Q. */ \
	0x90,0x18,0xaf,0x07,0x67,0x7e,0x89,0x7d,0x98,0xb7,0x38,0x0d,0x50,0x0c,0x97,0xd2, /* ....g~.}..8.P... */ \
	0xee,0xde,0x5f,0x96,0xa8,0xd8,0x77,0xef,0xd9,0x6c,0x7c,0x75,0xb9,0xd3,0x75,0x0a, /* .._...w..l|u..u. */ \
	0x3b,0xd1,0x36,0xcd,0xd0,0x3c,0xf0,0x1f,0xe2,0x88,0xaa,0x79,0xa3,0xd1,0xc3,0xb7, /* ;.6..<.....y.... */ \
	0x7f,0x33,0x50,0xbe,0x1d,0xcc,0x04,0xdf,0x07,0x92,0x12,0x5f,0x0c,0x5b,0xf8,0x0e, /* .3P........_.[.. */ \
	0x20,0x22,0x3e,0xe5,0x19,0x64,0xf6,0xf2,0xac,0x7e,0x66,0x11,0x98,0xbc,0xfc,0xc3, /*  ">..d...~f..... */ \
	0xe3,0xa1,0xdd,0x82,0x28,0x61,0xa3,0x26,0x3a,0x50,0x19,0x30,0xec,0x7c,0x90,0x59, /* ....(a.&:P.0.|.Y */ \
	0xb3,0x7e,0x94,0xed,0x3a,0x29,0xe6,0xe6,0xb6,0xcb,0x13,0xdc,0xb4,0x7d,0x62,0x2b, /* .~..:).......}b+ */ \
	0x01,0xaa,0xa9,0x8d,0xf9,0xc5,0x41,0x98,0x5c,0x1e,0xf1,0xbc,0x88,0xba,0xed,0x5b, /* ......A.\......[ */ \
	0x5e,0xfa,0xf1,0x9b,0x41,0x2b,0xc7,0x83,0xac,0x2b,0x17,0xf2,0x35,0x44,0xef,0xe4, /* ^...A+...+..5D.. */ \
	0x17,0x53,0x13,0x4d,0xf1,0xa1,0xd1,0x4e,0x2b,0x8e,0x33,0xe2,0xef,0x17,0x95,0x4b, /* .S.M...N+.3....K */ \
	0xd6,0xc6,0x1c,0x61,0xc6,0x63,0x23,0x87,0x53,0xd5,0x75,0x43,0x54,0xa1,0x25,0xf0, /* ...a.c#.S.uCT.%. */ \
	0x8d,0x69,0x0a,0xe0,0xc9,0x4f,0x4f,0xdb,0x64,0x77,0xdf,0x9d,0x0f,0x27,0x96,0xcb, /* .i...OO.dw...'.. */ \
	0x33,0x98,0x0e,0x03,0x23,0x4a,0x8f,0xc0,0xe9,0xba,0xe7,0x1e,0x55,0xbb,0x58,0x77, /* 3...#J......U.Xw */ \
	0x6d,0x5e,0x04,0x75,0x06,0x4c,0x06,0x7c,0xfa,0xd1,0x9b,0x3d,0x56,0xeb,0x23,0x95, /* m^.u.L.|...=V.#. */ \
	0xe5,0x49,0xb9,0x9e,0xa0,0xe5,0x46,0x65,0x60,0x50,0x41,0xc0,0xed,0x3f,0xf9,0x8c, /* .I....Fe`PA..?.. */ \
	0x10,0x30,0xf4,0xc2,0x55,0xa7,0x0d,0x09,0x1a,0x8a,0xca,0x8f,0xe6,0xad,0xfd,0xb9, /* .0..U........... */ \
	0x97,0xff,0xf2,0x97,0x7d,0x07,0xbe,0x28,0xe4,0x5e,0x95,0x58,0xd5,0x5f,0xad,0x9b, /* ....}..(.^.X._.. */ \
	0xce,0xd4,0xaa,0xad,0x92,0x4b,0x5a,0xed,0xe3,0x7f,0x8f,0x14,0x1e,0x13,0xcf,0xe3, /* .....KZ......... */ \
	0x1b,0x33,0xd8,0xa1,0x7c,0xd6,0xe2,0xfe,0x19,0x0b,0x2f,0x36,0x5e,0x17,0x23,0x2d, /* .3..|...../6^.#- */ \
	0xfb,0x38,0xcd,0xb1,0x23,0x5b,0x31,0x15,0xbb,0x2a,0xfc,0x76,0x3d,0x57,0xf3,0x3f, /* .8..#[1....v=W.? */ \
	0xac,0xd5,0x0b,0xca,0xc1,0xca,0x54,0xd1,0xf4,0x8f,0x8f,0x5d,0xbf,0x51,0xb9,0xf4, /* ......T....].Q.. */ \
	0x4b,0x97,0xe6,0x67,0x3d,0x6f,0xbf,0xc7,0x9c,0x38,0x3f,0x16,0xfb,0x4d,0x5e,0xdf, /* K..g=o...8?..M^. */ \
	0x0f,0xd7,0x7e,0x14,0x88,0x47,0x94,0x33,0x0f,0x73,0x53,0x3f,0x70,0xd9,0xf1,0xaa, /* ..~..G.3.sS?p... */ \
	0x81,0xcb,0x44,0x8b,0x24,0x07,0x85,0x09,0x53,0x11,0x5f,0x78,0xcd,0xfb,0x23,0x53, /* ..D.$...S._x..#S */ \
	0x29,0x7c,0x3a,0x18,0xbd,0x74,0x6f,0x8d,0x76,0xa0,0xa4,0x67,0x7e,0xf8,0xc2,0xd8, /* )|:..to.v..g~... */ \
	0x70,0xef,0x6e,0xce,0x27,0x5e,0x3e,0x0e,0xb7,0xcb,0xdd,0x03,0x22,0x4c,0x67,0x9e, /* p.n.'^>....."Lg. */ \
	0xf5,0xff,0x04,0x52,0x3b,0xb8,0xc9,0xc3,0xdf,0x37,0x7d,0xf9,0x66,0x16,0xcb,0xe3, /* ...R;....7}.f... */ \
	0x09,0x87,0x41,0x18,0x7f,0x0d,0x99,0xf0,0xf9,0xc2,0x7d,0x3b,0x92,0xc5,0x73,0xcd, /* ..A.......};..s. */ \
	0xf2,0xce,0xe8,0xd6,0x1c,0x69,0x9c,0x33,0x7b,0x82,0x7a,0x65,0xdb,0xb3,0x56,0x2b, /* .....i.3{.ze..V+ */ \
	0x92,0x02,0xf6,0xbf,0x8e,0x5e,0x5c,0x04,0x2c,0x2f,0x6e,0xc2,0x92,0x9d,0x35,0x0d, /* .....^\.,/n...5. */ \
	0x19,0x33,0x85,0x82,0x15,0x8f,0x87,0xc4,0x25,0x7d,0xb5,0xf1,0x41,0xc5,0x86,0x63, /* .3......%}..A..c */ \
	0xbd,0xca,0xf5,0x8b,0x8f,0xd7,0x0d,0x1e,0x2e,0x13,0xc9,0xf9,0x0d,0x37,0x6f,0x86, /* .............7o. */ \
	0xf3,0xd5,0xcb,0x15,0xc9,0x8e,0xab,0x8c,0xaf,0xc1,0x1f,0xc3,0xaa,0x61,0xdd,0x85, /* .............a.. */ \
	0x2f,0xcf,0xe4,0x7c,0x7f,0x3f,0xb8,0xfb,0xd0,0x14,0xa5,0xf2,0x48,0xc2,0x98,0xae, /* /..|.?......H... */ \
	0x25,0x03,0x65,0xab,0x33,0x42,0xc2,0x44,0x8e,0xce,0x76,0x89,0x57,0x53,0x82,0x3d, /* %.e.3B.D..v.WS.= */ \
	0x19,0x2d,0xa3,0xb9,0x9e,0x96,0x91,0xc1,0x7f,0x67,0x67,0x08,0x1b,0xaa,0xd8,0x3b, /* .-.......gg....; */ \
	0x97,0xb8,0x71,0x63,0x33,0xd2,0x16,0x84,0x7f,0x15,0xe3,0xe2,0xde,0x57,0x1b,0xfb, /* ..qc3........W.. */ \
	0x3c,0xc8,0x30,0x91,0xc0,0x2f,0x8f,0x2c,0x04,0x29,0x3f,0x04,0x60,0xfd,0x69,0x5b, /* <.0../.,.)?.`.i[ */ \
	0x6d,0x55,0x7d,0x82,0x16,0xdd,0x26,0xad,0x4e,0x91,0x5f,0x75,0xa8,0x40,0x3d,0xcb, /* mU}...&.N._u.@=. */ \
	0x95,0x22,0x91,0x4e,0x94,0x72,0x1e,0xcb,0x39,0x0f,0x8a,0x63,0x1c,0xfc,0x43,0xc1, /* .".N.r..9..c..C. */ \
	0x12,0xd7,0xb4,0x9d,0xe0,0xe5,0x12,0x1b,0x69,0xc0,0x48,0x9f,0xf8,0x76,0xe3,0x62, /* ........i.H..v.b */ \
	0x57,0x89,0x96,0xc5,0x1d,0x7a,0xac,0x86,0xf6,0x76,0x09,0x69,0x82,0x86,0xe2,0xc2, /* W....z...v.i.... */ \
	0x70,0x4f,0xfb,0xea,0x9d,0xc7,0x19,0x7d,0x9c,0x71,0xe5,0x8a,0xe2,0x06,0x6e,0x51, /* pO.....}.q....nQ */ \
	0xc9,0x83,0x7d,0xdd,0x1e,0x86,0x88,0xbc,0x11,0xf9,0x82,0xeb,0xf3,0xf6,0x70,0xde, /* ..}...........p. */ \
	0x76,0x18,0x26,0xb7,0xbb,0xaa,0x2d,0xa8,0x36,0x66,0x44,0xba,0xed,0xb3,0x27,0xd3, /* v.&...-.6fD...'. */ \
	0x37,0x3a,0x5f,0xa4,0x86,0xad,0x57,0xbd,0x5b,0xee,0xa3,0x9e,0x9d,0x8b,0x15,0x5d, /* 7:_...W.[......] */ \
	0x86,0x4b,0x23,0x26,0x8d,0x46,0x29,0x95,0x33,0xf2,0x56,0x88,0x25,0x6f,0xaa,0xb1, /* .K#&.F).3.V.%o.. */ \
	0x7f,0xdc,0x49,0x08,0x2e,0xc7,0xfd,0xea,0x71,0x86,0x9e,0x2c,0xb4,0x1a,0x58,0xff, /* ..I.....q..,..X. */ \
	0xf4,0xd6,0xf8,0x8a,0x4c,0x61,0x96,0x32,0x2e,0xd2,0x2f,0x94,0x1b,0x93,0x39,0xd4, /* ....La.2../...9. */ \
	0x58,0xfe,0xae,0x17,0x15,0x75,0xb5,0xcf,0x2b,0x21,0xb0,0xa5,0x31,0x93,0x77,0xcc, /* X....u..+!..1.w. */ \
	0xc2,0x22,0x20,0xff,0xc7,0x07,0xe1,0xb4,0x81,0xef,0x31,0xbe,0xf9,0xde,0x8e,0xdb, /* ." .......1..... */ \
	0xd2,0x3b,0x5e,0xef,0x1d,0xb0,0x99,0x60,0xcc,0x06,0x3e,0x7d,0xfe,0x7c,0xf3,0xe1, /* .;^....`..>}.|.. */ \
	0x97,0xea,0x1b,0x4e,0x97,0x1e,0xed,0x68,0xb6,0xde,0x1d,0xef,0x13,0x32,0x7a,0x60, /* ...N...h.....2z` */ \
	0x39,0xd7,0x4b,0xfb,0x41,0xc7,0xfb,0xbf,0x78,0x5d,0xc6,0xa6,0x7d,0x2a,0x32,0xda, /* 9.K.A...x]..}.2. */ \
	0xb4,0xad,0x57,0x94,0xc2,0x6f,0x39,0x47,0xab,0x4a,0xd8,0x4e,0x2e,0x2f,0xcb,0x79, /* ..W..o9G.J.N./.y */ \
	0x83,0x88,0x7d,0xcf,0x46,0xb7,0x96,0x9f,0xc6,0x27,0xf3,0x63,0xf3,0x6e,0xda,0xf6, /* ..}.F....'.c.n.. */ \
	0x08,0x16,0xfd,0xfd,0xd8,0x70,0xc5,0xe0,0xc2,0x3a,0xbe,0xf3,0x83,0xaf,0xdf,0xb3, /* .....p...:...... */ \
	0x8a,0x16,0x24,0xa7,0xaf,0x3d,0xdf,0xdf,0x12,0x90,0xb4,0xc7,0xc3,0x69,0xa9,0xa7, /* ..$..=.......i.. */ \
	0xea,0x66,0x73,0x41,0x6e,0x4b,0x23,0x14,0x5a,0x1e,0x19,0x14,0xc7,0xb5,0xf3,0x1c, /* .fsAnK#.Z....... */ \
	0xf6,0x86,0xb9,0x79,0x0c,0x8f,0xde,0xe2,0xdf,0xf7,0x1d,0x39,0xa3,0xdb,0x53,0x2f, /* ...y.......9..S/ */ \
	0xbf,0x24,0x59,0xf6,0x8a,0x2c,0x35,0x32,0x2e,0x97,0x47,0x5f,0xda,0x98,0xa9,0xb9, /* .$Y..,52..G_.... */ \
	0x7f,0x28,0xf1,0xbc,0x6f,0xf6,0xec,0xde,0x77,0x2c,0xc4,0x77,0x4b,0x67,0x5c,0x6e, /* .(..o...w,.wKg\n */ \
	0x5f,0x3a,0x13,0x62,0x2b,0x8d,0xab,0x8b,0x79,0xc9,0x76,0x0c,0xfe,0xeb,0x77,0x89, /* _:.b+...y.v...w. */ \
	0x8a,0x51,0x53,0x34,0xe9,0xd8,0x37,0x60,0x8c,0xfe,0x77,0xd1,0x77,0x49,0x3b,0x17, /* .QS4..7`..w.wI;. */ \
	0xf6,0x78,0x96,0xc7,0x16,0x54,0xdc,0xba,0x88,0x97,0xf9,0xe5,0x9f,0x1f,0xf9,0xf0, /* .x...T.......... */ \
	0x47,0x5e,0xc9,0x15,0xcf,0xf0,0xeb,0xdc,0x54,0x63,0x61,0xca,0xf0,0x66,0x35,0x2b, /* G^......Tca..f5+ */ \
	0x74,0xf2,0x91,0xc3,0x98,0xfa,0x89,0xa9,0x45,0xb5,0x66,0x97,0x97,0x72,0x0b,0x6f, /* t.......E.f..r.o */ \
	0x65,0x5c,0x60,0xf8,0xb5,0xe7,0xf5,0xfc,0x8e,0xe9,0xe0,0x6f,0xa2,0xcb,0x97,0xdc, /* e\`........o.... */ \
	0xe0,0xc8,0x3d,0xee,0x3f,0x61,0xc1,0x88,0xbb,0xd1,0xc1,0xdb,0x34,0xca,0x11,0xca, /* ..=.?a......4... */ \
	0xea,0xee,0xbd,0xdc,0x64,0x7f,0x2a,0xfc,0x81,0xc4,0x4f,0xea,0xe7,0x74,0xd2,0x42, /* ....d.....O..t.B */ \
	0x70,0xf2,0xfd,0x6e,0xe9,0xba,0xc1,0x73,0xb9,0x80,0x54,0xb0,0xe6,0xb6,0xd7,0xf9, /* p..n...s..T..... */ \
	0x9e,0x59,0x3a,0x82,0xec,0xb6,0x9f,0xe0,0xa3,0xf5,0xef,0x8b,0x9a,0x63,0x42,0xd7, /* .Y:..........cB. */ \
	0xf0,0xf7,0x8d,0x13,0xb7,0xdc,0x79,0x1a,0xe1,0x99,0x97,0x31,0x43,0x2f,0x6d,0x57, /* ......y....1C/mW */ \
	0x0c,0x7d,0x34,0x5e,0xb8,0x8f,0x96,0x67,0x6d,0xfb,0xe1,0xf0,0x05,0x91,0x94,0xf1, /* .}4^...gm....... */ \
	0x6e,0x9b,0xd1,0x31,0x6c,0x90,0x13,0xef,0x10,0xcc,0xbe,0x15,0x0c,0x13,0xb7,0x66, /* n..1l..........f */ \
	0x12,0xcb,0x5d,0x3a,0xe2,0x3a,0x4e,0xda,0xad,0xd6,0x85,0x19,0x5b,0x85,0x35,0x85, /* ..]:.:N.....[.5. */ \
	0xfc,0xf6,0xd4,0x60,0xd8,0xce,0x7b,0xa1,0xe3,0xbe,0x98,0x70,0x3f,0x3f,0xc0,0x1f, /* ...`..{....p??.. */ \
	0x93,0x70,0x1b,0x5f,0xcd,0x83,0x6a,0x41,0xd7,0x67,0xd8,0x15,0x95,0xa0,0xea,0x86, /* .p._..jA.g...... */ \
	0x7f,0x47,0x60,0x99,0x56,0x47,0x78,0x47,0x04,0xe8,0x0c,0x1f,0x41,0x77,0x87,0xb3, /* .G`.VGxG....Aw.. */ \
	0x41,0x4e,0x57,0x0b,0x58,0x35,0x83,0x9c,0x41,0x63,0xbe,0xd7,0x74,0x8a,0x35,0xc3, /* ANW.X5..Ac..t.5. */ \
	0xaa,0x71,0x2a,0x73,0x50,0x57,0x76,0xaa,0x51,0xe9,0x32,0x63,0x7f,0xa5,0x53,0xb9, /* .q.sPWv.Q.2c..S. */ \
	0xfe,0xb5,0x32,0x51,0x58,0xb1,0x31,0xb4,0x62,0xd3,0x96,0x8a,0xcd,0xc5,0x15,0x5b, /* ..2QX.1.b......[ */ \
	0x34,0x15,0xdb,0x7a,0x2b,0xb6,0xdf,0xa9,0xd8,0xf9,0xba,0x22,0x55,0xa8,0x4a,0x0b, /* 4..z+......"U.J. */ \
	0x55,0x65,0x6c,0x51,0x91,0xc5,0xaa,0x2c,0x8d,0x2a,0xbb,0x57,0xb5,0x7d,0xcb,0x47, /* UelQ...,...W.}.G */ \
	0x39,0x55,0x4e,0x3a,0x35,0xf7,0xbf,0x17,0x37,0xcc,0x4f,0xda,0x6f,0xd5,0xc0,0xd3, /* 9UN:5...7.O.o... */ \
	0x4e,0xbd,0x03,0xf9,0xc2,0xb3,0x21,0x5c,0xed,0x54,0xe6,0xbc,0xee,0xca,0x46,0xc5, /* N.....!\.T....F. */ \
	0x86,0x05,0x2a,0xd7,0xc4,0x27,0x2a,0xe7,0x6e,0xea,0x6c,0x13,0xb7,0xfe,0x3d,0xfb, /* .....'..n.l...=. */ \
	0x10,0x24,0xd9,0x6c,0x51,0x20,0xee,0x77,0xc7,0x70,0x3e,0x76,0xbf,0x80,0xff,0x86, /* .$.lQ .w.p>v.... */ \
	0x8f,0x85,0x88,0xb9,0xed,0x95,0x55,0xf0,0x1c,0x7f,0xd4,0xfc,0x63,0x12,0xb1,0x70, /* ......U.....c..p */ \
	0x05,0x2b,0xa1,0x97,0xef,0xd5,0x54,0xc3,0x2a,0xc5,0x46,0x0e,0xcc,0x37,0xaf,0xed, /* .+....T...F..7.. */ \
	0x83,0xc0,0x2a,0xd1,0x9b,0xcb,0x8c,0x08,0x3e,0xcf,0x59,0x37,0xc6,0xda,0x0f,0x45, /* ........>.Y7...E */ \
	0x7e,0x97,0xe3,0x78,0x0b,0x3a,0x79,0xeb,0xff,0x98,0x77,0xae,0x49,0x90,0xf8,0x9e, /* ~..x.:y...w.I... */ \
	0xe7,0x31,0x35,0xf7,0x54,0xb9,0xc3,0x18,0xa8,0xed,0xfa,0x92,0x39,0xbe,0xb7,0xee, /* .15.T.......9... */ \
	0x2b,0x0c,0xa4,0xf0,0xd7,0xc9,0x75,0xdc,0xf9,0x17,0xec,0x96,0xef,0x5d,0xf7,0xf6, /* +.....u......].. */ \
	0x14,0x2f,0xb1,0x5d,0x90,0xf8,0xfd,0x1e,0x69,0x50,0x42,0xa0,0x08,0xdb,0x7f,0x53, /* ./.]....iPB....S */ \
	0xf0,0xaf,0xde,0x0d,0x7b,0xce,0x6d,0x38,0x61,0xa8,0x5d,0x16,0x95,0x32,0xd6,0x93, /* ....{.m8a.]..2.. */ \
	0xcc,0x2c,0xa8,0x3f,0x3d,0x2d,0xf8,0xd6,0xa7,0xd2,0x2b,0x94,0x37,0x21,0xc6,0x70, /* .,.?=-....+.7!.p */ \
	0x4a,0xa8,0xee,0xb5,0x87,0x80,0xa5,0x33,0x72,0xe4,0x0c,0xb0,0xb5,0x9b,0x79,0x2e, /* J......3r.....y. */ \
	0x3a,0xc5,0xfa,0xa1,0xff,0x76,0x79,0xf5,0x53,0x47,0xc0,0x33,0xd4,0x86,0x00,0x16, /* :....vy.SG.3.... */ \
	0x03,0xec,0x37,0x2f,0xb3,0xde,0x3d,0x7b,0xd3,0x81,0x03,0xbc,0x90,0x38,0xc6,0x01, /* ..7/..={.....8.. */ \
	0x72,0x7e,0xba,0xda,0xbb,0xc6,0x7b,0x5f,0x10,0x92,0x35,0xa4,0x4c,0x00,0x26,0x03, /* r~....{_..5.L.&. */ \
	0x64,0x96,0xfa,0x4f,0xf0,0x59,0x01,0x53,0x75,0x0f,0x30,0xb0,0x70,0x39,0x17,0x4f, /* d..O.Y.Su.0.p9.O */ \
	0x65,0xd5,0x8b,0xf9,0x29,0x28,0x29,0xfa,0x0d,0x7f,0x1d,0xa6,0x2e,0x49,0x08,0x08, /* e...)()......I.. */ \
	0x78,0xd6,0xa3,0xde,0x95,0x58,0x23,0xab,0xc4,0x52,0xf8,0xfe,0x27,0x40,0x30,0x83, /* x....X#..R..'@0. */ \
	0x8f,0xbd,0x15,0x71,0x71,0xdd,0xb6,0xcc,0xf4,0xa4,0xbc,0xce,0xe4,0xd0,0x89,0xc6, /* ...qq........... */ \
	0x27,0xad,0x55,0xb8,0x8e,0xa7,0x8d,0xe3,0x65,0x01,0x30,0xa6,0xc0,0x18,0xc0,0xdb, /* '.U.....e.0..... */ \
	0x2f,0xcc,0x95,0xb3,0x5b,0x80,0x51,0xce,0x62,0xe3,0xce,0x41,0x05,0x36,0x36,0xd5, /* /...[.Q.b..A.66. */ \
	0xc8,0x2c,0xc2,0xee,0x70,0x58,0x97,0x59,0x91,0xde,0x9f,0x36,0xbb,0x11,0x09,0x96, /* .,..pX.Y...6.... */ \
	0x3a,0xe6,0xd1,0x19,0x41,0x80,0x88,0x9b,0xd2,0xe0,0x3c,0x1e,0xc7,0x03,0x86,0x45, /* :...A.....<....E */ \
	0x3b,0x7d,0x35,0x0b,0xf7,0x63,0x5d,0xa5,0xd8,0xa0,0x82,0x25,0xd7,0x09,0xeb,0x2f, /* ;}5..c]....%.../ */ \
	0xd9,0x5d,0x2d,0x0c,0x1a,0xbf,0xd9,0x12,0xd7,0xc3,0x14,0x29,0x59,0x5b,0xbb,0xb6, /* .]-........)Y[.. */ \
	0x1d,0x03,0x36,0xe5,0x97,0xea,0x32,0xc8,0x86,0xfa,0x39,0xac,0xf6,0xee,0xa2,0x14, /* ..6...2...9..... */ \
	0x83,0xdd,0x51,0x1f,0x0d,0x56,0xc8,0xda,0x6a,0xcf,0x3a,0xcd,0x90,0x9e,0xcd,0x4a, /* ..Q..V..j.:....J */ \
	0x3a,0xd4,0xdd,0xf4,0xc5,0x4c,0x5d,0xba,0x01,0xdf,0x19,0x7f,0xac,0x7f,0xa6,0xb1, /* :....L]......... */ \
	0x33,0xab,0x7a,0x99,0x3d,0x16,0x6e,0xf1,0x2e,0x33,0x62,0x83,0x58,0x1d,0x34,0x5e, /* 3.z.=.n..3b.X.4^ */ \
	0x1c,0x7e,0x73,0x44,0x0b,0x8d,0xe0,0x7e,0x59,0x01,0x33,0x82,0x2b,0x57,0x37,0x5b, /* .~sD...~Y.3.+W7[ */ \
	0x73,0xbc,0xe5,0xea,0x86,0xf6,0x5d,0xe9,0x21,0x22,0x2c,0xcb,0x20,0xae,0xe7,0x63, /* s.....].!",. ..c */ \
	0xce,0x61,0xd8,0xc1,0x1b,0x2d,0xe3,0x1b,0x1b,0x56,0xa2,0xd3,0x75,0x36,0x80,0xcc, /* .a...-...V..u6.. */ \
	0x9b,0x10,0xa4,0x29,0xea,0x07,0xa9,0x8f,0xfd,0xba,0x78,0xf2,0x4b,0x76,0x20,0xd5, /* ...)......x.Kv . */ \
	0x49,0xae,0xd8,0x00,0x74,0xcc,0x83,0xdd,0x76,0xe9,0x22,0x6e,0x9a,0x68,0xbe,0xb5, /* I...t...v."n.h.. */ \
	0xd0,0x2a,0xd5,0x8d,0x1f,0x32,0x85,0x21,0x8e,0xc3,0x8e,0xa7,0x0d,0xbb,0x4a,0xb9, /* .....2.!......J. */ \
	0x1c,0x35,0x57,0x2e,0xa9,0xbd,0xce,0xd9,0x1e,0xdf,0xc1,0xf3,0x4b,0xf5,0xce,0x33, /* .5W.........K..3 */ \
	0xd8,0x1d,0x1f,0x69,0x1d,0xe1,0x04,0x1f,0x13,0x7b,0x58,0xb3,0x4e,0xfc,0xdc,0x5e, /* ...i.....{X.N..^ */ \
	0xed,0x2f,0xf7,0x3e,0xf3,0xe7,0xae,0xc1,0xe9,0x70,0xc3,0x8c,0x80,0x27,0xe2,0x6a, /* ./.>.....p...'.j */ \
	0xf9,0x25,0x21,0x14,0xf6,0xc2,0xd7,0x6f,0xe8,0xcf,0x1a,0x63,0x10,0x77,0x7e,0x7c, /* .%!....o...c.w~| */ \
	0xca,0x99,0xad,0xee,0x53,0xb0,0xb1,0xa5,0x5d,0xf3,0x6c,0x7f,0x3d,0x18,0x6b,0x7a, /* ....S...].l.=.kz */ \
	0xcb,0x67,0x4d,0x72,0xc1,0xd7,0x4c,0x10,0xe6,0x70,0xa2,0xf3,0x69,0xe5,0x67,0x61, /* .gMr..L..p..i.ga */ \
	0xed,0xd7,0x47,0xc0,0xf6,0x83,0x6a,0xeb,0xd7,0x82,0x00,0x09,0x99,0x7f,0x9b,0x33, /* ..G...j........3 */ \
	0x2e,0x2c,0x59,0xd9,0xc0,0x1d,0xf7,0xc1,0xa4,0xbe,0x9a,0x89,0x59,0x6d,0x27,0x5c, /* .,Y.........Ym'\ */ \
	0xe0,0xfd,0x5d,0xcb,0xa1,0xad,0x89,0x59,0xb3,0xe4,0x86,0x63,0xc1,0xd8,0x60,0xe4, /* ..]....Y...c..`. */ \
	0x87,0x97,0x9a,0x0d,0x9b,0xaa,0xc5,0x53,0xcd,0xac,0x6e,0x0b,0xa0,0xc0,0xac,0xbf, /* .......S..n..... */ \
	0x13,0xd4,0xcf,0xae,0x4b,0xbd,0x58,0xd7,0xd2,0xde,0x39,0xeb,0x04,0xce,0x67,0xea, /* ....K.X...9...g. */ \
	0xce,0x9e,0xae,0x36,0xf5,0x32,0xbf,0xef,0xb5,0x90,0xac,0x3d,0xe2,0xb6,0x5c,0xc3, /* ...6.2.....=..\. */ \
	0x2e,0xa8,0xee,0xbc,0xe2,0x04,0xf2,0x75,0x4c,0x27,0x6e,0x6d,0x27,0x00,0x0e,0x63, /* .......uL'nm'..c */ \
	0xc1,0x93,0x3e,0x2c,0xef,0xc7,0x82,0xff,0xfc,0xf9,0x19,0x76,0x8a,0xa7,0x2a,0x61, /* ..>,.......v...a */ \
	0x65,0xba,0x71,0x15,0xda,0x35,0x6f,0x75,0xd5,0x64,0x04,0x6f,0xb7,0xae,0xf6,0xaf, /* e.q..5ou.d.o.... */ \
	0x8a,0x0f,0xe5,0xc6,0xa6,0x31,0x05,0x2b,0x05,0x38,0x8c,0xa6,0xfa,0x6b,0x0d,0x16, /* .....1.+.8...k.. */ \
	0xde,0x23,0x27,0xe7,0x5e,0x57,0x6d,0x75,0x4b,0x5d,0xea,0xc6,0x0d,0x14,0xb7,0xff, /* .#'.^WmuK]...... */ \
	0xb5,0x1c,0xb3,0x7e,0xb6,0x83,0x35,0x87,0x35,0x0b,0xdf,0xfd,0x93,0x43,0x2e,0x73, /* ...~..5.5....C.s */ \
	0xc3,0x96,0x36,0x90,0xe2,0xee,0xd6,0x31,0x75,0xc3,0xdc,0x96,0xfa,0xea,0x2e,0xe7, /* ..6....1u....... */ \
	0xb4,0x09,0x50,0x28,0xdc,0x33,0x96,0xbe,0xf2,0xd8,0x6e,0xff,0xd3,0xd3,0x5d,0xcc, /* ..P(.3....n...]. */ \
	0x39,0xcd,0x44,0x1c,0x4f,0x3e,0xb1,0xc9,0x58,0x54,0xaf,0x35,0xb5,0x1d,0xbd,0xf4, /* 9.D.O>..XT.5.... */ \
	0x89,0xf3,0xee,0xa4,0xc9,0x62,0xd7,0xaa,0x2a,0xcc,0x2f,0xb5,0x7a,0x73,0xc9,0xfc, /* .....b..../.zs.. */ \
	0x4f,0x66,0xc4,0xf9,0xc5,0x8b,0x07,0x28,0xd6,0x51,0x78,0xf6,0xef,0x37,0x67,0x81, /* Of.....(.Qx..7g. */ \
	0x8b,0x81,0xb9,0xc2,0xc0,0x4e,0x31,0x60,0x1f,0x18,0x36,0x0a,0xf9,0x60,0xc5,0xff, /* .....N1`..6..`.. */ \
	0x02,0xd3,0x22,0xc0,0x8b,0xdf,0x10,0x00,0x00,0x3c,0x21,0x44,0x4f,0x43,0x54,0x59, /* .."......<!DOCTY */ \
	0x50,0x45,0x20,0x68,0x74,0x6d,0x6c,0x20,0x50,0x55,0x42,0x4c,0x49,0x43,0x20,0x22, /* PE html PUBLIC " */ \
	0x2d,0x2f,0x2f,0x57,0x33,0x43,0x2f,0x2f,0x44,0x54,0x44,0x20,0x58,0x48,0x54,0x4d, /* -//W3C//DTD XHTM */ \
	0x4c,0x20,0x31,0x2e,0x30,0x20,0x53,0x74,0x72,0x69,0x63,0x74,0x2f,0x2f,0x45,0x4e, /* L 1.0 Strict//EN */ \
	0x22,0x0d,0x0a,0x20,0x20,0x22,0x68,0x74,0x74,0x70,0x3a,0x2f,0x2f,0x77,0x77,0x77, /* "..  "http://www */ \
	0x2e,0x77,0x33,0x2e,0x6f,0x72,0x67,0x2f,0x54,0x52,0x2f,0x78,0x68,0x74,0x6d,0x6c, /* .w3.org/TR/xhtml */ \
	0x31,0x2f,0x44,0x54,0x44,0x2f,0x78,0x68,0x74,0x6d,0x6c,0x31,0x2d,0x73,0x74,0x72, /* 1/DTD/xhtml1-str */ \
	0x69,0x63,0x74,0x2e,0x64,0x74,0x64,0x22,0x3e,0x0d,0x0a,0x3c,0x68,0x74,0x6d,0x6c, /* ict.dtd">..<html */ \
	0x20,0x78,0x6d,0x6c,0x6e,0x73,0x3d,0x22,0x68,0x74,0x74,0x70,0x3a,0x2f,0x2f,0x77, /*  xmlns="http://w */ \
	0x77,0x77,0x2e,0x77,0x33,0x2e,0x6f,0x72,0x67,0x2f,0x31,0x39,0x39,0x39,0x2f,0x78, /* ww.w3.org/1999/x */ \
	0x68,0x74,0x6d,0x6c,0x22,0x20,0x78,0x6d,0x6c,0x3a,0x6c,0x61,0x6e,0x67,0x3d,0x22, /* html" xml:lang=" */ \
	0x65,0x6e,0x22,0x20,0x6c,0x61,0x6e,0x67,0x3d,0x22,0x65,0x6e,0x22,0x3e,0x0d,0x0a, /* en" lang="en">.. */ \
	0x3c,0x68,0x65,0x61,0x64,0x3e,0x0d,0x0a,0x3c,0x74,0x69,0x74,0x6c,0x65,0x3e,0x4d, /* <head>..<title>M */ \
	0x69,0x63,0x72,0x6f,0x63,0x68,0x69,0x70,0x20,0x54,0x43,0x50,0x2f,0x49,0x50,0x20, /* icrochip TCP/IP  */ \
	0x53,0x74,0x61,0x63,0x6b,0x20,0x44,0x65,0x6d,0x6f,0x20,0x41,0x70,0x70,0x3c,0x2f, /* Stack Demo App</ */ \
	0x74,0x69,0x74,0x6c,0x65,0x3e,0x0d,0x0a,0x3c,0x6c,0x69,0x6e,0x6b,0x20,0x68,0x72, /* title>..<link hr */ \
	0x65,0x66,0x3d,0x22,0x2f,0x6d,0x63,0x68,0x70,0x2e,0x63,0x73,0x73,0x22,0x20,0x72, /* ef="/mchp.css" r */ \
	0x65,0x6c,0x3d,0x22,0x73,0x74,0x79,0x6c,0x65,0x73,0x68,0x65,0x65,0x74,0x22,0x20, /* el="stylesheet"  */ \
	0x74,0x79,0x70,0x65,0x3d,0x22,0x74,0x65,0x78,0x74,0x2f,0x63,0x73,0x73,0x22,0x20, /* type="text/css"  */ \
	0x2f,0x3e,0x0d,0x0a,0x3c,0x73,0x63,0x72,0x69,0x70,0x74,0x20,0x73,0x72,0x63,0x3d, /* />..<script src= */ \
	0x22,0x2f,0x6d,0x63,0x68,0x70,0x2e,0x6a,0x73,0x22,0x20,0x74,0x79,0x70,0x65,0x3d, /* "/mchp.js" type= */ \
	0x22,0x74,0x65,0x78,0x74,0x2f,0x6a,0x61,0x76,0x61,0x73,0x63,0x72,0x69,0x70,0x74, /* "text/javascript */ \
	0x22,0x3e,0x3c,0x2f,0x73,0x63,0x72,0x69,0x70,0x74,0x3e,0x0d,0x0a,0x3c,0x2f,0x68, /* "></script>..</h */ \
	0x65,0x61,0x64,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x62,0x6f,0x64,0x79,0x3e,0x0d,0x0a, /* ead>....<body>.. */ \
	0x3c,0x64,0x69,0x76,0x20,0x69,0x64,0x3d,0x22,0x73,0x68,0x61,0x64,0x6f,0x77,0x2d, /* <div id="shadow- */ \
	0x6f,0x6e,0x65,0x22,0x3e,0x3c,0x64,0x69,0x76,0x20,0x69,0x64,0x3d,0x22,0x73,0x68, /* one"><div id="sh */ \
	0x61,0x64,0x6f,0x77,0x2d,0x74,0x77,0x6f,0x22,0x3e,0x3c,0x64,0x69,0x76,0x20,0x69, /* adow-two"><div i */ \
	0x64,0x3d,0x22,0x73,0x68,0x61,0x64,0x6f,0x77,0x2d,0x74,0x68,0x72,0x65,0x65,0x22, /* d="shadow-three" */ \
	0x3e,0x3c,0x64,0x69,0x76,0x20,0x69,0x64,0x3d,0x22,0x73,0x68,0x61,0x64,0x6f,0x77, /* ><div id="shadow */ \
	0x2d,0x66,0x6f,0x75,0x72,0x22,0x3e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x69,0x64, /* -four">..<div id */ \
	0x3d,0x22,0x70,0x61,0x67,0x65,0x22,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x64,0x69,0x76, /* ="page">....<div */ \
	0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x22,0x70,0x61,0x64,0x64,0x69,0x6e,0x67,0x3a, /*  style="padding: */ \
	0x30,0x20,0x30,0x20,0x36,0x35,0x70,0x78,0x20,0x35,0x70,0x78,0x22,0x3e,0x3c,0x69, /* 0 0 65px 5px"><i */ \
	0x6d,0x67,0x20,0x73,0x72,0x63,0x3d,0x22,0x2f,0x6d,0x63,0x68,0x70,0x2e,0x67,0x69, /* mg src="/mchp.gi */ \
	0x66,0x22,0x20,0x61,0x6c,0x74,0x3d,0x22,0x4d,0x69,0x63,0x72,0x6f,0x63,0x68,0x69, /* f" alt="Microchi */ \
	0x70,0x22,0x20,0x61,0x6c,0x69,0x67,0x6e,0x3d,0x22,0x6c,0x65,0x66,0x74,0x22,0x2f, /* p" align="left"/ */ \
	0x3e,0x3c,0x69,0x6d,0x67,0x20,0x73,0x72,0x63,0x3d,0x22,0x2f,0x68,0x61,0x72,0x6d, /* ><img src="/harm */ \
	0x6f,0x6e,0x79,0x2e,0x67,0x69,0x66,0x22,0x20,0x61,0x6c,0x74,0x3d,0x22,0x48,0x61, /* ony.gif" alt="Ha */ \
	0x72,0x6d,0x6f,0x6e,0x79,0x22,0x20,0x61,0x6c,0x69,0x67,0x6e,0x3d,0x22,0x72,0x69, /* rmony" align="ri */ \
	0x67,0x68,0x74,0x22,0x2f,0x3e,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x0d,0x0a, /* ght"/></div>.... */ \
	0x3c,0x64,0x69,0x76,0x20,0x69,0x64,0x3d,0x22,0x74,0x69,0x74,0x6c,0x65,0x22,0x3e, /* <div id="title"> */ \
	0x3c,0x64,0x69,0x76,0x20,0x63,0x6c,0x61,0x73,0x73,0x3d,0x22,0x72,0x69,0x67,0x68, /* <div class="righ */ \
	0x74,0x22,0x3e,0x54,0x43,0x50,0x2f,0x49,0x50,0x20,0x53,0x74,0x61,0x63,0x6b,0x20, /* t">TCP/IP Stack  */ \
	0x44,0x65,0x6d,0x6f,0x20,0x41,0x70,0x70,0x6c,0x69,0x63,0x61,0x74,0x69,0x6f,0x6e, /* Demo Application */ \
	0x3c,0x2f,0x64,0x69,0x76,0x3e,0x3c,0x73,0x70,0x61,0x6e,0x20,0x69,0x64,0x3d,0x22, /* </div><span id=" */ \
	0x68,0x65,0x6c,0x6c,0x6f,0x22,0x3e,0x26,0x6e,0x62,0x73,0x70,0x3b,0x3c,0x2f,0x73, /* hello">&nbsp;</s */ \
	0x70,0x61,0x6e,0x3e,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x64, /* pan></div>....<d */ \
	0x69,0x76,0x20,0x69,0x64,0x3d,0x22,0x6d,0x65,0x6e,0x75,0x22,0x3e,0x0d,0x0a,0x3c, /* iv id="menu">..< */ \
	0x61,0x20,0x68,0x72,0x65,0x66,0x3d,0x22,0x2f,0x69,0x6e,0x64,0x65,0x78,0x2e,0x68, /* a href="/index.h */ \
	0x74,0x6d,0x22,0x3e,0x4f,0x76,0x65,0x72,0x76,0x69,0x65,0x77,0x3c,0x2f,0x61,0x3e, /* tm">Overview</a> */ \
	0x0d,0x0a,0x3c,0x61,0x20,0x68,0x72,0x65,0x66,0x3d,0x22,0x2f,0x64,0x79,0x6e,0x76, /* ..<a href="/dynv */ \
	0x61,0x72,0x73,0x2e,0x68,0x74,0x6d,0x22,0x3e,0x44,0x79,0x6e,0x61,0x6d,0x69,0x63, /* ars.htm">Dynamic */ \
	0x20,0x56,0x61,0x72,0x69,0x61,0x62,0x6c,0x65,0x73,0x3c,0x2f,0x61,0x3e,0x0d,0x0a, /*  Variables</a>.. */ \
	0x3c,0x61,0x20,0x68,0x72,0x65,0x66,0x3d,0x22,0x2f,0x66,0x6f,0x72,0x6d,0x73,0x2e, /* <a href="/forms. */ \
	0x68,0x74,0x6d,0x22,0x3e,0x46,0x6f,0x72,0x6d,0x20,0x50,0x72,0x6f,0x63,0x65,0x73, /* htm">Form Proces */ \
	0x73,0x69,0x6e,0x67,0x3c,0x2f,0x61,0x3e,0x0d,0x0a,0x3c,0x61,0x20,0x68,0x72,0x65, /* sing</a>..<a hre */ \
	0x66,0x3d,0x22,0x2f,0x61,0x75,0x74,0x68,0x2e,0x68,0x74,0x6d,0x22,0x3e,0x41,0x75, /* f="/auth.htm">Au */ \
	0x74,0x68,0x65,0x6e,0x74,0x69,0x63,0x61,0x74,0x69,0x6f,0x6e,0x3c,0x2f,0x61,0x3e, /* thentication</a> */ \
	0x0d,0x0a,0x3c,0x61,0x20,0x68,0x72,0x65,0x66,0x3d,0x22,0x2f,0x63,0x6f,0x6f,0x6b, /* ..<a href="/cook */ \
	0x69,0x65,0x73,0x2e,0x68,0x74,0x6d,0x22,0x3e,0x43,0x6f,0x6f,0x6b,0x69,0x65,0x73, /* ies.htm">Cookies */ \
	0x3c,0x2f,0x61,0x3e,0x0d,0x0a,0x3c,0x61,0x20,0x68,0x72,0x65,0x66,0x3d,0x22,0x2f, /* </a>..<a href="/ */ \
	0x75,0x70,0x6c,0x6f,0x61,0x64,0x2e,0x68,0x74,0x6d,0x22,0x3e,0x46,0x69,0x6c,0x65, /* upload.htm">File */ \
	0x20,0x55,0x70,0x6c,0x6f,0x61,0x64,0x73,0x3c,0x2f,0x61,0x3e,0x0d,0x0a,0x3c,0x61, /*  Uploads</a>..<a */ \
	0x20,0x68,0x72,0x65,0x66,0x3d,0x22,0x2f,0x65,0x6d,0x61,0x69,0x6c,0x22,0x3e,0x53, /*  href="/email">S */ \
	0x65,0x6e,0x64,0x20,0x45,0x2d,0x6d,0x61,0x69,0x6c,0x3c,0x2f,0x61,0x3e,0x0d,0x0a, /* end E-mail</a>.. */ \
	0x3c,0x61,0x20,0x68,0x72,0x65,0x66,0x3d,0x22,0x2f,0x64,0x79,0x6e,0x64,0x6e,0x73, /* <a href="/dyndns */ \
	0x22,0x3e,0x44,0x79,0x6e,0x61,0x6d,0x69,0x63,0x20,0x44,0x4e,0x53,0x3c,0x2f,0x61, /* ">Dynamic DNS</a */ \
	0x3e,0x0d,0x0a,0x3c,0x61,0x20,0x68,0x72,0x65,0x66,0x3d,0x22,0x2f,0x70,0x72,0x6f, /* >..<a href="/pro */ \
	0x74,0x65,0x63,0x74,0x2f,0x63,0x6f,0x6e,0x66,0x69,0x67,0x2e,0x68,0x74,0x6d,0x22, /* tect/config.htm" */ \
	0x3e,0x4e,0x65,0x74,0x77,0x6f,0x72,0x6b,0x20,0x43,0x6f,0x6e,0x66,0x69,0x67,0x75, /* >Network Configu */ \
	0x72,0x61,0x74,0x69,0x6f,0x6e,0x3c,0x2f,0x61,0x3e,0x0d,0x0a,0x3c,0x61,0x20,0x68, /* ration</a>..<a h */ \
	0x72,0x65,0x66,0x3d,0x22,0x2f,0x73,0x6e,0x6d,0x70,0x2f,0x73,0x6e,0x6d,0x70,0x63, /* ref="/snmp/snmpc */ \
	0x6f,0x6e,0x66,0x69,0x67,0x2e,0x68,0x74,0x6d,0x22,0x3e,0x53,0x4e,0x4d,0x50,0x20, /* onfig.htm">SNMP  */ \
	0x43,0x6f,0x6e,0x66,0x69,0x67,0x75,0x72,0x61,0x74,0x69,0x6f,0x6e,0x3c,0x2f,0x61, /* Configuration</a */ \
	0x3e,0x0d,0x0a,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x7e,0x69,0x6e,0x63,0x3a, /* >..</div>..~inc: */ \
	0x68,0x65,0x61,0x64,0x65,0x72,0x2e,0x69,0x6e,0x63,0x7e,0x0d,0x0a,0x3c,0x64,0x69, /* header.inc~..<di */ \
	0x76,0x20,0x69,0x64,0x3d,0x22,0x63,0x6f,0x6e,0x74,0x65,0x6e,0x74,0x22,0x3e,0x0d, /* v id="content">. */ \
	0x0a,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x69,0x64,0x3d,0x22,0x73,0x74,0x61,0x74, /* ...<div id="stat */ \
	0x75,0x73,0x22,0x3e,0x0d,0x0a,0x09,0x3c,0x64,0x69,0x76,0x20,0x69,0x64,0x3d,0x22, /* us">...<div id=" */ \
	0x6c,0x6f,0x61,0x64,0x69,0x6e,0x67,0x22,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x22, /* loading" style=" */ \
	0x64,0x69,0x73,0x70,0x6c,0x61,0x79,0x3a,0x6e,0x6f,0x6e,0x65,0x22,0x3e,0x45,0x72, /* display:none">Er */ \
	0x72,0x6f,0x72,0x3a,0x3c,0x62,0x72,0x20,0x2f,0x3e,0x43,0x6f,0x6e,0x6e,0x65,0x63, /* ror:<br />Connec */ \
	0x74,0x69,0x6f,0x6e,0x20,0x74,0x6f,0x20,0x64,0x65,0x6d,0x6f,0x20,0x62,0x6f,0x61, /* tion to demo boa */ \
	0x72,0x64,0x20,0x77,0x61,0x73,0x20,0x6c,0x6f,0x73,0x74,0x2e,0x3c,0x2f,0x64,0x69, /* rd was lost.</di */ \
	0x76,0x3e,0x0d,0x0a,0x09,0x3c,0x64,0x69,0x76,0x20,0x69,0x64,0x3d,0x22,0x64,0x69, /* v>...<div id="di */ \
	0x73,0x70,0x6c,0x61,0x79,0x22,0x3e,0x0d,0x0a,0x09,0x3c,0x21,0x2d,0x2d,0x3c,0x73, /* splay">...<!--<s */ \
	0x70,0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x22,0x66,0x6c,0x6f,0x61,0x74, /* pan style="float */ \
	0x3a,0x72,0x69,0x67,0x68,0x74,0x3b,0x66,0x6f,0x6e,0x74,0x2d,0x73,0x69,0x7a,0x65, /* :right;font-size */ \
	0x3a,0x39,0x70,0x78,0x3b,0x66,0x6f,0x6e,0x74,0x2d,0x77,0x65,0x69,0x67,0x68,0x74, /* :9px;font-weight */ \
	0x3a,0x6e,0x6f,0x72,0x6d,0x61,0x6c,0x3b,0x70,0x61,0x64,0x64,0x69,0x6e,0x67,0x2d, /* :normal;padding- */ \
	0x74,0x6f,0x70,0x3a,0x38,0x70,0x78,0x3b,0x74,0x65,0x78,0x74,0x2d,0x69,0x6e,0x64, /* top:8px;text-ind */ \
	0x65,0x6e,0x74,0x3a,0x30,0x70,0x78,0x22,0x3e,0x28,0x63,0x6c,0x69,0x63,0x6b,0x20, /* ent:0px">(click  */ \
	0x74,0x6f,0x20,0x74,0x6f,0x67,0x67,0x6c,0x65,0x29,0x3c,0x2f,0x73,0x70,0x61,0x6e, /* to toggle)</span */ \
	0x3e,0x2d,0x2d,0x3e,0x0d,0x0a,0x09,0x09,0x3c,0x70,0x3e,0x4c,0x45,0x44,0x3a,0x3c, /* >-->....<p>LED:< */ \
	0x62,0x72,0x20,0x2f,0x3e,0x3c,0x73,0x70,0x61,0x6e,0x20,0x63,0x6c,0x61,0x73,0x73, /* br /><span class */ \
	0x3d,0x22,0x6c,0x65,0x64,0x73,0x22,0x3e,0x0d,0x0a,0x09,0x09,0x3c,0x21,0x2d,0x2d, /* ="leds">....<!-- */ \
	0x20,0x74,0x68,0x69,0x73,0x20,0x69,0x73,0x20,0x63,0x6f,0x6d,0x6d,0x65,0x6e,0x74, /*  this is comment */ \
	0x65,0x64,0x20,0x6f,0x75,0x74,0x20,0x74,0x65,0x6d,0x70,0x6f,0x72,0x61,0x72,0x69, /* ed out temporari */ \
	0x6c,0x79,0x20,0x2d,0x2d,0x3e,0x0d,0x0a,0x09,0x3c,0x21,0x2d,0x2d,0x3c,0x61,0x20, /* ly -->...<!--<a  */ \
	0x69,0x64,0x3d,0x22,0x6c,0x65,0x64,0x32,0x22,0x20,0x6f,0x6e,0x63,0x6c,0x69,0x63, /* id="led2" onclic */ \
	0x6b,0x3d,0x22,0x6e,0x65,0x77,0x41,0x4a,0x41,0x58,0x43,0x6f,0x6d,0x6d,0x61,0x6e, /* k="newAJAXComman */ \
	0x64,0x28,0x27,0x6c,0x65,0x64,0x73,0x2e,0x63,0x67,0x69,0x3f,0x6c,0x65,0x64,0x3d, /* d('leds.cgi?led= */ \
	0x32,0x27,0x29,0x3b,0x22,0x3e,0x26,0x62,0x75,0x6c,0x6c,0x3b,0x3c,0x2f,0x61,0x3e, /* 2');">&bull;</a> */ \
	0x0d,0x0a,0x09,0x09,0x3c,0x61,0x20,0x69,0x64,0x3d,0x22,0x6c,0x65,0x64,0x31,0x22, /* ....<a id="led1" */ \
	0x20,0x6f,0x6e,0x63,0x6c,0x69,0x63,0x6b,0x3d,0x22,0x6e,0x65,0x77,0x41,0x4a,0x41, /*  onclick="newAJA */ \
	0x58,0x43,0x6f,0x6d,0x6d,0x61,0x6e,0x64,0x28,0x27,0x6c,0x65,0x64,0x73,0x2e,0x63, /* XCommand('leds.c */ \
	0x67,0x69,0x3f,0x6c,0x65,0x64,0x3d,0x31,0x27,0x29,0x3b,0x22,0x3e,0x26,0x62,0x75, /* gi?led=1');">&bu */ \
	0x6c,0x6c,0x3b,0x3c,0x2f,0x61,0x3e,0x2d,0x2d,0x3e,0x0d,0x0a,0x09,0x09,0x3c,0x61, /* ll;</a>-->....<a */ \
	0x20,0x69,0x64,0x3d,0x22,0x6c,0x65,0x64,0x30,0x22,0x3e,0x26,0x62,0x75,0x6c,0x6c, /*  id="led0">&bull */ \
	0x3b,0x3c,0x2f,0x61,0x3e,0x0d,0x0a,0x09,0x09,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e, /* ;</a>....</span> */ \
	0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x09,0x09,0x3c,0x70,0x3e,0x42,0x75,0x74,0x74,0x6f, /* </p>....<p>Butto */ \
	0x6e,0x73,0x3a,0x3c,0x62,0x72,0x20,0x2f,0x3e,0x0d,0x0a,0x09,0x09,0x3c,0x73,0x70, /* ns:<br />....<sp */ \
	0x61,0x6e,0x20,0x69,0x64,0x3d,0x22,0x62,0x74,0x6e,0x32,0x22,0x3e,0x3f,0x3c,0x2f, /* an id="btn2">?</ */ \
	0x73,0x70,0x61,0x6e,0x3e,0x20,0x26,0x6e,0x62,0x73,0x70,0x3b,0x0d,0x0a,0x09,0x09, /* span> &nbsp;.... */ \
	0x3c,0x73,0x70,0x61,0x6e,0x20,0x69,0x64,0x3d,0x22,0x62,0x74,0x6e,0x31,0x22,0x3e, /* <span id="btn1"> */ \
	0x3f,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x20,0x26,0x6e,0x62,0x73,0x70,0x3b,0x0d, /* ?</span> &nbsp;. */ \
	0x0a,0x09,0x09,0x3c,0x73,0x70,0x61,0x6e,0x20,0x69,0x64,0x3d,0x22,0x62,0x74,0x6e, /* ...<span id="btn */ \
	0x30,0x22,0x3e,0x3f,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x3c,0x2f,0x70,0x3e,0x0d, /* 0">?</span></p>. */ \
	0x0a,0x09,0x09,0x3c,0x70,0x3e,0x52,0x61,0x6e,0x64,0x6f,0x6d,0x20,0x4e,0x75,0x6d, /* ...<p>Random Num */ \
	0x62,0x65,0x72,0x3a,0x20,0x3c,0x73,0x70,0x61,0x6e,0x20,0x69,0x64,0x3d,0x22,0x70, /* ber: <span id="p */ \
	0x6f,0x74,0x30,0x22,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x22,0x66,0x6f,0x6e,0x74, /* ot0" style="font */ \
	0x2d,0x77,0x65,0x69,0x67,0x68,0x74,0x3a,0x6e,0x6f,0x72,0x6d,0x61,0x6c,0x22,0x3e, /* -weight:normal"> */ \
	0x3f,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x09,0x3c, /* ?</span></p>...< */ \
	0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x0d, /* /div>..</div>... */ \
	0x0a,0x3c,0x68,0x31,0x3e,0x57,0x65,0x6c,0x63,0x6f,0x6d,0x65,0x21,0x3c,0x2f,0x68, /* .<h1>Welcome!</h */ \
	0x31,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x74,0x61,0x62,0x6c,0x65,0x20,0x73,0x74,0x79, /* 1>....<table sty */ \
	0x6c,0x65,0x3d,0x22,0x70,0x61,0x64,0x64,0x69,0x6e,0x67,0x2d,0x6c,0x65,0x66,0x74, /* le="padding-left */ \
	0x3a,0x20,0x31,0x30,0x70,0x78,0x3b,0x22,0x3e,0x0d,0x0a,0x3c,0x74,0x72,0x3e,0x3c, /* : 10px;">..<tr>< */ \
	0x74,0x64,0x3e,0x3c,0x62,0x3e,0x53,0x74,0x61,0x63,0x6b,0x20,0x56,0x65,0x72,0x73, /* td><b>Stack Vers */ \
	0x69,0x6f,0x6e,0x3a,0x3c,0x2f,0x62,0x3e,0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x74,0x64, /* ion:</b></td><td */ \
	0x3e,0x26,0x6e,0x62,0x73,0x70,0x3b,0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x74,0x64,0x3e, /* >&nbsp;</td><td> */ \
	0x7e,0x76,0x65,0x72,0x73,0x69,0x6f,0x6e,0x7e,0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x2f, /* ~version~</td></ */ \
	0x74,0x72,0x3e,0x0d,0x0a,0x3c,0x74,0x72,0x3e,0x3c,0x74,0x64,0x3e,0x3c,0x62,0x3e, /* tr>..<tr><td><b> */ \
	0x42,0x75,0x69,0x6c,0x64,0x20,0x44,0x61,0x74,0x65,0x3a,0x3c,0x2f,0x62,0x3e,0x3c, /* Build Date:</b>< */ \
	0x2f,0x74,0x64,0x3e,0x3c,0x74,0x64,0x3e,0x26,0x6e,0x62,0x73,0x70,0x3b,0x3c,0x2f, /* /td><td>&nbsp;</ */ \
	0x74,0x64,0x3e,0x3c,0x74,0x64,0x3e,0x7e,0x62,0x75,0x69,0x6c,0x64,0x64,0x61,0x74, /* td><td>~builddat */ \
	0x65,0x7e,0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x2f,0x74,0x72,0x3e,0x0d,0x0a,0x3c,0x74, /* e~</td></tr>..<t */ \
	0x72,0x3e,0x3c,0x74,0x64,0x3e,0x3c,0x62,0x3e,0x46,0x69,0x6c,0x65,0x20,0x53,0x79, /* r><td><b>File Sy */ \
	0x73,0x74,0x65,0x6d,0x20,0x4c,0x6f,0x63,0x61,0x74,0x69,0x6f,0x6e,0x3a,0x3c,0x2f, /* stem Location:</ */ \
	0x62,0x3e,0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x74,0x64,0x3e,0x26,0x6e,0x62,0x73,0x70, /* b></td><td>&nbsp */ \
	0x3b,0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x74,0x64,0x3e,0x7e,0x64,0x72,0x69,0x76,0x65, /* ;</td><td>~drive */ \
	0x7e,0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x2f,0x74,0x72,0x3e,0x0d,0x0a,0x3c,0x74,0x72, /* ~</td></tr>..<tr */ \
	0x3e,0x3c,0x74,0x64,0x3e,0x3c,0x62,0x3e,0x46,0x69,0x6c,0x65,0x20,0x53,0x79,0x73, /* ><td><b>File Sys */ \
	0x74,0x65,0x6d,0x20,0x54,0x79,0x70,0x65,0x3a,0x3c,0x2f,0x62,0x3e,0x3c,0x2f,0x74, /* tem Type:</b></t */ \
	0x64,0x3e,0x3c,0x74,0x64,0x3e,0x26,0x6e,0x62,0x73,0x70,0x3b,0x3c,0x2f,0x74,0x64, /* d><td>&nbsp;</td */ \
	0x3e,0x3c,0x74,0x64,0x3e,0x7e,0x66,0x73,0x74,0x79,0x70,0x65,0x7e,0x3c,0x2f,0x74, /* ><td>~fstype~</t */ \
	0x64,0x3e,0x3c,0x2f,0x74,0x72,0x3e,0x0d,0x0a,0x3c,0x2f,0x74,0x61,0x62,0x6c,0x65, /* d></tr>..</table */ \
	0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70,0x3e,0x54,0x68,0x69,0x73,0x20,0x73,0x69,0x74, /* >....<p>This sit */ \
	0x65,0x20,0x64,0x65,0x6d,0x6f,0x6e,0x73,0x74,0x72,0x61,0x74,0x65,0x73,0x20,0x74, /* e demonstrates t */ \
	0x68,0x65,0x20,0x70,0x6f,0x77,0x65,0x72,0x2c,0x20,0x66,0x6c,0x65,0x78,0x69,0x62, /* he power, flexib */ \
	0x69,0x6c,0x69,0x74,0x79,0x2c,0x20,0x61,0x6e,0x64,0x20,0x73,0x63,0x61,0x6c,0x61, /* ility, and scala */ \
	0x62,0x69,0x6c,0x69,0x74,0x79,0x20,0x6f,0x66,0x20,0x61,0x20,0x33,0x32,0x2d,0x62, /* bility of a 32-b */ \
	0x69,0x74,0x20,0x65,0x6d,0x62,0x65,0x64,0x64,0x65,0x64,0x0d,0x0a,0x77,0x65,0x62, /* it embedded..web */ \
	0x20,0x73,0x65,0x72,0x76,0x65,0x72,0x2e,0x20,0x20,0x45,0x76,0x65,0x72,0x79,0x74, /*  server.  Everyt */ \
	0x68,0x69,0x6e,0x67,0x20,0x79,0x6f,0x75,0x20,0x73,0x65,0x65,0x20,0x69,0x73,0x20, /* hing you see is  */ \
	0x70,0x6f,0x77,0x65,0x72,0x65,0x64,0x20,0x62,0x79,0x20,0x61,0x20,0x4d,0x69,0x63, /* powered by a Mic */ \
	0x72,0x6f,0x63,0x68,0x69,0x70,0x20,0x50,0x49,0x43,0x20,0x6d,0x69,0x63,0x72,0x6f, /* rochip PIC micro */ \
	0x63,0x6f,0x6e,0x74,0x72,0x6f,0x6c,0x6c,0x65,0x72,0x0d,0x0a,0x72,0x75,0x6e,0x6e, /* controller..runn */ \
	0x69,0x6e,0x67,0x20,0x74,0x68,0x65,0x20,0x48,0x61,0x72,0x6d,0x6f,0x6e,0x79,0x20, /* ing the Harmony  */ \
	0x4d,0x69,0x63,0x72,0x6f,0x63,0x68,0x69,0x70,0x20,0x54,0x43,0x50,0x2f,0x49,0x50, /* Microchip TCP/IP */ \
	0x20,0x53,0x74,0x61,0x63,0x6b,0x2e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c, /*  Stack.</p>....< */ \
	0x70,0x3e,0x4f,0x6e,0x20,0x74,0x68,0x65,0x20,0x72,0x69,0x67,0x68,0x74,0x20,0x79, /* p>On the right y */ \
	0x6f,0x75,0x27,0x6c,0x6c,0x20,0x73,0x65,0x65,0x20,0x74,0x68,0x65,0x20,0x63,0x75, /* ou'll see the cu */ \
	0x72,0x72,0x65,0x6e,0x74,0x20,0x73,0x74,0x61,0x74,0x75,0x73,0x20,0x6f,0x66,0x20, /* rrent status of  */ \
	0x74,0x68,0x65,0x20,0x64,0x65,0x6d,0x6f,0x20,0x62,0x6f,0x61,0x72,0x64,0x2e,0x20, /* the demo board.  */ \
	0x20,0x46,0x6f,0x72,0x20,0x61,0x20,0x71,0x75,0x69,0x63,0x6b,0x0d,0x0a,0x65,0x78, /*  For a quick..ex */ \
	0x61,0x6d,0x70,0x6c,0x65,0x2c,0x20,0x63,0x6c,0x69,0x63,0x6b,0x20,0x74,0x68,0x65, /* ample, click the */ \
	0x20,0x4c,0x45,0x44,0x73,0x20,0x74,0x6f,0x20,0x74,0x6f,0x67,0x67,0x6c,0x65,0x20, /*  LEDs to toggle  */ \
	0x74,0x68,0x65,0x20,0x6c,0x69,0x67,0x68,0x74,0x73,0x20,0x6f,0x6e,0x20,0x74,0x68, /* the lights on th */ \
	0x65,0x20,0x62,0x6f,0x61,0x72,0x64,0x2e,0x20,0x20,0x50,0x72,0x65,0x73,0x73,0x20, /* e board.  Press  */ \
	0x74,0x68,0x65,0x20,0x70,0x75,0x73,0x68,0x0d,0x0a,0x62,0x75,0x74,0x74,0x6f,0x6e, /* the push..button */ \
	0x73,0x20,0x28,0x65,0x78,0x63,0x65,0x70,0x74,0x20,0x4d,0x43,0x4c,0x52,0x21,0x29, /* s (except MCLR!) */ \
	0x20,0x61,0x6e,0x64,0x20,0x79,0x6f,0x75,0x27,0x6c,0x6c,0x20,0x73,0x65,0x65,0x20, /*  and you'll see  */ \
	0x74,0x68,0x65,0x20,0x73,0x74,0x61,0x74,0x75,0x73,0x20,0x75,0x70,0x64,0x61,0x74, /* the status updat */ \
	0x65,0x20,0x69,0x6d,0x6d,0x65,0x64,0x69,0x61,0x74,0x65,0x6c,0x79,0x2e,0x0d,0x0a, /* e immediately... */ \
	0x54,0x68,0x69,0x73,0x20,0x65,0x78,0x61,0x6d,0x70,0x6c,0x65,0x73,0x20,0x75,0x73, /* This examples us */ \
	0x65,0x73,0x20,0x41,0x4a,0x41,0x58,0x20,0x74,0x65,0x63,0x68,0x6e,0x69,0x71,0x75, /* es AJAX techniqu */ \
	0x65,0x73,0x20,0x74,0x6f,0x20,0x70,0x72,0x6f,0x76,0x69,0x64,0x65,0x20,0x72,0x65, /* es to provide re */ \
	0x61,0x6c,0x2d,0x74,0x69,0x6d,0x65,0x20,0x66,0x65,0x65,0x64,0x62,0x61,0x63,0x6b, /* al-time feedback */ \
	0x2e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70,0x3e,0x54,0x68,0x69,0x73, /* .</p>....<p>This */ \
	0x20,0x73,0x69,0x74,0x65,0x20,0x69,0x73,0x20,0x70,0x72,0x6f,0x76,0x69,0x64,0x65, /*  site is provide */ \
	0x64,0x20,0x61,0x73,0x20,0x61,0x20,0x74,0x75,0x74,0x6f,0x72,0x69,0x61,0x6c,0x20, /* d as a tutorial  */ \
	0x66,0x6f,0x72,0x20,0x74,0x68,0x65,0x20,0x76,0x61,0x72,0x69,0x6f,0x75,0x73,0x20, /* for the various  */ \
	0x66,0x65,0x61,0x74,0x75,0x72,0x65,0x73,0x20,0x6f,0x66,0x20,0x74,0x68,0x65,0x20, /* features of the  */ \
	0x48,0x54,0x54,0x50,0x0d,0x0a,0x77,0x65,0x62,0x20,0x73,0x65,0x72,0x76,0x65,0x72, /* HTTP..web server */ \
	0x2c,0x20,0x69,0x6e,0x63,0x6c,0x75,0x64,0x69,0x6e,0x67,0x3a,0x3c,0x2f,0x70,0x3e, /* , including:</p> */ \
	0x0d,0x0a,0x0d,0x0a,0x3c,0x75,0x6c,0x3e,0x0d,0x0a,0x3c,0x6c,0x69,0x3e,0x3c,0x62, /* ....<ul>..<li><b */ \
	0x3e,0x44,0x79,0x6e,0x61,0x6d,0x69,0x63,0x20,0x56,0x61,0x72,0x69,0x61,0x62,0x6c, /* >Dynamic Variabl */ \
	0x65,0x20,0x53,0x75,0x62,0x73,0x74,0x69,0x74,0x75,0x74,0x69,0x6f,0x6e,0x3c,0x2f, /* e Substitution</ */ \
	0x62,0x3e,0x20,0x2d,0x20,0x64,0x69,0x73,0x70,0x6c,0x61,0x79,0x20,0x72,0x65,0x61, /* b> - display rea */ \
	0x6c,0x2d,0x74,0x69,0x6d,0x65,0x20,0x64,0x61,0x74,0x61,0x3c,0x2f,0x6c,0x69,0x3e, /* l-time data</li> */ \
	0x0d,0x0a,0x3c,0x6c,0x69,0x3e,0x3c,0x62,0x3e,0x46,0x6f,0x72,0x6d,0x20,0x50,0x72, /* ..<li><b>Form Pr */ \
	0x6f,0x63,0x65,0x73,0x73,0x69,0x6e,0x67,0x3c,0x2f,0x62,0x3e,0x20,0x2d,0x20,0x68, /* ocessing</b> - h */ \
	0x61,0x6e,0x64,0x6c,0x65,0x20,0x69,0x6e,0x70,0x75,0x74,0x20,0x66,0x72,0x6f,0x6d, /* andle input from */ \
	0x20,0x74,0x68,0x65,0x20,0x63,0x6c,0x69,0x65,0x6e,0x74,0x3c,0x2f,0x6c,0x69,0x3e, /*  the client</li> */ \
	0x0d,0x0a,0x3c,0x6c,0x69,0x3e,0x3c,0x62,0x3e,0x41,0x75,0x74,0x68,0x65,0x6e,0x74, /* ..<li><b>Authent */ \
	0x69,0x63,0x61,0x74,0x69,0x6f,0x6e,0x3c,0x2f,0x62,0x3e,0x20,0x2d,0x20,0x72,0x65, /* ication</b> - re */ \
	0x71,0x75,0x69,0x72,0x65,0x20,0x61,0x20,0x75,0x73,0x65,0x72,0x20,0x6e,0x61,0x6d, /* quire a user nam */ \
	0x65,0x20,0x61,0x6e,0x64,0x20,0x70,0x61,0x73,0x73,0x77,0x6f,0x72,0x64,0x3c,0x2f, /* e and password</ */ \
	0x6c,0x69,0x3e,0x0d,0x0a,0x3c,0x6c,0x69,0x3e,0x3c,0x62,0x3e,0x43,0x6f,0x6f,0x6b, /* li>..<li><b>Cook */ \
	0x69,0x65,0x73,0x3c,0x2f,0x62,0x3e,0x20,0x2d,0x20,0x73,0x74,0x6f,0x72,0x65,0x20, /* ies</b> - store  */ \
	0x73,0x65,0x73,0x73,0x69,0x6f,0x6e,0x20,0x73,0x74,0x61,0x74,0x65,0x20,0x69,0x6e, /* session state in */ \
	0x66,0x6f,0x72,0x6d,0x61,0x74,0x69,0x6f,0x6e,0x20,0x66,0x6f,0x72,0x20,0x72,0x69, /* formation for ri */ \
	0x63,0x68,0x65,0x72,0x20,0x61,0x70,0x70,0x6c,0x69,0x63,0x61,0x74,0x69,0x6f,0x6e, /* cher application */ \
	0x73,0x3c,0x2f,0x6c,0x69,0x3e,0x0d,0x0a,0x3c,0x6c,0x69,0x3e,0x3c,0x62,0x3e,0x46, /* s</li>..<li><b>F */ \
	0x69,0x6c,0x65,0x20,0x55,0x70,0x6c,0x6f,0x61,0x64,0x73,0x3c,0x2f,0x62,0x3e,0x20, /* ile Uploads</b>  */ \
	0x2d,0x20,0x70,0x61,0x72,0x73,0x65,0x20,0x66,0x69,0x6c,0x65,0x73,0x20,0x66,0x6f, /* - parse files fo */ \
	0x72,0x20,0x63,0x6f,0x6e,0x66,0x69,0x67,0x75,0x72,0x61,0x74,0x69,0x6f,0x6e,0x20, /* r configuration  */ \
	0x73,0x65,0x74,0x74,0x69,0x6e,0x67,0x73,0x20,0x61,0x6e,0x64,0x20,0x6d,0x6f,0x72, /* settings and mor */ \
	0x65,0x3c,0x2f,0x6c,0x69,0x3e,0x0d,0x0a,0x3c,0x2f,0x75,0x6c,0x3e,0x0d,0x0a,0x0d, /* e</li>..</ul>... */ \
	0x0a,0x3c,0x70,0x3e,0x53,0x65,0x76,0x65,0x72,0x61,0x6c,0x20,0x65,0x78,0x61,0x6d, /* .<p>Several exam */ \
	0x70,0x6c,0x65,0x20,0x61,0x70,0x70,0x6c,0x69,0x63,0x61,0x74,0x69,0x6f,0x6e,0x73, /* ple applications */ \
	0x20,0x61,0x72,0x65,0x20,0x61,0x6c,0x73,0x6f,0x20,0x70,0x72,0x6f,0x76,0x69,0x64, /*  are also provid */ \
	0x65,0x64,0x20,0x66,0x6f,0x72,0x20,0x75,0x70,0x64,0x61,0x74,0x69,0x6e,0x67,0x20, /* ed for updating  */ \
	0x63,0x6f,0x6e,0x66,0x69,0x67,0x75,0x72,0x61,0x74,0x69,0x6f,0x6e,0x0d,0x0a,0x70, /* configuration..p */ \
	0x61,0x72,0x61,0x6d,0x65,0x74,0x65,0x72,0x73,0x2c,0x20,0x73,0x65,0x6e,0x64,0x69, /* arameters, sendi */ \
	0x6e,0x67,0x20,0x65,0x2d,0x6d,0x61,0x69,0x6c,0x73,0x2c,0x20,0x61,0x6e,0x64,0x20, /* ng e-mails, and  */ \
	0x63,0x6f,0x6e,0x74,0x72,0x6f,0x6c,0x6c,0x69,0x6e,0x67,0x20,0x74,0x68,0x65,0x20, /* controlling the  */ \
	0x44,0x79,0x6e,0x61,0x6d,0x69,0x63,0x20,0x44,0x4e,0x53,0x20,0x63,0x6c,0x69,0x65, /* Dynamic DNS clie */ \
	0x6e,0x74,0x2e,0x20,0x20,0x54,0x68,0x61,0x6e,0x6b,0x73,0x20,0x74,0x6f,0x0d,0x0a, /* nt.  Thanks to.. */ \
	0x62,0x75,0x69,0x6c,0x74,0x2d,0x69,0x6e,0x20,0x47,0x5a,0x49,0x50,0x20,0x63,0x6f, /* built-in GZIP co */ \
	0x6d,0x70,0x72,0x65,0x73,0x73,0x69,0x6f,0x6e,0x20,0x73,0x75,0x70,0x70,0x6f,0x72, /* mpression suppor */ \
	0x74,0x2c,0x20,0x61,0x6c,0x6c,0x20,0x74,0x68,0x65,0x73,0x65,0x20,0x74,0x75,0x74, /* t, all these tut */ \
	0x6f,0x72,0x69,0x61,0x6c,0x73,0x20,0x61,0x6e,0x64,0x20,0x65,0x78,0x61,0x6d,0x70, /* orials and examp */ \
	0x6c,0x65,0x73,0x20,0x66,0x69,0x74,0x20,0x69,0x6e,0x20,0x74,0x68,0x65,0x0d,0x0a, /* les fit in the.. */ \
	0x33,0x32,0x6b,0x42,0x20,0x6f,0x66,0x20,0x6f,0x6e,0x2d,0x62,0x6f,0x61,0x72,0x64, /* 32kB of on-board */ \
	0x20,0x4d,0x65,0x6d,0x6f,0x72,0x79,0x2e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a, /*  Memory.</p>.... */ \
	0x3c,0x70,0x3e,0x46,0x6f,0x72,0x20,0x6d,0x6f,0x72,0x65,0x20,0x69,0x6e,0x66,0x6f, /* <p>For more info */ \
	0x72,0x6d,0x61,0x74,0x69,0x6f,0x6e,0x20,0x6f,0x6e,0x20,0x74,0x68,0x65,0x20,0x48, /* rmation on the H */ \
	0x61,0x72,0x6d,0x6f,0x6e,0x79,0x20,0x54,0x43,0x50,0x2f,0x49,0x50,0x20,0x53,0x74, /* armony TCP/IP St */ \
	0x61,0x63,0x6b,0x2c,0x20,0x70,0x6c,0x65,0x61,0x73,0x65,0x20,0x72,0x65,0x66,0x65, /* ack, please refe */ \
	0x72,0x20,0x74,0x6f,0x0d,0x0a,0x74,0x68,0x65,0x20,0x54,0x43,0x50,0x2f,0x49,0x50, /* r to..the TCP/IP */ \
	0x20,0x53,0x74,0x61,0x63,0x6b,0x20,0x4c,0x69,0x62,0x72,0x61,0x72,0x69,0x65,0x73, /*  Stack Libraries */ \
	0x20,0x48,0x65,0x6c,0x70,0x20,0x70,0x61,0x72,0x61,0x67,0x72,0x61,0x70,0x68,0x20, /*  Help paragraph  */ \
	0x69,0x6e,0x20,0x74,0x68,0x65,0x20,0x4d,0x50,0x4c,0x41,0x42,0x20,0x48,0x61,0x72, /* in the MPLAB Har */ \
	0x6d,0x6f,0x6e,0x79,0x20,0x48,0x65,0x6c,0x70,0x0d,0x0a,0x69,0x6e,0x73,0x74,0x61, /* mony Help..insta */ \
	0x6c,0x6c,0x65,0x64,0x20,0x6f,0x6e,0x20,0x79,0x6f,0x75,0x72,0x20,0x63,0x6f,0x6d, /* lled on your com */ \
	0x70,0x75,0x74,0x65,0x72,0x20,0x61,0x73,0x20,0x70,0x61,0x72,0x74,0x20,0x6f,0x66, /* puter as part of */ \
	0x20,0x74,0x68,0x65,0x20,0x48,0x61,0x72,0x6d,0x6f,0x6e,0x79,0x20,0x64,0x69,0x73, /*  the Harmony dis */ \
	0x74,0x72,0x69,0x62,0x75,0x74,0x69,0x6f,0x6e,0x2e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a, /* tribution.</p>.. */ \
	0x0d,0x0a,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x73,0x63,0x72, /* ..</div>....<scr */ \
	0x69,0x70,0x74,0x20,0x74,0x79,0x70,0x65,0x3d,0x22,0x74,0x65,0x78,0x74,0x2f,0x6a, /* ipt type="text/j */ \
	0x61,0x76,0x61,0x73,0x63,0x72,0x69,0x70,0x74,0x22,0x3e,0x0d,0x0a,0x3c,0x21,0x2d, /* avascript">..<!- */ \
	0x2d,0x0d,0x0a,0x2f,0x2f,0x20,0x50,0x61,0x72,0x73,0x65,0x73,0x20,0x74,0x68,0x65, /* -..// Parses the */ \
	0x20,0x78,0x6d,0x6c,0x52,0x65,0x73,0x70,0x6f,0x6e,0x73,0x65,0x20,0x66,0x72,0x6f, /*  xmlResponse fro */ \
	0x6d,0x20,0x73,0x74,0x61,0x74,0x75,0x73,0x2e,0x78,0x6d,0x6c,0x20,0x61,0x6e,0x64, /* m status.xml and */ \
	0x20,0x75,0x70,0x64,0x61,0x74,0x65,0x73,0x20,0x74,0x68,0x65,0x20,0x73,0x74,0x61, /*  updates the sta */ \
	0x74,0x75,0x73,0x20,0x62,0x6f,0x78,0x0d,0x0a,0x66,0x75,0x6e,0x63,0x74,0x69,0x6f, /* tus box..functio */ \
	0x6e,0x20,0x75,0x70,0x64,0x61,0x74,0x65,0x53,0x74,0x61,0x74,0x75,0x73,0x28,0x78, /* n updateStatus(x */ \
	0x6d,0x6c,0x44,0x61,0x74,0x61,0x29,0x20,0x7b,0x0d,0x0a,0x09,0x76,0x61,0x72,0x20, /* mlData) {...var  */ \
	0x6d,0x61,0x69,0x6e,0x73,0x74,0x61,0x74,0x20,0x3d,0x20,0x64,0x6f,0x63,0x75,0x6d, /* mainstat = docum */ \
	0x65,0x6e,0x74,0x2e,0x67,0x65,0x74,0x45,0x6c,0x65,0x6d,0x65,0x6e,0x74,0x42,0x79, /* ent.getElementBy */ \
	0x49,0x64,0x28,0x27,0x64,0x69,0x73,0x70,0x6c,0x61,0x79,0x27,0x29,0x2e,0x73,0x74, /* Id('display').st */ \
	0x79,0x6c,0x65,0x2e,0x64,0x69,0x73,0x70,0x6c,0x61,0x79,0x3b,0x0d,0x0a,0x09,0x76, /* yle.display;...v */ \
	0x61,0x72,0x20,0x6c,0x6f,0x61,0x64,0x73,0x74,0x61,0x74,0x20,0x3d,0x20,0x64,0x6f, /* ar loadstat = do */ \
	0x63,0x75,0x6d,0x65,0x6e,0x74,0x2e,0x67,0x65,0x74,0x45,0x6c,0x65,0x6d,0x65,0x6e, /* cument.getElemen */ \
	0x74,0x42,0x79,0x49,0x64,0x28,0x27,0x6c,0x6f,0x61,0x64,0x69,0x6e,0x67,0x27,0x29, /* tById('loading') */ \
	0x2e,0x73,0x74,0x79,0x6c,0x65,0x2e,0x64,0x69,0x73,0x70,0x6c,0x61,0x79,0x3b,0x0d, /* .style.display;. */ \
	0x0a,0x0d,0x0a,0x09,0x2f,0x2f,0x20,0x43,0x68,0x65,0x63,0x6b,0x20,0x69,0x66,0x20, /* ....// Check if  */ \
	0x61,0x20,0x74,0x69,0x6d,0x65,0x6f,0x75,0x74,0x20,0x6f,0x63,0x63,0x75,0x72,0x72, /* a timeout occurr */ \
	0x65,0x64,0x0d,0x0a,0x09,0x69,0x66,0x28,0x21,0x78,0x6d,0x6c,0x44,0x61,0x74,0x61, /* ed...if(!xmlData */ \
	0x29,0x0d,0x0a,0x09,0x7b,0x0d,0x0a,0x09,0x09,0x6d,0x61,0x69,0x6e,0x73,0x74,0x61, /* )...{....mainsta */ \
	0x74,0x20,0x3d,0x20,0x27,0x6e,0x6f,0x6e,0x65,0x27,0x3b,0x0d,0x0a,0x09,0x09,0x6c, /* t = 'none';....l */ \
	0x6f,0x61,0x64,0x73,0x74,0x61,0x74,0x20,0x3d,0x20,0x27,0x69,0x6e,0x6c,0x69,0x6e, /* oadstat = 'inlin */ \
	0x65,0x27,0x3b,0x0d,0x0a,0x09,0x09,0x72,0x65,0x74,0x75,0x72,0x6e,0x3b,0x0d,0x0a, /* e';....return;.. */ \
	0x09,0x7d,0x0d,0x0a,0x0d,0x0a,0x09,0x2f,0x2f,0x20,0x4d,0x61,0x6b,0x65,0x20,0x73, /* .}.....// Make s */ \
	0x75,0x72,0x65,0x20,0x77,0x65,0x27,0x72,0x65,0x20,0x64,0x69,0x73,0x70,0x6c,0x61, /* ure we're displa */ \
	0x79,0x69,0x6e,0x67,0x20,0x74,0x68,0x65,0x20,0x73,0x74,0x61,0x74,0x75,0x73,0x20, /* ying the status  */ \
	0x64,0x69,0x73,0x70,0x6c,0x61,0x79,0x0d,0x0a,0x09,0x6d,0x61,0x69,0x6e,0x73,0x74, /* display...mainst */ \
	0x61,0x74,0x20,0x3d,0x20,0x27,0x69,0x6e,0x6c,0x69,0x6e,0x65,0x27,0x3b,0x0d,0x0a, /* at = 'inline';.. */ \
	0x09,0x6c,0x6f,0x61,0x64,0x73,0x74,0x61,0x74,0x20,0x3d,0x20,0x27,0x6e,0x6f,0x6e, /* .loadstat = 'non */ \
	0x65,0x27,0x3b,0x0d,0x0a,0x0d,0x0a,0x09,0x2f,0x2f,0x20,0x4c,0x6f,0x6f,0x70,0x20, /* e';.....// Loop  */ \
	0x6f,0x76,0x65,0x72,0x20,0x61,0x6c,0x6c,0x20,0x74,0x68,0x65,0x20,0x4c,0x45,0x44, /* over all the LED */ \
	0x73,0x0d,0x0a,0x09,0x66,0x6f,0x72,0x28,0x69,0x20,0x3d,0x20,0x30,0x3b,0x20,0x69, /* s...for(i = 0; i */ \
	0x20,0x3c,0x20,0x31,0x3b,0x20,0x69,0x2b,0x2b,0x29,0x20,0x2f,0x2f,0x20,0x54,0x65, /*  < 1; i++) // Te */ \
	0x6d,0x70,0x6f,0x72,0x61,0x72,0x69,0x6c,0x79,0x20,0x63,0x68,0x61,0x6e,0x67,0x65, /* mporarily change */ \
	0x20,0x33,0x20,0x74,0x6f,0x20,0x31,0x0d,0x0a,0x09,0x09,0x64,0x6f,0x63,0x75,0x6d, /*  3 to 1....docum */ \
	0x65,0x6e,0x74,0x2e,0x67,0x65,0x74,0x45,0x6c,0x65,0x6d,0x65,0x6e,0x74,0x42,0x79, /* ent.getElementBy */ \
	0x49,0x64,0x28,0x27,0x6c,0x65,0x64,0x27,0x20,0x2b,0x20,0x69,0x29,0x2e,0x73,0x74, /* Id('led' + i).st */ \
	0x79,0x6c,0x65,0x2e,0x63,0x6f,0x6c,0x6f,0x72,0x20,0x3d,0x20,0x28,0x67,0x65,0x74, /* yle.color = (get */ \
	0x58,0x4d,0x4c,0x56,0x61,0x6c,0x75,0x65,0x28,0x78,0x6d,0x6c,0x44,0x61,0x74,0x61, /* XMLValue(xmlData */ \
	0x2c,0x20,0x27,0x6c,0x65,0x64,0x27,0x20,0x2b,0x20,0x69,0x29,0x20,0x3d,0x3d,0x20, /* , 'led' + i) ==  */ \
	0x27,0x31,0x27,0x29,0x20,0x3f,0x20,0x27,0x23,0x30,0x39,0x30,0x27,0x20,0x3a,0x20, /* '1') ? '#090' :  */ \
	0x27,0x23,0x64,0x64,0x64,0x27,0x3b,0x0d,0x0a,0x0d,0x0a,0x09,0x2f,0x2f,0x20,0x4c, /* '#ddd';.....// L */ \
	0x6f,0x6f,0x70,0x20,0x6f,0x76,0x65,0x72,0x20,0x61,0x6c,0x6c,0x20,0x74,0x68,0x65, /* oop over all the */ \
	0x20,0x62,0x75,0x74,0x74,0x6f,0x6e,0x73,0x0d,0x0a,0x09,0x66,0x6f,0x72,0x28,0x69, /*  buttons...for(i */ \
	0x20,0x3d,0x20,0x30,0x3b,0x20,0x69,0x20,0x3c,0x20,0x33,0x3b,0x20,0x69,0x2b,0x2b, /*  = 0; i < 3; i++ */ \
	0x29,0x0d,0x0a,0x09,0x09,0x64,0x6f,0x63,0x75,0x6d,0x65,0x6e,0x74,0x2e,0x67,0x65, /* )....document.ge */ \
	0x74,0x45,0x6c,0x65,0x6d,0x65,0x6e,0x74,0x42,0x79,0x49,0x64,0x28,0x27,0x62,0x74, /* tElementById('bt */ \
	0x6e,0x27,0x20,0x2b,0x20,0x69,0x29,0x2e,0x69,0x6e,0x6e,0x65,0x72,0x48,0x54,0x4d, /* n' + i).innerHTM */ \
	0x4c,0x20,0x3d,0x20,0x28,0x67,0x65,0x74,0x58,0x4d,0x4c,0x56,0x61,0x6c,0x75,0x65, /* L = (getXMLValue */ \
	0x28,0x78,0x6d,0x6c,0x44,0x61,0x74,0x61,0x2c,0x20,0x27,0x62,0x74,0x6e,0x27,0x20, /* (xmlData, 'btn'  */ \
	0x2b,0x20,0x69,0x29,0x20,0x3d,0x3d,0x20,0x27,0x75,0x70,0x27,0x29,0x20,0x3f,0x20, /* + i) == 'up') ?  */ \
	0x27,0x26,0x4c,0x61,0x6d,0x62,0x64,0x61,0x3b,0x27,0x20,0x3a,0x20,0x27,0x56,0x27, /* '&Lambda;' : 'V' */ \
	0x3b,0x0d,0x0a,0x0d,0x0a,0x09,0x2f,0x2f,0x20,0x55,0x70,0x64,0x61,0x74,0x65,0x20, /* ;.....// Update  */ \
	0x74,0x68,0x65,0x20,0x50,0x4f,0x54,0x20,0x76,0x61,0x6c,0x75,0x65,0x0d,0x0a,0x09, /* the POT value... */ \
	0x64,0x6f,0x63,0x75,0x6d,0x65,0x6e,0x74,0x2e,0x67,0x65,0x74,0x45,0x6c,0x65,0x6d, /* document.getElem */ \
	0x65,0x6e,0x74,0x42,0x79,0x49,0x64,0x28,0x27,0x70,0x6f,0x74,0x30,0x27,0x29,0x2e, /* entById('pot0'). */ \
	0x69,0x6e,0x6e,0x65,0x72,0x48,0x54,0x4d,0x4c,0x20,0x3d,0x20,0x67,0x65,0x74,0x58, /* innerHTML = getX */ \
	0x4d,0x4c,0x56,0x61,0x6c,0x75,0x65,0x28,0x78,0x6d,0x6c,0x44,0x61,0x74,0x61,0x2c, /* MLValue(xmlData, */ \
	0x20,0x27,0x70,0x6f,0x74,0x30,0x27,0x29,0x3b,0x0d,0x0a,0x7d,0x0d,0x0a,0x73,0x65, /*  'pot0');..}..se */ \
	0x74,0x54,0x69,0x6d,0x65,0x6f,0x75,0x74,0x28,0x22,0x6e,0x65,0x77,0x41,0x4a,0x41, /* tTimeout("newAJA */ \
	0x58,0x43,0x6f,0x6d,0x6d,0x61,0x6e,0x64,0x28,0x27,0x73,0x74,0x61,0x74,0x75,0x73, /* XCommand('status */ \
	0x2e,0x78,0x6d,0x6c,0x27,0x2c,0x20,0x75,0x70,0x64,0x61,0x74,0x65,0x53,0x74,0x61, /* .xml', updateSta */ \
	0x74,0x75,0x73,0x2c,0x20,0x74,0x72,0x75,0x65,0x29,0x22,0x2c,0x35,0x30,0x30,0x29, /* tus, true)",500) */ \
	0x3b,0x0d,0x0a,0x2f,0x2f,0x2d,0x2d,0x3e,0x0d,0x0a,0x3c,0x2f,0x73,0x63,0x72,0x69, /* ;..//-->..</scri */ \
	0x70,0x74,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x73,0x63,0x72,0x69,0x70,0x74,0x20,0x74, /* pt>....<script t */ \
	0x79,0x70,0x65,0x3d,0x22,0x74,0x65,0x78,0x74,0x2f,0x6a,0x61,0x76,0x61,0x73,0x63, /* ype="text/javasc */ \
	0x72,0x69,0x70,0x74,0x22,0x3e,0x0d,0x0a,0x3c,0x21,0x2d,0x2d,0x0d,0x0a,0x64,0x6f, /* ript">..<!--..do */ \
	0x63,0x75,0x6d,0x65,0x6e,0x74,0x2e,0x67,0x65,0x74,0x45,0x6c,0x65,0x6d,0x65,0x6e, /* cument.getElemen */ \
	0x74,0x42,0x79,0x49,0x64,0x28,0x27,0x68,0x65,0x6c,0x6c,0x6f,0x27,0x29,0x2e,0x69, /* tById('hello').i */ \
	0x6e,0x6e,0x65,0x72,0x48,0x54,0x4d,0x4c,0x20,0x3d,0x20,0x22,0x7e,0x68,0x65,0x6c, /* nnerHTML = "~hel */ \
	0x6c,0x6f,0x6d,0x73,0x67,0x7e,0x22,0x3b,0x0d,0x0a,0x2f,0x2f,0x2d,0x2d,0x3e,0x0d, /* lomsg~";..//-->. */ \
	0x0a,0x3c,0x2f,0x73,0x63,0x72,0x69,0x70,0x74,0x3e,0x0d,0x0a,0x7e,0x69,0x6e,0x63, /* .</script>..~inc */ \
	0x3a,0x66,0x6f,0x6f,0x74,0x65,0x72,0x2e,0x69,0x6e,0x63,0x7e,0x0d,0x0a,0x53,0x75, /* :footer.inc~..Su */ \
	0x63,0x63,0x65,0x73,0x73,0x21,0x20,0x7e,0x6c,0x65,0x64,0x28,0x30,0x29,0x7e,0x1f, /* ccess! ~led(0)~. */ \
	0x8b,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xad,0x56,0x51,0x6f,0x9b,0x30,0x10, /* ..........VQo.0. */ \
	0x7e,0x6e,0xa4,0xfc,0x07,0xa4,0xbe,0x86,0x08,0x12,0x48,0x53,0xfa,0xd4,0x4d,0xda, /* ~n........HS..M. */ \
	0xe3,0x1e,0xf7,0x6e,0xf0,0x11,0xac,0x3a,0x18,0xd9,0xa6,0x49,0x57,0xed,0xbf,0xcf, /* ...n...:...IW... */ \
	0x36,0x06,0x0c,0x38,0xa9,0x26,0x4d,0x48,0x5b,0x31,0x77,0xdf,0x7d,0xbe,0xfb,0xee, /* 6..8.&MH[1w.}... */ \
	0x2e,0x39,0xc3,0x1f,0xc1,0xe7,0x7a,0xf5,0x50,0xb2,0x5a,0x86,0x25,0x3a,0x13,0xfa, /* .9....z.P.Z.%:.. */ \
	0x91,0x05,0xbf,0x80,0x63,0x54,0xa3,0x4d,0xf0,0xca,0x09,0xa2,0x9b,0x40,0xa0,0x5a, /* ....cT.M.....@.Z */ \
	0x84,0x02,0x38,0x29,0x5f,0x94,0x69,0x8e,0x8a,0xb7,0x13,0x67,0x6d,0x8d,0xb3,0xe0, /* ..8)_.i....gm... */ \
	0x31,0xcd,0xf5,0xa3,0x8f,0xcf,0x88,0x9f,0x48,0x9d,0x05,0x51,0x73,0x0d,0x50,0x2b, /* 1.......H..Qs.P+ */ \
	0x99,0x3e,0x6b,0x10,0xc6,0xa4,0x3e,0xa9,0x43,0xf5,0xec,0xf4,0x97,0x48,0x1d,0xff, /* .>k...>.C....H.. */ \
	0x59,0xaf,0xd6,0xab,0x47,0x51,0x21,0xcc,0x2e,0x21,0xab,0xc1,0x10,0xb8,0x10,0x2c, /* Y...GQ!..!....., */ \
	0xab,0x2c,0x78,0x3a,0x28,0x2b,0x13,0x85,0x71,0x0c,0x3c,0x0b,0x62,0xe5,0x24,0x18, /* .,x:(+..q.<.b.$. */ \
	0x25,0x58,0xc5,0x4a,0xd3,0xf1,0x4b,0x28,0x59,0x93,0x19,0x38,0x5f,0xe4,0x3f,0x63, /* %X.J..K(Y..8_.?c */ \
	0x00,0x79,0x61,0x26,0x80,0x07,0x30,0xc9,0xf5,0xe3,0xc3,0x74,0xfd,0x2b,0x0e,0x70, /* .ya&..0....t.+.p */ \
	0x13,0x21,0x49,0xbe,0x70,0x2f,0x59,0xcb,0x6f,0x79,0xef,0x91,0x7e,0x6e,0x00,0x28, /* .!I.p/Y.oy..~n.( */ \
	0x88,0x06,0x9d,0x6e,0x46,0xde,0xef,0xf7,0x8b,0x62,0x94,0x65,0xe9,0x4d,0xd0,0x50, /* ...nF....b.e.M.P */ \
	0x86,0x9d,0x4d,0xae,0xa9,0xb6,0x20,0xbf,0x41,0x41,0x46,0x8d,0x9c,0x06,0x94,0x78, /* ..M... .AAF....x */ \
	0x54,0x84,0xc7,0x46,0x12,0x49,0x2d,0x2b,0x37,0xf6,0xb7,0x24,0xfd,0x11,0x25,0x93, /* T..F.I-+7..$..%. */ \
	0x68,0x89,0x13,0xec,0x02,0xe4,0x54,0xc9,0x2c,0xc8,0x19,0xc5,0xfa,0xb0,0x60,0x94, /* h.....T.,.....`. */ \
	0xf1,0x91,0x72,0x57,0xc2,0x30,0x67,0x52,0xb2,0xb3,0x0a,0x98,0x76,0xae,0x95,0xf5, /* ..rW.0gR....v... */ \
	0x8a,0x0f,0xe6,0xdd,0x25,0xb0,0xe5,0xfa,0x53,0xc7,0x94,0x32,0xa4,0x8c,0xcc,0xc1, /* ....%...S..2.... */ \
	0xcb,0x28,0xa5,0x7d,0x64,0x6f,0x2b,0xe1,0x2a,0x43,0x44,0xc9,0xa9,0x1e,0x8d,0x3a, /* .(.}do+..CD....: */ \
	0xa8,0x33,0xd4,0xad,0x0b,0x41,0xa1,0x74,0x11,0xe2,0xd4,0x22,0xd8,0x2b,0x85,0xbc, /* .3...A.t...".+.. */ \
	0xa3,0x63,0xd3,0xe8,0x60,0x20,0x57,0xc3,0x71,0x62,0xdd,0x30,0x11,0x0d,0x45,0xaa, /* .c..` W.qb.0..E. */ \
	0xa1,0x72,0xca,0x8a,0xb7,0x45,0xb9,0xc6,0x94,0xd9,0x6c,0x5c,0x2a,0x22,0x61,0x92, /* .r...E....l\."a. */ \
	0xc2,0xe3,0x9d,0x14,0xda,0x32,0x0f,0x39,0x1b,0xb5,0x61,0x93,0x6a,0xee,0x8d,0xa1, /* .....2.9..a.j... */ \
	0x60,0x1c,0x49,0xc2,0xd4,0xe5,0x6b,0xd5,0x6c,0x33,0xde,0x59,0xc5,0xde,0x81,0x2f, /* `.I...k.l3.Y.../ */ \
	0xcb,0x79,0x7c,0x8d,0x8e,0xd1,0x71,0x30,0x2e,0x14,0x01,0xa8,0xa5,0x7b,0xcb,0x74, /* .y|...q0.....{.t */ \
	0x67,0x8b,0x34,0x4f,0xff,0x2c,0x59,0xb1,0x9b,0xac,0x1e,0xa7,0xcb,0x57,0x2f,0x82, /* g.4O.,Y......W/. */ \
	0x22,0x8a,0xbe,0xe6,0x3b,0xb8,0x3a,0x94,0x7b,0x00,0xdc,0x35,0xc3,0x02,0x40,0xdd, /* "...;.:.{..5..@. */ \
	0x05,0x38,0x25,0x1e,0x94,0x2a,0x36,0x00,0x56,0x77,0x5d,0xab,0x8c,0x3c,0xb7,0xa2, /* .8%...6.Vw]..<.. */ \
	0x41,0x45,0x1f,0x83,0x02,0xe2,0x3a,0xeb,0xb2,0x1a,0x50,0x4a,0xc6,0xa4,0xfd,0xec, /* AE....:...PJ.... */ \
	0xb4,0x49,0xb4,0x3d,0xc2,0xd9,0x15,0xf7,0xe1,0x70,0x98,0xeb,0xaf,0x50,0xc1,0x81, /* .I.=.....p...P.. */ \
	0xbb,0x53,0x4b,0xe7,0x27,0x48,0xcd,0x6c,0x0c,0xe6,0x7a,0x33,0xbc,0xe2,0xc9,0x44, /* .SK.'H.l..z3...D */ \
	0xb4,0x67,0xca,0x1c,0xab,0xc2,0x03,0xee,0xa3,0xd8,0xa1,0x2a,0x91,0x6c,0xc5,0x44, /* .g...........l.D */ \
	0x8c,0x4f,0xf7,0xcb,0x34,0xe2,0xbb,0x84,0xe6,0x13,0x78,0x1a,0xcb,0xab,0xc7,0x09, /* .O..4.....x..... */ \
	0x81,0xc6,0x50,0x18,0x42,0xa4,0xdd,0xed,0xd4,0xbf,0xb1,0xdb,0x93,0x44,0x95,0xa7, /* ..P.B........D.. */ \
	0x56,0x08,0xe1,0x9c,0x42,0x34,0xc7,0xdb,0x52,0xc0,0x62,0x31,0x96,0x12,0x67,0x2c, /* V...B4..R.b1..g, */ \
	0x4d,0x0c,0xa7,0xf2,0xc2,0xb8,0x1b,0x39,0x2d,0x17,0xfa,0xbd,0x61,0xc4,0xd6,0xc0, /* M......9-...a... */ \
	0xe7,0xe9,0x53,0x57,0xe7,0x7f,0x57,0x9e,0x5b,0xb8,0xa2,0x73,0x43,0x21,0x67,0x57, /* ..SW..W.[..sC!gW */ \
	0x47,0x58,0x99,0x29,0xae,0x1e,0x07,0xc1,0xf0,0x97,0xaf,0xbf,0x7d,0xa9,0xde,0x3b, /* GX.)........}..; */ \
	0x9a,0xee,0xc4,0x33,0x6a,0xc7,0x69,0x55,0xcb,0xae,0x23,0x51,0x30,0x0c,0xcb,0x75, /* ...3j.iU..#Q0..u */ \
	0xfe,0x5d,0xad,0x20,0xa2,0xee,0xf4,0x13,0x2e,0x9b,0xfe,0x65,0x13,0x94,0xe4,0x0a, /* .]. .......e.... */ \
	0x38,0x34,0x2a,0xb1,0x2f,0xce,0x5d,0x80,0x17,0x44,0x78,0xa6,0x7c,0x09,0xcf,0x2f, /* 84../.]..Dx.|../ */ \
	0xb3,0xc2,0x3a,0xe3,0x5b,0x8f,0xcf,0x85,0x5e,0xbb,0xc3,0xdd,0x38,0x9d,0x20,0xdf, /* ..:.[...^...8. . */ \
	0x8f,0x91,0x38,0x67,0xdc,0xed,0xc4,0x29,0xc4,0x42,0xa3,0x53,0x32,0x18,0xdf,0x8b, /* ..8g...).B.S2... */ \
	0xf3,0x1c,0x8d,0x32,0x1a,0xda,0xfe,0xe0,0xec,0x53,0xa7,0x95,0x90,0xa8,0x9c,0x9c, /* ...2.....S...... */ \
	0x0f,0x9d,0x90,0xce,0x68,0x44,0xb3,0xb5,0xe4,0x4c,0x0c,0xa7,0xfe,0x76,0x81,0x3a, /* ....hD...L...v.: */ \
	0x95,0xeb,0xf7,0xca,0x7c,0x34,0xa6,0x23,0x40,0x49,0x80,0x62,0x01,0xf2,0xff,0xaa, /* ....|4.#@I.b.... */ \
	0xe7,0x86,0x50,0x86,0x60,0x98,0xbc,0x4f,0x3b,0x55,0xe7,0x4f,0xc7,0xd2,0xff,0xf7, /* ..P.`..O;U.O.... */ \
	0xeb,0x6f,0xe9,0x42,0x51,0x0e,0x74,0x59,0xb6,0x30,0x4e,0x7c,0x03,0x6c,0xd7,0x9d, /* .o.BQ.tY.0N|.l.. */ \
	0xf5,0x03,0x69,0x9f,0xde,0x59,0x6a,0x0d,0x13,0xa4,0xeb,0x2e,0x94,0xab,0x3a,0xb6, /* ..i..Yj.......:. */ \
	0x12,0x16,0x04,0x48,0xdd,0xb4,0x93,0x4d,0xb4,0xf3,0xf2,0x34,0x66,0x5b,0x71,0x76, /* ...H...M...4f[qv */ \
	0x2d,0xc7,0x5f,0x87,0x8e,0xa1,0xae,0x13,0xe2,0x80,0x6e,0x42,0x6e,0x39,0x88,0x96, /* -._.......nBn9.. */ \
	0xca,0xf5,0xea,0x73,0x3d,0x1b,0xdb,0xff,0x56,0x9b,0xe9,0x2f,0x37,0xff,0x56,0xf0, /* ...s=...V../7.V. */ \
	0x6f,0x7a,0x57,0xf5,0x00,0x43,0x4a,0x1e,0xb6,0xec,0xcd,0xb0,0xee,0x05,0x3d,0x2c, /* ozW..CJ.......=, */ \
	0x9e,0xdc,0x8c,0xe9,0x99,0x63,0x69,0x7e,0x5b,0x28,0xcf,0x07,0xed,0x5a,0x22,0x42, /* .....ci~[(...Z"B */ \
	0xbd,0xce,0xf9,0xc1,0xe3,0x5c,0xc2,0xc4,0xb9,0xad,0xfd,0x81,0x8b,0xc2,0xe7,0x5b, /* .....\.........[ */ \
	0x62,0xeb,0xfb,0x17,0x8c,0xa0,0xeb,0xa6,0x6f,0x0c,0x00,0x00,0x1f,0x8b,0x08,0x00, /* b.......o....... */ \
	0x00,0x00,0x00,0x00,0x00,0x00,0xad,0x8f,0xf9,0x4f,0x93,0x07,0x00,0x40,0xbf,0x1e, /* .........O...@.. */ \
	0x94,0x72,0x14,0x5a,0xb4,0xd0,0x72,0xd9,0x53,0x59,0x45,0x43,0x98,0x28,0xe0,0xd5, /* .r.Z..r.SYEC.(.. */ \
	0xd2,0xd2,0x43,0x18,0xf9,0xc8,0x40,0x04,0x06,0x16,0x42,0x8b,0x32,0xc0,0x82,0x58, /* ..C...@...B.2..X */ \
	0x04,0xa7,0x2d,0x50,0x11,0xb9,0x2a,0x47,0x05,0x0a,0x52,0x50,0xca,0x74,0x14,0x8b, /* ..-P...G..RP.t.. */ \
	0x12,0x04,0x65,0x0a,0xca,0xa1,0x96,0xab,0xae,0x20,0x90,0x62,0x00,0x15,0x5c,0x16, /* ..e...... .b..\. */ \
	0xae,0xb9,0x45,0xdd,0x70,0xfd,0x16,0xb3,0x7f,0x61,0xef,0x87,0x97,0xbc,0x1f,0x1f, /* ..E.p....a...... */ \
	0x4f,0xc0,0xf5,0x0f,0x48,0xa8,0x05,0x18,0xc0,0x14,0x0d,0x90,0xc9,0x64,0x7d,0x7d, /* O...H........d}} */ \
	0x7d,0x16,0xac,0x1b,0xb4,0xbe,0x01,0x4d,0xbc,0x58,0x5f,0x5f,0x97,0x48,0x24,0x13, /* }......M.X__.H$. */ \
	0x13,0x13,0xd0,0xfc,0x22,0x16,0x8b,0xb5,0x90,0x18,0x16,0x9f,0x40,0x8d,0x46,0x03, /* ....".......@.F. */ \
	0x82,0xa0,0x85,0x29,0x10,0x0a,0x85,0x24,0x12,0x49,0xa9,0x54,0xce,0xcf,0xcf,0x43, /* ...)...$.I.T...C */ \
	0xf2,0x42,0xbd,0x5e,0xef,0xe3,0xe3,0x63,0x91,0x5d,0x84,0x34,0x2d,0x50,0xdf,0x13, /* .B.^...c.].4-P.. */ \
	0x0b,0x78,0xcc,0x22,0x91,0x5a,0x84,0xc9,0x90,0xb2,0x1a,0x52,0xaa,0x20,0x7d,0xa7, /* .x.".Z.....R. }. */ \
	0x45,0x92,0xcd,0x64,0x32,0x2d,0x80,0x3d,0x04,0x41,0x00,0x00,0xfc,0xe7,0xff,0x17, /* E..d2-.=.A...... */ \
	0xf2,0x5f,0x48,0x18,0x00,0xd0,0x00,0xef,0x2f,0xf1,0xe5,0x09,0x40,0x41,0xcc,0x4a, /* ._H...../...@A.J */ \
	0x09,0xdf,0xdb,0x55,0xf9,0xac,0x25,0xf3,0x79,0x6a,0xa0,0xc6,0x78,0x33,0xeb,0x48, /* ...U..%.yj..x3.H */ \
	0x7b,0x8c,0x7e,0x46,0x27,0x1d,0x59,0xcd,0xbd,0x84,0x2c,0x61,0x63,0x19,0x35,0x56, /* {.~F'.Y...,ac.5V */ \
	0x0e,0x0e,0xaf,0x47,0xd2,0x7b,0xcb,0x10,0x25,0x4f,0x42,0xf5,0x97,0xdc,0x91,0x64, /* ...G.{..%OB....d */ \
	0x20,0xf1,0xec,0x26,0x14,0xe1,0x9c,0x24,0x55,0x88,0x6c,0x11,0x34,0x94,0x0d,0x46, /*  ..&...$U.l.4..F */ \
	0x5e,0x56,0x2e,0x40,0xdb,0x5d,0xac,0x12,0x39,0xd3,0x30,0x78,0x92,0xb2,0xbe,0x1e, /* ^V.@.]..9.0x.... */ \
	0x59,0x50,0x5d,0x95,0x03,0xb3,0x6a,0xd0,0xca,0x1a,0x9b,0x9a,0xec,0x5a,0x75,0xa7, /* YP]...j......Zu. */ \
	0x6e,0xde,0x6a,0x72,0xff,0xc6,0x8a,0x44,0x25,0x59,0xf3,0xac,0x30,0xf7,0x5a,0xda, /* n.jr...D%Y..0.Z. */ \
	0x75,0x88,0xd3,0x52,0x17,0x8a,0x5b,0x95,0x1d,0x5a,0x0f,0xff,0x3e,0x04,0x47,0x1d, /* u..R..[..Z..>.G. */ \
	0x57,0x73,0x1d,0xc7,0xa9,0xe7,0x1f,0xb5,0x6e,0x53,0x6c,0xa1,0x98,0x2b,0xa5,0x06, /* Ws......nSl..+.. */ \
	0x33,0x41,0xec,0x10,0x8a,0x32,0x51,0x9d,0x82,0xad,0x96,0x8d,0x2f,0xeb,0xd1,0x0a, /* 3A...2Q...../... */ \
	0x3b,0xb3,0x19,0xa9,0x18,0x78,0x4f,0x14,0x7b,0x86,0x74,0x99,0xa6,0xd8,0x63,0xa6, /* ;....xO.{.t...c. */ \
	0x99,0xae,0xd3,0x11,0xba,0xf1,0x7d,0x39,0x94,0xed,0x93,0xcf,0xe5,0xe0,0xa0,0x9c, /* ......}9........ */ \
	0x05,0xc7,0xd2,0x17,0xdf,0x79,0xb3,0x70,0xe8,0x65,0x2e,0x3a,0x00,0xb8,0xfe,0xa6, /* .....y.p.e.:.... */ \
	0xaf,0x9c,0xc4,0x3a,0x44,0xc2,0xdf,0x4d,0x42,0xa0,0xd8,0xb6,0x04,0xaf,0xd9,0x3b, /* ...:D..MB......; */ \
	0x2c,0x79,0xf5,0xce,0xe8,0xfc,0x22,0x66,0x3e,0x15,0x2d,0x0b,0x22,0x64,0x71,0x88, /* ,y...."f>.-."dq. */ \
	0x5b,0xb4,0xa3,0x50,0xb9,0xa3,0xd7,0x15,0x02,0xa8,0x6f,0x1e,0x10,0x92,0x29,0xae, /* [..P......o...). */ \
	0x0f,0x85,0xe2,0x82,0xca,0x52,0x2a,0x68,0x6b,0x03,0x9c,0xf9,0x6d,0x0f,0xb9,0xb7, /* .....R.hk...m... */ \
	0x29,0x8c,0x7d,0x6b,0xca,0xdd,0x00,0xc7,0x3f,0x08,0x3c,0x17,0x0d,0xdc,0x98,0x81, /* ).}k....?.<..... */ \
	0x47,0xa4,0xe1,0x61,0x0b,0xf6,0x80,0xcd,0x85,0xf4,0xa1,0xc0,0x1b,0xfd,0x93,0x4d, /* G..a...........M */ \
	0xe1,0x12,0x71,0xe0,0x1c,0x7e,0xb1,0xdf,0xbe,0x90,0x06,0xce,0x0a,0x46,0x8a,0x76, /* ..q..~.......F.v */ \
	0xb6,0x73,0x6d,0x32,0x79,0x83,0xaa,0xb6,0xcb,0xac,0x44,0x6e,0xf9,0x12,0x8a,0xbf, /* .sm2y.....Dn.... */ \
	0xf3,0x0a,0x32,0x76,0xe8,0x94,0xb9,0x92,0x6f,0x0f,0xd3,0x78,0xa4,0x65,0xdb,0x31, /* ..2v....o..x.e.1 */ \
	0xfc,0x8a,0x85,0xc6,0x66,0xaa,0x75,0x2b,0xbd,0xb6,0x30,0xec,0xda,0xd7,0x9d,0xd4, /* ....f.u+..0..... */ \
	0x78,0xd7,0xed,0x2c,0xf2,0xef,0x89,0xb1,0xe4,0xc8,0xd8,0xa3,0x18,0xdf,0x95,0xa9, /* x..,............ */ \
	0xc7,0x89,0x3b,0x0e,0xc7,0xb6,0x11,0xd7,0x96,0x93,0xef,0xff,0x48,0x6e,0x67,0x2f, /* ..;.........Hng/ */ \
	0xac,0x0d,0xf8,0xda,0xaf,0x33,0x74,0x59,0x83,0x3e,0xcc,0x14,0xda,0xed,0xe3,0x2e, /* .....3tY.>...... */ \
	0x81,0x9b,0x99,0xf0,0x2c,0xfe,0x6d,0x27,0xd6,0x8a,0x77,0x67,0x0c,0x65,0x7a,0xac, /* ....,.m'..wg.ez. */ \
	0xe0,0x57,0x91,0xc2,0x37,0x63,0x74,0x78,0xc8,0x91,0x7c,0xf8,0xfa,0xb8,0xe2,0x51, /* .W..7ctx..|....Q */ \
	0xf6,0x87,0xdc,0x8d,0xde,0xee,0xd8,0xa2,0x03,0xc1,0x93,0x47,0x1b,0xa3,0x9d,0x1f, /* ...........G.... */ \
	0xa3,0xae,0x8a,0x5f,0x61,0xac,0x8f,0xe5,0x04,0x7f,0x27,0x9a,0x3b,0xeb,0x90,0x52, /* ..._a.....'.;..R */ \
	0xa8,0x48,0x88,0xbb,0x8f,0xdf,0x56,0xc0,0x09,0x65,0xf3,0x0e,0x68,0x55,0xcd,0xd0, /* .H....V..e..hU.. */ \
	0x74,0xdc,0x27,0x8f,0x4c,0x97,0x83,0x22,0xdd,0xfb,0x46,0xee,0x92,0x3f,0x62,0x0e, /* t.'.L.."..F..?b. */ \
	0xb1,0x7c,0x5f,0xb5,0x90,0xb3,0x58,0xe6,0x37,0x9b,0x04,0x44,0x1a,0xaf,0xe3,0x70, /* .|_...X.7..D...p */ \
	0x89,0x7b,0x9b,0xd3,0xf6,0x19,0xba,0x2b,0x0a,0x93,0x49,0x1d,0x63,0x59,0xd6,0x7e, /* .{.....+..I.cY.~ */ \
	0x93,0x09,0x68,0xd7,0x15,0x6d,0x1e,0xf1,0x2e,0x36,0x83,0x88,0xa4,0x19,0x93,0xcb, /* ..h..m...6...... */ \
	0xc1,0xcf,0x27,0xde,0x27,0x8a,0x30,0x86,0xa1,0xd7,0x05,0xc4,0xab,0x4f,0x45,0xe7, /* ..'.'.0......OE. */ \
	0x0e,0xc4,0x7b,0xd5,0x10,0x3f,0x48,0x10,0xaf,0xe2,0x3d,0x6a,0x5f,0x34,0x84,0xf7, /* ..{..?H...=j_4.. */ \
	0x23,0x05,0x1c,0x55,0x10,0xf8,0xa7,0x1a,0xfb,0x55,0x4c,0xce,0x94,0xe8,0x98,0x74, /* #..U.....UL....t */ \
	0x76,0x2a,0x7b,0x9f,0xd3,0xa2,0x9a,0x7b,0xdc,0xb9,0xe2,0x28,0x9c,0x5e,0x27,0x6a, /* v.{....{...(.^'j */ \
	0x16,0x5f,0x8e,0x04,0x87,0x51,0x98,0x0a,0x42,0xbe,0xf5,0x3f,0xaa,0x9e,0x28,0x7f, /* ._...Q..B..?..(. */ \
	0xd1,0x67,0x3f,0x64,0x03,0x8d,0xb3,0xb7,0x2c,0xb6,0xb7,0x4c,0xf8,0xa2,0x04,0xdc, /* .g?d....,..L.... */ \
	0xed,0xf5,0xf2,0x2a,0x03,0x55,0x4b,0x2d,0xd9,0xff,0xe4,0x26,0x2f,0xa3,0xc8,0x10, /* .....UK-...&/... */ \
	0x9c,0x07,0xa7,0xec,0xe5,0xbc,0x05,0xa8,0x6a,0x98,0x3a,0xbc,0x51,0x40,0x1b,0x4c, /* ........j.:.Q@.L */ \
	0x99,0xa9,0x00,0x01,0xfd,0xb8,0x3c,0xbb,0x8e,0xdb,0x79,0x52,0x6d,0x13,0x72,0x3e, /* ......<...yRm.r> */ \
	0xd5,0xb6,0xff,0x2e,0x90,0xa4,0x15,0x14,0x53,0xdd,0xcd,0xb8,0x8e,0x1a,0x24,0xcd, /* ........S.....$. */ \
	0x04,0x5b,0x0b,0x78,0xce,0x10,0x1b,0x7c,0x7b,0x57,0x42,0x88,0xba,0x93,0x2d,0x44, /* .[.x...|{WB...-D */ \
	0xc1,0x11,0x97,0x96,0xd3,0x70,0xaf,0x2b,0x90,0xb6,0x9c,0x06,0x3c,0xe5,0x87,0x99, /* .....p.+....<... */ \
	0x9a,0xce,0x44,0xa6,0x64,0xd2,0x4b,0x9a,0x23,0x53,0xe2,0xa6,0x55,0xdb,0xff,0x4e, /* ..D.d.K.#S..U..N */ \
	0xa1,0x37,0xfc,0x74,0xcd,0xd3,0xb0,0xfa,0x30,0xd8,0x98,0x1b,0xa5,0xfe,0x7c,0x87, /* .7.t....0.....|. */ \
	0x58,0x8a,0x38,0x17,0x27,0xc9,0xd3,0xd4,0xb7,0x6e,0x75,0x46,0xf6,0x2c,0xb8,0x99, /* X.8.'....nuF.,.. */ \
	0x53,0x97,0x23,0xcf,0x36,0x70,0x39,0x3d,0x1f,0xdb,0xda,0xc2,0xe1,0x6d,0xf8,0x7b, /* S.#.6p9=.....m.{ */ \
	0xb6,0x0e,0x19,0x75,0xfd,0xdd,0xf4,0x3b,0xd3,0x15,0x85,0xa5,0x9f,0x04,0x75,0x5c, /* ...u...;......u\ */ \
	0x5c,0x82,0x69,0x57,0xc8,0xe8,0x0f,0xfd,0xa3,0x41,0x5b,0x37,0xe4,0xcf,0x4c,0x7b, /* \.iW.....A[7..L{ */ \
	0x98,0x95,0x3c,0xdf,0xec,0x88,0x31,0x58,0xb4,0x28,0x22,0x0f,0x74,0xc3,0xa7,0x85, /* ..<...1X.(".t... */ \
	0xc1,0xcf,0xcf,0x28,0xbe,0x6d,0xdd,0x4f,0x77,0xf2,0xe3,0x1f,0x99,0x5b,0xd2,0xb4, /* ...(.m.Ow....[.. */ \
	0x73,0xe3,0x0e,0xc6,0xb0,0x11,0x67,0x56,0x15,0xe1,0x21,0x4e,0x94,0xf4,0x20,0x29, /* s.....gV..!N.. ) */ \
	0xe7,0x69,0xd7,0xf4,0x89,0xa8,0x5d,0x8e,0xda,0x8d,0x67,0x6f,0x4e,0x78,0x10,0x1a, /* .i....]...goNx.. */ \
	0xae,0x7d,0x98,0xe3,0xa5,0xfe,0x31,0x47,0xcb,0xed,0x12,0xf0,0x75,0x14,0xe3,0x6a, /* .}....1G....u..j */ \
	0x37,0xce,0xbc,0xc0,0xbb,0x8c,0x8a,0x32,0x87,0xa7,0xcf,0xcb,0x76,0xec,0x46,0x8e, /* 7......2....v.F. */ \
	0x74,0x28,0xf2,0x7b,0x5e,0x17,0xf7,0xfd,0xe2,0x4f,0x86,0x03,0xe8,0x80,0xb7,0x15, /* t(.{^....O...... */ \
	0xa1,0xe9,0x97,0x10,0x0f,0xe2,0x2f,0x04,0x58,0x6b,0xf6,0xec,0x66,0x56,0x35,0xd6, /* ....../.Xk..fV5. */ \
	0x1c,0xaa,0x76,0xef,0xf0,0x12,0xb2,0xde,0xb5,0xd6,0x7b,0x0e,0x13,0x50,0x01,0xc2, /* ..v.......{..P.. */ \
	0xbc,0xa5,0xf6,0xe9,0x74,0xfb,0xcd,0xd5,0x9e,0x77,0xb7,0x37,0xd7,0x7e,0xfe,0xe8, /* ....t....w.7.~.. */ \
	0x19,0x8c,0x05,0xf6,0xff,0x0b,0xa6,0x2b,0xee,0xb4,0xef,0x04,0x00,0x00,0x1f,0x8b, /* .......+........ */ \
	0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xd5,0x57,0x5d,0x6f,0xdb,0x36,0x14,0x7d, /* .........W]o.6.} */ \
	0x56,0x80,0xfc,0x87,0x3b,0x3f,0x2c,0x32,0xe0,0x38,0x4e,0xb1,0xee,0xa1,0x81,0x3b, /* V...;?,2.8N....; */ \
	0xa4,0x49,0xb1,0x66,0x48,0x97,0x20,0x71,0x87,0x02,0xdb,0x1e,0x68,0x89,0x8e,0xd9, /* .I.fH. q....h... */ \
	0xc8,0xa2,0x4a,0x52,0x76,0x8d,0x22,0x3f,0x68,0xff,0x72,0xe7,0x92,0x94,0x2c,0xbb, /* ..JRv."?h.r...,. */ \
	0x69,0x51,0xac,0x7d,0x59,0x02,0x58,0x1f,0xbc,0xf7,0xf0,0xf2,0xdc,0x4f,0x1d,0x1d, /* iQ.}Y.X......O.. */ \
	0xd1,0x99,0xae,0xd6,0x46,0xdd,0xcd,0x1d,0xfd,0x43,0x4f,0x46,0xa3,0x27,0x87,0x4f, /* ....F....COF.'.O */ \
	0x46,0xc7,0x23,0x7a,0xad,0x32,0xa3,0xb3,0xb9,0xaa,0x68,0x22,0xb3,0x79,0xa9,0x0b, /* F.#z.2....h".y.. */ \
	0x7d,0xb7,0xa6,0x8b,0x32,0x1b,0x12,0x9d,0x16,0x05,0x79,0x05,0x4b,0x46,0x5a,0x69, /* }...2.....y.KFZi */ \
	0x96,0x32,0x1f,0xee,0xef,0x1d,0x1d,0xd1,0xad,0x94,0x5d,0xbd,0xb3,0xeb,0xa3,0x8b, /* .2........]..... */ \
	0x6b,0xba,0x75,0x22,0xbb,0xa7,0x5c,0x67,0xf5,0x42,0x96,0x4e,0x38,0xa5,0x4b,0x9a, /* k.u"..\g.B.N8.K. */ \
	0x69,0x43,0x85,0xca,0x64,0x69,0x25,0xa9,0x12,0x4f,0x0b,0xff,0x1e,0x28,0xfc,0x0f, /* iC..di%..O...(.. */ \
	0xa4,0x73,0xe9,0xa4,0x59,0xa8,0x52,0x5a,0x5a,0xcd,0x65,0x49,0x02,0x3b,0xbd,0xaf, /* .s..Y.RZZ.eI.;.. */ \
	0xa5,0x75,0xa4,0x2c,0x65,0xba,0xb4,0x2a,0x97,0x46,0xe6,0xd4,0x73,0x6a,0x81,0x8b, /* .u.,e....F..sj.. */ \
	0xae,0x5d,0x6f,0x7f,0x6f,0x29,0x0c,0xf1,0xf3,0x55,0xed,0x5e,0xdf,0xd2,0x98,0x9e, /* .]o.o)...U.^.... */ \
	0x8e,0x46,0xa3,0x13,0x3a,0x3a,0x5a,0xd8,0xfd,0x3d,0x0a,0x06,0x3a,0x0d,0x8b,0x81, /* .F..::Z..=..:... */ \
	0x06,0xac,0x5a,0x92,0x9e,0xd1,0xe9,0x6f,0xa7,0x6f,0x49,0x2e,0x61,0x99,0x25,0xa7, /* ..Z....o.oI.a.%. */ \
	0xa9,0x82,0xed,0xd2,0xda,0x80,0x25,0xde,0x89,0x0f,0x97,0x0a,0x7b,0x8e,0xa9,0x94, /* ......%.....{... */ \
	0x2b,0x3a,0x35,0x46,0xac,0xd3,0xfe,0x49,0x34,0xf1,0xa2,0x54,0x4e,0x09,0xe7,0xe1, /* +:5F...I4..TN... */ \
	0xfc,0x32,0x23,0x65,0x7a,0xb1,0x10,0x65,0xce,0x02,0x49,0x6d,0x8a,0x67,0xe4,0xe6, /* .2#ez..e..Im.g.. */ \
	0x92,0x70,0xc3,0xd8,0x22,0x0b,0xd0,0x58,0xc2,0x09,0x9c,0xc0,0xe9,0x4c,0x10,0x68, /* .p.."..X.....L.h */ \
	0xc8,0xa1,0x8b,0x73,0x16,0x9c,0xa9,0xa2,0x18,0x10,0x28,0x12,0x34,0xab,0xcb,0xcc, /* ...s......(.4... */ \
	0x33,0x86,0xd7,0x99,0x00,0xef,0x2b,0xe5,0xe6,0xcc,0x7a,0xa5,0x99,0xbb,0xb7,0xaf, /* 3.....+...z..... */ \
	0x2f,0x29,0xd5,0x15,0x4b,0x88,0xa2,0xef,0xa1,0x8d,0xac,0xa4,0x70,0xc0,0x35,0x38, /* /)..K.......p.58 */ \
	0x20,0xb4,0xc2,0x33,0xb6,0x61,0xe2,0x18,0x41,0x95,0xb9,0x9c,0x29,0x18,0x2f,0x8b, /*  ..3.a..A...)./. */ \
	0xf5,0xae,0x72,0x2e,0x9c,0x78,0x46,0xa2,0xa4,0x37,0x37,0x97,0x24,0xcb,0x4c,0xe7, /* ..r..xF..77.$.L. */ \
	0x20,0xd7,0x3a,0xa3,0xca,0x3b,0xc6,0x9a,0x4a,0xb2,0xf5,0x74,0xa1,0x9c,0xc3,0x6b, /*  .:..;..J..t...k */ \
	0x61,0xe9,0xfa,0xea,0x76,0x42,0xac,0xb3,0x85,0xd3,0xda,0x0c,0x56,0x98,0x94,0xb3, /* a...vB......V... */ \
	0xc0,0x49,0x0a,0x1a,0x06,0xd4,0x9e,0x7c,0x10,0x2d,0x1b,0x78,0x00,0xa8,0x7d,0xdc, /* .I.....|.-.x..}. */ \
	0xdf,0x4b,0x7c,0x0c,0x39,0xaa,0x2b,0x78,0xd4,0x90,0x9e,0xbe,0x93,0x99,0xc3,0x6b, /* .K|.9.+x.......k */ \
	0x76,0x06,0x83,0xc1,0x1f,0xd1,0x17,0x57,0x7e,0xc9,0x3b,0xc3,0xaf,0x82,0xc5,0x09, /* v......W~.;..... */ \
	0x3c,0x6f,0xe2,0xf2,0x39,0xfc,0x12,0x16,0xa3,0xda,0x90,0x7d,0x30,0x66,0x4f,0x74, /* <o..9......}0fOt */ \
	0x5f,0xb6,0xc6,0x60,0xa9,0xbd,0xef,0x0a,0x44,0xf2,0xc6,0xd1,0xd6,0xee,0x12,0x07, /* _..`....D....... */ \
	0xc7,0x8d,0x7c,0xcf,0x1b,0xd6,0x85,0x47,0x0d,0xf6,0x9f,0x19,0x08,0x4a,0x70,0x08, /* ..|....G.....Jp. */ \
	0xe2,0x24,0x7e,0xd8,0xbf,0x31,0x76,0x21,0xa0,0x66,0xe9,0x0a,0x0e,0xd0,0xab,0x21, /* .$~..1v!.f.....! */ \
	0x5c,0xf7,0xca,0xb9,0xea,0x26,0x2c,0xf5,0x09,0xc7,0xa7,0xf8,0xf7,0xc8,0x16,0x38, /* \....&,........8 */ \
	0xd3,0xb6,0x82,0x3f,0xdd,0x67,0x14,0x86,0xba,0x92,0x65,0x9a,0x32,0xaf,0xe3,0x31, /* ...?.g....e.2..1 */ \
	0x5b,0xd7,0xff,0xa5,0xf7,0xeb,0xcb,0x49,0xef,0x59,0x8f,0x1d,0xd6,0x1b,0x50,0x87, /* [......I.Y....P. */ \
	0x94,0x81,0x0f,0x94,0x2f,0x81,0xf1,0x29,0x3c,0x56,0x23,0xc4,0xb1,0x3f,0xa3,0x95, /* ..../..)<V#..?.. */ \
	0x3c,0x30,0x08,0x6d,0xcb,0xa1,0x71,0xf1,0xf2,0x67,0x44,0xc9,0xba,0x90,0x94,0x2e, /* <0.m..q..gD..... */ \
	0xc4,0x1a,0x51,0xf2,0x74,0xf8,0x94,0x53,0xa1,0x42,0x56,0x4f,0x0b,0x0e,0x43,0xdd, /* ..Q.t..S.BVO..C. */ \
	0x0f,0xba,0x0f,0x24,0x0b,0xce,0xf9,0x96,0x86,0x53,0x84,0xca,0x52,0xbe,0x0d,0xfe, /* ...$.....S..R... */ \
	0xfc,0x0a,0x16,0xb6,0xe4,0xd3,0x9e,0xaf,0x36,0x56,0xcf,0x9c,0xe7,0x73,0x32,0xb9, /* ........6V...s2. */ \
	0xee,0x75,0x8f,0x82,0x6d,0x76,0x50,0xb6,0x76,0xf8,0xee,0xd4,0x7d,0x15,0x7d,0x9e, /* .u..mvP.v...}.}. */ \
	0x86,0xc8,0x46,0xb8,0x84,0xdf,0x46,0xb1,0x10,0xd6,0x9d,0x21,0x51,0x91,0x62,0xe3, /* ..F...F....!Q.b. */ \
	0x36,0xae,0x87,0x77,0xd2,0xf1,0x4d,0xeb,0xf6,0xd6,0x15,0xbe,0xa4,0x21,0xa9,0x7d, /* 6..w..M......!.} */ \
	0xc6,0x08,0x2e,0x51,0x61,0xa9,0x29,0x5e,0xc3,0xaa,0xb6,0xf3,0x86,0x06,0xd6,0x7e, /* ...Qa.)^.......~ */ \
	0x88,0xf5,0xeb,0x52,0xeb,0xca,0x92,0x5e,0x22,0xfa,0xb9,0x2c,0xe0,0xdc,0x39,0xfb, /* ...R...^"..,..9. */ \
	0x72,0xa7,0x20,0xe6,0x4d,0x21,0x06,0x99,0x08,0xea,0x35,0xaa,0x98,0xcf,0x6d,0x65, /* r. .M!....5...me */ \
	0x7d,0x54,0x2b,0x14,0xe1,0x4e,0xc6,0x57,0xba,0x28,0x18,0x20,0x05,0xcf,0x49,0x4c, /* }T+..N.W.(. ..IL */ \
	0xcd,0xac,0x36,0xff,0x25,0x71,0x79,0x51,0x16,0xa2,0xb2,0x32,0xdf,0x24,0xd7,0x8d, /* ..6.%qyQ...2.$.. */ \
	0x14,0x28,0xf6,0xb3,0x99,0xcf,0xaa,0xb6,0x3c,0x87,0x3a,0x81,0xb3,0xc0,0xca,0xe9, /* .(......<.:..... */ \
	0x9a,0x2f,0x90,0x46,0x53,0x49,0x15,0x50,0x5b,0x1e,0x0a,0x59,0xde,0xb9,0xf9,0x09, /* ./.FSI.P[..Y.... */ \
	0x29,0x7a,0x4e,0x68,0x0b,0xea,0xf0,0x10,0x31,0x99,0x70,0xd5,0x49,0x36,0x26,0xb6, /* )zNh....1.p.I6&. */ \
	0xd2,0x76,0xae,0x66,0xd1,0x4c,0x4e,0xda,0x1f,0xa2,0x08,0xab,0x24,0xbe,0x7c,0xab, /* .v.f.LN.....$.|. */ \
	0xb2,0x96,0x7e,0x35,0x1a,0xf9,0xa8,0xb3,0xe8,0xb0,0x39,0x7e,0xc7,0xad,0x5e,0x2b, /* ..~5......9~..^+ */ \
	0xe1,0x13,0x25,0x4d,0x2a,0xa1,0xac,0x66,0x52,0xe6,0xcc,0xa5,0xdf,0xae,0x51,0x6a, /* ..%M...fR.....Qj */ \
	0x82,0x08,0x35,0x25,0x5f,0xa3,0x91,0xa2,0xb0,0x8c,0xc7,0xf4,0x13,0xfd,0xf8,0x23, /* ..5%_..........# */ \
	0xed,0x8a,0x58,0xac,0xd6,0x96,0x97,0xd1,0xc3,0x7d,0x98,0x27,0x0d,0xbe,0x72,0x34, /* ..X......}.'..r4 */ \
	0x17,0xdc,0xa6,0x3a,0xc5,0x77,0x65,0xd0,0x00,0x62,0x71,0xb2,0x75,0xe1,0xbc,0x38, /* ...:.we..bq.u..8 */ \
	0x76,0x76,0xeb,0x4a,0xea,0x8d,0x01,0xad,0x46,0x9f,0x91,0x0f,0x1a,0x47,0x1f,0xf4, /* vv.J....F....G.. */ \
	0x03,0x7e,0xf2,0x89,0xdc,0x23,0xa6,0x87,0x5e,0x85,0xfc,0x1c,0x36,0x7d,0xee,0x65, /* .~...#..^...6}.e */ \
	0x21,0xf9,0x12,0xd8,0x4d,0x36,0x35,0xe1,0xcb,0x9b,0x87,0x3e,0x74,0xd0,0x9c,0x2d, /* !...M65....>t..- */ \
	0x69,0xd0,0x98,0xee,0x88,0xf8,0x62,0x7d,0x91,0x3f,0xa2,0x3e,0x54,0x25,0x2e,0xaf, /* i.....b}.?.>T%.. */ \
	0x26,0xe8,0x96,0xe3,0x4f,0x88,0x6b,0x0c,0x9c,0xc8,0x0f,0xae,0x31,0x08,0xbc,0xa5, /* &...O.k.....1... */ \
	0x1a,0xe4,0x98,0x95,0xb2,0xdc,0x9e,0xa9,0xc4,0x13,0x67,0x07,0x0f,0x2e,0x5c,0x16, /* ..........g...\. */ \
	0x68,0x29,0x0a,0x94,0xe1,0x10,0x0e,0xf8,0xe1,0x8c,0x4b,0x76,0x91,0xc5,0x54,0x9b, /* h)........Kv..T. */ \
	0x18,0x43,0x8f,0xad,0x6f,0x5a,0xc7,0x96,0xaf,0x0e,0xac,0x9f,0x76,0xb8,0xdf,0x08, /* .C..oZ......v... */ \
	0x2e,0x9e,0xb1,0x79,0x0c,0xd8,0x59,0x25,0xdb,0x62,0x75,0xe3,0xac,0x06,0x30,0x48, /* ...y..Y%.bu...0H */ \
	0x07,0x63,0x92,0x9d,0xae,0xdb,0xc8,0x84,0xee,0xbb,0x4b,0xcd,0xe6,0x55,0xc4,0x38, /* .c........K..U.8 */ \
	0xf9,0x34,0xc0,0x1f,0xf8,0xa7,0x1b,0xad,0x07,0x4b,0x49,0x2b,0xa1,0x78,0x08,0xf0, /* .4.......KI+.x.. */ \
	0xe5,0xe3,0x18,0x9d,0x0e,0x1a,0x79,0x34,0x11,0xe1,0xdc,0x4e,0x65,0x31,0x9e,0x9b, /* ......y4...Ne1.. */ \
	0x1c,0x79,0xbe,0x99,0xcf,0xba,0x21,0x5a,0x2e,0xf5,0x7d,0x08,0xc6,0x1a,0xe3,0xe4, /* .y....!Z..}..... */ \
	0x66,0xe8,0xf1,0xc3,0x8e,0xa7,0x5b,0x95,0x55,0xfd,0xfd,0x62,0xd4,0x17,0xf6,0xad, /* f.....[.U..b.... */ \
	0xe0,0x8b,0xa2,0x30,0xe6,0xb4,0x90,0xc6,0xb5,0xb6,0x84,0xd7,0x82,0xdf,0xa5,0xbd, /* ...0............ */ \
	0x48,0x29,0xcd,0x84,0x42,0x1a,0x0f,0xff,0x2a,0xcf,0x34,0xe2,0xaa,0x9d,0xcf,0x72, /* H)..B.....4....r */ \
	0x54,0xcd,0x42,0x57,0x7e,0x90,0x9b,0x6a,0x61,0x72,0x90,0x64,0xa9,0xd0,0xa8,0x26, /* T.BW~..jar.d...& */ \
	0xbd,0x66,0x37,0xef,0xeb,0x6f,0x0b,0x96,0x58,0x3a,0xfe,0x1f,0xf1,0x72,0xd5,0x24, /* .f7..o..X:...r.$ */ \
	0xd1,0x80,0xde,0xd5,0x28,0xd5,0xf7,0x52,0x56,0x3e,0x76,0x90,0x4c,0x2c,0xb2,0xdd, /* ....(..RV>v.L,.. */ \
	0xa5,0x9a,0x22,0xcb,0x30,0x0f,0x9b,0x89,0x8a,0xdb,0x13,0xba,0x9b,0x95,0xc5,0x92, /* ..".0........... */ \
	0xa7,0xed,0x3b,0x58,0xc2,0x0d,0xef,0x78,0xc4,0x83,0x7d,0x62,0x43,0xb1,0x45,0xb0, /* ..;X...x..}bC.E. */ \
	0xa5,0xbd,0x4d,0xff,0xe9,0x0d,0x8e,0x47,0xfd,0xd0,0x38,0x1e,0x22,0x67,0x80,0xba, /* ..M....G..8."g.. */ \
	0x16,0x40,0xb1,0xde,0xbb,0x1f,0x16,0xc5,0x4d,0x33,0x46,0x1b,0xe9,0x6a,0x53,0x22, /* .@......M3F..jS" */ \
	0x3e,0xd1,0x3d,0x30,0xfc,0xc6,0x51,0x22,0x4e,0x5a,0xed,0x18,0x8a,0xf9,0x18,0x4a, /* >.=0..Q"NZ.....J */ \
	0xe7,0x7e,0x44,0x8e,0x08,0xfc,0xd0,0x6a,0xfb,0x1d,0x30,0xbc,0xcb,0x22,0x0f,0x02, /* .~D....j..0..".. */ \
	0xfe,0x96,0x23,0xc3,0x4a,0x61,0xb2,0x39,0x17,0x8f,0x4e,0xaf,0x44,0xd5,0xc2,0x46, /* ..#.Ja.9..N.D..F */ \
	0x7f,0x70,0x1d,0x49,0x23,0xd4,0x20,0xa8,0x84,0xd4,0x70,0x66,0x1d,0xc2,0x12,0x8e, /* .p.I#. ...pf.... */ \
	0x8b,0xeb,0x9d,0x4a,0x67,0x5f,0xac,0x27,0xe2,0xee,0x77,0x81,0x2e,0x13,0x74,0xfe, /* ...Jg_.'..w...t. */ \
	0x1c,0xfd,0x3d,0x9c,0x29,0x83,0x26,0x33,0x57,0x45,0x3e,0x2c,0x31,0xba,0x7b,0xec, /* ..=.).&3WE>,1.{. */ \
	0xe0,0xe5,0x60,0x23,0x7d,0x03,0x4e,0xec,0x75,0x56,0x76,0xf1,0x9a,0x90,0x7c,0xc0, /* ..`#}.N.uVv...|. */ \
	0xa7,0x85,0xcb,0xe6,0xa9,0x34,0x48,0xc2,0x8f,0xd4,0x5d,0xe5,0x21,0x27,0x8e,0x1c, /* .....4H...].!'.. */ \
	0xf7,0x0a,0x1f,0x82,0x4d,0xf7,0xf6,0x73,0xc6,0x9b,0x0a,0x93,0x11,0x67,0xd9,0xe7, /* ....M..s.....g.. */ \
	0x9c,0x88,0x4f,0xb8,0xf0,0xc1,0xf5,0x2f,0xde,0xe8,0x9b,0x2d,0xa8,0x0e,0x00,0x00, /* ..O..../...-.... */ \
	0x2b,0x10,0x06,0x10,0x01,0x10,0x02,0x18,0x6a,0x00,0x01,0x10,0x01,0x10,0x01,0x0a, /* +.......j....... */ \
	0x25,0x00,0x03,0x11,0x4d,0x69,0x63,0x72,0x6f,0x63,0x68,0x69,0x70,0x20,0x48,0x61, /* %...Microchip Ha */ \
	0x72,0x6d,0x6f,0x6e,0x79,0x02,0xca,0x01,0xff,0x36,0x00,0x09,0x09,0x2b,0x06,0x01, /* rmony....6...+.. */ \
	0x04,0x01,0x81,0x85,0x47,0x01,0x03,0x88,0x01,0xfa,0x3d,0x00,0x07,0x04,0x0a,0x48, /* ....G.....=....H */ \
	0x00,0x03,0x05,0x61,0x64,0x6d,0x69,0x6e,0x05,0x0a,0x57,0x00,0x03,0x09,0x4d,0x69, /* ...admin..W...Mi */ \
	0x63,0x72,0x6f,0x63,0x68,0x69,0x70,0x06,0x0a,0x63,0x00,0x03,0x06,0x6f,0x66,0x66, /* crochip..c...off */ \
	0x69,0x63,0x65,0x07,0x03,0x7c,0x00,0x00,0x01,0x07,0x04,0x18,0xdc,0x01,0x01,0x10, /* ice..|.......... */ \
	0x81,0x10,0x85,0x10,0x47,0x10,0x01,0x10,0x00,0x18,0x84,0x00,0x01,0x81,0x02,0x01, /* ....G........... */ \
	0xf4,0x88,0x00,0x00,0x01,0x18,0xb5,0x00,0x01,0x0a,0x99,0x00,0x03,0x0b,0x53,0x4e, /* ..............SN */ \
	0x4d,0x50,0x76,0x33,0x41,0x67,0x65,0x6e,0x74,0x02,0x0a,0xa4,0x00,0x03,0x05,0x76, /* MPv3Agent......v */ \
	0x37,0x2e,0x32,0x31,0x03,0x03,0xbf,0x00,0x03,0x0b,0x41,0x75,0x67,0x20,0x32,0x31, /* 7.21......Aug 21 */ \
	0x20,0x32,0x30,0x31,0x34,0x02,0x18,0x23,0x01,0x01,0x18,0xef,0x00,0x01,0x10,0x01, /*  2014..#........ */ \
	0xac,0x01,0x01,0xcb,0x00,0x00,0x01,0x01,0x01,0x01,0x00,0x02,0xac,0x01,0x02,0xd7, /* ................ */ \
	0x00,0x00,0x01,0x01,0x01,0x01,0x00,0x03,0xac,0x01,0x03,0xe3,0x00,0x05,0x01,0x01, /* ................ */ \
	0x01,0x01,0x00,0x04,0xa5,0x01,0x04,0xf3,0x00,0x04,0x01,0x01,0x01,0x01,0x00,0x02, /* ................ */ \
	0x10,0x01,0x10,0x01,0xac,0x01,0x1f,0xff,0x00,0x00,0x01,0x01,0x01,0x1f,0x00,0x02, /* ................ */ \
	0xac,0x01,0x20,0x0b,0x01,0x00,0x01,0x01,0x01,0x1f,0x00,0x03,0xac,0x01,0x21,0x17, /* .. ...........!. */ \
	0x01,0x03,0x01,0x01,0x01,0x1f,0x00,0x04,0xa5,0x01,0x22,0x27,0x01,0x04,0x01,0x01, /* .........."'.... */ \
	0x01,0x1f,0x00,0x03,0x18,0x4a,0x01,0x01,0xa8,0x01,0x05,0x2e,0x01,0x00,0x02,0xa8, /* .....J.......... */ \
	0x01,0x06,0x35,0x01,0x00,0x03,0x88,0x01,0x07,0x3c,0x01,0x00,0x04,0x88,0x01,0x08, /* ..5......<...... */ \
	0x43,0x01,0x01,0x06,0xa1,0x01,0x0a,0x52,0x01,0x04,0x04,0x18,0x9a,0x01,0x01,0x10, /* C......R........ */ \
	0x01,0x10,0x01,0x8c,0x01,0x0b,0x5e,0x01,0x00,0x01,0x01,0x01,0x0b,0x00,0x02,0xac, /* ......^......... */ \
	0x01,0x0c,0x6a,0x01,0x04,0x01,0x01,0x01,0x0b,0x00,0x03,0xac,0x01,0x0d,0x76,0x01, /* ..j...........v. */ \
	0x00,0x01,0x01,0x01,0x0b,0x00,0x04,0xac,0x01,0x0e,0x82,0x01,0x04,0x01,0x01,0x01, /* ................ */ \
	0x0b,0x00,0x05,0xac,0x01,0x0f,0x8e,0x01,0x00,0x01,0x01,0x01,0x0b,0x00,0x06,0xa5, /* ................ */ \
	0x01,0x10,0xa0,0x01,0x04,0x01,0x01,0x01,0x0b,0x00,0x05,0x10,0x01,0x10,0x01,0x10, /* ................ */ \
	0x01,0x8c,0x01,0x11,0xac,0x01,0x00,0x01,0x01,0x01,0x11,0x00,0x02,0xac,0x01,0x12, /* ................ */ \
	0xb8,0x01,0x00,0x01,0x01,0x01,0x11,0x00,0x03,0xac,0x01,0x13,0xc4,0x01,0x00,0x01, /* ................ */ \
	0x01,0x01,0x11,0x00,0x04,0xac,0x01,0x14,0xd0,0x01,0x04,0x01,0x01,0x01,0x11,0x00, /* ................ */ \
	0x05,0xa5,0x01,0x15,0xe6,0x01,0x00,0x01,0x01,0x01,0x11,0x00,0x06,0x10,0x03,0x10, /* ................ */ \
	0x0a,0x10,0x02,0x10,0x01,0x10,0x01,0x88,0x01,0xf9,0xed,0x01,0x04,0x02,0x88,0x01, /* ................ */ \
	0xf8,0xf4,0x01,0x02,0x03,0x88,0x01,0xf7,0xfb,0x01,0x02,0x04,0x80,0x01,0xf6,0x01, /* ................ */ \
	0x3c,0x72,0x65,0x73,0x70,0x6f,0x6e,0x73,0x65,0x3e,0x0d,0x0a,0x3c,0x6c,0x65,0x64, /* <response>..<led */ \
	0x30,0x3e,0x7e,0x6c,0x65,0x64,0x28,0x30,0x29,0x7e,0x3c,0x2f,0x6c,0x65,0x64,0x30, /* 0>~led(0)~</led0 */ \
	0x3e,0x0d,0x0a,0x3c,0x6c,0x65,0x64,0x31,0x3e,0x7e,0x6c,0x65,0x64,0x28,0x31,0x29, /* >..<led1>~led(1) */ \
	0x7e,0x3c,0x2f,0x6c,0x65,0x64,0x31,0x3e,0x0d,0x0a,0x3c,0x6c,0x65,0x64,0x32,0x3e, /* ~</led1>..<led2> */ \
	0x7e,0x6c,0x65,0x64,0x28,0x32,0x29,0x7e,0x3c,0x2f,0x6c,0x65,0x64,0x32,0x3e,0x0d, /* ~led(2)~</led2>. */ \
	0x0a,0x3c,0x62,0x74,0x6e,0x30,0x3e,0x7e,0x62,0x74,0x6e,0x28,0x30,0x29,0x7e,0x3c, /* .<btn0>~btn(0)~< */ \
	0x2f,0x62,0x74,0x6e,0x30,0x3e,0x0d,0x0a,0x3c,0x62,0x74,0x6e,0x31,0x3e,0x7e,0x62, /* /btn0>..<btn1>~b */ \
	0x74,0x6e,0x28,0x31,0x29,0x7e,0x3c,0x2f,0x62,0x74,0x6e,0x31,0x3e,0x0d,0x0a,0x3c, /* tn(1)~</btn1>..< */ \
	0x62,0x74,0x6e,0x32,0x3e,0x7e,0x62,0x74,0x6e,0x28,0x32,0x29,0x7e,0x3c,0x2f,0x62, /* btn2>~btn(2)~</b */ \
	0x74,0x6e,0x32,0x3e,0x0d,0x0a,0x3c,0x70,0x6f,0x74,0x30,0x3e,0x7e,0x70,0x6f,0x74, /* tn2>..<pot0>~pot */ \
	0x7e,0x3c,0x2f,0x70,0x6f,0x74,0x30,0x3e,0x0d,0x0a,0x3c,0x2f,0x72,0x65,0x73,0x70, /* ~</pot0>..</resp */ \
	0x6f,0x6e,0x73,0x65,0x3e,0x0d,0x0a,0x1f,0x8b,0x08,0x00,0x00,0x00,0x00,0x00,0x00, /* onse>........... */ \
	0x00,0x3d,0x8d,0x41,0x6b,0x03,0x21,0x10,0x85,0xef,0x82,0xff,0x21,0xe7,0x1c,0xb2, /* .=.Ak.!.....!... */ \
	0x6b,0xb6,0xd0,0xb2,0x21,0x87,0x10,0x7a,0x6c,0x7b,0x08,0x14,0x0a,0xc2,0xa2,0x5b, /* k...!..zl{.....[ */ \
	0x77,0xd7,0x10,0xcd,0xe0,0x18,0xb3,0xfd,0xf7,0x75,0xdc,0xb4,0x88,0xdf,0x1b,0x1f, /* w........u...... */ \
	0xf3,0x9e,0xd1,0x38,0xe0,0xec,0xd3,0x04,0xb4,0x57,0xbf,0x6f,0x38,0x3b,0xb6,0x72, /* ...8.....W.o8;.r */ \
	0x52,0xc1,0x5d,0xfd,0x8f,0xd4,0x41,0xf9,0x7e,0x92,0xa9,0x7b,0xae,0xb5,0x54,0x00, /* R.]...A.~..{..T. */ \
	0x28,0x63,0x0f,0x16,0xe4,0xdd,0xe8,0x0e,0x4d,0x48,0x26,0x74,0x3e,0xb9,0xce,0xc1, /* (c......MH&t>... */ \
	0x80,0xc5,0x03,0x35,0x1a,0xdc,0x72,0x36,0xc5,0x08,0x6d,0x55,0x71,0x46,0x47,0x88, /* ...5..r6..mUqFG. */ \
	0xea,0xa9,0xda,0xd6,0xa2,0x59,0x89,0xba,0x6d,0x5e,0x5a,0x51,0xaf,0x0e,0x6f,0x9c, /* .....Y..m^ZQ..o. */ \
	0xbd,0x7f,0x2c,0xf7,0xeb,0xf5,0xf4,0xc0,0x7a,0x33,0x45,0x77,0xd9,0x15,0xc9,0x4c, /* ..,.....z3Ew...L */ \
	0x7f,0x24,0x4b,0x21,0x64,0xf6,0x88,0x99,0xf8,0x58,0x83,0x7f,0x85,0x85,0x4d,0x96, /* .$K!d....X....M. */ \
	0xb9,0x58,0x33,0x12,0xfb,0xc1,0x2d,0xa4,0x47,0x9c,0x23,0x6d,0x15,0x7f,0xb4,0x54, /* .X3...-.G.#m...T */ \
	0xe3,0x29,0x76,0xa6,0xc6,0xa4,0x0b,0x68,0xd4,0x0a,0xd7,0x1b,0x67,0xbf,0xf3,0x78, /* .)v....h....g..x */ \
	0x57,0x89,0x7e,0xbe,0x65,0x04,0x55,0x40,0x75,0xda,0x51,0x6c,0xb4,0x03,0x85,0x61, /* W.~.e.U@u.Ql...a */ \
	0x2c,0x34,0x24,0xe0,0x89,0x66,0x36,0x3b,0xce,0x7e,0x01,0x2a,0x48,0x3b,0x38,0x55, /* ,4$..f6;.~..H;8U */ \
	0x01,0x00,0x00,0x7e,0x69,0x6e,0x63,0x3a,0x68,0x65,0x61,0x64,0x65,0x72,0x2e,0x69, /* ...~inc:header.i */ \
	0x6e,0x63,0x7e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x69,0x64,0x3d,0x22,0x63,0x6f, /* nc~..<div id="co */ \
	0x6e,0x74,0x65,0x6e,0x74,0x22,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x68,0x31,0x3e,0x46, /* ntent">....<h1>F */ \
	0x69,0x6c,0x65,0x20,0x55,0x70,0x6c,0x6f,0x61,0x64,0x73,0x3c,0x2f,0x68,0x31,0x3e, /* ile Uploads</h1> */ \
	0x0d,0x0a,0x0d,0x0a,0x3c,0x70,0x3e,0x54,0x68,0x65,0x20,0x48,0x54,0x54,0x50,0x20, /* ....<p>The HTTP  */ \
	0x73,0x65,0x72,0x76,0x65,0x72,0x20,0x63,0x61,0x6e,0x20,0x61,0x63,0x63,0x65,0x70, /* server can accep */ \
	0x74,0x20,0x66,0x69,0x6c,0x65,0x20,0x75,0x70,0x6c,0x6f,0x61,0x64,0x73,0x20,0x76, /* t file uploads v */ \
	0x69,0x61,0x20,0x50,0x4f,0x53,0x54,0x2e,0x20,0x20,0x54,0x68,0x69,0x73,0x20,0x63, /* ia POST.  This c */ \
	0x61,0x6e,0x20,0x62,0x65,0x20,0x75,0x73,0x65,0x64,0x20,0x66,0x6f,0x72,0x0d,0x0a, /* an be used for.. */ \
	0x6d,0x61,0x6e,0x79,0x20,0x61,0x70,0x70,0x6c,0x69,0x63,0x61,0x74,0x69,0x6f,0x6e, /* many application */ \
	0x73,0x20,0x73,0x75,0x63,0x68,0x20,0x61,0x73,0x20,0x61,0x6c,0x6c,0x6f,0x77,0x69, /* s such as allowi */ \
	0x6e,0x67,0x20,0x75,0x73,0x65,0x72,0x73,0x20,0x74,0x6f,0x20,0x75,0x70,0x6c,0x6f, /* ng users to uplo */ \
	0x61,0x64,0x20,0x63,0x6f,0x6e,0x66,0x69,0x67,0x75,0x72,0x61,0x74,0x69,0x6f,0x6e, /* ad configuration */ \
	0x20,0x73,0x65,0x74,0x74,0x69,0x6e,0x67,0x73,0x20,0x66,0x69,0x6c,0x65,0x73,0x2e, /*  settings files. */ \
	0x0d,0x0a,0x45,0x61,0x63,0x68,0x20,0x61,0x70,0x70,0x6c,0x69,0x63,0x61,0x74,0x69, /* ..Each applicati */ \
	0x6f,0x6e,0x20,0x6d,0x75,0x73,0x74,0x20,0x69,0x6d,0x70,0x6c,0x65,0x6d,0x65,0x6e, /* on must implemen */ \
	0x74,0x20,0x69,0x74,0x73,0x20,0x6f,0x77,0x6e,0x20,0x66,0x69,0x6c,0x65,0x20,0x70, /* t its own file p */ \
	0x72,0x6f,0x63,0x65,0x73,0x73,0x6f,0x72,0x2e,0x20,0x20,0x54,0x68,0x69,0x73,0x20, /* rocessor.  This  */ \
	0x65,0x78,0x61,0x6d,0x70,0x6c,0x65,0x0d,0x0a,0x63,0x61,0x6c,0x63,0x75,0x6c,0x61, /* example..calcula */ \
	0x74,0x65,0x73,0x20,0x74,0x68,0x65,0x20,0x4d,0x44,0x35,0x20,0x68,0x61,0x73,0x68, /* tes the MD5 hash */ \
	0x20,0x6f,0x66,0x20,0x61,0x20,0x66,0x69,0x6c,0x65,0x2e,0x3c,0x2f,0x70,0x3e,0x0d, /*  of a file.</p>. */ \
	0x0a,0x0d,0x0a,0x3c,0x66,0x6f,0x72,0x6d,0x20,0x61,0x63,0x74,0x69,0x6f,0x6e,0x3d, /* ...<form action= */ \
	0x22,0x75,0x70,0x6c,0x6f,0x61,0x64,0x2e,0x68,0x74,0x6d,0x22,0x20,0x6d,0x65,0x74, /* "upload.htm" met */ \
	0x68,0x6f,0x64,0x3d,0x22,0x70,0x6f,0x73,0x74,0x22,0x20,0x65,0x6e,0x63,0x74,0x79, /* hod="post" encty */ \
	0x70,0x65,0x3d,0x22,0x6d,0x75,0x6c,0x74,0x69,0x70,0x61,0x72,0x74,0x2f,0x66,0x6f, /* pe="multipart/fo */ \
	0x72,0x6d,0x2d,0x64,0x61,0x74,0x61,0x22,0x3e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20, /* rm-data">..<div  */ \
	0x63,0x6c,0x61,0x73,0x73,0x3d,0x22,0x65,0x78,0x61,0x6d,0x70,0x6c,0x65,0x62,0x6f, /* class="examplebo */ \
	0x78,0x22,0x3e,0x0d,0x0a,0x7e,0x75,0x70,0x6c,0x6f,0x61,0x64,0x65,0x64,0x6d,0x64, /* x">..~uploadedmd */ \
	0x35,0x7e,0x0d,0x0a,0x3c,0x70,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x22,0x6d,0x61, /* 5~..<p style="ma */ \
	0x72,0x67,0x69,0x6e,0x2d,0x62,0x6f,0x74,0x74,0x6f,0x6d,0x3a,0x20,0x32,0x70,0x78, /* rgin-bottom: 2px */ \
	0x22,0x3e,0x3c,0x62,0x3e,0x46,0x69,0x6c,0x65,0x3a,0x20,0x3c,0x2f,0x62,0x3e,0x26, /* "><b>File: </b>& */ \
	0x6e,0x62,0x73,0x70,0x3b,0x0d,0x0a,0x3c,0x69,0x6e,0x70,0x75,0x74,0x20,0x74,0x79, /* nbsp;..<input ty */ \
	0x70,0x65,0x3d,0x22,0x66,0x69,0x6c,0x65,0x22,0x20,0x6e,0x61,0x6d,0x65,0x3d,0x22, /* pe="file" name=" */ \
	0x6d,0x64,0x35,0x66,0x69,0x6c,0x65,0x22,0x20,0x73,0x69,0x7a,0x65,0x3d,0x22,0x33, /* md5file" size="3 */ \
	0x30,0x22,0x20,0x2f,0x3e,0x20,0x26,0x6e,0x62,0x73,0x70,0x3b,0x0d,0x0a,0x3c,0x69, /* 0" /> &nbsp;..<i */ \
	0x6e,0x70,0x75,0x74,0x20,0x74,0x79,0x70,0x65,0x3d,0x22,0x73,0x75,0x62,0x6d,0x69, /* nput type="submi */ \
	0x74,0x22,0x20,0x76,0x61,0x6c,0x75,0x65,0x3d,0x22,0x47,0x65,0x74,0x20,0x4d,0x44, /* t" value="Get MD */ \
	0x35,0x22,0x20,0x2f,0x3e,0x0d,0x0a,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x3c,0x2f,0x64, /* 5" />..</p>..</d */ \
	0x69,0x76,0x3e,0x0d,0x0a,0x3c,0x2f,0x66,0x6f,0x72,0x6d,0x3e,0x0d,0x0a,0x0d,0x0a, /* iv>..</form>.... */ \
	0x3c,0x70,0x3e,0x54,0x68,0x69,0x73,0x20,0x69,0x73,0x20,0x61,0x6e,0x20,0x61,0x64, /* <p>This is an ad */ \
	0x76,0x61,0x6e,0x63,0x65,0x64,0x20,0x66,0x65,0x61,0x74,0x75,0x72,0x65,0x2e,0x20, /* vanced feature.  */ \
	0x20,0x46,0x6f,0x72,0x20,0x6d,0x6f,0x72,0x65,0x20,0x69,0x6e,0x66,0x6f,0x72,0x6d, /*  For more inform */ \
	0x61,0x74,0x69,0x6f,0x6e,0x2c,0x20,0x70,0x6c,0x65,0x61,0x73,0x65,0x20,0x72,0x65, /* ation, please re */ \
	0x66,0x65,0x72,0x20,0x74,0x6f,0x20,0x74,0x68,0x65,0x0d,0x0a,0x69,0x6d,0x70,0x6c, /* fer to the..impl */ \
	0x65,0x6d,0x65,0x6e,0x74,0x61,0x74,0x69,0x6f,0x6e,0x20,0x69,0x6e,0x20,0x3c,0x63, /* ementation in <c */ \
	0x6f,0x64,0x65,0x3e,0x63,0x75,0x73,0x74,0x6f,0x6d,0x5f,0x68,0x74,0x74,0x70,0x5f, /* ode>custom_http_ */ \
	0x61,0x70,0x70,0x2e,0x63,0x3c,0x2f,0x63,0x6f,0x64,0x65,0x3e,0x20,0x66,0x6f,0x72, /* app.c</code> for */ \
	0x20,0x63,0x6f,0x6d,0x6d,0x65,0x6e,0x74,0x73,0x20,0x61,0x6e,0x64,0x20,0x65,0x78, /*  comments and ex */ \
	0x70,0x6c,0x61,0x69,0x6e,0x61,0x74,0x69,0x6f,0x6e,0x2e,0x3c,0x2f,0x70,0x3e,0x0d, /* plaination.</p>. */ \
	0x0a,0x0d,0x0a,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x73,0x63, /* ...</div>....<sc */ \
	0x72,0x69,0x70,0x74,0x20,0x74,0x79,0x70,0x65,0x3d,0x22,0x74,0x65,0x78,0x74,0x2f, /* ript type="text/ */ \
	0x6a,0x61,0x76,0x61,0x73,0x63,0x72,0x69,0x70,0x74,0x22,0x3e,0x0d,0x0a,0x3c,0x21, /* javascript">..<! */ \
	0x2d,0x2d,0x0d,0x0a,0x64,0x6f,0x63,0x75,0x6d,0x65,0x6e,0x74,0x2e,0x67,0x65,0x74, /* --..document.get */ \
	0x45,0x6c,0x65,0x6d,0x65,0x6e,0x74,0x42,0x79,0x49,0x64,0x28,0x27,0x68,0x65,0x6c, /* ElementById('hel */ \
	0x6c,0x6f,0x27,0x29,0x2e,0x69,0x6e,0x6e,0x65,0x72,0x48,0x54,0x4d,0x4c,0x20,0x3d, /* lo').innerHTML = */ \
	0x20,0x22,0x7e,0x68,0x65,0x6c,0x6c,0x6f,0x6d,0x73,0x67,0x7e,0x22,0x3b,0x0d,0x0a, /*  "~hellomsg~";.. */ \
	0x2d,0x2d,0x3e,0x0d,0x0a,0x3c,0x2f,0x73,0x63,0x72,0x69,0x70,0x74,0x3e,0x0d,0x0a, /* -->..</script>.. */ \
	0x7e,0x69,0x6e,0x63,0x3a,0x66,0x6f,0x6f,0x74,0x65,0x72,0x2e,0x69,0x6e,0x63,0x7e, /* ~inc:footer.inc~ */ \
	0x0d,0x0a,0x7e,0x69,0x6e,0x63,0x3a,0x68,0x65,0x61,0x64,0x65,0x72,0x2e,0x69,0x6e, /* ..~inc:header.in */ \
	0x63,0x7e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x69,0x64,0x3d,0x22,0x63,0x6f,0x6e, /* c~..<div id="con */ \
	0x74,0x65,0x6e,0x74,0x22,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x68,0x31,0x3e,0x53,0x4e, /* tent">....<h1>SN */ \
	0x4d,0x50,0x20,0x43,0x6f,0x6d,0x6d,0x75,0x6e,0x69,0x74,0x79,0x20,0x43,0x6f,0x6e, /* MP Community Con */ \
	0x66,0x69,0x67,0x75,0x72,0x61,0x74,0x69,0x6f,0x6e,0x3c,0x2f,0x68,0x31,0x3e,0x0d, /* figuration</h1>. */ \
	0x0a,0x3c,0x70,0x3e,0x52,0x65,0x61,0x64,0x2f,0x57,0x72,0x69,0x74,0x65,0x20,0x43, /* .<p>Read/Write C */ \
	0x6f,0x6d,0x6d,0x75,0x6e,0x69,0x74,0x79,0x20,0x53,0x74,0x72,0x69,0x6e,0x67,0x20, /* ommunity String  */ \
	0x63,0x6f,0x6e,0x66,0x69,0x67,0x75,0x72,0x61,0x74,0x69,0x6f,0x6e,0x20,0x66,0x6f, /* configuration fo */ \
	0x72,0x20,0x53,0x4e,0x4d,0x50,0x76,0x32,0x63,0x20,0x41,0x67,0x65,0x6e,0x74,0x2e, /* r SNMPv2c Agent. */ \
	0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x63,0x6c,0x61,0x73,0x73, /* </p>..<div class */ \
	0x3d,0x22,0x72,0x65,0x73,0x75,0x6c,0x74,0x20,0x66,0x61,0x69,0x6c,0x22,0x20,0x73, /* ="result fail" s */ \
	0x74,0x79,0x6c,0x65,0x3d,0x22,0x64,0x69,0x73,0x70,0x6c,0x61,0x79,0x3a,0x7e,0x73, /* tyle="display:~s */ \
	0x6e,0x6d,0x70,0x5f,0x65,0x6e,0x7e,0x22,0x3e,0x0d,0x0a,0x53,0x54,0x41,0x43,0x4b, /* nmp_en~">..STACK */ \
	0x5f,0x55,0x53,0x45,0x5f,0x53,0x4e,0x4d,0x50,0x5f,0x53,0x45,0x52,0x56,0x45,0x52, /* _USE_SNMP_SERVER */ \
	0x20,0x69,0x73,0x20,0x75,0x6e,0x64,0x65,0x66,0x69,0x6e,0x65,0x64,0x2e,0x20,0x20, /*  is undefined.   */ \
	0x53,0x4e,0x4d,0x50,0x20,0x69,0x73,0x20,0x75,0x6e,0x61,0x76,0x61,0x69,0x6c,0x61, /* SNMP is unavaila */ \
	0x62,0x6c,0x65,0x2e,0x0d,0x0a,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x0d,0x0a, /* ble...</div>.... */ \
	0x3c,0x70,0x3e,0x43,0x6f,0x6e,0x66,0x69,0x67,0x75,0x72,0x65,0x20,0x6d,0x75,0x6c, /* <p>Configure mul */ \
	0x74,0x69,0x70,0x6c,0x65,0x20,0x63,0x6f,0x6d,0x6d,0x75,0x6e,0x69,0x74,0x79,0x20, /* tiple community  */ \
	0x6e,0x61,0x6d,0x65,0x73,0x20,0x69,0x66,0x20,0x79,0x6f,0x75,0x20,0x77,0x61,0x6e, /* names if you wan */ \
	0x74,0x20,0x74,0x68,0x65,0x20,0x53,0x4e,0x4d,0x50,0x20,0x61,0x67,0x65,0x6e,0x74, /* t the SNMP agent */ \
	0x20,0x0d,0x0a,0x74,0x6f,0x20,0x72,0x65,0x73,0x70,0x6f,0x6e,0x64,0x20,0x74,0x6f, /*  ..to respond to */ \
	0x20,0x74,0x68,0x65,0x20,0x4e,0x4d,0x53,0x2f,0x53,0x4e,0x4d,0x50,0x20,0x6d,0x61, /*  the NMS/SNMP ma */ \
	0x6e,0x61,0x67,0x65,0x72,0x20,0x77,0x69,0x74,0x68,0x20,0x64,0x69,0x66,0x66,0x65, /* nager with diffe */ \
	0x72,0x65,0x6e,0x74,0x20,0x72,0x65,0x61,0x64,0x20,0x61,0x6e,0x64,0x20,0x77,0x72, /* rent read and wr */ \
	0x69,0x74,0x65,0x20,0x0d,0x0a,0x63,0x6f,0x6d,0x6d,0x75,0x6e,0x69,0x74,0x79,0x20, /* ite ..community  */ \
	0x6e,0x61,0x6d,0x65,0x73,0x2e,0x20,0x49,0x66,0x20,0x6c,0x65,0x73,0x73,0x20,0x74, /* names. If less t */ \
	0x68,0x61,0x6e,0x20,0x74,0x68,0x72,0x65,0x65,0x20,0x63,0x6f,0x6d,0x6d,0x75,0x6e, /* han three commun */ \
	0x69,0x74,0x69,0x65,0x73,0x20,0x61,0x72,0x65,0x20,0x6e,0x65,0x65,0x64,0x65,0x64, /* ities are needed */ \
	0x2c,0x20,0x6c,0x65,0x61,0x76,0x65,0x20,0x0d,0x0a,0x65,0x78,0x74,0x72,0x61,0x20, /* , leave ..extra  */ \
	0x66,0x69,0x65,0x6c,0x64,0x73,0x20,0x62,0x6c,0x61,0x6e,0x6b,0x20,0x74,0x6f,0x20, /* fields blank to  */ \
	0x64,0x69,0x73,0x61,0x62,0x6c,0x65,0x20,0x74,0x68,0x65,0x6d,0x2e,0x3c,0x2f,0x70, /* disable them.</p */ \
	0x3e,0x0d,0x0a,0x0d,0x0a,0x0d,0x0a,0x3c,0x66,0x6f,0x72,0x6d,0x20,0x6d,0x65,0x74, /* >......<form met */ \
	0x68,0x6f,0x64,0x3d,0x22,0x70,0x6f,0x73,0x74,0x22,0x20,0x61,0x63,0x74,0x69,0x6f, /* hod="post" actio */ \
	0x6e,0x3d,0x22,0x2f,0x73,0x6e,0x6d,0x70,0x2f,0x73,0x6e,0x6d,0x70,0x63,0x6f,0x6e, /* n="/snmp/snmpcon */ \
	0x66,0x69,0x67,0x2e,0x68,0x74,0x6d,0x22,0x20,0x6e,0x61,0x6d,0x65,0x3d,0x22,0x63, /* fig.htm" name="c */ \
	0x6f,0x6e,0x66,0x69,0x67,0x22,0x3e,0x0d,0x0a,0x3c,0x66,0x69,0x65,0x6c,0x64,0x73, /* onfig">..<fields */ \
	0x65,0x74,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x3e,0x3c,0x6c,0x61,0x62, /* et>....<div><lab */ \
	0x65,0x6c,0x3e,0x52,0x65,0x61,0x64,0x20,0x43,0x6f,0x6d,0x6d,0x31,0x20,0x3a,0x3c, /* el>Read Comm1 :< */ \
	0x2f,0x6c,0x61,0x62,0x65,0x6c,0x3e,0x0d,0x0a,0x3c,0x69,0x6e,0x70,0x75,0x74,0x20, /* /label>..<input  */ \
	0x74,0x79,0x70,0x65,0x3d,0x22,0x74,0x65,0x78,0x74,0x22,0x20,0x6e,0x61,0x6d,0x65, /* type="text" name */ \
	0x3d,0x22,0x72,0x63,0x6d,0x30,0x22,0x20,0x76,0x61,0x6c,0x75,0x65,0x3d,0x22,0x7e, /* ="rcm0" value="~ */ \
	0x72,0x65,0x61,0x64,0x5f,0x63,0x6f,0x6d,0x6d,0x28,0x30,0x29,0x7e,0x22,0x20,0x2f, /* read_comm(0)~" / */ \
	0x3e,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x3e,0x3c,0x6c, /* ></div>..<div><l */ \
	0x61,0x62,0x65,0x6c,0x3e,0x52,0x65,0x61,0x64,0x20,0x43,0x6f,0x6d,0x6d,0x32,0x20, /* abel>Read Comm2  */ \
	0x3a,0x3c,0x2f,0x6c,0x61,0x62,0x65,0x6c,0x3e,0x0d,0x0a,0x3c,0x69,0x6e,0x70,0x75, /* :</label>..<inpu */ \
	0x74,0x20,0x74,0x79,0x70,0x65,0x3d,0x22,0x74,0x65,0x78,0x74,0x22,0x20,0x6e,0x61, /* t type="text" na */ \
	0x6d,0x65,0x3d,0x22,0x72,0x63,0x6d,0x31,0x22,0x20,0x76,0x61,0x6c,0x75,0x65,0x3d, /* me="rcm1" value= */ \
	0x22,0x7e,0x72,0x65,0x61,0x64,0x5f,0x63,0x6f,0x6d,0x6d,0x28,0x31,0x29,0x7e,0x22, /* "~read_comm(1)~" */ \
	0x20,0x2f,0x3e,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x3e, /*  /></div>..<div> */ \
	0x3c,0x6c,0x61,0x62,0x65,0x6c,0x3e,0x52,0x65,0x61,0x64,0x20,0x43,0x6f,0x6d,0x6d, /* <label>Read Comm */ \
	0x33,0x20,0x3a,0x3c,0x2f,0x6c,0x61,0x62,0x65,0x6c,0x3e,0x0d,0x0a,0x3c,0x69,0x6e, /* 3 :</label>..<in */ \
	0x70,0x75,0x74,0x20,0x74,0x79,0x70,0x65,0x3d,0x22,0x74,0x65,0x78,0x74,0x22,0x20, /* put type="text"  */ \
	0x6e,0x61,0x6d,0x65,0x3d,0x22,0x72,0x63,0x6d,0x32,0x22,0x20,0x76,0x61,0x6c,0x75, /* name="rcm2" valu */ \
	0x65,0x3d,0x22,0x7e,0x72,0x65,0x61,0x64,0x5f,0x63,0x6f,0x6d,0x6d,0x28,0x32,0x29, /* e="~read_comm(2) */ \
	0x7e,0x22,0x20,0x2f,0x3e,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x0d,0x0a,0x0d, /* ~" /></div>..... */ \
	0x0a,0x3c,0x64,0x69,0x76,0x3e,0x3c,0x6c,0x61,0x62,0x65,0x6c,0x3e,0x57,0x72,0x69, /* .<div><label>Wri */ \
	0x74,0x65,0x20,0x43,0x6f,0x6d,0x6d,0x31,0x3a,0x3c,0x2f,0x6c,0x61,0x62,0x65,0x6c, /* te Comm1:</label */ \
	0x3e,0x0d,0x0a,0x3c,0x69,0x6e,0x70,0x75,0x74,0x20,0x74,0x79,0x70,0x65,0x3d,0x22, /* >..<input type=" */ \
	0x74,0x65,0x78,0x74,0x22,0x20,0x6e,0x61,0x6d,0x65,0x3d,0x22,0x77,0x63,0x6d,0x30, /* text" name="wcm0 */ \
	0x22,0x20,0x76,0x61,0x6c,0x75,0x65,0x3d,0x22,0x7e,0x77,0x72,0x69,0x74,0x65,0x5f, /* " value="~write_ */ \
	0x63,0x6f,0x6d,0x6d,0x28,0x30,0x29,0x7e,0x22,0x20,0x2f,0x3e,0x3c,0x2f,0x64,0x69, /* comm(0)~" /></di */ \
	0x76,0x3e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x3e,0x3c,0x6c,0x61,0x62,0x65,0x6c,0x3e, /* v>..<div><label> */ \
	0x57,0x72,0x69,0x74,0x65,0x20,0x43,0x6f,0x6d,0x6d,0x32,0x3a,0x3c,0x2f,0x6c,0x61, /* Write Comm2:</la */ \
	0x62,0x65,0x6c,0x3e,0x0d,0x0a,0x3c,0x69,0x6e,0x70,0x75,0x74,0x20,0x74,0x79,0x70, /* bel>..<input typ */ \
	0x65,0x3d,0x22,0x74,0x65,0x78,0x74,0x22,0x20,0x6e,0x61,0x6d,0x65,0x3d,0x22,0x77, /* e="text" name="w */ \
	0x63,0x6d,0x31,0x22,0x20,0x76,0x61,0x6c,0x75,0x65,0x3d,0x22,0x7e,0x77,0x72,0x69, /* cm1" value="~wri */ \
	0x74,0x65,0x5f,0x63,0x6f,0x6d,0x6d,0x28,0x31,0x29,0x7e,0x22,0x20,0x2f,0x3e,0x3c, /* te_comm(1)~" />< */ \
	0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x3e,0x3c,0x6c,0x61,0x62, /* /div>..<div><lab */ \
	0x65,0x6c,0x3e,0x57,0x72,0x69,0x74,0x65,0x20,0x43,0x6f,0x6d,0x6d,0x33,0x3a,0x3c, /* el>Write Comm3:< */ \
	0x2f,0x6c,0x61,0x62,0x65,0x6c,0x3e,0x0d,0x0a,0x3c,0x69,0x6e,0x70,0x75,0x74,0x20, /* /label>..<input  */ \
	0x74,0x79,0x70,0x65,0x3d,0x22,0x74,0x65,0x78,0x74,0x22,0x20,0x6e,0x61,0x6d,0x65, /* type="text" name */ \
	0x3d,0x22,0x77,0x63,0x6d,0x32,0x22,0x20,0x76,0x61,0x6c,0x75,0x65,0x3d,0x22,0x7e, /* ="wcm2" value="~ */ \
	0x77,0x72,0x69,0x74,0x65,0x5f,0x63,0x6f,0x6d,0x6d,0x28,0x32,0x29,0x7e,0x22,0x20, /* write_comm(2)~"  */ \
	0x2f,0x3e,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x64,0x69,0x76, /* /></div>....<div */ \
	0x3e,0x26,0x6e,0x62,0x73,0x70,0x3b,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x3c, /* >&nbsp;</div>..< */ \
	0x64,0x69,0x76,0x3e,0x3c,0x69,0x6e,0x70,0x75,0x74,0x20,0x74,0x79,0x70,0x65,0x3d, /* div><input type= */ \
	0x22,0x73,0x75,0x62,0x6d,0x69,0x74,0x22,0x20,0x63,0x6c,0x61,0x73,0x73,0x3d,0x22, /* "submit" class=" */ \
	0x73,0x6d,0x22,0x20,0x76,0x61,0x6c,0x75,0x65,0x3d,0x22,0x53,0x61,0x76,0x65,0x20, /* sm" value="Save  */ \
	0x43,0x6f,0x6e,0x66,0x69,0x67,0x22,0x20,0x2f,0x3e,0x3c,0x2f,0x64,0x69,0x76,0x3e, /* Config" /></div> */ \
	0x0d,0x0a,0x0d,0x0a,0x3c,0x2f,0x66,0x69,0x65,0x6c,0x64,0x73,0x65,0x74,0x3e,0x0d, /* ....</fieldset>. */ \
	0x0a,0x3c,0x2f,0x66,0x6f,0x72,0x6d,0x3e,0x0d,0x0a,0x3c,0x2f,0x64,0x69,0x76,0x3e, /* .</form>..</div> */ \
	0x0d,0x0a,0x0d,0x0a,0x3c,0x2f,0x73,0x63,0x72,0x69,0x70,0x74,0x3e,0x0d,0x0a,0x7e, /* ....</script>..~ */ \
	0x69,0x6e,0x63,0x3a,0x66,0x6f,0x6f,0x74,0x65,0x72,0x2e,0x69,0x6e,0x63,0x7e,0x0d, /* inc:footer.inc~. */ \
	0x0a,0x7e,0x69,0x6e,0x63,0x3a,0x68,0x65,0x61,0x64,0x65,0x72,0x2e,0x69,0x6e,0x63, /* .~inc:header.inc */ \
	0x7e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x69,0x64,0x3d,0x22,0x63,0x6f,0x6e,0x74, /* ~..<div id="cont */ \
	0x65,0x6e,0x74,0x22,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x68,0x31,0x3e,0x49,0x6e,0x74, /* ent">....<h1>Int */ \
	0x65,0x72,0x66,0x61,0x63,0x65,0x20,0x43,0x6f,0x6e,0x66,0x69,0x67,0x75,0x72,0x61, /* erface Configura */ \
	0x74,0x69,0x6f,0x6e,0x3c,0x2f,0x68,0x31,0x3e,0x0d,0x0a,0x3c,0x70,0x3e,0x54,0x68, /* tion</h1>..<p>Th */ \
	0x69,0x73,0x20,0x70,0x61,0x67,0x65,0x20,0x61,0x6c,0x6c,0x6f,0x77,0x73,0x20,0x74, /* is page allows t */ \
	0x68,0x65,0x20,0x63,0x6f,0x6e,0x66,0x69,0x67,0x75,0x72,0x61,0x74,0x69,0x6f,0x6e, /* he configuration */ \
	0x20,0x6f,0x66,0x20,0x74,0x68,0x65,0x20,0x62,0x6f,0x61,0x72,0x64,0x27,0x73,0x20, /*  of the board's  */ \
	0x6e,0x65,0x74,0x77,0x6f,0x72,0x6b,0x20,0x73,0x65,0x74,0x74,0x69,0x6e,0x67,0x73, /* network settings */ \
	0x2e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x63,0x6c,0x61,0x73, /* .</p>..<div clas */ \
	0x73,0x3d,0x22,0x72,0x65,0x73,0x75,0x6c,0x74,0x20,0x66,0x61,0x69,0x6c,0x22,0x20, /* s="result fail"  */ \
	0x73,0x74,0x79,0x6c,0x65,0x3d,0x22,0x64,0x69,0x73,0x70,0x6c,0x61,0x79,0x3a,0x7e, /* style="display:~ */ \
	0x73,0x74,0x61,0x74,0x75,0x73,0x5f,0x66,0x61,0x69,0x6c,0x7e,0x22,0x3e,0x0d,0x0a, /* status_fail~">.. */ \
	0x45,0x52,0x52,0x4f,0x52,0x3a,0x20,0x41,0x20,0x66,0x69,0x65,0x6c,0x64,0x20,0x77, /* ERROR: A field w */ \
	0x61,0x73,0x20,0x75,0x6e,0x70,0x61,0x72,0x73,0x61,0x62,0x6c,0x65,0x20,0x6f,0x72, /* as unparsable or */ \
	0x20,0x74,0x6f,0x6f,0x20,0x6d,0x75,0x63,0x68,0x20,0x64,0x61,0x74,0x61,0x20,0x77, /*  too much data w */ \
	0x61,0x73,0x20,0x50,0x4f,0x53,0x54,0x65,0x64,0x2e,0x20,0x20,0x54,0x72,0x79,0x20, /* as POSTed.  Try  */ \
	0x61,0x67,0x61,0x69,0x6e,0x2e,0x0d,0x0a,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a, /* again...</div>.. */ \
	0x3c,0x70,0x20,0x63,0x6c,0x61,0x73,0x73,0x3d,0x22,0x65,0x72,0x72,0x6f,0x72,0x22, /* <p class="error" */ \
	0x3e,0x0d,0x0a,0x3c,0x62,0x3e,0x43,0x41,0x55,0x54,0x49,0x4f,0x4e,0x3a,0x3c,0x2f, /* >..<b>CAUTION:</ */ \
	0x62,0x3e,0x20,0x49,0x6e,0x63,0x6f,0x72,0x72,0x65,0x63,0x74,0x20,0x73,0x65,0x74, /* b> Incorrect set */ \
	0x74,0x69,0x6e,0x67,0x73,0x20,0x6d,0x61,0x79,0x20,0x63,0x61,0x75,0x73,0x65,0x20, /* tings may cause  */ \
	0x74,0x68,0x65,0x20,0x62,0x6f,0x61,0x72,0x64,0x20,0x74,0x6f,0x20,0x6c,0x6f,0x73, /* the board to los */ \
	0x65,0x20,0x6e,0x65,0x74,0x77,0x6f,0x72,0x6b,0x0d,0x0a,0x63,0x6f,0x6e,0x6e,0x65, /* e network..conne */ \
	0x63,0x74,0x69,0x76,0x69,0x74,0x79,0x2e,0x20,0x20,0x52,0x65,0x63,0x6f,0x76,0x65, /* ctivity.  Recove */ \
	0x72,0x79,0x20,0x6f,0x70,0x74,0x69,0x6f,0x6e,0x73,0x20,0x77,0x69,0x6c,0x6c,0x20, /* ry options will  */ \
	0x62,0x65,0x20,0x70,0x72,0x6f,0x76,0x69,0x64,0x65,0x64,0x20,0x6f,0x6e,0x20,0x74, /* be provided on t */ \
	0x68,0x65,0x20,0x6e,0x65,0x78,0x74,0x20,0x70,0x61,0x67,0x65,0x2e,0x3c,0x2f,0x70, /* he next page.</p */ \
	0x3e,0x0d,0x0a,0x3c,0x70,0x3e,0x45,0x6e,0x74,0x65,0x72,0x20,0x74,0x68,0x65,0x20, /* >..<p>Enter the  */ \
	0x6e,0x65,0x77,0x20,0x73,0x65,0x74,0x74,0x69,0x6e,0x67,0x73,0x20,0x66,0x6f,0x72, /* new settings for */ \
	0x20,0x74,0x68,0x65,0x20,0x6e,0x65,0x74,0x77,0x6f,0x72,0x6b,0x20,0x69,0x6e,0x74, /*  the network int */ \
	0x65,0x72,0x66,0x61,0x63,0x65,0x20,0x62,0x65,0x6c,0x6f,0x77,0x3a,0x3c,0x2f,0x70, /* erface below:</p */ \
	0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x66,0x6f,0x72,0x6d,0x20,0x6d,0x65,0x74,0x68,0x6f, /* >....<form metho */ \
	0x64,0x3d,0x22,0x70,0x6f,0x73,0x74,0x22,0x20,0x61,0x63,0x74,0x69,0x6f,0x6e,0x3d, /* d="post" action= */ \
	0x22,0x2f,0x70,0x72,0x6f,0x74,0x65,0x63,0x74,0x2f,0x63,0x6f,0x6e,0x66,0x69,0x67, /* "/protect/config */ \
	0x2e,0x68,0x74,0x6d,0x22,0x20,0x6e,0x61,0x6d,0x65,0x3d,0x22,0x63,0x6f,0x6e,0x66, /* .htm" name="conf */ \
	0x69,0x67,0x22,0x3e,0x0d,0x0a,0x3c,0x66,0x69,0x65,0x6c,0x64,0x73,0x65,0x74,0x3e, /* ig">..<fieldset> */ \
	0x0d,0x0a,0x3c,0x64,0x69,0x76,0x3e,0x3c,0x6c,0x61,0x62,0x65,0x6c,0x3e,0x4d,0x41, /* ..<div><label>MA */ \
	0x43,0x20,0x41,0x64,0x64,0x72,0x65,0x73,0x73,0x3a,0x3c,0x2f,0x6c,0x61,0x62,0x65, /* C Address:</labe */ \
	0x6c,0x3e,0x0d,0x0a,0x3c,0x69,0x6e,0x70,0x75,0x74,0x20,0x74,0x79,0x70,0x65,0x3d, /* l>..<input type= */ \
	0x22,0x74,0x65,0x78,0x74,0x22,0x20,0x6e,0x61,0x6d,0x65,0x3d,0x22,0x6d,0x61,0x63, /* "text" name="mac */ \
	0x22,0x20,0x76,0x61,0x6c,0x75,0x65,0x3d,0x22,0x7e,0x63,0x6f,0x6e,0x66,0x69,0x67, /* " value="~config */ \
	0x5f,0x6d,0x61,0x63,0x7e,0x22,0x20,0x2f,0x3e,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d, /* _mac~" /></div>. */ \
	0x0a,0x3c,0x64,0x69,0x76,0x3e,0x3c,0x6c,0x61,0x62,0x65,0x6c,0x3e,0x48,0x6f,0x73, /* .<div><label>Hos */ \
	0x74,0x20,0x4e,0x61,0x6d,0x65,0x3a,0x3c,0x2f,0x6c,0x61,0x62,0x65,0x6c,0x3e,0x0d, /* t Name:</label>. */ \
	0x0a,0x3c,0x69,0x6e,0x70,0x75,0x74,0x20,0x74,0x79,0x70,0x65,0x3d,0x22,0x74,0x65, /* .<input type="te */ \
	0x78,0x74,0x22,0x20,0x6e,0x61,0x6d,0x65,0x3d,0x22,0x68,0x6f,0x73,0x74,0x22,0x20, /* xt" name="host"  */ \
	0x76,0x61,0x6c,0x75,0x65,0x3d,0x22,0x7e,0x63,0x6f,0x6e,0x66,0x69,0x67,0x5f,0x68, /* value="~config_h */ \
	0x6f,0x73,0x74,0x6e,0x61,0x6d,0x65,0x7e,0x22,0x20,0x2f,0x3e,0x3c,0x2f,0x64,0x69, /* ostname~" /></di */ \
	0x76,0x3e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x3e,0x26,0x6e,0x62,0x73,0x70,0x3b,0x3c, /* v>..<div>&nbsp;< */ \
	0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x3e,0x0d,0x0a, /* /div>....<div>.. */ \
	0x3c,0x69,0x6e,0x70,0x75,0x74,0x20,0x74,0x79,0x70,0x65,0x3d,0x22,0x63,0x68,0x65, /* <input type="che */ \
	0x63,0x6b,0x62,0x6f,0x78,0x22,0x20,0x63,0x6c,0x61,0x73,0x73,0x3d,0x22,0x73,0x6d, /* ckbox" class="sm */ \
	0x22,0x20,0x6e,0x61,0x6d,0x65,0x3d,0x22,0x64,0x68,0x63,0x70,0x22,0x20,0x76,0x61, /* " name="dhcp" va */ \
	0x6c,0x75,0x65,0x3d,0x22,0x31,0x22,0x20,0x6f,0x6e,0x63,0x6c,0x69,0x63,0x6b,0x3d, /* lue="1" onclick= */ \
	0x22,0x63,0x6f,0x6e,0x66,0x69,0x67,0x49,0x50,0x42,0x6f,0x78,0x65,0x73,0x28,0x29, /* "configIPBoxes() */ \
	0x22,0x20,0x7e,0x63,0x6f,0x6e,0x66,0x69,0x67,0x5f,0x64,0x68,0x63,0x70,0x63,0x68, /* " ~config_dhcpch */ \
	0x65,0x63,0x6b,0x65,0x64,0x7e,0x20,0x2f,0x3e,0x20,0x45,0x6e,0x61,0x62,0x6c,0x65, /* ecked~ /> Enable */ \
	0x20,0x44,0x48,0x43,0x50,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x3c,0x64,0x69, /*  DHCP</div>..<di */ \
	0x76,0x3e,0x3c,0x6c,0x61,0x62,0x65,0x6c,0x3e,0x49,0x50,0x20,0x41,0x64,0x64,0x72, /* v><label>IP Addr */ \
	0x65,0x73,0x73,0x3a,0x3c,0x2f,0x6c,0x61,0x62,0x65,0x6c,0x3e,0x0d,0x0a,0x3c,0x74, /* ess:</label>..<t */ \
	0x64,0x3e,0x3c,0x69,0x6e,0x70,0x75,0x74,0x20,0x74,0x79,0x70,0x65,0x3d,0x22,0x74, /* d><input type="t */ \
	0x65,0x78,0x74,0x22,0x20,0x6e,0x61,0x6d,0x65,0x3d,0x22,0x69,0x70,0x22,0x20,0x76, /* ext" name="ip" v */ \
	0x61,0x6c,0x75,0x65,0x3d,0x22,0x7e,0x63,0x6f,0x6e,0x66,0x69,0x67,0x5f,0x69,0x70, /* alue="~config_ip */ \
	0x7e,0x22,0x20,0x2f,0x3e,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x3c,0x64,0x69, /* ~" /></div>..<di */ \
	0x76,0x3e,0x3c,0x6c,0x61,0x62,0x65,0x6c,0x3e,0x47,0x61,0x74,0x65,0x77,0x61,0x79, /* v><label>Gateway */ \
	0x3a,0x3c,0x2f,0x6c,0x61,0x62,0x65,0x6c,0x3e,0x0d,0x0a,0x3c,0x74,0x64,0x3e,0x3c, /* :</label>..<td>< */ \
	0x69,0x6e,0x70,0x75,0x74,0x20,0x74,0x79,0x70,0x65,0x3d,0x22,0x74,0x65,0x78,0x74, /* input type="text */ \
	0x22,0x20,0x6e,0x61,0x6d,0x65,0x3d,0x22,0x67,0x77,0x22,0x20,0x76,0x61,0x6c,0x75, /* " name="gw" valu */ \
	0x65,0x3d,0x22,0x7e,0x63,0x6f,0x6e,0x66,0x69,0x67,0x5f,0x67,0x77,0x7e,0x22,0x20, /* e="~config_gw~"  */ \
	0x2f,0x3e,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x3e,0x3c, /* /></div>..<div>< */ \
	0x6c,0x61,0x62,0x65,0x6c,0x3e,0x53,0x75,0x62,0x6e,0x65,0x74,0x20,0x4d,0x61,0x73, /* label>Subnet Mas */ \
	0x6b,0x3a,0x3c,0x2f,0x6c,0x61,0x62,0x65,0x6c,0x3e,0x0d,0x0a,0x3c,0x74,0x64,0x3e, /* k:</label>..<td> */ \
	0x3c,0x69,0x6e,0x70,0x75,0x74,0x20,0x74,0x79,0x70,0x65,0x3d,0x22,0x74,0x65,0x78, /* <input type="tex */ \
	0x74,0x22,0x20,0x6e,0x61,0x6d,0x65,0x3d,0x22,0x73,0x75,0x62,0x22,0x20,0x76,0x61, /* t" name="sub" va */ \
	0x6c,0x75,0x65,0x3d,0x22,0x7e,0x63,0x6f,0x6e,0x66,0x69,0x67,0x5f,0x73,0x75,0x62, /* lue="~config_sub */ \
	0x6e,0x65,0x74,0x7e,0x22,0x20,0x2f,0x3e,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a, /* net~" /></div>.. */ \
	0x3c,0x64,0x69,0x76,0x3e,0x3c,0x6c,0x61,0x62,0x65,0x6c,0x3e,0x50,0x72,0x69,0x6d, /* <div><label>Prim */ \
	0x61,0x72,0x79,0x20,0x44,0x4e,0x53,0x3a,0x3c,0x2f,0x6c,0x61,0x62,0x65,0x6c,0x3e, /* ary DNS:</label> */ \
	0x0d,0x0a,0x3c,0x74,0x64,0x3e,0x3c,0x69,0x6e,0x70,0x75,0x74,0x20,0x74,0x79,0x70, /* ..<td><input typ */ \
	0x65,0x3d,0x22,0x74,0x65,0x78,0x74,0x22,0x20,0x6e,0x61,0x6d,0x65,0x3d,0x22,0x64, /* e="text" name="d */ \
	0x6e,0x73,0x31,0x22,0x20,0x76,0x61,0x6c,0x75,0x65,0x3d,0x22,0x7e,0x63,0x6f,0x6e, /* ns1" value="~con */ \
	0x66,0x69,0x67,0x5f,0x64,0x6e,0x73,0x31,0x7e,0x22,0x20,0x2f,0x3e,0x3c,0x2f,0x64, /* fig_dns1~" /></d */ \
	0x69,0x76,0x3e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x3e,0x3c,0x6c,0x61,0x62,0x65,0x6c, /* iv>..<div><label */ \
	0x3e,0x53,0x65,0x63,0x6f,0x6e,0x64,0x61,0x72,0x79,0x20,0x44,0x4e,0x53,0x3a,0x3c, /* >Secondary DNS:< */ \
	0x2f,0x6c,0x61,0x62,0x65,0x6c,0x3e,0x0d,0x0a,0x3c,0x69,0x6e,0x70,0x75,0x74,0x20, /* /label>..<input  */ \
	0x74,0x79,0x70,0x65,0x3d,0x22,0x74,0x65,0x78,0x74,0x22,0x20,0x6e,0x61,0x6d,0x65, /* type="text" name */ \
	0x3d,0x22,0x64,0x6e,0x73,0x32,0x22,0x20,0x76,0x61,0x6c,0x75,0x65,0x3d,0x22,0x7e, /* ="dns2" value="~ */ \
	0x63,0x6f,0x6e,0x66,0x69,0x67,0x5f,0x64,0x6e,0x73,0x32,0x7e,0x22,0x20,0x2f,0x3e, /* config_dns2~" /> */ \
	0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x3e,0x3c,0x69,0x6e, /* </div>..<div><in */ \
	0x70,0x75,0x74,0x20,0x74,0x79,0x70,0x65,0x3d,0x22,0x73,0x75,0x62,0x6d,0x69,0x74, /* put type="submit */ \
	0x22,0x20,0x63,0x6c,0x61,0x73,0x73,0x3d,0x22,0x73,0x6d,0x22,0x20,0x76,0x61,0x6c, /* " class="sm" val */ \
	0x75,0x65,0x3d,0x22,0x52,0x65,0x73,0x74,0x61,0x72,0x74,0x20,0x49,0x6e,0x74,0x65, /* ue="Restart Inte */ \
	0x72,0x66,0x61,0x63,0x65,0x22,0x20,0x2f,0x3e,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d, /* rface" /></div>. */ \
	0x0a,0x3c,0x2f,0x66,0x69,0x65,0x6c,0x64,0x73,0x65,0x74,0x3e,0x0d,0x0a,0x3c,0x2f, /* .</fieldset>..</ */ \
	0x66,0x6f,0x72,0x6d,0x3e,0x0d,0x0a,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x0d, /* form>..</div>... */ \
	0x0a,0x3c,0x73,0x63,0x72,0x69,0x70,0x74,0x20,0x6c,0x61,0x6e,0x67,0x75,0x61,0x67, /* .<script languag */ \
	0x65,0x3d,0x22,0x6a,0x61,0x76,0x61,0x73,0x63,0x72,0x69,0x70,0x74,0x22,0x3e,0x0d, /* e="javascript">. */ \
	0x0a,0x3c,0x21,0x2d,0x2d,0x0d,0x0a,0x66,0x75,0x6e,0x63,0x74,0x69,0x6f,0x6e,0x20, /* .<!--..function  */ \
	0x63,0x6f,0x6e,0x66,0x69,0x67,0x49,0x50,0x42,0x6f,0x78,0x65,0x73,0x28,0x29,0x20, /* configIPBoxes()  */ \
	0x7b,0x0d,0x0a,0x09,0x65,0x20,0x3d,0x20,0x64,0x6f,0x63,0x75,0x6d,0x65,0x6e,0x74, /* {...e = document */ \
	0x2e,0x66,0x6f,0x72,0x6d,0x73,0x2e,0x63,0x6f,0x6e,0x66,0x69,0x67,0x3b,0x0d,0x0a, /* .forms.config;.. */ \
	0x09,0x73,0x74,0x20,0x3d,0x20,0x65,0x2e,0x64,0x68,0x63,0x70,0x2e,0x63,0x68,0x65, /* .st = e.dhcp.che */ \
	0x63,0x6b,0x65,0x64,0x3b,0x0d,0x0a,0x09,0x65,0x2e,0x69,0x70,0x2e,0x64,0x69,0x73, /* cked;...e.ip.dis */ \
	0x61,0x62,0x6c,0x65,0x64,0x20,0x3d,0x20,0x73,0x74,0x3b,0x0d,0x0a,0x09,0x65,0x2e, /* abled = st;...e. */ \
	0x67,0x77,0x2e,0x64,0x69,0x73,0x61,0x62,0x6c,0x65,0x64,0x20,0x3d,0x20,0x73,0x74, /* gw.disabled = st */ \
	0x3b,0x0d,0x0a,0x09,0x65,0x2e,0x73,0x75,0x62,0x2e,0x64,0x69,0x73,0x61,0x62,0x6c, /* ;...e.sub.disabl */ \
	0x65,0x64,0x20,0x3d,0x20,0x73,0x74,0x3b,0x0d,0x0a,0x09,0x65,0x2e,0x64,0x6e,0x73, /* ed = st;...e.dns */ \
	0x31,0x2e,0x64,0x69,0x73,0x61,0x62,0x6c,0x65,0x64,0x20,0x3d,0x20,0x73,0x74,0x3b, /* 1.disabled = st; */ \
	0x0d,0x0a,0x09,0x65,0x2e,0x64,0x6e,0x73,0x32,0x2e,0x64,0x69,0x73,0x61,0x62,0x6c, /* ...e.dns2.disabl */ \
	0x65,0x64,0x20,0x3d,0x20,0x73,0x74,0x3b,0x0d,0x0a,0x7d,0x0d,0x0a,0x0d,0x0a,0x63, /* ed = st;..}....c */ \
	0x6f,0x6e,0x66,0x69,0x67,0x49,0x50,0x42,0x6f,0x78,0x65,0x73,0x28,0x29,0x3b,0x0d, /* onfigIPBoxes();. */ \
	0x0a,0x64,0x6f,0x63,0x75,0x6d,0x65,0x6e,0x74,0x2e,0x67,0x65,0x74,0x45,0x6c,0x65, /* .document.getEle */ \
	0x6d,0x65,0x6e,0x74,0x42,0x79,0x49,0x64,0x28,0x27,0x68,0x65,0x6c,0x6c,0x6f,0x27, /* mentById('hello' */ \
	0x29,0x2e,0x69,0x6e,0x6e,0x65,0x72,0x48,0x54,0x4d,0x4c,0x20,0x3d,0x20,0x22,0x7e, /* ).innerHTML = "~ */ \
	0x68,0x65,0x6c,0x6c,0x6f,0x6d,0x73,0x67,0x7e,0x22,0x3b,0x0d,0x0a,0x2f,0x2f,0x2d, /* hellomsg~";..//- */ \
	0x2d,0x3e,0x0d,0x0a,0x3c,0x2f,0x73,0x63,0x72,0x69,0x70,0x74,0x3e,0x0d,0x0a,0x7e, /* ->..</script>..~ */ \
	0x69,0x6e,0x63,0x3a,0x66,0x6f,0x6f,0x74,0x65,0x72,0x2e,0x69,0x6e,0x63,0x7e,0x0d, /* inc:footer.inc~. */ \
	0x0a,0x7e,0x69,0x6e,0x63,0x3a,0x68,0x65,0x61,0x64,0x65,0x72,0x2e,0x69,0x6e,0x63, /* .~inc:header.inc */ \
	0x7e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x69,0x64,0x3d,0x22,0x63,0x6f,0x6e,0x74, /* ~..<div id="cont */ \
	0x65,0x6e,0x74,0x22,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x68,0x31,0x3e,0x4c,0x6f,0x67, /* ent">....<h1>Log */ \
	0x69,0x6e,0x20,0x53,0x75,0x63,0x63,0x65,0x73,0x73,0x66,0x75,0x6c,0x3c,0x2f,0x68, /* in Successful</h */ \
	0x31,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70,0x3e,0x59,0x6f,0x75,0x20,0x68,0x61,0x76, /* 1>....<p>You hav */ \
	0x65,0x20,0x73,0x75,0x63,0x63,0x65,0x73,0x73,0x66,0x75,0x6c,0x6c,0x79,0x20,0x6c, /* e successfully l */ \
	0x6f,0x67,0x67,0x65,0x64,0x20,0x69,0x6e,0x20,0x74,0x6f,0x20,0x74,0x68,0x65,0x20, /* ogged in to the  */ \
	0x77,0x65,0x62,0x20,0x73,0x65,0x72,0x76,0x65,0x72,0x2e,0x20,0x20,0x54,0x68,0x69, /* web server.  Thi */ \
	0x73,0x20,0x61,0x75,0x74,0x68,0x65,0x6e,0x74,0x69,0x63,0x61,0x74,0x69,0x6f,0x6e, /* s authentication */ \
	0x0d,0x0a,0x69,0x73,0x20,0x76,0x61,0x6c,0x69,0x64,0x20,0x75,0x6e,0x74,0x69,0x6c, /* ..is valid until */ \
	0x20,0x79,0x6f,0x75,0x20,0x63,0x6c,0x6f,0x73,0x65,0x20,0x79,0x6f,0x75,0x72,0x20, /*  you close your  */ \
	0x62,0x72,0x6f,0x77,0x73,0x65,0x72,0x2e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a, /* browser.</p>.... */ \
	0x3c,0x70,0x3e,0x43,0x72,0x65,0x64,0x65,0x6e,0x74,0x69,0x61,0x6c,0x73,0x20,0x61, /* <p>Credentials a */ \
	0x72,0x65,0x20,0x76,0x65,0x72,0x69,0x66,0x69,0x65,0x64,0x20,0x69,0x6e,0x20,0x79, /* re verified in y */ \
	0x6f,0x75,0x72,0x20,0x6f,0x77,0x6e,0x20,0x63,0x75,0x73,0x74,0x6f,0x6d,0x20,0x63, /* our own custom c */ \
	0x61,0x6c,0x6c,0x62,0x61,0x63,0x6b,0x20,0x66,0x75,0x6e,0x63,0x74,0x69,0x6f,0x6e, /* allback function */ \
	0x20,0x63,0x61,0x6c,0x6c,0x65,0x64,0x0d,0x0a,0x3c,0x63,0x6f,0x64,0x65,0x3e,0x54, /*  called..<code>T */ \
	0x43,0x50,0x49,0x50,0x5f,0x48,0x54,0x54,0x50,0x5f,0x55,0x73,0x65,0x72,0x41,0x75, /* CPIP_HTTP_UserAu */ \
	0x74,0x68,0x65,0x6e,0x74,0x69,0x63,0x61,0x74,0x65,0x3c,0x2f,0x63,0x6f,0x64,0x65, /* thenticate</code */ \
	0x3e,0x2e,0x20,0x20,0x49,0x6e,0x20,0x68,0x65,0x72,0x65,0x2c,0x20,0x79,0x6f,0x75, /* >.  In here, you */ \
	0x20,0x63,0x61,0x6e,0x20,0x64,0x65,0x74,0x65,0x72,0x6d,0x69,0x6e,0x65,0x20,0x69, /*  can determine i */ \
	0x66,0x20,0x74,0x68,0x65,0x20,0x73,0x75,0x70,0x70,0x6c,0x69,0x65,0x64,0x0d,0x0a, /* f the supplied.. */ \
	0x75,0x73,0x65,0x72,0x20,0x6e,0x61,0x6d,0x65,0x20,0x61,0x6e,0x64,0x20,0x70,0x61, /* user name and pa */ \
	0x73,0x73,0x77,0x6f,0x72,0x64,0x20,0x61,0x72,0x65,0x20,0x76,0x61,0x6c,0x69,0x64, /* ssword are valid */ \
	0x20,0x66,0x6f,0x72,0x20,0x61,0x63,0x63,0x65,0x73,0x73,0x20,0x74,0x6f,0x20,0x74, /*  for access to t */ \
	0x68,0x65,0x20,0x72,0x65,0x71,0x75,0x65,0x73,0x74,0x65,0x64,0x20,0x70,0x61,0x67, /* he requested pag */ \
	0x65,0x2e,0x20,0x20,0x59,0x6f,0x75,0x20,0x63,0x61,0x6e,0x0d,0x0a,0x61,0x64,0x64, /* e.  You can..add */ \
	0x20,0x6d,0x75,0x6c,0x74,0x69,0x70,0x6c,0x65,0x20,0x75,0x73,0x65,0x72,0x73,0x20, /*  multiple users  */ \
	0x61,0x6e,0x64,0x20,0x72,0x65,0x73,0x74,0x72,0x69,0x63,0x74,0x20,0x64,0x69,0x66, /* and restrict dif */ \
	0x66,0x65,0x72,0x65,0x6e,0x74,0x20,0x75,0x73,0x65,0x72,0x73,0x20,0x74,0x6f,0x20, /* ferent users to  */ \
	0x64,0x69,0x66,0x66,0x65,0x72,0x65,0x6e,0x74,0x20,0x70,0x61,0x67,0x65,0x73,0x2e, /* different pages. */ \
	0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70,0x20,0x63,0x6c,0x61,0x73,0x73, /* </p>....<p class */ \
	0x3d,0x22,0x65,0x78,0x65,0x72,0x63,0x69,0x73,0x65,0x22,0x3e,0x3c,0x62,0x3e,0x45, /* ="exercise"><b>E */ \
	0x78,0x65,0x72,0x63,0x69,0x73,0x65,0x3a,0x3c,0x2f,0x62,0x3e,0x20,0x43,0x68,0x61, /* xercise:</b> Cha */ \
	0x6e,0x67,0x65,0x20,0x74,0x68,0x65,0x20,0x75,0x73,0x65,0x72,0x20,0x6e,0x61,0x6d, /* nge the user nam */ \
	0x65,0x20,0x61,0x6e,0x64,0x20,0x70,0x61,0x73,0x73,0x77,0x6f,0x72,0x64,0x20,0x69, /* e and password i */ \
	0x6e,0x0d,0x0a,0x3c,0x63,0x6f,0x64,0x65,0x3e,0x54,0x43,0x50,0x49,0x50,0x5f,0x48, /* n..<code>TCPIP_H */ \
	0x54,0x54,0x50,0x5f,0x55,0x73,0x65,0x72,0x41,0x75,0x74,0x68,0x65,0x6e,0x74,0x69, /* TTP_UserAuthenti */ \
	0x63,0x61,0x74,0x65,0x3c,0x2f,0x63,0x6f,0x64,0x65,0x3e,0x20,0x74,0x6f,0x20,0x6f, /* cate</code> to o */ \
	0x6e,0x65,0x20,0x6f,0x66,0x20,0x79,0x6f,0x75,0x72,0x20,0x63,0x68,0x6f,0x6f,0x73, /* ne of your choos */ \
	0x69,0x6e,0x67,0x2e,0x20,0x20,0x28,0x54,0x68,0x65,0x20,0x63,0x61,0x6c,0x6c,0x62, /* ing.  (The callb */ \
	0x61,0x63,0x6b,0x20,0x69,0x73,0x0d,0x0a,0x6c,0x6f,0x63,0x61,0x74,0x65,0x64,0x20, /* ack is..located  */ \
	0x69,0x6e,0x20,0x3c,0x63,0x6f,0x64,0x65,0x3e,0x63,0x75,0x73,0x74,0x6f,0x6d,0x5f, /* in <code>custom_ */ \
	0x68,0x74,0x74,0x70,0x5f,0x61,0x70,0x70,0x2e,0x63,0x3c,0x2f,0x63,0x6f,0x64,0x65, /* http_app.c</code */ \
	0x3e,0x2e,0x29,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20, /* >.)</p>....<div  */ \
	0x63,0x6c,0x61,0x73,0x73,0x3d,0x22,0x65,0x78,0x61,0x6d,0x70,0x6c,0x65,0x62,0x6f, /* class="examplebo */ \
	0x78,0x22,0x3e,0x0d,0x0a,0x57,0x68,0x65,0x6e,0x20,0x79,0x6f,0x75,0x20,0x66,0x69, /* x">..When you fi */ \
	0x6e,0x69,0x73,0x68,0x2c,0x20,0x72,0x65,0x66,0x72,0x65,0x73,0x68,0x20,0x74,0x68, /* nish, refresh th */ \
	0x69,0x73,0x20,0x70,0x61,0x67,0x65,0x20,0x74,0x6f,0x20,0x74,0x65,0x73,0x74,0x20, /* is page to test  */ \
	0x79,0x6f,0x75,0x72,0x20,0x6e,0x65,0x77,0x20,0x75,0x73,0x65,0x72,0x20,0x6e,0x61, /* your new user na */ \
	0x6d,0x65,0x20,0x61,0x6e,0x64,0x20,0x70,0x61,0x73,0x73,0x77,0x6f,0x72,0x64,0x0d, /* me and password. */ \
	0x0a,0x63,0x6f,0x6d,0x62,0x69,0x6e,0x61,0x74,0x69,0x6f,0x6e,0x2e,0x0d,0x0a,0x3c, /* .combination...< */ \
	0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d, /* /div>....</div>. */ \
	0x0a,0x0d,0x0a,0x3c,0x73,0x63,0x72,0x69,0x70,0x74,0x20,0x74,0x79,0x70,0x65,0x3d, /* ...<script type= */ \
	0x22,0x74,0x65,0x78,0x74,0x2f,0x6a,0x61,0x76,0x61,0x73,0x63,0x72,0x69,0x70,0x74, /* "text/javascript */ \
	0x22,0x3e,0x0d,0x0a,0x3c,0x21,0x2d,0x2d,0x0d,0x0a,0x64,0x6f,0x63,0x75,0x6d,0x65, /* ">..<!--..docume */ \
	0x6e,0x74,0x2e,0x67,0x65,0x74,0x45,0x6c,0x65,0x6d,0x65,0x6e,0x74,0x42,0x79,0x49, /* nt.getElementByI */ \
	0x64,0x28,0x27,0x68,0x65,0x6c,0x6c,0x6f,0x27,0x29,0x2e,0x69,0x6e,0x6e,0x65,0x72, /* d('hello').inner */ \
	0x48,0x54,0x4d,0x4c,0x20,0x3d,0x20,0x22,0x7e,0x68,0x65,0x6c,0x6c,0x6f,0x6d,0x73, /* HTML = "~helloms */ \
	0x67,0x7e,0x22,0x3b,0x0d,0x0a,0x2f,0x2f,0x2d,0x2d,0x3e,0x0d,0x0a,0x3c,0x2f,0x73, /* g~";..//-->..</s */ \
	0x63,0x72,0x69,0x70,0x74,0x3e,0x0d,0x0a,0x7e,0x69,0x6e,0x63,0x3a,0x66,0x6f,0x6f, /* cript>..~inc:foo */ \
	0x74,0x65,0x72,0x2e,0x69,0x6e,0x63,0x7e,0x0d,0x0a,0x7e,0x72,0x65,0x62,0x6f,0x6f, /* ter.inc~..~reboo */ \
	0x74,0x7e,0x7e,0x69,0x6e,0x63,0x3a,0x68,0x65,0x61,0x64,0x65,0x72,0x2e,0x69,0x6e, /* t~~inc:header.in */ \
	0x63,0x7e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x69,0x64,0x3d,0x22,0x63,0x6f,0x6e, /* c~..<div id="con */ \
	0x74,0x65,0x6e,0x74,0x22,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x68,0x31,0x3e,0x52,0x65, /* tent">....<h1>Re */ \
	0x73,0x74,0x61,0x72,0x74,0x20,0x49,0x6e,0x20,0x50,0x72,0x6f,0x67,0x72,0x65,0x73, /* start In Progres */ \
	0x73,0x2e,0x2e,0x2e,0x3c,0x2f,0x68,0x31,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70,0x3e, /* s...</h1>....<p> */ \
	0x59,0x6f,0x75,0x72,0x20,0x73,0x65,0x74,0x74,0x69,0x6e,0x67,0x73,0x20,0x77,0x65, /* Your settings we */ \
	0x72,0x65,0x20,0x73,0x75,0x63,0x63,0x65,0x73,0x73,0x66,0x75,0x6c,0x6c,0x79,0x20, /* re successfully  */ \
	0x73,0x61,0x76,0x65,0x64,0x2c,0x20,0x61,0x6e,0x64,0x20,0x74,0x68,0x65,0x20,0x69, /* saved, and the i */ \
	0x6e,0x74,0x65,0x72,0x66,0x61,0x63,0x65,0x20,0x69,0x73,0x20,0x6e,0x6f,0x77,0x20, /* nterface is now  */ \
	0x72,0x65,0x73,0x74,0x61,0x72,0x74,0x69,0x6e,0x67,0x20,0x0d,0x0a,0x74,0x6f,0x20, /* restarting ..to  */ \
	0x63,0x6f,0x6e,0x66,0x69,0x67,0x75,0x72,0x65,0x20,0x69,0x74,0x73,0x65,0x6c,0x66, /* configure itself */ \
	0x20,0x77,0x69,0x74,0x68,0x20,0x74,0x68,0x65,0x20,0x6e,0x65,0x77,0x20,0x73,0x65, /*  with the new se */ \
	0x74,0x74,0x69,0x6e,0x67,0x73,0x2e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c, /* ttings.</p>....< */ \
	0x70,0x20,0x61,0x6c,0x69,0x67,0x6e,0x3d,0x22,0x63,0x65,0x6e,0x74,0x65,0x72,0x22, /* p align="center" */ \
	0x3e,0x3c,0x62,0x3e,0x59,0x6f,0x75,0x72,0x20,0x62,0x6f,0x61,0x72,0x64,0x20,0x69, /* ><b>Your board i */ \
	0x73,0x20,0x6e,0x6f,0x77,0x20,0x6c,0x6f,0x63,0x61,0x74,0x65,0x64,0x20,0x61,0x74, /* s now located at */ \
	0x3a,0x20,0x0d,0x0a,0x3c,0x61,0x20,0x68,0x72,0x65,0x66,0x3d,0x22,0x68,0x74,0x74, /* : ..<a href="htt */ \
	0x70,0x3a,0x2f,0x2f,0x7e,0x72,0x65,0x62,0x6f,0x6f,0x74,0x61,0x64,0x64,0x72,0x7e, /* p://~rebootaddr~ */ \
	0x2f,0x22,0x3e,0x68,0x74,0x74,0x70,0x3a,0x2f,0x2f,0x7e,0x72,0x65,0x62,0x6f,0x6f, /* /">http://~reboo */ \
	0x74,0x61,0x64,0x64,0x72,0x7e,0x2f,0x3c,0x2f,0x61,0x3e,0x3c,0x2f,0x62,0x3e,0x3c, /* taddr~/</a></b>< */ \
	0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x68,0x36,0x3e,0x3c,0x2f,0x68,0x36,0x3e, /* /p>....<h6></h6> */ \
	0x0d,0x0a,0x0d,0x0a,0x3c,0x68,0x33,0x3e,0x52,0x65,0x63,0x6f,0x6e,0x6e,0x65,0x63, /* ....<h3>Reconnec */ \
	0x74,0x69,0x6f,0x6e,0x20,0x49,0x6e,0x73,0x74,0x72,0x75,0x63,0x74,0x69,0x6f,0x6e, /* tion Instruction */ \
	0x73,0x3c,0x2f,0x68,0x33,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x6f,0x6c,0x3e,0x0d,0x0a, /* s</h3>....<ol>.. */ \
	0x3c,0x6c,0x69,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x22,0x6d,0x61,0x72,0x67,0x69, /* <li style="margi */ \
	0x6e,0x2d,0x62,0x6f,0x74,0x74,0x6f,0x6d,0x3a,0x31,0x30,0x70,0x78,0x22,0x3e,0x3c, /* n-bottom:10px">< */ \
	0x62,0x3e,0x44,0x69,0x64,0x20,0x79,0x6f,0x75,0x20,0x63,0x68,0x61,0x6e,0x67,0x65, /* b>Did you change */ \
	0x20,0x74,0x68,0x65,0x20,0x68,0x6f,0x73,0x74,0x6e,0x61,0x6d,0x65,0x2c,0x20,0x49, /*  the hostname, I */ \
	0x50,0x20,0x6f,0x72,0x20,0x4d,0x41,0x43,0x20,0x61,0x64,0x64,0x72,0x65,0x73,0x73, /* P or MAC address */ \
	0x3f,0x3c,0x2f,0x62,0x3e,0x3c,0x62,0x72,0x20,0x2f,0x3e,0x0d,0x0a,0x09,0x49,0x74, /* ?</b><br />...It */ \
	0x20,0x69,0x73,0x20,0x6e,0x65,0x63,0x65,0x73,0x73,0x61,0x72,0x79,0x20,0x74,0x6f, /*  is necessary to */ \
	0x20,0x63,0x6c,0x65,0x61,0x72,0x20,0x74,0x68,0x65,0x20,0x61,0x64,0x64,0x72,0x65, /*  clear the addre */ \
	0x73,0x73,0x20,0x63,0x61,0x63,0x68,0x65,0x73,0x20,0x69,0x6e,0x20,0x79,0x6f,0x75, /* ss caches in you */ \
	0x72,0x20,0x77,0x65,0x62,0x20,0x62,0x72,0x6f,0x77,0x73,0x65,0x72,0x20,0x61,0x6e, /* r web browser an */ \
	0x64,0x20,0x4f,0x53,0x2e,0x0d,0x0a,0x09,0x46,0x72,0x6f,0x6d,0x20,0x74,0x68,0x65, /* d OS....From the */ \
	0x20,0x63,0x6f,0x6d,0x6d,0x61,0x6e,0x64,0x20,0x70,0x72,0x6f,0x6d,0x70,0x74,0x20, /*  command prompt  */ \
	0x69,0x6e,0x20,0x57,0x69,0x6e,0x64,0x6f,0x77,0x73,0x2c,0x20,0x65,0x6e,0x74,0x65, /* in Windows, ente */ \
	0x72,0x20,0x22,0x6e,0x62,0x74,0x73,0x74,0x61,0x74,0x26,0x6e,0x62,0x73,0x70,0x3b, /* r "nbtstat&nbsp; */ \
	0x2d,0x52,0x22,0x20,0x74,0x6f,0x20,0x63,0x6c,0x65,0x61,0x72,0x20,0x74,0x68,0x65, /* -R" to clear the */ \
	0x20,0x68,0x6f,0x73,0x74,0x6e,0x61,0x6d,0x65,0x20,0x63,0x61,0x63,0x68,0x65,0x2c, /*  hostname cache, */ \
	0x20,0x0d,0x0a,0x09,0x63,0x6c,0x6f,0x73,0x65,0x20,0x79,0x6f,0x75,0x72,0x20,0x63, /*  ...close your c */ \
	0x75,0x72,0x72,0x65,0x6e,0x74,0x20,0x77,0x65,0x62,0x20,0x62,0x72,0x6f,0x77,0x73, /* urrent web brows */ \
	0x65,0x72,0x2c,0x20,0x6f,0x70,0x65,0x6e,0x20,0x61,0x20,0x6e,0x65,0x77,0x20,0x77, /* er, open a new w */ \
	0x65,0x62,0x20,0x62,0x72,0x6f,0x77,0x73,0x65,0x72,0x2c,0x20,0x61,0x6e,0x64,0x20, /* eb browser, and  */ \
	0x74,0x68,0x65,0x6e,0x20,0x74,0x72,0x79,0x20,0x74,0x6f,0x20,0x61,0x63,0x63,0x65, /* then try to acce */ \
	0x73,0x73,0x20,0x74,0x68,0x65,0x20,0x77,0x65,0x62,0x20,0x61,0x64,0x64,0x72,0x65, /* ss the web addre */ \
	0x73,0x73,0x20,0x61,0x62,0x6f,0x76,0x65,0x2e,0x3c,0x2f,0x6c,0x69,0x3e,0x0d,0x0a, /* ss above.</li>.. */ \
	0x3c,0x6c,0x69,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x22,0x6d,0x61,0x72,0x67,0x69, /* <li style="margi */ \
	0x6e,0x2d,0x62,0x6f,0x74,0x74,0x6f,0x6d,0x3a,0x31,0x30,0x70,0x78,0x22,0x3e,0x3c, /* n-bottom:10px">< */ \
	0x62,0x3e,0x44,0x69,0x64,0x20,0x79,0x6f,0x75,0x20,0x74,0x72,0x79,0x20,0x74,0x68, /* b>Did you try th */ \
	0x65,0x20,0x49,0x50,0x20,0x61,0x64,0x64,0x72,0x65,0x73,0x73,0x3f,0x3c,0x2f,0x62, /* e IP address?</b */ \
	0x3e,0x3c,0x62,0x72,0x20,0x2f,0x3e,0x0d,0x0a,0x09,0x54,0x72,0x79,0x20,0x61,0x63, /* ><br />...Try ac */ \
	0x63,0x65,0x73,0x73,0x69,0x6e,0x67,0x20,0x74,0x68,0x65,0x20,0x62,0x6f,0x61,0x72, /* cessing the boar */ \
	0x64,0x20,0x64,0x69,0x72,0x65,0x63,0x74,0x6c,0x79,0x20,0x77,0x69,0x74,0x68,0x20, /* d directly with  */ \
	0x74,0x68,0x65,0x20,0x49,0x50,0x20,0x61,0x64,0x64,0x72,0x65,0x73,0x73,0x20,0x74, /* the IP address t */ \
	0x68,0x61,0x74,0x20,0x79,0x6f,0x75,0x20,0x73,0x65,0x6c,0x65,0x63,0x74,0x65,0x64, /* hat you selected */ \
	0x0d,0x0a,0x09,0x28,0x65,0x78,0x3a,0x20,0x65,0x6e,0x74,0x65,0x72,0x20,0x22,0x68, /* ...(ex: enter "h */ \
	0x74,0x74,0x70,0x3a,0x2f,0x2f,0x31,0x39,0x32,0x2e,0x31,0x36,0x38,0x2e,0x35,0x2e, /* ttp://192.168.5. */ \
	0x32,0x33,0x2f,0x22,0x20,0x69,0x6e,0x74,0x6f,0x20,0x79,0x6f,0x75,0x72,0x20,0x62, /* 23/" into your b */ \
	0x72,0x6f,0x77,0x73,0x65,0x72,0x29,0x2e,0x20,0x20,0x49,0x66,0x20,0x74,0x68,0x69, /* rowser).  If thi */ \
	0x73,0x20,0x66,0x61,0x69,0x6c,0x73,0x2c,0x20,0x74,0x68,0x65,0x6e,0x20,0x0d,0x0a, /* s fails, then .. */ \
	0x09,0x74,0x68,0x65,0x20,0x49,0x50,0x20,0x61,0x64,0x64,0x72,0x65,0x73,0x73,0x20, /* .the IP address  */ \
	0x79,0x6f,0x75,0x20,0x73,0x65,0x74,0x20,0x69,0x73,0x20,0x6e,0x6f,0x74,0x20,0x72, /* you set is not r */ \
	0x65,0x61,0x63,0x68,0x61,0x62,0x6c,0x65,0x2e,0x20,0x20,0x54,0x72,0x79,0x20,0x74, /* eachable.  Try t */ \
	0x68,0x65,0x20,0x73,0x74,0x65,0x70,0x20,0x62,0x65,0x6c,0x6f,0x77,0x2e,0x3c,0x2f, /* he step below.</ */ \
	0x6c,0x69,0x3e,0x0d,0x0a,0x3c,0x6c,0x69,0x3e,0x3c,0x62,0x3e,0x53,0x74,0x69,0x6c, /* li>..<li><b>Stil */ \
	0x6c,0x20,0x6e,0x6f,0x74,0x20,0x77,0x6f,0x72,0x6b,0x69,0x6e,0x67,0x3f,0x3c,0x2f, /* l not working?</ */ \
	0x62,0x3e,0x3c,0x62,0x72,0x20,0x2f,0x3e,0x0d,0x0a,0x09,0x59,0x6f,0x75,0x20,0x63, /* b><br />...You c */ \
	0x61,0x6e,0x20,0x72,0x65,0x73,0x74,0x6f,0x72,0x65,0x20,0x63,0x6f,0x6d,0x70,0x69, /* an restore compi */ \
	0x6c,0x65,0x2d,0x74,0x69,0x6d,0x65,0x20,0x73,0x65,0x74,0x74,0x69,0x6e,0x67,0x73, /* le-time settings */ \
	0x20,0x62,0x79,0x20,0x72,0x65,0x73,0x65,0x74,0x74,0x69,0x6e,0x67,0x20,0x74,0x68, /*  by resetting th */ \
	0x65,0x20,0x62,0x6f,0x61,0x72,0x64,0x2e,0x0d,0x0a,0x09,0x50,0x72,0x65,0x73,0x73, /* e board....Press */ \
	0x20,0x4d,0x43,0x4c,0x52,0x20,0x6f,0x72,0x20,0x64,0x69,0x73,0x63,0x6f,0x6e,0x6e, /*  MCLR or disconn */ \
	0x65,0x63,0x74,0x20,0x70,0x6f,0x77,0x65,0x72,0x2e,0x20,0x0d,0x0a,0x09,0x54,0x68, /* ect power. ...Th */ \
	0x69,0x73,0x20,0x70,0x72,0x6f,0x63,0x65,0x64,0x75,0x72,0x65,0x20,0x72,0x65,0x73, /* is procedure res */ \
	0x74,0x6f,0x72,0x65,0x73,0x20,0x74,0x68,0x65,0x20,0x63,0x6f,0x6e,0x66,0x69,0x67, /* tores the config */ \
	0x75,0x72,0x61,0x74,0x69,0x6f,0x6e,0x20,0x73,0x65,0x74,0x74,0x69,0x6e,0x67,0x73, /* uration settings */ \
	0x20,0x69,0x6e,0x20,0x3c,0x63,0x6f,0x64,0x65,0x3e,0x74,0x63,0x70,0x69,0x70,0x5f, /*  in <code>tcpip_ */ \
	0x63,0x6f,0x6e,0x66,0x69,0x67,0x2e,0x68,0x3c,0x2f,0x63,0x6f,0x64,0x65,0x3e,0x2e, /* config.h</code>. */ \
	0x20,0x0d,0x0a,0x09,0x59,0x6f,0x75,0x27,0x6c,0x6c,0x20,0x62,0x65,0x20,0x61,0x62, /*  ...You'll be ab */ \
	0x6c,0x65,0x20,0x74,0x6f,0x20,0x61,0x63,0x63,0x65,0x73,0x73,0x20,0x74,0x68,0x65, /* le to access the */ \
	0x20,0x62,0x6f,0x61,0x72,0x64,0x20,0x61,0x73,0x20,0x79,0x6f,0x75,0x20,0x64,0x69, /*  board as you di */ \
	0x64,0x20,0x77,0x68,0x65,0x6e,0x20,0x66,0x69,0x72,0x73,0x74,0x20,0x63,0x6f,0x6e, /* d when first con */ \
	0x6e,0x65,0x63,0x74,0x69,0x6e,0x67,0x2e,0x20,0x20,0x53,0x65,0x65,0x20,0x74,0x68, /* necting.  See th */ \
	0x65,0x20,0x0d,0x0a,0x09,0x4d,0x69,0x63,0x72,0x6f,0x63,0x68,0x69,0x70,0x20,0x54, /* e ...Microchip T */ \
	0x43,0x50,0x2f,0x49,0x50,0x20,0x53,0x74,0x61,0x63,0x6b,0x20,0x48,0x65,0x6c,0x70, /* CP/IP Stack Help */ \
	0x20,0x64,0x69,0x73,0x74,0x72,0x69,0x62,0x75,0x74,0x65,0x64,0x20,0x77,0x69,0x74, /*  distributed wit */ \
	0x68,0x20,0x74,0x68,0x65,0x20,0x73,0x74,0x61,0x63,0x6b,0x20,0x66,0x6f,0x72,0x20, /* h the stack for  */ \
	0x69,0x6e,0x73,0x74,0x72,0x75,0x63,0x74,0x69,0x6f,0x6e,0x73,0x2e,0x0d,0x0a,0x09, /* instructions.... */ \
	0x28,0x49,0x66,0x20,0x79,0x6f,0x75,0x20,0x61,0x72,0x65,0x20,0x75,0x73,0x69,0x6e, /* (If you are usin */ \
	0x67,0x20,0x61,0x6e,0x20,0x4d,0x50,0x4c,0x41,0x42,0x20,0x49,0x43,0x44,0x20,0x33, /* g an MPLAB ICD 3 */ \
	0x20,0x6f,0x72,0x20,0x4d,0x50,0x4c,0x41,0x42,0x20,0x52,0x45,0x41,0x4c,0x20,0x49, /*  or MPLAB REAL I */ \
	0x43,0x45,0x3c,0x73,0x75,0x70,0x3e,0x54,0x4d,0x3c,0x2f,0x73,0x75,0x70,0x3e,0x20, /* CE<sup>TM</sup>  */ \
	0x69,0x6e,0x20,0x64,0x65,0x62,0x75,0x67,0x20,0x6d,0x6f,0x64,0x65,0x2c,0x20,0x0d, /* in debug mode, . */ \
	0x0a,0x09,0x4d,0x43,0x4c,0x52,0x20,0x77,0x69,0x6c,0x6c,0x20,0x6e,0x6f,0x74,0x20, /* ..MCLR will not  */ \
	0x77,0x6f,0x72,0x6b,0x20,0x61,0x6e,0x64,0x20,0x79,0x6f,0x75,0x27,0x6c,0x6c,0x20, /* work and you'll  */ \
	0x6e,0x65,0x65,0x64,0x20,0x74,0x6f,0x20,0x72,0x65,0x73,0x65,0x74,0x20,0x74,0x68, /* need to reset th */ \
	0x65,0x20,0x62,0x6f,0x61,0x72,0x64,0x20,0x76,0x69,0x61,0x20,0x74,0x68,0x65,0x20, /* e board via the  */ \
	0x4d,0x50,0x4c,0x41,0x42,0x20,0x49,0x44,0x45,0x2e,0x29,0x3c,0x2f,0x6c,0x69,0x3e, /* MPLAB IDE.)</li> */ \
	0x0d,0x0a,0x3c,0x2f,0x6f,0x6c,0x3e,0x0d,0x0a,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d, /* ..</ol>..</div>. */ \
	0x0a,0x0d,0x0a,0x3c,0x73,0x63,0x72,0x69,0x70,0x74,0x20,0x6c,0x61,0x6e,0x67,0x75, /* ...<script langu */ \
	0x61,0x67,0x65,0x3d,0x22,0x6a,0x61,0x76,0x61,0x73,0x63,0x72,0x69,0x70,0x74,0x22, /* age="javascript" */ \
	0x3e,0x0d,0x0a,0x3c,0x21,0x2d,0x2d,0x0d,0x0a,0x66,0x75,0x6e,0x63,0x74,0x69,0x6f, /* >..<!--..functio */ \
	0x6e,0x20,0x72,0x65,0x62,0x6f,0x6f,0x74,0x44,0x75,0x6d,0x6d,0x79,0x28,0x78,0x29, /* n rebootDummy(x) */ \
	0x7b,0x7d,0x0d,0x0a,0x73,0x65,0x74,0x54,0x69,0x6d,0x65,0x6f,0x75,0x74,0x28,0x22, /* {}..setTimeout(" */ \
	0x6e,0x65,0x77,0x41,0x4a,0x41,0x58,0x43,0x6f,0x6d,0x6d,0x61,0x6e,0x64,0x28,0x27, /* newAJAXCommand(' */ \
	0x2f,0x70,0x72,0x6f,0x74,0x65,0x63,0x74,0x2f,0x72,0x65,0x62,0x6f,0x6f,0x74,0x2e, /* /protect/reboot. */ \
	0x63,0x67,0x69,0x27,0x2c,0x72,0x65,0x62,0x6f,0x6f,0x74,0x44,0x75,0x6d,0x6d,0x79, /* cgi',rebootDummy */ \
	0x2c,0x66,0x61,0x6c,0x73,0x65,0x29,0x3b,0x22,0x2c,0x35,0x30,0x30,0x29,0x3b,0x0d, /* ,false);",500);. */ \
	0x0a,0x2f,0x2f,0x2d,0x2d,0x3e,0x0d,0x0a,0x3c,0x2f,0x73,0x63,0x72,0x69,0x70,0x74, /* .//-->..</script */ \
	0x3e,0x0d,0x0a,0x7e,0x69,0x6e,0x63,0x3a,0x66,0x6f,0x6f,0x74,0x65,0x72,0x2e,0x69, /* >..~inc:footer.i */ \
	0x6e,0x63,0x7e,0x0d,0x0a,0x7e,0x69,0x6e,0x63,0x3a,0x68,0x65,0x61,0x64,0x65,0x72, /* nc~..~inc:header */ \
	0x2e,0x69,0x6e,0x63,0x7e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x69,0x64,0x3d,0x22, /* .inc~..<div id=" */ \
	0x63,0x6f,0x6e,0x74,0x65,0x6e,0x74,0x22,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x68,0x31, /* content">....<h1 */ \
	0x3e,0x53,0x65,0x6e,0x64,0x20,0x45,0x2d,0x4d,0x61,0x69,0x6c,0x3c,0x2f,0x68,0x31, /* >Send E-Mail</h1 */ \
	0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x63,0x6c,0x61,0x73,0x73,0x3d, /* >....<div class= */ \
	0x22,0x72,0x65,0x73,0x75,0x6c,0x74,0x20,0x6f,0x6b,0x22,0x20,0x73,0x74,0x79,0x6c, /* "result ok" styl */ \
	0x65,0x3d,0x22,0x64,0x69,0x73,0x70,0x6c,0x61,0x79,0x3a,0x7e,0x73,0x74,0x61,0x74, /* e="display:~stat */ \
	0x75,0x73,0x5f,0x6f,0x6b,0x7e,0x22,0x3e,0x0d,0x0a,0x59,0x6f,0x75,0x72,0x20,0x6d, /* us_ok~">..Your m */ \
	0x65,0x73,0x73,0x61,0x67,0x65,0x20,0x68,0x61,0x73,0x20,0x62,0x65,0x65,0x6e,0x20, /* essage has been  */ \
	0x73,0x65,0x6e,0x74,0x2e,0x0d,0x0a,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x3c, /* sent...</div>..< */ \
	0x64,0x69,0x76,0x20,0x63,0x6c,0x61,0x73,0x73,0x3d,0x22,0x72,0x65,0x73,0x75,0x6c, /* div class="resul */ \
	0x74,0x20,0x66,0x61,0x69,0x6c,0x22,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x22,0x64, /* t fail" style="d */ \
	0x69,0x73,0x70,0x6c,0x61,0x79,0x3a,0x7e,0x73,0x74,0x61,0x74,0x75,0x73,0x5f,0x66, /* isplay:~status_f */ \
	0x61,0x69,0x6c,0x7e,0x22,0x3e,0x0d,0x0a,0x45,0x52,0x52,0x4f,0x52,0x3a,0x20,0x59, /* ail~">..ERROR: Y */ \
	0x6f,0x75,0x72,0x20,0x6d,0x65,0x73,0x73,0x61,0x67,0x65,0x20,0x63,0x6f,0x75,0x6c, /* our message coul */ \
	0x64,0x20,0x6e,0x6f,0x74,0x20,0x62,0x65,0x20,0x73,0x65,0x6e,0x74,0x2e,0x3c,0x62, /* d not be sent.<b */ \
	0x72,0x20,0x2f,0x3e,0x0d,0x0a,0x43,0x68,0x65,0x63,0x6b,0x20,0x79,0x6f,0x75,0x72, /* r />..Check your */ \
	0x20,0x53,0x4d,0x54,0x50,0x20,0x73,0x65,0x72,0x76,0x65,0x72,0x20,0x73,0x65,0x74, /*  SMTP server set */ \
	0x74,0x69,0x6e,0x67,0x73,0x20,0x61,0x6e,0x64,0x20,0x74,0x72,0x79,0x20,0x61,0x67, /* tings and try ag */ \
	0x61,0x69,0x6e,0x2e,0x0d,0x0a,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x0d,0x0a, /* ain...</div>.... */ \
	0x3c,0x70,0x3e,0x42,0x79,0x20,0x63,0x6f,0x6d,0x62,0x69,0x6e,0x69,0x6e,0x67,0x20, /* <p>By combining  */ \
	0x74,0x68,0x65,0x20,0x53,0x4d,0x54,0x50,0x20,0x63,0x6c,0x69,0x65,0x6e,0x74,0x20, /* the SMTP client  */ \
	0x69,0x6e,0x74,0x6f,0x20,0x61,0x6e,0x20,0x48,0x54,0x54,0x50,0x20,0x50,0x4f,0x53, /* into an HTTP POS */ \
	0x54,0x20,0x63,0x61,0x6c,0x6c,0x62,0x61,0x63,0x6b,0x2c,0x20,0x61,0x20,0x66,0x6f, /* T callback, a fo */ \
	0x72,0x6d,0x20,0x0d,0x0a,0x63,0x61,0x6e,0x20,0x62,0x65,0x20,0x64,0x65,0x76,0x65, /* rm ..can be deve */ \
	0x6c,0x6f,0x70,0x65,0x64,0x20,0x74,0x68,0x61,0x74,0x20,0x73,0x65,0x6e,0x64,0x73, /* loped that sends */ \
	0x20,0x61,0x6e,0x20,0x65,0x2d,0x6d,0x61,0x69,0x6c,0x20,0x74,0x6f,0x20,0x61,0x6e, /*  an e-mail to an */ \
	0x20,0x61,0x64,0x6d,0x69,0x6e,0x69,0x73,0x74,0x72,0x61,0x74,0x6f,0x72,0x2e,0x20, /*  administrator.  */ \
	0x20,0x46,0x6f,0x72,0x20,0x6d,0x6f,0x72,0x65,0x0d,0x0a,0x64,0x65,0x74,0x61,0x69, /*  For more..detai */ \
	0x6c,0x73,0x20,0x6f,0x6e,0x20,0x74,0x68,0x65,0x20,0x53,0x4d,0x54,0x50,0x20,0x43, /* ls on the SMTP C */ \
	0x6c,0x69,0x65,0x6e,0x74,0x20,0x6d,0x6f,0x64,0x75,0x6c,0x65,0x2c,0x20,0x70,0x6c, /* lient module, pl */ \
	0x65,0x61,0x73,0x65,0x20,0x73,0x65,0x65,0x20,0x74,0x68,0x65,0x20,0x54,0x43,0x50, /* ease see the TCP */ \
	0x49,0x50,0x20,0x53,0x74,0x61,0x63,0x6b,0x20,0x55,0x73,0x65,0x72,0x27,0x73,0x0d, /* IP Stack User's. */ \
	0x0a,0x47,0x75,0x69,0x64,0x65,0x2e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c, /* .Guide.</p>....< */ \
	0x70,0x3e,0x45,0x6e,0x74,0x65,0x72,0x20,0x74,0x68,0x65,0x20,0x61,0x70,0x70,0x72, /* p>Enter the appr */ \
	0x6f,0x70,0x72,0x69,0x61,0x74,0x65,0x20,0x73,0x65,0x74,0x74,0x69,0x6e,0x67,0x73, /* opriate settings */ \
	0x20,0x69,0x6e,0x20,0x74,0x68,0x65,0x20,0x66,0x69,0x65,0x6c,0x64,0x73,0x20,0x62, /*  in the fields b */ \
	0x65,0x6c,0x6f,0x77,0x3a,0x0d,0x0a,0x3c,0x62,0x72,0x20,0x2f,0x3e,0x28,0x59,0x6f, /* elow:..<br />(Yo */ \
	0x75,0x72,0x20,0x53,0x4d,0x54,0x50,0x20,0x73,0x65,0x72,0x76,0x65,0x72,0x20,0x6d, /* ur SMTP server m */ \
	0x61,0x79,0x20,0x6e,0x6f,0x74,0x20,0x72,0x65,0x71,0x75,0x69,0x72,0x65,0x20,0x61, /* ay not require a */ \
	0x20,0x75,0x73,0x65,0x72,0x20,0x6e,0x61,0x6d,0x65,0x20,0x6f,0x72,0x20,0x70,0x61, /*  user name or pa */ \
	0x73,0x73,0x77,0x6f,0x72,0x64,0x2e,0x29,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a, /* ssword.)</p>.... */ \
	0x3c,0x66,0x6f,0x72,0x6d,0x20,0x6d,0x65,0x74,0x68,0x6f,0x64,0x3d,0x22,0x70,0x6f, /* <form method="po */ \
	0x73,0x74,0x22,0x20,0x61,0x63,0x74,0x69,0x6f,0x6e,0x3d,0x22,0x2f,0x65,0x6d,0x61, /* st" action="/ema */ \
	0x69,0x6c,0x2f,0x69,0x6e,0x64,0x65,0x78,0x2e,0x68,0x74,0x6d,0x22,0x20,0x6f,0x6e, /* il/index.htm" on */ \
	0x73,0x75,0x62,0x6d,0x69,0x74,0x3d,0x22,0x62,0x74,0x6e,0x3d,0x64,0x6f,0x63,0x75, /* submit="btn=docu */ \
	0x6d,0x65,0x6e,0x74,0x2e,0x67,0x65,0x74,0x45,0x6c,0x65,0x6d,0x65,0x6e,0x74,0x42, /* ment.getElementB */ \
	0x79,0x49,0x64,0x28,0x27,0x62,0x74,0x6e,0x53,0x75,0x62,0x6d,0x69,0x74,0x27,0x29, /* yId('btnSubmit') */ \
	0x3b,0x20,0x62,0x74,0x6e,0x2e,0x76,0x61,0x6c,0x75,0x65,0x3d,0x27,0x28,0x70,0x6c, /* ; btn.value='(pl */ \
	0x65,0x61,0x73,0x65,0x20,0x77,0x61,0x69,0x74,0x29,0x27,0x3b,0x20,0x62,0x74,0x6e, /* ease wait)'; btn */ \
	0x2e,0x64,0x69,0x73,0x61,0x62,0x6c,0x65,0x64,0x20,0x3d,0x20,0x74,0x72,0x75,0x65, /* .disabled = true */ \
	0x3b,0x22,0x3e,0x0d,0x0a,0x3c,0x66,0x69,0x65,0x6c,0x64,0x73,0x65,0x74,0x3e,0x0d, /* ;">..<fieldset>. */ \
	0x0a,0x3c,0x64,0x69,0x76,0x3e,0x3c,0x6c,0x61,0x62,0x65,0x6c,0x3e,0x53,0x4d,0x54, /* .<div><label>SMT */ \
	0x50,0x20,0x53,0x65,0x72,0x76,0x65,0x72,0x3a,0x3c,0x2f,0x6c,0x61,0x62,0x65,0x6c, /* P Server:</label */ \
	0x3e,0x0d,0x0a,0x3c,0x69,0x6e,0x70,0x75,0x74,0x20,0x74,0x79,0x70,0x65,0x3d,0x22, /* >..<input type=" */ \
	0x74,0x65,0x78,0x74,0x22,0x20,0x6e,0x61,0x6d,0x65,0x3d,0x22,0x73,0x65,0x72,0x76, /* text" name="serv */ \
	0x65,0x72,0x22,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x22,0x77,0x69,0x64,0x74,0x68, /* er" style="width */ \
	0x3a,0x31,0x36,0x35,0x70,0x78,0x22,0x2f,0x3e,0x0d,0x0a,0x26,0x6e,0x62,0x73,0x70, /* :165px"/>..&nbsp */ \
	0x3b,0x3c,0x62,0x3e,0x50,0x6f,0x72,0x74,0x3a,0x3c,0x2f,0x62,0x3e,0x26,0x6e,0x62, /* ;<b>Port:</b>&nb */ \
	0x73,0x70,0x3b,0x0d,0x0a,0x3c,0x69,0x6e,0x70,0x75,0x74,0x20,0x74,0x79,0x70,0x65, /* sp;..<input type */ \
	0x3d,0x22,0x74,0x65,0x78,0x74,0x22,0x20,0x6e,0x61,0x6d,0x65,0x3d,0x22,0x70,0x6f, /* ="text" name="po */ \
	0x72,0x74,0x22,0x20,0x76,0x61,0x6c,0x75,0x65,0x3d,0x22,0x32,0x35,0x22,0x20,0x73, /* rt" value="25" s */ \
	0x74,0x79,0x6c,0x65,0x3d,0x22,0x77,0x69,0x64,0x74,0x68,0x3a,0x32,0x35,0x70,0x78, /* tyle="width:25px */ \
	0x3b,0x22,0x2f,0x3e,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x3c,0x64,0x69,0x76, /* ;"/></div>..<div */ \
	0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x22,0x64,0x69,0x73,0x70,0x6c,0x61,0x79,0x3a, /*  style="display: */ \
	0x7e,0x73,0x6d,0x74,0x70,0x73,0x5f,0x65,0x6e,0x7e,0x22,0x3e,0x3c,0x69,0x6e,0x70, /* ~smtps_en~"><inp */ \
	0x75,0x74,0x20,0x74,0x79,0x70,0x65,0x3d,0x22,0x63,0x68,0x65,0x63,0x6b,0x62,0x6f, /* ut type="checkbo */ \
	0x78,0x22,0x20,0x6e,0x61,0x6d,0x65,0x3d,0x22,0x73,0x73,0x6c,0x22,0x20,0x76,0x61, /* x" name="ssl" va */ \
	0x6c,0x75,0x65,0x3d,0x22,0x31,0x22,0x20,0x63,0x6c,0x61,0x73,0x73,0x3d,0x22,0x73, /* lue="1" class="s */ \
	0x6d,0x22,0x2f,0x3e,0x20,0x55,0x73,0x65,0x20,0x53,0x53,0x4c,0x20,0x28,0x75,0x73, /* m"/> Use SSL (us */ \
	0x75,0x61,0x6c,0x6c,0x79,0x20,0x70,0x6f,0x72,0x74,0x20,0x34,0x36,0x35,0x29,0x3c, /* ually port 465)< */ \
	0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x3e,0x3c,0x6c,0x61,0x62, /* /div>..<div><lab */ \
	0x65,0x6c,0x3e,0x55,0x73,0x65,0x72,0x20,0x4e,0x61,0x6d,0x65,0x3a,0x3c,0x2f,0x6c, /* el>User Name:</l */ \
	0x61,0x62,0x65,0x6c,0x3e,0x0d,0x0a,0x3c,0x69,0x6e,0x70,0x75,0x74,0x20,0x74,0x79, /* abel>..<input ty */ \
	0x70,0x65,0x3d,0x22,0x74,0x65,0x78,0x74,0x22,0x20,0x6e,0x61,0x6d,0x65,0x3d,0x22, /* pe="text" name=" */ \
	0x75,0x73,0x65,0x72,0x22,0x20,0x2f,0x3e,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a, /* user" /></div>.. */ \
	0x3c,0x64,0x69,0x76,0x3e,0x3c,0x6c,0x61,0x62,0x65,0x6c,0x3e,0x50,0x61,0x73,0x73, /* <div><label>Pass */ \
	0x77,0x6f,0x72,0x64,0x3a,0x3c,0x2f,0x6c,0x61,0x62,0x65,0x6c,0x3e,0x0d,0x0a,0x3c, /* word:</label>..< */ \
	0x69,0x6e,0x70,0x75,0x74,0x20,0x74,0x79,0x70,0x65,0x3d,0x22,0x70,0x61,0x73,0x73, /* input type="pass */ \
	0x77,0x6f,0x72,0x64,0x22,0x20,0x6e,0x61,0x6d,0x65,0x3d,0x22,0x70,0x61,0x73,0x73, /* word" name="pass */ \
	0x22,0x20,0x2f,0x3e,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x3c,0x64,0x69,0x76, /* " /></div>..<div */ \
	0x3e,0x26,0x6e,0x62,0x73,0x70,0x3b,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x0d, /* >&nbsp;</div>... */ \
	0x0a,0x3c,0x64,0x69,0x76,0x3e,0x3c,0x6c,0x61,0x62,0x65,0x6c,0x3e,0x54,0x6f,0x3a, /* .<div><label>To: */ \
	0x3c,0x2f,0x6c,0x61,0x62,0x65,0x6c,0x3e,0x0d,0x0a,0x3c,0x69,0x6e,0x70,0x75,0x74, /* </label>..<input */ \
	0x20,0x74,0x79,0x70,0x65,0x3d,0x22,0x74,0x65,0x78,0x74,0x22,0x20,0x6e,0x61,0x6d, /*  type="text" nam */ \
	0x65,0x3d,0x22,0x74,0x6f,0x22,0x20,0x2f,0x3e,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d, /* e="to" /></div>. */ \
	0x0a,0x3c,0x64,0x69,0x76,0x3e,0x3c,0x6c,0x61,0x62,0x65,0x6c,0x3e,0x4d,0x65,0x73, /* .<div><label>Mes */ \
	0x73,0x61,0x67,0x65,0x3a,0x3c,0x2f,0x6c,0x61,0x62,0x65,0x6c,0x3e,0x0d,0x0a,0x3c, /* sage:</label>..< */ \
	0x74,0x65,0x78,0x74,0x61,0x72,0x65,0x61,0x20,0x6e,0x61,0x6d,0x65,0x3d,0x22,0x6d, /* textarea name="m */ \
	0x73,0x67,0x22,0x20,0x72,0x6f,0x77,0x73,0x3d,0x22,0x36,0x22,0x3e,0x54,0x68,0x69, /* sg" rows="6">Thi */ \
	0x73,0x20,0x6d,0x65,0x73,0x73,0x61,0x67,0x65,0x20,0x77,0x61,0x73,0x20,0x73,0x65, /* s message was se */ \
	0x6e,0x74,0x20,0x62,0x79,0x20,0x74,0x68,0x65,0x20,0x4d,0x69,0x63,0x72,0x6f,0x63, /* nt by the Microc */ \
	0x68,0x69,0x70,0x20,0x54,0x43,0x50,0x2f,0x49,0x50,0x20,0x53,0x74,0x61,0x63,0x6b, /* hip TCP/IP Stack */ \
	0x2e,0x20,0x20,0x53,0x65,0x65,0x20,0x74,0x68,0x65,0x20,0x61,0x74,0x74,0x61,0x63, /* .  See the attac */ \
	0x68,0x65,0x64,0x20,0x66,0x69,0x6c,0x65,0x20,0x66,0x6f,0x72,0x20,0x63,0x75,0x72, /* hed file for cur */ \
	0x72,0x65,0x6e,0x74,0x20,0x73,0x79,0x73,0x74,0x65,0x6d,0x20,0x73,0x74,0x61,0x74, /* rent system stat */ \
	0x75,0x73,0x20,0x69,0x6e,0x66,0x6f,0x72,0x6d,0x61,0x74,0x69,0x6f,0x6e,0x2e,0x20, /* us information.  */ \
	0x20,0x54,0x68,0x65,0x20,0x61,0x74,0x74,0x61,0x63,0x68,0x65,0x64,0x20,0x43,0x53, /*  The attached CS */ \
	0x56,0x20,0x66,0x69,0x6c,0x65,0x20,0x77,0x69,0x6c,0x6c,0x20,0x6f,0x70,0x65,0x6e, /* V file will open */ \
	0x20,0x69,0x6e,0x20,0x61,0x6e,0x79,0x20,0x73,0x70,0x72,0x65,0x61,0x64,0x73,0x68, /*  in any spreadsh */ \
	0x65,0x65,0x74,0x20,0x70,0x72,0x6f,0x67,0x72,0x61,0x6d,0x2e,0x3c,0x2f,0x74,0x65, /* eet program.</te */ \
	0x78,0x74,0x61,0x72,0x65,0x61,0x3e,0x0d,0x0a,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d, /* xtarea>..</div>. */ \
	0x0a,0x3c,0x64,0x69,0x76,0x3e,0x3c,0x69,0x6e,0x70,0x75,0x74,0x20,0x69,0x64,0x3d, /* .<div><input id= */ \
	0x22,0x62,0x74,0x6e,0x53,0x75,0x62,0x6d,0x69,0x74,0x22,0x20,0x74,0x79,0x70,0x65, /* "btnSubmit" type */ \
	0x3d,0x22,0x73,0x75,0x62,0x6d,0x69,0x74,0x22,0x20,0x63,0x6c,0x61,0x73,0x73,0x3d, /* ="submit" class= */ \
	0x22,0x73,0x6d,0x22,0x20,0x76,0x61,0x6c,0x75,0x65,0x3d,0x22,0x53,0x65,0x6e,0x64, /* "sm" value="Send */ \
	0x20,0x4d,0x65,0x73,0x73,0x61,0x67,0x65,0x22,0x2f,0x3e,0x3c,0x2f,0x64,0x69,0x76, /*  Message"/></div */ \
	0x3e,0x0d,0x0a,0x3c,0x2f,0x66,0x69,0x65,0x6c,0x64,0x73,0x65,0x74,0x3e,0x0d,0x0a, /* >..</fieldset>.. */ \
	0x3c,0x2f,0x66,0x6f,0x72,0x6d,0x3e,0x0d,0x0a,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d, /* </form>..</div>. */ \
	0x0a,0x0d,0x0a,0x3c,0x73,0x63,0x72,0x69,0x70,0x74,0x20,0x74,0x79,0x70,0x65,0x3d, /* ...<script type= */ \
	0x22,0x74,0x65,0x78,0x74,0x2f,0x6a,0x61,0x76,0x61,0x73,0x63,0x72,0x69,0x70,0x74, /* "text/javascript */ \
	0x22,0x3e,0x0d,0x0a,0x3c,0x21,0x2d,0x2d,0x0d,0x0a,0x64,0x6f,0x63,0x75,0x6d,0x65, /* ">..<!--..docume */ \
	0x6e,0x74,0x2e,0x67,0x65,0x74,0x45,0x6c,0x65,0x6d,0x65,0x6e,0x74,0x42,0x79,0x49, /* nt.getElementByI */ \
	0x64,0x28,0x27,0x68,0x65,0x6c,0x6c,0x6f,0x27,0x29,0x2e,0x69,0x6e,0x6e,0x65,0x72, /* d('hello').inner */ \
	0x48,0x54,0x4d,0x4c,0x20,0x3d,0x20,0x22,0x7e,0x68,0x65,0x6c,0x6c,0x6f,0x6d,0x73, /* HTML = "~helloms */ \
	0x67,0x7e,0x22,0x3b,0x0d,0x0a,0x2d,0x2d,0x3e,0x0d,0x0a,0x3c,0x2f,0x73,0x63,0x72, /* g~";..-->..</scr */ \
	0x69,0x70,0x74,0x3e,0x0d,0x0a,0x7e,0x69,0x6e,0x63,0x3a,0x66,0x6f,0x6f,0x74,0x65, /* ipt>..~inc:foote */ \
	0x72,0x2e,0x69,0x6e,0x63,0x7e,0x0d,0x0a,0x7e,0x69,0x6e,0x63,0x3a,0x68,0x65,0x61, /* r.inc~..~inc:hea */ \
	0x64,0x65,0x72,0x2e,0x69,0x6e,0x63,0x7e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x69, /* der.inc~..<div i */ \
	0x64,0x3d,0x22,0x63,0x6f,0x6e,0x74,0x65,0x6e,0x74,0x22,0x3e,0x0d,0x0a,0x0d,0x0a, /* d="content">.... */ \
	0x3c,0x68,0x31,0x3e,0x44,0x79,0x6e,0x61,0x6d,0x69,0x63,0x20,0x44,0x4e,0x53,0x3c, /* <h1>Dynamic DNS< */ \
	0x2f,0x68,0x31,0x3e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x63,0x6c,0x61,0x73,0x73, /* /h1>..<div class */ \
	0x3d,0x22,0x72,0x65,0x73,0x75,0x6c,0x74,0x20,0x6f,0x6b,0x22,0x20,0x73,0x74,0x79, /* ="result ok" sty */ \
	0x6c,0x65,0x3d,0x22,0x64,0x69,0x73,0x70,0x6c,0x61,0x79,0x3a,0x7e,0x73,0x74,0x61, /* le="display:~sta */ \
	0x74,0x75,0x73,0x5f,0x6f,0x6b,0x7e,0x22,0x3e,0x0d,0x0a,0x59,0x6f,0x75,0x72,0x20, /* tus_ok~">..Your  */ \
	0x73,0x65,0x74,0x74,0x69,0x6e,0x67,0x73,0x20,0x68,0x61,0x76,0x65,0x20,0x62,0x65, /* settings have be */ \
	0x65,0x6e,0x20,0x73,0x61,0x76,0x65,0x64,0x2e,0x0d,0x0a,0x3c,0x2f,0x64,0x69,0x76, /* en saved...</div */ \
	0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x63,0x6c,0x61,0x73,0x73,0x3d, /* >....<div class= */ \
	0x22,0x72,0x65,0x73,0x75,0x6c,0x74,0x20,0x7e,0x64,0x64,0x6e,0x73,0x5f,0x73,0x74, /* "result ~ddns_st */ \
	0x61,0x74,0x75,0x73,0x7e,0x22,0x3e,0x0d,0x0a,0x7e,0x64,0x64,0x6e,0x73,0x5f,0x73, /* atus~">..~ddns_s */ \
	0x74,0x61,0x74,0x75,0x73,0x5f,0x6d,0x73,0x67,0x7e,0x0d,0x0a,0x3c,0x2f,0x64,0x69, /* tatus_msg~..</di */ \
	0x76,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70,0x3e,0x54,0x68,0x65,0x20,0x44,0x79,0x6e, /* v>....<p>The Dyn */ \
	0x61,0x6d,0x69,0x63,0x20,0x44,0x4e,0x53,0x20,0x6d,0x6f,0x64,0x75,0x6c,0x65,0x20, /* amic DNS module  */ \
	0x61,0x6c,0x6c,0x6f,0x77,0x73,0x20,0x74,0x68,0x65,0x20,0x73,0x74,0x61,0x63,0x6b, /* allows the stack */ \
	0x20,0x74,0x6f,0x20,0x75,0x70,0x64,0x61,0x74,0x65,0x20,0x74,0x68,0x65,0x20,0x62, /*  to update the b */ \
	0x6f,0x61,0x72,0x64,0x27,0x73,0x20,0x67,0x6c,0x6f,0x62,0x61,0x6c,0x20,0x49,0x50, /* oard's global IP */ \
	0x20,0x0d,0x0a,0x61,0x64,0x64,0x72,0x65,0x73,0x73,0x20,0x74,0x6f,0x20,0x76,0x61, /*  ..address to va */ \
	0x72,0x69,0x6f,0x75,0x73,0x20,0x44,0x79,0x6e,0x61,0x6d,0x69,0x63,0x20,0x44,0x4e, /* rious Dynamic DN */ \
	0x53,0x20,0x73,0x65,0x72,0x76,0x69,0x63,0x65,0x73,0x2e,0x20,0x20,0x54,0x68,0x69, /* S services.  Thi */ \
	0x73,0x20,0x66,0x65,0x61,0x74,0x75,0x72,0x65,0x2c,0x20,0x61,0x6c,0x6f,0x6e,0x67, /* s feature, along */ \
	0x20,0x77,0x69,0x74,0x68,0x20,0x70,0x72,0x6f,0x70,0x65,0x72,0x0d,0x0a,0x70,0x6f, /*  with proper..po */ \
	0x72,0x74,0x20,0x66,0x6f,0x72,0x77,0x61,0x72,0x64,0x69,0x6e,0x67,0x20,0x69,0x6e, /* rt forwarding in */ \
	0x20,0x70,0x6c,0x61,0x63,0x65,0x20,0x61,0x74,0x20,0x74,0x68,0x65,0x20,0x72,0x6f, /*  place at the ro */ \
	0x75,0x74,0x65,0x72,0x2c,0x20,0x63,0x61,0x6e,0x20,0x65,0x6e,0x61,0x62,0x6c,0x65, /* uter, can enable */ \
	0x20,0x67,0x6c,0x6f,0x62,0x61,0x6c,0x20,0x61,0x63,0x63,0x65,0x73,0x73,0x20,0x74, /*  global access t */ \
	0x6f,0x20,0x61,0x20,0x0d,0x0a,0x64,0x65,0x76,0x69,0x63,0x65,0x20,0x62,0x65,0x68, /* o a ..device beh */ \
	0x69,0x6e,0x64,0x20,0x61,0x20,0x4e,0x41,0x54,0x20,0x72,0x6f,0x75,0x74,0x65,0x72, /* ind a NAT router */ \
	0x20,0x6f,0x72,0x20,0x66,0x69,0x72,0x65,0x77,0x61,0x6c,0x6c,0x2e,0x3c,0x2f,0x70, /*  or firewall.</p */ \
	0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70,0x3e,0x45,0x6e,0x74,0x65,0x72,0x20,0x74,0x68, /* >....<p>Enter th */ \
	0x65,0x20,0x73,0x65,0x74,0x74,0x69,0x6e,0x67,0x73,0x20,0x69,0x6e,0x20,0x74,0x68, /* e settings in th */ \
	0x65,0x20,0x66,0x69,0x65,0x6c,0x64,0x73,0x20,0x62,0x65,0x6c,0x6f,0x77,0x3a,0x3c, /* e fields below:< */ \
	0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x66,0x6f,0x72,0x6d,0x20,0x6d,0x65,0x74, /* /p>....<form met */ \
	0x68,0x6f,0x64,0x3d,0x22,0x70,0x6f,0x73,0x74,0x22,0x20,0x61,0x63,0x74,0x69,0x6f, /* hod="post" actio */ \
	0x6e,0x3d,0x22,0x2f,0x64,0x79,0x6e,0x64,0x6e,0x73,0x2f,0x69,0x6e,0x64,0x65,0x78, /* n="/dyndns/index */ \
	0x2e,0x68,0x74,0x6d,0x22,0x3e,0x0d,0x0a,0x3c,0x66,0x69,0x65,0x6c,0x64,0x73,0x65, /* .htm">..<fieldse */ \
	0x74,0x3e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x3e,0x3c,0x6c,0x61,0x62,0x65,0x6c,0x3e, /* t>..<div><label> */ \
	0x44,0x44,0x4e,0x53,0x20,0x53,0x65,0x72,0x76,0x69,0x63,0x65,0x3a,0x3c,0x2f,0x6c, /* DDNS Service:</l */ \
	0x61,0x62,0x65,0x6c,0x3e,0x0d,0x0a,0x3c,0x73,0x65,0x6c,0x65,0x63,0x74,0x20,0x6e, /* abel>..<select n */ \
	0x61,0x6d,0x65,0x3d,0x22,0x73,0x65,0x72,0x76,0x69,0x63,0x65,0x22,0x3e,0x0d,0x0a, /* ame="service">.. */ \
	0x3c,0x6f,0x70,0x74,0x69,0x6f,0x6e,0x20,0x76,0x61,0x6c,0x75,0x65,0x3d,0x22,0x30, /* <option value="0 */ \
	0x22,0x20,0x7e,0x64,0x64,0x6e,0x73,0x5f,0x73,0x65,0x72,0x76,0x69,0x63,0x65,0x28, /* " ~ddns_service( */ \
	0x30,0x29,0x7e,0x3e,0x44,0x79,0x6e,0x44,0x4e,0x53,0x20,0x28,0x77,0x77,0x77,0x2e, /* 0)~>DynDNS (www. */ \
	0x64,0x79,0x6e,0x64,0x6e,0x73,0x2e,0x63,0x6f,0x6d,0x29,0x3c,0x2f,0x6f,0x70,0x74, /* dyndns.com)</opt */ \
	0x69,0x6f,0x6e,0x3e,0x0d,0x0a,0x3c,0x6f,0x70,0x74,0x69,0x6f,0x6e,0x20,0x76,0x61, /* ion>..<option va */ \
	0x6c,0x75,0x65,0x3d,0x22,0x31,0x22,0x20,0x7e,0x64,0x64,0x6e,0x73,0x5f,0x73,0x65, /* lue="1" ~ddns_se */ \
	0x72,0x76,0x69,0x63,0x65,0x28,0x31,0x29,0x7e,0x3e,0x4e,0x6f,0x2d,0x49,0x50,0x20, /* rvice(1)~>No-IP  */ \
	0x28,0x77,0x77,0x77,0x2e,0x6e,0x6f,0x2d,0x69,0x70,0x2e,0x63,0x6f,0x6d,0x29,0x3c, /* (www.no-ip.com)< */ \
	0x2f,0x6f,0x70,0x74,0x69,0x6f,0x6e,0x3e,0x0d,0x0a,0x3c,0x6f,0x70,0x74,0x69,0x6f, /* /option>..<optio */ \
	0x6e,0x20,0x76,0x61,0x6c,0x75,0x65,0x3d,0x22,0x32,0x22,0x20,0x7e,0x64,0x64,0x6e, /* n value="2" ~ddn */ \
	0x73,0x5f,0x73,0x65,0x72,0x76,0x69,0x63,0x65,0x28,0x32,0x29,0x7e,0x3e,0x44,0x4e, /* s_service(2)~>DN */ \
	0x53,0x2d,0x4f,0x2d,0x4d,0x61,0x74,0x69,0x63,0x20,0x28,0x77,0x77,0x77,0x2e,0x64, /* S-O-Matic (www.d */ \
	0x6e,0x73,0x6f,0x6d,0x61,0x74,0x69,0x63,0x2e,0x63,0x6f,0x6d,0x29,0x3c,0x2f,0x6f, /* nsomatic.com)</o */ \
	0x70,0x74,0x69,0x6f,0x6e,0x3e,0x0d,0x0a,0x3c,0x2f,0x73,0x65,0x6c,0x65,0x63,0x74, /* ption>..</select */ \
	0x3e,0x0d,0x0a,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x3e, /* >..</div>..<div> */ \
	0x3c,0x6c,0x61,0x62,0x65,0x6c,0x3e,0x55,0x73,0x65,0x72,0x20,0x4e,0x61,0x6d,0x65, /* <label>User Name */ \
	0x3a,0x3c,0x2f,0x6c,0x61,0x62,0x65,0x6c,0x3e,0x0d,0x0a,0x3c,0x69,0x6e,0x70,0x75, /* :</label>..<inpu */ \
	0x74,0x20,0x74,0x79,0x70,0x65,0x3d,0x22,0x74,0x65,0x78,0x74,0x22,0x20,0x6e,0x61, /* t type="text" na */ \
	0x6d,0x65,0x3d,0x22,0x75,0x73,0x65,0x72,0x22,0x20,0x6d,0x61,0x78,0x6c,0x65,0x6e, /* me="user" maxlen */ \
	0x67,0x74,0x68,0x3d,0x22,0x34,0x30,0x22,0x20,0x76,0x61,0x6c,0x75,0x65,0x3d,0x22, /* gth="40" value=" */ \
	0x7e,0x64,0x64,0x6e,0x73,0x5f,0x75,0x73,0x65,0x72,0x7e,0x22,0x2f,0x3e,0x3c,0x2f, /* ~ddns_user~"/></ */ \
	0x64,0x69,0x76,0x3e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x3e,0x3c,0x6c,0x61,0x62,0x65, /* div>..<div><labe */ \
	0x6c,0x3e,0x50,0x61,0x73,0x73,0x77,0x6f,0x72,0x64,0x3a,0x3c,0x2f,0x6c,0x61,0x62, /* l>Password:</lab */ \
	0x65,0x6c,0x3e,0x0d,0x0a,0x3c,0x69,0x6e,0x70,0x75,0x74,0x20,0x74,0x79,0x70,0x65, /* el>..<input type */ \
	0x3d,0x22,0x70,0x61,0x73,0x73,0x77,0x6f,0x72,0x64,0x22,0x20,0x6e,0x61,0x6d,0x65, /* ="password" name */ \
	0x3d,0x22,0x70,0x61,0x73,0x73,0x22,0x20,0x6d,0x61,0x78,0x6c,0x65,0x6e,0x67,0x74, /* ="pass" maxlengt */ \
	0x68,0x3d,0x22,0x32,0x34,0x22,0x20,0x76,0x61,0x6c,0x75,0x65,0x3d,0x22,0x7e,0x64, /* h="24" value="~d */ \
	0x64,0x6e,0x73,0x5f,0x70,0x61,0x73,0x73,0x7e,0x22,0x2f,0x3e,0x3c,0x2f,0x64,0x69, /* dns_pass~"/></di */ \
	0x76,0x3e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x3e,0x3c,0x6c,0x61,0x62,0x65,0x6c,0x3e, /* v>..<div><label> */ \
	0x48,0x6f,0x73,0x74,0x3a,0x3c,0x2f,0x6c,0x61,0x62,0x65,0x6c,0x3e,0x0d,0x0a,0x3c, /* Host:</label>..< */ \
	0x69,0x6e,0x70,0x75,0x74,0x20,0x74,0x79,0x70,0x65,0x3d,0x22,0x74,0x65,0x78,0x74, /* input type="text */ \
	0x22,0x20,0x6e,0x61,0x6d,0x65,0x3d,0x22,0x68,0x6f,0x73,0x74,0x22,0x20,0x6d,0x61, /* " name="host" ma */ \
	0x78,0x6c,0x65,0x6e,0x67,0x74,0x68,0x3d,0x22,0x34,0x38,0x22,0x20,0x76,0x61,0x6c, /* xlength="48" val */ \
	0x75,0x65,0x3d,0x22,0x7e,0x64,0x64,0x6e,0x73,0x5f,0x68,0x6f,0x73,0x74,0x7e,0x22, /* ue="~ddns_host~" */ \
	0x20,0x2f,0x3e,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x3e, /*  /></div>..<div> */ \
	0x3c,0x69,0x6e,0x70,0x75,0x74,0x20,0x74,0x79,0x70,0x65,0x3d,0x22,0x73,0x75,0x62, /* <input type="sub */ \
	0x6d,0x69,0x74,0x22,0x20,0x63,0x6c,0x61,0x73,0x73,0x3d,0x22,0x73,0x6d,0x22,0x20, /* mit" class="sm"  */ \
	0x76,0x61,0x6c,0x75,0x65,0x3d,0x22,0x53,0x65,0x74,0x20,0x44,0x44,0x4e,0x53,0x20, /* value="Set DDNS  */ \
	0x43,0x6f,0x6e,0x66,0x69,0x67,0x75,0x72,0x61,0x74,0x69,0x6f,0x6e,0x22,0x2f,0x3e, /* Configuration"/> */ \
	0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x3c,0x2f,0x66,0x69,0x65,0x6c,0x64,0x73, /* </div>..</fields */ \
	0x65,0x74,0x3e,0x0d,0x0a,0x3c,0x2f,0x66,0x6f,0x72,0x6d,0x3e,0x0d,0x0a,0x3c,0x2f, /* et>..</form>..</ */ \
	0x64,0x69,0x76,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x73,0x63,0x72,0x69,0x70,0x74,0x20, /* div>....<script  */ \
	0x74,0x79,0x70,0x65,0x3d,0x22,0x74,0x65,0x78,0x74,0x2f,0x6a,0x61,0x76,0x61,0x73, /* type="text/javas */ \
	0x63,0x72,0x69,0x70,0x74,0x22,0x3e,0x0d,0x0a,0x3c,0x21,0x2d,0x2d,0x0d,0x0a,0x64, /* cript">..<!--..d */ \
	0x6f,0x63,0x75,0x6d,0x65,0x6e,0x74,0x2e,0x67,0x65,0x74,0x45,0x6c,0x65,0x6d,0x65, /* ocument.getEleme */ \
	0x6e,0x74,0x42,0x79,0x49,0x64,0x28,0x27,0x68,0x65,0x6c,0x6c,0x6f,0x27,0x29,0x2e, /* ntById('hello'). */ \
	0x69,0x6e,0x6e,0x65,0x72,0x48,0x54,0x4d,0x4c,0x20,0x3d,0x20,0x22,0x7e,0x68,0x65, /* innerHTML = "~he */ \
	0x6c,0x6c,0x6f,0x6d,0x73,0x67,0x7e,0x22,0x3b,0x0d,0x0a,0x2d,0x2d,0x3e,0x0d,0x0a, /* llomsg~";..-->.. */ \
	0x3c,0x2f,0x73,0x63,0x72,0x69,0x70,0x74,0x3e,0x0d,0x0a,0x7e,0x69,0x6e,0x63,0x3a, /* </script>..~inc: */ \
	0x66,0x6f,0x6f,0x74,0x65,0x72,0x2e,0x69,0x6e,0x63,0x7e,0x0d,0x0a                 /* footer.inc~..    */


};
<#elseif CONFIG_DRV_WIFI_HTTP_CUSTOM_TEMPLATE == "Easy Configuration Demo">
const uint8_t __attribute__((space(prog),address(DRV_NVM_MEDIA_START_ADDRESS))) NVM_MEDIA_DATA[DRV_NVM_MEDIA_SIZE*1024] = { \
	0x4d,0x50,0x46,0x53,0x02,0x01,0x17,0x00,0x6a,0xfd,0xf0,0x94,0xca,0xa7,0x92,0x6c, /* MPFS....j......l */ \
	0xf0,0xd6,0x26,0x4f,0x26,0x2d,0x0a,0xa3,0x46,0xce,0x2a,0xcf,0x3e,0x67,0x8a,0x10, /* ..&O&-..F...>g.. */ \
	0xe6,0xd2,0xcc,0x83,0x46,0xbc,0x66,0xbc,0x86,0xbc,0xa6,0xbc,0x46,0xd6,0x46,0x7a, /* ....F.f.....F.Fz */ \
	0xa8,0x8f,0x86,0x74,0x08,0x71,0x30,0x02,0x00,0x00,0x66,0x03,0x00,0x00,0x40,0x03, /* ...t.q0...f...@. */ \
	0x00,0x00,0x87,0x22,0x28,0x56,0x00,0x00,0x00,0x00,0x02,0x00,0x3e,0x02,0x00,0x00, /* ..."(V......>... */ \
	0xa6,0x06,0x00,0x00,0x34,0x01,0x00,0x00,0xd2,0x5c,0x4a,0x56,0x00,0x00,0x00,0x00, /* ....4....\JV.... */ \
	0x00,0x00,0x4a,0x02,0x00,0x00,0xda,0x07,0x00,0x00,0xfd,0x00,0x00,0x00,0x87,0x22, /* ..J............" */ \
	0x28,0x56,0x00,0x00,0x00,0x00,0x01,0x00,0x54,0x02,0x00,0x00,0xd7,0x08,0x00,0x00, /* (V......T....... */ \
	0x8d,0x0e,0x00,0x00,0x87,0x22,0x28,0x56,0x00,0x00,0x00,0x00,0x01,0x00,0x60,0x02, /* ....."(V......`. */ \
	0x00,0x00,0x64,0x17,0x00,0x00,0x40,0x00,0x00,0x00,0xd2,0x5c,0x4a,0x56,0x00,0x00, /* ..d...@....\JV.. */ \
	0x00,0x00,0x00,0x00,0x6d,0x02,0x00,0x00,0xa4,0x17,0x00,0x00,0xa1,0x00,0x00,0x00, /* ....m........... */ \
	0x46,0x05,0x39,0x56,0x00,0x00,0x00,0x00,0x00,0x00,0x78,0x02,0x00,0x00,0x45,0x18, /* F.9V......x...E. */ \
	0x00,0x00,0xac,0x03,0x00,0x00,0x87,0x22,0x28,0x56,0x00,0x00,0x00,0x00,0x00,0x00, /* ......."(V...... */ \
	0x83,0x02,0x00,0x00,0xf1,0x1b,0x00,0x00,0xd9,0x0f,0x00,0x00,0x87,0x22,0x28,0x56, /* ............."(V */ \
	0x00,0x00,0x00,0x00,0x02,0x00,0x8d,0x02,0x00,0x00,0xca,0x2b,0x00,0x00,0x11,0x00, /* ...........+.... */ \
	0x00,0x00,0x87,0x22,0x28,0x56,0x00,0x00,0x00,0x00,0x02,0x00,0x96,0x02,0x00,0x00, /* ..."(V.......... */ \
	0xdb,0x2b,0x00,0x00,0x9d,0x03,0x00,0x00,0x87,0x22,0x28,0x56,0x00,0x00,0x00,0x00, /* .+......."(V.... */ \
	0x01,0x00,0x9f,0x02,0x00,0x00,0x78,0x2f,0x00,0x00,0xf3,0x17,0x00,0x00,0xf9,0x48, /* ......x/.......H */ \
	0x45,0x56,0x00,0x00,0x00,0x00,0x01,0x00,0xa7,0x02,0x00,0x00,0x6b,0x47,0x00,0x00, /* EV..........kG.. */ \
	0x44,0x02,0x00,0x00,0x87,0x22,0x28,0x56,0x00,0x00,0x00,0x00,0x02,0x00,0xb5,0x02, /* D...."(V........ */ \
	0x00,0x00,0xaf,0x49,0x00,0x00,0x0f,0x00,0x00,0x00,0x87,0x22,0x28,0x56,0x00,0x00, /* ...I......."(V.. */ \
	0x00,0x00,0x02,0x00,0xbe,0x02,0x00,0x00,0xbe,0x49,0x00,0x00,0xd3,0x01,0x00,0x00, /* .........I...... */ \
	0x87,0x22,0x28,0x56,0x00,0x00,0x00,0x00,0x02,0x00,0xc9,0x02,0x00,0x00,0x91,0x4b, /* ."(V...........K */ \
	0x00,0x00,0x9e,0x01,0x00,0x00,0x87,0x22,0x28,0x56,0x00,0x00,0x00,0x00,0x00,0x00, /* ......."(V...... */ \
	0xda,0x02,0x00,0x00,0x2f,0x4d,0x00,0x00,0xff,0x01,0x00,0x00,0x87,0x22,0x28,0x56, /* ..../M......."(V */ \
	0x00,0x00,0x00,0x00,0x00,0x00,0xeb,0x02,0x00,0x00,0x2e,0x4f,0x00,0x00,0xfe,0x01, /* ...........O.... */ \
	0x00,0x00,0x87,0x22,0x28,0x56,0x00,0x00,0x00,0x00,0x00,0x00,0xfc,0x02,0x00,0x00, /* ..."(V.......... */ \
	0x2c,0x51,0x00,0x00,0x35,0x02,0x00,0x00,0x87,0x22,0x28,0x56,0x00,0x00,0x00,0x00, /* ,Q..5...."(V.... */ \
	0x00,0x00,0x0d,0x03,0x00,0x00,0x61,0x53,0x00,0x00,0x80,0x00,0x00,0x00,0x87,0x22, /* ......aS......." */ \
	0x28,0x56,0x00,0x00,0x00,0x00,0x00,0x00,0x1e,0x03,0x00,0x00,0xe1,0x53,0x00,0x00, /* (V...........S.. */ \
	0x2e,0x01,0x00,0x00,0x87,0x22,0x28,0x56,0x00,0x00,0x00,0x00,0x00,0x00,0x33,0x03, /* ....."(V......3. */ \
	0x00,0x00,0x0f,0x55,0x00,0x00,0x3d,0x10,0x00,0x00,0x87,0x22,0x28,0x56,0x00,0x00, /* ...U..=...."(V.. */ \
	0x00,0x00,0x01,0x00,0x46,0x03,0x00,0x00,0x4c,0x65,0x00,0x00,0x11,0x01,0x00,0x00, /* ....F...Le...... */ \
	0x87,0x22,0x28,0x56,0x00,0x00,0x00,0x00,0x00,0x00,0x56,0x03,0x00,0x00,0x5d,0x66, /* ."(V......V...]f */ \
	0x00,0x00,0xe2,0x04,0x00,0x00,0x87,0x22,0x28,0x56,0x00,0x00,0x00,0x00,0x01,0x00, /* ......."(V...... */ \
	0x63,0x6f,0x6e,0x66,0x69,0x67,0x75,0x72,0x65,0x2e,0x68,0x74,0x6d,0x00,0x44,0x79, /* configure.htm.Dy */ \
	0x6e,0x52,0x63,0x72,0x64,0x2e,0x62,0x69,0x6e,0x00,0x65,0x72,0x72,0x6f,0x72,0x2e, /* nRcrd.bin.error. */ \
	0x68,0x74,0x6d,0x00,0x66,0x61,0x76,0x69,0x63,0x6f,0x6e,0x2e,0x69,0x63,0x6f,0x00, /* htm.favicon.ico. */ \
	0x46,0x69,0x6c,0x65,0x52,0x63,0x72,0x64,0x2e,0x62,0x69,0x6e,0x00,0x66,0x6f,0x6f, /* FileRcrd.bin.foo */ \
	0x74,0x65,0x72,0x2e,0x69,0x6e,0x63,0x00,0x68,0x65,0x61,0x64,0x65,0x72,0x2e,0x69, /* ter.inc.header.i */ \
	0x6e,0x63,0x00,0x69,0x6e,0x64,0x65,0x78,0x2e,0x68,0x74,0x6d,0x00,0x6c,0x65,0x64, /* nc.index.htm.led */ \
	0x73,0x2e,0x63,0x67,0x69,0x00,0x6d,0x63,0x68,0x70,0x2e,0x63,0x73,0x73,0x00,0x6d, /* s.cgi.mchp.css.m */ \
	0x63,0x68,0x70,0x2e,0x6a,0x73,0x00,0x72,0x65,0x63,0x6f,0x6e,0x6e,0x65,0x63,0x74, /* chp.js.reconnect */ \
	0x2e,0x68,0x74,0x6d,0x00,0x73,0x63,0x61,0x6e,0x2e,0x63,0x67,0x69,0x00,0x73,0x74, /* .htm.scan.cgi.st */ \
	0x61,0x74,0x75,0x73,0x2e,0x78,0x6d,0x6c,0x00,0x69,0x6d,0x61,0x67,0x65,0x73,0x2f, /* atus.xml.images/ */ \
	0x62,0x61,0x72,0x2d,0x31,0x2e,0x70,0x6e,0x67,0x00,0x69,0x6d,0x61,0x67,0x65,0x73, /* bar-1.png.images */ \
	0x2f,0x62,0x61,0x72,0x2d,0x32,0x2e,0x70,0x6e,0x67,0x00,0x69,0x6d,0x61,0x67,0x65, /* /bar-2.png.image */ \
	0x73,0x2f,0x62,0x61,0x72,0x2d,0x33,0x2e,0x70,0x6e,0x67,0x00,0x69,0x6d,0x61,0x67, /* s/bar-3.png.imag */ \
	0x65,0x73,0x2f,0x62,0x61,0x72,0x2d,0x34,0x2e,0x70,0x6e,0x67,0x00,0x69,0x6d,0x61, /* es/bar-4.png.ima */ \
	0x67,0x65,0x73,0x2f,0x62,0x6c,0x61,0x6e,0x6b,0x2e,0x70,0x6e,0x67,0x00,0x69,0x6d, /* ges/blank.png.im */ \
	0x61,0x67,0x65,0x73,0x2f,0x63,0x68,0x65,0x63,0x6b,0x6d,0x61,0x72,0x6b,0x2e,0x70, /* ages/checkmark.p */ \
	0x6e,0x67,0x00,0x69,0x6d,0x61,0x67,0x65,0x73,0x2f,0x68,0x61,0x72,0x6d,0x6f,0x6e, /* ng.images/harmon */ \
	0x79,0x2e,0x67,0x69,0x66,0x00,0x69,0x6d,0x61,0x67,0x65,0x73,0x2f,0x6c,0x6f,0x63, /* y.gif.images/loc */ \
	0x6b,0x2e,0x70,0x6e,0x67,0x00,0x69,0x6d,0x61,0x67,0x65,0x73,0x2f,0x6d,0x63,0x68, /* k.png.images/mch */ \
	0x70,0x2e,0x67,0x69,0x66,0x00,0x7e,0x69,0x6e,0x63,0x3a,0x68,0x65,0x61,0x64,0x65, /* p.gif.~inc:heade */ \
	0x72,0x2e,0x69,0x6e,0x63,0x7e,0x0a,0x3c,0x64,0x69,0x76,0x20,0x69,0x64,0x3d,0x22, /* r.inc~.<div id=" */ \
	0x63,0x6f,0x6e,0x74,0x65,0x6e,0x74,0x22,0x3e,0x0a,0x0a,0x3c,0x66,0x6f,0x72,0x6d, /* content">..<form */ \
	0x20,0x6d,0x65,0x74,0x68,0x6f,0x64,0x3d,0x22,0x70,0x6f,0x73,0x74,0x22,0x20,0x6e, /*  method="post" n */ \
	0x61,0x6d,0x65,0x3d,0x22,0x6e,0x65,0x76,0x65,0x72,0x73,0x65,0x6e,0x64,0x22,0x20, /* ame="neversend"  */ \
	0x61,0x63,0x74,0x69,0x6f,0x6e,0x3d,0x22,0x22,0x3e,0x0a,0x20,0x20,0x20,0x3c,0x74, /* action="">.   <t */ \
	0x61,0x62,0x6c,0x65,0x20,0x69,0x64,0x3d,0x22,0x73,0x63,0x61,0x6e,0x54,0x61,0x62, /* able id="scanTab */ \
	0x6c,0x65,0x22,0x20,0x63,0x65,0x6c,0x6c,0x70,0x61,0x64,0x64,0x69,0x6e,0x67,0x3d, /* le" cellpadding= */ \
	0x22,0x32,0x22,0x20,0x62,0x6f,0x72,0x64,0x65,0x72,0x3d,0x22,0x30,0x22,0x3e,0x0a, /* "2" border="0">. */ \
	0x09,0x3c,0x74,0x62,0x6f,0x64,0x79,0x3e,0x0a,0x09,0x09,0x3c,0x74,0x72,0x3e,0x0a, /* .<tbody>...<tr>. */ \
	0x09,0x09,0x09,0x3c,0x74,0x64,0x20,0x63,0x6f,0x6c,0x73,0x70,0x61,0x6e,0x3d,0x22, /* ...<td colspan=" */ \
	0x34,0x22,0x3e,0x0a,0x09,0x09,0x09,0x09,0x3c,0x69,0x6e,0x70,0x75,0x74,0x20,0x69, /* 4">.....<input i */ \
	0x64,0x3d,0x22,0x72,0x65,0x73,0x63,0x61,0x6e,0x22,0x20,0x74,0x79,0x70,0x65,0x3d, /* d="rescan" type= */ \
	0x22,0x62,0x75,0x74,0x74,0x6f,0x6e,0x22,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x22, /* "button" style=" */ \
	0x77,0x69,0x64,0x74,0x68,0x3a,0x31,0x38,0x65,0x6d,0x22,0x20,0x0a,0x09,0x09,0x09, /* width:18em" .... */ \
	0x09,0x20,0x20,0x76,0x61,0x6c,0x75,0x65,0x3d,0x22,0x53,0x63,0x61,0x6e,0x20,0x66, /* .  value="Scan f */ \
	0x6f,0x72,0x20,0x57,0x69,0x72,0x65,0x6c,0x65,0x73,0x73,0x20,0x4e,0x65,0x74,0x77, /* or Wireless Netw */ \
	0x6f,0x72,0x6b,0x73,0x22,0x20,0x6f,0x6e,0x63,0x6c,0x69,0x63,0x6b,0x3d,0x22,0x72, /* orks" onclick="r */ \
	0x65,0x73,0x63,0x61,0x6e,0x4e,0x65,0x74,0x77,0x6f,0x72,0x6b,0x28,0x29,0x3b,0x22, /* escanNetwork();" */ \
	0x3e,0x3c,0x2f,0x69,0x6e,0x70,0x75,0x74,0x3e,0x0a,0x09,0x09,0x09,0x3c,0x2f,0x74, /* ></input>....</t */ \
	0x64,0x3e,0x0a,0x09,0x09,0x3c,0x2f,0x74,0x72,0x3e,0x0a,0x09,0x3c,0x2f,0x74,0x62, /* d>...</tr>..</tb */ \
	0x6f,0x64,0x79,0x3e,0x0a,0x09,0x3c,0x74,0x66,0x6f,0x6f,0x74,0x3e,0x0a,0x09,0x09, /* ody>..<tfoot>... */ \
	0x3c,0x74,0x72,0x3e,0x0a,0x09,0x09,0x09,0x3c,0x74,0x64,0x20,0x63,0x6f,0x6c,0x73, /* <tr>....<td cols */ \
	0x70,0x61,0x6e,0x3d,0x22,0x34,0x22,0x3e,0x0a,0x09,0x09,0x09,0x09,0x3c,0x69,0x6e, /* pan="4">.....<in */ \
	0x70,0x75,0x74,0x20,0x69,0x64,0x3d,0x22,0x5f,0x5f,0x6f,0x74,0x68,0x65,0x72,0x5f, /* put id="__other_ */ \
	0x5f,0x22,0x20,0x74,0x79,0x70,0x65,0x3d,0x22,0x62,0x75,0x74,0x74,0x6f,0x6e,0x22, /* _" type="button" */ \
	0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x22,0x77,0x69,0x64,0x74,0x68,0x3a,0x31,0x38, /*  style="width:18 */ \
	0x65,0x6d,0x22,0x0a,0x09,0x09,0x09,0x09,0x20,0x20,0x76,0x61,0x6c,0x75,0x65,0x3d, /* em".....  value= */ \
	0x22,0x4f,0x74,0x68,0x65,0x72,0x20,0x4e,0x65,0x74,0x77,0x6f,0x72,0x6b,0x2e,0x2e, /* "Other Network.. */ \
	0x2e,0x22,0x20,0x6f,0x6e,0x63,0x6c,0x69,0x63,0x6b,0x3d,0x22,0x75,0x73,0x65,0x72, /* ." onclick="user */ \
	0x53,0x65,0x6c,0x65,0x63,0x74,0x4e,0x65,0x74,0x77,0x6f,0x72,0x6b,0x28,0x29,0x3b, /* SelectNetwork(); */ \
	0x22,0x3e,0x3c,0x2f,0x69,0x6e,0x70,0x75,0x74,0x3e,0x0a,0x09,0x09,0x09,0x3c,0x2f, /* "></input>....</ */ \
	0x74,0x64,0x3e,0x0a,0x09,0x09,0x3c,0x2f,0x74,0x72,0x3e,0x0a,0x09,0x3c,0x2f,0x74, /* td>...</tr>..</t */ \
	0x66,0x6f,0x6f,0x74,0x3e,0x0a,0x3c,0x2f,0x74,0x61,0x62,0x6c,0x65,0x3e,0x0a,0x3c, /* foot>.</table>.< */ \
	0x2f,0x66,0x6f,0x72,0x6d,0x3e,0x0a,0x0a,0x3c,0x66,0x6f,0x72,0x6d,0x20,0x6d,0x65, /* /form>..<form me */ \
	0x74,0x68,0x6f,0x64,0x3d,0x22,0x70,0x6f,0x73,0x74,0x22,0x20,0x6e,0x61,0x6d,0x65, /* thod="post" name */ \
	0x3d,0x22,0x6b,0x69,0x63,0x6b,0x6f,0x66,0x66,0x22,0x20,0x61,0x63,0x74,0x69,0x6f, /* ="kickoff" actio */ \
	0x6e,0x3d,0x22,0x22,0x3e,0x0a,0x09,0x3c,0x69,0x6e,0x70,0x75,0x74,0x20,0x74,0x79, /* n="">..<input ty */ \
	0x70,0x65,0x3d,0x22,0x68,0x69,0x64,0x64,0x65,0x6e,0x22,0x20,0x69,0x64,0x3d,0x22, /* pe="hidden" id=" */ \
	0x77,0x6c,0x61,0x6e,0x22,0x20,0x6e,0x61,0x6d,0x65,0x3d,0x22,0x77,0x6c,0x61,0x6e, /* wlan" name="wlan */ \
	0x22,0x3e,0x3c,0x2f,0x69,0x6e,0x70,0x75,0x74,0x3e,0x0a,0x09,0x3c,0x69,0x6e,0x70, /* "></input>..<inp */ \
	0x75,0x74,0x20,0x74,0x79,0x70,0x65,0x3d,0x22,0x68,0x69,0x64,0x64,0x65,0x6e,0x22, /* ut type="hidden" */ \
	0x20,0x69,0x64,0x3d,0x22,0x73,0x73,0x69,0x64,0x22,0x20,0x6e,0x61,0x6d,0x65,0x3d, /*  id="ssid" name= */ \
	0x22,0x73,0x73,0x69,0x64,0x22,0x3e,0x3c,0x2f,0x69,0x6e,0x70,0x75,0x74,0x3e,0x0a, /* "ssid"></input>. */ \
	0x09,0x3c,0x69,0x6e,0x70,0x75,0x74,0x20,0x74,0x79,0x70,0x65,0x3d,0x22,0x68,0x69, /* .<input type="hi */ \
	0x64,0x64,0x65,0x6e,0x22,0x20,0x69,0x64,0x3d,0x22,0x73,0x65,0x63,0x22,0x20,0x6e, /* dden" id="sec" n */ \
	0x61,0x6d,0x65,0x3d,0x22,0x73,0x65,0x63,0x22,0x3e,0x3c,0x2f,0x69,0x6e,0x70,0x75, /* ame="sec"></inpu */ \
	0x74,0x3e,0x0a,0x09,0x3c,0x69,0x6e,0x70,0x75,0x74,0x20,0x74,0x79,0x70,0x65,0x3d, /* t>..<input type= */ \
	0x22,0x68,0x69,0x64,0x64,0x65,0x6e,0x22,0x20,0x69,0x64,0x3d,0x22,0x6b,0x65,0x79, /* "hidden" id="key */ \
	0x22,0x20,0x6e,0x61,0x6d,0x65,0x3d,0x22,0x6b,0x65,0x79,0x22,0x3e,0x3c,0x2f,0x69, /* " name="key"></i */ \
	0x6e,0x70,0x75,0x74,0x3e,0x0a,0x3c,0x2f,0x66,0x6f,0x72,0x6d,0x3e,0x0a,0x3c,0x2f, /* nput>.</form>.</ */ \
	0x64,0x69,0x76,0x3e,0x0a,0x7e,0x69,0x6e,0x63,0x3a,0x66,0x6f,0x6f,0x74,0x65,0x72, /* div>.~inc:footer */ \
	0x2e,0x69,0x6e,0x63,0x7e,0x0a,0x16,0x00,0x00,0x00,0x02,0x00,0x00,0x00,0x00,0x00, /* .inc~........... */ \
	0x00,0x00,0x00,0x00,0x2f,0x03,0x00,0x00,0x01,0x00,0x00,0x00,0x3e,0x00,0x00,0x00, /* ..../.......>... */ \
	0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x85,0x03,0x00,0x00,0x02,0x00, /* ................ */ \
	0x00,0x00,0xcc,0x03,0x00,0x00,0x03,0x00,0x00,0x00,0x1f,0x04,0x00,0x00,0x04,0x00, /* ................ */ \
	0x00,0x00,0x6a,0x04,0x00,0x00,0x05,0x00,0x00,0x00,0xa7,0x0f,0x00,0x00,0x06,0x00, /* ..j............. */ \
	0x00,0x00,0xc7,0x0f,0x00,0x00,0x01,0x00,0x00,0x00,0x0e,0x00,0x00,0x00,0x02,0x00, /* ................ */ \
	0x09,0x00,0x00,0x00,0x07,0x00,0x00,0x00,0x3e,0x00,0x00,0x00,0x02,0x00,0x00,0x00, /* ........>....... */ \
	0x00,0x00,0x00,0x00,0x00,0x00,0xd0,0x00,0x00,0x00,0x08,0x00,0x00,0x00,0x54,0x01, /* ..............T. */ \
	0x00,0x00,0x09,0x00,0x00,0x00,0x7d,0x01,0x00,0x00,0x0a,0x00,0x00,0x00,0xe7,0x01, /* ......}......... */ \
	0x00,0x00,0x08,0x00,0x00,0x00,0x10,0x02,0x00,0x00,0x0b,0x00,0x00,0x00,0x32,0x02, /* ..............2. */ \
	0x00,0x00,0x01,0x00,0x00,0x00,0x0e,0x00,0x00,0x00,0x02,0x00,0x09,0x00,0x00,0x00, /* ................ */ \
	0x0c,0x00,0x00,0x00,0x86,0x00,0x00,0x00,0x02,0x00,0x3d,0x00,0x00,0x00,0x0c,0x00, /* ..........=..... */ \
	0x00,0x00,0x51,0x00,0x00,0x00,0x0d,0x00,0x00,0x00,0x67,0x00,0x00,0x00,0x0e,0x00, /* ..Q.......g..... */ \
	0x00,0x00,0x81,0x00,0x00,0x00,0x0f,0x00,0x00,0x00,0xa1,0x00,0x00,0x00,0x10,0x00, /* ................ */ \
	0x00,0x00,0xb9,0x00,0x00,0x00,0x11,0x00,0x00,0x00,0xd2,0x00,0x00,0x00,0x12,0x00, /* ................ */ \
	0x00,0x00,0xee,0x00,0x00,0x00,0x13,0x00,0x00,0x00,0x08,0x01,0x00,0x00,0x14,0x00, /* ................ */ \
	0x00,0x00,0x2f,0x01,0x00,0x00,0x07,0x00,0x00,0x00,0x46,0x01,0x00,0x00,0x15,0x00, /* ../.......F..... */ \
	0x00,0x00,0x5d,0x01,0x00,0x00,0x16,0x00,0x00,0x00,0x74,0x01,0x00,0x00,0x17,0x00, /* ..].......t..... */ \
	0x00,0x00,0x8b,0x01,0x00,0x00,0x18,0x00,0x00,0x00,0xa2,0x01,0x00,0x00,0x19,0x00, /* ................ */ \
	0x00,0x00,0xb9,0x01,0x00,0x00,0x1a,0x00,0x00,0x00,0x1f,0x8b,0x08,0x00,0x00,0x00, /* ................ */ \
	0x00,0x00,0x00,0x00,0x45,0x8f,0x51,0x4f,0x83,0x40,0x0c,0xc7,0xdf,0x4d,0xfc,0x0e, /* ....E.QO.@...M.. */ \
	0xf5,0xde,0xa1,0x2e,0x9b,0xc9,0xd4,0x63,0x0f,0x02,0x46,0x93,0x4d,0x17,0x83,0x31, /* .......c..F.M..1 */ \
	0x3e,0xe2,0x51,0x76,0x97,0x0c,0xee,0x3c,0x8a,0xb8,0x6f,0x2f,0x8c,0x39,0xfa,0xd2, /* >.Qv...<..o/.9.. */ \
	0x7f,0xfb,0x4f,0x7f,0x6d,0xe5,0x55,0xf2,0x1a,0x67,0x9f,0xdb,0x14,0x9e,0xb2,0xcd, /* ..O.m.U..g...... */ \
	0x1a,0xb6,0xef,0x0f,0xeb,0xe7,0x18,0x44,0x80,0xf8,0x31,0x8f,0x11,0x93,0x2c,0x19, /* .......D..1...,. */ \
	0x8d,0x45,0x78,0x3d,0x43,0x4c,0x5f,0x04,0x08,0xcd,0xec,0xee,0x10,0xbb,0xae,0x0b, /* .Ex=CL_......... */ \
	0xbb,0x79,0x68,0xfd,0x0e,0xb3,0x37,0xd4,0x5c,0xed,0x17,0xd8,0xb0,0x37,0x8a,0xc3, /* .yh...7.\....7.. */ \
	0x82,0x0b,0xb1,0xba,0xbc,0x90,0x43,0xb3,0xcf,0x00,0x20,0x35,0xe5,0xc5,0x28,0x87, /* ......C... 5..(. */ \
	0xaa,0x22,0xce,0x61,0xe0,0x04,0xf4,0xdd,0x9a,0x9f,0x48,0xc4,0xb6,0x66,0xaa,0x39, /* .".a......H..f.9 */ \
	0xc8,0x0e,0x8e,0x04,0xa8,0xb1,0x8a,0x04,0xd3,0x2f,0x1f,0xd1,0xf7,0xa0,0x74,0xee, /* ........./....t. */ \
	0x1b,0xe2,0xc8,0x34,0x36,0x58,0x2e,0x6f,0x6e,0x83,0x99,0x98,0x78,0x6c,0x78,0x4f, /* ...46X.on...xlxO */ \
	0xab,0x1e,0x52,0x9a,0x5d,0xeb,0x73,0x36,0xb6,0x86,0xd4,0x7b,0xeb,0x25,0x8e,0xd6, /* ..R.].s6...{.%.. */ \
	0x78,0x04,0x4e,0x57,0xc8,0x2f,0x5b,0x1c,0x26,0x80,0x3b,0xcb,0x3e,0x1e,0x5b,0x6e, /* x.NW./[.&.;.>.[n */ \
	0x3d,0x81,0xb6,0x15,0x81,0x2d,0x61,0xa3,0xb4,0x03,0x1a,0x68,0x50,0x5b,0x36,0xa5, /* =....-a....hP[6. */ \
	0x51,0xc7,0x05,0xe1,0x79,0x18,0xdd,0x3f,0xff,0x04,0x95,0x78,0xfa,0xfc,0x0f,0xf0, /* Q...y..?...x.... */ \
	0x9c,0xf2,0x25,0x5e,0x01,0x00,0x00,0x1f,0x8b,0x08,0x00,0x00,0x00,0x00,0x00,0x00, /* ..%^............ */ \
	0x00,0xed,0x59,0x7f,0x5c,0x54,0xd7,0x95,0x3f,0x08,0x71,0x20,0xcb,0x4a,0xd4,0x2c, /* ..Y.\T..?.q .J., */ \
	0x2a,0x5a,0x40,0xd0,0x20,0x11,0x44,0x33,0x89,0x09,0xd9,0xb8,0x58,0xdb,0xcd,0x6e, /* .Z@. .D3....X..n */ \
	0x93,0xe8,0x66,0x13,0xfd,0xa4,0x4d,0x9b,0x40,0xb6,0xed,0x33,0x6e,0xe3,0xd6,0x6c, /* ..f...M.@..3n..l */ \
	0x34,0x48,0xb1,0x61,0x90,0x84,0x1f,0x0d,0xae,0x94,0xaa,0xcc,0xb3,0xae,0xd5,0x17, /* 4H.a............ */ \
	0x23,0xd3,0xc6,0x62,0x62,0xc5,0x9f,0xa8,0x28,0x63,0x11,0x1d,0xc3,0x68,0x14,0x82, /* #..bb...(c...h.. */ \
	0x3a,0x14,0x92,0xf8,0x5b,0x14,0xfc,0xb1,0xd2,0xd5,0x78,0xfb,0x3d,0xf7,0xbe,0x19, /* :...[.....x.=... */ \
	0x86,0x61,0x4c,0xec,0x76,0xff,0xd8,0xcf,0x67,0x73,0xe7,0x9d,0xf7,0xee,0x3d,0xe7, /* .aL.v...gs....=. */ \
	0xdc,0x73,0xcf,0x3d,0xe7,0xdc,0x73,0x2f,0x17,0xa2,0x10,0xea,0x4f,0xf7,0xdc,0x43, /* .s.=..s/....O..C */ \
	0xb2,0xbc,0x1c,0x4a,0xa4,0xe1,0xeb,0x6b,0xdf,0x45,0xf4,0x61,0x28,0xb7,0x15,0x62, /* ...J...k.E.a(..b */ \
	0x4c,0x08,0xd1,0xc4,0x08,0xa2,0xf8,0x78,0x45,0x77,0x44,0x12,0xbd,0x78,0xb7,0x5f, /* L......xEwD..x._ */ \
	0x3b,0x9c,0xa8,0xff,0x10,0x6e,0x2b,0xfe,0x33,0xfd,0x88,0xaa,0xe2,0xd0,0x8f,0x65, /* ;....n+.3......e */ \
	0x02,0x98,0x2d,0x84,0x86,0x2a,0xe6,0x50,0xfa,0xc2,0x72,0xe0,0xc0,0x01,0x4d,0xd3, /* ..-....P..r...M. */ \
	0x35,0xab,0x6e,0xe5,0x47,0x43,0x65,0xd9,0xb2,0x65,0xcd,0xcd,0xcd,0x7d,0x39,0xcf, /* 5.n.GCe..e...}9. */ \
	0x9d,0x3b,0xa7,0x69,0x2e,0x2b,0xe9,0x78,0x88,0xf2,0xbd,0x15,0x1b,0xe6,0x62,0x25, /* .;.i.+.x......b% */ \
	0xad,0xb0,0xb0,0x30,0x80,0x5f,0xf7,0x32,0x5b,0xc9,0x15,0xf0,0xc8,0xe9,0x6b,0x01, /* ...0._.2[.....k. */ \
	0xa3,0xb8,0x5c,0xc2,0x9f,0x07,0x4d,0x3f,0x8c,0x0e,0x69,0x7d,0x55,0xd2,0x75,0x93, /* ..\...M?..i}U.u. */ \
	0x41,0xf3,0x52,0x75,0x5d,0xf2,0x5b,0xf5,0xee,0xee,0x6e,0x7f,0xcd,0x7d,0x75,0xcd, /* A.Ru].[...n..}u. */ \
	0xca,0x0c,0x3e,0x8c,0x1a,0x62,0xed,0xfe,0x4e,0xd5,0xfc,0xf4,0xd3,0x4f,0x6b,0x6b, /* ..>..b..N....Okk */ \
	0x6b,0xc1,0x03,0xbc,0xc2,0x58,0xad,0x2e,0xc8,0x54,0x75,0xc8,0x04,0x49,0xf3,0xd3, /* k....X...Tu..I.. */ \
	0xc4,0x67,0x3a,0xbc,0x65,0xd3,0x05,0x86,0x00,0xf5,0xba,0xba,0xba,0xfc,0xc6,0xd2, /* .g:.e........... */ \
	0x21,0x4d,0xea,0xa0,0x2b,0x4d,0x7c,0x03,0x29,0x4d,0xd0,0xa5,0xd7,0x58,0x52,0xac, /* !M..+M|.)M...XR. */ \
	0xae,0x99,0xd3,0xf4,0x37,0x02,0x77,0xef,0x33,0x96,0x32,0x29,0x44,0xa9,0x2e,0xe0, /* ....7.w.3.2)D... */ \
	0x51,0xa3,0xbb,0x74,0xd3,0x17,0x18,0x4f,0x4d,0x33,0x40,0x5a,0x4f,0x17,0x4d,0x9a, /* Q..t...OM3@ZO.M. */ \
	0xdd,0xea,0x75,0x84,0x34,0x85,0x6f,0x2c,0xc8,0xf7,0x99,0x4e,0x78,0xbb,0x04,0x7d, /* ..u.4.o,...Nx..} */ \
	0x50,0x76,0xef,0xde,0xad,0x69,0xbd,0x02,0x83,0x7d,0xaa,0x43,0x5a,0x8f,0x5b,0xd5, /* Pv...i...}.CZ.[. */ \
	0xa3,0x4c,0xba,0x6a,0xd5,0x9a,0x00,0x7e,0x53,0x31,0x5d,0x68,0x5e,0x7d,0x34,0x3f, /* .L.j...~S1]h^}4? */ \
	0x77,0xa0,0x6c,0xd8,0xb0,0x01,0xa3,0xfc,0xb9,0xfc,0x9d,0x51,0x42,0xd4,0x5a,0x00, /* w.l........QB.Z. */ \
	0xa1,0xea,0xdb,0x5e,0x24,0xc4,0xab,0xa5,0x42,0x58,0x47,0x08,0x91,0x34,0x54,0x88, /* ...^$...BXG..4T. */ \
	0xfe,0x13,0x84,0x18,0xf0,0xaa,0x10,0x61,0x89,0x42,0xd8,0xc2,0xc0,0x43,0x42,0xb4, /* .......a.B...CB. */ \
	0x85,0x0b,0xd1,0x39,0x42,0x41,0xef,0x75,0x16,0xae,0x44,0x87,0x50,0xd0,0x62,0x33, /* ...9BA.u..D.P.b3 */ \
	0x5f,0x36,0xb3,0x62,0x33,0x1b,0x08,0x33,0xaa,0x3d,0x51,0x4b,0x1c,0x7a,0x61,0x61, /* _6.b3..3.=QK.zaa */ \
	0x61,0x14,0x1e,0x1e,0x4e,0x91,0x91,0x91,0x34,0x70,0xe0,0x40,0x8a,0x8e,0x8e,0xa6, /* a...N...4p.@.... */ \
	0x11,0x23,0x46,0x50,0x42,0x42,0x02,0x25,0x27,0x27,0xd3,0x8c,0x19,0x33,0x68,0xea, /* .#FPBB.%''...3h. */ \
	0xd4,0xa9,0x34,0x65,0xca,0x14,0x4a,0x4f,0x4f,0xa7,0xfc,0xfc,0x7c,0xca,0x67,0x71, /* ..4e..JOO...|.gq */ \
	0x78,0xe5,0x9b,0x95,0x7c,0xb3,0x61,0x25,0x95,0x5b,0x38,0x6e,0xe4,0xbc,0xad,0x1c, /* x...|.a%.[8n.... */ \
	0xc3,0x72,0x8d,0xb2,0xa9,0xd9,0x28,0x24,0x4c,0x26,0x2b,0xaf,0x42,0x8d,0xe3,0x0b, /* .r....($L&+.B... */ \
	0x78,0x80,0x30,0x3b,0x72,0xd0,0x69,0x3a,0xc7,0x14,0x47,0x0e,0xf0,0xa6,0x30,0x0e, /* x.0;r.i:..G...0. */ \
	0x01,0xf6,0x14,0x1b,0x94,0xe3,0x48,0x70,0x1b,0xf1,0xca,0x31,0xab,0xc2,0xd8,0x2a, /* ......Hp...1.... */ \
	0x7f,0x1a,0x71,0x66,0xe0,0x75,0x6e,0x25,0x61,0x2a,0x60,0x05,0x68,0x56,0x76,0xb7, /* ..qf.un%a.`.hVv. */ \
	0x8c,0x2a,0xe8,0xa0,0x94,0xb2,0x72,0xf2,0xd0,0xe4,0x72,0x60,0x6f,0x41,0x07,0xa5, /* ......r...r`oA.. */ \
	0x28,0x56,0x15,0x74,0xe0,0xf5,0xc2,0x91,0x0a,0xbc,0xa9,0x3c,0x3b,0x56,0x26,0x16, /* (V.t.......<;V&. */ \
	0x19,0x64,0xc0,0x33,0x0e,0x13,0xe2,0x48,0x94,0x4b,0x00,0x20,0xcc,0x09,0xb2,0x26, /* .d.3...H.K. ...& */ \
	0xfc,0xd3,0x01,0x2e,0x80,0x30,0x27,0x8d,0x3c,0x87,0xa1,0x81,0x07,0xb8,0x00,0xc2, /* .....0'.<....... */ \
	0x34,0x04,0xd2,0x1f,0x3e,0x1a,0xc7,0x23,0x2f,0x04,0x69,0x18,0x2c,0x6d,0xe8,0xa1, /* 4...>..#/.i.,m.. */ \
	0x71,0x02,0xe2,0x15,0x03,0x3d,0x94,0xb1,0xb0,0x36,0xa1,0x03,0x70,0x00,0x61,0x1a, /* q....=...6..p.a. */ \
	0xcf,0x0a,0x40,0xec,0x41,0x07,0x1e,0xcb,0x85,0x9f,0x90,0x46,0xd4,0x61,0x50,0xfe, /* ..@.A......F.aP. */ \
	0xb9,0xa4,0x57,0x60,0x19,0xab,0x2e,0xb5,0x72,0xe1,0x2b,0x48,0x19,0xdb,0x0a,0xe0, /* ..W`....r.+H.... */ \
	0xd5,0xae,0xe3,0xeb,0x02,0x08,0xd4,0xad,0xe8,0xab,0x71,0x7f,0x00,0xc2,0x18,0x63, /* ..........q....c */ \
	0x2b,0x87,0x20,0xa6,0x61,0x03,0x1e,0x1f,0x78,0x80,0x30,0x9d,0x64,0x15,0x8c,0x07, /* +. .a...x.0.d... */ \
	0x3f,0xbe,0x58,0x06,0xb0,0x83,0x72,0x9c,0xd5,0xb4,0x80,0x2e,0x75,0x72,0x49,0x07, /* ?.X...r.....urI. */ \
	0xf3,0x7a,0xe6,0x5c,0xa5,0x03,0x5c,0x00,0x61,0x3a,0xd7,0x0a,0x40,0x56,0xe3,0xec, /* .z.\..\.a:..@V.. */ \
	0x0d,0x3d,0x80,0x97,0x81,0x00,0x3c,0x40,0x03,0xf0,0x6a,0x42,0x36,0xc1,0x70,0x2a, \
	0x08,0x90,0x1f,0xd0,0xcd,0xc5,0x99,0x85,0x17,0x3d,0x74,0x51,0x81,0x61,0x05,0x68, /* .........=tQ.a.h */ \
	0x82,0x75,0x01,0x1e,0x20,0x18,0x67,0x7a,0x81,0x67,0xcd,0xc1,0x64,0xb5,0xc2,0x23, /* .u.. .gz.g..d..# */ \
	0x00,0x1d,0xe0,0x02,0x08,0x00,0x07,0x94,0x15,0xc0,0x29,0x01,0xe9,0x05,0x3a,0x00, /* ..........)...:. */ \
	0x2f,0x83,0x0e,0x78,0x80,0x06,0xe0,0x24,0x89,0x3c,0x02,0x1d,0x54,0xe0,0x59,0x01, /* /..x...$.<..T.Y. */ \
	0x1a,0x40,0x07,0x70,0x3e,0x15,0x8c,0x13,0xc0,0x61,0x4c,0x1d,0x5f,0x97,0x60,0x19, /* .@.p>....aL._.`. */ \
	0xf0,0x23,0xfb,0x45,0xb0,0x8f,0xb9,0xcd,0x74,0x41,0x9c,0x3e,0x32,0x33,0x33,0x29, /* .#.E....tA.>233) */ \
	0x3b,0x3b,0x9b,0x38,0xf5,0x60,0xf7,0xe3,0x3d,0x91,0x33,0x05,0x67,0x3b,0xf2,0x78, /* ;;.8.`..=.3.g;.x */ \
	0x3c,0x9c,0x2e,0xe5,0x1e,0xc2,0xb9,0x94,0xf7,0x15,0x71,0xa3,0x93,0x93,0x15,0x96, /* <.........q..... */ \
	0xb1,0x8d,0x64,0xd8,0xe3,0x25,0xcc,0x8a,0x30,0x1b,0x42,0x21,0xe8,0x62,0x55,0x69, /* ..d..%..0.B!.bUi */ \
	0xa1,0x56,0xda,0x61,0xee,0x2f,0x57,0x1a,0x0d,0x23,0xc6,0x30,0xc2,0x32,0xb3,0x2e, /* .V.a./W..#.0.2.. */ \
	0xc8,0xf6,0x7a,0xc3,0x70,0xca,0x92,0x99,0x29,0x39,0x3c,0x5c,0xf7,0xe0,0x6d,0xac, /* ..z.p...)9<\..m. */ \
	0x57,0x1d,0x9a,0x9c,0xce,0x46,0xa2,0x6a,0x67,0xe1,0x35,0xee,0x0d,0x70,0x38,0xaf, /* W....F.jg.5..p8. */ \
	0x30,0x1b,0x4e,0x07,0x97,0x2d,0x0e,0x0f,0x51,0x65,0x35,0xd1,0x35,0x07,0x78,0x08, /* 0.N..-..Qe5.5.x. */ \
	0x03,0x95,0x52,0xa3,0x43,0x76,0xba,0x0a,0x1e,0xa3,0xda,0x61,0x38,0x9c,0x1e,0xe6, /* ..R.Cv.....a8... */ \
	0x6e,0x62,0x9e,0x52,0x72,0x3b,0x9d,0x2c,0xd6,0x51,0x29,0x79,0x3a,0xc9,0xe3,0x76, /* nb.Rr;.,.Q)y:..v */ \
	0x3a,0xae,0xd2,0x26,0xc3,0xa8,0xa1,0xcb,0x92,0x02,0xc4,0x29,0x4f,0xa5,0xd3,0x59, /* :..&.......)O..Y */ \
	0xe9,0x01,0x4f,0x27,0x06,0x6a,0x75,0x3b,0xcd,0x52,0x73,0x76,0x36,0xab,0xec,0x69, /* ..O'.ju;.Rsv6..i */ \
	0x6e,0x80,0x72,0x86,0xd1,0x48,0xd7,0x65,0x9b,0x3c,0x4d,0x0e,0xa7,0xd3,0x01,0x25, /* n.r..H.e.<M....% */ \
	0xe8,0xd2,0xd9,0xc0,0xf6,0xff,0x6e,0x9e,0x0d,0xeb,0xc9,0xa7,0xb7,0xcb,0xb4,0x4c, /* ......n........L */ \
	0xb4,0xd9,0xd4,0x87,0x7f,0x32,0xd5,0xaa,0x5c,0xab,0x9c,0x44,0xca,0x37,0x5e,0x4f, /* .....2..\..D.7^O */ \
	0x49,0x57,0x71,0xab,0x58,0xaf,0xe0,0x4e,0x16,0xac,0x34,0x7d,0x0e,0x51,0x0e,0x7f, /* IWq.X..N..4}.Q.. */ \
	0xcb,0x88,0x22,0x74,0x7b,0x89,0x0e,0x42,0xb8,0x3e,0x27,0x9c,0x97,0x12,0x22,0x37, /* .."t{..B.>'..."7 */ \
	0xdc,0xce,0x8f,0x9d,0x22,0xe6,0x80,0xcb,0x52,0x46,0x25,0x68,0xf2,0xb2,0x04,0xa6, /* ...."...RF%h.... */ \
	0x2c,0xa7,0x82,0x18,0x63,0x2b,0xd1,0xa9,0x84,0x79,0x2c,0xfa,0x7c,0x5d,0x2f,0x2a, /* ,...c+...y,.|]/. */ \
	0xe3,0x1c,0x80,0x52,0x9c,0x2d,0xe5,0x57,0x58,0xb2,0x89,0x8a,0x74,0x88,0x2d,0xf6, /* ...R.-.WX...t.-. */ \
	0x7e,0x3b,0xe3,0x30,0x6f,0x8b,0xb2,0x11,0x7f,0xdb,0x17,0x0b,0x71,0xe5,0x3f,0x60, /* ~;.0o.......q.?` */ \
	0xa7,0x15,0xb0,0xd3,0x23,0x42,0x44,0xa5,0x2b,0x3b,0x45,0x22,0xa8,0x6d,0x96,0xe0, /* ....#BD.+;E".m.. */ \
	0x76,0x62,0x1b,0x4d,0x26,0xbf,0x73,0x5f,0xe4,0x6d,0x0d,0x75,0xfb,0xb2,0x63,0xf3, /* vb.M&.s_.m.u..c. */ \
	0x47,0x79,0x73,0x7f,0xf3,0xf2,0xf3,0xfa,0x73,0xdf,0x5a,0x34,0x2d,0xe3,0xcd,0xa7, /* Gys.....s.Z4-... */ \
	0xa7,0x14,0x7c,0xe7,0xa9,0xc2,0x7f,0xcd,0x5a,0x5c,0x9c,0xff,0xce,0xd1,0x8f,0x5a, /* ..|.....Z\.....Z */ \
	0xff,0x07,0x02,0x55,0xd9,0xef,0x6c,0xfd,0xd1,0x77,0xd7,0x3c,0x3c,0xb2,0x30,0x86, /* ...U..l..w.<<.0. */ \
	0x5e,0x8f,0xa1,0x1c,0xef,0x93,0x3d,0x8c,0x5e,0x1b,0x4a,0xff,0x16,0x4d,0x33,0xef, /* ^.....=.^.J..M3. */ \
	0xa5,0xcc,0x61,0x96,0xef,0x4d,0x7e,0x60,0xce,0x82,0xb9,0x15,0xa7,0x4f,0x9d,0xbf, /* ..a..M~`.....O.. */ \
	0x73,0xc9,0x67,0x4f,0x5f,0xfe,0xf9,0x5b,0xbb,0x12,0xc2,0x17,0x8e,0xa0,0x85,0x5f, /* s.gO_..[......._ */ \
	0xa3,0xb7,0x62,0xa9,0x24,0x91,0x7e,0x35,0x86,0x36,0xdf,0x4f,0x7b,0xc6,0x52,0xfd, /* ..b.$.~5.6.O{.R. */ \
	0x58,0x72,0x8e,0xa1,0x2d,0x89,0xb4,0x6a,0x38,0xe5,0x62,0xac,0x21,0xf4,0xf2,0x60, /* Xr..-..j8.b.!..` */ \
	0x7a,0xfe,0x91,0xb1,0xb3,0xb6,0x6c,0xfc,0xfd,0x9d,0x08,0x77,0xed,0x3d,0xf5,0xcd, /* z.....l....w.=.. */ \
	0xb1,0xbf,0x8a,0xa5,0x9f,0xc5,0x52,0x69,0x1c,0x95,0x25,0x51,0x75,0x0a,0xb9,0xd2, /* ......Ri..%Qu... */ \
	0xa8,0x79,0x3c,0x79,0xc6,0x53,0xab,0xdf,0x73,0x7c,0x1c,0x7d,0x74,0x3f,0xd5,0x8d, /* .y<y.S..s|.}t?.. */ \
	0xa2,0xb5,0xc3,0x68,0x5e,0x34,0xfd,0x70,0x10,0x4d,0x7f,0x71,0x7a,0xc1,0x17,0x0b, /* ...h^4.p.M.qz... */ \
	0x3f,0xd4,0xd0,0x31,0x21,0xea,0x3d,0xe8,0x96,0x40,0x2b,0xee,0xa3,0xdf,0xa6,0xd0, /* ?..1!.=..@+..... */ \
	0x81,0x34,0xfa,0xd8,0x2b,0xf9,0xd8,0x38,0x3a,0x9c,0x4a,0x07,0x53,0xe9,0xc3,0x71, /* .4..+..8:.J.S..q */ \
	0x74,0x04,0x4d,0x89,0xf4,0x60,0xe8,0xb1,0xb4,0x37,0x8e,0x16,0x0f,0xa5,0xd9,0xf7, /* t.M..`...7...... */ \
	0xd2,0x0b,0x79,0xaf,0x1b,0x5f,0xa4,0xfc,0x9e,0xce,0xb4,0xfe,0xbb,0xee,0xef,0xb7, /* ..y.._.......... */ \
	0x65,0x0c,0x6d,0x1c,0x47,0x87,0xc6,0xd3,0x09,0x25,0x64,0x1c,0x1d,0x1d,0x4b,0x75, /* e.m.G....%d...Ku */ \
	0xf7,0xd1,0xfa,0x97,0x1e,0xdf,0xfb,0xe3,0xe9,0x87,0x1f,0x1d,0x78,0x60,0xc2,0x5d, /* ............x`.] */ \
	0x07,0xd3,0xe8,0xa8,0x1a,0x1a,0xe3,0x26,0xd2,0xea,0xe1,0xb4,0xc0,0x1a,0xfb,0xc6, /* .......&........ */ \
	0x97,0xda,0x67,0x49,0x6e,0xc7,0xcb,0x8f,0x89,0x7f,0x88,0x3d,0x36,0x2e,0xc4,0x0d, /* ..gIn......=6... */ \
	0x23,0xa0,0x7b,0x1a,0x35,0x25,0x53,0x4d,0x02,0xfd,0xf2,0x1b,0xa3,0xcd,0xfc,0x55, /* #.{.5%SM.......U */ \
	0xf1,0xba,0x98,0xfb,0x84,0x98,0x78,0xb7,0x1b,0x24,0xf0,0xc0,0x23,0x30,0xe6,0x08, /* ......x..$..#0.. */ \
	0xca,0x5b,0x5a,0xb2,0xf3,0x4e,0x5c,0xb0,0xb9,0x5c,0x54,0x15,0x88,0xc9,0xd1,0x47, /* .[Z..N\..\T....G */ \
	0xa5,0x86,0xe8,0xbe,0x37,0x9e,0x96,0xc4,0xd3,0x2f,0xb6,0x7f,0xd0,0xee,0xe3,0x69, /* ....7..../.....i */ \
	0xdd,0x28,0x5e,0x99,0x22,0xd2,0xfa,0x35,0x62,0x6a,0x09,0x04,0x7f,0x95,0xcc,0xfe, /* .(^."..5bj...... */ \
	0xde,0xba,0x3b,0x11,0xae,0x8a,0x53,0x17,0x0b,0xfe,0x59,0x75,0x3f,0x02,0x77,0xc4, /* ..;...S...Yu?.w. */ \
	0xd1,0xa2,0x99,0xcf,0x7e,0x10,0xc0,0x53,0xf4,0x82,0x78,0x30,0xbc,0x11,0x3e,0x8a, /* ....~..S..x0..>. */ \
	0xa7,0x9f,0x8f,0xec,0xff,0x96,0xa7,0xe5,0xcf,0x08,0x51,0xf7,0x4e,0xf1,0xb3,0x17, /* ..........Q.N... */ \
	0xc5,0xc4,0xbf,0x72,0xa7,0xd0,0x3e,0x68,0xfe,0xe8,0xc8,0x65,0x1d,0xe7,0xaf,0x05, /* ...r..>h...e.... */ \
	0xf0,0xd8,0x17,0xfc,0xf7,0x43,0x11,0x8d,0x63,0x68,0x5b,0x2c,0xbd,0xbd,0x78,0xe1, /* .....C..ch[,..x. */ \
	0xae,0x3b,0x17,0xae,0xca,0xca,0x37,0x3f,0x7f,0x38,0xd2,0x9d,0x44,0x1f,0x40,0xf9, /* .;....7?.8..D.@. */ \
	0xf7,0xd7,0x7e,0xd4,0x97,0xe1,0x60,0xdd,0xe5,0x09,0x77,0xb9,0xe1,0x97,0xc7,0xc7, /* ..~...`...w..... */ \
	0x2d,0xbf,0xdc,0xd5,0xdd,0x97,0xa1,0x6e,0xe7,0x11,0xe2,0x75,0xea,0x09,0x2a,0x7f, /* -......n...u.... */ \
	0x4f,0x75,0x67,0x5a,0xe8,0x87,0x09,0xf4,0x9f,0x4f,0x3f,0xfa,0x4e,0x50,0x86,0xec, /* OugZ.....O?.NP.. */ \
	0x17,0x0e,0xc1,0x7a,0x29,0x03,0xec,0x07,0xeb,0x3f,0xed,0x4b,0xdd,0xbe,0xb1,0x29, /* ...z)....?.K...) */ \
	0x75,0xf8,0xec,0xcf,0x3e,0x39,0x57,0x30,0x77,0xdb,0xc4,0xc4,0x9c,0xbe,0x0c,0x3f, /* u...>9W0w......? */ \
	0xfd,0x21,0xa2,0xbd,0x31,0x29,0x7c,0x59,0xc3,0x9e,0xf6,0xbe,0xd4,0xfa,0x9d,0x67, /* .!..1)|Y.......g */ \
	0xc7,0xdf,0xd5,0x90,0x4c,0xdb,0xe7,0x7d,0x7f,0x73,0xd0,0xd1,0xbf,0x65,0xb5,0x63, /* ....L..}.s...e.c */ \
	0xd1,0x55,0xae,0xde,0x31,0xeb,0xd9,0x6d,0x31,0xf4,0x93,0x57,0xb2,0xf4,0x5e,0x53, /* .U..1..m1..W..^S */ \
	0xdb,0x76,0x72,0x7c,0x48,0xd3,0x68,0xfa,0xcd,0xd2,0xa2,0xfa,0xa0,0xdd,0x33,0xe2, /* .vr|H.h.......3. */ \
	0xd6,0x23,0xf8,0xa7,0x3e,0xe8,0x38,0xfd,0xd9,0xe5,0xbe,0xd4,0x55,0xe5,0xee,0xf8, /* .#..>.8.....U... */ \
	0x90,0xc5,0x43,0xe8,0x95,0x62,0x9b,0xe3,0xb9,0xf4,0x5d,0x23,0xa9,0x22,0xa6,0xdf, /* ..C..b....]#.".. */ \
	0xab,0xfe,0x0c,0x4f,0x24,0xef,0xc6,0xc2,0x7c,0xea,0xc1,0xe0,0x96,0xb1,0xcd,0xde, /* ...O$...|....... */ \
	0x07,0xcb,0x20,0x33,0xd4,0xd7,0x06,0x99,0x1a,0xca,0x43,0x43,0x56,0x23,0xab,0xa4, /* .. 3......CCV#.. */ \
	0x0e,0x79,0xa3,0xf5,0xf8,0x69,0x9f,0xfc,0xca,0x55,0x75,0x8a,0xfa,0x59,0x7b,0xd7, /* .y...i...Uu..Y{. */ \
	0x5f,0x22,0xff,0xcc,0xc9,0x6b,0xfe,0xf2,0xbf,0xfd,0xc8,0xfe,0xfb,0xe8,0xfd,0xd1, /* _"...k.......... */ \
	0xf4,0xeb,0xf4,0x51,0x66,0x76,0xca,0xfe,0x41,0x0d,0x96,0x7c,0xf2,0x5f,0x97,0x1d, /* ...Qfv..A..|._.. */ \
	0x76,0x9d,0x0a,0x2a,0x3f,0x39,0xec,0x7d,0x30,0xcc,0x9a,0x11,0xb8,0x22,0x54,0x99, /* v...?9.}0...."T. */ \
	0xf5,0xcc,0x0e,0xa4,0x59,0xd8,0xb6,0x38,0x97,0x5d,0xf3,0xef,0x33,0x8e,0xdd,0x1f, /* ....Y..8.]..3... */ \
	0xba,0x09,0x59,0x6b,0x14,0xad,0xf9,0xee,0x3f,0xae,0xda,0xb2,0xbe,0x25,0x2d,0x7c, /* ..Yk....?....%-| */ \
	0xcb,0x48,0xb2,0x97,0xfc,0xa4,0x26,0x68,0xf7,0x7f,0x79,0x62,0x2b,0xf2,0x52,0xea, /* .H....&h..yb+.R. */ \
	0xc0,0x25,0x9e,0x96,0x0b,0x7d,0xa9,0x55,0xab,0x4f,0x24,0xd2,0x3b,0x58,0xf5,0x59, /* .%...}.U.O$.;X.Y */ \
	0x4f,0xbd,0xa7,0x30,0x4b,0x16,0x9c,0x99,0x34,0xf8,0x50,0x0a,0xed,0x67,0x9d,0x69, /* O..0K...4.P..g.i */ \
	0x7b,0x52,0x48,0x55,0x3c,0x95,0xff,0xed,0xe8,0x45,0x7f,0xec,0xbe,0xd1,0xb7,0xfb, /* {RHU<....E...... */ \
	0xdb,0x39,0xfb,0x91,0xb1,0x91,0x8e,0xde,0x5b,0xdd,0xd8,0x97,0x7a,0xf1,0xfc,0xf5, /* .9......[...z... */ \
	0xf4,0x98,0x75,0x48,0xb9,0x89,0xa1,0x4b,0x8e,0xba,0x4f,0x2b,0xa4,0x6b,0xf7,0xb5, /* ..uH...K..O+.k.. */ \
	0x67,0xc7,0x5c,0x18,0x6f,0xa9,0x4d,0xa3,0x16,0xe4,0xab,0x24,0xda,0x10,0x6f,0xf9, /* g.\.o.M....$..o. */ \
	0x69,0xd5,0xda,0x20,0x17,0x0f,0x28,0xd6,0xbf,0x31,0x60,0xd8,0x97,0xa6,0x05,0xf7, /* i.. ..(..1`..... */ \
	0xcb,0x2f,0x16,0x62,0x3d,0x56,0x23,0xaa,0x0b,0x5e,0xdb,0xe1,0x8f,0xff,0xd1,0x37, /* ./.b=V#..^.....7 */ \
	0xae,0x4f,0x1b,0xf5,0x89,0x4c,0xc8,0xad,0x63,0x68,0xd3,0xa3,0xa3,0x8b,0xaf,0x5e, /* .O...L..ch.....^ */ \
	0x09,0xb2,0x1e,0xe7,0x65,0xed,0x86,0xdd,0x92,0x69,0x67,0xd9,0x9b,0x5b,0xfb,0x52, /* ....e....ig..[.R */ \
	0x1b,0x76,0x9f,0x4a,0x8d,0x5c,0xc3,0xf9,0x7c,0xf0,0xb2,0x00,0x52,0xd9,0x6b,0xdd, /* .v.J.\..|...R.k. */ \
	0x79,0xd3,0xc5,0x43,0x77,0xbb,0x10,0xd2,0x48,0x38,0x31,0x21,0xaf,0xcf,0xf9,0xfe, /* y..Cw...H81!.... */ \
	0xca,0x00,0x9e,0x5d,0x9b,0x3e,0x49,0xea,0xbf,0x12,0x9b,0x0e,0x82,0xe1,0x81,0xd8, /* ...].>I......... */ \
	0x5c,0xcf,0xb1,0x5e,0xae,0xbf,0xfe,0x5f,0x37,0xfe,0xe9,0xc1,0xf5,0x70,0xeb,0x03, /* \..^..._7....p.. */ \
	0x11,0xfb,0x6a,0x36,0x1e,0x0b,0xe8,0xdb,0xe4,0xba,0xb1,0x7a,0x9e,0xc8,0x9e,0x2a, /* ..j6.......z.... */ \
	0xe0,0x02,0xb8,0x06,0xf6,0x1f,0xda,0x4f,0xdb,0xb1,0xc5,0xed,0xcf,0x33,0x61,0xd0, /* .......O.....3a. */ \
	0x4a,0x6c,0x6a,0xd8,0x65,0xb0,0x11,0x63,0xe1,0x3c,0x96,0x32,0xcf,0x9f,0x6a,0x2f, /* Jlj.e..c.<.2..j/ */ \
	0x39,0x98,0x48,0x06,0xd4,0x9b,0xfd,0xed,0x20,0x53,0x63,0xf5,0x2a,0xc5,0x1f,0x7e, /* 9.H..... Sc....~ */ \
	0x27,0x9e,0x4b,0x3d,0x07,0x2f,0xc0,0x80,0xd8,0x52,0x27,0xa5,0xf4,0x6c,0x46,0x05, /* '.K=./...R'..lF. */ \
	0xaf,0xd5,0xc2,0x32,0xa3,0xe9,0x3d,0x28,0x90,0x42,0x0d,0x38,0x45,0x44,0xd3,0x0f, /* ...2..=(.B.8ED.. */ \
	0x4a,0x6c,0xbf,0x55,0xd4,0x33,0x27,0x2f,0x3f,0xf2,0xb5,0x95,0x70,0xeb,0xa4,0x7b, /* Jl.U.3'/?...p..{ */ \
	0x0f,0xb6,0x1e,0xbb,0x14,0x54,0x3e,0x8a,0x73,0x95,0x38,0xb9,0x55,0x7c,0x7d,0x08, /* .....T>.s.8.U|}. */ \
	0xb6,0xf2,0x13,0xc8,0xea,0x38,0x8d,0x3c,0xfd,0x77,0xe5,0x2d,0x47,0xcf,0xac,0xfd, /* .....8.<.w.-G... */ \
	0xe5,0xc1,0x84,0xd0,0xb2,0x51,0xf4,0x0e,0x90,0x98,0x9d,0x8c,0x81,0x8d,0xc3,0x68, /* .....Q.........h */ \
	0xee,0xf0,0xb0,0x57,0x0c,0xbd,0x6e,0xef,0xae,0x13,0x8f,0xa7,0x2d,0x07,0x09,0xdb, /* ...W..n.....-... */ \
	0xfd,0xca,0xb7,0xdb,0x94,0xa8,0x43,0x87,0x0e,0x95,0x97,0x97,0xbb,0xdd,0xbd,0x2c, /* ......C........, */ \
	0x70,0xdc,0x2d,0xf6,0xad,0x10,0x7f,0xd8,0x80,0x9d,0xab,0x49,0xca,0x69,0x46,0x2c, /* p.-........I.iF, */ \
	0x25,0x85,0xdb,0x47,0x92,0x9e,0x44,0xbf,0x93,0x7b,0x7d,0x8b,0xdc,0x8e,0x4f,0x40, /* %..G..D..{}...O@ */ \
	0xd4,0x18,0xda,0x8a,0x6d,0x05,0x47,0x94,0x91,0x21,0x4b,0x70,0x8a,0x80,0xd7,0xb2, /* ....m.G..!Kp.... */ \
	0xbe,0x69,0x5e,0x69,0xac,0x5b,0xb7,0x6e,0xda,0xb4,0x69,0xf3,0xe7,0xcf,0x7f,0xf2, /* .i^i.[.n..i..... */ \
	0xc9,0x27,0x51,0xf7,0x1f,0xa2,0xf5,0x88,0xd8,0xb5,0x44,0x9c,0x78,0x5f,0x3c,0x37, /* .'Q.......D.x_<7 */ \
	0xee,0x3c,0x84,0xc8,0xe3,0xc1,0xc7,0x48,0x05,0xf2,0x7c,0x72,0xdc,0xef,0x70,0x02, /* .<.....H..|r..p. */ \
	0x7c,0x8b,0x3a,0x4e,0x60,0x5c,0x4c,0x67,0x64,0xbf,0xf2,0xc3,0x07,0x78,0xff,0x3a, /* |.:N`\Lgd....x.: */ \
	0x72,0xe4,0xc8,0x33,0xcf,0x3c,0xb3,0x70,0xe1,0xc2,0x8a,0x8a,0x8a,0xdc,0xdc,0xdc, /* r..3.<.p........ */ \
	0x82,0x82,0xc0,0x13,0x4b,0xcb,0x87,0x62,0x6d,0x9e,0x38,0xbc,0x46,0xbc,0x9d,0x25, /* ....K..bm.8.F..% */ \
	0xd2,0x07,0xb8,0x21,0x44,0xaa,0x7d,0x5c,0x9e,0x25,0xd4,0x73,0x5c,0xce,0xae,0x45, /* ...!D.}\.%.s\..E */ \
	0x1e,0x2a,0xea,0xb1,0x41,0x60,0x83,0xcb,0xff,0xb1,0x99,0xbb,0x36,0x6d,0xda,0x54, /* ....A`......6m.T */ \
	0x56,0x56,0x56,0x5a,0x5a,0x3a,0x7d,0xfa,0xf4,0xa5,0x4b,0x97,0xbe,0xfb,0xee,0xbb, /* VVVZZ:}...K..... */ \
	0x41,0x7d,0xb1,0xd5,0x10,0xbf,0x5e,0x20,0x2a,0x73,0xc5,0xac,0x0c,0x31,0x79,0xc8, /* A}....^ .s...1y. */ \
	0xe1,0xf1,0xfd,0xeb,0x53,0x43,0x1a,0x52,0x69,0x7f,0x0a,0x3f,0xfb,0xc6,0xd2,0x1e, /* ....SC.Ri..?.... */ \
	0x44,0xd1,0x28,0xaa,0x44,0x2a,0x40,0x50,0xa5,0x0f,0xef,0x39,0xf3,0x5c,0xba,0x74, /* D.(.D.@P...9.\.t */ \
	0x69,0xc5,0x8a,0x15,0x38,0xdf,0x2f,0x5f,0xbe,0x7c,0xde,0xbc,0x79,0x33,0x67,0xce, /* i...8./_.|..y3g. */ \
	0xbc,0x9d,0xbb,0x9b,0x0e,0xdc,0xb4,0xe7,0x8a,0x05,0x33,0xc4,0x4b,0x0f,0x7d,0x3e, /* ..........3.K.}> */ \
	0x2d,0xf1,0xd4,0x63,0x83,0xdc,0x0f,0x44,0xd4,0xa5,0x86,0x6d,0x4f,0xee,0xb7,0x09, /* -..c...D...mO... */ \
	0x7e,0xc1,0x59,0x08,0xe1,0x84,0xc3,0xd8,0xf3,0x5f,0xdf,0xbc,0x67,0x6b,0xaf,0xfd, /* ~.Y......_..gk.. */ \
	0xab,0xad,0xad,0x0d,0xf2,0x17,0x2d,0x5a,0x84,0xbf,0x10,0x77,0xee,0xfc,0xf2,0x13, /* ......-Z...w.... */ \
	0x4b,0xfd,0xb6,0x6b,0xc5,0xb3,0x4f,0x7d,0x67,0x62,0xd3,0xa4,0xe8,0x86,0x87,0xef, /* K..k..O}gb...... */ \
	0x71,0x4e,0x8c,0xda,0x35,0x69,0xd8,0x8e,0x97,0xfe,0xfe,0xf7,0xf6,0xa2,0x8f,0x3f, /* qN..5i.........? */ \
	0x6b,0xbb,0x7a,0xbb,0x5e,0x27,0x4f,0x9e,0xfc,0x52,0xc9,0xbe,0x72,0x3b,0xf9,0x5f, /* k.z.^'O..R..r;._ */ \
	0xd0,0xc5,0x27,0x5f,0xfe,0x71,0x81,0xcf,0x4d,0xa2,0x3c,0x24,0x9d,0x0c,0xfc,0xc9, /* ..'_.q..M.<$.... */ \
	0x19,0x07,0xc8,0xe8,0x0e,0xb1,0x65,0xdc,0x0c,0xa9,0xcd,0xbb,0x15,0xda,0xc6,0x20, /* ......e........  */ \
	0x84,0xa5,0xed,0xf3,0xbc,0xa8,0xf6,0xee,0x8c,0xa8,0xba,0xee,0xd8,0xb8,0xba,0xce, /* ................ */ \
	0xd8,0x8c,0xa2,0xce,0xc8,0x8c,0xa2,0xb6,0xc8,0x8c,0xc5,0xed,0x94,0x17,0x55,0x47, /* ..............UG */ \
	0x6f,0xc4,0x15,0xd0,0xad,0x8c,0x22,0xdb,0xcd,0x8c,0x28,0x5b,0x77,0x6c,0x94,0x6d, /* o....."...([wl.m */ \
	0x7e,0x6c,0x5c,0xed,0x9c,0xc8,0xb8,0x36,0xac,0x7d,0x40,0x16,0x64,0x4e,0x86,0xfc, /* ~l\....6.}@.dN.. */ \
	0xda,0x5b,0x14,0x52,0x2b,0x28,0xa4,0x0d,0xe3,0xde,0x10,0x9d,0x51,0x37,0x7a,0xff, /* .[.R+(......Q7z. */ \
	0x9d,0x62,0xde,0x9b,0x85,0x05,0x57,0xda,0x66,0xbe,0xbe,0xba,0x37,0xfb,0xea,0xde, /* .b....W.f...7... */ \
	0xec,0xab,0x7b,0xb3,0xff,0x7f,0xf7,0x66,0x66,0x39,0x5b,0x55,0x85,0x1d,0xa4,0xb4, /* ..{....ff9[U.... */ \
	0xca,0x7b,0x81,0xd6,0xab,0xd4,0x54,0x15,0x86,0xc9,0x02,0x45,0x32,0xb5,0xe8,0x2b, /* .{....T....E2..+ */ \
	0xbd,0xa9,0x57,0xaa,0x8d,0x98,0x18,0xf3,0x7e,0xcd,0x60,0x1e,0xcd,0xe2,0x4f,0xee, /* ..W.....~.`...O. */ \
	0x2c,0x34,0xbc,0x97,0x6f,0x26,0x4b,0x66,0x66,0x55,0x0f,0xd9,0x63,0xf4,0x26,0x33, /* ,4..o&KffU..c.&3 */ \
	0x87,0x3f,0x83,0xa7,0x07,0xed,0x68,0xf4,0x4a,0xd0,0xfc,0xe4,0xbb,0x1b,0x2a,0x15, /* .?....h.J....... */ \
	0xb6,0x90,0xeb,0x8a,0x5e,0xed,0xaf,0x40,0x73,0x93,0x44,0x1a,0x11,0x2c,0x4d,0xde, /* ....^..@s.D..,M. */ \
	0xaa,0x55,0x51,0xaf,0xd2,0x7c,0xaa,0x07,0xe9,0xe6,0x6a,0xc0,0x9f,0x27,0x1e,0x46, /* .UQ..|....j..'.F */ \
	0x16,0x5e,0xf5,0xd1,0xab,0x29,0xa0,0x34,0xa1,0x4f,0xb5,0x57,0x5d,0x2f,0x27,0x5d, /* .^...).4.O.W]/'] */ \
	0x24,0xef,0x69,0x1c,0xc8,0x52,0xb3,0xda,0xe8,0x34,0x4c,0x0b,0x9f,0xd5,0x2e,0xaf, /* $.i..R...4L..... */ \
	0xd7,0x7c,0xc8,0x1a,0xdf,0x6c,0xbd,0x87,0xe8,0xc2,0xcc,0xea,0xc6,0x30,0xa9,0xd4, /* .|...l.......0.. */ \
	0xc5,0x9e,0x21,0x0b,0x9d,0xa5,0xa6,0xf5,0xab,0x8d,0xcc,0x0e,0x87,0x91,0xc5,0xd5, /* ..!............. */ \
	0x4a,0xa7,0xf7,0x3f,0x39,0xeb,0x7d,0x82,0xc8,0x70,0x66,0x75,0x81,0x8e,0x8e,0x57, /* J..?9.}..pfu...W */ \
	0x82,0xd1,0xaf,0x28,0x3a,0x1b,0xad,0x47,0x25,0x74,0xf2,0x9a,0xa6,0x91,0x6f,0x46, /* ...(:..G%t....oF */ \
	0x61,0x6f,0xa3,0xd4,0xe2,0xbb,0x23,0x25,0x87,0xd3,0x6b,0x9a,0x6a,0xc3,0x59,0x2a, /* ao....#%..k.j.Y. */ \
	0x8d,0xc1,0xe6,0x2a,0xbc,0xe6,0x95,0xee,0x34,0xf5,0xbc,0x5a,0x28,0x65,0xb2,0xb5, /* ........4..Z(e.. */ \
	0x9d,0x52,0x87,0x00,0xe9,0xd5,0xea,0x82,0x94,0x1a,0x1c,0x60,0xf0,0x76,0x6f,0x34, /* .R.........`.vo4 */ \
	0xbc,0xdd,0x3d,0x86,0x53,0x1d,0x3f,0xdc,0xf0,0x8c,0x53,0x19,0x81,0x2e,0x22,0x4e, /* ..=.S.?...S..."N */ \
	0x34,0xf9,0x1f,0xbe,0x6b,0xa5,0x4e,0xe7,0x59,0xc5,0xc8,0x0c,0x46,0xa6,0x6c,0x70, /* 4...k.N.Y...F.lp */ \
	0x14,0x65,0x6a,0xa6,0x72,0x5e,0x23,0x36,0xb3,0x0a,0x32,0x5c,0xe4,0x0d,0x70,0x58, /* .ej.r^#6..2\..pX */ \
	0x66,0x07,0xa6,0x5e,0xe8,0x74,0xfa,0x3c,0xdc,0xcc,0xf1,0x15,0x56,0xda,0x55,0xad, /* f..^.t.<....V.U. */ \
	0x82,0x30,0x2c,0xab,0xfa,0x62,0xa1,0x9c,0x46,0x4d,0x87,0xb4,0x94,0xa7,0xb9,0x59, /* .0,..b..FM.....Y */ \
	0xce,0xd1,0x1b,0xa2,0x46,0x18,0x6a,0x0e,0x1c,0x8a,0x06,0x9f,0x1f,0x7c,0xc9,0x64, /* ....F.j......|.d */ \
	0x68,0xe8,0x1d,0xbe,0x4e,0xc3,0x43,0x9d,0x83,0xa2,0x3b,0xce,0x47,0x9b,0x3a,0x36, /* h...N.C...;.G.:6 */ \
	0xbb,0x7b,0x51,0xd9,0x9c,0x97,0x3a,0x2e,0x0c,0xea,0xb8,0xee,0xd5,0xc1,0xed,0x6e, /* .{Q...:........n */ \
	0xe8,0xa1,0xb2,0x4b,0xe8,0x6a,0x79,0x77,0xf9,0xf9,0xd9,0x5e,0x25,0x31,0xcd,0x86, /* ...K.jyw...^%1.. */ \
	0x06,0x93,0x6a,0x38,0x2e,0x32,0xaa,0xab,0xfb,0xc2,0x39,0xff,0x65,0xe6,0x71,0xb3, /* ..j8.2....9.e.q. */ \
	0x29,0x9d,0x8e,0x6a,0xdf,0xe2,0x0c,0x08,0x62,0x2f,0x9d,0xfc,0xe8,0xff,0xb7,0xce, /* )..j....b/...... */ \
	0x29,0xe6,0x01,0xa5,0x1f,0xdd,0xa6,0xd8,0xfe,0x82,0x7b,0x67,0x94,0xf0,0xa2,0xec, /* ).........{g.... */ \
	0xec,0xe2,0x1e,0x69,0x45,0xf2,0xae,0x58,0xde,0x46,0x4b,0xaa,0xae,0xfb,0x23,0xc2, /* ...iE..X.FK...#. */ \
	0x73,0x74,0x2f,0x42,0xb6,0x4b,0x74,0x5f,0xb1,0xf9,0xda,0x15,0x92,0xa9,0xa7,0xfb, /* st/B.Kt_........ */ \
	0x1c,0xbe,0x76,0xb6,0x2b,0x79,0x39,0x92,0x53,0xdd,0x72,0x9b,0x1d,0x2a,0xe4,0xbb, /* ..v.+y9.S.r..... */ \
	0x67,0xbc,0x32,0xbe,0x07,0xb7,0x7b,0xf5,0xf1,0xde,0x7f,0xf3,0xd4,0x58,0xcd,0x12, /* g.2...{......X.. */ \
	0x1e,0xd8,0x22,0x91,0x65,0x45,0xdc,0xb6,0x7b,0x5f,0x16,0x7b,0x8e,0x0d,0x9c,0xac, /* ..".eE..{_.{.... */ \
	0x87,0x64,0x2f,0xb1,0xe7,0xd8,0xc9,0x52,0x21,0x85,0x4a,0x64,0x59,0x9f,0x76,0x85, /* .d/....R!.JdY.v. */ \
	0xea,0x19,0x61,0xca,0xcc,0xd1,0xe7,0x4b,0x4a,0x4e,0x99,0x1a,0x48,0x29,0xe7,0x63, /* ..a....KJN..H).c */ \
	0xe7,0xb6,0x8f,0x9d,0x91,0x11,0xba,0x39,0x90,0xd4,0x53,0x5e,0xdf,0xdb,0xe5,0x14, /* .......9..S^.... */ \
	0x58,0x86,0xaa,0x79,0xb9,0xd4,0x0c,0x4a,0xb8,0x2a,0xa5,0x44,0xc8,0x09,0xa3,0x43, /* X..y...J...D...C */ \
	0x85,0x34,0x51,0x31,0xd8,0x8b,0x6c,0x3e,0x6b,0x4b,0xa3,0x61,0x63,0xf3,0xb3,0xaf, /* .4Q1..l>kK.ac... */ \
	0xad,0x88,0xdb,0x3e,0xfb,0x83,0x9d,0xdb,0xbe,0x1e,0x65,0x24,0xf9,0xfd,0xfc,0x17, /* ...>......e$.... */ \
	0x9e,0x3d,0xdf,0xf4,0xaf,0xae,0xcf,0xf7,0x0b,0x17,0xbf,0xb6,0x68,0x8b,0x42,0x14, /* .=..........h.B. */ \
	0x84,0x88,0x5b,0xb7,0x89,0xf3,0x9b,0xa1,0xb5,0xe2,0x96,0x85,0xe3,0xbc,0xfd,0xf3, /* ..[............. */ \
	0x8c,0xa8,0xf6,0x3f,0xaa,0x38,0xaf,0xef,0x1c,0x90,0x51,0xd4,0xc5,0xa0,0xe2,0x3c, /* ...?.8....Q....< */ \
	0xae,0x8e,0x6e,0xc5,0xd5,0x73,0x9c,0xe7,0xcb,0x38,0xcf,0x30,0xe3,0x7c,0x40,0x46, /* ..n..s...8.0.|@F */ \
	0x5b,0x7c,0x9f,0x38,0x6f,0x53,0x71,0x8e,0x71,0x01,0x7f,0x02,0xd6,0xb6,0x18,0x5d, /* [|.8oSq.q......] */ \
	0x96,0x22,0x00,0x00,0x06,0x00,0x00,0x00,0x8a,0x10,0x62,0x00,0x00,0x00,0x07,0x00, /* ."........b..... */ \
	0x00,0x00,0xcc,0x83,0xae,0x00,0x00,0x00,0x10,0x00,0x00,0x00,0x0a,0xa3,0x16,0x00, /* ................ */ \
	0x00,0x00,0x07,0x00,0x00,0x00,0x46,0xce,0x54,0x00,0x00,0x00,0x01,0x00,0x00,0x00, /* ......F.T....... */ \
	0xe6,0xd2,0xa0,0x00,0x00,0x00,0x01,0x00,0x00,0x00,0x6a,0xfd,0x00,0x00,0x00,0x00, /* ..........j..... */ \
	0x02,0x00,0x00,0x00,0x3c,0x64,0x69,0x76,0x20,0x63,0x6c,0x61,0x73,0x73,0x3d,0x22, /* ....<div class=" */ \
	0x73,0x70,0x61,0x63,0x65,0x72,0x22,0x3e,0x26,0x6e,0x62,0x73,0x70,0x3b,0x3c,0x2f, /* spacer">&nbsp;</ */ \
	0x64,0x69,0x76,0x3e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x69,0x64,0x3d,0x22,0x66, /* div>..<div id="f */ \
	0x6f,0x6f,0x74,0x65,0x72,0x22,0x3e,0x43,0x6f,0x70,0x79,0x72,0x69,0x67,0x68,0x74, /* ooter">Copyright */ \
	0x20,0x26,0x63,0x6f,0x70,0x79,0x3b,0x20,0x32,0x30,0x31,0x35,0x20,0x4d,0x69,0x63, /*  &copy; 2015 Mic */ \
	0x72,0x6f,0x63,0x68,0x69,0x70,0x20,0x54,0x65,0x63,0x68,0x6e,0x6f,0x6c,0x6f,0x67, /* rochip Technolog */ \
	0x79,0x2c,0x20,0x49,0x6e,0x63,0x2e,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x0d, /* y, Inc.</div>... */ \
	0x0a,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x3c,0x2f,0x64, /* .</div></div></d */ \
	0x69,0x76,0x3e,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d, /* iv></div></div>. */ \
	0x0a,0x0d,0x0a,0x3c,0x2f,0x62,0x6f,0x64,0x79,0x3e,0x0d,0x0a,0x3c,0x2f,0x68,0x74, /* ...</body>..</ht */ \
	0x6d,0x6c,0x3e,0x0d,0x0a,0x3c,0x21,0x44,0x4f,0x43,0x54,0x59,0x50,0x45,0x20,0x68, /* ml>..<!DOCTYPE h */ \
	0x74,0x6d,0x6c,0x20,0x50,0x55,0x42,0x4c,0x49,0x43,0x20,0x22,0x2d,0x2f,0x2f,0x57, /* tml PUBLIC "-//W */ \
	0x33,0x43,0x2f,0x2f,0x44,0x54,0x44,0x20,0x58,0x48,0x54,0x4d,0x4c,0x20,0x31,0x2e, /* 3C//DTD XHTML 1. */ \
	0x30,0x20,0x53,0x74,0x72,0x69,0x63,0x74,0x2f,0x2f,0x45,0x4e,0x22,0x0d,0x0a,0x20, /* 0 Strict//EN"..  */ \
	0x20,0x22,0x68,0x74,0x74,0x70,0x3a,0x2f,0x2f,0x77,0x77,0x77,0x2e,0x77,0x33,0x2e, /*  "http://www.w3. */ \
	0x6f,0x72,0x67,0x2f,0x54,0x52,0x2f,0x78,0x68,0x74,0x6d,0x6c,0x31,0x2f,0x44,0x54, /* org/TR/xhtml1/DT */ \
	0x44,0x2f,0x78,0x68,0x74,0x6d,0x6c,0x31,0x2d,0x73,0x74,0x72,0x69,0x63,0x74,0x2e, /* D/xhtml1-strict. */ \
	0x64,0x74,0x64,0x22,0x3e,0x0d,0x0a,0x3c,0x68,0x74,0x6d,0x6c,0x20,0x78,0x6d,0x6c, /* dtd">..<html xml */ \
	0x6e,0x73,0x3d,0x22,0x68,0x74,0x74,0x70,0x3a,0x2f,0x2f,0x77,0x77,0x77,0x2e,0x77, /* ns="http://www.w */ \
	0x33,0x2e,0x6f,0x72,0x67,0x2f,0x31,0x39,0x39,0x39,0x2f,0x78,0x68,0x74,0x6d,0x6c, /* 3.org/1999/xhtml */ \
	0x22,0x20,0x78,0x6d,0x6c,0x3a,0x6c,0x61,0x6e,0x67,0x3d,0x22,0x65,0x6e,0x22,0x20, /* " xml:lang="en"  */ \
	0x6c,0x61,0x6e,0x67,0x3d,0x22,0x65,0x6e,0x22,0x3e,0x0d,0x0a,0x3c,0x68,0x65,0x61, /* lang="en">..<hea */ \
	0x64,0x3e,0x0d,0x0a,0x20,0x20,0x20,0x20,0x3c,0x74,0x69,0x74,0x6c,0x65,0x3e,0x4d, /* d>..    <title>M */ \
	0x69,0x63,0x72,0x6f,0x63,0x68,0x69,0x70,0x20,0x57,0x69,0x2d,0x46,0x69,0x20,0x45, /* icrochip Wi-Fi E */ \
	0x61,0x73,0x79,0x20,0x43,0x6f,0x6e,0x66,0x69,0x67,0x75,0x72,0x61,0x74,0x69,0x6f, /* asy Configuratio */ \
	0x6e,0x20,0x44,0x65,0x6d,0x6f,0x3c,0x2f,0x74,0x69,0x74,0x6c,0x65,0x3e,0x0d,0x0a, /* n Demo</title>.. */ \
	0x20,0x20,0x20,0x20,0x3c,0x6c,0x69,0x6e,0x6b,0x20,0x68,0x72,0x65,0x66,0x3d,0x22, /*     <link href=" */ \
	0x2f,0x6d,0x63,0x68,0x70,0x2e,0x63,0x73,0x73,0x22,0x20,0x72,0x65,0x6c,0x3d,0x22, /* /mchp.css" rel=" */ \
	0x73,0x74,0x79,0x6c,0x65,0x73,0x68,0x65,0x65,0x74,0x22,0x20,0x74,0x79,0x70,0x65, /* stylesheet" type */ \
	0x3d,0x22,0x74,0x65,0x78,0x74,0x2f,0x63,0x73,0x73,0x22,0x20,0x2f,0x3e,0x0d,0x0a, /* ="text/css" />.. */ \
	0x20,0x20,0x20,0x20,0x3c,0x73,0x63,0x72,0x69,0x70,0x74,0x20,0x73,0x72,0x63,0x3d, /*     <script src= */ \
	0x22,0x2f,0x6d,0x63,0x68,0x70,0x2e,0x6a,0x73,0x22,0x20,0x74,0x79,0x70,0x65,0x3d, /* "/mchp.js" type= */ \
	0x22,0x74,0x65,0x78,0x74,0x2f,0x6a,0x61,0x76,0x61,0x73,0x63,0x72,0x69,0x70,0x74, /* "text/javascript */ \
	0x22,0x3e,0x3c,0x2f,0x73,0x63,0x72,0x69,0x70,0x74,0x3e,0x0d,0x0a,0x3c,0x2f,0x68, /* "></script>..</h */ \
	0x65,0x61,0x64,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x62,0x6f,0x64,0x79,0x20,0x6f,0x6e, /* ead>....<body on */ \
	0x6c,0x6f,0x61,0x64,0x3d,0x22,0x6e,0x65,0x77,0x41,0x4a,0x41,0x58,0x43,0x6f,0x6d, /* load="newAJAXCom */ \
	0x6d,0x61,0x6e,0x64,0x28,0x27,0x73,0x74,0x61,0x74,0x75,0x73,0x2e,0x78,0x6d,0x6c, /* mand('status.xml */ \
	0x27,0x29,0x3b,0x22,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x69,0x64, /* ');">....<div id */ \
	0x3d,0x22,0x73,0x68,0x61,0x64,0x6f,0x77,0x2d,0x6f,0x6e,0x65,0x22,0x3e,0x3c,0x64, /* ="shadow-one"><d */ \
	0x69,0x76,0x20,0x69,0x64,0x3d,0x22,0x73,0x68,0x61,0x64,0x6f,0x77,0x2d,0x74,0x77, /* iv id="shadow-tw */ \
	0x6f,0x22,0x3e,0x3c,0x64,0x69,0x76,0x20,0x69,0x64,0x3d,0x22,0x73,0x68,0x61,0x64, /* o"><div id="shad */ \
	0x6f,0x77,0x2d,0x74,0x68,0x72,0x65,0x65,0x22,0x3e,0x3c,0x64,0x69,0x76,0x20,0x69, /* ow-three"><div i */ \
	0x64,0x3d,0x22,0x73,0x68,0x61,0x64,0x6f,0x77,0x2d,0x66,0x6f,0x75,0x72,0x22,0x3e, /* d="shadow-four"> */ \
	0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x69,0x64,0x3d,0x22,0x70,0x61,0x67,0x65,0x22, /* ..<div id="page" */ \
	0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d, /* >....<div style= */ \
	0x22,0x70,0x61,0x64,0x64,0x69,0x6e,0x67,0x3a,0x30,0x20,0x30,0x20,0x36,0x35,0x70, /* "padding:0 0 65p */ \
	0x78,0x20,0x35,0x70,0x78,0x22,0x3e,0x3c,0x69,0x6d,0x67,0x20,0x73,0x72,0x63,0x3d, /* x 5px"><img src= */ \
	0x22,0x69,0x6d,0x61,0x67,0x65,0x73,0x2f,0x6d,0x63,0x68,0x70,0x2e,0x67,0x69,0x66, /* "images/mchp.gif */ \
	0x22,0x20,0x61,0x6c,0x74,0x3d,0x22,0x4d,0x69,0x63,0x72,0x6f,0x63,0x68,0x69,0x70, /* " alt="Microchip */ \
	0x22,0x20,0x61,0x6c,0x69,0x67,0x6e,0x3d,0x22,0x6c,0x65,0x66,0x74,0x22,0x2f,0x3e, /* " align="left"/> */ \
	0x3c,0x69,0x6d,0x67,0x20,0x73,0x72,0x63,0x3d,0x22,0x69,0x6d,0x61,0x67,0x65,0x73, /* <img src="images */ \
	0x2f,0x68,0x61,0x72,0x6d,0x6f,0x6e,0x79,0x2e,0x67,0x69,0x66,0x22,0x20,0x61,0x6c, /* /harmony.gif" al */ \
	0x74,0x3d,0x22,0x48,0x61,0x72,0x6d,0x6f,0x6e,0x79,0x22,0x20,0x61,0x6c,0x69,0x67, /* t="Harmony" alig */ \
	0x6e,0x3d,0x22,0x72,0x69,0x67,0x68,0x74,0x22,0x2f,0x3e,0x3c,0x2f,0x64,0x69,0x76, /* n="right"/></div */ \
	0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x69,0x64,0x3d,0x22,0x74,0x69, /* >....<div id="ti */ \
	0x74,0x6c,0x65,0x22,0x3e,0x3c,0x64,0x69,0x76,0x20,0x63,0x6c,0x61,0x73,0x73,0x3d, /* tle"><div class= */ \
	0x22,0x72,0x69,0x67,0x68,0x74,0x22,0x3e,0x45,0x61,0x73,0x79,0x20,0x43,0x6f,0x6e, /* "right">Easy Con */ \
	0x66,0x69,0x67,0x75,0x72,0x61,0x74,0x69,0x6f,0x6e,0x20,0x44,0x65,0x6d,0x6f,0x20, /* figuration Demo  */ \
	0x41,0x70,0x70,0x6c,0x69,0x63,0x61,0x74,0x69,0x6f,0x6e,0x3c,0x2f,0x64,0x69,0x76, /* Application</div */ \
	0x3e,0x3c,0x73,0x70,0x61,0x6e,0x20,0x69,0x64,0x3d,0x22,0x68,0x65,0x6c,0x6c,0x6f, /* ><span id="hello */ \
	0x22,0x3e,0x26,0x6e,0x62,0x73,0x70,0x3b,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x3c, /* ">&nbsp;</span>< */ \
	0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x69,0x64, /* /div>....<div id */ \
	0x3d,0x22,0x6d,0x65,0x6e,0x75,0x22,0x3e,0x0d,0x0a,0x20,0x20,0x20,0x20,0x3c,0x61, /* ="menu">..    <a */ \
	0x20,0x68,0x72,0x65,0x66,0x3d,0x22,0x2f,0x69,0x6e,0x64,0x65,0x78,0x2e,0x68,0x74, /*  href="/index.ht */ \
	0x6d,0x22,0x3e,0x4f,0x76,0x65,0x72,0x76,0x69,0x65,0x77,0x3c,0x2f,0x61,0x3e,0x0d, /* m">Overview</a>. */ \
	0x0a,0x20,0x20,0x20,0x20,0x3c,0x61,0x20,0x68,0x72,0x65,0x66,0x3d,0x22,0x2f,0x63, /* .    <a href="/c */ \
	0x6f,0x6e,0x66,0x69,0x67,0x75,0x72,0x65,0x2e,0x68,0x74,0x6d,0x22,0x3e,0x4e,0x65, /* onfigure.htm">Ne */ \
	0x74,0x77,0x6f,0x72,0x6b,0x20,0x43,0x6f,0x6e,0x66,0x69,0x67,0x75,0x72,0x61,0x74, /* twork Configurat */ \
	0x69,0x6f,0x6e,0x3c,0x2f,0x61,0x3e,0x0d,0x0a,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d, /* ion</a>..</div>. */ \
	0x0a,0x7e,0x69,0x6e,0x63,0x3a,0x68,0x65,0x61,0x64,0x65,0x72,0x2e,0x69,0x6e,0x63, /* .~inc:header.inc */ \
	0x7e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x69,0x64,0x3d,0x22,0x63,0x6f,0x6e,0x74, /* ~..<div id="cont */ \
	0x65,0x6e,0x74,0x22,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x69,0x64, /* ent">....<div id */ \
	0x3d,0x22,0x73,0x74,0x61,0x74,0x75,0x73,0x22,0x3e,0x0d,0x0a,0x09,0x3c,0x64,0x69, /* ="status">...<di */ \
	0x76,0x20,0x69,0x64,0x3d,0x22,0x6c,0x6f,0x61,0x64,0x69,0x6e,0x67,0x22,0x20,0x73, /* v id="loading" s */ \
	0x74,0x79,0x6c,0x65,0x3d,0x22,0x64,0x69,0x73,0x70,0x6c,0x61,0x79,0x3a,0x6e,0x6f, /* tyle="display:no */ \
	0x6e,0x65,0x22,0x3e,0x45,0x72,0x72,0x6f,0x72,0x3a,0x3c,0x62,0x72,0x20,0x2f,0x3e, /* ne">Error:<br /> */ \
	0x43,0x6f,0x6e,0x6e,0x65,0x63,0x74,0x69,0x6f,0x6e,0x20,0x74,0x6f,0x20,0x64,0x65, /* Connection to de */ \
	0x6d,0x6f,0x20,0x62,0x6f,0x61,0x72,0x64,0x20,0x77,0x61,0x73,0x20,0x6c,0x6f,0x73, /* mo board was los */ \
	0x74,0x2e,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x09,0x3c,0x64,0x69,0x76,0x20, /* t.</div>...<div  */ \
	0x69,0x64,0x3d,0x22,0x64,0x69,0x73,0x70,0x6c,0x61,0x79,0x22,0x3e,0x0d,0x0a,0x09, /* id="display">... */ \
	0x3c,0x21,0x2d,0x2d,0x3c,0x73,0x70,0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d, /* <!--<span style= */ \
	0x22,0x66,0x6c,0x6f,0x61,0x74,0x3a,0x72,0x69,0x67,0x68,0x74,0x3b,0x66,0x6f,0x6e, /* "float:right;fon */ \
	0x74,0x2d,0x73,0x69,0x7a,0x65,0x3a,0x39,0x70,0x78,0x3b,0x66,0x6f,0x6e,0x74,0x2d, /* t-size:9px;font- */ \
	0x77,0x65,0x69,0x67,0x68,0x74,0x3a,0x6e,0x6f,0x72,0x6d,0x61,0x6c,0x3b,0x70,0x61, /* weight:normal;pa */ \
	0x64,0x64,0x69,0x6e,0x67,0x2d,0x74,0x6f,0x70,0x3a,0x38,0x70,0x78,0x3b,0x74,0x65, /* dding-top:8px;te */ \
	0x78,0x74,0x2d,0x69,0x6e,0x64,0x65,0x6e,0x74,0x3a,0x30,0x70,0x78,0x22,0x3e,0x28, /* xt-indent:0px">( */ \
	0x63,0x6c,0x69,0x63,0x6b,0x20,0x74,0x6f,0x20,0x74,0x6f,0x67,0x67,0x6c,0x65,0x29, /* click to toggle) */ \
	0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x2d,0x2d,0x3e,0x0d,0x0a,0x09,0x09,0x3c,0x70, /* </span>-->....<p */ \
	0x3e,0x4c,0x45,0x44,0x3a,0x3c,0x62,0x72,0x20,0x2f,0x3e,0x3c,0x73,0x70,0x61,0x6e, /* >LED:<br /><span */ \
	0x20,0x63,0x6c,0x61,0x73,0x73,0x3d,0x22,0x6c,0x65,0x64,0x73,0x22,0x3e,0x0d,0x0a, /*  class="leds">.. */ \
	0x09,0x09,0x3c,0x21,0x2d,0x2d,0x20,0x74,0x68,0x69,0x73,0x20,0x69,0x73,0x20,0x63, /* ..<!-- this is c */ \
	0x6f,0x6d,0x6d,0x65,0x6e,0x74,0x65,0x64,0x20,0x6f,0x75,0x74,0x20,0x74,0x65,0x6d, /* ommented out tem */ \
	0x70,0x6f,0x72,0x61,0x72,0x69,0x6c,0x79,0x20,0x2d,0x2d,0x3e,0x0d,0x0a,0x09,0x3c, /* porarily -->...< */ \
	0x21,0x2d,0x2d,0x3c,0x61,0x20,0x69,0x64,0x3d,0x22,0x6c,0x65,0x64,0x32,0x22,0x20, /* !--<a id="led2"  */ \
	0x6f,0x6e,0x63,0x6c,0x69,0x63,0x6b,0x3d,0x22,0x6e,0x65,0x77,0x41,0x4a,0x41,0x58, /* onclick="newAJAX */ \
	0x43,0x6f,0x6d,0x6d,0x61,0x6e,0x64,0x28,0x27,0x6c,0x65,0x64,0x73,0x2e,0x63,0x67, /* Command('leds.cg */ \
	0x69,0x3f,0x6c,0x65,0x64,0x3d,0x32,0x27,0x29,0x3b,0x22,0x3e,0x26,0x62,0x75,0x6c, /* i?led=2');">&bul */ \
	0x6c,0x3b,0x3c,0x2f,0x61,0x3e,0x0d,0x0a,0x09,0x09,0x3c,0x61,0x20,0x69,0x64,0x3d, /* l;</a>....<a id= */ \
	0x22,0x6c,0x65,0x64,0x31,0x22,0x20,0x6f,0x6e,0x63,0x6c,0x69,0x63,0x6b,0x3d,0x22, /* "led1" onclick=" */ \
	0x6e,0x65,0x77,0x41,0x4a,0x41,0x58,0x43,0x6f,0x6d,0x6d,0x61,0x6e,0x64,0x28,0x27, /* newAJAXCommand(' */ \
	0x6c,0x65,0x64,0x73,0x2e,0x63,0x67,0x69,0x3f,0x6c,0x65,0x64,0x3d,0x31,0x27,0x29, /* leds.cgi?led=1') */ \
	0x3b,0x22,0x3e,0x26,0x62,0x75,0x6c,0x6c,0x3b,0x3c,0x2f,0x61,0x3e,0x2d,0x2d,0x3e, /* ;">&bull;</a>--> */ \
	0x0d,0x0a,0x09,0x09,0x3c,0x61,0x20,0x69,0x64,0x3d,0x22,0x6c,0x65,0x64,0x30,0x22, /* ....<a id="led0" */ \
	0x3e,0x26,0x62,0x75,0x6c,0x6c,0x3b,0x3c,0x2f,0x61,0x3e,0x0d,0x0a,0x09,0x09,0x3c, /* >&bull;</a>....< */ \
	0x2f,0x73,0x70,0x61,0x6e,0x3e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x09,0x09,0x3c,0x70, /* /span></p>....<p */ \
	0x3e,0x42,0x75,0x74,0x74,0x6f,0x6e,0x73,0x3a,0x3c,0x62,0x72,0x20,0x2f,0x3e,0x0d, /* >Buttons:<br />. */ \
	0x0a,0x09,0x09,0x3c,0x73,0x70,0x61,0x6e,0x20,0x69,0x64,0x3d,0x22,0x62,0x74,0x6e, /* ...<span id="btn */ \
	0x32,0x22,0x3e,0x3f,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x20,0x26,0x6e,0x62,0x73, /* 2">?</span> &nbs */ \
	0x70,0x3b,0x0d,0x0a,0x09,0x09,0x3c,0x73,0x70,0x61,0x6e,0x20,0x69,0x64,0x3d,0x22, /* p;....<span id=" */ \
	0x62,0x74,0x6e,0x31,0x22,0x3e,0x3f,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x20,0x26, /* btn1">?</span> & */ \
	0x6e,0x62,0x73,0x70,0x3b,0x0d,0x0a,0x09,0x09,0x3c,0x73,0x70,0x61,0x6e,0x20,0x69, /* nbsp;....<span i */ \
	0x64,0x3d,0x22,0x62,0x74,0x6e,0x30,0x22,0x3e,0x3f,0x3c,0x2f,0x73,0x70,0x61,0x6e, /* d="btn0">?</span */ \
	0x3e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x09,0x09,0x3c,0x70,0x3e,0x52,0x61,0x6e,0x64, /* ></p>....<p>Rand */ \
	0x6f,0x6d,0x20,0x4e,0x75,0x6d,0x62,0x65,0x72,0x3a,0x20,0x3c,0x73,0x70,0x61,0x6e, /* om Number: <span */ \
	0x20,0x69,0x64,0x3d,0x22,0x70,0x6f,0x74,0x30,0x22,0x20,0x73,0x74,0x79,0x6c,0x65, /*  id="pot0" style */ \
	0x3d,0x22,0x66,0x6f,0x6e,0x74,0x2d,0x77,0x65,0x69,0x67,0x68,0x74,0x3a,0x6e,0x6f, /* ="font-weight:no */ \
	0x72,0x6d,0x61,0x6c,0x22,0x3e,0x3f,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x3c,0x2f, /* rmal">?</span></ */ \
	0x70,0x3e,0x0d,0x0a,0x09,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x3c,0x2f,0x64, /* p>...</div>..</d */ \
	0x69,0x76,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x68,0x31,0x3e,0x57,0x65,0x6c,0x63,0x6f, /* iv>....<h1>Welco */ \
	0x6d,0x65,0x21,0x3c,0x2f,0x68,0x31,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x74,0x61,0x62, /* me!</h1>....<tab */ \
	0x6c,0x65,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x22,0x70,0x61,0x64,0x64,0x69,0x6e, /* le style="paddin */ \
	0x67,0x2d,0x6c,0x65,0x66,0x74,0x3a,0x20,0x31,0x30,0x70,0x78,0x3b,0x22,0x3e,0x0d, /* g-left: 10px;">. */ \
	0x0a,0x3c,0x74,0x72,0x3e,0x3c,0x74,0x64,0x3e,0x3c,0x62,0x3e,0x53,0x74,0x61,0x63, /* .<tr><td><b>Stac */ \
	0x6b,0x20,0x56,0x65,0x72,0x73,0x69,0x6f,0x6e,0x3a,0x3c,0x2f,0x62,0x3e,0x3c,0x2f, /* k Version:</b></ */ \
	0x74,0x64,0x3e,0x3c,0x74,0x64,0x3e,0x26,0x6e,0x62,0x73,0x70,0x3b,0x3c,0x2f,0x74, /* td><td>&nbsp;</t */ \
	0x64,0x3e,0x3c,0x74,0x64,0x3e,0x7e,0x76,0x65,0x72,0x73,0x69,0x6f,0x6e,0x7e,0x3c, /* d><td>~version~< */ \
	0x2f,0x74,0x64,0x3e,0x3c,0x2f,0x74,0x72,0x3e,0x0d,0x0a,0x3c,0x74,0x72,0x3e,0x3c, /* /td></tr>..<tr>< */ \
	0x74,0x64,0x3e,0x3c,0x62,0x3e,0x42,0x75,0x69,0x6c,0x64,0x20,0x44,0x61,0x74,0x65, /* td><b>Build Date */ \
	0x3a,0x3c,0x2f,0x62,0x3e,0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x74,0x64,0x3e,0x26,0x6e, /* :</b></td><td>&n */ \
	0x62,0x73,0x70,0x3b,0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x74,0x64,0x3e,0x7e,0x62,0x75, /* bsp;</td><td>~bu */ \
	0x69,0x6c,0x64,0x64,0x61,0x74,0x65,0x7e,0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x2f,0x74, /* ilddate~</td></t */ \
	0x72,0x3e,0x0d,0x0a,0x3c,0x74,0x72,0x3e,0x3c,0x74,0x64,0x3e,0x3c,0x62,0x3e,0x46, /* r>..<tr><td><b>F */ \
	0x69,0x6c,0x65,0x20,0x53,0x79,0x73,0x74,0x65,0x6d,0x20,0x4c,0x6f,0x63,0x61,0x74, /* ile System Locat */ \
	0x69,0x6f,0x6e,0x3a,0x3c,0x2f,0x62,0x3e,0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x74,0x64, /* ion:</b></td><td */ \
	0x3e,0x26,0x6e,0x62,0x73,0x70,0x3b,0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x74,0x64,0x3e, /* >&nbsp;</td><td> */ \
	0x7e,0x64,0x72,0x69,0x76,0x65,0x7e,0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x2f,0x74,0x72, /* ~drive~</td></tr */ \
	0x3e,0x0d,0x0a,0x3c,0x74,0x72,0x3e,0x3c,0x74,0x64,0x3e,0x3c,0x62,0x3e,0x46,0x69, /* >..<tr><td><b>Fi */ \
	0x6c,0x65,0x20,0x53,0x79,0x73,0x74,0x65,0x6d,0x20,0x54,0x79,0x70,0x65,0x3a,0x3c, /* le System Type:< */ \
	0x2f,0x62,0x3e,0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x74,0x64,0x3e,0x26,0x6e,0x62,0x73, /* /b></td><td>&nbs */ \
	0x70,0x3b,0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x74,0x64,0x3e,0x7e,0x66,0x73,0x74,0x79, /* p;</td><td>~fsty */ \
	0x70,0x65,0x7e,0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x2f,0x74,0x72,0x3e,0x0d,0x0a,0x3c, /* pe~</td></tr>..< */ \
	0x2f,0x74,0x61,0x62,0x6c,0x65,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x68,0x32,0x3e,0x42, /* /table>....<h2>B */ \
	0x72,0x6f,0x77,0x73,0x65,0x72,0x2d,0x62,0x61,0x73,0x65,0x64,0x20,0x44,0x65,0x76, /* rowser-based Dev */ \
	0x69,0x63,0x65,0x20,0x43,0x6f,0x6e,0x66,0x69,0x67,0x75,0x72,0x61,0x74,0x69,0x6f, /* ice Configuratio */ \
	0x6e,0x3c,0x2f,0x68,0x32,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70,0x3e,0x54,0x68,0x69, /* n</h2>....<p>Thi */ \
	0x73,0x20,0x64,0x65,0x6d,0x6f,0x20,0x73,0x68,0x6f,0x77,0x63,0x61,0x73,0x65,0x73, /* s demo showcases */ \
	0x20,0x68,0x6f,0x77,0x20,0x74,0x6f,0x20,0x63,0x6f,0x6e,0x66,0x69,0x67,0x75,0x72, /*  how to configur */ \
	0x65,0x20,0x61,0x6e,0x64,0x20,0x70,0x72,0x6f,0x67,0x72,0x61,0x6d,0x20,0x61,0x6e, /* e and program an */ \
	0x20,0x65,0x6d,0x62,0x65,0x64,0x64,0x65,0x64,0x0d,0x0a,0x57,0x69,0x2d,0x46,0x69, /*  embedded..Wi-Fi */ \
	0x20,0x64,0x65,0x76,0x69,0x63,0x65,0x20,0x74,0x68,0x61,0x74,0x20,0x64,0x6f,0x65, /*  device that doe */ \
	0x73,0x20,0x6e,0x6f,0x74,0x20,0x68,0x61,0x76,0x65,0x20,0x61,0x20,0x6e,0x61,0x74, /* s not have a nat */ \
	0x75,0x72,0x61,0x6c,0x20,0x6b,0x65,0x79,0x62,0x6f,0x61,0x72,0x64,0x20,0x61,0x6e, /* ural keyboard an */ \
	0x64,0x20,0x73,0x63,0x72,0x65,0x65,0x6e,0x2e,0x20,0x20,0x42,0x79,0x20,0x75,0x73, /* d screen.  By us */ \
	0x69,0x6e,0x67,0x20,0x74,0x68,0x65,0x20,0x69,0x6e,0x74,0x65,0x72,0x6e,0x61,0x6c, /* ing the internal */ \
	0x20,0x77,0x65,0x62,0x73,0x65,0x72,0x76,0x65,0x72,0x0d,0x0a,0x74,0x68,0x61,0x74, /*  webserver..that */ \
	0x20,0x61,0x63,0x63,0x6f,0x6d,0x70,0x61,0x6e,0x69,0x65,0x73,0x20,0x74,0x68,0x65, /*  accompanies the */ \
	0x20,0x4d,0x69,0x63,0x72,0x6f,0x63,0x68,0x69,0x70,0x20,0x54,0x43,0x50,0x2f,0x49, /*  Microchip TCP/I */ \
	0x50,0x20,0x73,0x74,0x61,0x63,0x6b,0x2c,0x20,0x65,0x6e,0x64,0x2d,0x75,0x73,0x65, /* P stack, end-use */ \
	0x72,0x73,0x20,0x63,0x61,0x6e,0x20,0x75,0x73,0x65,0x20,0x74,0x68,0x65,0x69,0x72, /* rs can use their */ \
	0x20,0x62,0x72,0x6f,0x77,0x73,0x65,0x72,0x20,0x61,0x73,0x20,0x61,0x20,0x63,0x6f, /*  browser as a co */ \
	0x6e,0x64,0x75,0x69,0x74,0x0d,0x0a,0x66,0x6f,0x72,0x20,0x70,0x72,0x6f,0x67,0x72, /* nduit..for progr */ \
	0x61,0x6d,0x6d,0x69,0x6e,0x67,0x20,0x74,0x68,0x65,0x20,0x64,0x65,0x76,0x69,0x63, /* amming the devic */ \
	0x65,0x20,0x77,0x69,0x74,0x68,0x20,0x74,0x68,0x65,0x20,0x63,0x6f,0x72,0x72,0x65, /* e with the corre */ \
	0x63,0x74,0x20,0x6e,0x65,0x74,0x77,0x6f,0x72,0x6b,0x20,0x70,0x61,0x72,0x61,0x6d, /* ct network param */ \
	0x65,0x74,0x65,0x72,0x73,0x2e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70, /* eters.</p>....<p */ \
	0x3e,0x3c,0x2f,0x70,0x3e,0x46,0x6f,0x72,0x20,0x61,0x20,0x77,0x69,0x72,0x65,0x6c, /* ></p>For a wirel */ \
	0x65,0x73,0x73,0x20,0x6e,0x65,0x74,0x77,0x6f,0x72,0x6b,0x2c,0x20,0x61,0x6e,0x20, /* ess network, an  */ \
	0x65,0x6e,0x64,0x2d,0x75,0x73,0x65,0x72,0x20,0x77,0x6f,0x75,0x6c,0x64,0x20,0x6e, /* end-user would n */ \
	0x65,0x65,0x64,0x20,0x74,0x6f,0x20,0x68,0x61,0x76,0x65,0x20,0x6b,0x6e,0x6f,0x77, /* eed to have know */ \
	0x6c,0x65,0x64,0x67,0x65,0x20,0x6f,0x66,0x20,0x61,0x74,0x20,0x6c,0x65,0x61,0x73, /* ledge of at leas */ \
	0x74,0x20,0x74,0x68,0x65,0x20,0x66,0x6f,0x6c,0x6c,0x6f,0x77,0x69,0x6e,0x67,0x20, /* t the following  */ \
	0x69,0x6e,0x66,0x6f,0x72,0x6d,0x61,0x74,0x69,0x6f,0x6e,0x3a,0x3c,0x2f,0x70,0x3e, /* information:</p> */ \
	0x0d,0x0a,0x3c,0x75,0x6c,0x3e,0x0d,0x0a,0x3c,0x6c,0x69,0x3e,0x53,0x53,0x49,0x44, /* ..<ul>..<li>SSID */ \
	0x20,0x6e,0x61,0x6d,0x65,0x3c,0x2f,0x6c,0x69,0x3e,0x0d,0x0a,0x3c,0x6c,0x69,0x3e, /*  name</li>..<li> */ \
	0x53,0x65,0x63,0x75,0x72,0x69,0x74,0x79,0x20,0x74,0x79,0x70,0x65,0x20,0x28,0x57, /* Security type (W */ \
	0x45,0x50,0x2c,0x20,0x57,0x50,0x41,0x2c,0x20,0x57,0x50,0x41,0x32,0x29,0x3c,0x2f, /* EP, WPA, WPA2)</ */ \
	0x6c,0x69,0x3e,0x0d,0x0a,0x3c,0x6c,0x69,0x3e,0x53,0x65,0x63,0x75,0x72,0x69,0x74, /* li>..<li>Securit */ \
	0x79,0x20,0x6b,0x65,0x79,0x3c,0x2f,0x6c,0x69,0x3e,0x0d,0x0a,0x3c,0x2f,0x75,0x6c, /* y key</li>..</ul */ \
	0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70,0x3e,0x41,0x73,0x20,0x70,0x69,0x6f,0x6e,0x65, /* >....<p>As pione */ \
	0x65,0x72,0x65,0x64,0x20,0x62,0x79,0x20,0x6d,0x6f,0x73,0x74,0x20,0x6d,0x6f,0x64, /* ered by most mod */ \
	0x65,0x72,0x6e,0x20,0x6f,0x70,0x65,0x72,0x61,0x74,0x69,0x6e,0x67,0x20,0x73,0x79, /* ern operating sy */ \
	0x73,0x74,0x65,0x6d,0x73,0x2c,0x20,0x45,0x61,0x73,0x79,0x20,0x43,0x6f,0x6e,0x66, /* stems, Easy Conf */ \
	0x69,0x67,0x75,0x72,0x61,0x74,0x69,0x6f,0x6e,0x20,0x61,0x6c,0x73,0x6f,0x20,0x68, /* iguration also h */ \
	0x61,0x73,0x20,0x74,0x68,0x65,0x20,0x61,0x62,0x69,0x6c,0x69,0x74,0x79,0x20,0x74, /* as the ability t */ \
	0x6f,0x20,0x73,0x63,0x61,0x6e,0x20,0x66,0x6f,0x72,0x0d,0x0a,0x61,0x6c,0x6c,0x20, /* o scan for..all  */ \
	0x6e,0x65,0x74,0x77,0x6f,0x72,0x6b,0x73,0x20,0x69,0x6e,0x20,0x74,0x68,0x65,0x20, /* networks in the  */ \
	0x76,0x69,0x63,0x69,0x6e,0x69,0x74,0x79,0x20,0x6f,0x66,0x20,0x74,0x68,0x65,0x20, /* vicinity of the  */ \
	0x64,0x65,0x76,0x69,0x63,0x65,0x2c,0x20,0x61,0x6e,0x64,0x20,0x64,0x69,0x73,0x70, /* device, and disp */ \
	0x6c,0x61,0x79,0x20,0x74,0x68,0x65,0x6d,0x20,0x74,0x6f,0x20,0x74,0x68,0x65,0x20, /* lay them to the  */ \
	0x75,0x73,0x65,0x72,0x2e,0x20,0x20,0x54,0x68,0x65,0x20,0x75,0x73,0x65,0x72,0x20, /* user.  The user  */ \
	0x77,0x69,0x6c,0x6c,0x0d,0x0a,0x61,0x6c,0x73,0x6f,0x20,0x62,0x65,0x20,0x67,0x69, /* will..also be gi */ \
	0x76,0x65,0x6e,0x20,0x61,0x64,0x64,0x69,0x74,0x69,0x6f,0x6e,0x61,0x6c,0x20,0x69, /* ven additional i */ \
	0x6e,0x66,0x6f,0x72,0x6d,0x61,0x74,0x69,0x6f,0x6e,0x20,0x61,0x62,0x6f,0x75,0x74, /* nformation about */ \
	0x20,0x74,0x68,0x65,0x20,0x6e,0x65,0x74,0x77,0x6f,0x72,0x6b,0x20,0x73,0x75,0x63, /*  the network suc */ \
	0x68,0x20,0x61,0x73,0x20,0x77,0x68,0x65,0x74,0x68,0x65,0x72,0x20,0x73,0x65,0x63, /* h as whether sec */ \
	0x75,0x72,0x69,0x74,0x79,0x20,0x69,0x73,0x20,0x65,0x6e,0x61,0x62,0x6c,0x65,0x64, /* urity is enabled */ \
	0x0d,0x0a,0x6f,0x72,0x20,0x68,0x6f,0x77,0x20,0x66,0x61,0x72,0x20,0x61,0x77,0x61, /* ..or how far awa */ \
	0x79,0x20,0x74,0x68,0x65,0x20,0x6f,0x74,0x68,0x65,0x72,0x20,0x6e,0x65,0x74,0x77, /* y the other netw */ \
	0x6f,0x72,0x6b,0x20,0x69,0x73,0x2e,0x20,0x20,0x55,0x73,0x65,0x72,0x73,0x20,0x61, /* ork is.  Users a */ \
	0x72,0x65,0x20,0x61,0x6c,0x73,0x6f,0x20,0x67,0x69,0x76,0x65,0x6e,0x20,0x74,0x68, /* re also given th */ \
	0x65,0x20,0x6f,0x70,0x70,0x6f,0x72,0x74,0x75,0x6e,0x69,0x74,0x79,0x20,0x74,0x6f, /* e opportunity to */ \
	0x20,0x65,0x6e,0x74,0x65,0x72,0x20,0x61,0x6c,0x6c,0x20,0x74,0x68,0x65,0x0d,0x0a, /*  enter all the.. */ \
	0x6e,0x65,0x74,0x77,0x6f,0x72,0x6b,0x20,0x69,0x6e,0x66,0x6f,0x72,0x6d,0x61,0x74, /* network informat */ \
	0x69,0x6f,0x6e,0x20,0x6d,0x61,0x6e,0x75,0x61,0x6c,0x6c,0x79,0x2c,0x20,0x77,0x68, /* ion manually, wh */ \
	0x69,0x63,0x68,0x20,0x69,0x73,0x20,0x72,0x65,0x71,0x75,0x69,0x72,0x65,0x64,0x20, /* ich is required  */ \
	0x77,0x68,0x65,0x6e,0x20,0x74,0x72,0x79,0x69,0x6e,0x67,0x20,0x74,0x6f,0x20,0x63, /* when trying to c */ \
	0x6f,0x6e,0x6e,0x65,0x63,0x74,0x20,0x74,0x6f,0x20,0x61,0x20,0x6e,0x65,0x74,0x77, /* onnect to a netw */ \
	0x6f,0x72,0x6b,0x20,0x77,0x69,0x74,0x68,0x20,0x61,0x0d,0x0a,0x68,0x69,0x64,0x64, /* ork with a..hidd */ \
	0x65,0x6e,0x20,0x53,0x53,0x49,0x44,0x2e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a, /* en SSID.</p>.... */ \
	0x3c,0x70,0x3e,0x54,0x68,0x65,0x72,0x65,0x20,0x61,0x72,0x65,0x20,0x74,0x77,0x6f, /* <p>There are two */ \
	0x20,0x6d,0x65,0x6e,0x75,0x20,0x69,0x74,0x65,0x6d,0x73,0x20,0x6f,0x6e,0x20,0x74, /*  menu items on t */ \
	0x68,0x65,0x20,0x6c,0x65,0x66,0x74,0x20,0x68,0x61,0x6e,0x64,0x20,0x73,0x69,0x64, /* he left hand sid */ \
	0x65,0x2e,0x20,0x20,0x54,0x68,0x65,0x20,0x66,0x69,0x72,0x73,0x74,0x20,0x69,0x73, /* e.  The first is */ \
	0x20,0x74,0x68,0x65,0x20,0x63,0x75,0x72,0x72,0x65,0x6e,0x74,0x20,0x70,0x61,0x67, /*  the current pag */ \
	0x65,0x20,0x79,0x6f,0x75,0x20,0x73,0x65,0x65,0x2c,0x0d,0x0a,0x77,0x68,0x69,0x63, /* e you see,..whic */ \
	0x68,0x20,0x73,0x68,0x6f,0x77,0x73,0x20,0x73,0x69,0x6d,0x69,0x6c,0x61,0x72,0x20, /* h shows similar  */ \
	0x69,0x6e,0x66,0x6f,0x72,0x6d,0x61,0x74,0x69,0x6f,0x6e,0x20,0x74,0x6f,0x20,0x74, /* information to t */ \
	0x68,0x65,0x20,0x73,0x74,0x61,0x6e,0x64,0x61,0x72,0x64,0x20,0x4d,0x69,0x63,0x72, /* he standard Micr */ \
	0x6f,0x63,0x68,0x69,0x70,0x20,0x54,0x43,0x50,0x2f,0x49,0x50,0x20,0x44,0x65,0x6d, /* ochip TCP/IP Dem */ \
	0x6f,0x20,0x53,0x74,0x61,0x63,0x6b,0x20,0x28,0x73,0x74,0x61,0x74,0x75,0x73,0x20, /* o Stack (status  */ \
	0x6f,0x66,0x20,0x74,0x68,0x65,0x20,0x4c,0x45,0x44,0x73,0x2c,0x0d,0x0a,0x62,0x75, /* of the LEDs,..bu */ \
	0x74,0x74,0x6f,0x6e,0x73,0x2c,0x20,0x61,0x6e,0x64,0x20,0x70,0x6f,0x74,0x65,0x6e, /* ttons, and poten */ \
	0x74,0x69,0x6f,0x6d,0x65,0x74,0x65,0x72,0x29,0x2e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a, /* tiometer).</p>.. */ \
	0x0d,0x0a,0x3c,0x70,0x3e,0x54,0x68,0x65,0x20,0x73,0x65,0x63,0x6f,0x6e,0x64,0x20, /* ..<p>The second  */ \
	0x6d,0x65,0x6e,0x75,0x20,0x69,0x74,0x65,0x6d,0x20,0x28,0x4e,0x65,0x74,0x77,0x6f, /* menu item (Netwo */ \
	0x72,0x6b,0x20,0x43,0x6f,0x6e,0x66,0x69,0x67,0x75,0x72,0x61,0x74,0x69,0x6f,0x6e, /* rk Configuration */ \
	0x29,0x2c,0x20,0x77,0x69,0x6c,0x6c,0x20,0x64,0x69,0x73,0x70,0x6c,0x61,0x79,0x20, /* ), will display  */ \
	0x61,0x20,0x70,0x61,0x67,0x65,0x20,0x74,0x68,0x61,0x74,0x20,0x77,0x69,0x6c,0x6c, /* a page that will */ \
	0x20,0x61,0x6c,0x6c,0x6f,0x77,0x20,0x79,0x6f,0x75,0x20,0x74,0x6f,0x20,0x73,0x63, /*  allow you to sc */ \
	0x61,0x6e,0x0d,0x0a,0x66,0x6f,0x72,0x20,0x6e,0x65,0x61,0x72,0x62,0x79,0x20,0x6e, /* an..for nearby n */ \
	0x65,0x74,0x77,0x6f,0x72,0x6b,0x73,0x2c,0x20,0x73,0x65,0x65,0x20,0x74,0x68,0x65, /* etworks, see the */ \
	0x6d,0x2c,0x20,0x61,0x6e,0x64,0x20,0x74,0x68,0x65,0x6e,0x20,0x63,0x6f,0x6e,0x6e, /* m, and then conn */ \
	0x65,0x63,0x74,0x20,0x74,0x6f,0x20,0x61,0x6e,0x6f,0x74,0x68,0x65,0x72,0x20,0x6e, /* ect to another n */ \
	0x65,0x74,0x77,0x6f,0x72,0x6b,0x2e,0x20,0x20,0x41,0x66,0x74,0x65,0x72,0x20,0x74, /* etwork.  After t */ \
	0x68,0x65,0x20,0x61,0x74,0x74,0x65,0x6d,0x70,0x74,0x20,0x69,0x73,0x20,0x6d,0x61, /* he attempt is ma */ \
	0x64,0x65,0x0d,0x0a,0x74,0x6f,0x20,0x63,0x6f,0x6e,0x6e,0x65,0x63,0x74,0x20,0x74, /* de..to connect t */ \
	0x6f,0x20,0x74,0x68,0x65,0x20,0x6e,0x65,0x77,0x20,0x6e,0x65,0x74,0x77,0x6f,0x72, /* o the new networ */ \
	0x6b,0x2c,0x20,0x79,0x6f,0x75,0x20,0x77,0x69,0x6c,0x6c,0x20,0x68,0x61,0x76,0x65, /* k, you will have */ \
	0x20,0x74,0x6f,0x20,0x74,0x72,0x61,0x6e,0x73,0x69,0x74,0x69,0x6f,0x6e,0x20,0x79, /*  to transition y */ \
	0x6f,0x75,0x72,0x20,0x77,0x69,0x72,0x65,0x6c,0x65,0x73,0x73,0x20,0x50,0x43,0x2c, /* our wireless PC, */ \
	0x20,0x6c,0x61,0x70,0x74,0x6f,0x70,0x2c,0x20,0x6f,0x72,0x20,0x68,0x61,0x6e,0x64, /*  laptop, or hand */ \
	0x68,0x65,0x6c,0x64,0x0d,0x0a,0x77,0x69,0x72,0x65,0x6c,0x65,0x73,0x73,0x20,0x64, /* held..wireless d */ \
	0x65,0x76,0x69,0x63,0x65,0x20,0x74,0x6f,0x20,0x74,0x68,0x69,0x73,0x20,0x6e,0x65, /* evice to this ne */ \
	0x77,0x20,0x6e,0x65,0x74,0x77,0x6f,0x72,0x6b,0x20,0x69,0x6e,0x20,0x6f,0x72,0x64, /* w network in ord */ \
	0x65,0x72,0x20,0x74,0x6f,0x20,0x73,0x65,0x65,0x20,0x74,0x68,0x61,0x74,0x20,0x74, /* er to see that t */ \
	0x68,0x65,0x20,0x64,0x65,0x76,0x69,0x63,0x65,0x20,0x68,0x61,0x73,0x20,0x69,0x6e, /* he device has in */ \
	0x64,0x65,0x65,0x64,0x20,0x63,0x68,0x61,0x6e,0x67,0x65,0x64,0x20,0x6e,0x65,0x74, /* deed changed net */ \
	0x77,0x6f,0x72,0x6b,0x73,0x2e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x2f, /* works.</p>....</ */ \
	0x64,0x69,0x76,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x73,0x63,0x72,0x69,0x70,0x74,0x20, /* div>....<script  */ \
	0x74,0x79,0x70,0x65,0x3d,0x22,0x74,0x65,0x78,0x74,0x2f,0x6a,0x61,0x76,0x61,0x73, /* type="text/javas */ \
	0x63,0x72,0x69,0x70,0x74,0x22,0x3e,0x0d,0x0a,0x3c,0x21,0x2d,0x2d,0x0d,0x0a,0x2f, /* cript">..<!--../ */ \
	0x2f,0x20,0x50,0x61,0x72,0x73,0x65,0x73,0x20,0x74,0x68,0x65,0x20,0x78,0x6d,0x6c, /* / Parses the xml */ \
	0x52,0x65,0x73,0x70,0x6f,0x6e,0x73,0x65,0x20,0x66,0x72,0x6f,0x6d,0x20,0x73,0x74, /* Response from st */ \
	0x61,0x74,0x75,0x73,0x2e,0x78,0x6d,0x6c,0x20,0x61,0x6e,0x64,0x20,0x75,0x70,0x64, /* atus.xml and upd */ \
	0x61,0x74,0x65,0x73,0x20,0x74,0x68,0x65,0x20,0x73,0x74,0x61,0x74,0x75,0x73,0x20, /* ates the status  */ \
	0x62,0x6f,0x78,0x0d,0x0a,0x66,0x75,0x6e,0x63,0x74,0x69,0x6f,0x6e,0x20,0x75,0x70, /* box..function up */ \
	0x64,0x61,0x74,0x65,0x53,0x74,0x61,0x74,0x75,0x73,0x28,0x78,0x6d,0x6c,0x44,0x61, /* dateStatus(xmlDa */ \
	0x74,0x61,0x29,0x20,0x7b,0x0d,0x0a,0x09,0x76,0x61,0x72,0x20,0x6d,0x61,0x69,0x6e, /* ta) {...var main */ \
	0x73,0x74,0x61,0x74,0x20,0x3d,0x20,0x64,0x6f,0x63,0x75,0x6d,0x65,0x6e,0x74,0x2e, /* stat = document. */ \
	0x67,0x65,0x74,0x45,0x6c,0x65,0x6d,0x65,0x6e,0x74,0x42,0x79,0x49,0x64,0x28,0x27, /* getElementById(' */ \
	0x64,0x69,0x73,0x70,0x6c,0x61,0x79,0x27,0x29,0x2e,0x73,0x74,0x79,0x6c,0x65,0x2e, /* display').style. */ \
	0x64,0x69,0x73,0x70,0x6c,0x61,0x79,0x3b,0x0d,0x0a,0x09,0x76,0x61,0x72,0x20,0x6c, /* display;...var l */ \
	0x6f,0x61,0x64,0x73,0x74,0x61,0x74,0x20,0x3d,0x20,0x64,0x6f,0x63,0x75,0x6d,0x65, /* oadstat = docume */ \
	0x6e,0x74,0x2e,0x67,0x65,0x74,0x45,0x6c,0x65,0x6d,0x65,0x6e,0x74,0x42,0x79,0x49, /* nt.getElementByI */ \
	0x64,0x28,0x27,0x6c,0x6f,0x61,0x64,0x69,0x6e,0x67,0x27,0x29,0x2e,0x73,0x74,0x79, /* d('loading').sty */ \
	0x6c,0x65,0x2e,0x64,0x69,0x73,0x70,0x6c,0x61,0x79,0x3b,0x0d,0x0a,0x0d,0x0a,0x09, /* le.display;..... */ \
	0x2f,0x2f,0x20,0x43,0x68,0x65,0x63,0x6b,0x20,0x69,0x66,0x20,0x61,0x20,0x74,0x69, /* // Check if a ti */ \
	0x6d,0x65,0x6f,0x75,0x74,0x20,0x6f,0x63,0x63,0x75,0x72,0x72,0x65,0x64,0x0d,0x0a, /* meout occurred.. */ \
	0x09,0x69,0x66,0x28,0x21,0x78,0x6d,0x6c,0x44,0x61,0x74,0x61,0x29,0x0d,0x0a,0x09, /* .if(!xmlData)... */ \
	0x7b,0x0d,0x0a,0x09,0x09,0x6d,0x61,0x69,0x6e,0x73,0x74,0x61,0x74,0x20,0x3d,0x20, /* {....mainstat =  */ \
	0x27,0x6e,0x6f,0x6e,0x65,0x27,0x3b,0x0d,0x0a,0x09,0x09,0x6c,0x6f,0x61,0x64,0x73, /* 'none';....loads */ \
	0x74,0x61,0x74,0x20,0x3d,0x20,0x27,0x69,0x6e,0x6c,0x69,0x6e,0x65,0x27,0x3b,0x0d, /* tat = 'inline';. */ \
	0x0a,0x09,0x09,0x72,0x65,0x74,0x75,0x72,0x6e,0x3b,0x0d,0x0a,0x09,0x7d,0x0d,0x0a, /* ...return;...}.. */ \
	0x0d,0x0a,0x09,0x2f,0x2f,0x20,0x4d,0x61,0x6b,0x65,0x20,0x73,0x75,0x72,0x65,0x20, /* ...// Make sure  */ \
	0x77,0x65,0x27,0x72,0x65,0x20,0x64,0x69,0x73,0x70,0x6c,0x61,0x79,0x69,0x6e,0x67, /* we're displaying */ \
	0x20,0x74,0x68,0x65,0x20,0x73,0x74,0x61,0x74,0x75,0x73,0x20,0x64,0x69,0x73,0x70, /*  the status disp */ \
	0x6c,0x61,0x79,0x0d,0x0a,0x09,0x6d,0x61,0x69,0x6e,0x73,0x74,0x61,0x74,0x20,0x3d, /* lay...mainstat = */ \
	0x20,0x27,0x69,0x6e,0x6c,0x69,0x6e,0x65,0x27,0x3b,0x0d,0x0a,0x09,0x6c,0x6f,0x61, /*  'inline';...loa */ \
	0x64,0x73,0x74,0x61,0x74,0x20,0x3d,0x20,0x27,0x6e,0x6f,0x6e,0x65,0x27,0x3b,0x0d, /* dstat = 'none';. */ \
	0x0a,0x0d,0x0a,0x09,0x2f,0x2f,0x20,0x4c,0x6f,0x6f,0x70,0x20,0x6f,0x76,0x65,0x72, /* ....// Loop over */ \
	0x20,0x61,0x6c,0x6c,0x20,0x74,0x68,0x65,0x20,0x4c,0x45,0x44,0x73,0x0d,0x0a,0x09, /*  all the LEDs... */ \
	0x66,0x6f,0x72,0x28,0x69,0x20,0x3d,0x20,0x30,0x3b,0x20,0x69,0x20,0x3c,0x20,0x31, /* for(i = 0; i < 1 */ \
	0x3b,0x20,0x69,0x2b,0x2b,0x29,0x20,0x2f,0x2f,0x20,0x54,0x65,0x6d,0x70,0x6f,0x72, /* ; i++) // Tempor */ \
	0x61,0x72,0x69,0x6c,0x79,0x20,0x63,0x68,0x61,0x6e,0x67,0x65,0x20,0x33,0x20,0x74, /* arily change 3 t */ \
	0x6f,0x20,0x31,0x0d,0x0a,0x09,0x09,0x64,0x6f,0x63,0x75,0x6d,0x65,0x6e,0x74,0x2e, /* o 1....document. */ \
	0x67,0x65,0x74,0x45,0x6c,0x65,0x6d,0x65,0x6e,0x74,0x42,0x79,0x49,0x64,0x28,0x27, /* getElementById(' */ \
	0x6c,0x65,0x64,0x27,0x20,0x2b,0x20,0x69,0x29,0x2e,0x73,0x74,0x79,0x6c,0x65,0x2e, /* led' + i).style. */ \
	0x63,0x6f,0x6c,0x6f,0x72,0x20,0x3d,0x20,0x28,0x67,0x65,0x74,0x58,0x4d,0x4c,0x56, /* color = (getXMLV */ \
	0x61,0x6c,0x75,0x65,0x28,0x78,0x6d,0x6c,0x44,0x61,0x74,0x61,0x2c,0x20,0x27,0x6c, /* alue(xmlData, 'l */ \
	0x65,0x64,0x27,0x20,0x2b,0x20,0x69,0x29,0x20,0x3d,0x3d,0x20,0x27,0x31,0x27,0x29, /* ed' + i) == '1') */ \
	0x20,0x3f,0x20,0x27,0x23,0x30,0x39,0x30,0x27,0x20,0x3a,0x20,0x27,0x23,0x64,0x64, /*  ? '#090' : '#dd */ \
	0x64,0x27,0x3b,0x0d,0x0a,0x0d,0x0a,0x09,0x2f,0x2f,0x20,0x4c,0x6f,0x6f,0x70,0x20, /* d';.....// Loop  */ \
	0x6f,0x76,0x65,0x72,0x20,0x61,0x6c,0x6c,0x20,0x74,0x68,0x65,0x20,0x62,0x75,0x74, /* over all the but */ \
	0x74,0x6f,0x6e,0x73,0x0d,0x0a,0x09,0x66,0x6f,0x72,0x28,0x69,0x20,0x3d,0x20,0x30, /* tons...for(i = 0 */ \
	0x3b,0x20,0x69,0x20,0x3c,0x20,0x33,0x3b,0x20,0x69,0x2b,0x2b,0x29,0x0d,0x0a,0x09, /* ; i < 3; i++)... */ \
	0x09,0x64,0x6f,0x63,0x75,0x6d,0x65,0x6e,0x74,0x2e,0x67,0x65,0x74,0x45,0x6c,0x65, /* .document.getEle */ \
	0x6d,0x65,0x6e,0x74,0x42,0x79,0x49,0x64,0x28,0x27,0x62,0x74,0x6e,0x27,0x20,0x2b, /* mentById('btn' + */ \
	0x20,0x69,0x29,0x2e,0x69,0x6e,0x6e,0x65,0x72,0x48,0x54,0x4d,0x4c,0x20,0x3d,0x20, /*  i).innerHTML =  */ \
	0x28,0x67,0x65,0x74,0x58,0x4d,0x4c,0x56,0x61,0x6c,0x75,0x65,0x28,0x78,0x6d,0x6c, /* (getXMLValue(xml */ \
	0x44,0x61,0x74,0x61,0x2c,0x20,0x27,0x62,0x74,0x6e,0x27,0x20,0x2b,0x20,0x69,0x29, /* Data, 'btn' + i) */ \
	0x20,0x3d,0x3d,0x20,0x27,0x75,0x70,0x27,0x29,0x20,0x3f,0x20,0x27,0x26,0x4c,0x61, /*  == 'up') ? '&La */ \
	0x6d,0x62,0x64,0x61,0x3b,0x27,0x20,0x3a,0x20,0x27,0x56,0x27,0x3b,0x0d,0x0a,0x0d, /* mbda;' : 'V';... */ \
	0x0a,0x09,0x2f,0x2f,0x20,0x55,0x70,0x64,0x61,0x74,0x65,0x20,0x74,0x68,0x65,0x20, /* ..// Update the  */ \
	0x50,0x4f,0x54,0x20,0x76,0x61,0x6c,0x75,0x65,0x0d,0x0a,0x09,0x64,0x6f,0x63,0x75, /* POT value...docu */ \
	0x6d,0x65,0x6e,0x74,0x2e,0x67,0x65,0x74,0x45,0x6c,0x65,0x6d,0x65,0x6e,0x74,0x42, /* ment.getElementB */ \
	0x79,0x49,0x64,0x28,0x27,0x70,0x6f,0x74,0x30,0x27,0x29,0x2e,0x69,0x6e,0x6e,0x65, /* yId('pot0').inne */ \
	0x72,0x48,0x54,0x4d,0x4c,0x20,0x3d,0x20,0x67,0x65,0x74,0x58,0x4d,0x4c,0x56,0x61, /* rHTML = getXMLVa */ \
	0x6c,0x75,0x65,0x28,0x78,0x6d,0x6c,0x44,0x61,0x74,0x61,0x2c,0x20,0x27,0x70,0x6f, /* lue(xmlData, 'po */ \
	0x74,0x30,0x27,0x29,0x3b,0x0d,0x0a,0x7d,0x0d,0x0a,0x73,0x65,0x74,0x54,0x69,0x6d, /* t0');..}..setTim */ \
	0x65,0x6f,0x75,0x74,0x28,0x22,0x6e,0x65,0x77,0x41,0x4a,0x41,0x58,0x43,0x6f,0x6d, /* eout("newAJAXCom */ \
	0x6d,0x61,0x6e,0x64,0x28,0x27,0x73,0x74,0x61,0x74,0x75,0x73,0x2e,0x78,0x6d,0x6c, /* mand('status.xml */ \
	0x27,0x2c,0x20,0x75,0x70,0x64,0x61,0x74,0x65,0x53,0x74,0x61,0x74,0x75,0x73,0x2c, /* ', updateStatus, */ \
	0x20,0x74,0x72,0x75,0x65,0x29,0x22,0x2c,0x35,0x30,0x30,0x29,0x3b,0x0d,0x0a,0x2f, /*  true)",500);../ */ \
	0x2f,0x2d,0x2d,0x3e,0x0d,0x0a,0x3c,0x2f,0x73,0x63,0x72,0x69,0x70,0x74,0x3e,0x0d, /* /-->..</script>. */ \
	0x0a,0x0d,0x0a,0x3c,0x73,0x63,0x72,0x69,0x70,0x74,0x20,0x74,0x79,0x70,0x65,0x3d, /* ...<script type= */ \
	0x22,0x74,0x65,0x78,0x74,0x2f,0x6a,0x61,0x76,0x61,0x73,0x63,0x72,0x69,0x70,0x74, /* "text/javascript */ \
	0x22,0x3e,0x0d,0x0a,0x3c,0x21,0x2d,0x2d,0x0d,0x0a,0x64,0x6f,0x63,0x75,0x6d,0x65, /* ">..<!--..docume */ \
	0x6e,0x74,0x2e,0x67,0x65,0x74,0x45,0x6c,0x65,0x6d,0x65,0x6e,0x74,0x42,0x79,0x49, /* nt.getElementByI */ \
	0x64,0x28,0x27,0x68,0x65,0x6c,0x6c,0x6f,0x27,0x29,0x2e,0x69,0x6e,0x6e,0x65,0x72, /* d('hello').inner */ \
	0x48,0x54,0x4d,0x4c,0x20,0x3d,0x20,0x22,0x7e,0x68,0x65,0x6c,0x6c,0x6f,0x6d,0x73, /* HTML = "~helloms */ \
	0x67,0x7e,0x22,0x3b,0x0d,0x0a,0x2f,0x2f,0x2d,0x2d,0x3e,0x0d,0x0a,0x3c,0x2f,0x73, /* g~";..//-->..</s */ \
	0x63,0x72,0x69,0x70,0x74,0x3e,0x0d,0x0a,0x7e,0x69,0x6e,0x63,0x3a,0x66,0x6f,0x6f, /* cript>..~inc:foo */ \
	0x74,0x65,0x72,0x2e,0x69,0x6e,0x63,0x7e,0x0d,0x0a,0x53,0x75,0x63,0x63,0x65,0x73, /* ter.inc~..Succes */ \
	0x73,0x21,0x20,0x7e,0x6c,0x65,0x64,0x28,0x30,0x29,0x7e,0x1f,0x8b,0x08,0x00,0x00, /* s! ~led(0)~..... */ \
	0x00,0x00,0x00,0x00,0x00,0xad,0x56,0x51,0x6f,0x9b,0x30,0x10,0x7e,0x6e,0xa4,0xfc, /* ......VQo.0.~n.. */ \
	0x07,0xa4,0xbe,0x86,0x08,0x12,0x48,0x53,0xfa,0xd4,0x4d,0xda,0xe3,0x1e,0xf7,0x6e, /* ......HS..M....n */ \
	0xf0,0x11,0xac,0x3a,0x18,0xd9,0xa6,0x49,0x57,0xed,0xbf,0xcf,0x36,0x06,0x0c,0x38, /* ...:...IW...6..8 */ \
	0xa9,0x26,0x4d,0x48,0x5b,0x31,0x77,0xdf,0x7d,0xbe,0xfb,0xee,0x2e,0x39,0xc3,0x1f, /* .&MH[1w.}....9.. */ \
	0xc1,0xe7,0x7a,0xf5,0x50,0xb2,0x5a,0x86,0x25,0x3a,0x13,0xfa,0x91,0x05,0xbf,0x80, /* ..z.P.Z.%:...... */ \
	0x63,0x54,0xa3,0x4d,0xf0,0xca,0x09,0xa2,0x9b,0x40,0xa0,0x5a,0x84,0x02,0x38,0x29, /* cT.M.....@.Z..8) */ \
	0x5f,0x94,0x69,0x8e,0x8a,0xb7,0x13,0x67,0x6d,0x8d,0xb3,0xe0,0x31,0xcd,0xf5,0xa3, /* _.i....gm...1... */ \
	0x8f,0xcf,0x88,0x9f,0x48,0x9d,0x05,0x51,0x73,0x0d,0x50,0x2b,0x99,0x3e,0x6b,0x10, /* ....H..Qs.P+.>k. */ \
	0xc6,0xa4,0x3e,0xa9,0x43,0xf5,0xec,0xf4,0x97,0x48,0x1d,0xff,0x59,0xaf,0xd6,0xab, /* ..>.C....H..Y... */ \
	0x47,0x51,0x21,0xcc,0x2e,0x21,0xab,0xc1,0x10,0xb8,0x10,0x2c,0xab,0x2c,0x78,0x3a, /* GQ!..!.....,.,x: */ \
	0x28,0x2b,0x13,0x85,0x71,0x0c,0x3c,0x0b,0x62,0xe5,0x24,0x18,0x25,0x58,0xc5,0x4a, /* (+..q.<.b.$.%X.J */ \
	0xd3,0xf1,0x4b,0x28,0x59,0x93,0x19,0x38,0x5f,0xe4,0x3f,0x63,0x00,0x79,0x61,0x26, /* ..K(Y..8_.?c.ya& */ \
	0x80,0x07,0x30,0xc9,0xf5,0xe3,0xc3,0x74,0xfd,0x2b,0x0e,0x70,0x13,0x21,0x49,0xbe, /* ..0....t.+.p.!I. */ \
	0x70,0x2f,0x59,0xcb,0x6f,0x79,0xef,0x91,0x7e,0x6e,0x00,0x28,0x88,0x06,0x9d,0x6e, /* p/Y.oy..~n.(...n */ \
	0x46,0xde,0xef,0xf7,0x8b,0x62,0x94,0x65,0xe9,0x4d,0xd0,0x50,0x86,0x9d,0x4d,0xae, /* F....b.e.M.P..M. */ \
	0xa9,0xb6,0x20,0xbf,0x41,0x41,0x46,0x8d,0x9c,0x06,0x94,0x78,0x54,0x84,0xc7,0x46, /* .. .AAF....xT..F */ \
	0x12,0x49,0x2d,0x2b,0x37,0xf6,0xb7,0x24,0xfd,0x11,0x25,0x93,0x68,0x89,0x13,0xec, /* .I-+7..$..%.h... */ \
	0x02,0xe4,0x54,0xc9,0x2c,0xc8,0x19,0xc5,0xfa,0xb0,0x60,0x94,0xf1,0x91,0x72,0x57, /* ..T.,.....`...rW */ \
	0xc2,0x30,0x67,0x52,0xb2,0xb3,0x0a,0x98,0x76,0xae,0x95,0xf5,0x8a,0x0f,0xe6,0xdd, /* .0gR....v....... */ \
	0x25,0xb0,0xe5,0xfa,0x53,0xc7,0x94,0x32,0xa4,0x8c,0xcc,0xc1,0xcb,0x28,0xa5,0x7d, /* %...S..2.....(.} */ \
	0x64,0x6f,0x2b,0xe1,0x2a,0x43,0x44,0xc9,0xa9,0x1e,0x8d,0x3a,0xa8,0x33,0xd4,0xad, /* do+..CD....:.3.. */ \
	0x0b,0x41,0xa1,0x74,0x11,0xe2,0xd4,0x22,0xd8,0x2b,0x85,0xbc,0xa3,0x63,0xd3,0xe8, /* .A.t...".+...c.. */ \
	0x60,0x20,0x57,0xc3,0x71,0x62,0xdd,0x30,0x11,0x0d,0x45,0xaa,0xa1,0x72,0xca,0x8a, /* ` W.qb.0..E..r.. */ \
	0xb7,0x45,0xb9,0xc6,0x94,0xd9,0x6c,0x5c,0x2a,0x22,0x61,0x92,0xc2,0xe3,0x9d,0x14, /* .E....l\."a..... */ \
	0xda,0x32,0x0f,0x39,0x1b,0xb5,0x61,0x93,0x6a,0xee,0x8d,0xa1,0x60,0x1c,0x49,0xc2, /* .2.9..a.j...`.I. */ \
	0xd4,0xe5,0x6b,0xd5,0x6c,0x33,0xde,0x59,0xc5,0xde,0x81,0x2f,0xcb,0x79,0x7c,0x8d, /* ..k.l3.Y.../.y|. */ \
	0x8e,0xd1,0x71,0x30,0x2e,0x14,0x01,0xa8,0xa5,0x7b,0xcb,0x74,0x67,0x8b,0x34,0x4f, /* ..q0.....{.tg.4O */ \
	0xff,0x2c,0x59,0xb1,0x9b,0xac,0x1e,0xa7,0xcb,0x57,0x2f,0x82,0x22,0x8a,0xbe,0xe6, /* .,Y......W/."... */ \
	0x3b,0xb8,0x3a,0x94,0x7b,0x00,0xdc,0x35,0xc3,0x02,0x40,0xdd,0x05,0x38,0x25,0x1e, /* ;.:.{..5..@..8%. */ \
	0x94,0x2a,0x36,0x00,0x56,0x77,0x5d,0xab,0x8c,0x3c,0xb7,0xa2,0x41,0x45,0x1f,0x83, /* ..6.Vw]..<..AE.. */ \
	0x02,0xe2,0x3a,0xeb,0xb2,0x1a,0x50,0x4a,0xc6,0xa4,0xfd,0xec,0xb4,0x49,0xb4,0x3d, /* ..:...PJ.....I.= */ \
	0xc2,0xd9,0x15,0xf7,0xe1,0x70,0x98,0xeb,0xaf,0x50,0xc1,0x81,0xbb,0x53,0x4b,0xe7, /* .....p...P...SK. */ \
	0x27,0x48,0xcd,0x6c,0x0c,0xe6,0x7a,0x33,0xbc,0xe2,0xc9,0x44,0xb4,0x67,0xca,0x1c, /* 'H.l..z3...D.g.. */ \
	0xab,0xc2,0x03,0xee,0xa3,0xd8,0xa1,0x2a,0x91,0x6c,0xc5,0x44,0x8c,0x4f,0xf7,0xcb, /* .........l.D.O.. */ \
	0x34,0xe2,0xbb,0x84,0xe6,0x13,0x78,0x1a,0xcb,0xab,0xc7,0x09,0x81,0xc6,0x50,0x18, /* 4.....x.......P. */ \
	0x42,0xa4,0xdd,0xed,0xd4,0xbf,0xb1,0xdb,0x93,0x44,0x95,0xa7,0x56,0x08,0xe1,0x9c, /* B........D..V... */ \
	0x42,0x34,0xc7,0xdb,0x52,0xc0,0x62,0x31,0x96,0x12,0x67,0x2c,0x4d,0x0c,0xa7,0xf2, /* B4..R.b1..g,M... */ \
	0xc2,0xb8,0x1b,0x39,0x2d,0x17,0xfa,0xbd,0x61,0xc4,0xd6,0xc0,0xe7,0xe9,0x53,0x57, /* ...9-...a.....SW */ \
	0xe7,0x7f,0x57,0x9e,0x5b,0xb8,0xa2,0x73,0x43,0x21,0x67,0x57,0x47,0x58,0x99,0x29, /* ..W.[..sC!gWGX.) */ \
	0xae,0x1e,0x07,0xc1,0xf0,0x97,0xaf,0xbf,0x7d,0xa9,0xde,0x3b,0x9a,0xee,0xc4,0x33, /* ........}..;...3 */ \
	0x6a,0xc7,0x69,0x55,0xcb,0xae,0x23,0x51,0x30,0x0c,0xcb,0x75,0xfe,0x5d,0xad,0x20, /* j.iU..#Q0..u.].  */ \
	0xa2,0xee,0xf4,0x13,0x2e,0x9b,0xfe,0x65,0x13,0x94,0xe4,0x0a,0x38,0x34,0x2a,0xb1, /* .......e....84.. */ \
	0x2f,0xce,0x5d,0x80,0x17,0x44,0x78,0xa6,0x7c,0x09,0xcf,0x2f,0xb3,0xc2,0x3a,0xe3, /* /.]..Dx.|../..:. */ \
	0x5b,0x8f,0xcf,0x85,0x5e,0xbb,0xc3,0xdd,0x38,0x9d,0x20,0xdf,0x8f,0x91,0x38,0x67, /* [...^...8. ...8g */ \
	0xdc,0xed,0xc4,0x29,0xc4,0x42,0xa3,0x53,0x32,0x18,0xdf,0x8b,0xf3,0x1c,0x8d,0x32, /* ...).B.S2......2 */ \
	0x1a,0xda,0xfe,0xe0,0xec,0x53,0xa7,0x95,0x90,0xa8,0x9c,0x9c,0x0f,0x9d,0x90,0xce, /* .....S.......... */ \
	0x68,0x44,0xb3,0xb5,0xe4,0x4c,0x0c,0xa7,0xfe,0x76,0x81,0x3a,0x95,0xeb,0xf7,0xca, /* hD...L...v.:.... */ \
	0x7c,0x34,0xa6,0x23,0x40,0x49,0x80,0x62,0x01,0xf2,0xff,0xaa,0xe7,0x86,0x50,0x86, /* |4.#@I.b......P. */ \
	0x60,0x98,0xbc,0x4f,0x3b,0x55,0xe7,0x4f,0xc7,0xd2,0xff,0xf7,0xeb,0x6f,0xe9,0x42, /* `..O;U.O.....o.B */ \
	0x51,0x0e,0x74,0x59,0xb6,0x30,0x4e,0x7c,0x03,0x6c,0xd7,0x9d,0xf5,0x03,0x69,0x9f, /* Q.tY.0N|.l....i. */ \
	0xde,0x59,0x6a,0x0d,0x13,0xa4,0xeb,0x2e,0x94,0xab,0x3a,0xb6,0x12,0x16,0x04,0x48, /* .Yj.......:....H */ \
	0xdd,0xb4,0x93,0x4d,0xb4,0xf3,0xf2,0x34,0x66,0x5b,0x71,0x76,0x2d,0xc7,0x5f,0x87, /* ...M...4f[qv-._. */ \
	0x8e,0xa1,0xae,0x13,0xe2,0x80,0x6e,0x42,0x6e,0x39,0x88,0x96,0xca,0xf5,0xea,0x73, /* ......nBn9.....s */ \
	0x3d,0x1b,0xdb,0xff,0x56,0x9b,0xe9,0x2f,0x37,0xff,0x56,0xf0,0x6f,0x7a,0x57,0xf5, /* =...V../7.V.ozW. */ \
	0x00,0x43,0x4a,0x1e,0xb6,0xec,0xcd,0xb0,0xee,0x05,0x3d,0x2c,0x9e,0xdc,0x8c,0xe9, /* .CJ.......=,.... */ \
	0x99,0x63,0x69,0x7e,0x5b,0x28,0xcf,0x07,0xed,0x5a,0x22,0x42,0xbd,0xce,0xf9,0xc1, /* .ci~[(...Z"B.... */ \
	0xe3,0x5c,0xc2,0xc4,0xb9,0xad,0xfd,0x81,0x8b,0xc2,0xe7,0x5b,0x62,0xeb,0xfb,0x17, /* .\.........[b... */ \
	0x8c,0xa0,0xeb,0xa6,0x6f,0x0c,0x00,0x00,0x1f,0x8b,0x08,0x00,0x00,0x00,0x00,0x00, /* ....o........... */ \
	0x00,0x00,0xed,0x3c,0xed,0x92,0xe2,0x46,0x92,0xbf,0x71,0xc4,0xbc,0x43,0x0d,0x77, /* ...<...F..q..C.w */ \
	0x67,0x60,0x87,0xa6,0x81,0xfe,0xf0,0x78,0x7a,0xdb,0x0e,0x9a,0x66,0x66,0xb0,0x7b, /* g`.....xz...ff.{ */ \
	0xa0,0x0f,0xe8,0x19,0x4f,0xd8,0x3e,0x87,0x90,0x0a,0x90,0x47,0xa8,0xb4,0x92,0x68, /* ....O.>....G...h */ \
	0x9a,0xf0,0xce,0x3d,0xc4,0xee,0xbe,0xc4,0xbe,0xe5,0x65,0x66,0x55,0x49,0x25,0x21, /* ...=......efUI%! */ \
	0x68,0xc6,0x9e,0x8b,0xfb,0xb1,0xd7,0x11,0xf6,0x80,0x2a,0x33,0x2b,0xbf,0x33,0xeb, /* h..........3+.3. */ \
	0x43,0x1c,0xff,0xe9,0x73,0xfc,0x3d,0xf9,0x82,0xfd,0x89,0xbd,0x71,0xed,0x50,0xd8, /* C...s.=.....q.P. */ \
	0x0b,0x37,0x60,0x93,0xee,0xed,0x71,0xff,0x96,0x8d,0x63,0xcb,0xfe,0xc0,0xbe,0xb3, /* .7`...q...c..... */ \
	0xee,0xad,0xc8,0x0e,0xdd,0x20,0x66,0x37,0xee,0x34,0xb4,0xc2,0x0d,0x42,0x7f,0xb6, /* ..... f7.4...B.. */ \
	0x69,0x69,0xea,0xb1,0x98,0xc5,0x6b,0x2b,0xe4,0x30,0x83,0xcd,0xfd,0x88,0xb3,0xce, /* ii....k+.0...... */ \
	0x3c,0xe4,0x7c,0xc9,0xfd,0x38,0x01,0xe9,0x8a,0x60,0x13,0xba,0xf3,0x45,0xcc,0xfe, /* <.|..8...`...E.. */ \
	0xc9,0xda,0xcd,0x66,0xfb,0xa8,0xdd,0x6c,0x35,0x4d,0x9e,0xb9,0xbd,0xf0,0x85,0x27, /* ...f...l5M.....' */ \
	0xe6,0x1b,0xd6,0xf7,0xed,0x06,0x63,0x1d,0xcf,0x63,0x84,0x10,0x11,0x7e,0xc8,0x23, /* ......c..c...~.# */ \
	0x1e,0xde,0x73,0xa7,0x91,0x50,0x4c,0x71,0x3d,0x39,0x6b,0xc4,0x62,0xc1,0x36,0x62, /* ..s..PLq=9k.b.6b */ \
	0xc5,0xe2,0x05,0x97,0xa8,0xf8,0x60,0x15,0xf1,0x3a,0x5b,0x0a,0xc7,0x9d,0x6d,0xea, /* ......`..:[...m. */ \
	0xcc,0x06,0x2e,0xea,0xcc,0xf2,0x1d,0xa2,0xe0,0xb8,0x51,0x1c,0xba,0xd3,0x55,0xcc, /* ..........Q...U. */ \
	0x5f,0xd0,0xf7,0xaa,0x5b,0x63,0x84,0x9c,0xc8,0xb3,0x5e,0x70,0x9f,0xf1,0xe5,0x94, /* _...[c....^p.... */ \
	0x3b,0x0e,0x77,0x98,0xf0,0x99,0x65,0x4c,0xbb,0xa4,0x4f,0xc2,0x8f,0x43,0xe1,0x79, /* ;.w...eL..O..C.y */ \
	0x3c,0x64,0x22,0x24,0x2a,0xf4,0xe7,0xb8,0x73,0x37,0xb6,0x3c,0x16,0xb9,0x73,0x1f, /* <d"$....s7.<..s. */ \
	0xfe,0x31,0xa0,0x82,0x50,0x38,0x2b,0x3b,0x66,0xd5,0xbf,0x5f,0xf3,0x7b,0x60,0xfc, /* .1..P8+;f.._.{`. */ \
	0x1f,0x35,0x98,0xc5,0xb5,0x17,0xcc,0x8d,0x52,0x74,0xd7,0x8f,0xf9,0x3c,0xb4,0x62, /* .5......Rt...<.b */ \
	0x98,0x14,0x3e,0x0a,0xad,0x57,0xfe,0xb7,0x48,0xe3,0x5f,0xe8,0xe9,0xaa,0x2e,0x70, /* ..>..W..H._....p */ \
	0x3d,0x1c,0xdc,0xbc,0xcf,0x72,0xee,0x84,0xee,0x3d,0xcc,0x16,0x89,0x55,0x68,0x73, /* =....r...=...Uhs */ \
	0x36,0x73,0x3d,0x50,0x4f,0x6f,0xd0,0x6d,0x3f,0xff,0xee,0xbc,0xd9,0xb0,0x13,0x15, /* 6s=POo.m?....... */ \
	0xd0,0x5f,0xf2,0x7c,0xc1,0x02,0x11,0xe2,0xa4,0x30,0xa5,0xc5,0x7c,0xe1,0x1f,0xa5, /* ._.|.....0..|... */ \
	0xd2,0x3a,0xc4,0x2d,0xaa,0x13,0x79,0x4a,0x91,0x41,0xb4,0x5f,0x57,0xbe,0x1d,0xbb, /* .:.-..yJ.A._W... */ \
	0xa0,0x9d,0xb5,0x1b,0x2f,0x32,0x2a,0xe2,0xc0,0x53,0xe8,0xf3,0xd8,0x54,0xc0,0x4c, /* ..../2...S...T.L */ \
	0x84,0xc8,0x6a,0x4a,0x21,0x12,0x1e,0x67,0xc1,0x2a,0x0c,0x04,0x78,0x8e,0x98,0x91, /* ..jJ!..g....x... */ \
	0xf0,0xe1,0xcc,0xb2,0x5d,0x7f,0x2e,0x29,0xa2,0x60,0x05,0x94,0x52,0x57,0x78,0x0f, /* ....]..).`..RWx. */ \
	0x46,0x8f,0x16,0x62,0xe5,0x39,0xe0,0x27,0x33,0x98,0x03,0xf8,0x47,0x24,0xe5,0x18, /* F..b.9.'3...G$.. */ \
	0xcc,0xd2,0xee,0xc8,0x2c,0xdb,0x16,0xcb,0xc0,0xf2,0x37,0x48,0x3c,0x5e,0x28,0x9d, /* ....,.....7H<^(. */ \
	0x27,0x5a,0x43,0xde,0x2c,0xc7,0x71,0x51,0x1a,0x30,0x9b,0xeb,0xc3,0x83,0xa5,0x45, /* 'ZC.,.qQ.0.....E */ \
	0xb2,0x85,0x7c,0x6e,0x85,0x0e,0xa2,0x81,0x8b,0x85,0xca,0x35,0x13,0x3d,0x8a,0xa9, /* ..|n.......5.=.. */ \
	0xe7,0xce,0x09,0x30,0x4a,0xd9,0x9a,0xbc,0xee,0xb1,0xf1,0xf0,0xe5,0xe4,0x5d,0x67, /* ...0J.........]g */ \
	0xd4,0x63,0x9d,0xc1,0x35,0xbb,0x1e,0x76,0xef,0xde,0xf4,0x06,0x93,0xce,0xa4,0x3f, /* .c..5..v.......? */ \
	0x1c,0x30,0x7c,0x7a,0x3b,0x1a,0xbe,0xed,0x5f,0xf7,0xae,0xd9,0xdf,0x3b,0x63,0xd6, /* .0|z;..._....;c. */ \
	0x1f,0xff,0x83,0xbd,0xeb,0x4f,0x5e,0x0f,0xef,0x26,0x84,0x0f,0x78,0xa3,0xce,0x60, /* .....O^..&..x..` */ \
	0xf2,0x9e,0x0d,0x5f,0x02,0xfa,0x7b,0xf6,0x7d,0x7f,0x70,0x5d,0x67,0x3d,0x80,0xe8, /* ..._..{.}.p]g=.. */ \
	0x8d,0x58,0xef,0x87,0xdb,0x51,0x6f,0x3c,0x66,0xc3,0x11,0xeb,0xbf,0xb9,0xbd,0xe9, /* .X...Qo<f....... */ \
	0xf7,0x60,0xa8,0x3f,0xe8,0xde,0xdc,0x5d,0xf7,0x07,0xaf,0x32,0x64,0x6e,0xfa,0x6f, /* .`.?...]...2dn.o */ \
	0xfa,0x72,0xca,0x3a,0x91,0x31,0xc9,0xbe,0xe9,0x8d,0xba,0xaf,0xe1,0x4b,0xe7,0xaa, /* .r.:.1.......K.. */ \
	0x7f,0xd3,0x9f,0xbc,0xaf,0xb3,0x97,0xfd,0xc9,0x00,0xc9,0xbe,0x04,0xba,0x1d,0x42, /* ...............B */ \
	0xbf,0xed,0x8c,0x26,0xfd,0xee,0xdd,0x4d,0x67,0xc4,0x6e,0xef,0x46,0xb7,0xc3,0x71, /* ...&...Mg.n.F..q */ \
	0xaf,0xce,0x26,0xfd,0xc9,0x8d,0x14,0x69,0x30,0x1c,0x1c,0xf5,0x07,0x2f,0x47,0x30, /* ..&....i0..../G0 */ \
	0x69,0x0f,0x45,0x6b,0x00,0x13,0xf0,0x90,0xf5,0xde,0xc2,0x17,0x36,0x7e,0xdd,0xb9, /* i.Ek........6~.. */ \
	0xb9,0x91,0xd1,0xda,0xef,0x8e,0x86,0xdd,0xd7,0x90,0x96,0xae,0x7a,0xc0,0x51,0xe7, /* ............z.Q. */ \
	0x0a,0xf0,0x69,0x0e,0x60,0x08,0xd8,0x06,0x1d,0x00,0x13,0x37,0x75,0x36,0xbe,0xed, /* ..i.`......7u6.. */ \
	0x75,0xfb,0xf8,0x01,0x64,0xed,0x8f,0x7a,0xdd,0x09,0x08,0x28,0x13,0xc8,0x70,0x30, /* u...d..z...(..p0 */ \
	0xee,0xfd,0xe7,0x1d,0x80,0xc1,0x30,0xbb,0xee,0xbc,0xe9,0xbc,0xea,0x8d,0xeb,0xec, /* ......0......... */ \
	0x66,0x38,0x9e,0xa0,0x16,0x81,0x6f,0xd2,0x05,0x7d,0xbf,0xee,0x4c,0x3a,0x75,0xc0, /* f8....o..}..L:u. */ \
	0x80,0x8f,0xc3,0x97,0x52,0x08,0x98,0xfc,0x6e,0x44,0x1c,0xa2,0xd8,0xe3,0xbb,0xab, /* ....R...nD...... */ \
	0x31,0xc8,0x70,0x37,0xe9,0xb1,0x57,0xc3,0xe1,0x35,0xd0,0x99,0xf4,0xba,0xaf,0x07, /* 1.p7..W..5...... */ \
	0xc3,0x9b,0xe1,0xab,0xf7,0x48,0x65,0xdc,0x1b,0xbd,0xed,0x77,0x91,0x3e,0xf2,0xd7, /* .....He....w.>.. */ \
	0xbd,0xe9,0xf4,0xdf,0x8c,0x89,0xce,0xd5,0x7b,0xb0,0x6a,0x7f,0x74,0x2d,0xb5,0xd2, /* ........{.j.t-.. */ \
	0x1b,0xb3,0x6a,0xaa,0xf3,0xab,0xbb,0x09,0x48,0x3e,0x91,0xfa,0x06,0x93,0x4e,0x86, /* ..j.....H>....N. */ \
	0x84,0x7d,0xdd,0x7b,0xd9,0x03,0xd6,0xb5,0x47,0x8c,0x7a,0xc3,0x97,0x35,0x93,0x2e, /* .}.{....G.z..5.. */ \
	0xa9,0x01,0xa4,0xed,0xbd,0x19,0xf4,0x27,0x34,0x3b,0x88,0x3a,0x19,0xf5,0x81,0x1c, /* .......'4;.:.... */ \
	0x99,0x0c,0x1e,0x0c,0x11,0x4f,0x7a,0x2a,0xd0,0x46,0x4b,0xa0,0x6c,0xc0,0xdd,0xbb, /* .....Oz..FK.l... */ \
	0xd7,0x3d,0x72,0x86,0xce,0x18,0x38,0xc6,0x39,0xc1,0xad,0xd0,0xeb,0xae,0x3a,0xe3, /* .=r...8.9.....:. */ \
	0xfe,0x18,0x05,0x25,0x52,0x9d,0xee,0x04,0x04,0x1c,0x8e,0xa4,0x3b,0x18,0x1c,0x0f, /* ...%R.......;... */ \
	0x7a,0xaf,0x6e,0xfa,0xaf,0x20,0xfc,0x7b,0xc0,0xd1,0xd5,0xa8,0xd7,0xe9,0xbe,0x46, /* z.n.. .{.......F */ \
	0x24,0xed,0x20,0xe9,0xdc,0xef,0xfa,0xe3,0x5e,0xe2,0xd7,0x44,0xa5,0xb3,0x8a,0x17, /* $. .....^..D.... */ \
	0x10,0x2c,0xd9,0xbf,0x6b,0xc8,0x58,0xfa,0x73,0x57,0x2c,0x75,0x01,0xf8,0xef,0xcf, /* .,..k.X.sW,u.... */ \
	0xf0,0x47,0x93,0xf6,0x3c,0xcf,0x15,0x71,0xcc,0xde,0x09,0xe1,0x94,0x4a,0xa5,0x56, /* .G..<..q.....J.V */ \
	0xfb,0xf8,0xec,0xb8,0xf9,0x55,0xa9,0x74,0x17,0x38,0x94,0x2b,0x7d,0xbe,0xee,0x7c, /* .....U.t.8.+}..| */ \
	0xd7,0xf9,0x01,0xa7,0x56,0x81,0xf9,0x19,0xfe,0x8e,0x9f,0x7c,0xf1,0xe4,0x8b,0xe3, /* ....V......|.... */ \
	0x63,0x76,0xcd,0x21,0x2d,0x2d,0x5d,0x1f,0x12,0x29,0x95,0x05,0x0b,0x52,0xc2,0x5f, /* cv.!--]..)...R._ */ \
	0x56,0x3c,0x8a,0x21,0x73,0x63,0x56,0x8a,0x5c,0x87,0x87,0xc0,0x44,0x39,0x76,0x97, /* V<.!scV.\...D9v. */ \
	0x58,0x2c,0x56,0x71,0xf9,0xc9,0x17,0xf7,0x16,0x24,0x23,0xf8,0x3e,0x5c,0xc5,0x60, /* X,Vq.....$#.>\.` */ \
	0xe9,0x4b,0x2c,0x7d,0xcd,0xe6,0x05,0x03,0x72,0xcb,0x48,0xd1,0x1d,0xc7,0x02,0x8a, /* .K,}....r.H..... */ \
	0x1b,0x90,0x03,0x62,0x2b,0x4a,0x80,0x28,0x03,0xe3,0xf7,0xa0,0x3d,0x2a,0x69,0x90, /* ...b+J.(....=.i. */ \
	0xf1,0x6d,0x1e,0x45,0x92,0x98,0xf5,0xab,0xf5,0x70,0x03,0x75,0x0b,0x68,0x81,0xb4, /* .m.E.....p.u.h.. */ \
	0xac,0x13,0x86,0xd6,0xa6,0x5a,0xbb,0x20,0x5a,0xaa,0x11,0x88,0x24,0x41,0x4c,0x80, /* .....Z. Z...$AL. */ \
	0xfe,0x0a,0x6a,0x57,0x88,0x34,0x1d,0x01,0xc4,0xec,0x55,0x18,0x62,0x16,0x9c,0x72, /* ..jW.4....U.b..r */ \
	0xcc,0x63,0x90,0x31,0xd7,0x3e,0xe4,0x38,0x59,0x2f,0x79,0x64,0x5b,0x3e,0x83,0x62, /* .c.1.>.8Y/yd[>.b */ \
	0x18,0x0b,0xca,0xee,0xc7,0x72,0x3e,0x7c,0x7a,0x8d,0xb8,0x97,0xac,0x99,0x99,0x45, /* .....r>|z......E */ \
	0xd3,0x72,0x41,0x2b,0x32,0x43,0xc2,0x2c,0x48,0x69,0x1a,0x45,0x94,0x38,0x81,0xa4, /* .rA+2C.,Hi.E.8.. */ \
	0xe5,0xb0,0x59,0x28,0x96,0xec,0x9d,0xfb,0xd2,0xc5,0x1a,0xbc,0xf2,0x78,0xc3,0xa0, /* ..Y(.........x.. */ \
	0x8d,0x24,0xae,0xa2,0x6d,0xd2,0xa0,0x5e,0xcc,0xf6,0x28,0xbb,0x03,0xfa,0x0d,0xc5, /* .$..m..^..(..... */ \
	0x06,0x8a,0x1d,0xb0,0xe6,0x42,0x7e,0x17,0x34,0x02,0x85,0x60,0x2d,0xc2,0x0f,0x20, /* .....B~.4..`-..  */ \
	0xa4,0x35,0xf5,0xb8,0x41,0x92,0x86,0x07,0x72,0xb4,0xf7,0x00,0x89,0x1e,0xeb,0xf6, /* .5..A...r....... */ \
	0x25,0x6b,0x5d,0x28,0x65,0xf7,0x7d,0xc8,0xed,0xe0,0x2b,0xa8,0x6f,0xd2,0x1f,0xaa, /* %k](e.}...+.o... */ \
	0xda,0xd6,0xfe,0x72,0x7c,0x5c,0x5a,0x85,0xde,0x0b,0x12,0x03,0x3e,0x50,0x19,0xb4, /* ...r|\Z.....>P.. */ \
	0xa5,0xee,0x61,0x08,0x2b,0x8f,0x05,0xf6,0x0f,0x25,0x80,0x23,0xec,0x15,0xd5,0x94, /* ..a.+....%.#.... */ \
	0xfe,0x35,0x02,0x42,0x89,0xf5,0xea,0xc8,0xa7,0xc5,0x66,0xba,0x1e,0xc2,0x63,0xdb, /* .5.B......f...c. */ \
	0x82,0x3e,0x86,0xaa,0x18,0x68,0x38,0x10,0x58,0x8d,0x7e,0x78,0x73,0xc3,0xaa,0x22, /* .>...h8.X.~xs.." */ \
	0x90,0x35,0xa6,0x46,0xa4,0x43,0x1e,0x70,0x2b,0x06,0xba,0x21,0x78,0x40,0x8c,0xaa, /* .5.F.C.p+..!x@.. */ \
	0xc3,0xef,0x54,0xa0,0x24,0x05,0x17,0x04,0x99,0xb9,0xc0,0x3c,0xf7,0x36,0x79,0x64, /* ..T.$......<.6yd */ \
	0xf0,0x7d,0xeb,0x05,0x54,0x22,0x76,0x37,0xba,0x61,0xdc,0xb7,0x05,0xca,0x8c,0x9d, /* .}..T"v7.a...... */ \
	0x0d,0x96,0x38,0x01,0xc6,0x66,0xd1,0x6a,0xba,0x74,0x63,0x8c,0x10,0x2b,0x62,0xb7, /* ..8..f.j.tc..+b. */ \
	0x98,0x16,0x11,0x27,0x43,0x27,0xe1,0x39,0x1b,0x43,0x55,0x50,0x43,0x9d,0x25,0x92, /* ...'C'.9.CUPC.%. */ \
	0xd7,0x15,0x67,0x75,0x22,0x00,0x68,0xbf,0x3d,0xf9,0xa2,0x84,0x3e,0x0c,0x85,0x79, /* ..gu".h.=...>..y */ \
	0x15,0x30,0x2c,0x8c,0x62,0xfa,0x2b,0xb7,0x21,0xec,0x4b,0x68,0x0e,0x24,0x06,0x0e, /* .0,.b.+.!.Kh.$.. */ \
	0xab,0x9c,0x75,0x48,0x43,0xe4,0xad,0x34,0x0a,0x5a,0x9c,0x40,0x6c,0x84,0x6a,0x18, /* ..uHC..4.Z.@l.j. */ \
	0xb3,0x87,0x1c,0x54,0x68,0x0d,0xb4,0xc1,0x25,0x5a,0xc2,0x7c,0x98,0x30,0x03,0x43, /* ...Th...%Z.|.0.C */ \
	0xc9,0x67,0x13,0x40,0x29,0xef,0x52,0xf1,0x6a,0x0e,0x61,0xf4,0x8c,0xf8,0x5f,0x70, /* .g.@).R.j.a..._p */ \
	0xc2,0x95,0xe7,0x91,0x53,0x20,0xfb,0x5d,0x70,0x55,0xc8,0x5c,0x20,0x2f,0x8b,0x38, /* ....S .]pU.\ /.8 */ \
	0xfc,0x4f,0x06,0x04,0x05,0x37,0x00,0xb8,0xb3,0xea,0x1a,0xf4,0x2f,0xd6,0x0d,0xb0, /* .O...7....../... */ \
	0xdc,0xeb,0x38,0x0e,0x46,0x72,0xa8,0xc6,0x40,0x7a,0x9d,0xee,0x0a,0x66,0x00,0x91, /* ..8.Fr..@z...f.. */ \
	0xb2,0x08,0x24,0xdc,0x0e,0x84,0x86,0x08,0xb8,0x5f,0xad,0xa2,0x5a,0x2f,0x2f,0x91, /* ..$......_..Z//. */ \
	0xb9,0xda,0xb7,0xe5,0x57,0xbd,0x49,0xf9,0x45,0x19,0xed,0x55,0xae,0x33,0x43,0x27, /* ....W.I.E..U.3C' */ \
	0x75,0xf2,0x93,0x7d,0xc4,0x50,0x0a,0xa2,0xa5,0x81,0xd0,0xf5,0x67,0x6c,0xcd,0x2b, /* u..}.P......gl.+ */ \
	0x21,0xb6,0x70,0xe8,0x19,0xfd,0xde,0x39,0x38,0xc9,0x06,0x5a,0xaf,0xea,0xd2,0xda, /* !.p....98..Z.... */ \
	0x80,0x93,0x9c,0x35,0xce,0x18,0x35,0x47,0xb1,0x0b,0x31,0x05,0x9e,0x23,0x6a,0x12, /* ...5..5G..1..#j. */ \
	0xf7,0x23,0xe3,0x1e,0xb8,0x6d,0xaa,0x86,0x0e,0x78,0xca,0x3d,0xff,0x41,0x9a,0xf3, /* .#...m...x.=.A.. */ \
	0x00,0x2d,0x64,0xe0,0xab,0x65,0x6a,0x0f,0x23,0x68,0xb9,0x48,0x9f,0x93,0xc9,0x6d, /* .-d..ej.#h.H...m */ \
	0xd9,0x14,0x05,0xa6,0xc9,0x51,0xc9,0xcc,0xf0,0xd9,0x55,0x77,0x90,0xfa,0x48,0x0d, /* .....Q....Uw..H. */ \
	0x4a,0x1b,0xe8,0x34,0x26,0x92,0x67,0x45,0x71,0x17,0x62,0x94,0x12,0x8d,0x76,0xe9, /* J..4&.gEq.b...v. */ \
	0xc6,0x9c,0xc7,0xf8,0x41,0xa5,0x66,0x65,0x02,0x4a,0xf5,0x98,0x71,0x31,0x50,0x2c, /* ....A.fe.J..q1P, */ \
	0x4c,0xdd,0x72,0x48,0x27,0xf5,0x46,0xb0,0x8a,0x16,0x5a,0x7c,0xc4,0xfc,0xa8,0xd2, /* L.rH'.F...Z|.... */ \
	0xd6,0x8d,0x10,0x41,0xc4,0x04,0x76,0xf4,0x98,0x0d,0x40,0x5e,0xea,0x44,0x73,0x85, /* ...A..v...@^.Ds. */ \
	0xc2,0xd1,0x15,0x0a,0x94,0x08,0xce,0xbc,0x81,0xe4,0x45,0x21,0x0d,0x49,0x04,0xbd, /* ..........E!.I.. */ \
	0xd9,0x85,0xea,0x64,0x04,0x7a,0x00,0x4d,0x34,0x12,0xa8,0x92,0x7e,0x4b,0x2a,0x21, /* ...d.z.M4...~K.! */ \
	0xff,0x9e,0x70,0xc5,0x41,0xee,0x59,0x01,0x2c,0x0d,0x92,0x90,0x1a,0x61,0xf2,0x17, /* ..p.A.Y.,....a.. */ \
	0x33,0x59,0x12,0x92,0xa2,0x25,0x93,0x03,0x48,0x02,0x3c,0x4e,0x37,0xf8,0x0f,0x40, /* 3Y...%..H.<N7..@ */ \
	0x43,0x8f,0x5d,0x75,0x81,0x68,0xa2,0x05,0x8f,0xfb,0xf3,0x78,0x71,0xc1,0x5c,0xf6, /* C.]u.h.....xq.\. */ \
	0x0d,0x54,0x06,0xe6,0x1e,0x1d,0x81,0x27,0x96,0x90,0xc9,0x52,0xca,0x61,0x02,0x1d, /* .T.....'...R.a.. */ \
	0x2d,0xdc,0x99,0xe2,0x12,0x43,0xf5,0xa9,0x02,0x41,0x94,0x12,0xe5,0x6c,0xd7,0x5f, /* -....C...A...l._ */ \
	0x71,0x1a,0x55,0x3c,0x16,0x9a,0x89,0x1d,0x69,0xe9,0x0d,0x83,0x4a,0x69,0x4a,0x3a, /* q.U<....i...JiJ: */ \
	0x78,0x20,0x8f,0x42,0x35,0xe0,0x0e,0xaa,0x91,0xe6,0xd2,0x18,0xda,0x6f,0xb0,0xe2, /* x .B5........o.. */ \
	0x6d,0x60,0xd9,0x0d,0xb9,0xe4,0xf2,0x92,0x9d,0xb2,0x2f,0xbf,0x64,0x79,0x90,0x08, /* m`......../.dy.. */ \
	0x46,0x57,0x11,0x0e,0x43,0x2b,0x20,0x35,0xaf,0x27,0x70,0x63,0xb6,0xb0,0xb0,0x30, /* FW..C+ 5.'pc...0 */ \
	0x19,0xe9,0x76,0x1d,0x42,0xca,0xd7,0x05,0x7a,0xe5,0xc5,0x04,0x0e,0x33,0xc7,0x9b, /* ..v.B...z....3.. */ \
	0x80,0x8b,0x94,0x81,0x04,0xa3,0x86,0x94,0x2b,0xda,0xc6,0x95,0x9a,0xa4,0x5f,0xda, /* ........+....._. */ \
	0x82,0x2b,0x60,0x5d,0x56,0x27,0x08,0xc9,0x86,0xae,0x6c,0x3d,0x8f,0x16,0x4d,0x52, /* .+`]V'....l=..MR */ \
	0xb5,0xa5,0x34,0x0d,0xec,0x9f,0x5c,0x56,0x9e,0x8a,0x96,0xad,0xa4,0xa9,0xa1,0xae, /* ..4...\V........ */ \
	0x15,0xc5,0xab,0x4d,0xdf,0x29,0x40,0x6f,0xb8,0x3e,0xfc,0xf3,0x7a,0x02,0xf5,0xf1, /* ...M.)@o.>..z... */ \
	0x72,0x4b,0x71,0x9a,0xc1,0x09,0x7f,0x88,0x35,0x43,0xa0,0xb7,0x2a,0x55,0xfc,0xb5, /* rKq.....5C...U.. */ \
	0x1b,0x61,0x41,0x86,0x25,0x2b,0x94,0x4c,0x08,0x0c,0x5c,0xc7,0x61,0x26,0x60,0xf7, /* .aA.%+.L..\.a&`. */ \
	0x96,0x07,0x99,0xb7,0x46,0x76,0xc4,0x48,0x2b,0xe5,0xc9,0x5a,0x53,0x58,0xf1,0x4a, /* ....Fv.H+..ZSX.J */ \
	0xef,0x29,0x1a,0xcf,0x54,0x8a,0xd4,0x50,0x95,0x88,0xda,0x3f,0x2c,0x2f,0xd8,0x80, /* .)..T..P...?,/.. */ \
	0xe8,0x62,0x51,0x47,0x4b,0xf9,0xc8,0x48,0x24,0xb4,0xa5,0x34,0x41,0x09,0x2d,0xbd, /* .bQGK..H$..4A.-. */ \
	0xb2,0x94,0x2b,0xb2,0x1a,0x46,0x16,0xdb,0xbc,0x5e,0xd2,0x47,0x8a,0xc6,0xc5,0xb6, /* ..+..F...^.G.... */ \
	0x6b,0x7f,0xcc,0x7a,0x6a,0xe5,0x9e,0xb3,0xb5,0xe5,0x62,0xc5,0xa7,0xa4,0xd1,0x82, /* k..zj.....b..... */ \
	0xba,0x06,0xf0,0x8e,0x62,0x10,0x5c,0x39,0x69,0x52,0x95,0x2b,0xeb,0xd8,0xf8,0x26, /* ....b.\9iR.+...& */ \
	0x6d,0x57,0x4d,0xef,0xf4,0xef,0xc5,0x07,0xe9,0x87,0xab,0x08,0xd7,0xf0,0x99,0x15, /* mWM............. */ \
	0x3f,0x69,0xda,0xf5,0x83,0xd5,0xe7,0x73,0x4f,0x4a,0xe3,0x19,0xbf,0x53,0xa0,0xc0, /* ?i.....sOJ...S.. */ \
	0x4c,0x07,0xd6,0xfe,0x71,0xc2,0x8b,0x7c,0x6c,0xe1,0xb3,0x6a,0x59,0x29,0x94,0xcd, /* L...q..|l..jY).. */ \
	0x2c,0x17,0xc2,0xb7,0xf1,0x93,0xdf,0x15,0xe0,0x52,0x49,0x33,0xe6,0x40,0xae,0xf4, /* ,........RI3.@.. */ \
	0x44,0x40,0x5d,0xdb,0x54,0xc0,0x72,0x1e,0x94,0x14,0x31,0x4f,0x40,0x16,0x29,0xeb, /* D@].T.r...1O@.). */ \
	0xd9,0xfe,0x85,0x5c,0x65,0xa8,0x43,0xa7,0xce,0x7e,0x5d,0x41,0x76,0xfe,0xc0,0x79, /* ...\e.C..~]Av..y */ \
	0x40,0x6e,0x03,0x21,0x84,0x20,0xd9,0xb2,0xa4,0xf3,0x2a,0x12,0xf9,0x98,0x74,0x4e, /* @n.!. ........tN */ \
	0x58,0x8e,0xa0,0x9a,0x45,0xdc,0xbb,0xc7,0xa6,0x7a,0x0e,0x6c,0x60,0x81,0x6b,0x35, /* X...E....z.l`.k5 */ \
	0x71,0x7d,0x53,0x8a,0x64,0x7a,0x05,0x37,0xab,0x96,0xd3,0x7a,0x53,0xae,0xb7,0x9a, /* q}S.dz.7...zS... */ \
	0xb2,0x2e,0xea,0xfa,0x76,0x6b,0x85,0x91,0x5a,0xb2,0x3c,0x2c,0xbd,0x91,0xee,0x94, /* ....vk..Z.<,.... */ \
	0x43,0x1e,0xaf,0x42,0x1f,0xbc,0x12,0x6a,0x05,0xf4,0xb7,0xaa,0x5d,0x50,0xdd,0x54, /* C..B...j....]P.T */ \
	0xd2,0x69,0x42,0x0b,0x0c,0x48,0xd7,0xd4,0x05,0x2b,0x0a,0xf8,0x25,0xc1,0xa6,0x19, /* .iB..H...+..%... */ \
	0xa0,0x3f,0xe7,0x9e,0x23,0x01,0xe8,0x23,0xfa,0x43,0xc4,0xad,0xd0,0x5e,0x60,0xb6, /* .?..#..#.C...^`. */ \
	0x30,0xea,0x22,0xa4,0x29,0x98,0xe8,0x2d,0x26,0x8e,0xaa,0x22,0x55,0x97,0x28,0xa0, /* 0.".)..-&.."U.(. */ \
	0xdd,0x05,0xac,0x41,0x64,0x5c,0xd0,0x47,0x2c,0x25,0xca,0xd5,0xe5,0x08,0xb8,0x77, /* ...Ad\.G,%.....w */ \
	0x79,0x25,0x7b,0x75,0xee,0x94,0xd9,0xb7,0xac,0xc9,0x5e,0x48,0x2c,0xe9,0x17,0x71, /* y%{u......^H,..q */ \
	0xb8,0x91,0x9e,0x0c,0xe6,0x56,0xc4,0x8d,0xbc,0x18,0x5d,0x6d,0x26,0xd6,0x7c,0x60, /* .....V....]m&.|` */ \
	0x41,0x41,0xa2,0x09,0x6b,0x3f,0x12,0xea,0xcf,0x8d,0x99,0x1b,0x42,0x4d,0xc2,0xcf, /* AA..k?......BM.. */ \
	0x0d,0x1f,0xda,0x7b,0x62,0x4e,0xfa,0x87,0x14,0x92,0xfd,0x41,0x5a,0xaa,0x3c,0x46, /* ...{bN.....AZ.<F */ \
	0xdc,0xa4,0xa9,0xbc,0x19,0x02,0xd0,0xb6,0x62,0x7b,0x51,0xe5,0x21,0xc4,0xef,0x6f, /* ........b{Q.!..o */ \
	0xcc,0x1c,0xc5,0x6e,0x88,0x6c,0x68,0x6a,0x6f,0x1c,0x87,0x54,0xc0,0xab,0x50,0x09, /* ...n.lhjo..T..P. */ \
	0xd4,0x12,0x01,0xfa,0x11,0xfc,0x86,0xea,0x39,0x23,0xbe,0xe9,0x0b,0x3b,0x95,0x4a, /* ........9#...;.J */ \
	0x51,0x14,0xcb,0xee,0xd2,0x9a,0xf3,0xe8,0x78,0x6a,0x85,0x47,0x65,0xf6,0x0c,0x97, /* Q.......xj.Ge... */ \
	0x30,0xf0,0xff,0x72,0x23,0xf0,0xe7,0xe5,0x8b,0xfc,0x3c,0x21,0x5f,0x42,0x66,0xeb, /* 0..r#.....<!_Bf. */ \
	0x2e,0xb8,0xfd,0x61,0x69,0x85,0x1f,0xaa,0x72,0x22,0x8c,0x4b,0x6a,0x55,0x28,0xd4, /* ...ai...r".KjU(. */ \
	0x2e,0xd9,0xae,0xda,0x53,0xc1,0x65,0xed,0x04,0x81,0x2a,0xb5,0x62,0x9d,0x95,0xe3, /* ....S.e.....b... */ \
	0xa9,0x70,0x36,0xe5,0xda,0x8f,0xcd,0x9f,0x2f,0x52,0xba,0xa1,0x58,0xe3,0x72,0x95, /* .p6...../R..X.r. */ \
	0xc8,0x37,0xf0,0x4b,0xd2,0xdd,0x61,0xc5,0xa1,0x2e,0xa6,0x85,0x7d,0xcb,0x9f,0x09, /* .7.K..a.....}... */ \
	0x32,0x6d,0x64,0x9e,0x3d,0x4b,0x9a,0xd8,0x12,0x8e,0xfc,0xe8,0xfe,0x2c,0xdb,0x0c, /* 2md.=K.......,.. */ \
	0x32,0x83,0x96,0x05,0x3e,0x57,0xb7,0x47,0x93,0x4f,0xba,0x19,0x2d,0xa0,0x60,0x05, /* 2...>W.G.O..-.`. */ \
	0xd8,0x12,0x4a,0x0a,0x89,0xcc,0x36,0xad,0x6a,0xb0,0x5e,0x0e,0xc0,0xce,0xd5,0x72, /* ..J...6.j.^....r */ \
	0xb9,0xa6,0x29,0x14,0x5a,0x8d,0x43,0x80,0xbb,0xf1,0xa6,0x0a,0x95,0x22,0xed,0x08, /* ..).Z.C......".. */ \
	0x23,0xf5,0x54,0x1a,0x2a,0x82,0x74,0x0f,0xf1,0x42,0x20,0xaa,0x23,0xb3,0x2d,0x88, /* #.T...t..B .#.-. */ \
	0xd3,0xe6,0x0b,0xb2,0xa9,0x82,0x05,0x25,0x94,0x7d,0x51,0x26,0x9f,0x9a,0x02,0x0f, /* .......%.}Q&.... */ \
	0x1f,0x2e,0x34,0x5c,0x6b,0x0b,0x6e,0xcd,0x83,0x22,0xc0,0xb3,0x17,0x58,0xdb,0xa3, /* ..4\k.n.."...X.. */ \
	0x55,0x80,0xfb,0xd1,0xec,0xdd,0x6d,0x67,0x0b,0x2f,0xb0,0x5a,0x45,0x88,0x5f,0xe7, /* U.....mg./.ZE._. */ \
	0x11,0xdb,0xc9,0xdc,0x27,0x99,0xa1,0x29,0x74,0x0a,0x38,0x4e,0x8b,0x3e,0x05,0x97, /* ....'..)t.8N.>.. */ \
	0x9f,0xa1,0x9d,0x9b,0x01,0xc2,0xda,0x82,0x1e,0xec,0x85,0x4a,0x9f,0xee,0x32,0x10, /* ...........J..2. */ \
	0x51,0xa4,0x16,0x4b,0xa8,0x42,0x06,0xe9,0x94,0x3f,0xcd,0xa0,0x7c,0x34,0x1d,0xdc, /* Q..K.B...?..|4.. */ \
	0x50,0x66,0x56,0xfd,0x7a,0xe0,0x7b,0xbe,0xb9,0x0d,0x61,0x09,0x16,0xa3,0x86,0xbb, /* PfV.z.{...a..... */ \
	0x60,0xb4,0xd4,0x10,0x1f,0xb8,0xb2,0x01,0x7e,0x01,0xad,0x9d,0x9f,0x8e,0x7a,0xaa, /* `.......~.....z. */ \
	0x11,0x1f,0xf1,0x79,0xef,0x21,0xa8,0x96,0xff,0xeb,0xc7,0xe6,0xd1,0xd7,0xd6,0xd1, /* ...y.!.......... */ \
	0xac,0x73,0xf4,0xf2,0xe7,0xdf,0x5a,0xcd,0x8f,0xff,0x0e,0x35,0x0d,0x45,0xb6,0x31, /* .s....Z....5.E.1 */ \
	0x48,0xc8,0x41,0x17,0xfc,0x01,0x09,0xd5,0x21,0x3d,0xcb,0x13,0x0a,0x2c,0x7e,0x94, /* H.A.....!=...,~. */ \
	0xeb,0x0d,0xaa,0x9d,0x3c,0xd9,0xc6,0x6f,0x67,0x05,0xb4,0x3a,0xe3,0x6e,0xbf,0x2f, /* ....<..og..:.n./ */ \
	0xa9,0x9d,0x15,0x13,0x6b,0xb5,0x9f,0xef,0xe7,0xb1,0x7d,0xbe,0x8f,0xc7,0xf6,0xf9, /* ....k.....}..... */ \
	0x1e,0xb2,0x05,0x4c,0xb6,0x4e,0xf6,0x73,0xd9,0x3a,0x29,0xa2,0x17,0x58,0x85,0xc4, /* ...L.N.s.:)..X.. */ \
	0x9e,0xd7,0xcf,0x77,0x93,0x0b,0xac,0x28,0x0a,0x16,0xa1,0x85,0x85,0xf3,0xf9,0xd1, /* ...w...(........ */ \
	0xf9,0x09,0x00,0x58,0x21,0xac,0xb5,0x78,0xa8,0x69,0xeb,0x45,0x51,0x18,0xbe,0x89, /* ...X!..x.i.EQ... */ \
	0xe6,0x17,0xa9,0x09,0xa1,0x8f,0xb2,0x3c,0xd7,0x51,0x3b,0x5e,0x32,0x2d,0x4a,0x4b, /* .......<.Q;^2-JK */ \
	0x63,0x6a,0x6c,0xa9,0x8e,0x0b,0x9a,0x02,0xd9,0xed,0x2c,0xa3,0x39,0xba,0xe2,0xad, /* cjl.......,.9... */ \
	0xc7,0xd1,0x83,0x39,0x9e,0x8b,0xc8,0xd3,0x87,0x77,0xbd,0x5b,0x24,0x27,0xfd,0x93, /* ...9.....w.[$'.. */ \
	0xc8,0xa4,0xc4,0x93,0xc6,0x5b,0x62,0x4b,0x1e,0x30,0x91,0xfe,0x14,0xfe,0xe4,0x63, /* .....[bK.0.....c */ \
	0x5e,0x5d,0x4a,0x96,0x92,0x4e,0xa0,0x04,0xb8,0x00,0x18,0x48,0xcf,0x83,0xd1,0x9a, /* ^]J..N.....H.... */ \
	0xee,0x61,0x14,0x61,0xe4,0x8d,0x1a,0x32,0xa3,0x09,0xa3,0x36,0x70,0x01,0x4b,0x16, /* .a.a...2...6p.K. */ \
	0x48,0xa4,0x36,0x87,0x5e,0x24,0x82,0xee,0x9b,0xcb,0xa3,0xa3,0xb9,0x60,0x53,0x3c, /* H.6.^$.......`S< */ \
	0x7a,0x84,0x8f,0x4b,0xec,0x07,0x22,0xc8,0x44,0xb8,0x61,0x0a,0x91,0x06,0x0d,0xba, /* z..K..".D.a..... */ \
	0xda,0x8d,0x4a,0x28,0xc9,0xec,0xa7,0x94,0x8c,0xb9,0x1c,0x96,0xb8,0xd8,0x13,0x49, /* ..J(...........I */ \
	0x00,0x5d,0x1b,0x7e,0xf9,0xe5,0xee,0xe5,0xdd,0x2f,0xbf,0x94,0x73,0x6b,0x91,0x84, /* .].~...../..sk.. */ \
	0x3f,0xc8,0x6e,0x45,0xdc,0x49,0x9d,0x09,0xdf,0xdb,0x10,0x87,0xf2,0x1c,0x10,0x75, /* ?.nE.I.........u */ \
	0x02,0xc6,0x5c,0xf2,0x28,0x82,0x82,0x83,0x6c,0x02,0x5b,0xf8,0x3c,0xed,0x27,0x33, /* ..\.(...l.[.<.'3 */ \
	0xb6,0x6a,0xc9,0x49,0x4b,0x4a,0x95,0x30,0xd9,0x40,0xa0,0xfa,0x25,0x75,0xee,0x3c, /* .j.IKJ.0.@..%u.< */ \
	0x25,0xcd,0xee,0xe8,0x56,0x11,0xce,0xa6,0xa3,0xa9,0x29,0x67,0x44,0xb1,0xae,0x64, /* %...V.....)gD..d */ \
	0xd5,0x3a,0x40,0x29,0xaa,0x2a,0xf8,0x1a,0x31,0xee,0x13,0x01,0x0e,0xb5,0x12,0x33, /* .:@)....1......3 */ \
	0xd0,0x04,0xe4,0x00,0x58,0x46,0xea,0xf1,0xce,0x0e,0x00,0x49,0xa9,0x54,0xd5,0xf1, /* ....XF.....I.T.. */ \
	0xb1,0x8f,0x8e,0x0c,0xa0,0x22,0x88,0x44,0x85,0xc5,0xf2,0x1b,0x0a,0x50,0x0e,0x88, /* .....".D.....P.. */ \
	0x5b,0x0b,0x68,0x52,0xec,0xaa,0x6c,0x11,0x86,0xd0,0x8f,0x31,0x59,0xf4,0x4c,0x9d, /* [.hR..l....1Y.L. */ \
	0x24,0x88,0xcf,0x00,0x13,0x72,0x5c,0xc4,0x96,0xd8,0x6e,0x82,0x3e,0xb8,0x8b,0x2d, /* $....r\...n.>..- */ \
	0xe8,0x8b,0x5d,0xb0,0x55,0xab,0x86,0xa9,0x0a,0x6c,0x05,0xc9,0x00,0x12,0x83,0xe5, /* ..].U....l...... */ \
	0x70,0x1b,0x9a,0x04,0x4f,0x07,0xb2,0x08,0x77,0x62,0x4e,0x6b,0x90,0x96,0x00,0x11, /* p...O...wbNk.... */ \
	0xa2,0x5e,0x06,0x6d,0x1a,0xa3,0x26,0x4e,0xd6,0x5c,0xd2,0x14,0x20,0x97,0xaa,0xdc, /* .^.m..&N.\.. ... */ \
	0xb2,0x5f,0x61,0x7f,0xfd,0x2b,0xcb,0x3d,0x84,0xfe,0x35,0xd5,0xd5,0xce,0x15,0x6e, /* ._a..+.=..5....n */ \
	0x19,0x62,0xbb,0x5c,0x6b,0xd0,0x1a,0x94,0xb8,0x3a,0x6d,0x26,0xbc,0x1a,0x1e,0x9c, /* .b.\k....:m&.... */ \
	0xa7,0x7d,0x52,0x30,0x61,0xfb,0xbc,0xf6,0xbb,0x66,0x6c,0x35,0x4f,0xd3,0x29,0x75, /* .}R0a....fl5O.)u */ \
	0x4c,0x95,0xb6,0x33,0x91,0x1c,0xd6,0xff,0xff,0x88,0x47,0xd2,0xb8,0x33,0x68,0x64, /* L..3......G..3hd */ \
	0x15,0xd9,0x09,0x26,0x4c,0xeb,0xb4,0xf5,0xcd,0x27,0x64,0xad,0x34,0x6f,0xfe,0x7f, /* ...&L....'d.4o.. */ \
	0xe2,0xfa,0xbf,0x4b,0x5c,0xa9,0x15,0x0e,0xca,0x5f,0x06,0xf8,0xe3,0x69,0x4c,0x96, /* ...K\...._...iL. */ \
	0xd3,0xc2,0xe4,0x73,0x70,0x66,0x81,0x9e,0xcc,0x98,0xd3,0x11,0x5c,0xa6,0x98,0x85, /* ...spf......\... */ \
	0x75,0xcf,0x3f,0x25,0xcf,0xdc,0xa6,0x34,0x74,0xb6,0x29,0xaa,0xd5,0x8d,0x3d,0xd9, /* u.?%...4t.)...=. */ \
	0xe0,0x77,0x87,0x89,0xd9,0xf4,0xc9,0xc6,0x2d,0xd7,0xef,0x51,0x1f,0xad,0x8e,0xa9, /* .w......-..Q.... */ \
	0xaa,0xda,0xf3,0x51,0x81,0x3b,0x03,0x5b,0x9e,0xcf,0x41,0x6c,0x3b,0x6e,0x84,0xab, /* ...Q.;.[..Al;n.. */ \
	0x0f,0x07,0x55,0x4b,0x7b,0xd9,0x92,0x5d,0xb0,0x94,0x23,0xfc,0x4a,0x8c,0xfb,0xc3, /* ..UK{..]..#.J... */ \
	0x62,0x4d,0x0e,0x41,0x7b,0xc2,0xb6,0xe7,0x82,0x8d,0x70,0x33,0x58,0x1d,0xcf,0xa9, /* bM.A{.....p3X... */ \
	0xa3,0x33,0xe6,0xc3,0x2a,0x27,0xd2,0x9d,0x2c,0xed,0x6e,0xe2,0x05,0x08,0x75,0xaa, /* .3...'..,.n...u. */ \
	0xe7,0x6d,0x80,0x1a,0x6e,0xa4,0x59,0x74,0x00,0x88,0x60,0x52,0x9c,0x54,0x3c,0x79, /* .m..n.Yt..`R.T<y */ \
	0xbc,0x43,0xb4,0x60,0xf5,0x6e,0x2d,0xb7,0x0e,0x24,0x4b,0xb9,0x51,0xd7,0x69,0x44, /* .C.`.n-..$K.Q.iD */ \
	0x81,0xe7,0xc6,0xd5,0xf2,0x4f,0xcd,0x76,0xb3,0x5c,0x67,0x27,0xb5,0xb4,0xa3,0x45, /* .....O.v.\g'...E */ \
	0x6e,0x88,0x42,0x8a,0x22,0x57,0x5e,0x7a,0x15,0x22,0x7b,0xa4,0x2c,0x40,0x2b,0x01, /* n.B."W^z."{.,@+. */ \
	0x58,0x7b,0x96,0x5f,0x04,0xd1,0xfe,0x59,0x4e,0x81,0xaa,0x95,0x53,0x50,0xc0,0xa9, /* X{._...YN...SP.. */ \
	0xb5,0x8b,0xda,0x35,0xaa,0x8c,0xc7,0xfd,0x6b,0x4c,0x07,0xe8,0x66,0xe0,0x26,0x1e, /* ...5....kL..f.&. */ \
	0x9f,0xc1,0xbf,0x40,0xf1,0xc3,0xd3,0x8a,0xdc,0x40,0xc9,0xc8,0x5e,0x4a,0x22,0x38, /* ...@.....@..^J"8 */ \
	0x9d,0x35,0xb3,0xea,0xcf,0x93,0x57,0x89,0xd0,0x5e,0x08,0xbc,0xe0,0x22,0x4b,0x1e, /* .5....W..^..."K. */ \
	0xb3,0x9c,0x85,0xb0,0xb1,0x40,0xb9,0xfe,0x0c,0x9c,0x14,0x2c,0x69,0xc3,0x1c,0xbc, /* .....@.....,i... */ \
	0x68,0x42,0xf2,0xa5,0xdc,0x6a,0x57,0x0b,0x0e,0x4b,0xc1,0x3d,0xcb,0x5c,0xe5,0x8f, /* hB...jW..K.=.\.. */ \
	0xc8,0x2b,0x02,0x3e,0xcd,0x64,0x43,0xb0,0x3b,0x6d,0xdc,0x2d,0xb9,0xe5,0xe3,0xd6, /* .+.>.dC.;m.-.... */ \
	0x8b,0x25,0xcb,0x38,0x02,0x62,0xd0,0xa1,0x2f,0xf1,0x07,0x97,0x4e,0xc0,0x10,0x16, /* .%.8.b../...N... */ \
	0x53,0x11,0x04,0x21,0x2e,0x34,0xd5,0x01,0xb8,0x72,0x19,0x4a,0x22,0xd2,0x57,0x48, /* S..!.4...r.J".WH */ \
	0x91,0x4b,0xcb,0x5f,0x81,0x13,0x6e,0x14,0x1e,0x1d,0x00,0x23,0x61,0xda,0x6d,0x62, /* .K._..n....#a.mb */ \
	0xca,0xe9,0x1b,0x8d,0x06,0x73,0x42,0x11,0x38,0x62,0x2d,0xbd,0x4b,0xac,0x77,0x2f, /* .....sB.8b-.K.w/ */ \
	0x88,0x77,0x2d,0x86,0x11,0x91,0x8e,0x2d,0x50,0x2f,0xfd,0xe5,0xdc,0xd4,0x84,0x5c, /* .w-....-P/.....\ */ \
	0xfc,0x2a,0x65,0x54,0xcb,0xee,0x72,0xae,0x76,0xf8,0x34,0x70,0x23,0x0a,0x6d,0xcc, /* ..eT..r.v.4p#.m. */ \
	0x37,0x6a,0xd3,0xc1,0xd6,0xba,0xd5,0xdb,0x0d,0x79,0x9e,0xcc,0x25,0xb6,0xa6,0x61, /* 7j.......y..%..a */ \
	0x44,0xfb,0xce,0xc0,0x45,0x27,0x49,0x4a,0xf2,0x65,0xd6,0x69,0xa0,0x74,0x7e,0x0b, /* D...E'IJ.e.i.t~. */ \
	0x1c,0xa0,0x07,0x94,0xd9,0x0b,0x56,0x26,0xa7,0xa0,0xc9,0x77,0x17,0xf8,0xc8,0x75, /* ......V&...w...u */ \
	0x0c,0x72,0xe8,0xd4,0xfb,0xe1,0x8d,0x86,0xe0,0x32,0xb3,0xce,0x0f,0x70,0xcf,0xad, /* .r.......2...p.. */ \
	0xef,0xa7,0x6b,0x4d,0x23,0x1c,0x65,0xd2,0x22,0xc7,0xd9,0x06,0x93,0xee,0x23,0x6b, /* ..kM#.e.".....#k */ \
	0xef,0xee,0x95,0xeb,0x85,0xec,0x09,0x76,0xb0,0x85,0x8b,0x97,0x94,0x2d,0x35,0xdd, /* .......v.....-5. */ \
	0xc7,0x24,0x56,0x75,0x6d,0xd4,0xc5,0x33,0x75,0xd9,0x5c,0xf9,0xc6,0x3b,0x79,0xe8, /* .$Vum..3u.\..;y. */ \
	0x5c,0xb2,0x07,0x80,0x55,0xfd,0x83,0xbe,0x5f,0xa6,0x13,0x81,0xc2,0x83,0x1a,0x0a, /* \...U..._....... */ \
	0x05,0x01,0x98,0xc1,0x31,0xc8,0x6e,0xae,0x83,0x0e,0xbe,0xb6,0xfc,0x58,0x6e,0x04, /* ....1.n......Xn. */ \
	0xc6,0x79,0x9c,0xc2,0x90,0x3b,0x54,0xa0,0x74,0xeb,0x2c,0x2d,0x28,0x09,0xea,0x07, /* .y...;T.t.,-(... */ \
	0xc8,0xc8,0x62,0x36,0x6b,0xc8,0x76,0xa2,0xaa,0x9d,0x28,0x5b,0x22,0x7e,0x85,0xf4, /* ..b6k.v...(["~.. */ \
	0xab,0x0b,0x84,0x94,0x1e,0x17,0xa2,0x22,0x80,0x1e,0x40,0xed,0x55,0xc9,0xc8,0x5a, /* ......."..@.U..Z */ \
	0xb8,0x8e,0x03,0xb1,0x88,0xf7,0xd4,0xe4,0xf9,0x35,0x11,0x45,0x61,0x30,0xea,0x42, /* .........5.Ea0.B */ \
	0xb1,0x9a,0x2f,0x24,0x2e,0x89,0x87,0xb7,0xd9,0x3c,0x02,0x56,0x86,0x76,0xd5,0xbe, /* ../$.....<.V.v.. */ \
	0x24,0x95,0xb8,0xdd,0xbb,0x65,0xe0,0x74,0xad,0x4a,0xd2,0x57,0x32,0x99,0xc1,0x2f, /* $....e.t.J.W2../ */ \
	0x24,0xde,0xb3,0x7d,0x88,0xdc,0x2e,0xc4,0x33,0xd2,0xf6,0x5b,0xcb,0x33,0xb3,0xf8, /* $..}....3..[.3.. */ \
	0xc8,0x72,0x5c,0x51,0xcc,0x4b,0x74,0xb5,0xa1,0xad,0xb9,0x0a,0xc2,0xb5,0x64,0xa6, /* .r\Q.Kt.......d. */ \
	0x4c,0xb6,0xdd,0x9a,0x72,0xdb,0x2d,0x21,0xb1,0xb5,0xf7,0xa6,0x1a,0x14,0x3d,0x8e, /* L...r.-!......=. */ \
	0xfb,0x67,0x14,0xc6,0x3c,0xe9,0x3b,0x15,0x37,0x78,0x4b,0x87,0x1d,0x31,0x57,0xd6, /* .g..<.;.7xK..1W. */ \
	0xfb,0x64,0x27,0x87,0x52,0xff,0x47,0xad,0x2c,0x10,0x3a,0x65,0xfe,0x89,0xde,0x19, /* .d'.R.G.,.:e.... */ \
	0x33,0x2a,0xfa,0x56,0xcd,0x47,0xc7,0x1d,0x83,0xed,0xec,0x78,0xcb,0xac,0x96,0xe3, /* 3..V.G.....x.... */ \
	0xc8,0x9d,0x45,0x79,0xfd,0x10,0x72,0xc0,0x31,0xe5,0x04,0x70,0x4b,0x4f,0x1e,0x5e, /* ..Ey..r.1..pKO.^ */ \
	0xd4,0x59,0xcc,0x1f,0x62,0x79,0xc6,0x82,0x85,0x1c,0x0d,0x22,0xef,0x1e,0x92,0x6f, /* .Y..by....."...o */ \
	0x13,0x18,0x5e,0x91,0x51,0xee,0x9f,0xec,0x63,0xe1,0xe6,0xb4,0x84,0x01,0xe1,0x33, /* ..^.Q...c......3 */ \
	0x4f,0xd5,0x45,0x1a,0x48,0xfb,0x3e,0x5e,0xf4,0xe4,0x74,0x89,0x69,0x01,0x05,0x0a, /* O.E.H.>^..t.i... */ \
	0xe6,0x92,0xa9,0xce,0xb8,0x08,0xa9,0x3c,0x28,0x65,0x41,0xee,0xa0,0xe3,0x54,0xe0, /* .......<(eA...T. */ \
	0xf7,0xc7,0x69,0xbb,0x46,0xba,0xd8,0x71,0x07,0xa7,0x5a,0xfc,0x5c,0x65,0x41,0xdc, /* ..i.F..q..Z.\eA. */ \
	0x27,0x6f,0xa5,0xc5,0xba,0x08,0x56,0xd5,0x55,0x7d,0x1e,0x8f,0xf5,0x4b,0xf5,0xed, /* 'o....V.U}...K.. */ \
	0xfa,0x96,0x90,0xdc,0xf6,0xd5,0x2d,0x3c,0x9d,0x69,0x24,0x17,0x9a,0xd4,0xdf,0xe7, /* ......-<.i$..... */ \
	0xd9,0x1d,0xae,0xc4,0x33,0x21,0xe2,0x8a,0xb1,0x3b,0xbc,0x7f,0x87,0x18,0x9c,0x4b, /* ....3!...;.....K */ \
	0x76,0x8a,0xc6,0xb6,0x30,0xf8,0x18,0x48,0x0e,0x52,0xe8,0x55,0x1e,0x6b,0xb1,0xa3, /* v...0..H.R.U.k.. */ \
	0x6f,0xf0,0xf6,0x56,0x00,0x24,0xc1,0xf5,0x24,0x0d,0x07,0x8c,0x1b,0xf3,0x91,0x58, /* o..V.$..$......X */ \
	0x6f,0xe1,0xe6,0x13,0x0c,0x89,0x86,0x7c,0xfd,0xc1,0x8d,0x6f,0x24,0xa1,0x37,0xbe, /* o......|...o$.7. */ \
	0x35,0x5d,0x98,0xbb,0xb5,0xa7,0xbc,0xc6,0xa1,0xaa,0xae,0x08,0xd7,0x80,0x6c,0xda, /* 5]............l. */ \
	0x89,0xd5,0xcd,0x6a,0x98,0x11,0x2f,0x99,0x54,0xea,0xac,0xb2,0x76,0x9d,0x78,0xf1, /* ...j../.T...v.x. */ \
	0xe2,0x6b,0xbe,0xac,0x98,0xc5,0x1b,0xaf,0x59,0xec,0x25,0xed,0x28,0xd2,0x04,0x98, /* .k......Y.%.(... */ \
	0xa3,0x6d,0x0b,0x2f,0x02,0xe7,0xa8,0xa8,0x66,0x52,0x03,0x1d,0xb2,0x1d,0x5e,0xe9, /* .m./....fR....^. */ \
	0x38,0x47,0xaf,0x85,0x5d,0xa9,0xe5,0x99,0x69,0x1f,0xc2,0x0c,0x5d,0xc5,0xc3,0x48, /* 8G..]...i...]..H */ \
	0xed,0x53,0x3c,0xec,0x69,0x3c,0x70,0x5c,0x21,0xa5,0x08,0x39,0x31,0x30,0x20,0x51, /* .S<.i<p\!..910 Q */ \
	0x43,0x21,0x66,0xa6,0xca,0x23,0xc0,0x58,0xf2,0x49,0x9d,0x69,0x16,0xdc,0x0d,0x4c, /* C!f..#.X.I.i...L */ \
	0x99,0x17,0xa1,0xdb,0x8f,0x41,0x0a,0x9f,0x96,0x0a,0x08,0x4b,0x30,0x90,0xab,0xa0, /* .....A.....K0... */ \
	0x34,0x55,0x52,0xb5,0xb6,0x33,0x6a,0x4d,0xe9,0x68,0xfd,0x91,0xe9,0x33,0x9a,0x47, /* 4UR..3jM.h...3.G */ \
	0x5b,0x18,0x6e,0x91,0x1f,0x6b,0xd7,0xb2,0x0e,0xb6,0x57,0xf1,0x86,0x83,0xb5,0x3f, /* [.n..k....W....? */ \
	0xdd,0xc1,0x4e,0x0e,0x75,0xb0,0x93,0x43,0x1c,0xec,0xe4,0x30,0x07,0xeb,0xe7,0x3a, /* ..N.u..C...0...: */ \
	0xfb,0x3c,0x53,0xa7,0x87,0x3a,0x1a,0x15,0x83,0x4f,0x71,0xb4,0x14,0xe1,0x00,0x47, /* .<S..:...Oq....G */ \
	0xdb,0x09,0x5c,0xe4,0x68,0x3b,0x81,0x13,0x47,0x7b,0x14,0xd2,0x70,0x34,0x82,0xd9, /* ..\.h;..G{..p4.. */ \
	0x72,0xb4,0xd3,0x8c,0x7a,0x53,0x3a,0x86,0xa3,0xb5,0xb7,0x9c,0xe9,0xc4,0x70,0x8f, /* r...zS:.......p. */ \
	0xfc,0xd8,0x69,0xce,0xd1,0xf6,0x7a,0x83,0xe1,0x68,0x79,0x67,0xd8,0xe1,0x68,0xa9, /* ..i...z..hyg..h. */ \
	0x45,0xcf,0x0e,0x75,0xb3,0xb3,0x9d,0x6e,0x56,0x39,0xad,0x98,0x60,0x07,0x1d,0xec, /* E..u...nV9..`... */ \
	0xa9,0x3a,0xc9,0x30,0x7f,0x97,0x6b,0x86,0x9a,0x4e,0xb6,0x54,0x71,0x96,0x53,0xc5, /* .:.0..k..N.Tq.S. */ \
	0x5e,0x1f,0x34,0x54,0x71,0xfa,0xa9,0xaa,0x38,0x3f,0x54,0x15,0xe7,0x8f,0xab,0x82, /* ^.4Tq...8?T..... */ \
	0xb6,0x00,0xa0,0xe3,0xf9,0x94,0x10,0x48,0xe0,0x77,0x44,0x00,0x36,0x33,0x95,0xfd, /* .......H.wD.63.. */ \
	0xa0,0xae,0x83,0x80,0xaa,0xf7,0xdd,0x0b,0xa9,0x23,0xe5,0x10,0xd8,0xa5,0xf5,0x20, /* .........#.....  */ \
	0x6b,0x38,0x22,0x9c,0xb4,0x2b,0xa6,0x26,0x4c,0x6b,0x25,0xf8,0x86,0x3d,0x4f,0xb7, /* k8"..+.&Lk%..=O. */ \
	0xec,0x79,0x9e,0xb3,0xe7,0x5e,0x0f,0x34,0xec,0x99,0x77,0xc0,0x47,0xed,0xf9,0xd5, /* .y...^.4..w.G... */ \
	0xa1,0xf6,0xfc,0xea,0x40,0x7b,0x72,0xac,0x30,0x7b,0x88,0xca,0xa6,0x56,0x5b,0x93, /* ....@{r.0{...V[. */ \
	0xa0,0x77,0x69,0x9d,0x16,0x19,0xbb,0xe1,0x94,0x1d,0xb7,0xa0,0xe4,0xed,0xe7,0x08, /* .wi............. */ \
	0x1a,0x1d,0x7d,0xe1,0x91,0x1e,0x54,0x2b,0x03,0xe8,0x87,0x11,0xa5,0x59,0x0c,0xdf, /* ..}...T+.....Y.. */ \
	0xca,0xc3,0xbf,0xeb,0xdd,0x9a,0x99,0x2f,0x07,0xde,0xde,0x02,0xbf,0xed,0x1c,0xdd, /* ......./........ */ \
	0x8e,0xbf,0x47,0x94,0xb3,0x62,0x94,0x93,0x02,0x94,0xb6,0xc6,0xf9,0xba,0x62,0x2a, /* ..G..b........b. */ \
	0x3b,0xe3,0x32,0x44,0xc5,0xf0,0x97,0xb3,0x2d,0x7f,0xf9,0x2a,0xe7,0x2f,0x7b,0xc3, /* ;.2D....-..../{. */ \
	0xd4,0xf0,0x97,0x7c,0x94,0x3e,0xea,0x2f,0xcf,0x0f,0xf5,0x97,0xe7,0xbb,0xfd,0xe5, /* ...|.>./........ */ \
	0xc4,0xa0,0x89,0xeb,0xe1,0x2b,0xea,0xe5,0x0f,0x4c,0x00,0x29,0x42,0xa1,0x3b,0xa4, /* .....+...L.)B.;. */ \
	0xc3,0x95,0x47,0xe0,0x75,0xc6,0x98,0x1e,0x04,0x9d,0xd4,0xc1,0xef,0x00,0xe2,0x31, /* ..G.u..........1 */ \
	0x60,0xa3,0x14,0x66,0xd6,0xfb,0x66,0x35,0x7c,0x9e,0xb1,0x61,0x4a,0xca,0x30,0xf3, /* `..f..f5|..aJ.0. */ \
	0xf9,0x96,0x99,0x9f,0xeb,0x51,0x6a,0xe6,0x33,0xc3,0xd8,0x8a,0x49,0xea,0x85,0x63, /* .....Qj.3...I..c */ \
	0xed,0x3d,0x63,0x27,0x7b,0xc6,0x4e,0xf7,0x8c,0x9d,0xed,0x19,0x3b,0x2f,0xde,0xfe, /* .=c'{.N.....;/.. */ \
	0x48,0x5b,0xd0,0x47,0xb7,0xc6,0xf5,0x26,0x83,0x0a,0x1e,0xe3,0xd0,0xec,0xb4,0x96, /* H[.G...&........ */ \
	0xdb,0x79,0xd9,0x81,0x29,0xb7,0x7a,0xaa,0xba,0xc3,0x3b,0x0c,0xba,0x5d,0xcc,0x78, /* .y..).z...;..].x */ \
	0xda,0xd2,0xfc,0x01,0xc6,0xdb,0x07,0x32,0xfe,0x29,0x29,0xe6,0x50,0x5a,0x87,0xe4, /* .......2.)).PZ.. */ \
	0x9e,0x02,0x73,0x39,0x63,0x58,0x58,0xe2,0x2a,0x15,0xeb,0x56,0x1d,0xd3,0x7b,0x1d, /* ..s9cXX....V..{. */ \
	0x2f,0x70,0xd5,0x69,0x9b,0x24,0xbd,0xc6,0x42,0xb7,0xaa,0x3e,0xe3,0xc5,0xac,0xa2, /* /p.i.$..B..>.... */ \
	0x4d,0xf0,0xe2,0x34,0xa6,0x60,0x69,0x5f,0xff,0xc0,0xbd,0x62,0x0d,0x9b,0xdb,0x2a, /* M..4.`i_...b.... */ \
	0xa6,0xc7,0x7a,0x9b,0x18,0xc0,0x70,0x9f,0xb8,0x20,0xc5,0xd0,0x1e,0x8d,0xde,0xf3, /* ..z...p.. ...... */ \
	0xc2,0xeb,0x6c,0xdc,0x36,0xbf,0x92,0x5e,0x2e,0x0a,0xd1,0x85,0xbf,0x14,0xab,0x88, /* ..l.6..^........ */ \
	0xe3,0xcd,0x5d,0xa0,0x53,0xc6,0xb7,0x80,0x1a,0x94,0x70,0x1b,0xf6,0x2a,0x8c,0x44, /* ..].S.....p....D */ \
	0x78,0x59,0x09,0x04,0xbd,0x24,0x5b,0x29,0xef,0xa4,0x90,0x24,0x96,0xed,0x9d,0xa9, /* xY...$[)...$.... */ \
	0x8a,0xa1,0x8e,0x43,0x57,0xdf,0x45,0x8b,0xef,0x5c,0x0d,0x68,0x35,0x75,0x11,0x38, /* ...CW.E..\.h5u.8 */ \
	0x7c,0x11,0x8e,0x3a,0xaa,0xe5,0xd8,0x39,0x64,0xfd,0xad,0x3a,0x88,0x03,0xed,0x28, /* |..:...9d..:...( */ \
	0x21,0x73,0x56,0xf4,0x84,0x9d,0xee,0xf5,0xab,0x13,0x6d,0x7c,0xdf,0x40,0x87,0xde, /* !sV.......m|.@.. */ \
	0xd6,0x8a,0x57,0x52,0xd9,0xda,0x75,0xd9,0x06,0xd4,0x6e,0x63,0x9c,0x0e,0x7c,0xca, /* ..WR..u...nc..|. */ \
	0x3a,0x14,0x61,0x83,0x75,0x78,0xa0,0x6c,0x12,0x52,0xc9,0x96,0xbf,0x7c,0xa9,0x8d, /* :.a.ux.l.R...|.. */ \
	0x91,0x5d,0x07,0x48,0x94,0x9c,0xd6,0x0f,0x59,0x8c,0x6e,0x2f,0xce,0x4c,0x51,0x95, /* .].H....Y.n/.LQ. */ \
	0x23,0x16,0xef,0x00,0x14,0x8d,0xb4,0x77,0x8e,0x9c,0xec,0x1c,0xd1,0x4b,0x39,0x4a, /* #......w.....K9J */ \
	0x02,0xf9,0x5a,0xb2,0xbd,0xe9,0x2a,0x37,0xcf,0xc6,0x3a,0xa7,0x7c,0xf6,0x5b,0xa2, /* ..Z....7..:.|.[. */ \
	0x15,0xe2,0xa3,0x72,0xf0,0x2d,0xd1,0x47,0x77,0x01,0x2f,0xcd,0x3d,0x40,0xf5,0x77, /* ...r.-.Gw./.=@.w */ \
	0xc0,0x3e,0x60,0x56,0xea,0x20,0x84,0xec,0x20,0xbb,0x04,0xe2,0x52,0x5d,0xc2,0x25, /* .>`V. .. ...R].% */ \
	0x91,0x21,0xf2,0x6e,0xac,0x29,0x75,0xde,0x65,0xd4,0x8b,0xef,0x26,0x79,0x2c,0xbf, /* .!.n.)u.e...&y,. */ \
	0x97,0x9e,0xbc,0xfa,0xf9,0x1f,0xec,0xd4,0xdc,0x47,0x4f,0x69,0xe0,0x39,0x7b,0xa3, /* .........GOi.9{. */ \
	0x9c,0xba,0xb9,0xc6,0x78,0xf6,0xec,0x62,0xff,0xa1,0x58,0x72,0x9a,0xad,0x0f,0x4c, /* ....x..b..Xr...L */ \
	0x12,0x9a,0x5b,0xc2,0xac,0xe8,0xdd,0xde,0x31,0xbd,0x36,0xa3,0xaf,0x4c,0x1b,0x02, /* ..[.....1.6..L.. */ \
	0xad,0x42,0xef,0xd6,0xa2,0xdd,0x53,0xf5,0x72,0x1a,0xc4,0x35,0xbd,0x8e,0xda,0x08, /* .B....S.r..5.... */ \
	0xe0,0xb1,0x3e,0x1e,0xa3,0x98,0x82,0xb0,0x1f,0xc8,0x63,0x66,0x85,0x84,0x27,0x30, /* ..>.......cf..'0 */ \
	0xf2,0x6d,0x95,0xaa,0x7e,0x82,0xe7,0x7d,0x7d,0xdf,0xe1,0x0f,0xc3,0x59,0xb5,0x72, /* .m..~..}}....Y.r */ \
	0x5c,0xa9,0x41,0xa2,0x6e,0x29,0x97,0x93,0x87,0x61,0x9a,0xc6,0x25,0x83,0x4e,0xd5, /* \.A.n)...a..%.N. */ \
	0x9f,0xb9,0xf3,0x55,0xc8,0x1b,0x8b,0x78,0x59,0x31,0x0e,0x19,0x0a,0x6f,0x90,0x93, /* ...U...xY1...o.. */ \
	0x33,0x41,0xb6,0x6c,0xe2,0xa5,0x88,0x4b,0x5a,0x5c,0xa8,0x73,0x07,0x44,0xd1,0xaf, /* 3A.l...KZ\.s.D.. */ \
	0xc2,0x3e,0xbd,0x2c,0xbe,0x7f,0x0e,0x93,0xad,0xfc,0x98,0xd0,0x93,0xab,0x14,0xbb, /* .>.,............ */ \
	0xa7,0xa2,0xab,0x08,0x85,0x73,0xd1,0x59,0x58,0xf2,0x1a,0x70,0x14,0xa5,0x57,0xec, /* .....s.YX..p..W. */ \
	0x5d,0x3a,0xf1,0x55,0x37,0x3b,0x22,0x01,0xdf,0x23,0xb0,0x4c,0xfa,0x92,0x33,0xde, /* ]:.U7;"..#.L..3. */ \
	0x25,0x58,0xb8,0x81,0xa2,0x62,0xf2,0xfc,0x67,0xd6,0x3a,0x37,0xee,0x26,0xd1,0x9d, /* %X...b..g.:7.&.. */ \
	0x11,0x87,0x35,0xd9,0x94,0xcf,0xf0,0x75,0xb7,0x48,0xbd,0xac,0x06,0x04,0x16,0x22, /* ..5....u.H....." */ \
	0x8a,0x35,0x58,0xee,0xbd,0x06,0x52,0x4f,0xc3,0x9e,0xbb,0xdf,0x82,0x48,0x40,0xf5, /* .5X...RO.....H@. */ \
	0xb2,0x59,0x01,0xdd,0xab,0x29,0x1a,0xb1,0x18,0x4b,0x3b,0xc1,0x4c,0xb2,0x9d,0x49, /* .Y...)...K;.L..I */ \
	0x6e,0x62,0xc8,0x7b,0xeb,0xe9,0xf4,0x8f,0xd1,0x3d,0x84,0xac,0xfa,0x64,0xbe,0xbd, /* nb.{.....=...d.. */ \
	0xb0,0x45,0x96,0x1c,0xb2,0x01,0x3a,0x07,0x3d,0x9b,0x3e,0x5a,0x57,0x17,0x5e,0xca, /* .E....:.=.>ZW.^. */ \
	0x75,0x76,0xd6,0xd4,0x44,0x15,0xab,0xdb,0x77,0xcd,0x8a,0xed,0xa7,0x56,0xb6,0x60, /* uv..D...w....V.` */ \
	0xbe,0xe4,0xc8,0x3e,0xbd,0xe2,0x77,0x00,0xca,0x2e,0x0f,0x8c,0x94,0x57,0x64,0xee, /* ...>..w......Wd. */ \
	0x92,0x25,0x37,0x47,0x1c,0x37,0x0a,0x3c,0x6b,0xa3,0x8f,0x14,0x93,0x77,0xac,0xb3, /* .%7G.7.<k....w.. */ \
	0xe7,0xa9,0xf4,0x0b,0x2b,0x99,0xab,0x22,0x06,0x21,0x5b,0xbe,0x6e,0x43,0xa7,0x32, /* ....+..".![.nC.2 */ \
	0xfa,0xb1,0xd1,0x1b,0x3e,0xc2,0x7a,0x7d,0x87,0xef,0x43,0x3e,0xbb,0xb7,0xec,0xcd, /* ....>.z}..C>.... */ \
	0x5e,0x98,0x48,0xd5,0xbd,0xbd,0x40,0xd8,0x73,0x49,0x05,0x6c,0x1b,0x5b,0xf9,0x84, /* ^.H...@.sI.l.[.. */ \
	0x4e,0x5d,0x4a,0x20,0x3c,0xab,0xa5,0xd7,0x18,0x75,0x18,0xd0,0x9b,0x65,0x78,0x10, /* N]J <....u...ex. */ \
	0x46,0xaf,0xcb,0x83,0xfc,0xe1,0xe6,0x5f,0x22,0x24,0xfe,0x57,0x02,0x42,0x6b,0xdf, /* F......_"$.W.Bk. */ \
	0x54,0xdd,0xe5,0x27,0x64,0x40,0xd0,0xab,0x7c,0xa5,0xd9,0xc1,0x13,0x4c,0xbc,0x7d, /* T..'d@..|....L.} */ \
	0x5f,0xa7,0xf7,0x63,0xc9,0x36,0xf2,0x85,0xc9,0x88,0x05,0xa0,0x61,0x2e,0x73,0x1a, /* _..c.6......a.s. */ \
	0xde,0xe6,0xa3,0x9a,0x9f,0xf9,0xad,0x83,0xbc,0xf1,0x80,0x83,0x66,0x6a,0x3c,0xf5, /* ............fj<. */ \
	0x66,0x19,0xba,0x30,0xbd,0x1e,0x8d,0x55,0xd8,0x81,0xba,0x3b,0x10,0xac,0x73,0x1b, /* f..0...U...;..s. */ \
	0x11,0x25,0x48,0x9f,0xc9,0xfb,0x63,0x5a,0x57,0x9f,0x72,0x91,0x4b,0x2a,0xe8,0xe2, /* .%H...cZW.r.K... */ \
	0x50,0x44,0x5d,0x33,0x25,0x4f,0xe8,0x90,0xef,0xdc,0x10,0xba,0x03,0x60,0x5d,0xb5, /* PD]3%O.......`]. */ \
	0xf9,0x91,0xbe,0xcc,0xf7,0x44,0x9d,0x5b,0x9b,0x0e,0xb1,0xd5,0x1d,0x48,0xd8,0x3f, /* .....D.[.....H.? */ \
	0x6a,0xdb,0xb6,0x5a,0xe5,0xab,0x63,0x72,0x39,0x23,0x18,0x48,0xdd,0x77,0xc2,0x1f, /* j..Z..cr9#.H.w.. */ \
	0x30,0x78,0xc0,0x42,0x89,0xe9,0x44,0xbf,0xa6,0x59,0x7d,0x78,0x78,0x68,0x18,0xff, /* 0x.B..D..Y}xxh.. */ \
	0xb1,0xb9,0x7b,0x4f,0xd7,0xfd,0xa8,0x58,0xd3,0xe5,0x16,0x7d,0x99,0x0a,0xdf,0x35, /* ..{O...X...}...5 */ \
	0x93,0xd7,0x0d,0x67,0x50,0x94,0x62,0xc9,0x29,0x13,0x36,0x65,0x21,0x87,0xca,0x73, /* ...gP.b.).6e!..s */ \
	0xf5,0x69,0xda,0x1e,0x94,0xf6,0xaf,0x9f,0x55,0xaa,0x83,0xb6,0x4e,0xae,0xab,0x74, /* .i......U...N..t */ \
	0xea,0x83,0x5a,0x89,0x87,0xe1,0x95,0xfd,0x2b,0x66,0x4f,0x58,0x0e,0xbd,0xe2,0xba, /* ..Z.....+fOX.... */ \
	0x8d,0xed,0xfa,0x9e,0xab,0xf1,0xf3,0x97,0xb8,0x40,0x84,0x37,0xd6,0x07,0x7c,0x8b, /* .........@.7..|. */ \
	0x18,0x7f,0x59,0x4a,0xfa,0xad,0xc4,0x94,0x3f,0x46,0x04,0x23,0xf2,0xe5,0x60,0xf5, /* ..YJ....?F.#..`. */ \
	0x74,0x4f,0x03,0xb5,0x8f,0x85,0x44,0x80,0xdf,0x23,0x7d,0xca,0xbf,0x64,0x18,0x5f, /* tO....D..#}..d._ */ \
	0x3c,0x4f,0xdf,0x3b,0x47,0x1e,0x6f,0x7a,0xd7,0xd1,0x93,0xf4,0xa5,0x6d,0xd5,0x2b, /* <O.;G.oz.....m.+ */ \
	0x3e,0xcf,0x5e,0xb4,0xd8,0x91,0xe9,0xc1,0xdb,0x2b,0xcf,0x5c,0xf9,0x12,0x68,0xab, /* >.^......+.\..h. */ \
	0x22,0x5f,0x60,0xdb,0x2d,0x22,0x00,0x43,0x62,0x72,0x35,0x97,0xb6,0xf0,0x04,0xbe, /* "_`.-".Cbr5..... */ \
	0x34,0x56,0xf9,0xb7,0xe6,0xd7,0x4d,0xa9,0xe1,0xe4,0x8d,0xb5,0xdf,0x41,0xc4,0x71, /* 4V....M......A.q */ \
	0x9c,0x4a,0xc6,0x36,0xdb,0xa2,0xca,0x04,0x51,0x20,0xed,0xe9,0x41,0xd2,0x4e,0x63, /* .J.6....Q ..A.Nc */ \
	0x3f,0x91,0x76,0x15,0x3c,0x26,0x2e,0x42,0x4b,0x4e,0xcd,0xb7,0xa0,0x2b,0x5f,0xde, /* ?.v.<&.BKN...+_. */ \
	0x58,0xcb,0xa9,0x63,0x5d,0x1c,0x2a,0xf0,0x0e,0x32,0x6f,0xb3,0xb2,0xca,0x1f,0xcc, /* X..c]....2o..... */ \
	0x21,0x21,0x6f,0x87,0x13,0xf9,0x96,0xf4,0x3e,0x8f,0x09,0x44,0x0c,0x3d,0x64,0x86, /* !!o.....>..D.=d. */ \
	0xe4,0x8e,0x52,0x4d,0x80,0x85,0x7b,0x44,0x32,0x7f,0x25,0x7b,0x9c,0xb2,0x85,0xcf, /* ..RM..{D2.%{.... */ \
	0xfd,0xbc,0x4c,0x71,0x72,0xfa,0xa4,0x5c,0x8a,0x77,0x62,0x13,0xf7,0x9d,0x73,0x1f, /* ..Lqr..\.wb...s. */ \
	0x7f,0x9d,0x26,0xd7,0xc7,0x2e,0xac,0xd0,0xa1,0x9f,0xfb,0x8a,0xcd,0x36,0x57,0x5d, /* ..&..........6W] */ \
	0x74,0xdd,0x59,0x2c,0xf1,0xc3,0x65,0x4b,0x6f,0x9e,0x60,0xd7,0x44,0x2b,0x32,0x26, /* t.Y,..eKo.`.D+2& */ \
	0xf0,0x5d,0x52,0x9c,0x9d,0x7e,0x1c,0xc5,0xb3,0x6c,0xae,0xde,0x8a,0xe6,0x6b,0xb5, /* .]R..~...l....k. */ \
	0xc2,0xb4,0x66,0x78,0x97,0x9b,0x6a,0x8e,0x1b,0x31,0xfc,0x19,0x97,0x68,0x81,0x39, /* ..fx..j..1...h.9 */ \
	0x0b,0x17,0x77,0x5b,0x2b,0x54,0x49,0xde,0xfc,0x69,0x1c,0x46,0x77,0xcd,0xf5,0x15, /* ..w[+TI..i.Fw... */ \
	0x35,0xb3,0x79,0x57,0xdb,0x40,0x72,0xed,0xf5,0x59,0x6a,0xb3,0x7a,0x21,0x37,0x69, /* 5.yW.@r..Yj.z!7i */ \
	0x7b,0x70,0x46,0xfa,0x95,0x09,0xe9,0x31,0x30,0xd5,0xae,0x57,0x7a,0x99,0x7c,0xa7, /* {pF....10..Wz.|. */ \
	0xf7,0x7f,0x00,0x6f,0xfc,0xb4,0x65,0xd1,0x50,0x00,0x00,0x7e,0x69,0x6e,0x63,0x3a, /* ...o..e.P..~inc: */ \
	0x68,0x65,0x61,0x64,0x65,0x72,0x2e,0x69,0x6e,0x63,0x7e,0x0d,0x0a,0x3c,0x64,0x69, /* header.inc~..<di */ \
	0x76,0x20,0x69,0x64,0x3d,0x22,0x63,0x6f,0x6e,0x74,0x65,0x6e,0x74,0x22,0x3e,0x0d, /* v id="content">. */ \
	0x0a,0x0d,0x0a,0x3c,0x68,0x32,0x3e,0x52,0x65,0x63,0x6f,0x6e,0x6e,0x65,0x63,0x74, /* ...<h2>Reconnect */ \
	0x69,0x6f,0x6e,0x20,0x69,0x6e,0x20,0x50,0x72,0x6f,0x67,0x72,0x65,0x73,0x73,0x3c, /* ion in Progress< */ \
	0x2f,0x68,0x32,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70,0x3e,0x41,0x20,0x63,0x6f,0x6e, /* /h2>....<p>A con */ \
	0x6e,0x65,0x63,0x74,0x69,0x6f,0x6e,0x20,0x74,0x6f,0x20,0x61,0x6e,0x6f,0x74,0x68, /* nection to anoth */ \
	0x65,0x72,0x20,0x6e,0x65,0x74,0x77,0x6f,0x72,0x6b,0x20,0x69,0x73,0x20,0x6e,0x6f, /* er network is no */ \
	0x77,0x20,0x75,0x6e,0x64,0x65,0x72,0x77,0x61,0x79,0x21,0x20,0x20,0x59,0x6f,0x75, /* w underway!  You */ \
	0x20,0x77,0x69,0x6c,0x6c,0x20,0x6e,0x65,0x65,0x64,0x20,0x74,0x6f,0x20,0x63,0x6f, /*  will need to co */ \
	0x6e,0x6e,0x65,0x63,0x74,0x20,0x74,0x68,0x69,0x73,0x0d,0x0a,0x6c,0x61,0x70,0x74, /* nnect this..lapt */ \
	0x6f,0x70,0x2f,0x50,0x43,0x2f,0x70,0x6f,0x72,0x74,0x61,0x62,0x6c,0x65,0x20,0x64, /* op/PC/portable d */ \
	0x65,0x76,0x69,0x63,0x65,0x20,0x74,0x6f,0x20,0x74,0x68,0x65,0x20,0x6e,0x65,0x77, /* evice to the new */ \
	0x20,0x6e,0x65,0x74,0x77,0x6f,0x72,0x6b,0x20,0x28,0x22,0x7e,0x6e,0x65,0x78,0x74, /*  network ("~next */ \
	0x53,0x53,0x49,0x44,0x7e,0x22,0x29,0x20,0x74,0x6f,0x20,0x72,0x65,0x67,0x61,0x69, /* SSID~") to regai */ \
	0x6e,0x20,0x61,0x63,0x63,0x65,0x73,0x73,0x20,0x74,0x6f,0x20,0x74,0x68,0x69,0x73, /* n access to this */ \
	0x20,0x64,0x65,0x6d,0x6f,0x2e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70, /*  demo.</p>....<p */ \
	0x3e,0x41,0x73,0x20,0x61,0x20,0x72,0x65,0x6d,0x69,0x6e,0x64,0x65,0x72,0x2c,0x20, /* >As a reminder,  */ \
	0x74,0x68,0x69,0x73,0x20,0x69,0x73,0x20,0x74,0x68,0x65,0x20,0x6e,0x65,0x74,0x77, /* this is the netw */ \
	0x6f,0x72,0x6b,0x20,0x79,0x6f,0x75,0x20,0x77,0x65,0x72,0x65,0x20,0x6f,0x6e,0x3a, /* ork you were on: */ \
	0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x3c,0x75,0x6c,0x3e,0x0d,0x0a,0x09,0x3c,0x6c,0x69, /* </p>..<ul>...<li */ \
	0x3e,0x3c,0x62,0x3e,0x53,0x53,0x49,0x44,0x3a,0x3c,0x2f,0x62,0x3e,0x20,0x22,0x7e, /* ><b>SSID:</b> "~ */ \
	0x70,0x72,0x65,0x76,0x53,0x53,0x49,0x44,0x7e,0x22,0x3c,0x2f,0x6c,0x69,0x3e,0x0d, /* prevSSID~"</li>. */ \
	0x0a,0x09,0x3c,0x6c,0x69,0x3e,0x3c,0x62,0x3e,0x57,0x4c,0x41,0x4e,0x20,0x54,0x79, /* ..<li><b>WLAN Ty */ \
	0x70,0x65,0x3a,0x3c,0x2f,0x62,0x3e,0x20,0x7e,0x70,0x72,0x65,0x76,0x57,0x4c,0x41, /* pe:</b> ~prevWLA */ \
	0x4e,0x7e,0x3c,0x2f,0x6c,0x69,0x3e,0x0d,0x0a,0x3c,0x2f,0x75,0x6c,0x3e,0x0d,0x0a, /* N~</li>..</ul>.. */ \
	0x0d,0x0a,0x3c,0x70,0x3e,0x54,0x68,0x69,0x73,0x20,0x69,0x73,0x20,0x74,0x68,0x65, /* ..<p>This is the */ \
	0x20,0x6e,0x65,0x74,0x77,0x6f,0x72,0x6b,0x20,0x74,0x68,0x61,0x74,0x20,0x79,0x6f, /*  network that yo */ \
	0x75,0x20,0x77,0x69,0x6c,0x6c,0x20,0x62,0x65,0x20,0x67,0x6f,0x69,0x6e,0x67,0x20, /* u will be going  */ \
	0x74,0x6f,0x3a,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x3c,0x75,0x6c,0x3e,0x0d,0x0a,0x09, /* to:</p>..<ul>... */ \
	0x3c,0x6c,0x69,0x3e,0x3c,0x62,0x3e,0x53,0x53,0x49,0x44,0x3a,0x3c,0x2f,0x62,0x3e, /* <li><b>SSID:</b> */ \
	0x20,0x22,0x7e,0x6e,0x65,0x78,0x74,0x53,0x53,0x49,0x44,0x7e,0x22,0x3c,0x2f,0x6c, /*  "~nextSSID~"</l */ \
	0x69,0x3e,0x0d,0x0a,0x09,0x3c,0x6c,0x69,0x3e,0x3c,0x62,0x3e,0x57,0x4c,0x41,0x4e, /* i>...<li><b>WLAN */ \
	0x20,0x54,0x79,0x70,0x65,0x3a,0x3c,0x2f,0x62,0x3e,0x20,0x7e,0x6e,0x65,0x78,0x74, /*  Type:</b> ~next */ \
	0x57,0x4c,0x41,0x4e,0x7e,0x3c,0x2f,0x6c,0x69,0x3e,0x0d,0x0a,0x3c,0x2f,0x75,0x6c, /* WLAN~</li>..</ul */ \
	0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x7e,0x69,0x6e, /* >....</div>..~in */ \
	0x63,0x3a,0x66,0x6f,0x6f,0x74,0x65,0x72,0x2e,0x69,0x6e,0x63,0x7e,0x0d,0x0a,0x53, /* c:footer.inc~..S */ \
	0x75,0x63,0x63,0x65,0x73,0x73,0x21,0x20,0x7e,0x73,0x63,0x61,0x6e,0x7e,0x3c,0x3f, /* uccess! ~scan~<? */ \
	0x78,0x6d,0x6c,0x20,0x76,0x65,0x72,0x73,0x69,0x6f,0x6e,0x3d,0x22,0x31,0x2e,0x30, /* xml version="1.0 */ \
	0x22,0x20,0x65,0x6e,0x63,0x6f,0x64,0x69,0x6e,0x67,0x3d,0x22,0x75,0x74,0x66,0x2d, /* " encoding="utf- */ \
	0x38,0x22,0x3f,0x3e,0x0a,0x20,0x0a,0x20,0x3c,0x72,0x65,0x73,0x70,0x6f,0x6e,0x73, /* 8"?>. . <respons */ \
	0x65,0x3e,0x0a,0x20,0x09,0x3c,0x73,0x63,0x61,0x6e,0x3e,0x7e,0x73,0x63,0x61,0x6e, /* e>. .<scan>~scan */ \
	0x7e,0x3c,0x2f,0x73,0x63,0x61,0x6e,0x3e,0x0a,0x09,0x3c,0x76,0x65,0x72,0x3e,0x7e, /* ~</scan>..<ver>~ */ \
	0x66,0x77,0x76,0x65,0x72,0x7e,0x3c,0x2f,0x76,0x65,0x72,0x3e,0x0a,0x09,0x3c,0x63, /* fwver~</ver>..<c */ \
	0x6f,0x75,0x6e,0x74,0x3e,0x7e,0x62,0x73,0x73,0x43,0x6f,0x75,0x6e,0x74,0x7e,0x3c, /* ount>~bssCount~< */ \
	0x2f,0x63,0x6f,0x75,0x6e,0x74,0x3e,0x0a,0x09,0x3c,0x73,0x73,0x69,0x64,0x3e,0x7e, /* /count>..<ssid>~ */ \
	0x73,0x73,0x69,0x64,0x7e,0x3c,0x2f,0x73,0x73,0x69,0x64,0x3e,0x0a,0x09,0x0a,0x09, /* ssid~</ssid>.... */ \
	0x3c,0x62,0x73,0x73,0x3e,0x0a,0x09,0x09,0x3c,0x76,0x61,0x6c,0x69,0x64,0x3e,0x7e, /* <bss>...<valid>~ */ \
	0x76,0x61,0x6c,0x69,0x64,0x7e,0x3c,0x2f,0x76,0x61,0x6c,0x69,0x64,0x3e,0x0a,0x09, /* valid~</valid>.. */ \
	0x09,0x3c,0x6e,0x61,0x6d,0x65,0x3e,0x7e,0x6e,0x61,0x6d,0x65,0x7e,0x3c,0x2f,0x6e, /* .<name>~name~</n */ \
	0x61,0x6d,0x65,0x3e,0x0a,0x09,0x09,0x3c,0x70,0x72,0x69,0x76,0x61,0x63,0x79,0x3e, /* ame>...<privacy> */ \
	0x7e,0x70,0x72,0x69,0x76,0x61,0x63,0x79,0x7e,0x3c,0x2f,0x70,0x72,0x69,0x76,0x61, /* ~privacy~</priva */ \
	0x63,0x79,0x3e,0x0a,0x09,0x09,0x3c,0x77,0x6c,0x61,0x6e,0x3e,0x7e,0x77,0x6c,0x61, /* cy>...<wlan>~wla */ \
	0x6e,0x7e,0x3c,0x2f,0x77,0x6c,0x61,0x6e,0x3e,0x0a,0x09,0x09,0x3c,0x73,0x74,0x72, /* n~</wlan>...<str */ \
	0x65,0x6e,0x67,0x74,0x68,0x3e,0x7e,0x73,0x74,0x72,0x65,0x6e,0x67,0x74,0x68,0x7e, /* ength>~strength~ */ \
	0x3c,0x2f,0x73,0x74,0x72,0x65,0x6e,0x67,0x74,0x68,0x3e,0x0a,0x09,0x3c,0x2f,0x62, /* </strength>..</b */ \
	0x73,0x73,0x3e,0x0a,0x09,0x0a,0x09,0x3c,0x6c,0x65,0x64,0x30,0x3e,0x7e,0x6c,0x65, /* ss>....<led0>~le */ \
	0x64,0x28,0x30,0x29,0x7e,0x3c,0x2f,0x6c,0x65,0x64,0x30,0x3e,0x0a,0x09,0x3c,0x6c, /* d(0)~</led0>..<l */ \
	0x65,0x64,0x31,0x3e,0x7e,0x6c,0x65,0x64,0x28,0x31,0x29,0x7e,0x3c,0x2f,0x6c,0x65, /* ed1>~led(1)~</le */ \
	0x64,0x31,0x3e,0x0a,0x09,0x3c,0x6c,0x65,0x64,0x32,0x3e,0x7e,0x6c,0x65,0x64,0x28, /* d1>..<led2>~led( */ \
	0x32,0x29,0x7e,0x3c,0x2f,0x6c,0x65,0x64,0x32,0x3e,0x0a,0x09,0x3c,0x62,0x74,0x6e, /* 2)~</led2>..<btn */ \
	0x30,0x3e,0x7e,0x62,0x74,0x6e,0x28,0x30,0x29,0x7e,0x3c,0x2f,0x62,0x74,0x6e,0x30, /* 0>~btn(0)~</btn0 */ \
	0x3e,0x0a,0x09,0x3c,0x62,0x74,0x6e,0x31,0x3e,0x7e,0x62,0x74,0x6e,0x28,0x31,0x29, /* >..<btn1>~btn(1) */ \
	0x7e,0x3c,0x2f,0x62,0x74,0x6e,0x31,0x3e,0x0a,0x09,0x3c,0x62,0x74,0x6e,0x32,0x3e, /* ~</btn1>..<btn2> */ \
	0x7e,0x62,0x74,0x6e,0x28,0x32,0x29,0x7e,0x3c,0x2f,0x62,0x74,0x6e,0x32,0x3e,0x0a, /* ~btn(2)~</btn2>. */ \
	0x09,0x3c,0x70,0x6f,0x74,0x30,0x3e,0x7e,0x70,0x6f,0x74,0x7e,0x3c,0x2f,0x70,0x6f, /* .<pot0>~pot~</po */ \
	0x74,0x30,0x3e,0x0a,0x20,0x3c,0x2f,0x72,0x65,0x73,0x70,0x6f,0x6e,0x73,0x65,0x3e, /* t0>. </response> */ \
	0x0a,0x89,0x50,0x4e,0x47,0x0d,0x0a,0x1a,0x0a,0x00,0x00,0x00,0x0d,0x49,0x48,0x44, /* ..PNG........IHD */ \
	0x52,0x00,0x00,0x00,0x13,0x00,0x00,0x00,0x0f,0x08,0x03,0x00,0x00,0x00,0x31,0x9a, /* R.............1. */ \
	0x04,0x1e,0x00,0x00,0x00,0x19,0x74,0x45,0x58,0x74,0x53,0x6f,0x66,0x74,0x77,0x61, /* ......tEXtSoftwa */ \
	0x72,0x65,0x00,0x41,0x64,0x6f,0x62,0x65,0x20,0x49,0x6d,0x61,0x67,0x65,0x52,0x65, /* re.Adobe ImageRe */ \
	0x61,0x64,0x79,0x71,0xc9,0x65,0x3c,0x00,0x00,0x00,0x90,0x50,0x4c,0x54,0x45,0xef, /* adyq.e<....PLTE. */ \
	0xef,0xef,0xd0,0xd0,0xd0,0xd1,0xd1,0xd1,0xc9,0xc9,0xc9,0xe9,0xe9,0xe9,0xf9,0xf9, /* ................ */ \
	0xf9,0xbc,0xbc,0xbc,0xdc,0xdc,0xdc,0xf6,0xf6,0xf6,0xfb,0xfb,0xfb,0xfa,0xfa,0xfa, /* ................ */ \
	0xf4,0xf4,0xf4,0xcb,0xcb,0xcb,0xc8,0xc8,0xc8,0xdf,0xdf,0xdf,0xc5,0xc5,0xc5,0xd5, /* ................ */ \
	0xd5,0xd5,0xc2,0xc2,0xc2,0xcc,0xcc,0xcc,0xbf,0xbf,0xbf,0xf5,0xf5,0xf5,0xe0,0xe0, /* ................ */ \
	0xe0,0xd6,0xd6,0xd6,0xf8,0xf8,0xf8,0xca,0xca,0xca,0xea,0xea,0xea,0xe8,0xe8,0xe8, /* ................ */ \
	0xde,0xde,0xde,0xaf,0xaf,0xaf,0xe7,0xe7,0xe7,0xe5,0xe5,0xe5,0xc6,0xc6,0xc6,0xe4, /* ................ */ \
	0xe4,0xe4,0xe3,0xe3,0xe3,0xdd,0xdd,0xdd,0xf2,0xf2,0xf2,0xcd,0xcd,0xcd,0x60,0x60, /* ..............`` */ \
	0x60,0xee,0xee,0xee,0xdb,0xdb,0xdb,0xc3,0xc3,0xc3,0xd3,0xd3,0xd3,0xd4,0xd4,0xd4, /* `............... */ \
	0xbd,0xbd,0xbd,0xbe,0xbe,0xbe,0xfd,0xfd,0xfd,0xfe,0xfe,0xfe,0xff,0xff,0xff,0x44, /* ...............D */ \
	0x39,0x7d,0x47,0x00,0x00,0x00,0xa4,0x49,0x44,0x41,0x54,0x78,0xda,0x64,0x90,0x57, /* 9}G....IDATx.d.W */ \
	0x0e,0x03,0x21,0x0c,0x05,0xe9,0xdb,0x7b,0x4b,0xef,0x1d,0x1b,0xee,0x7f,0xbb,0x20, /* ..!....{K......  */ \
	0x94,0x64,0xb3,0xda,0xf7,0x61,0x89,0x91,0x6c,0x8f,0x21,0xd6,0xc5,0xa0,0x8b,0x71, /* .d...a..l.!....q */ \
	0xb1,0xfe,0x45,0x7c,0x3d,0xe7,0xcf,0x74,0x51,0xbf,0xba,0xe4,0xc7,0x48,0xad,0x95, /* ..E|=..tQ....H.. */ \
	0xaa,0xf6,0x95,0x06,0xb8,0x10,0xcf,0xcc,0x1d,0x34,0x5d,0x0d,0xae,0x57,0x0a,0x06, /* .........4]..W.. */ \
	0x10,0x18,0xc7,0x7a,0xe0,0x37,0x44,0xd9,0x26,0x61,0x6c,0x2c,0xe1,0xd0,0x3b,0x46, /* ...z.7D.&al,..;F */ \
	0xca,0xc8,0x6c,0x33,0xa5,0x5d,0xb8,0xb0,0x51,0x49,0xfc,0x3c,0xa4,0x5a,0xd3,0x7c, /* ..l3.]..QI.<.Z.| */ \
	0xd7,0xb1,0x06,0x18,0x7e,0x76,0x84,0x40,0x13,0xef,0xd2,0xb2,0x26,0xfc,0xba,0x0c, /* ....~v.@....&... */ \
	0x18,0x1f,0x69,0xca,0x0e,0x91,0x95,0xa3,0x1f,0x66,0x0a,0x0a,0xd0,0xfc,0xdf,0x19, /* ..i......f...... */ \
	0x45,0x20,0x4d,0x7c,0x5a,0x4e,0x18,0x62,0xb0,0x59,0x4f,0x6f,0x73,0xec,0x71,0x2d, /* E M|ZN.b.YOos.q- */ \
	0x66,0x0c,0x85,0x99,0xb3,0xf1,0x5f,0xde,0x02,0x0c,0x00,0x5e,0x6c,0x28,0x41,0x61, /* f....._....^l(Aa */ \
	0xb4,0x15,0x36,0x00,0x00,0x00,0x00,0x49,0x45,0x4e,0x44,0xae,0x42,0x60,0x82,0x89, /* ..6....IEND.B`.. */ \
	0x50,0x4e,0x47,0x0d,0x0a,0x1a,0x0a,0x00,0x00,0x00,0x0d,0x49,0x48,0x44,0x52,0x00, /* PNG........IHDR. */ \
	0x00,0x00,0x13,0x00,0x00,0x00,0x0f,0x08,0x03,0x00,0x00,0x00,0x31,0x9a,0x04,0x1e, /* ............1... */ \
	0x00,0x00,0x00,0x19,0x74,0x45,0x58,0x74,0x53,0x6f,0x66,0x74,0x77,0x61,0x72,0x65, /* ....tEXtSoftware */ \
	0x00,0x41,0x64,0x6f,0x62,0x65,0x20,0x49,0x6d,0x61,0x67,0x65,0x52,0x65,0x61,0x64, /* .Adobe ImageRead */ \
	0x79,0x71,0xc9,0x65,0x3c,0x00,0x00,0x00,0xc6,0x50,0x4c,0x54,0x45,0xbe,0xbe,0xbe, /* yq.e<....PLTE... */ \
	0xf9,0xf9,0xf9,0xd1,0xd1,0xd1,0xf3,0xf3,0xf3,0xbc,0xbc,0xbc,0xf6,0xf6,0xf6,0xd4, /* ................ */ \
	0xd4,0xd4,0xe0,0xe0,0xe0,0xbb,0xbb,0xbb,0x60,0x60,0x60,0xf5,0xf5,0xf5,0xf7,0xf7, /* ........```..... */ \
	0xf7,0xf8,0xf8,0xf8,0xc2,0xc2,0xc2,0xc6,0xc6,0xc6,0xe8,0xe8,0xe8,0xdc,0xdc,0xdc, /* ................ */ \
	0xc9,0xc9,0xc9,0xc7,0xc7,0xc7,0xcf,0xcf,0xcf,0xcc,0xcc,0xcc,0xec,0xec,0xec,0xcd, /* ................ */ \
	0xcd,0xcd,0xef,0xef,0xef,0xb5,0xb5,0xb5,0xdb,0xdb,0xdb,0xdf,0xdf,0xdf,0x82,0x82, /* ................ */ \
	0x82,0xd8,0xd8,0xd8,0xcb,0xcb,0xcb,0x71,0x71,0x71,0xae,0xae,0xae,0xed,0xed,0xed, /* .......qqq...... */ \
	0xc4,0xc4,0xc4,0x7a,0x7a,0x7a,0xba,0xba,0xba,0xce,0xce,0xce,0xf4,0xf4,0xf4,0x7c, /* ...zzz.........| */ \
	0x7c,0x7c,0xf2,0xf2,0xf2,0xeb,0xeb,0xeb,0xa4,0xa4,0xa4,0xb4,0xb4,0xb4,0xe7,0xe7, /* ||.............. */ \
	0xe7,0xe4,0xe4,0xe4,0x5e,0x5e,0x5e,0x5d,0x5d,0x5d,0xc5,0xc5,0xc5,0xe9,0xe9,0xe9, /* ....^^^]]]...... */ \
	0xe6,0xe6,0xe6,0xf1,0xf1,0xf1,0xd2,0xd2,0xd2,0xd6,0xd6,0xd6,0x80,0x80,0x80,0xca, /* ................ */ \
	0xca,0xca,0xbf,0xbf,0xbf,0x6e,0x6e,0x6e,0xa3,0xa3,0xa3,0xd3,0xd3,0xd3,0xbd,0xbd, /* .....nnn........ */ \
	0xbd,0xfa,0xfa,0xfa,0xfc,0xfc,0xfc,0xfe,0xfe,0xfe,0xfd,0xfd,0xfd,0xfb,0xfb,0xfb, /* ................ */ \
	0xff,0xff,0xff,0x49,0x41,0x85,0x40,0x00,0x00,0x00,0xcf,0x49,0x44,0x41,0x54,0x78, /* ...IA.@....IDATx */ \
	0xda,0x3c,0xd0,0xd7,0x52,0x03,0x31,0x0c,0x05,0x50,0x6f,0xef,0xe9,0x8d,0x54,0x20, /* .<..R.1..Po...T  */ \
	0x85,0x92,0x0a,0x01,0x12,0x58,0xab,0xec,0xff,0xff,0x14,0xb2,0x77,0x12,0x3d,0xe8, /* .....X......w.=. */ \
	0xe1,0xcc,0xd5,0xc8,0xb2,0x02,0x02,0x32,0x85,0x88,0xd2,0x2a,0x53,0x8a,0x8c,0xbd, /* .......2....S... */ \
	0x44,0x61,0xef,0xa7,0x17,0x46,0x1e,0x59,0x03,0xa0,0xfe,0xac,0x2c,0xcb,0xa2,0x51, /* Da...F.Y....,..Q */ \
	0x48,0x1f,0x0c,0xad,0xf1,0x34,0xf6,0xbb,0xcd,0x9c,0x90,0x9c,0x93,0xab,0x54,0x0b, /* H....4........T. */ \
	0x2b,0xc5,0x7f,0xcb,0x46,0x1f,0xc0,0x49,0xbd,0x40,0x13,0x3e,0xb6,0xd5,0x97,0xd8, /* +...F..I.@.>.... */ \
	0xeb,0x39,0xe3,0x8f,0x8e,0xef,0xcb,0x64,0x7b,0x8b,0x1c,0x0e,0x2b,0xa5,0x99,0xf3, /* .9.....d{...+... */ \
	0x55,0x1c,0x77,0xc7,0xbb,0x48,0x26,0x5d,0xb3,0x44,0x31,0xeb,0x4f,0x7f,0xe0,0xb1, /* U.w..H&].D1.O... */ \
	0x6c,0xc7,0xd4,0xbd,0x04,0xc6,0x24,0xc7,0x29,0x07,0xef,0xdf,0xf3,0xc9,0x28,0xc3, /* l.....$.).....(. */ \
	0xdc,0xbe,0xc5,0x61,0xd1,0xec,0xf9,0x90,0x5c,0x93,0xfd,0x86,0xb1,0x36,0x6d,0xf0, /* ...a....\....6m. */ \
	0xf8,0xeb,0xc1,0xfa,0xad,0x83,0x77,0x93,0x02,0x7e,0x58,0xb4,0xe4,0xbe,0xfa,0x0e, /* ......w..~X..... */ \
	0x6d,0x72,0x9a,0xa1,0x48,0x9e,0x6e,0x07,0xdb,0x1d,0x92,0x03,0x68,0x82,0xf9,0x87, /* mr..H.n.....h... */ \
	0x9b,0x69,0x6b,0x12,0xa2,0xda,0xfe,0x05,0x18,0x00,0xfe,0xce,0x34,0xaf,0x11,0x44, /* .ik.........4..D */ \
	0xc9,0xf9,0x00,0x00,0x00,0x00,0x49,0x45,0x4e,0x44,0xae,0x42,0x60,0x82,0x89,0x50, /* ......IEND.B`..P */ \
	0x4e,0x47,0x0d,0x0a,0x1a,0x0a,0x00,0x00,0x00,0x0d,0x49,0x48,0x44,0x52,0x00,0x00, /* NG........IHDR.. */ \
	0x00,0x13,0x00,0x00,0x00,0x0f,0x08,0x03,0x00,0x00,0x00,0x31,0x9a,0x04,0x1e,0x00, /* ...........1.... */ \
	0x00,0x00,0x19,0x74,0x45,0x58,0x74,0x53,0x6f,0x66,0x74,0x77,0x61,0x72,0x65,0x00, /* ...tEXtSoftware. */ \
	0x41,0x64,0x6f,0x62,0x65,0x20,0x49,0x6d,0x61,0x67,0x65,0x52,0x65,0x61,0x64,0x79, /* Adobe ImageReady */ \
	0x71,0xc9,0x65,0x3c,0x00,0x00,0x00,0xcf,0x50,0x4c,0x54,0x45,0x61,0x61,0x61,0xfb, /* q.e<....PLTEaaa. */ \
	0xfb,0xfb,0x62,0x62,0x62,0xc7,0xc7,0xc7,0xc2,0xc2,0xc2,0xe9,0xe9,0xe9,0xf5,0xf5, /* ..bbb........... */ \
	0xf5,0xed,0xed,0xed,0xd6,0xd6,0xd6,0x7c,0x7c,0x7c,0xce,0xce,0xce,0x8c,0x8c,0x8c, /* .......|||...... */ \
	0xbe,0xbe,0xbe,0xbc,0xbc,0xbc,0xd4,0xd4,0xd4,0xf8,0xf8,0xf8,0xc8,0xc8,0xc8,0xe8, /* ................ */ \
	0xe8,0xe8,0xef,0xef,0xef,0xcc,0xcc,0xcc,0xf9,0xf9,0xf9,0xc9,0xc9,0xc9,0x8d,0x8d, /* ................ */ \
	0x8d,0xe0,0xe0,0xe0,0x7b,0x7b,0x7b,0xea,0xea,0xea,0xdf,0xdf,0xdf,0xf6,0xf6,0xf6, /* ....{{{......... */ \
	0xaf,0xaf,0xaf,0x72,0x72,0x72,0xd1,0xd1,0xd1,0x82,0x82,0x82,0xc0,0xc0,0xc0,0xdd, /* ...rrr.......... */ \
	0xdd,0xdd,0xd3,0xd3,0xd3,0xb4,0xb4,0xb4,0xdc,0xdc,0xdc,0xc6,0xc6,0xc6,0xd9,0xd9, /* ................ */ \
	0xd9,0x5d,0x5d,0x5d,0x83,0x83,0x83,0x8f,0x8f,0x8f,0xa4,0xa4,0xa4,0x8e,0x8e,0x8e, /* .]]]............ */ \
	0xcb,0xcb,0xcb,0xcf,0xcf,0xcf,0xcd,0xcd,0xcd,0xc5,0xc5,0xc5,0x70,0x70,0x70,0xfa, /* ............ppp. */ \
	0xfa,0xfa,0xf1,0xf1,0xf1,0xee,0xee,0xee,0xde,0xde,0xde,0xa5,0xa5,0xa5,0xd5,0xd5, /* ................ */ \
	0xd5,0xb3,0xb3,0xb3,0xb5,0xb5,0xb5,0xf7,0xf7,0xf7,0xd2,0xd2,0xd2,0xe1,0xe1,0xe1, /* ................ */ \
	0xb6,0xb6,0xb6,0xf3,0xf3,0xf3,0xc3,0xc3,0xc3,0x5e,0x5e,0x5e,0xbd,0xbd,0xbd,0xfc, /* .........^^^.... */ \
	0xfc,0xfc,0xfe,0xfe,0xfe,0xfd,0xfd,0xfd,0xff,0xff,0xff,0x8c,0xa6,0x02,0x56,0x00, /* ..............V. */ \
	0x00,0x00,0xc5,0x49,0x44,0x41,0x54,0x78,0xda,0x4c,0xcf,0xd5,0x0e,0xc3,0x30,0x0c, /* ...IDATx.L....0. */ \
	0x05,0xd0,0x94,0xdb,0x51,0x07,0x5d,0x61,0xcc,0xcc,0xcc,0x4d,0xec,0xfd,0xff,0x37, /* ....Q.]a...M...7 */ \
	0xcd,0xe9,0x56,0x69,0xf7,0x25,0xd1,0x51,0x6c,0xc7,0x4c,0x50,0x50,0x08,0x00,0x04, /* ..Vi.%.Ql.LPP... */ \
	0x99,0x37,0x85,0xa1,0x94,0x5d,0x50,0xa8,0x54,0x2b,0xbd,0xe0,0xf9,0x35,0x22,0x6b, /* .7...]P.T+...5"k */ \
	0xc1,0x79,0x5e,0x1f,0xea,0x9c,0xe7,0x56,0xe5,0xe4,0x9d,0x32,0xe2,0x7c,0x59,0xf2, /* .y^....V...2.|Y. */ \
	0xa8,0xce,0x2b,0xb5,0x38,0x1f,0x20,0x59,0x21,0xaf,0xed,0x01,0x8c,0x8c,0x9e,0x31, /* ..+.8. Y!......1 */ \
	0x10,0xac,0x62,0xce,0x26,0xb3,0x6e,0x2e,0x16,0xc3,0x58,0xc6,0xa9,0x82,0x72,0x2a, /* ..b.&.n...X...r. */ \
	0xcb,0x19,0xc2,0xcc,0x8e,0xd5,0xf9,0xb9,0xd3,0x9f,0xaa,0xb1,0x5f,0x4f,0xfa,0x21, /* ............_O.! */ \
	0xda,0x2c,0x1b,0x01,0x9d,0x10,0xf9,0xaa,0xfd,0x33,0xac,0x29,0xee,0xa3,0xdd,0x9c, /* .,.......3.).... */ \
	0x5c,0xae,0xe2,0x9e,0xfe,0x0f,0x41,0x09,0x63,0xb6,0x61,0xb1,0xb3,0xc5,0xdf,0xff, /* \.....A.c.a..... */ \
	0xc8,0x50,0x9b,0x99,0x68,0x1e,0xb5,0x74,0x0f,0x1a,0x42,0x08,0xdd,0xc6,0x41,0xee, /* .P..h..t..B...A. */ \
	0xf7,0x4e,0xfb,0xd1,0x4b,0x78,0xb1,0x35,0xa6,0x96,0xd4,0xca,0x18,0x20,0x2f,0x7f, /* .N..Kx.5..... /. */ \
	0xf6,0x65,0x52,0x69,0x1f,0x01,0x06,0x00,0x81,0xbe,0x39,0x19,0xd0,0x7a,0x8f,0x4b, /* .eRi......9..z.K */ \
	0x00,0x00,0x00,0x00,0x49,0x45,0x4e,0x44,0xae,0x42,0x60,0x82,0x89,0x50,0x4e,0x47, /* ....IEND.B`..PNG */ \
	0x0d,0x0a,0x1a,0x0a,0x00,0x00,0x00,0x0d,0x49,0x48,0x44,0x52,0x00,0x00,0x00,0x13, /* ........IHDR.... */ \
	0x00,0x00,0x00,0x0f,0x08,0x03,0x00,0x00,0x00,0x31,0x9a,0x04,0x1e,0x00,0x00,0x00, /* .........1...... */ \
	0x19,0x74,0x45,0x58,0x74,0x53,0x6f,0x66,0x74,0x77,0x61,0x72,0x65,0x00,0x41,0x64, /* .tEXtSoftware.Ad */ \
	0x6f,0x62,0x65,0x20,0x49,0x6d,0x61,0x67,0x65,0x52,0x65,0x61,0x64,0x79,0x71,0xc9, /* obe ImageReadyq. */ \
	0x65,0x3c,0x00,0x00,0x00,0xf0,0x50,0x4c,0x54,0x45,0x5d,0x5d,0x5d,0xf7,0xf7,0xf7, /* e<....PLTE]]]... */ \
	0x79,0x79,0x79,0x60,0x60,0x60,0xdc,0xdc,0xdc,0x8a,0x8a,0x8a,0xf3,0xf3,0xf3,0x62, /* yyy```.........b */ \
	0x62,0x62,0x7b,0x7b,0x7b,0xf1,0xf1,0xf1,0xf2,0xf2,0xf2,0xc7,0xc7,0xc7,0xd2,0xd2, /* bb{{{........... */ \
	0xd2,0xe6,0xe6,0xe6,0xac,0xac,0xac,0x8c,0x8c,0x8c,0xd7,0xd7,0xd7,0xa4,0xa4,0xa4, /* ................ */ \
	0x8d,0x8d,0x8d,0x73,0x73,0x73,0xc9,0xc9,0xc9,0xb5,0xb5,0xb5,0x76,0x76,0x76,0xd8, /* ...sss......vvv. */ \
	0xd8,0xd8,0xa2,0xa2,0xa2,0xc4,0xc4,0xc4,0xfa,0xfa,0xfb,0x7f,0x7f,0x7f,0xca,0xca, /* ................ */ \
	0xca,0x6d,0x6d,0x6d,0xef,0xef,0xef,0xe7,0xe7,0xe7,0x83,0x83,0x83,0x74,0x74,0x74, /* .mmm.........ttt */ \
	0x80,0x80,0x80,0xc5,0xc5,0xc5,0x6a,0x6a,0x6a,0x69,0x69,0x69,0x70,0x70,0x70,0xbf, /* ......jjjiiippp. */ \
	0xbf,0xbf,0xd3,0xd3,0xd3,0xda,0xda,0xda,0x71,0x71,0x71,0x8b,0x8b,0x8b,0xe1,0xe1, /* ........qqq..... */ \
	0xe1,0xcc,0xcc,0xcc,0x8e,0x8e,0x8e,0x89,0x89,0x89,0xb1,0xb1,0xb1,0xc1,0xc1,0xc1, /* ................ */ \
	0x93,0x93,0x93,0xcd,0xcd,0xcd,0xbe,0xbe,0xbe,0xa8,0xa8,0xa8,0xd4,0xd4,0xd4,0xae, /* ................ */ \
	0xae,0xae,0x90,0x90,0x90,0xe5,0xe5,0xe5,0xe0,0xe0,0xe0,0xea,0xea,0xea,0x94,0x94, /* ................ */ \
	0x94,0xd9,0xd9,0xd9,0xf6,0xf6,0xf6,0x6e,0x6e,0x6e,0xc3,0xc3,0xc3,0xb2,0xb2,0xb2, /* .......nnn...... */ \
	0xb3,0xb3,0xb3,0x98,0x98,0x98,0x5f,0x5f,0x5f,0x81,0x81,0x81,0x5e,0x5e,0x5e,0xfd, /* ......___...^^^. */ \
	0xfd,0xfd,0xfe,0xfe,0xfe,0xf8,0xf8,0xf8,0x5c,0x5c,0x5c,0xfc,0xfc,0xfc,0xfb,0xfb, /* ........\\\..... */ \
	0xfb,0xf9,0xf9,0xf9,0xfa,0xfa,0xfa,0xff,0xff,0xff,0xc2,0x2f,0xbf,0xb7,0x00,0x00, /* .........../.... */ \
	0x00,0xdb,0x49,0x44,0x41,0x54,0x78,0xda,0x4c,0x90,0xe7,0x52,0x42,0x41,0x0c,0x85, /* ..IDATx.L..RBA.. */ \
	0xf7,0x36,0x7a,0x57,0xb0,0x17,0xc0,0x86,0x54,0x05,0x7b,0x03,0x95,0xbd,0x77,0x37, /* .6zW....T.{...w7 */ \
	0x85,0xf7,0x7f,0x1b,0x73,0x0b,0x33,0x66,0xf2,0xeb,0x9b,0x73,0x92,0x93,0x28,0x00, /* ....s.3f...s..(. */ \
	0x3e,0x64,0x62,0x46,0x06,0x08,0xa3,0x4d,0x5c,0x0a,0x00,0x99,0xfd,0xda,0xb4,0x7b, /* >dbF...M\......{ */ \
	0xb2,0x33,0x7c,0x1a,0xa5,0x8c,0x11,0x1f,0x8f,0xac,0xb5,0x97,0xb7,0x17,0x4a,0xe9, /* .3|...........J. */ \
	0xf3,0x8f,0x98,0xa1,0x69,0x5a,0x1b,0x94,0x4f,0x11,0xb1,0x74,0xdc,0xd2,0xfa,0x01, /* ....iZ..O..t.... */ \
	0x44,0xf7,0x6e,0x3b,0x37,0xc4,0x2f,0xe3,0xeb,0xf9,0x59,0x14,0xed,0xb9,0xfa,0x47, /* D.n;7./...Y....G */ \
	0x58,0xe5,0xb9,0x48,0x7d,0x57,0xdc,0x4a,0x15,0x76,0x37,0x9f,0xf7,0x0d,0x61,0xcc, /* X..H}W.J.v7...a. */ \
	0xa5,0xc0,0x7a,0xf5,0xd9,0x62,0x35,0xc9,0xeb,0x96,0x93,0xec,0x20,0xae,0x78,0x41, /* ..z..b5..... .xA */ \
	0x55,0x56,0x01,0xbc,0xd5,0xf3,0x8d,0x84,0x31,0x93,0xef,0xe4,0xbe,0x7b,0x57,0xeb, /* UV......1....{W. */ \
	0xb6,0xc1,0xd7,0x24,0x0b,0x91,0x21,0x72,0x5c,0xfb,0xfb,0xe5,0xa9,0x02,0xa6,0xf9, /* ...$..!r\....... */ \
	0x8c,0x43,0x52,0x07,0xfb,0x45,0xcc,0x35,0xcb,0x61,0xc6,0x44,0xc6,0xd2,0x83,0x9a, /* .CR..E.5.a.D.... */ \
	0x1f,0x46,0xd9,0x6d,0x82,0x8c,0xcc,0xe4,0x3b,0xbd,0x84,0x7f,0x8c,0x62,0x86,0x55, /* .F.m....;....b.U */ \
	0x79,0x41,0xe6,0x4d,0x55,0x92,0x08,0x61,0xeb,0xfd,0x13,0x60,0x00,0xe0,0x6f,0x42, /* yA.MU..a...`..oB */ \
	0x10,0x81,0x5f,0xe9,0x1b,0x00,0x00,0x00,0x00,0x49,0x45,0x4e,0x44,0xae,0x42,0x60, /* .._......IEND.B` */ \
	0x82,0x89,0x50,0x4e,0x47,0x0d,0x0a,0x1a,0x0a,0x00,0x00,0x00,0x0d,0x49,0x48,0x44, /* ..PNG........IHD */ \
	0x52,0x00,0x00,0x00,0x13,0x00,0x00,0x00,0x0f,0x08,0x03,0x00,0x00,0x00,0x31,0x9a, /* R.............1. */ \
	0x04,0x1e,0x00,0x00,0x00,0x19,0x74,0x45,0x58,0x74,0x53,0x6f,0x66,0x74,0x77,0x61, /* ......tEXtSoftwa */ \
	0x72,0x65,0x00,0x41,0x64,0x6f,0x62,0x65,0x20,0x49,0x6d,0x61,0x67,0x65,0x52,0x65, /* re.Adobe ImageRe */ \
	0x61,0x64,0x79,0x71,0xc9,0x65,0x3c,0x00,0x00,0x00,0x06,0x50,0x4c,0x54,0x45,0xff, /* adyq.e<....PLTE. */ \
	0xff,0xff,0x00,0x00,0x00,0x55,0xc2,0xd3,0x7e,0x00,0x00,0x00,0x10,0x49,0x44,0x41, /* .....U..~....IDA */ \
	0x54,0x78,0xda,0x62,0x60,0x18,0x05,0xc4,0x02,0x80,0x00,0x03,0x00,0x01,0x2c,0x00, /* Tx.b`.........,. */ \
	0x01,0x6d,0xb7,0x50,0x6f,0x00,0x00,0x00,0x00,0x49,0x45,0x4e,0x44,0xae,0x42,0x60, /* .m.Po....IEND.B` */ \
	0x82,0x89,0x50,0x4e,0x47,0x0d,0x0a,0x1a,0x0a,0x00,0x00,0x00,0x0d,0x49,0x48,0x44, /* ..PNG........IHD */ \
	0x52,0x00,0x00,0x00,0x13,0x00,0x00,0x00,0x0f,0x08,0x03,0x00,0x00,0x00,0x31,0x9a, /* R.............1. */ \
	0x04,0x1e,0x00,0x00,0x00,0x19,0x74,0x45,0x58,0x74,0x53,0x6f,0x66,0x74,0x77,0x61, /* ......tEXtSoftwa */ \
	0x72,0x65,0x00,0x41,0x64,0x6f,0x62,0x65,0x20,0x49,0x6d,0x61,0x67,0x65,0x52,0x65, /* re.Adobe ImageRe */ \
	0x61,0x64,0x79,0x71,0xc9,0x65,0x3c,0x00,0x00,0x00,0x48,0x50,0x4c,0x54,0x45,0xf5, /* adyq.e<...HPLTE. */ \
	0xf5,0xf5,0xa3,0xa3,0xa4,0x89,0x89,0x8a,0x75,0x75,0x76,0xe3,0xe3,0xe3,0xd0,0xd0, /* ........uuv..... */ \
	0xd0,0xfc,0xfc,0xfc,0xc8,0xc8,0xc8,0xcf,0xcf,0xcf,0x9b,0x9b,0x9b,0xbe,0xbe,0xbe, /* ................ */ \
	0xac,0xac,0xad,0x6b,0x6b,0x6c,0x74,0x74,0x75,0x91,0x91,0x92,0xf4,0xf4,0xf4,0xab, /* ...kklttu....... */ \
	0xac,0xac,0x89,0x89,0x89,0xb5,0xb5,0xb6,0x6c,0x6c,0x6c,0x6c,0x6c,0x6d,0xfd,0xfd, /* ........lllllm.. */ \
	0xfd,0xfe,0xfe,0xfe,0xff,0xff,0xff,0xa7,0x59,0x10,0xe4,0x00,0x00,0x00,0x7c,0x49, /* ........Y.....|I */ \
	0x44,0x41,0x54,0x78,0xda,0x64,0x8f,0x89,0x0e,0x83,0x30,0x0c,0x43,0xd3,0x03,0xc6, /* DATx.d....0.C... */ \
	0xd8,0xd8,0xc1,0x1c,0xf3,0xff,0x7f,0xba,0x04,0x95,0xb6,0x63,0x56,0x5b,0xa9,0x4f, /* ...........cV[.O */ \
	0xce,0x61,0xd9,0xfe,0x25,0x76,0x75,0xd4,0x43,0xa3,0x16,0x46,0x97,0xaa,0x3d,0x61, /* .a..%vu.C..F..=a */ \
	0xe2,0xe1,0xa3,0xfd,0x1d,0x5d,0x90,0xd8,0x7c,0x4e,0x98,0xf1,0x79,0x55,0xb6,0x13, /* .....]..|N..yU.. */ \
	0x4a,0x42,0x94,0xe6,0xcb,0x37,0xab,0x8f,0x40,0x66,0x9b,0x11,0xb1,0x32,0xe0,0x3e, /* JB...7..@f...2.> */ \
	0x9b,0xbb,0xb2,0x00,0xd8,0x79,0x78,0xdf,0xda,0xef,0xb9,0x00,0x48,0xd2,0x33,0xea, /* .....yx.....H.3. */ \
	0x60,0x6c,0xd8,0xc7,0x77,0xfb,0x5d,0x11,0x3c,0x47,0xc7,0x6c,0x91,0xb7,0x78,0x14, /* `l..w.].<G.l..x. */ \
	0xfd,0xc9,0xc1,0x12,0xa6,0xb0,0xb3,0xbe,0x02,0x0c,0x00,0x1a,0x8c,0x16,0x6e,0xfa, /* ..............n. */ \
	0x1a,0x09,0x15,0x00,0x00,0x00,0x00,0x49,0x45,0x4e,0x44,0xae,0x42,0x60,0x82,0x1f, /* .......IEND.B`.. */ \
	0x8b,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x45,0x57,0x69,0x58,0x53,0xd7,0xd6, /* .........EWiXS.. */ \
	0xde,0x19,0x38,0x24,0x10,0x20,0x04,0xd4,0x30,0xa8,0x01,0x99,0x0f,0xda,0xc0,0x41, /* ..8$. ..0......A */ \
	0x26,0x87,0x86,0x51,0xd0,0xa0,0x20,0xc6,0xaa,0xa8,0x25,0x0c,0x47,0x44,0x86,0xa0, /* &..Q.. ...%.GD.. */ \
	0x88,0x48,0xab,0x3d,0x40,0x08,0xb3,0x06,0x64,0xc8,0x0e,0xb6,0x06,0xb1,0x54,0xf2, /* .H.=@...d.....T. */ \
	0xd9,0x1a,0x44,0x2d,0x5e,0x6d,0x0d,0xa3,0x80,0xa7,0x14,0xad,0xb1,0xda,0xa2,0x17, /* ..D-^m.......... */ \
	0x1c,0x2a,0x5a,0xab,0xd0,0xf6,0x56,0xab,0xb7,0xdd,0x5f,0xfa,0xfd,0xf9,0xd6,0xaf, /* ..Z...V..._..... */ \
	0xbd,0xd7,0x7a,0x9e,0xfd,0xbe,0xeb,0x7d,0xd7,0x8f,0xb5,0xd7,0xc4,0xc7,0x86,0x86, /* ..z....}........ */ \
	0xc9,0xbf,0x04,0xab,0x81,0x02,0x00,0xb7,0x3f,0xd9,0x0c,0x00,0xfe,0x0b,0xfc,0x81, /* ........?....... */ \
	0x39,0xfe,0xc9,0x55,0xfe,0x73,0x00,0x04,0x00,0x24,0x00,0x10,0x00,0x1a,0x00,0x04, /* 9..U.s...$...... */ \
	0x70,0x00,0x70,0x02,0xe0,0x24,0xc0,0x21,0xc0,0x69,0x80,0x23,0x20,0x03,0x40,0x46, /* p.p..$.!.i.# .@F */ \
	0x00,0x19,0x09,0x64,0x10,0xc8,0x68,0x20,0x43,0x80,0x02,0x80,0x22,0x00,0x45,0x02, /* ...d..h C...".E. */ \
	0x0a,0x02,0x8a,0x06,0x14,0x02,0x7a,0x00,0xf4,0x04,0xd0,0x93,0x40,0x0f,0x81,0x9e, /* ......z.....@... */ \
	0x06,0x7a,0x04,0x4c,0x00,0x98,0x08,0x60,0x22,0x81,0x09,0x02,0x13,0x0d,0x4c,0xc8, /* .z.L...`".....L. */ \
	0xfc,0x36,0x40,0x04,0x40,0x24,0x40,0x10,0x20,0x1a,0x20,0xf3,0xc5,0x8c,0x4d,0x10, /* .6@.@$@. . ...M. */ \
	0x80,0x24,0x00,0x24,0x00,0x6d,0xae,0x11,0x38,0x20,0x70,0x82,0xc0,0x49,0x02,0x87, /* .$.$.m..8 p..I.. */ \
	0x04,0x4e,0x13,0x38,0x22,0x64,0x80,0x90,0x11,0x84,0x8c,0x24,0x64,0x90,0x90,0xd1, /* .N.8"d.....$d... */ \
	0x84,0x0c,0x11,0x14,0x20,0x28,0x82,0xa0,0x48,0x82,0x82,0x04,0x45,0x13,0x14,0x22, /* .... (..H...E.." */ \
	0xf4,0x80,0xd0,0x13,0x84,0x9e,0x24,0xf4,0x90,0xd0,0xd3,0x84,0x1e,0x11,0x26,0x40, /* ......$.......&@ */ \
	0x98,0x08,0xc2,0x44,0x12,0x26,0x48,0x98,0x68,0xc2,0x84,0x08,0x04,0x08,0x44,0x10, /* ...D.&H.h.....D. */ \
	0x88,0x24,0x10,0x24,0x10,0x4d,0x20,0x33,0x0f,0x73,0xdb,0x04,0x09,0x48,0x12,0x40, /* .$.$.M 3.s...H.@ */ \
	0x12,0xd0,0x66,0x5a,0x24,0x0e,0x48,0x9c,0x20,0x71,0x92,0xc4,0x21,0x89,0xd3,0x24, /* ..fZ$.H. q..!..$ */ \
	0x8e,0x48,0x19,0x20,0x65,0x04,0x29,0x23,0x49,0x19,0x24,0x65,0x34,0x29,0x43,0x24, /* .H. e.)#I.$e4)C$ */ \
	0x05,0x48,0x8a,0x20,0x29,0x92,0xa4,0x20,0x49,0xd1,0x24,0x85,0x48,0x3d,0x20,0xf5, /* .H. ).. I.$.H= . */ \
	0x04,0xa9,0x27,0x49,0x3d,0x24,0xf5,0x34,0xa9,0x47,0xa4,0x09,0x90,0x26,0x82,0x34, /* ..'I=$.4.G...&.4 */ \
	0x91,0xa4,0x09,0x92,0x26,0x9a,0x34,0x21,0x12,0x01,0x12,0x11,0x24,0x22,0x49,0x04, /* ....&.4!....$"I. */ \
	0x49,0x44,0x93,0xc8,0x2c,0x81,0x59,0x71,0x02,0x02,0x12,0x02,0x08,0x01,0x6d,0x56, /* ID..,.Yq......mV */ \
	0x04,0xe2,0x00,0xe2,0x04,0xc4,0x49,0x88,0x43,0x88,0xd3,0x10,0x47,0x50,0x06,0xa0, /* ......I.C...GP.. */ \
	0x8c,0x80,0x32,0x12,0xca,0x20,0x94,0xd1,0x50,0x86,0x20,0x05,0x20,0x45,0x40,0x8a, /* ..2.. ..P. . E@. */ \
	0x84,0x14,0x84,0x14,0x0d,0x29,0x04,0xf5,0x00,0xea,0x09,0xa8,0x27,0xa1,0x1e,0x42, /* .....)......'..B */ \
	0x3d,0x0d,0xf5,0x08,0x9a,0x00,0x34,0x11,0xd0,0x44,0x42,0x13,0x84,0x26,0x1a,0x9a, /* =.....4..DB..&.. */ \
	0x10,0x44,0x00,0x22,0x02,0x22,0x12,0x22,0x08,0x11,0x0d,0x91,0x59,0x7d,0xb3,0xd9, /* .D."."."....Y}.. */ \
	0x04,0x0d,0x48,0x1a,0x40,0x1a,0xd0,0x66,0x33,0x68,0x1c,0xd0,0x38,0x41,0xe3,0x24, /* ..H.@..f3h..8A.$ */ \
	0x8d,0x43,0x1a,0xa7,0x69,0x1c,0xd1,0x32,0x40,0xcb,0x08,0x5a,0x46,0xd2,0x32,0x48, /* .C..i..2@..ZF.2H */ \
	0xcb,0x68,0x5a,0x86,0x68,0x0a,0xd0,0x14,0x41,0x53,0x24,0x4d,0x41,0x9a,0xa2,0x69, /* .hZ.h...AS$MA..i */ \
	0x0a,0xd1,0x7a,0x40,0xeb,0x09,0x5a,0x4f,0xd2,0x7a,0x48,0xeb,0x69,0x5a,0x8f,0x68, /* ..z@..ZO.zH.iZ.h */ \
	0x13,0xa0,0x4d,0x04,0x6d,0x22,0x69,0x13,0xa4,0x4d,0x34,0x6d,0x42,0x34,0x02,0x34, /* ..M.m"i..M4mB4.4 */ \
	0x22,0x68,0x44,0xd2,0x08,0xd2,0x88,0xa6,0x11,0xfa,0x67,0x10,0xcc,0x6e,0x98,0x25, /* "hD.......g..n.% */ \
	0x31,0xf3,0x32,0x17,0xcd,0xa3,0x80,0x03,0x84,0x13,0x08,0x27,0x11,0x0e,0x11,0x4e, /* 1.2........'...N */ \
	0x23,0x1c,0x21,0x19,0x40,0x32,0x02,0xc9,0x48,0x24,0x83,0x48,0x46,0x23,0x19,0x42, /* #.!.@2..H$.HF#.B */ \
	0x14,0x40,0x14,0x81,0x28,0x12,0x51,0x10,0x51,0x34,0xa2,0x10,0xd2,0x03,0xa4,0x27, /* .@..(.Q.Q4.....' */ \
	0x90,0x9e,0x44,0x7a,0x88,0xf4,0x34,0xd2,0x23,0x64,0x02,0xc8,0x44,0x20,0x13,0x89, /* ..Dz..4.#d..D .. */ \
	0x4c,0x10,0x99,0x68,0x64,0xfa,0x07,0xcc,0x3c,0x68,0x66,0xb7,0xcd,0x92,0x9b,0xfb, /* L..hd...<hf..... */ \
	0xfe,0x3f,0xf0,0xff,0x0f,0x0e,0x02,0xaf,0xb8,0xae,0x71,0x06,0x5d,0x5f,0x39,0xc7, /* .?........q.]_9. */ \
	0xc1,0x6f,0xfb,0x88,0xa1,0x7d,0xa0,0x92,0xbf,0x64,0xed,0xf1,0xb8,0xee,0x93,0x43, /* .o...}...d.....C */ \
	0xb5,0x42,0x22,0x7b,0xd2,0x47,0xdc,0xb4,0x26,0x54,0x3b,0x55,0xcc,0x33,0xa9,0x35, /* .B"{.G..&T;U.3.5 */ \
	0x9d,0xc7,0xb4,0xec,0x93,0xb7,0xa2,0x73,0x4e,0x04,0x66,0x62,0xd5,0x7d,0x4e,0xc5, /* .......sN.fb.}N. */ \
	0x82,0x47,0x62,0x8d,0xeb,0xbe,0x67,0x93,0xd5,0xe2,0xa6,0xce,0x10,0xc5,0x61,0xd0, /* .Gb...g.......a. */ \
	0x95,0x3a,0x5d,0x5a,0xb1,0xd8,0x7d,0xc1,0x83,0x50,0xbe,0x48,0xc2,0x0a,0x80,0x6c, /* .:]Z..}..P.H...l */ \
	0x57,0x85,0x88,0x65,0xe9,0xec,0xb4,0xdb,0xaa,0xac,0xa6,0x40,0x32,0xbc,0x3a,0x8d, /* W..e.......@2.:. */ \
	0x91,0x37,0x92,0x25,0x56,0x7d,0x76,0xb7,0xc7,0xb5,0xd6,0xa9,0xcb,0x61,0xec,0x88, /* .7.%V}v......a.. */ \
	0x05,0x47,0x72,0x3f,0x92,0x4a,0xdc,0xe4,0x10,0xaf,0x0c,0xc8,0x7b,0xa4,0x50,0x7b, /* .Gr?.J......{.P{ */ \
	0xc5,0x1e,0x61,0x65,0x05,0x7d,0x5a,0xc0,0x17,0x95,0x7a,0x1c,0x62,0x55,0x0f,0x19, /* ..ae.}Z...z.bU.. */ \
	0xdb,0x7d,0x55,0x76,0x09,0x96,0x23,0x59,0x63,0x37,0x44,0x0e,0x3f,0x5c,0xd7,0x2c, /* .}Uv..#Yc7D.?\., */ \
	0xf9,0x3a,0x40,0xa0,0xbf,0xe3,0x22,0x8a,0xc4,0xa9,0x8b,0x53,0x1d,0x9c,0x8f,0xa5, /* .:@..."....S.... */ \
	0x50,0xe1,0x9c,0xa3,0x8e,0x72,0x68,0x95,0x86,0x29,0xa6,0xe2,0xca,0xa3,0x62,0x6d, /* P....rh..)....bm */ \
	0x03,0x3e,0xe7,0xd6,0x70,0xd5,0xb1,0x77,0x79,0x46,0x55,0xc1,0xe4,0x16,0x86,0x5f, /* .>..p..wyFU...._ */ \
	0xcf,0xdc,0x43,0xec,0x3f,0x7d,0xdd,0x92,0x5f,0xeb,0x2d,0xac,0x25,0x75,0xd1,0x21, /* ..C.?}.._.-.%u.! */ \
	0x91,0xa7,0x6c,0x3b,0xd7,0x9f,0x58,0xb9,0x6a,0x5d,0x91,0x18,0xbb,0x65,0xa9,0x55, /* ..l;..X.j]...e.U */ \
	0xd0,0x48,0x21,0xf2,0xad,0x17,0x26,0xe8,0x32,0x74,0x6e,0xa1,0x64,0x36,0xf3,0x8b, /* .H!...&.2tn.d6.. */ \
	0xb4,0x45,0x3a,0x18,0x14,0xbb,0xfa,0xd7,0xb7,0xd7,0xa6,0x41,0xe9,0xd3,0xe3,0x03, /* .E:........A.... */ \
	0x76,0xb6,0x31,0x46,0xb9,0xd2,0xe5,0x5b,0xd1,0x6f,0x75,0xde,0x50,0x54,0x55,0x97, /* v.1F...[.ou.PTU. */ \
	0xcd,0xea,0x56,0xc5,0xdb,0x36,0x85,0xce,0xa6,0xac,0x63,0xda,0x97,0x0f,0xe4,0xa6, /* ..V..6....c..... */ \
	0x55,0xb5,0x0f,0xdb,0x4c,0xed,0x76,0xe7,0x32,0xc3,0xd8,0xea,0x28,0xaf,0xb4,0xc1, /* U...L.v.2...(... */ \
	0xc4,0xf9,0x87,0x7d,0x3e,0x99,0x37,0x66,0xd7,0xf6,0xbc,0xa3,0xc5,0x5e,0xac,0x77, /* ...}>.7f.....^.w */ \
	0xbb,0xc7,0xd7,0x78,0x94,0xd7,0xd5,0x5b,0xde,0x9e,0x8e,0xf5,0x9d,0x7c,0xda,0xa2, /* ...x...[.....|.. */ \
	0xf2,0x7a,0xf2,0xcd,0xfc,0xf2,0xec,0x89,0x53,0x6e,0x51,0x4c,0x3b,0xff,0x96,0x81, /* .z......SnQL;... */ \
	0x92,0xb7,0xca,0x40,0x96,0xd7,0x82,0xe1,0x29,0x89,0xed,0xaa,0xce,0x2c,0xcf,0x35, /* ...@....)....,.5 */ \
	0xf8,0xf8,0x79,0x3b,0x9f,0xd8,0x4d,0xe0,0x1a,0x16,0x7b,0x65,0x4e,0xe5,0x32,0x7a, /* ..y;..M...{eN.2z */ \
	0xfc,0xa7,0xea,0xfa,0xd1,0xd0,0x63,0xa3,0x47,0x2c,0x92,0x38,0x0e,0x41,0xef,0xdb, /* ......c.G,.8.A.. */ \
	0x2b,0x35,0x81,0x13,0x3e,0x51,0xd2,0x8f,0xf5,0xab,0x7a,0xbe,0xf5,0x2a,0xfa,0xba, /* +5..>Q....z..... */ \
	0xf0,0xf1,0x09,0xe7,0xa7,0x1d,0x9b,0x7d,0xde,0x28,0x99,0x96,0x96,0x4c,0xa6,0xdc, /* .......}.(...L.. */ \
	0xd2,0x35,0x57,0xf4,0x5b,0x7c,0xbd,0x66,0xcb,0xab,0xba,0x95,0xa3,0xc5,0xbf,0xc6, /* .5W.[|.f........ */ \
	0x36,0x33,0xdd,0x54,0x9a,0xad,0x6d,0xce,0x9f,0xf1,0x7c,0xbc,0xed,0x07,0x44,0x3a, /* 63.T..m...|...D: */ \
	0xdb,0xbe,0xb9,0x61,0xaf,0xeb,0x39,0x9b,0xa3,0x35,0xb5,0x7e,0x0d,0x74,0x69,0xbe, /* ...a..9..5.~.ti. */ \
	0x08,0x65,0xf9,0x7a,0x7d,0x9a,0x58,0xe2,0x1c,0x91,0x5d,0xd5,0x30,0x2f,0xd2,0xe3, /* .e.z}.X...].0/.. */ \
	0x8d,0xd8,0x2f,0x22,0x34,0xb1,0x58,0x1d,0x98,0x55,0x57,0x8a,0x39,0xef,0x3e,0x2d, /* ../"4.X..UW.9.>- */ \
	0x7f,0x2f,0x52,0xbb,0xa5,0x85,0x1f,0x90,0xef,0xc3,0xfe,0xbc,0x69,0xbb,0x69,0xf8, /* ./R.........i.i. */ \
	0xce,0x0e,0x8b,0xf6,0xf6,0xc7,0x91,0x1e,0x9d,0xa7,0xb8,0xce,0x69,0x8e,0x95,0x6a, /* ............i..j */ \
	0x97,0xb4,0x1c,0x3c,0x29,0x6e,0xa6,0x82,0xb9,0xc4,0x55,0x2a,0xec,0x66,0xbb,0xee, /* ...<)n....U..f.. */ \
	0x17,0x3d,0x3c,0x7d,0x86,0xbb,0xed,0x15,0x77,0x35,0x9c,0x48,0xca,0xac,0x62,0x14, /* .=<}....w5.H..b. */ \
	0x6e,0xe3,0x7b,0x32,0x5c,0x45,0x39,0x6d,0x94,0x67,0x13,0x37,0x59,0xba,0x7c,0x7f, /* n.{2\E9m.g.7Y.|. */ \
	0x14,0xef,0x27,0xdb,0x53,0x76,0xb9,0x56,0x99,0xee,0x03,0x67,0x97,0x75,0xdd,0x90, /* ..'.Sv.V...g.u.. */ \
	0x00,0x4e,0x90,0xa9,0x69,0x13,0x43,0x4c,0xf2,0x6d,0x19,0x89,0xd2,0xc4,0x40,0x82, /* .N..i.CL.m....@. */ \
	0x2d,0x52,0xad,0x5b,0xb0,0x44,0x12,0x90,0xc1,0x90,0x3e,0x78,0x27,0x5a,0x55,0x13, /* -R.[.D....>x'ZU. */ \
	0x5d,0x67,0x1f,0x23,0xee,0x5b,0xb6,0x6b,0xd4,0x27,0xfd,0xa1,0xf8,0x93,0x0f,0x23, /* ]g.#.[.k.'.....# */ \
	0xc7,0xc4,0xad,0x57,0xda,0xe9,0xfa,0x5d,0xb6,0x41,0x18,0xb0,0x14,0xba,0x4a,0x78, /* ...W...].A....Jx */ \
	0x0f,0x9c,0x1f,0x61,0x20,0x4c,0xfc,0x01,0x05,0x42,0x3c,0x44,0x51,0xfd,0x0c,0xf1, /* ...a L...B<DQ... */ \
	0xd6,0x89,0x8d,0xbe,0x6e,0xca,0x01,0x35,0xe6,0xfb,0x30,0x0a,0x80,0xa0,0xe6,0xa8, /* ....n..5..0..... */ \
	0x73,0xe9,0x41,0x94,0x82,0xb7,0xcd,0x5a,0x19,0x2b,0xd7,0x38,0x3b,0x8e,0x6d,0xf4, /* s.A....Z.+.8;.m. */ \
	0xce,0x16,0x50,0x20,0xd7,0x4e,0x09,0x6e,0xb9,0x13,0xe8,0x3c,0xd7,0x67,0xd6,0x39, /* ..P .N.n...<.g.9 */ \
	0xbb,0xd2,0xbe,0xc8,0x51,0x7e,0xcd,0xe5,0x40,0x69,0x99,0xd4,0xb7,0xbf,0xa9,0x2c, /* ....Q~..@i....., */ \
	0xbe,0xac,0xb5,0xf8,0x57,0xc1,0xc2,0xfc,0x9c,0x37,0x12,0x23,0x66,0xad,0x0b,0x8c, /* ....W....7.#f... */ \
	0x64,0x35,0xad,0x12,0x47,0xf8,0x1f,0x58,0x38,0xe6,0xc1,0x09,0xb9,0xb2,0xa1,0x6a, /* d5..G..X8......j */ \
	0x47,0xe5,0x57,0x91,0xa0,0xcb,0xfa,0x14,0x6f,0xc4,0xd2,0x63,0x6a,0x64,0xf5,0xdf, /* G.W.....o..cjd.. */ \
	0xfd,0x0d,0xe5,0x80,0xd1,0xd6,0x16,0x2b,0xe7,0xf8,0x9c,0x92,0x56,0xed,0xce,0x29, /* .......+....V..) */ \
	0x89,0xba,0x6b,0xf1,0x94,0x88,0x07,0xfe,0xa1,0x2b,0xec,0x83,0xda,0x8c,0x8c,0xca, /* ..k......+...... */ \
	0xc0,0x76,0xf6,0x9d,0xbc,0xcb,0xb9,0x8d,0x1b,0xbb,0x1e,0x9e,0xb8,0x12,0xb1,0xfb, /* .v.............. */ \
	0x5b,0xf8,0xe2,0x6f,0x6a,0x04,0xb2,0x27,0x83,0x22,0xf2,0x07,0x17,0x51,0x2c,0x8e, /* [..oj..'."...Q,. */ \
	0xfd,0x80,0xa3,0x27,0xdb,0x77,0xdf,0x9c,0x95,0xe2,0xe6,0xe0,0x3c,0xe6,0xdc,0x82, /* ...'.w......<... */ \
	0x47,0xd8,0xb0,0xb7,0xc3,0xef,0x17,0x81,0xd4,0xfb,0xf7,0xa2,0xbb,0x3b,0xbe,0xb3, /* G............;.. */ \
	0xb4,0x15,0xf0,0x0d,0x42,0x8f,0x8c,0x3c,0x46,0x68,0xc3,0x3a,0xc5,0x82,0x0b,0x83, /* ....B..<Fh.:.... */ \
	0xcf,0x97,0x5a,0x1e,0xfa,0xcd,0xc5,0xe7,0xb9,0x71,0x7e,0x82,0xb0,0x8f,0xdc,0x4f, /* ..Z......q~....O */ \
	0x0d,0x08,0xfa,0xff,0xe8,0x19,0x5e,0x35,0x6e,0x13,0x3e,0x30,0xd8,0xd9,0xeb,0x5e, /* ......^5n.>0...^ */ \
	0xde,0x6a,0xa3,0x14,0x70,0xee,0x1c,0x8f,0x48,0x03,0x80,0xb9,0xf9,0x27,0x51,0x3b, /* .j..p...H....'Q; */ \
	0x1e,0x67,0x0b,0x66,0xfb,0x4b,0x4f,0x47,0xa4,0x77,0xfe,0x58,0xc9,0xd3,0x96,0xb1, /* .g.f.KOG.w.X.... */ \
	0xca,0xa2,0x87,0x7c,0xed,0x27,0x2b,0x9d,0x91,0xa2,0xf5,0xea,0x77,0x09,0x4b,0xd3, /* ...|.'+.....w.K. */ \
	0x57,0xb9,0x6e,0xae,0x9a,0x98,0xe8,0x0a,0x02,0x0a,0xd1,0x47,0x0d,0x7d,0xaf,0x3d, /* W.n........G.}.= */ \
	0x98,0x36,0xd6,0xce,0x0c,0xc7,0xf6,0x62,0x96,0x03,0xef,0x1a,0x63,0x85,0xeb,0x60, /* .6.....b....c..` */ \
	0xd2,0x98,0x31,0xba,0xe8,0x5c,0x07,0x2f,0x7c,0x2a,0x83,0x27,0x64,0xfd,0xfb,0x66, /* ..1..\./|..'d..f */ \
	0xe7,0xeb,0x79,0x6c,0xd7,0xd4,0x95,0xcc,0x3b,0xb2,0x88,0x2d,0x9d,0x2b,0x9b,0x45, /* ..yl....;..-.+.E */ \
	0x67,0xf7,0xa7,0x85,0x02,0x81,0x4d,0x60,0x1d,0xe5,0x66,0x4c,0x67,0x96,0xee,0xf8, /* g.....M`..fLg... */ \
	0x59,0x70,0xae,0x8d,0x95,0xc5,0x75,0x60,0x85,0x82,0xab,0x87,0x53,0xfb,0x33,0x94, /* Yp....u`....S.3. */ \
	0x71,0xa5,0x3e,0x6d,0x6b,0x2b,0x98,0xd8,0x68,0xf5,0x4c,0xba,0x70,0x8f,0x6f,0x6c, /* q.>mk+..h.L.p.ol */ \
	0xca,0xb2,0xd3,0x7d,0xaa,0xa7,0xe5,0xc2,0xaf,0x66,0x95,0xde,0x86,0x27,0xaa,0x35, /* ...}.....f...'.5 */ \
	0xb2,0x51,0x06,0x90,0x18,0xaf,0x07,0x67,0x7e,0x89,0x7d,0x98,0xb7,0x38,0x0d,0x50, /* .Q.....g~.}..8.P */ \
	0x0c,0x97,0xd2,0xee,0xde,0x5f,0x96,0xa8,0xd8,0x77,0xef,0xd9,0x6c,0x7c,0x75,0xb9, /* ....._...w..l|u. */ \
	0xd3,0x75,0x0a,0x3b,0xd1,0x36,0xcd,0xd0,0x3c,0xf0,0x1f,0xe2,0x88,0xaa,0x79,0xa3, /* .u.;.6..<.....y. */ \
	0xd1,0xc3,0xb7,0x7f,0x33,0x50,0xbe,0x1d,0xcc,0x04,0xdf,0x07,0x92,0x12,0x5f,0x0c, /* ....3P........_. */ \
	0x5b,0xf8,0x0e,0x20,0x22,0x3e,0xe5,0x19,0x64,0xf6,0xf2,0xac,0x7e,0x66,0x11,0x98, /* [.. ">..d...~f.. */ \
	0xbc,0xfc,0xc3,0xe3,0xa1,0xdd,0x82,0x28,0x61,0xa3,0x26,0x3a,0x50,0x19,0x30,0xec, /* .......(a.&:P.0. */ \
	0x7c,0x90,0x59,0xb3,0x7e,0x94,0xed,0x3a,0x29,0xe6,0xe6,0xb6,0xcb,0x13,0xdc,0xb4, /* |.Y.~..:)....... */ \
	0x7d,0x62,0x2b,0x01,0xaa,0xa9,0x8d,0xf9,0xc5,0x41,0x98,0x5c,0x1e,0xf1,0xbc,0x88, /* }b+......A.\.... */ \
	0xba,0xed,0x5b,0x5e,0xfa,0xf1,0x9b,0x41,0x2b,0xc7,0x83,0xac,0x2b,0x17,0xf2,0x35, /* ..[^...A+...+..5 */ \
	0x44,0xef,0xe4,0x17,0x53,0x13,0x4d,0xf1,0xa1,0xd1,0x4e,0x2b,0x8e,0x33,0xe2,0xef, /* D...S.M...N+.3.. */ \
	0x17,0x95,0x4b,0xd6,0xc6,0x1c,0x61,0xc6,0x63,0x23,0x87,0x53,0xd5,0x75,0x43,0x54, /* ..K...a.c#.S.uCT */ \
	0xa1,0x25,0xf0,0x8d,0x69,0x0a,0xe0,0xc9,0x4f,0x4f,0xdb,0x64,0x77,0xdf,0x9d,0x0f, /* .%..i...OO.dw... */ \
	0x27,0x96,0xcb,0x33,0x98,0x0e,0x03,0x23,0x4a,0x8f,0xc0,0xe9,0xba,0xe7,0x1e,0x55, /* '..3...#J......U */ \
	0xbb,0x58,0x77,0x6d,0x5e,0x04,0x75,0x06,0x4c,0x06,0x7c,0xfa,0xd1,0x9b,0x3d,0x56, /* .Xwm^.u.L.|...=V */ \
	0xeb,0x23,0x95,0xe5,0x49,0xb9,0x9e,0xa0,0xe5,0x46,0x65,0x60,0x50,0x41,0xc0,0xed, /* .#..I....Fe`PA.. */ \
	0x3f,0xf9,0x8c,0x10,0x30,0xf4,0xc2,0x55,0xa7,0x0d,0x09,0x1a,0x8a,0xca,0x8f,0xe6, /* ?...0..U........ */ \
	0xad,0xfd,0xb9,0x97,0xff,0xf2,0x97,0x7d,0x07,0xbe,0x28,0xe4,0x5e,0x95,0x58,0xd5, /* .......}..(.^.X. */ \
	0x5f,0xad,0x9b,0xce,0xd4,0xaa,0xad,0x92,0x4b,0x5a,0xed,0xe3,0x7f,0x8f,0x14,0x1e, /* _.......KZ...... */ \
	0x13,0xcf,0xe3,0x1b,0x33,0xd8,0xa1,0x7c,0xd6,0xe2,0xfe,0x19,0x0b,0x2f,0x36,0x5e, /* ....3..|...../6^ */ \
	0x17,0x23,0x2d,0xfb,0x38,0xcd,0xb1,0x23,0x5b,0x31,0x15,0xbb,0x2a,0xfc,0x76,0x3d, /* .#-.8..#[1....v= */ \
	0x57,0xf3,0x3f,0xac,0xd5,0x0b,0xca,0xc1,0xca,0x54,0xd1,0xf4,0x8f,0x8f,0x5d,0xbf, /* W.?......T....]. */ \
	0x51,0xb9,0xf4,0x4b,0x97,0xe6,0x67,0x3d,0x6f,0xbf,0xc7,0x9c,0x38,0x3f,0x16,0xfb, /* Q..K..g=o...8?.. */ \
	0x4d,0x5e,0xdf,0x0f,0xd7,0x7e,0x14,0x88,0x47,0x94,0x33,0x0f,0x73,0x53,0x3f,0x70, /* M^...~..G.3.sS?p */ \
	0xd9,0xf1,0xaa,0x81,0xcb,0x44,0x8b,0x24,0x07,0x85,0x09,0x53,0x11,0x5f,0x78,0xcd, /* .....D.$...S._x. */ \
	0xfb,0x23,0x53,0x29,0x7c,0x3a,0x18,0xbd,0x74,0x6f,0x8d,0x76,0xa0,0xa4,0x67,0x7e, /* .#S)|:..to.v..g~ */ \
	0xf8,0xc2,0xd8,0x70,0xef,0x6e,0xce,0x27,0x5e,0x3e,0x0e,0xb7,0xcb,0xdd,0x03,0x22, /* ...p.n.'^>....." */ \
	0x4c,0x67,0x9e,0xf5,0xff,0x04,0x52,0x3b,0xb8,0xc9,0xc3,0xdf,0x37,0x7d,0xf9,0x66, /* Lg....R;....7}.f */ \
	0x16,0xcb,0xe3,0x09,0x87,0x41,0x18,0x7f,0x0d,0x99,0xf0,0xf9,0xc2,0x7d,0x3b,0x92, /* .....A.......};. */ \
	0xc5,0x73,0xcd,0xf2,0xce,0xe8,0xd6,0x1c,0x69,0x9c,0x33,0x7b,0x82,0x7a,0x65,0xdb, /* .s......i.3{.ze. */ \
	0xb3,0x56,0x2b,0x92,0x02,0xf6,0xbf,0x8e,0x5e,0x5c,0x04,0x2c,0x2f,0x6e,0xc2,0x92, /* .V+.....^\.,/n.. */ \
	0x9d,0x35,0x0d,0x19,0x33,0x85,0x82,0x15,0x8f,0x87,0xc4,0x25,0x7d,0xb5,0xf1,0x41, /* .5..3......%}..A */ \
	0xc5,0x86,0x63,0xbd,0xca,0xf5,0x8b,0x8f,0xd7,0x0d,0x1e,0x2e,0x13,0xc9,0xf9,0x0d, /* ..c............. */ \
	0x37,0x6f,0x86,0xf3,0xd5,0xcb,0x15,0xc9,0x8e,0xab,0x8c,0xaf,0xc1,0x1f,0xc3,0xaa, /* 7o.............. */ \
	0x61,0xdd,0x85,0x2f,0xcf,0xe4,0x7c,0x7f,0x3f,0xb8,0xfb,0xd0,0x14,0xa5,0xf2,0x48, /* a../..|.?......H */ \
	0xc2,0x98,0xae,0x25,0x03,0x65,0xab,0x33,0x42,0xc2,0x44,0x8e,0xce,0x76,0x89,0x57, /* ...%.e.3B.D..v.W */ \
	0x53,0x82,0x3d,0x19,0x2d,0xa3,0xb9,0x9e,0x96,0x91,0xc1,0x7f,0x67,0x67,0x08,0x1b, /* S.=.-.......gg.. */ \
	0xaa,0xd8,0x3b,0x97,0xb8,0x71,0x63,0x33,0xd2,0x16,0x84,0x7f,0x15,0xe3,0xe2,0xde, /* ..;..qc3........ */ \
	0x57,0x1b,0xfb,0x3c,0xc8,0x30,0x91,0xc0,0x2f,0x8f,0x2c,0x04,0x29,0x3f,0x04,0x60, /* W..<.0../.,.)?.` */ \
	0xfd,0x69,0x5b,0x6d,0x55,0x7d,0x82,0x16,0xdd,0x26,0xad,0x4e,0x91,0x5f,0x75,0xa8, /* .i[mU}...&.N._u. */ \
	0x40,0x3d,0xcb,0x95,0x22,0x91,0x4e,0x94,0x72,0x1e,0xcb,0x39,0x0f,0x8a,0x63,0x1c, /* @=..".N.r..9..c. */ \
	0xfc,0x43,0xc1,0x12,0xd7,0xb4,0x9d,0xe0,0xe5,0x12,0x1b,0x69,0xc0,0x48,0x9f,0xf8, /* .C.........i.H.. */ \
	0x76,0xe3,0x62,0x57,0x89,0x96,0xc5,0x1d,0x7a,0xac,0x86,0xf6,0x76,0x09,0x69,0x82, /* v.bW....z...v.i. */ \
	0x86,0xe2,0xc2,0x70,0x4f,0xfb,0xea,0x9d,0xc7,0x19,0x7d,0x9c,0x71,0xe5,0x8a,0xe2, /* ...pO.....}.q... */ \
	0x06,0x6e,0x51,0xc9,0x83,0x7d,0xdd,0x1e,0x86,0x88,0xbc,0x11,0xf9,0x82,0xeb,0xf3, /* .nQ..}.......... */ \
	0xf6,0x70,0xde,0x76,0x18,0x26,0xb7,0xbb,0xaa,0x2d,0xa8,0x36,0x66,0x44,0xba,0xed, /* .p.v.&...-.6fD.. */ \
	0xb3,0x27,0xd3,0x37,0x3a,0x5f,0xa4,0x86,0xad,0x57,0xbd,0x5b,0xee,0xa3,0x9e,0x9d, /* .'.7:_...W.[.... */ \
	0x8b,0x15,0x5d,0x86,0x4b,0x23,0x26,0x8d,0x46,0x29,0x95,0x33,0xf2,0x56,0x88,0x25, /* ..].K#&.F).3.V.% */ \
	0x6f,0xaa,0xb1,0x7f,0xdc,0x49,0x08,0x2e,0xc7,0xfd,0xea,0x71,0x86,0x9e,0x2c,0xb4, /* o....I.....q..,. */ \
	0x1a,0x58,0xff,0xf4,0xd6,0xf8,0x8a,0x4c,0x61,0x96,0x32,0x2e,0xd2,0x2f,0x94,0x1b, /* .X.....La.2../.. */ \
	0x93,0x39,0xd4,0x58,0xfe,0xae,0x17,0x15,0x75,0xb5,0xcf,0x2b,0x21,0xb0,0xa5,0x31, /* .9.X....u..+!..1 */ \
	0x93,0x77,0xcc,0xc2,0x22,0x20,0xff,0xc7,0x07,0xe1,0xb4,0x81,0xef,0x31,0xbe,0xf9, /* .w.." .......1.. */ \
	0xde,0x8e,0xdb,0xd2,0x3b,0x5e,0xef,0x1d,0xb0,0x99,0x60,0xcc,0x06,0x3e,0x7d,0xfe, /* ....;^....`..>}. */ \
	0x7c,0xf3,0xe1,0x97,0xea,0x1b,0x4e,0x97,0x1e,0xed,0x68,0xb6,0xde,0x1d,0xef,0x13, /* |.....N...h..... */ \
	0x32,0x7a,0x60,0x39,0xd7,0x4b,0xfb,0x41,0xc7,0xfb,0xbf,0x78,0x5d,0xc6,0xa6,0x7d, /* 2z`9.K.A...x]..} */ \
	0x2a,0x32,0xda,0xb4,0xad,0x57,0x94,0xc2,0x6f,0x39,0x47,0xab,0x4a,0xd8,0x4e,0x2e, /* .2...W..o9G.J.N. */ \
	0x2f,0xcb,0x79,0x83,0x88,0x7d,0xcf,0x46,0xb7,0x96,0x9f,0xc6,0x27,0xf3,0x63,0xf3, /* /.y..}.F....'.c. */ \
	0x6e,0xda,0xf6,0x08,0x16,0xfd,0xfd,0xd8,0x70,0xc5,0xe0,0xc2,0x3a,0xbe,0xf3,0x83, /* n.......p...:... */ \
	0xaf,0xdf,0xb3,0x8a,0x16,0x24,0xa7,0xaf,0x3d,0xdf,0xdf,0x12,0x90,0xb4,0xc7,0xc3, /* .....$..=....... */ \
	0x69,0xa9,0xa7,0xea,0x66,0x73,0x41,0x6e,0x4b,0x23,0x14,0x5a,0x1e,0x19,0x14,0xc7, /* i...fsAnK#.Z.... */ \
	0xb5,0xf3,0x1c,0xf6,0x86,0xb9,0x79,0x0c,0x8f,0xde,0xe2,0xdf,0xf7,0x1d,0x39,0xa3, /* ......y.......9. */ \
	0xdb,0x53,0x2f,0xbf,0x24,0x59,0xf6,0x8a,0x2c,0x35,0x32,0x2e,0x97,0x47,0x5f,0xda, /* .S/.$Y..,52..G_. */ \
	0x98,0xa9,0xb9,0x7f,0x28,0xf1,0xbc,0x6f,0xf6,0xec,0xde,0x77,0x2c,0xc4,0x77,0x4b, /* ....(..o...w,.wK */ \
	0x67,0x5c,0x6e,0x5f,0x3a,0x13,0x62,0x2b,0x8d,0xab,0x8b,0x79,0xc9,0x76,0x0c,0xfe, /* g\n_:.b+...y.v.. */ \
	0xeb,0x77,0x89,0x8a,0x51,0x53,0x34,0xe9,0xd8,0x37,0x60,0x8c,0xfe,0x77,0xd1,0x77, /* .w..QS4..7`..w.w */ \
	0x49,0x3b,0x17,0xf6,0x78,0x96,0xc7,0x16,0x54,0xdc,0xba,0x88,0x97,0xf9,0xe5,0x9f, /* I;..x...T....... */ \
	0x1f,0xf9,0xf0,0x47,0x5e,0xc9,0x15,0xcf,0xf0,0xeb,0xdc,0x54,0x63,0x61,0xca,0xf0, /* ...G^......Tca.. */ \
	0x66,0x35,0x2b,0x74,0xf2,0x91,0xc3,0x98,0xfa,0x89,0xa9,0x45,0xb5,0x66,0x97,0x97, /* f5+t.......E.f.. */ \
	0x72,0x0b,0x6f,0x65,0x5c,0x60,0xf8,0xb5,0xe7,0xf5,0xfc,0x8e,0xe9,0xe0,0x6f,0xa2, /* r.oe\`........o. */ \
	0xcb,0x97,0xdc,0xe0,0xc8,0x3d,0xee,0x3f,0x61,0xc1,0x88,0xbb,0xd1,0xc1,0xdb,0x34, /* .....=.?a......4 */ \
	0xca,0x11,0xca,0xea,0xee,0xbd,0xdc,0x64,0x7f,0x2a,0xfc,0x81,0xc4,0x4f,0xea,0xe7, /* .......d.....O.. */ \
	0x74,0xd2,0x42,0x70,0xf2,0xfd,0x6e,0xe9,0xba,0xc1,0x73,0xb9,0x80,0x54,0xb0,0xe6, /* t.Bp..n...s..T.. */ \
	0xb6,0xd7,0xf9,0x9e,0x59,0x3a,0x82,0xec,0xb6,0x9f,0xe0,0xa3,0xf5,0xef,0x8b,0x9a, /* ....Y:.......... */ \
	0x63,0x42,0xd7,0xf0,0xf7,0x8d,0x13,0xb7,0xdc,0x79,0x1a,0xe1,0x99,0x97,0x31,0x43, /* cB.......y....1C */ \
	0x2f,0x6d,0x57,0x0c,0x7d,0x34,0x5e,0xb8,0x8f,0x96,0x67,0x6d,0xfb,0xe1,0xf0,0x05, /* /mW.}4^...gm.... */ \
	0x91,0x94,0xf1,0x6e,0x9b,0xd1,0x31,0x6c,0x90,0x13,0xef,0x10,0xcc,0xbe,0x15,0x0c, /* ...n..1l........ */ \
	0x13,0xb7,0x66,0x12,0xcb,0x5d,0x3a,0xe2,0x3a,0x4e,0xda,0xad,0xd6,0x85,0x19,0x5b, /* ..f..]:.:N.....[ */ \
	0x85,0x35,0x85,0xfc,0xf6,0xd4,0x60,0xd8,0xce,0x7b,0xa1,0xe3,0xbe,0x98,0x70,0x3f, /* .5....`..{....p? */ \
	0x3f,0xc0,0x1f,0x93,0x70,0x1b,0x5f,0xcd,0x83,0x6a,0x41,0xd7,0x67,0xd8,0x15,0x95, /* ?...p._..jA.g... */ \
	0xa0,0xea,0x86,0x7f,0x47,0x60,0x99,0x56,0x47,0x78,0x47,0x04,0xe8,0x0c,0x1f,0x41, /* ....G`.VGxG....A */ \
	0x77,0x87,0xb3,0x41,0x4e,0x57,0x0b,0x58,0x35,0x83,0x9c,0x41,0x63,0xbe,0xd7,0x74, /* w..ANW.X5..Ac..t */ \
	0x8a,0x35,0xc3,0xaa,0x71,0x2a,0x73,0x50,0x57,0x76,0xaa,0x51,0xe9,0x32,0x63,0x7f, /* .5..q.sPWv.Q.2c. */ \
	0xa5,0x53,0xb9,0xfe,0xb5,0x32,0x51,0x58,0xb1,0x31,0xb4,0x62,0xd3,0x96,0x8a,0xcd, /* .S...2QX.1.b.... */ \
	0xc5,0x15,0x5b,0x34,0x15,0xdb,0x7a,0x2b,0xb6,0xdf,0xa9,0xd8,0xf9,0xba,0x22,0x55, /* ..[4..z+......"U */ \
	0xa8,0x4a,0x0b,0x55,0x65,0x6c,0x51,0x91,0xc5,0xaa,0x2c,0x8d,0x2a,0xbb,0x57,0xb5, /* .J.UelQ...,...W. */ \
	0x7d,0xcb,0x47,0x39,0x55,0x4e,0x3a,0x35,0xf7,0xbf,0x17,0x37,0xcc,0x4f,0xda,0x6f, /* }.G9UN:5...7.O.o */ \
	0xd5,0xc0,0xd3,0x4e,0xbd,0x03,0xf9,0xc2,0xb3,0x21,0x5c,0xed,0x54,0xe6,0xbc,0xee, /* ...N.....!\.T... */ \
	0xca,0x46,0xc5,0x86,0x05,0x2a,0xd7,0xc4,0x27,0x2a,0xe7,0x6e,0xea,0x6c,0x13,0xb7, /* .F......'..n.l.. */ \
	0xfe,0x3d,0xfb,0x10,0x24,0xd9,0x6c,0x51,0x20,0xee,0x77,0xc7,0x70,0x3e,0x76,0xbf, /* .=..$.lQ .w.p>v. */ \
	0x80,0xff,0x86,0x8f,0x85,0x88,0xb9,0xed,0x95,0x55,0xf0,0x1c,0x7f,0xd4,0xfc,0x63, /* .........U.....c */ \
	0x12,0xb1,0x70,0x05,0x2b,0xa1,0x97,0xef,0xd5,0x54,0xc3,0x2a,0xc5,0x46,0x0e,0xcc, /* ..p.+....T...F.. */ \
	0x37,0xaf,0xed,0x83,0xc0,0x2a,0xd1,0x9b,0xcb,0x8c,0x08,0x3e,0xcf,0x59,0x37,0xc6, /* 7..........>.Y7. */ \
	0xda,0x0f,0x45,0x7e,0x97,0xe3,0x78,0x0b,0x3a,0x79,0xeb,0xff,0x98,0x77,0xae,0x49, /* ..E~..x.:y...w.I */ \
	0x90,0xf8,0x9e,0xe7,0x31,0x35,0xf7,0x54,0xb9,0xc3,0x18,0xa8,0xed,0xfa,0x92,0x39, /* ....15.T.......9 */ \
	0xbe,0xb7,0xee,0x2b,0x0c,0xa4,0xf0,0xd7,0xc9,0x75,0xdc,0xf9,0x17,0xec,0x96,0xef, /* ...+.....u...... */ \
	0x5d,0xf7,0xf6,0x14,0x2f,0xb1,0x5d,0x90,0xf8,0xfd,0x1e,0x69,0x50,0x42,0xa0,0x08, /* ].../.]....iPB.. */ \
	0xdb,0x7f,0x53,0xf0,0xaf,0xde,0x0d,0x7b,0xce,0x6d,0x38,0x61,0xa8,0x5d,0x16,0x95, /* ..S....{.m8a.].. */ \
	0x32,0xd6,0x93,0xcc,0x2c,0xa8,0x3f,0x3d,0x2d,0xf8,0xd6,0xa7,0xd2,0x2b,0x94,0x37, /* 2...,.?=-....+.7 */ \
	0x21,0xc6,0x70,0x4a,0xa8,0xee,0xb5,0x87,0x80,0xa5,0x33,0x72,0xe4,0x0c,0xb0,0xb5, /* !.pJ......3r.... */ \
	0x9b,0x79,0x2e,0x3a,0xc5,0xfa,0xa1,0xff,0x76,0x79,0xf5,0x53,0x47,0xc0,0x33,0xd4, /* .y.:....vy.SG.3. */ \
	0x86,0x00,0x16,0x03,0xec,0x37,0x2f,0xb3,0xde,0x3d,0x7b,0xd3,0x81,0x03,0xbc,0x90, /* .....7/..={..... */ \
	0x38,0xc6,0x01,0x72,0x7e,0xba,0xda,0xbb,0xc6,0x7b,0x5f,0x10,0x92,0x35,0xa4,0x4c, /* 8..r~....{_..5.L */ \
	0x00,0x26,0x03,0x64,0x96,0xfa,0x4f,0xf0,0x59,0x01,0x53,0x75,0x0f,0x30,0xb0,0x70, /* .&.d..O.Y.Su.0.p */ \
	0x39,0x17,0x4f,0x65,0xd5,0x8b,0xf9,0x29,0x28,0x29,0xfa,0x0d,0x7f,0x1d,0xa6,0x2e, /* 9.Oe...)()...... */ \
	0x49,0x08,0x08,0x78,0xd6,0xa3,0xde,0x95,0x58,0x23,0xab,0xc4,0x52,0xf8,0xfe,0x27, /* I..x....X#..R..' */ \
	0x40,0x30,0x83,0x8f,0xbd,0x15,0x71,0x71,0xdd,0xb6,0xcc,0xf4,0xa4,0xbc,0xce,0xe4, /* @0....qq........ */ \
	0xd0,0x89,0xc6,0x27,0xad,0x55,0xb8,0x8e,0xa7,0x8d,0xe3,0x65,0x01,0x30,0xa6,0xc0, /* ...'.U.....e.0.. */ \
	0x18,0xc0,0xdb,0x2f,0xcc,0x95,0xb3,0x5b,0x80,0x51,0xce,0x62,0xe3,0xce,0x41,0x05, /* .../...[.Q.b..A. */ \
	0x36,0x36,0xd5,0xc8,0x2c,0xc2,0xee,0x70,0x58,0x97,0x59,0x91,0xde,0x9f,0x36,0xbb, /* 66..,..pX.Y...6. */ \
	0x11,0x09,0x96,0x3a,0xe6,0xd1,0x19,0x41,0x80,0x88,0x9b,0xd2,0xe0,0x3c,0x1e,0xc7, /* ...:...A.....<.. */ \
	0x03,0x86,0x45,0x3b,0x7d,0x35,0x0b,0xf7,0x63,0x5d,0xa5,0xd8,0xa0,0x82,0x25,0xd7, /* ..E;}5..c]....%. */ \
	0x09,0xeb,0x2f,0xd9,0x5d,0x2d,0x0c,0x1a,0xbf,0xd9,0x12,0xd7,0xc3,0x14,0x29,0x59, /* ../.]-........)Y */ \
	0x5b,0xbb,0xb6,0x1d,0x03,0x36,0xe5,0x97,0xea,0x32,0xc8,0x86,0xfa,0x39,0xac,0xf6, /* [....6...2...9.. */ \
	0xee,0xa2,0x14,0x83,0xdd,0x51,0x1f,0x0d,0x56,0xc8,0xda,0x6a,0xcf,0x3a,0xcd,0x90, /* .....Q..V..j.:.. */ \
	0x9e,0xcd,0x4a,0x3a,0xd4,0xdd,0xf4,0xc5,0x4c,0x5d,0xba,0x01,0xdf,0x19,0x7f,0xac, /* ..J:....L]...... */ \
	0x7f,0xa6,0xb1,0x33,0xab,0x7a,0x99,0x3d,0x16,0x6e,0xf1,0x2e,0x33,0x62,0x83,0x58, /* ...3.z.=.n..3b.X */ \
	0x1d,0x34,0x5e,0x1c,0x7e,0x73,0x44,0x0b,0x8d,0xe0,0x7e,0x59,0x01,0x33,0x82,0x2b, /* .4^.~sD...~Y.3.+ */ \
	0x57,0x37,0x5b,0x73,0xbc,0xe5,0xea,0x86,0xf6,0x5d,0xe9,0x21,0x22,0x2c,0xcb,0x20, /* W7[s.....].!",.  */ \
	0xae,0xe7,0x63,0xce,0x61,0xd8,0xc1,0x1b,0x2d,0xe3,0x1b,0x1b,0x56,0xa2,0xd3,0x75, /* ..c.a...-...V..u */ \
	0x36,0x80,0xcc,0x9b,0x10,0xa4,0x29,0xea,0x07,0xa9,0x8f,0xfd,0xba,0x78,0xf2,0x4b, /* 6.....)......x.K */ \
	0x76,0x20,0xd5,0x49,0xae,0xd8,0x00,0x74,0xcc,0x83,0xdd,0x76,0xe9,0x22,0x6e,0x9a, /* v .I...t...v."n. */ \
	0x68,0xbe,0xb5,0xd0,0x2a,0xd5,0x8d,0x1f,0x32,0x85,0x21,0x8e,0xc3,0x8e,0xa7,0x0d, /* h.......2.!..... */ \
	0xbb,0x4a,0xb9,0x1c,0x35,0x57,0x2e,0xa9,0xbd,0xce,0xd9,0x1e,0xdf,0xc1,0xf3,0x4b, /* .J..5W.........K */ \
	0xf5,0xce,0x33,0xd8,0x1d,0x1f,0x69,0x1d,0xe1,0x04,0x1f,0x13,0x7b,0x58,0xb3,0x4e, /* ..3...i.....{X.N */ \
	0xfc,0xdc,0x5e,0xed,0x2f,0xf7,0x3e,0xf3,0xe7,0xae,0xc1,0xe9,0x70,0xc3,0x8c,0x80, /* ..^./.>.....p... */ \
	0x27,0xe2,0x6a,0xf9,0x25,0x21,0x14,0xf6,0xc2,0xd7,0x6f,0xe8,0xcf,0x1a,0x63,0x10, /* '.j.%!....o...c. */ \
	0x77,0x7e,0x7c,0xca,0x99,0xad,0xee,0x53,0xb0,0xb1,0xa5,0x5d,0xf3,0x6c,0x7f,0x3d, /* w~|....S...].l.= */ \
	0x18,0x6b,0x7a,0xcb,0x67,0x4d,0x72,0xc1,0xd7,0x4c,0x10,0xe6,0x70,0xa2,0xf3,0x69, /* .kz.gMr..L..p..i */ \
	0xe5,0x67,0x61,0xed,0xd7,0x47,0xc0,0xf6,0x83,0x6a,0xeb,0xd7,0x82,0x00,0x09,0x99, /* .ga..G...j...... */ \
	0x7f,0x9b,0x33,0x2e,0x2c,0x59,0xd9,0xc0,0x1d,0xf7,0xc1,0xa4,0xbe,0x9a,0x89,0x59, /* ..3.,Y.........Y */ \
	0x6d,0x27,0x5c,0xe0,0xfd,0x5d,0xcb,0xa1,0xad,0x89,0x59,0xb3,0xe4,0x86,0x63,0xc1, /* m'\..]....Y...c. */ \
	0xd8,0x60,0xe4,0x87,0x97,0x9a,0x0d,0x9b,0xaa,0xc5,0x53,0xcd,0xac,0x6e,0x0b,0xa0, /* .`........S..n.. */ \
	0xc0,0xac,0xbf,0x13,0xd4,0xcf,0xae,0x4b,0xbd,0x58,0xd7,0xd2,0xde,0x39,0xeb,0x04, /* .......K.X...9.. */ \
	0xce,0x67,0xea,0xce,0x9e,0xae,0x36,0xf5,0x32,0xbf,0xef,0xb5,0x90,0xac,0x3d,0xe2, /* .g....6.2.....=. */ \
	0xb6,0x5c,0xc3,0x2e,0xa8,0xee,0xbc,0xe2,0x04,0xf2,0x75,0x4c,0x27,0x6e,0x6d,0x27, /* .\........uL'nm' */ \
	0x00,0x0e,0x63,0xc1,0x93,0x3e,0x2c,0xef,0xc7,0x82,0xff,0xfc,0xf9,0x19,0x76,0x8a, /* ..c..>,.......v. */ \
	0xa7,0x2a,0x61,0x65,0xba,0x71,0x15,0xda,0x35,0x6f,0x75,0xd5,0x64,0x04,0x6f,0xb7, /* ..ae.q..5ou.d.o. */ \
	0xae,0xf6,0xaf,0x8a,0x0f,0xe5,0xc6,0xa6,0x31,0x05,0x2b,0x05,0x38,0x8c,0xa6,0xfa, /* ........1.+.8... */ \
	0x6b,0x0d,0x16,0xde,0x23,0x27,0xe7,0x5e,0x57,0x6d,0x75,0x4b,0x5d,0xea,0xc6,0x0d, /* k...#'.^WmuK]... */ \
	0x14,0xb7,0xff,0xb5,0x1c,0xb3,0x7e,0xb6,0x83,0x35,0x87,0x35,0x0b,0xdf,0xfd,0x93, /* ......~..5.5.... */ \
	0x43,0x2e,0x73,0xc3,0x96,0x36,0x90,0xe2,0xee,0xd6,0x31,0x75,0xc3,0xdc,0x96,0xfa, /* C.s..6....1u.... */ \
	0xea,0x2e,0xe7,0xb4,0x09,0x50,0x28,0xdc,0x33,0x96,0xbe,0xf2,0xd8,0x6e,0xff,0xd3, /* .....P(.3....n.. */ \
	0xd3,0x5d,0xcc,0x39,0xcd,0x44,0x1c,0x4f,0x3e,0xb1,0xc9,0x58,0x54,0xaf,0x35,0xb5, /* .].9.D.O>..XT.5. */ \
	0x1d,0xbd,0xf4,0x89,0xf3,0xee,0xa4,0xc9,0x62,0xd7,0xaa,0x2a,0xcc,0x2f,0xb5,0x7a, /* ........b..../.z */ \
	0x73,0xc9,0xfc,0x4f,0x66,0xc4,0xf9,0xc5,0x8b,0x07,0x28,0xd6,0x51,0x78,0xf6,0xef, /* s..Of.....(.Qx.. */ \
	0x37,0x67,0x81,0x8b,0x81,0xb9,0xc2,0xc0,0x4e,0x31,0x60,0x1f,0x18,0x36,0x0a,0xf9, /* 7g......N1`..6.. */ \
	0x60,0xc5,0xff,0x02,0xd3,0x22,0xc0,0x8b,0xdf,0x10,0x00,0x00,0x89,0x50,0x4e,0x47, /* `....".......PNG */ \
	0x0d,0x0a,0x1a,0x0a,0x00,0x00,0x00,0x0d,0x49,0x48,0x44,0x52,0x00,0x00,0x00,0x13, /* ........IHDR.... */ \
	0x00,0x00,0x00,0x0f,0x08,0x03,0x00,0x00,0x00,0x31,0x9a,0x04,0x1e,0x00,0x00,0x00, /* .........1...... */ \
	0x19,0x74,0x45,0x58,0x74,0x53,0x6f,0x66,0x74,0x77,0x61,0x72,0x65,0x00,0x41,0x64, /* .tEXtSoftware.Ad */ \
	0x6f,0x62,0x65,0x20,0x49,0x6d,0x61,0x67,0x65,0x52,0x65,0x61,0x64,0x79,0x71,0xc9, /* obe ImageReadyq. */ \
	0x65,0x3c,0x00,0x00,0x00,0x39,0x50,0x4c,0x54,0x45,0x81,0x81,0x81,0x5c,0x5c,0x5c, /* e<...9PLTE...\\\ */ \
	0x8b,0x8b,0x8b,0xc5,0xc5,0xc5,0xbc,0xbc,0xbc,0x77,0x77,0x77,0x5e,0x5e,0x5e,0x78, /* .........www^^^x */ \
	0x78,0x78,0xb8,0xb8,0xb8,0xc6,0xc6,0xc6,0xb7,0xb7,0xb7,0xb5,0xb5,0xb5,0x8a,0x8a, /* xx.............. */ \
	0x8a,0x60,0x60,0x60,0xfd,0xfd,0xfd,0xfb,0xfb,0xfb,0x5d,0x5d,0x5d,0xfc,0xfc,0xfc, /* .```......]]]... */ \
	0xff,0xff,0xff,0x81,0x07,0x29,0x88,0x00,0x00,0x00,0x6e,0x49,0x44,0x41,0x54,0x78, /* .....)....nIDATx */ \
	0xda,0x7c,0x90,0x0b,0x0e,0x80,0x20,0x0c,0x43,0xc7,0x4f,0xfc,0x6f,0xf3,0xfe,0x87, /* .|.... .C.O.o... */ \
	0xb5,0x10,0x74,0x18,0x8d,0x4d,0x08,0xe4,0xa5,0x1d,0xdb,0xe8,0x78,0x8b,0x70,0x94, /* ..t..M......x.p. */ \
	0x55,0x75,0x87,0x70,0x69,0x63,0x05,0x4d,0x79,0xcb,0xe1,0xc1,0x38,0x88,0x5f,0xbc, /* Uu.pic.My...8._. */ \
	0x04,0x24,0x8c,0xa5,0x15,0x51,0x9f,0xcc,0x87,0xd7,0x30,0x83,0x8d,0x03,0x5b,0x96, /* .$...Q....0...[. */ \
	0x55,0x22,0x58,0x14,0xee,0x7c,0x24,0x55,0x8e,0x94,0xef,0x7a,0x4e,0x9a,0x3a,0x9f, /* U"X..|$U...zN.:. */ \
	0xfc,0x32,0xcb,0x7e,0xf9,0xca,0x1f,0xa5,0x26,0xf5,0xfd,0x61,0x00,0x8c,0xcb,0x7d, /* .2.~....&..a...} */ \
	0xcf,0x75,0x09,0x7a,0xed,0xe0,0x14,0x60,0x00,0x27,0x9e,0x11,0x7d,0x9d,0xca,0x9f, /* .u.z...`.'..}... */ \
	0xc1,0x00,0x00,0x00,0x00,0x49,0x45,0x4e,0x44,0xae,0x42,0x60,0x82,0x1f,0x8b,0x08, /* .....IEND.B`.... */ \
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xad,0x8f,0xf9,0x4f,0x93,0x07,0x00,0x40,0xbf, /* ..........O...@. */ \
	0x1e,0x94,0x72,0x14,0x5a,0xb4,0xd0,0x72,0xd9,0x53,0x59,0x45,0x43,0x98,0x28,0xe0, /* ..r.Z..r.SYEC.(. */ \
	0xd5,0xd2,0xd2,0x43,0x18,0xf9,0xc8,0x40,0x04,0x06,0x16,0x42,0x8b,0x32,0xc0,0x82, /* ...C...@...B.2.. */ \
	0x58,0x04,0xa7,0x2d,0x50,0x11,0xb9,0x2a,0x47,0x05,0x0a,0x52,0x50,0xca,0x74,0x14, /* X..-P...G..RP.t. */ \
	0x8b,0x12,0x04,0x65,0x0a,0xca,0xa1,0x96,0xab,0xae,0x20,0x90,0x62,0x00,0x15,0x5c, /* ...e...... .b..\ */ \
	0x16,0xae,0xb9,0x45,0xdd,0x70,0xfd,0x16,0xb3,0x7f,0x61,0xef,0x87,0x97,0xbc,0x1f, /* ...E.p....a..... */ \
	0x1f,0x4f,0xc0,0xf5,0x0f,0x48,0xa8,0x05,0x18,0xc0,0x14,0x0d,0x90,0xc9,0x64,0x7d, /* .O...H........d} */ \
	0x7d,0x7d,0x16,0xac,0x1b,0xb4,0xbe,0x01,0x4d,0xbc,0x58,0x5f,0x5f,0x97,0x48,0x24, /* }}......M.X__.H$ */ \
	0x13,0x13,0x13,0xd0,0xfc,0x22,0x16,0x8b,0xb5,0x90,0x18,0x16,0x9f,0x40,0x8d,0x46, /* .....".......@.F */ \
	0x03,0x82,0xa0,0x85,0x29,0x10,0x0a,0x85,0x24,0x12,0x49,0xa9,0x54,0xce,0xcf,0xcf, /* ....)...$.I.T... */ \
	0x43,0xf2,0x42,0xbd,0x5e,0xef,0xe3,0xe3,0x63,0x91,0x5d,0x84,0x34,0x2d,0x50,0xdf, /* C.B.^...c.].4-P. */ \
	0x13,0x0b,0x78,0xcc,0x22,0x91,0x5a,0x84,0xc9,0x90,0xb2,0x1a,0x52,0xaa,0x20,0x7d, /* ..x.".Z.....R. } */ \
	0xa7,0x45,0x92,0xcd,0x64,0x32,0x2d,0x80,0x3d,0x04,0x41,0x00,0x00,0xfc,0xe7,0xff, /* .E..d2-.=.A..... */ \
	0x17,0xf2,0x5f,0x48,0x18,0x00,0xd0,0x00,0xef,0x2f,0xf1,0xe5,0x09,0x40,0x41,0xcc, /* .._H...../...@A. */ \
	0x4a,0x09,0xdf,0xdb,0x55,0xf9,0xac,0x25,0xf3,0x79,0x6a,0xa0,0xc6,0x78,0x33,0xeb, /* J...U..%.yj..x3. */ \
	0x48,0x7b,0x8c,0x7e,0x46,0x27,0x1d,0x59,0xcd,0xbd,0x84,0x2c,0x61,0x63,0x19,0x35, /* H{.~F'.Y...,ac.5 */ \
	0x56,0x0e,0x0e,0xaf,0x47,0xd2,0x7b,0xcb,0x10,0x25,0x4f,0x42,0xf5,0x97,0xdc,0x91, /* V...G.{..%OB.... */ \
	0x64,0x20,0xf1,0xec,0x26,0x14,0xe1,0x9c,0x24,0x55,0x88,0x6c,0x11,0x34,0x94,0x0d, /* d ..&...$U.l.4.. */ \
	0x46,0x5e,0x56,0x2e,0x40,0xdb,0x5d,0xac,0x12,0x39,0xd3,0x30,0x78,0x92,0xb2,0xbe, /* F^V.@.]..9.0x... */ \
	0x1e,0x59,0x50,0x5d,0x95,0x03,0xb3,0x6a,0xd0,0xca,0x1a,0x9b,0x9a,0xec,0x5a,0x75, /* .YP]...j......Zu */ \
	0xa7,0x6e,0xde,0x6a,0x72,0xff,0xc6,0x8a,0x44,0x25,0x59,0xf3,0xac,0x30,0xf7,0x5a, /* .n.jr...D%Y..0.Z */ \
	0xda,0x75,0x88,0xd3,0x52,0x17,0x8a,0x5b,0x95,0x1d,0x5a,0x0f,0xff,0x3e,0x04,0x47, /* .u..R..[..Z..>.G */ \
	0x1d,0x57,0x73,0x1d,0xc7,0xa9,0xe7,0x1f,0xb5,0x6e,0x53,0x6c,0xa1,0x98,0x2b,0xa5, /* .Ws......nSl..+. */ \
	0x06,0x33,0x41,0xec,0x10,0x8a,0x32,0x51,0x9d,0x82,0xad,0x96,0x8d,0x2f,0xeb,0xd1, /* .3A...2Q...../.. */ \
	0x0a,0x3b,0xb3,0x19,0xa9,0x18,0x78,0x4f,0x14,0x7b,0x86,0x74,0x99,0xa6,0xd8,0x63, /* .;....xO.{.t...c */ \
	0xa6,0x99,0xae,0xd3,0x11,0xba,0xf1,0x7d,0x39,0x94,0xed,0x93,0xcf,0xe5,0xe0,0xa0, /* .......}9....... */ \
	0x9c,0x05,0xc7,0xd2,0x17,0xdf,0x79,0xb3,0x70,0xe8,0x65,0x2e,0x3a,0x00,0xb8,0xfe, /* ......y.p.e.:... */ \
	0xa6,0xaf,0x9c,0xc4,0x3a,0x44,0xc2,0xdf,0x4d,0x42,0xa0,0xd8,0xb6,0x04,0xaf,0xd9, /* ....:D..MB...... */ \
	0x3b,0x2c,0x79,0xf5,0xce,0xe8,0xfc,0x22,0x66,0x3e,0x15,0x2d,0x0b,0x22,0x64,0x71, /* ;,y...."f>.-."dq */ \
	0x88,0x5b,0xb4,0xa3,0x50,0xb9,0xa3,0xd7,0x15,0x02,0xa8,0x6f,0x1e,0x10,0x92,0x29, /* .[..P......o...) */ \
	0xae,0x0f,0x85,0xe2,0x82,0xca,0x52,0x2a,0x68,0x6b,0x03,0x9c,0xf9,0x6d,0x0f,0xb9, /* ......R.hk...m.. */ \
	0xb7,0x29,0x8c,0x7d,0x6b,0xca,0xdd,0x00,0xc7,0x3f,0x08,0x3c,0x17,0x0d,0xdc,0x98, /* .).}k....?.<.... */ \
	0x81,0x47,0xa4,0xe1,0x61,0x0b,0xf6,0x80,0xcd,0x85,0xf4,0xa1,0xc0,0x1b,0xfd,0x93, /* .G..a........... */ \
	0x4d,0xe1,0x12,0x71,0xe0,0x1c,0x7e,0xb1,0xdf,0xbe,0x90,0x06,0xce,0x0a,0x46,0x8a, /* M..q..~.......F. */ \
	0x76,0xb6,0x73,0x6d,0x32,0x79,0x83,0xaa,0xb6,0xcb,0xac,0x44,0x6e,0xf9,0x12,0x8a, /* v.sm2y.....Dn... */ \
	0xbf,0xf3,0x0a,0x32,0x76,0xe8,0x94,0xb9,0x92,0x6f,0x0f,0xd3,0x78,0xa4,0x65,0xdb, /* ...2v....o..x.e. */ \
	0x31,0xfc,0x8a,0x85,0xc6,0x66,0xaa,0x75,0x2b,0xbd,0xb6,0x30,0xec,0xda,0xd7,0x9d, /* 1....f.u+..0.... */ \
	0xd4,0x78,0xd7,0xed,0x2c,0xf2,0xef,0x89,0xb1,0xe4,0xc8,0xd8,0xa3,0x18,0xdf,0x95, /* .x..,........... */ \
	0xa9,0xc7,0x89,0x3b,0x0e,0xc7,0xb6,0x11,0xd7,0x96,0x93,0xef,0xff,0x48,0x6e,0x67, /* ...;.........Hng */ \
	0x2f,0xac,0x0d,0xf8,0xda,0xaf,0x33,0x74,0x59,0x83,0x3e,0xcc,0x14,0xda,0xed,0xe3, /* /.....3tY.>..... */ \
	0x2e,0x81,0x9b,0x99,0xf0,0x2c,0xfe,0x6d,0x27,0xd6,0x8a,0x77,0x67,0x0c,0x65,0x7a, /* .....,.m'..wg.ez */ \
	0xac,0xe0,0x57,0x91,0xc2,0x37,0x63,0x74,0x78,0xc8,0x91,0x7c,0xf8,0xfa,0xb8,0xe2, /* ..W..7ctx..|.... */ \
	0x51,0xf6,0x87,0xdc,0x8d,0xde,0xee,0xd8,0xa2,0x03,0xc1,0x93,0x47,0x1b,0xa3,0x9d, /* Q...........G... */ \
	0x1f,0xa3,0xae,0x8a,0x5f,0x61,0xac,0x8f,0xe5,0x04,0x7f,0x27,0x9a,0x3b,0xeb,0x90, /* ...._a.....'.;.. */ \
	0x52,0xa8,0x48,0x88,0xbb,0x8f,0xdf,0x56,0xc0,0x09,0x65,0xf3,0x0e,0x68,0x55,0xcd, /* R.H....V..e..hU. */ \
	0xd0,0x74,0xdc,0x27,0x8f,0x4c,0x97,0x83,0x22,0xdd,0xfb,0x46,0xee,0x92,0x3f,0x62, /* .t.'.L.."..F..?b */ \
	0x0e,0xb1,0x7c,0x5f,0xb5,0x90,0xb3,0x58,0xe6,0x37,0x9b,0x04,0x44,0x1a,0xaf,0xe3, /* ..|_...X.7..D... */ \
	0x70,0x89,0x7b,0x9b,0xd3,0xf6,0x19,0xba,0x2b,0x0a,0x93,0x49,0x1d,0x63,0x59,0xd6, /* p.{.....+..I.cY. */ \
	0x7e,0x93,0x09,0x68,0xd7,0x15,0x6d,0x1e,0xf1,0x2e,0x36,0x83,0x88,0xa4,0x19,0x93, /* ~..h..m...6..... */ \
	0xcb,0xc1,0xcf,0x27,0xde,0x27,0x8a,0x30,0x86,0xa1,0xd7,0x05,0xc4,0xab,0x4f,0x45, /* ...'.'.0......OE */ \
	0xe7,0x0e,0xc4,0x7b,0xd5,0x10,0x3f,0x48,0x10,0xaf,0xe2,0x3d,0x6a,0x5f,0x34,0x84, /* ...{..?H...=j_4. */ \
	0xf7,0x23,0x05,0x1c,0x55,0x10,0xf8,0xa7,0x1a,0xfb,0x55,0x4c,0xce,0x94,0xe8,0x98, /* .#..U.....UL.... */ \
	0x74,0x76,0x2a,0x7b,0x9f,0xd3,0xa2,0x9a,0x7b,0xdc,0xb9,0xe2,0x28,0x9c,0x5e,0x27, /* tv.{....{...(.^' */ \
	0x6a,0x16,0x5f,0x8e,0x04,0x87,0x51,0x98,0x0a,0x42,0xbe,0xf5,0x3f,0xaa,0x9e,0x28, /* j._...Q..B..?..( */ \
	0x7f,0xd1,0x67,0x3f,0x64,0x03,0x8d,0xb3,0xb7,0x2c,0xb6,0xb7,0x4c,0xf8,0xa2,0x04, /* ..g?d....,..L... */ \
	0xdc,0xed,0xf5,0xf2,0x2a,0x03,0x55,0x4b,0x2d,0xd9,0xff,0xe4,0x26,0x2f,0xa3,0xc8, /* ......UK-...&/.. */ \
	0x10,0x9c,0x07,0xa7,0xec,0xe5,0xbc,0x05,0xa8,0x6a,0x98,0x3a,0xbc,0x51,0x40,0x1b, /* .........j.:.Q@. */ \
	0x4c,0x99,0xa9,0x00,0x01,0xfd,0xb8,0x3c,0xbb,0x8e,0xdb,0x79,0x52,0x6d,0x13,0x72, /* L......<...yRm.r */ \
	0x3e,0xd5,0xb6,0xff,0x2e,0x90,0xa4,0x15,0x14,0x53,0xdd,0xcd,0xb8,0x8e,0x1a,0x24, /* >........S.....$ */ \
	0xcd,0x04,0x5b,0x0b,0x78,0xce,0x10,0x1b,0x7c,0x7b,0x57,0x42,0x88,0xba,0x93,0x2d, /* ..[.x...|{WB...- */ \
	0x44,0xc1,0x11,0x97,0x96,0xd3,0x70,0xaf,0x2b,0x90,0xb6,0x9c,0x06,0x3c,0xe5,0x87, /* D.....p.+....<.. */ \
	0x99,0x9a,0xce,0x44,0xa6,0x64,0xd2,0x4b,0x9a,0x23,0x53,0xe2,0xa6,0x55,0xdb,0xff, /* ...D.d.K.#S..U.. */ \
	0x4e,0xa1,0x37,0xfc,0x74,0xcd,0xd3,0xb0,0xfa,0x30,0xd8,0x98,0x1b,0xa5,0xfe,0x7c, /* N.7.t....0.....| */ \
	0x87,0x58,0x8a,0x38,0x17,0x27,0xc9,0xd3,0xd4,0xb7,0x6e,0x75,0x46,0xf6,0x2c,0xb8, /* .X.8.'....nuF.,. */ \
	0x99,0x53,0x97,0x23,0xcf,0x36,0x70,0x39,0x3d,0x1f,0xdb,0xda,0xc2,0xe1,0x6d,0xf8, /* .S.#.6p9=.....m. */ \
	0x7b,0xb6,0x0e,0x19,0x75,0xfd,0xdd,0xf4,0x3b,0xd3,0x15,0x85,0xa5,0x9f,0x04,0x75, /* {...u...;......u */ \
	0x5c,0x5c,0x82,0x69,0x57,0xc8,0xe8,0x0f,0xfd,0xa3,0x41,0x5b,0x37,0xe4,0xcf,0x4c, /* \\.iW.....A[7..L */ \
	0x7b,0x98,0x95,0x3c,0xdf,0xec,0x88,0x31,0x58,0xb4,0x28,0x22,0x0f,0x74,0xc3,0xa7, /* {..<...1X.(".t.. */ \
	0x85,0xc1,0xcf,0xcf,0x28,0xbe,0x6d,0xdd,0x4f,0x77,0xf2,0xe3,0x1f,0x99,0x5b,0xd2, /* ....(.m.Ow....[. */ \
	0xb4,0x73,0xe3,0x0e,0xc6,0xb0,0x11,0x67,0x56,0x15,0xe1,0x21,0x4e,0x94,0xf4,0x20, /* .s.....gV..!N..  */ \
	0x29,0xe7,0x69,0xd7,0xf4,0x89,0xa8,0x5d,0x8e,0xda,0x8d,0x67,0x6f,0x4e,0x78,0x10, /* ).i....]...goNx. */ \
	0x1a,0xae,0x7d,0x98,0xe3,0xa5,0xfe,0x31,0x47,0xcb,0xed,0x12,0xf0,0x75,0x14,0xe3, /* ..}....1G....u.. */ \
	0x6a,0x37,0xce,0xbc,0xc0,0xbb,0x8c,0x8a,0x32,0x87,0xa7,0xcf,0xcb,0x76,0xec,0x46, /* j7......2....v.F */ \
	0x8e,0x74,0x28,0xf2,0x7b,0x5e,0x17,0xf7,0xfd,0xe2,0x4f,0x86,0x03,0xe8,0x80,0xb7, /* .t(.{^....O..... */ \
	0x15,0xa1,0xe9,0x97,0x10,0x0f,0xe2,0x2f,0x04,0x58,0x6b,0xf6,0xec,0x66,0x56,0x35, /* ......./.Xk..fV5 */ \
	0xd6,0x1c,0xaa,0x76,0xef,0xf0,0x12,0xb2,0xde,0xb5,0xd6,0x7b,0x0e,0x13,0x50,0x01, /* ...v.......{..P. */ \
	0xc2,0xbc,0xa5,0xf6,0xe9,0x74,0xfb,0xcd,0xd5,0x9e,0x77,0xb7,0x37,0xd7,0x7e,0xfe, /* .....t....w.7.~. */ \
	0xe8,0x19,0x8c,0x05,0xf6,0xff,0x0b,0xa6,0x2b,0xee,0xb4,0xef,0x04,0x00,0x00       /* ........+......  */


};
<#elseif CONFIG_DRV_WIFI_HTTP_CUSTOM_TEMPLATE == "Wi-Fi G Demo">
const uint8_t __attribute__((space(prog),address(DRV_NVM_MEDIA_START_ADDRESS))) NVM_MEDIA_DATA[DRV_NVM_MEDIA_SIZE*1024] = { \
	0x4d,0x50,0x46,0x53,0x02,0x01,0x18,0x00,0x6a,0xfd,0xf0,0x94,0xca,0xa7,0x92,0x6c, /* MPFS....j......l */ \
	0xf0,0xd6,0x26,0x4f,0x26,0x2d,0x0a,0xa3,0x46,0xce,0x2a,0xcf,0x3e,0x67,0x6a,0x7b, /* ..&O&-..F...>gj{ */ \
	0x8a,0x10,0xe6,0xd2,0xcc,0x83,0x46,0xbc,0x66,0xbc,0x86,0xbc,0xa6,0xbc,0x46,0xd6, /* ......F.f.....F. */ \
	0x46,0x7a,0xa8,0x8f,0x86,0x74,0x08,0x71,0x48,0x02,0x00,0x00,0x8a,0x03,0x00,0x00, /* Fz...t.qH....... */ \
	0x5e,0x04,0x00,0x00,0xdf,0xe7,0x1f,0x56,0x00,0x00,0x00,0x00,0x02,0x00,0x56,0x02, /* ^......V......V. */ \
	0x00,0x00,0xe8,0x07,0x00,0x00,0x32,0x01,0x00,0x00,0x62,0x21,0x4d,0x56,0x00,0x00, /* ......2...b!MV.. */ \
	0x00,0x00,0x00,0x00,0x62,0x02,0x00,0x00,0x1a,0x09,0x00,0x00,0xfd,0x00,0x00,0x00, /* ....b........... */ \
	0xde,0xe7,0x1f,0x56,0x00,0x00,0x00,0x00,0x01,0x00,0x6c,0x02,0x00,0x00,0x17,0x0a, /* ...V......l..... */ \
	0x00,0x00,0x8d,0x0e,0x00,0x00,0xde,0xe7,0x1f,0x56,0x00,0x00,0x00,0x00,0x01,0x00, /* .........V...... */ \
	0x78,0x02,0x00,0x00,0xa4,0x18,0x00,0x00,0x4a,0x00,0x00,0x00,0x62,0x21,0x4d,0x56, /* x.......J...b!MV */ \
	0x00,0x00,0x00,0x00,0x00,0x00,0x85,0x02,0x00,0x00,0xee,0x18,0x00,0x00,0xa1,0x00, /* ................ */ \
	0x00,0x00,0xdf,0xe7,0x1f,0x56,0x00,0x00,0x00,0x00,0x00,0x00,0x90,0x02,0x00,0x00, /* .....V.......... */ \
	0x8f,0x19,0x00,0x00,0xc4,0x03,0x00,0x00,0xde,0xe7,0x1f,0x56,0x00,0x00,0x00,0x00, /* ...........V.... */ \
	0x00,0x00,0x9b,0x02,0x00,0x00,0x53,0x1d,0x00,0x00,0xe9,0x0c,0x00,0x00,0xde,0xe7, /* ......S......... */ \
	0x1f,0x56,0x00,0x00,0x00,0x00,0x02,0x00,0xa5,0x02,0x00,0x00,0x3c,0x2a,0x00,0x00, /* .V..........<... */ \
	0x11,0x00,0x00,0x00,0xde,0xe7,0x1f,0x56,0x00,0x00,0x00,0x00,0x02,0x00,0xae,0x02, /* .......V........ */ \
	0x00,0x00,0x4d,0x2a,0x00,0x00,0xb3,0x03,0x00,0x00,0xdf,0xe7,0x1f,0x56,0x00,0x00, /* ..M..........V.. */ \
	0x00,0x00,0x01,0x00,0xb7,0x02,0x00,0x00,0x00,0x2e,0x00,0x00,0x36,0x19,0x00,0x00, /* ............6... */ \
	0xd0,0x3a,0x49,0x56,0x00,0x00,0x00,0x00,0x01,0x00,0xbf,0x02,0x00,0x00,0x36,0x47, /* .:IV..........6G */ \
	0x00,0x00,0xd0,0x1a,0x00,0x00,0xb4,0x20,0x4d,0x56,0x00,0x00,0x00,0x00,0x02,0x00, /* ....... MV...... */ \
	0xcb,0x02,0x00,0x00,0x06,0x62,0x00,0x00,0x75,0x02,0x00,0x00,0xdf,0xe7,0x1f,0x56, /* .....b..u......V */ \
	0x00,0x00,0x00,0x00,0x02,0x00,0xd9,0x02,0x00,0x00,0x7b,0x64,0x00,0x00,0x0f,0x00, /* ..........{d.... */ \
	0x00,0x00,0xde,0xe7,0x1f,0x56,0x00,0x00,0x00,0x00,0x02,0x00,0xe2,0x02,0x00,0x00, /* .....V.......... */ \
	0x8a,0x64,0x00,0x00,0x91,0x01,0x00,0x00,0xde,0xe7,0x1f,0x56,0x00,0x00,0x00,0x00, /* .d.........V.... */ \
	0x02,0x00,0xed,0x02,0x00,0x00,0x1b,0x66,0x00,0x00,0x9e,0x01,0x00,0x00,0xde,0xe7, /* .......f........ */ \
	0x1f,0x56,0x00,0x00,0x00,0x00,0x00,0x00,0xfe,0x02,0x00,0x00,0xb9,0x67,0x00,0x00, /* .V...........g.. */ \
	0xff,0x01,0x00,0x00,0xde,0xe7,0x1f,0x56,0x00,0x00,0x00,0x00,0x00,0x00,0x0f,0x03, /* .......V........ */ \
	0x00,0x00,0xb8,0x69,0x00,0x00,0xfe,0x01,0x00,0x00,0xde,0xe7,0x1f,0x56,0x00,0x00, /* ...i.........V.. */ \
	0x00,0x00,0x00,0x00,0x20,0x03,0x00,0x00,0xb6,0x6b,0x00,0x00,0x35,0x02,0x00,0x00, /* .... ....k..5... */ \
	0xde,0xe7,0x1f,0x56,0x00,0x00,0x00,0x00,0x00,0x00,0x31,0x03,0x00,0x00,0xeb,0x6d, /* ...V......1....m */ \
	0x00,0x00,0x80,0x00,0x00,0x00,0xde,0xe7,0x1f,0x56,0x00,0x00,0x00,0x00,0x00,0x00, /* .........V...... */ \
	0x42,0x03,0x00,0x00,0x6b,0x6e,0x00,0x00,0x2e,0x01,0x00,0x00,0xde,0xe7,0x1f,0x56, /* B...kn.........V */ \
	0x00,0x00,0x00,0x00,0x00,0x00,0x57,0x03,0x00,0x00,0x99,0x6f,0x00,0x00,0x3d,0x10, /* ......W....o..=. */ \
	0x00,0x00,0xde,0xe7,0x1f,0x56,0x00,0x00,0x00,0x00,0x01,0x00,0x6a,0x03,0x00,0x00, /* .....V......j... */ \
	0xd6,0x7f,0x00,0x00,0x11,0x01,0x00,0x00,0xde,0xe7,0x1f,0x56,0x00,0x00,0x00,0x00, /* ...........V.... */ \
	0x00,0x00,0x7a,0x03,0x00,0x00,0xe7,0x80,0x00,0x00,0xe2,0x04,0x00,0x00,0xdf,0xe7, /* ..z............. */ \
	0x1f,0x56,0x00,0x00,0x00,0x00,0x01,0x00,0x63,0x6f,0x6e,0x66,0x69,0x67,0x75,0x72, /* .V......configur */ \
	0x65,0x2e,0x68,0x74,0x6d,0x00,0x44,0x79,0x6e,0x52,0x63,0x72,0x64,0x2e,0x62,0x69, /* e.htm.DynRcrd.bi */ \
	0x6e,0x00,0x65,0x72,0x72,0x6f,0x72,0x2e,0x68,0x74,0x6d,0x00,0x66,0x61,0x76,0x69, /* n.error.htm.favi */ \
	0x63,0x6f,0x6e,0x2e,0x69,0x63,0x6f,0x00,0x46,0x69,0x6c,0x65,0x52,0x63,0x72,0x64, /* con.ico.FileRcrd */ \
	0x2e,0x62,0x69,0x6e,0x00,0x66,0x6f,0x6f,0x74,0x65,0x72,0x2e,0x69,0x6e,0x63,0x00, /* .bin.footer.inc. */ \
	0x68,0x65,0x61,0x64,0x65,0x72,0x2e,0x69,0x6e,0x63,0x00,0x69,0x6e,0x64,0x65,0x78, /* header.inc.index */ \
	0x2e,0x68,0x74,0x6d,0x00,0x6c,0x65,0x64,0x73,0x2e,0x63,0x67,0x69,0x00,0x6d,0x63, /* .htm.leds.cgi.mc */ \
	0x68,0x70,0x2e,0x63,0x73,0x73,0x00,0x6d,0x63,0x68,0x70,0x2e,0x6a,0x73,0x00,0x6d, /* hp.css.mchp.js.m */ \
	0x72,0x66,0x32,0x34,0x77,0x67,0x2e,0x68,0x74,0x6d,0x00,0x72,0x65,0x63,0x6f,0x6e, /* rf24wg.htm.recon */ \
	0x6e,0x65,0x63,0x74,0x2e,0x68,0x74,0x6d,0x00,0x73,0x63,0x61,0x6e,0x2e,0x63,0x67, /* nect.htm.scan.cg */ \
	0x69,0x00,0x73,0x74,0x61,0x74,0x75,0x73,0x2e,0x78,0x6d,0x6c,0x00,0x69,0x6d,0x61, /* i.status.xml.ima */ \
	0x67,0x65,0x73,0x2f,0x62,0x61,0x72,0x2d,0x31,0x2e,0x70,0x6e,0x67,0x00,0x69,0x6d, /* ges/bar-1.png.im */ \
	0x61,0x67,0x65,0x73,0x2f,0x62,0x61,0x72,0x2d,0x32,0x2e,0x70,0x6e,0x67,0x00,0x69, /* ages/bar-2.png.i */ \
	0x6d,0x61,0x67,0x65,0x73,0x2f,0x62,0x61,0x72,0x2d,0x33,0x2e,0x70,0x6e,0x67,0x00, /* mages/bar-3.png. */ \
	0x69,0x6d,0x61,0x67,0x65,0x73,0x2f,0x62,0x61,0x72,0x2d,0x34,0x2e,0x70,0x6e,0x67, /* images/bar-4.png */ \
	0x00,0x69,0x6d,0x61,0x67,0x65,0x73,0x2f,0x62,0x6c,0x61,0x6e,0x6b,0x2e,0x70,0x6e, /* .images/blank.pn */ \
	0x67,0x00,0x69,0x6d,0x61,0x67,0x65,0x73,0x2f,0x63,0x68,0x65,0x63,0x6b,0x6d,0x61, /* g.images/checkma */ \
	0x72,0x6b,0x2e,0x70,0x6e,0x67,0x00,0x69,0x6d,0x61,0x67,0x65,0x73,0x2f,0x68,0x61, /* rk.png.images/ha */ \
	0x72,0x6d,0x6f,0x6e,0x79,0x2e,0x67,0x69,0x66,0x00,0x69,0x6d,0x61,0x67,0x65,0x73, /* rmony.gif.images */ \
	0x2f,0x6c,0x6f,0x63,0x6b,0x2e,0x70,0x6e,0x67,0x00,0x69,0x6d,0x61,0x67,0x65,0x73, /* /lock.png.images */ \
	0x2f,0x6d,0x63,0x68,0x70,0x2e,0x67,0x69,0x66,0x00,0x7e,0x69,0x6e,0x63,0x3a,0x68, /* /mchp.gif.~inc:h */ \
	0x65,0x61,0x64,0x65,0x72,0x2e,0x69,0x6e,0x63,0x7e,0x0d,0x0a,0x3c,0x64,0x69,0x76, /* eader.inc~..<div */ \
	0x20,0x69,0x64,0x3d,0x22,0x63,0x6f,0x6e,0x74,0x65,0x6e,0x74,0x22,0x3e,0x0d,0x0a, /*  id="content">.. */ \
	0x0d,0x0a,0x20,0x20,0x20,0x20,0x3c,0x66,0x6f,0x72,0x6d,0x20,0x6d,0x65,0x74,0x68, /* ..    <form meth */ \
	0x6f,0x64,0x3d,0x22,0x70,0x6f,0x73,0x74,0x22,0x20,0x6e,0x61,0x6d,0x65,0x3d,0x22, /* od="post" name=" */ \
	0x6e,0x65,0x76,0x65,0x72,0x73,0x65,0x6e,0x64,0x22,0x20,0x61,0x63,0x74,0x69,0x6f, /* neversend" actio */ \
	0x6e,0x3d,0x22,0x22,0x3e,0x0d,0x0a,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x3c, /* n="">..        < */ \
	0x74,0x61,0x62,0x6c,0x65,0x20,0x69,0x64,0x3d,0x22,0x73,0x63,0x61,0x6e,0x54,0x61, /* table id="scanTa */ \
	0x62,0x6c,0x65,0x22,0x20,0x63,0x65,0x6c,0x6c,0x70,0x61,0x64,0x64,0x69,0x6e,0x67, /* ble" cellpadding */ \
	0x3d,0x22,0x32,0x22,0x20,0x62,0x6f,0x72,0x64,0x65,0x72,0x3d,0x22,0x30,0x22,0x3e, /* ="2" border="0"> */ \
	0x0d,0x0a,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x3c,0x74,0x62,0x6f,0x64,0x79, /* ..        <tbody */ \
	0x3e,0x0d,0x0a,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x3c, /* >..            < */ \
	0x74,0x72,0x3e,0x0d,0x0a,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20, /* tr>..            */ \
	0x20,0x20,0x20,0x20,0x20,0x3c,0x74,0x64,0x20,0x63,0x6f,0x6c,0x73,0x70,0x61,0x6e, /*      <td colspan */ \
	0x3d,0x22,0x34,0x22,0x3e,0x0d,0x0a,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20, /* ="4">..          */ \
	0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x3c,0x69,0x6e,0x70,0x75, /*            <inpu */ \
	0x74,0x20,0x69,0x64,0x3d,0x22,0x72,0x65,0x73,0x63,0x61,0x6e,0x22,0x20,0x74,0x79, /* t id="rescan" ty */ \
	0x70,0x65,0x3d,0x22,0x62,0x75,0x74,0x74,0x6f,0x6e,0x22,0x20,0x73,0x74,0x79,0x6c, /* pe="button" styl */ \
	0x65,0x3d,0x22,0x77,0x69,0x64,0x74,0x68,0x3a,0x32,0x35,0x65,0x6d,0x22,0x0d,0x0a, /* e="width:25em".. */ \
	0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20, /*                  */ \
	0x20,0x20,0x20,0x20,0x20,0x76,0x61,0x6c,0x75,0x65,0x3d,0x22,0x44,0x69,0x73,0x70, /*      value="Disp */ \
	0x6c,0x61,0x79,0x20,0x53,0x63,0x61,0x6e,0x20,0x52,0x65,0x73,0x75,0x6c,0x74,0x73, /* lay Scan Results */ \
	0x22,0x20,0x6f,0x6e,0x63,0x6c,0x69,0x63,0x6b,0x3d,0x22,0x64,0x69,0x73,0x70,0x6c, /* " onclick="displ */ \
	0x61,0x79,0x53,0x63,0x61,0x6e,0x52,0x65,0x73,0x75,0x6c,0x74,0x73,0x28,0x29,0x3b, /* ayScanResults(); */ \
	0x22,0x3e,0x3c,0x2f,0x69,0x6e,0x70,0x75,0x74,0x3e,0x0d,0x0a,0x20,0x20,0x20,0x20, /* "></input>..     */ \
	0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x3c,0x2f,0x74,0x64, /*             </td */ \
	0x3e,0x0d,0x0a,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x3c, /* >..            < */ \
	0x2f,0x74,0x72,0x3e,0x0d,0x0a,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x3c,0x2f, /* /tr>..        </ */ \
	0x74,0x62,0x6f,0x64,0x79,0x3e,0x0d,0x0a,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20, /* tbody>..         */ \
	0x3c,0x74,0x66,0x6f,0x6f,0x74,0x3e,0x0d,0x0a,0x20,0x20,0x20,0x20,0x20,0x20,0x20, /* <tfoot>..        */ \
	0x20,0x20,0x20,0x20,0x20,0x3c,0x74,0x72,0x3e,0x0d,0x0a,0x20,0x20,0x20,0x20,0x20, /*      <tr>..      */ \
	0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x3c,0x74,0x64,0x20,0x63, /*            <td c */ \
	0x6f,0x6c,0x73,0x70,0x61,0x6e,0x3d,0x22,0x34,0x22,0x3e,0x0d,0x0a,0x20,0x20,0x20, /* olspan="4">..    */ \
	0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20, /*                  */ \
	0x20,0x3c,0x69,0x6e,0x70,0x75,0x74,0x20,0x69,0x64,0x3d,0x22,0x5f,0x5f,0x6f,0x74, /*  <input id="__ot */ \
	0x68,0x65,0x72,0x5f,0x5f,0x22,0x20,0x74,0x79,0x70,0x65,0x3d,0x22,0x62,0x75,0x74, /* her__" type="but */ \
	0x74,0x6f,0x6e,0x22,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x22,0x77,0x69,0x64,0x74, /* ton" style="widt */ \
	0x68,0x3a,0x32,0x35,0x65,0x6d,0x22,0x0d,0x0a,0x20,0x20,0x20,0x20,0x20,0x20,0x20, /* h:25em"..        */ \
	0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x76,0x61, /*               va */ \
	0x6c,0x75,0x65,0x3d,0x22,0x4f,0x74,0x68,0x65,0x72,0x20,0x4e,0x65,0x74,0x77,0x6f, /* lue="Other Netwo */ \
	0x72,0x6b,0x2e,0x2e,0x2e,0x22,0x20,0x6f,0x6e,0x63,0x6c,0x69,0x63,0x6b,0x3d,0x22, /* rk..." onclick=" */ \
	0x75,0x73,0x65,0x72,0x53,0x65,0x6c,0x65,0x63,0x74,0x4e,0x65,0x74,0x77,0x6f,0x72, /* userSelectNetwor */ \
	0x6b,0x28,0x29,0x3b,0x22,0x3e,0x3c,0x2f,0x69,0x6e,0x70,0x75,0x74,0x3e,0x0d,0x0a, /* k();"></input>.. */ \
	0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20, /*                  */ \
	0x3c,0x2f,0x74,0x64,0x3e,0x0d,0x0a,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20, /* </td>..          */ \
	0x20,0x20,0x20,0x3c,0x2f,0x74,0x72,0x3e,0x0d,0x0a,0x20,0x20,0x20,0x20,0x20,0x20, /*    </tr>..       */ \
	0x20,0x20,0x3c,0x2f,0x74,0x66,0x6f,0x6f,0x74,0x3e,0x0d,0x0a,0x20,0x20,0x20,0x20, /*   </tfoot>..     */ \
	0x20,0x20,0x20,0x20,0x3c,0x2f,0x74,0x61,0x62,0x6c,0x65,0x3e,0x0d,0x0a,0x20,0x20, /*     </table>..   */ \
	0x20,0x20,0x3c,0x2f,0x66,0x6f,0x72,0x6d,0x3e,0x0d,0x0a,0x0d,0x0a,0x20,0x20,0x20, /*   </form>....    */ \
	0x20,0x3c,0x66,0x6f,0x72,0x6d,0x20,0x6d,0x65,0x74,0x68,0x6f,0x64,0x3d,0x22,0x70, /*  <form method="p */ \
	0x6f,0x73,0x74,0x22,0x20,0x6e,0x61,0x6d,0x65,0x3d,0x22,0x6b,0x69,0x63,0x6b,0x6f, /* ost" name="kicko */ \
	0x66,0x66,0x22,0x20,0x61,0x63,0x74,0x69,0x6f,0x6e,0x3d,0x22,0x22,0x3e,0x0d,0x0a, /* ff" action="">.. */ \
	0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x3c,0x69,0x6e,0x70,0x75,0x74,0x20,0x74, /*         <input t */ \
	0x79,0x70,0x65,0x3d,0x22,0x68,0x69,0x64,0x64,0x65,0x6e,0x22,0x20,0x69,0x64,0x3d, /* ype="hidden" id= */ \
	0x22,0x77,0x6c,0x61,0x6e,0x22,0x20,0x6e,0x61,0x6d,0x65,0x3d,0x22,0x77,0x6c,0x61, /* "wlan" name="wla */ \
	0x6e,0x22,0x3e,0x3c,0x2f,0x69,0x6e,0x70,0x75,0x74,0x3e,0x0d,0x0a,0x20,0x20,0x20, /* n"></input>..    */ \
	0x20,0x20,0x20,0x20,0x20,0x3c,0x69,0x6e,0x70,0x75,0x74,0x20,0x74,0x79,0x70,0x65, /*      <input type */ \
	0x3d,0x22,0x68,0x69,0x64,0x64,0x65,0x6e,0x22,0x20,0x69,0x64,0x3d,0x22,0x73,0x73, /* ="hidden" id="ss */ \
	0x69,0x64,0x22,0x20,0x6e,0x61,0x6d,0x65,0x3d,0x22,0x73,0x73,0x69,0x64,0x22,0x3e, /* id" name="ssid"> */ \
	0x3c,0x2f,0x69,0x6e,0x70,0x75,0x74,0x3e,0x0d,0x0a,0x20,0x20,0x20,0x20,0x20,0x20, /* </input>..       */ \
	0x20,0x20,0x3c,0x69,0x6e,0x70,0x75,0x74,0x20,0x74,0x79,0x70,0x65,0x3d,0x22,0x68, /*   <input type="h */ \
	0x69,0x64,0x64,0x65,0x6e,0x22,0x20,0x69,0x64,0x3d,0x22,0x73,0x65,0x63,0x22,0x20, /* idden" id="sec"  */ \
	0x6e,0x61,0x6d,0x65,0x3d,0x22,0x73,0x65,0x63,0x22,0x3e,0x3c,0x2f,0x69,0x6e,0x70, /* name="sec"></inp */ \
	0x75,0x74,0x3e,0x0d,0x0a,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x3c,0x69,0x6e, /* ut>..        <in */ \
	0x70,0x75,0x74,0x20,0x74,0x79,0x70,0x65,0x3d,0x22,0x68,0x69,0x64,0x64,0x65,0x6e, /* put type="hidden */ \
	0x22,0x20,0x69,0x64,0x3d,0x22,0x6b,0x65,0x79,0x22,0x20,0x6e,0x61,0x6d,0x65,0x3d, /* " id="key" name= */ \
	0x22,0x6b,0x65,0x79,0x22,0x3e,0x3c,0x2f,0x69,0x6e,0x70,0x75,0x74,0x3e,0x0d,0x0a, /* "key"></input>.. */ \
	0x20,0x20,0x20,0x20,0x3c,0x2f,0x66,0x6f,0x72,0x6d,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c, /*     </form>....< */ \
	0x2f,0x64,0x69,0x76,0x3e,0x20,0x3c,0x21,0x2d,0x2d,0x63,0x6f,0x6e,0x74,0x65,0x6e, /* /div> <!--conten */ \
	0x74,0x2d,0x2d,0x3e,0x0d,0x0a,0x7e,0x69,0x6e,0x63,0x3a,0x66,0x6f,0x6f,0x74,0x65, /* t-->..~inc:foote */ \
	0x72,0x2e,0x69,0x6e,0x63,0x7e,0x0d,0x0a,0x16,0x00,0x00,0x00,0x02,0x00,0x00,0x00, /* r.inc~.......... */ \
	0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0x04,0x00,0x00,0x01,0x00,0x00,0x00,0x3e,0x00, /* ......L.......>. */ \
	0x00,0x00,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xdd,0x02,0x00,0x00, /* ................ */ \
	0x02,0x00,0x00,0x00,0x24,0x03,0x00,0x00,0x03,0x00,0x00,0x00,0x6e,0x03,0x00,0x00, /* ....$.......n... */ \
	0x04,0x00,0x00,0x00,0xb6,0x03,0x00,0x00,0x05,0x00,0x00,0x00,0x03,0x04,0x00,0x00, /* ................ */ \
	0x06,0x00,0x00,0x00,0xd7,0x0c,0x00,0x00,0x01,0x00,0x00,0x00,0x0e,0x00,0x00,0x00, /* ................ */ \
	0x02,0x00,0x09,0x00,0x00,0x00,0x07,0x00,0x00,0x00,0x16,0x00,0x00,0x00,0x02,0x00, /* ................ */ \
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xbe,0x1a,0x00,0x00,0x01,0x00,0x00,0x00, /* ................ */ \
	0x3e,0x00,0x00,0x00,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xd5,0x00, /* >............... */ \
	0x00,0x00,0x08,0x00,0x00,0x00,0x65,0x01,0x00,0x00,0x09,0x00,0x00,0x00,0x93,0x01, /* ......e......... */ \
	0x00,0x00,0x0a,0x00,0x00,0x00,0x04,0x02,0x00,0x00,0x08,0x00,0x00,0x00,0x32,0x02, /* ..............2. */ \
	0x00,0x00,0x0b,0x00,0x00,0x00,0x63,0x02,0x00,0x00,0x01,0x00,0x00,0x00,0x0e,0x00, /* ......c......... */ \
	0x00,0x00,0x02,0x00,0x09,0x00,0x00,0x00,0x0c,0x00,0x00,0x00,0x6e,0x00,0x00,0x00, /* ............n... */ \
	0x02,0x00,0x3e,0x00,0x00,0x00,0x0c,0x00,0x00,0x00,0x52,0x00,0x00,0x00,0x06,0x00, /* ..>.......R..... */ \
	0x00,0x00,0x68,0x00,0x00,0x00,0x0d,0x00,0x00,0x00,0x82,0x00,0x00,0x00,0x02,0x00, /* ..h............. */ \
	0x00,0x00,0xa2,0x00,0x00,0x00,0x0e,0x00,0x00,0x00,0xba,0x00,0x00,0x00,0x0f,0x00, /* ................ */ \
	0x00,0x00,0xd3,0x00,0x00,0x00,0x10,0x00,0x00,0x00,0xef,0x00,0x00,0x00,0x11,0x00, /* ................ */ \
	0x00,0x00,0x09,0x01,0x00,0x00,0x12,0x00,0x00,0x00,0x2f,0x01,0x00,0x00,0x07,0x00, /* ........../..... */ \
	0x00,0x00,0x46,0x01,0x00,0x00,0x13,0x00,0x00,0x00,0x5d,0x01,0x00,0x00,0x14,0x00, /* ..F.......]..... */ \
	0x00,0x00,0x74,0x01,0x00,0x00,0x15,0x00,0x00,0x00,0x1f,0x8b,0x08,0x00,0x00,0x00, /* ..t............. */ \
	0x00,0x00,0x00,0x00,0x45,0x8f,0x51,0x4f,0x83,0x40,0x0c,0xc7,0xdf,0x4d,0xfc,0x0e, /* ....E.QO.@...M.. */ \
	0xf5,0xde,0xa1,0x2e,0x9b,0xc9,0xd4,0x63,0x0f,0x02,0x46,0x93,0x4d,0x17,0x83,0x31, /* .......c..F.M..1 */ \
	0x3e,0xe2,0x51,0x76,0x97,0x0c,0xee,0x3c,0x8a,0xb8,0x6f,0x2f,0x8c,0x39,0xfa,0xd2, /* >.Qv...<..o/.9.. */ \
	0x7f,0xfb,0x4f,0x7f,0x6d,0xe5,0x55,0xf2,0x1a,0x67,0x9f,0xdb,0x14,0x9e,0xb2,0xcd, /* ..O.m.U..g...... */ \
	0x1a,0xb6,0xef,0x0f,0xeb,0xe7,0x18,0x44,0x80,0xf8,0x31,0x8f,0x11,0x93,0x2c,0x19, /* .......D..1...,. */ \
	0x8d,0x45,0x78,0x3d,0x43,0x4c,0x5f,0x04,0x08,0xcd,0xec,0xee,0x10,0xbb,0xae,0x0b, /* .Ex=CL_......... */ \
	0xbb,0x79,0x68,0xfd,0x0e,0xb3,0x37,0xd4,0x5c,0xed,0x17,0xd8,0xb0,0x37,0x8a,0xc3, /* .yh...7.\....7.. */ \
	0x82,0x0b,0xb1,0xba,0xbc,0x90,0x43,0xb3,0xcf,0x00,0x20,0x35,0xe5,0xc5,0x28,0x87, /* ......C... 5..(. */ \
	0xaa,0x22,0xce,0x61,0xe0,0x04,0xf4,0xdd,0x9a,0x9f,0x48,0xc4,0xb6,0x66,0xaa,0x39, /* .".a......H..f.9 */ \
	0xc8,0x0e,0x8e,0x04,0xa8,0xb1,0x8a,0x04,0xd3,0x2f,0x1f,0xd1,0xf7,0xa0,0x74,0xee, /* ........./....t. */ \
	0x1b,0xe2,0xc8,0x34,0x36,0x58,0x2e,0x6f,0x6e,0x83,0x99,0x98,0x78,0x6c,0x78,0x4f, /* ...46X.on...xlxO */ \
	0xab,0x1e,0x52,0x9a,0x5d,0xeb,0x73,0x36,0xb6,0x86,0xd4,0x7b,0xeb,0x25,0x8e,0xd6, /* ..R.].s6...{.%.. */ \
	0x78,0x04,0x4e,0x57,0xc8,0x2f,0x5b,0x1c,0x26,0x80,0x3b,0xcb,0x3e,0x1e,0x5b,0x6e, /* x.NW./[.&.;.>.[n */ \
	0x3d,0x81,0xb6,0x15,0x81,0x2d,0x61,0xa3,0xb4,0x03,0x1a,0x68,0x50,0x5b,0x36,0xa5, /* =....-a....hP[6. */ \
	0x51,0xc7,0x05,0xe1,0x79,0x18,0xdd,0x3f,0xff,0x04,0x95,0x78,0xfa,0xfc,0x0f,0xf0, /* Q...y..?...x.... */ \
	0x9c,0xf2,0x25,0x5e,0x01,0x00,0x00,0x1f,0x8b,0x08,0x00,0x00,0x00,0x00,0x00,0x00, /* ..%^............ */ \
	0x00,0xed,0x59,0x7f,0x5c,0x54,0xd7,0x95,0x3f,0x08,0x71,0x20,0xcb,0x4a,0xd4,0x2c, /* ..Y.\T..?.q .J., */ \
	0x2a,0x5a,0x40,0xd0,0x20,0x11,0x44,0x33,0x89,0x09,0xd9,0xb8,0x58,0xdb,0xcd,0x6e, /* .Z@. .D3....X..n */ \
	0x93,0xe8,0x66,0x13,0xfd,0xa4,0x4d,0x9b,0x40,0xb6,0xed,0x33,0x6e,0xe3,0xd6,0x6c, /* ..f...M.@..3n..l */ \
	0x34,0x48,0xb1,0x61,0x90,0x84,0x1f,0x0d,0xae,0x94,0xaa,0xcc,0xb3,0xae,0xd5,0x17, /* 4H.a............ */ \
	0x23,0xd3,0xc6,0x62,0x62,0xc5,0x9f,0xa8,0x28,0x63,0x11,0x1d,0xc3,0x68,0x14,0x82, /* #..bb...(c...h.. */ \
	0x3a,0x14,0x92,0xf8,0x5b,0x14,0xfc,0xb1,0xd2,0xd5,0x78,0xfb,0x3d,0xf7,0xbe,0x19, /* :...[.....x.=... */ \
	0x86,0x61,0x4c,0xec,0x76,0xff,0xd8,0xcf,0x67,0x73,0xe7,0x9d,0xf7,0xee,0x3d,0xe7, /* .aL.v...gs....=. */ \
	0xdc,0x73,0xcf,0x3d,0xe7,0xdc,0x73,0x2f,0x17,0xa2,0x10,0xea,0x4f,0xf7,0xdc,0x43, /* .s.=..s/....O..C */ \
	0xb2,0xbc,0x1c,0x4a,0xa4,0xe1,0xeb,0x6b,0xdf,0x45,0xf4,0x61,0x28,0xb7,0x15,0x62, /* ...J...k.E.a(..b */ \
	0x4c,0x08,0xd1,0xc4,0x08,0xa2,0xf8,0x78,0x45,0x77,0x44,0x12,0xbd,0x78,0xb7,0x5f, /* L......xEwD..x._ */ \
	0x3b,0x9c,0xa8,0xff,0x10,0x6e,0x2b,0xfe,0x33,0xfd,0x88,0xaa,0xe2,0xd0,0x8f,0x65, /* ;....n+.3......e */ \
	0x02,0x98,0x2d,0x84,0x86,0x2a,0xe6,0x50,0xfa,0xc2,0x72,0xe0,0xc0,0x01,0x4d,0xd3, /* ..-....P..r...M. */ \
	0x35,0xab,0x6e,0xe5,0x47,0x43,0x65,0xd9,0xb2,0x65,0xcd,0xcd,0xcd,0x7d,0x39,0xcf, /* 5.n.GCe..e...}9. */ \
	0x9d,0x3b,0xa7,0x69,0x2e,0x2b,0xe9,0x78,0x88,0xf2,0xbd,0x15,0x1b,0xe6,0x62,0x25, /* .;.i.+.x......b% */ \
	0xad,0xb0,0xb0,0x30,0x80,0x5f,0xf7,0x32,0x5b,0xc9,0x15,0xf0,0xc8,0xe9,0x6b,0x01, /* ...0._.2[.....k. */ \
	0xa3,0xb8,0x5c,0xc2,0x9f,0x07,0x4d,0x3f,0x8c,0x0e,0x69,0x7d,0x55,0xd2,0x75,0x93, /* ..\...M?..i}U.u. */ \
	0x41,0xf3,0x52,0x75,0x5d,0xf2,0x5b,0xf5,0xee,0xee,0x6e,0x7f,0xcd,0x7d,0x75,0xcd, /* A.Ru].[...n..}u. */ \
	0xca,0x0c,0x3e,0x8c,0x1a,0x62,0xed,0xfe,0x4e,0xd5,0xfc,0xf4,0xd3,0x4f,0x6b,0x6b, /* ..>..b..N....Okk */ \
	0x6b,0xc1,0x03,0xbc,0xc2,0x58,0xad,0x2e,0xc8,0x54,0x75,0xc8,0x04,0x49,0xf3,0xd3, /* k....X...Tu..I.. */ \
	0xc4,0x67,0x3a,0xbc,0x65,0xd3,0x05,0x86,0x00,0xf5,0xba,0xba,0xba,0xfc,0xc6,0xd2, /* .g:.e........... */ \
	0x21,0x4d,0xea,0xa0,0x2b,0x4d,0x7c,0x03,0x29,0x4d,0xd0,0xa5,0xd7,0x58,0x52,0xac, /* !M..+M|.)M...XR. */ \
	0xae,0x99,0xd3,0xf4,0x37,0x02,0x77,0xef,0x33,0x96,0x32,0x29,0x44,0xa9,0x2e,0xe0, /* ....7.w.3.2)D... */ \
	0x51,0xa3,0xbb,0x74,0xd3,0x17,0x18,0x4f,0x4d,0x33,0x40,0x5a,0x4f,0x17,0x4d,0x9a, /* Q..t...OM3@ZO.M. */ \
	0xdd,0xea,0x75,0x84,0x34,0x85,0x6f,0x2c,0xc8,0xf7,0x99,0x4e,0x78,0xbb,0x04,0x7d, /* ..u.4.o,...Nx..} */ \
	0x50,0x76,0xef,0xde,0xad,0x69,0xbd,0x02,0x83,0x7d,0xaa,0x43,0x5a,0x8f,0x5b,0xd5, /* Pv...i...}.CZ.[. */ \
	0xa3,0x4c,0xba,0x6a,0xd5,0x9a,0x00,0x7e,0x53,0x31,0x5d,0x68,0x5e,0x7d,0x34,0x3f, /* .L.j...~S1]h^}4? */ \
	0x77,0xa0,0x6c,0xd8,0xb0,0x01,0xa3,0xfc,0xb9,0xfc,0x9d,0x51,0x42,0xd4,0x5a,0x00, /* w.l........QB.Z. */ \
	0xa1,0xea,0xdb,0x5e,0x24,0xc4,0xab,0xa5,0x42,0x58,0x47,0x08,0x91,0x34,0x54,0x88, /* ...^$...BXG..4T. */ \
	0xfe,0x13,0x84,0x18,0xf0,0xaa,0x10,0x61,0x89,0x42,0xd8,0xc2,0xc0,0x43,0x42,0xb4, /* .......a.B...CB. */ \
	0x85,0x0b,0xd1,0x39,0x42,0x41,0xef,0x75,0x16,0xae,0x44,0x87,0x50,0xd0,0x62,0x33, /* ...9BA.u..D.P.b3 */ \
	0x5f,0x36,0xb3,0x62,0x33,0x1b,0x08,0x33,0xaa,0x3d,0x51,0x4b,0x1c,0x7a,0x61,0x61, /* _6.b3..3.=QK.zaa */ \
	0x61,0x14,0x1e,0x1e,0x4e,0x91,0x91,0x91,0x34,0x70,0xe0,0x40,0x8a,0x8e,0x8e,0xa6, /* a...N...4p.@.... */ \
	0x11,0x23,0x46,0x50,0x42,0x42,0x02,0x25,0x27,0x27,0xd3,0x8c,0x19,0x33,0x68,0xea, /* .#FPBB.%''...3h. */ \
	0xd4,0xa9,0x34,0x65,0xca,0x14,0x4a,0x4f,0x4f,0xa7,0xfc,0xfc,0x7c,0xca,0x67,0x71, /* ..4e..JOO...|.gq */ \
	0x78,0xe5,0x9b,0x95,0x7c,0xb3,0x61,0x25,0x95,0x5b,0x38,0x6e,0xe4,0xbc,0xad,0x1c, /* x...|.a%.[8n.... */ \
	0xc3,0x72,0x8d,0xb2,0xa9,0xd9,0x28,0x24,0x4c,0x26,0x2b,0xaf,0x42,0x8d,0xe3,0x0b, /* .r....($L&+.B... */ \
	0x78,0x80,0x30,0x3b,0x72,0xd0,0x69,0x3a,0xc7,0x14,0x47,0x0e,0xf0,0xa6,0x30,0x0e, /* x.0;r.i:..G...0. */ \
	0x01,0xf6,0x14,0x1b,0x94,0xe3,0x48,0x70,0x1b,0xf1,0xca,0x31,0xab,0xc2,0xd8,0x2a, /* ......Hp...1.... */ \
	0x7f,0x1a,0x71,0x66,0xe0,0x75,0x6e,0x25,0x61,0x2a,0x60,0x05,0x68,0x56,0x76,0xb7, /* ..qf.un%a.`.hVv. */ \
	0x8c,0x2a,0xe8,0xa0,0x94,0xb2,0x72,0xf2,0xd0,0xe4,0x72,0x60,0x6f,0x41,0x07,0xa5, /* ......r...r`oA.. */ \
	0x28,0x56,0x15,0x74,0xe0,0xf5,0xc2,0x91,0x0a,0xbc,0xa9,0x3c,0x3b,0x56,0x26,0x16, /* (V.t.......<;V&. */ \
	0x19,0x64,0xc0,0x33,0x0e,0x13,0xe2,0x48,0x94,0x4b,0x00,0x20,0xcc,0x09,0xb2,0x26, /* .d.3...H.K. ...& */ \
	0xfc,0xd3,0x01,0x2e,0x80,0x30,0x27,0x8d,0x3c,0x87,0xa1,0x81,0x07,0xb8,0x00,0xc2, /* .....0'.<....... */ \
	0x34,0x04,0xd2,0x1f,0x3e,0x1a,0xc7,0x23,0x2f,0x04,0x69,0x18,0x2c,0x6d,0xe8,0xa1, /* 4...>..#/.i.,m.. */ \
	0x71,0x02,0xe2,0x15,0x03,0x3d,0x94,0xb1,0xb0,0x36,0xa1,0x03,0x70,0x00,0x61,0x1a, /* q....=...6..p.a. */ \
	0xcf,0x0a,0x40,0xec,0x41,0x07,0x1e,0xcb,0x85,0x9f,0x90,0x46,0xd4,0x61,0x50,0xfe, /* ..@.A......F.aP. */ \
	0xb9,0xa4,0x57,0x60,0x19,0xab,0x2e,0xb5,0x72,0xe1,0x2b,0x48,0x19,0xdb,0x0a,0xe0, /* ..W`....r.+H.... */ \
	0xd5,0xae,0xe3,0xeb,0x02,0x08,0xd4,0xad,0xe8,0xab,0x71,0x7f,0x00,0xc2,0x18,0x63, /* ..........q....c */ \
	0x2b,0x87,0x20,0xa6,0x61,0x03,0x1e,0x1f,0x78,0x80,0x30,0x9d,0x64,0x15,0x8c,0x07, /* +. .a...x.0.d... */ \
	0x3f,0xbe,0x58,0x06,0xb0,0x83,0x72,0x9c,0xd5,0xb4,0x80,0x2e,0x75,0x72,0x49,0x07, /* ?.X...r.....urI. */ \
	0xf3,0x7a,0xe6,0x5c,0xa5,0x03,0x5c,0x00,0x61,0x3a,0xd7,0x0a,0x40,0x56,0xe3,0xec, /* .z.\..\.a:..@V.. */ \
	0x0d,0x3d,0x80,0x97,0x81,0x00,0x3c,0x40,0x03,0xf0,0x6a,0x42,0x36,0xc1,0x70,0x2a, \
	0x08,0x90,0x1f,0xd0,0xcd,0xc5,0x99,0x85,0x17,0x3d,0x74,0x51,0x81,0x61,0x05,0x68, /* .........=tQ.a.h */ \
	0x82,0x75,0x01,0x1e,0x20,0x18,0x67,0x7a,0x81,0x67,0xcd,0xc1,0x64,0xb5,0xc2,0x23, /* .u.. .gz.g..d..# */ \
	0x00,0x1d,0xe0,0x02,0x08,0x00,0x07,0x94,0x15,0xc0,0x29,0x01,0xe9,0x05,0x3a,0x00, /* ..........)...:. */ \
	0x2f,0x83,0x0e,0x78,0x80,0x06,0xe0,0x24,0x89,0x3c,0x02,0x1d,0x54,0xe0,0x59,0x01, /* /..x...$.<..T.Y. */ \
	0x1a,0x40,0x07,0x70,0x3e,0x15,0x8c,0x13,0xc0,0x61,0x4c,0x1d,0x5f,0x97,0x60,0x19, /* .@.p>....aL._.`. */ \
	0xf0,0x23,0xfb,0x45,0xb0,0x8f,0xb9,0xcd,0x74,0x41,0x9c,0x3e,0x32,0x33,0x33,0x29, /* .#.E....tA.>233) */ \
	0x3b,0x3b,0x9b,0x38,0xf5,0x60,0xf7,0xe3,0x3d,0x91,0x33,0x05,0x67,0x3b,0xf2,0x78, /* ;;.8.`..=.3.g;.x */ \
	0x3c,0x9c,0x2e,0xe5,0x1e,0xc2,0xb9,0x94,0xf7,0x15,0x71,0xa3,0x93,0x93,0x15,0x96, /* <.........q..... */ \
	0xb1,0x8d,0x64,0xd8,0xe3,0x25,0xcc,0x8a,0x30,0x1b,0x42,0x21,0xe8,0x62,0x55,0x69, /* ..d..%..0.B!.bUi */ \
	0xa1,0x56,0xda,0x61,0xee,0x2f,0x57,0x1a,0x0d,0x23,0xc6,0x30,0xc2,0x32,0xb3,0x2e, /* .V.a./W..#.0.2.. */ \
	0xc8,0xf6,0x7a,0xc3,0x70,0xca,0x92,0x99,0x29,0x39,0x3c,0x5c,0xf7,0xe0,0x6d,0xac, /* ..z.p...)9<\..m. */ \
	0x57,0x1d,0x9a,0x9c,0xce,0x46,0xa2,0x6a,0x67,0xe1,0x35,0xee,0x0d,0x70,0x38,0xaf, /* W....F.jg.5..p8. */ \
	0x30,0x1b,0x4e,0x07,0x97,0x2d,0x0e,0x0f,0x51,0x65,0x35,0xd1,0x35,0x07,0x78,0x08, /* 0.N..-..Qe5.5.x. */ \
	0x03,0x95,0x52,0xa3,0x43,0x76,0xba,0x0a,0x1e,0xa3,0xda,0x61,0x38,0x9c,0x1e,0xe6, /* ..R.Cv.....a8... */ \
	0x6e,0x62,0x9e,0x52,0x72,0x3b,0x9d,0x2c,0xd6,0x51,0x29,0x79,0x3a,0xc9,0xe3,0x76, /* nb.Rr;.,.Q)y:..v */ \
	0x3a,0xae,0xd2,0x26,0xc3,0xa8,0xa1,0xcb,0x92,0x02,0xc4,0x29,0x4f,0xa5,0xd3,0x59, /* :..&.......)O..Y */ \
	0xe9,0x01,0x4f,0x27,0x06,0x6a,0x75,0x3b,0xcd,0x52,0x73,0x76,0x36,0xab,0xec,0x69, /* ..O'.ju;.Rsv6..i */ \
	0x6e,0x80,0x72,0x86,0xd1,0x48,0xd7,0x65,0x9b,0x3c,0x4d,0x0e,0xa7,0xd3,0x01,0x25, /* n.r..H.e.<M....% */ \
	0xe8,0xd2,0xd9,0xc0,0xf6,0xff,0x6e,0x9e,0x0d,0xeb,0xc9,0xa7,0xb7,0xcb,0xb4,0x4c, /* ......n........L */ \
	0xb4,0xd9,0xd4,0x87,0x7f,0x32,0xd5,0xaa,0x5c,0xab,0x9c,0x44,0xca,0x37,0x5e,0x4f, /* .....2..\..D.7^O */ \
	0x49,0x57,0x71,0xab,0x58,0xaf,0xe0,0x4e,0x16,0xac,0x34,0x7d,0x0e,0x51,0x0e,0x7f, /* IWq.X..N..4}.Q.. */ \
	0xcb,0x88,0x22,0x74,0x7b,0x89,0x0e,0x42,0xb8,0x3e,0x27,0x9c,0x97,0x12,0x22,0x37, /* .."t{..B.>'..."7 */ \
	0xdc,0xce,0x8f,0x9d,0x22,0xe6,0x80,0xcb,0x52,0x46,0x25,0x68,0xf2,0xb2,0x04,0xa6, /* ...."...RF%h.... */ \
	0x2c,0xa7,0x82,0x18,0x63,0x2b,0xd1,0xa9,0x84,0x79,0x2c,0xfa,0x7c,0x5d,0x2f,0x2a, /* ,...c+...y,.|]/. */ \
	0xe3,0x1c,0x80,0x52,0x9c,0x2d,0xe5,0x57,0x58,0xb2,0x89,0x8a,0x74,0x88,0x2d,0xf6, /* ...R.-.WX...t.-. */ \
	0x7e,0x3b,0xe3,0x30,0x6f,0x8b,0xb2,0x11,0x7f,0xdb,0x17,0x0b,0x71,0xe5,0x3f,0x60, /* ~;.0o.......q.?` */ \
	0xa7,0x15,0xb0,0xd3,0x23,0x42,0x44,0xa5,0x2b,0x3b,0x45,0x22,0xa8,0x6d,0x96,0xe0, /* ....#BD.+;E".m.. */ \
	0x76,0x62,0x1b,0x4d,0x26,0xbf,0x73,0x5f,0xe4,0x6d,0x0d,0x75,0xfb,0xb2,0x63,0xf3, /* vb.M&.s_.m.u..c. */ \
	0x47,0x79,0x73,0x7f,0xf3,0xf2,0xf3,0xfa,0x73,0xdf,0x5a,0x34,0x2d,0xe3,0xcd,0xa7, /* Gys.....s.Z4-... */ \
	0xa7,0x14,0x7c,0xe7,0xa9,0xc2,0x7f,0xcd,0x5a,0x5c,0x9c,0xff,0xce,0xd1,0x8f,0x5a, /* ..|.....Z\.....Z */ \
	0xff,0x07,0x02,0x55,0xd9,0xef,0x6c,0xfd,0xd1,0x77,0xd7,0x3c,0x3c,0xb2,0x30,0x86, /* ...U..l..w.<<.0. */ \
	0x5e,0x8f,0xa1,0x1c,0xef,0x93,0x3d,0x8c,0x5e,0x1b,0x4a,0xff,0x16,0x4d,0x33,0xef, /* ^.....=.^.J..M3. */ \
	0xa5,0xcc,0x61,0x96,0xef,0x4d,0x7e,0x60,0xce,0x82,0xb9,0x15,0xa7,0x4f,0x9d,0xbf, /* ..a..M~`.....O.. */ \
	0x73,0xc9,0x67,0x4f,0x5f,0xfe,0xf9,0x5b,0xbb,0x12,0xc2,0x17,0x8e,0xa0,0x85,0x5f, /* s.gO_..[......._ */ \
	0xa3,0xb7,0x62,0xa9,0x24,0x91,0x7e,0x35,0x86,0x36,0xdf,0x4f,0x7b,0xc6,0x52,0xfd, /* ..b.$.~5.6.O{.R. */ \
	0x58,0x72,0x8e,0xa1,0x2d,0x89,0xb4,0x6a,0x38,0xe5,0x62,0xac,0x21,0xf4,0xf2,0x60, /* Xr..-..j8.b.!..` */ \
	0x7a,0xfe,0x91,0xb1,0xb3,0xb6,0x6c,0xfc,0xfd,0x9d,0x08,0x77,0xed,0x3d,0xf5,0xcd, /* z.....l....w.=.. */ \
	0xb1,0xbf,0x8a,0xa5,0x9f,0xc5,0x52,0x69,0x1c,0x95,0x25,0x51,0x75,0x0a,0xb9,0xd2, /* ......Ri..%Qu... */ \
	0xa8,0x79,0x3c,0x79,0xc6,0x53,0xab,0xdf,0x73,0x7c,0x1c,0x7d,0x74,0x3f,0xd5,0x8d, /* .y<y.S..s|.}t?.. */ \
	0xa2,0xb5,0xc3,0x68,0x5e,0x34,0xfd,0x70,0x10,0x4d,0x7f,0x71,0x7a,0xc1,0x17,0x0b, /* ...h^4.p.M.qz... */ \
	0x3f,0xd4,0xd0,0x31,0x21,0xea,0x3d,0xe8,0x96,0x40,0x2b,0xee,0xa3,0xdf,0xa6,0xd0, /* ?..1!.=..@+..... */ \
	0x81,0x34,0xfa,0xd8,0x2b,0xf9,0xd8,0x38,0x3a,0x9c,0x4a,0x07,0x53,0xe9,0xc3,0x71, /* .4..+..8:.J.S..q */ \
	0x74,0x04,0x4d,0x89,0xf4,0x60,0xe8,0xb1,0xb4,0x37,0x8e,0x16,0x0f,0xa5,0xd9,0xf7, /* t.M..`...7...... */ \
	0xd2,0x0b,0x79,0xaf,0x1b,0x5f,0xa4,0xfc,0x9e,0xce,0xb4,0xfe,0xbb,0xee,0xef,0xb7, /* ..y.._.......... */ \
	0x65,0x0c,0x6d,0x1c,0x47,0x87,0xc6,0xd3,0x09,0x25,0x64,0x1c,0x1d,0x1d,0x4b,0x75, /* e.m.G....%d...Ku */ \
	0xf7,0xd1,0xfa,0x97,0x1e,0xdf,0xfb,0xe3,0xe9,0x87,0x1f,0x1d,0x78,0x60,0xc2,0x5d, /* ............x`.] */ \
	0x07,0xd3,0xe8,0xa8,0x1a,0x1a,0xe3,0x26,0xd2,0xea,0xe1,0xb4,0xc0,0x1a,0xfb,0xc6, /* .......&........ */ \
	0x97,0xda,0x67,0x49,0x6e,0xc7,0xcb,0x8f,0x89,0x7f,0x88,0x3d,0x36,0x2e,0xc4,0x0d, /* ..gIn......=6... */ \
	0x23,0xa0,0x7b,0x1a,0x35,0x25,0x53,0x4d,0x02,0xfd,0xf2,0x1b,0xa3,0xcd,0xfc,0x55, /* #.{.5%SM.......U */ \
	0xf1,0xba,0x98,0xfb,0x84,0x98,0x78,0xb7,0x1b,0x24,0xf0,0xc0,0x23,0x30,0xe6,0x08, /* ......x..$..#0.. */ \
	0xca,0x5b,0x5a,0xb2,0xf3,0x4e,0x5c,0xb0,0xb9,0x5c,0x54,0x15,0x88,0xc9,0xd1,0x47, /* .[Z..N\..\T....G */ \
	0xa5,0x86,0xe8,0xbe,0x37,0x9e,0x96,0xc4,0xd3,0x2f,0xb6,0x7f,0xd0,0xee,0xe3,0x69, /* ....7..../.....i */ \
	0xdd,0x28,0x5e,0x99,0x22,0xd2,0xfa,0x35,0x62,0x6a,0x09,0x04,0x7f,0x95,0xcc,0xfe, /* .(^."..5bj...... */ \
	0xde,0xba,0x3b,0x11,0xae,0x8a,0x53,0x17,0x0b,0xfe,0x59,0x75,0x3f,0x02,0x77,0xc4, /* ..;...S...Yu?.w. */ \
	0xd1,0xa2,0x99,0xcf,0x7e,0x10,0xc0,0x53,0xf4,0x82,0x78,0x30,0xbc,0x11,0x3e,0x8a, /* ....~..S..x0..>. */ \
	0xa7,0x9f,0x8f,0xec,0xff,0x96,0xa7,0xe5,0xcf,0x08,0x51,0xf7,0x4e,0xf1,0xb3,0x17, /* ..........Q.N... */ \
	0xc5,0xc4,0xbf,0x72,0xa7,0xd0,0x3e,0x68,0xfe,0xe8,0xc8,0x65,0x1d,0xe7,0xaf,0x05, /* ...r..>h...e.... */ \
	0xf0,0xd8,0x17,0xfc,0xf7,0x43,0x11,0x8d,0x63,0x68,0x5b,0x2c,0xbd,0xbd,0x78,0xe1, /* .....C..ch[,..x. */ \
	0xae,0x3b,0x17,0xae,0xca,0xca,0x37,0x3f,0x7f,0x38,0xd2,0x9d,0x44,0x1f,0x40,0xf9, /* .;....7?.8..D.@. */ \
	0xf7,0xd7,0x7e,0xd4,0x97,0xe1,0x60,0xdd,0xe5,0x09,0x77,0xb9,0xe1,0x97,0xc7,0xc7, /* ..~...`...w..... */ \
	0x2d,0xbf,0xdc,0xd5,0xdd,0x97,0xa1,0x6e,0xe7,0x11,0xe2,0x75,0xea,0x09,0x2a,0x7f, /* -......n...u.... */ \
	0x4f,0x75,0x67,0x5a,0xe8,0x87,0x09,0xf4,0x9f,0x4f,0x3f,0xfa,0x4e,0x50,0x86,0xec, /* OugZ.....O?.NP.. */ \
	0x17,0x0e,0xc1,0x7a,0x29,0x03,0xec,0x07,0xeb,0x3f,0xed,0x4b,0xdd,0xbe,0xb1,0x29, /* ...z)....?.K...) */ \
	0x75,0xf8,0xec,0xcf,0x3e,0x39,0x57,0x30,0x77,0xdb,0xc4,0xc4,0x9c,0xbe,0x0c,0x3f, /* u...>9W0w......? */ \
	0xfd,0x21,0xa2,0xbd,0x31,0x29,0x7c,0x59,0xc3,0x9e,0xf6,0xbe,0xd4,0xfa,0x9d,0x67, /* .!..1)|Y.......g */ \
	0xc7,0xdf,0xd5,0x90,0x4c,0xdb,0xe7,0x7d,0x7f,0x73,0xd0,0xd1,0xbf,0x65,0xb5,0x63, /* ....L..}.s...e.c */ \
	0xd1,0x55,0xae,0xde,0x31,0xeb,0xd9,0x6d,0x31,0xf4,0x93,0x57,0xb2,0xf4,0x5e,0x53, /* .U..1..m1..W..^S */ \
	0xdb,0x76,0x72,0x7c,0x48,0xd3,0x68,0xfa,0xcd,0xd2,0xa2,0xfa,0xa0,0xdd,0x33,0xe2, /* .vr|H.h.......3. */ \
	0xd6,0x23,0xf8,0xa7,0x3e,0xe8,0x38,0xfd,0xd9,0xe5,0xbe,0xd4,0x55,0xe5,0xee,0xf8, /* .#..>.8.....U... */ \
	0x90,0xc5,0x43,0xe8,0x95,0x62,0x9b,0xe3,0xb9,0xf4,0x5d,0x23,0xa9,0x22,0xa6,0xdf, /* ..C..b....]#.".. */ \
	0xab,0xfe,0x0c,0x4f,0x24,0xef,0xc6,0xc2,0x7c,0xea,0xc1,0xe0,0x96,0xb1,0xcd,0xde, /* ...O$...|....... */ \
	0x07,0xcb,0x20,0x33,0xd4,0xd7,0x06,0x99,0x1a,0xca,0x43,0x43,0x56,0x23,0xab,0xa4, /* .. 3......CCV#.. */ \
	0x0e,0x79,0xa3,0xf5,0xf8,0x69,0x9f,0xfc,0xca,0x55,0x75,0x8a,0xfa,0x59,0x7b,0xd7, /* .y...i...Uu..Y{. */ \
	0x5f,0x22,0xff,0xcc,0xc9,0x6b,0xfe,0xf2,0xbf,0xfd,0xc8,0xfe,0xfb,0xe8,0xfd,0xd1, /* _"...k.......... */ \
	0xf4,0xeb,0xf4,0x51,0x66,0x76,0xca,0xfe,0x41,0x0d,0x96,0x7c,0xf2,0x5f,0x97,0x1d, /* ...Qfv..A..|._.. */ \
	0x76,0x9d,0x0a,0x2a,0x3f,0x39,0xec,0x7d,0x30,0xcc,0x9a,0x11,0xb8,0x22,0x54,0x99, /* v...?9.}0...."T. */ \
	0xf5,0xcc,0x0e,0xa4,0x59,0xd8,0xb6,0x38,0x97,0x5d,0xf3,0xef,0x33,0x8e,0xdd,0x1f, /* ....Y..8.]..3... */ \
	0xba,0x09,0x59,0x6b,0x14,0xad,0xf9,0xee,0x3f,0xae,0xda,0xb2,0xbe,0x25,0x2d,0x7c, /* ..Yk....?....%-| */ \
	0xcb,0x48,0xb2,0x97,0xfc,0xa4,0x26,0x68,0xf7,0x7f,0x79,0x62,0x2b,0xf2,0x52,0xea, /* .H....&h..yb+.R. */ \
	0xc0,0x25,0x9e,0x96,0x0b,0x7d,0xa9,0x55,0xab,0x4f,0x24,0xd2,0x3b,0x58,0xf5,0x59, /* .%...}.U.O$.;X.Y */ \
	0x4f,0xbd,0xa7,0x30,0x4b,0x16,0x9c,0x99,0x34,0xf8,0x50,0x0a,0xed,0x67,0x9d,0x69, /* O..0K...4.P..g.i */ \
	0x7b,0x52,0x48,0x55,0x3c,0x95,0xff,0xed,0xe8,0x45,0x7f,0xec,0xbe,0xd1,0xb7,0xfb, /* {RHU<....E...... */ \
	0xdb,0x39,0xfb,0x91,0xb1,0x91,0x8e,0xde,0x5b,0xdd,0xd8,0x97,0x7a,0xf1,0xfc,0xf5, /* .9......[...z... */ \
	0xf4,0x98,0x75,0x48,0xb9,0x89,0xa1,0x4b,0x8e,0xba,0x4f,0x2b,0xa4,0x6b,0xf7,0xb5, /* ..uH...K..O+.k.. */ \
	0x67,0xc7,0x5c,0x18,0x6f,0xa9,0x4d,0xa3,0x16,0xe4,0xab,0x24,0xda,0x10,0x6f,0xf9, /* g.\.o.M....$..o. */ \
	0x69,0xd5,0xda,0x20,0x17,0x0f,0x28,0xd6,0xbf,0x31,0x60,0xd8,0x97,0xa6,0x05,0xf7, /* i.. ..(..1`..... */ \
	0xcb,0x2f,0x16,0x62,0x3d,0x56,0x23,0xaa,0x0b,0x5e,0xdb,0xe1,0x8f,0xff,0xd1,0x37, /* ./.b=V#..^.....7 */ \
	0xae,0x4f,0x1b,0xf5,0x89,0x4c,0xc8,0xad,0x63,0x68,0xd3,0xa3,0xa3,0x8b,0xaf,0x5e, /* .O...L..ch.....^ */ \
	0x09,0xb2,0x1e,0xe7,0x65,0xed,0x86,0xdd,0x92,0x69,0x67,0xd9,0x9b,0x5b,0xfb,0x52, /* ....e....ig..[.R */ \
	0x1b,0x76,0x9f,0x4a,0x8d,0x5c,0xc3,0xf9,0x7c,0xf0,0xb2,0x00,0x52,0xd9,0x6b,0xdd, /* .v.J.\..|...R.k. */ \
	0x79,0xd3,0xc5,0x43,0x77,0xbb,0x10,0xd2,0x48,0x38,0x31,0x21,0xaf,0xcf,0xf9,0xfe, /* y..Cw...H81!.... */ \
	0xca,0x00,0x9e,0x5d,0x9b,0x3e,0x49,0xea,0xbf,0x12,0x9b,0x0e,0x82,0xe1,0x81,0xd8, /* ...].>I......... */ \
	0x5c,0xcf,0xb1,0x5e,0xae,0xbf,0xfe,0x5f,0x37,0xfe,0xe9,0xc1,0xf5,0x70,0xeb,0x03, /* \..^..._7....p.. */ \
	0x11,0xfb,0x6a,0x36,0x1e,0x0b,0xe8,0xdb,0xe4,0xba,0xb1,0x7a,0x9e,0xc8,0x9e,0x2a, /* ..j6.......z.... */ \
	0xe0,0x02,0xb8,0x06,0xf6,0x1f,0xda,0x4f,0xdb,0xb1,0xc5,0xed,0xcf,0x33,0x61,0xd0, /* .......O.....3a. */ \
	0x4a,0x6c,0x6a,0xd8,0x65,0xb0,0x11,0x63,0xe1,0x3c,0x96,0x32,0xcf,0x9f,0x6a,0x2f, /* Jlj.e..c.<.2..j/ */ \
	0x39,0x98,0x48,0x06,0xd4,0x9b,0xfd,0xed,0x20,0x53,0x63,0xf5,0x2a,0xc5,0x1f,0x7e, /* 9.H..... Sc....~ */ \
	0x27,0x9e,0x4b,0x3d,0x07,0x2f,0xc0,0x80,0xd8,0x52,0x27,0xa5,0xf4,0x6c,0x46,0x05, /* '.K=./...R'..lF. */ \
	0xaf,0xd5,0xc2,0x32,0xa3,0xe9,0x3d,0x28,0x90,0x42,0x0d,0x38,0x45,0x44,0xd3,0x0f, /* ...2..=(.B.8ED.. */ \
	0x4a,0x6c,0xbf,0x55,0xd4,0x33,0x27,0x2f,0x3f,0xf2,0xb5,0x95,0x70,0xeb,0xa4,0x7b, /* Jl.U.3'/?...p..{ */ \
	0x0f,0xb6,0x1e,0xbb,0x14,0x54,0x3e,0x8a,0x73,0x95,0x38,0xb9,0x55,0x7c,0x7d,0x08, /* .....T>.s.8.U|}. */ \
	0xb6,0xf2,0x13,0xc8,0xea,0x38,0x8d,0x3c,0xfd,0x77,0xe5,0x2d,0x47,0xcf,0xac,0xfd, /* .....8.<.w.-G... */ \
	0xe5,0xc1,0x84,0xd0,0xb2,0x51,0xf4,0x0e,0x90,0x98,0x9d,0x8c,0x81,0x8d,0xc3,0x68, /* .....Q.........h */ \
	0xee,0xf0,0xb0,0x57,0x0c,0xbd,0x6e,0xef,0xae,0x13,0x8f,0xa7,0x2d,0x07,0x09,0xdb, /* ...W..n.....-... */ \
	0xfd,0xca,0xb7,0xdb,0x94,0xa8,0x43,0x87,0x0e,0x95,0x97,0x97,0xbb,0xdd,0xbd,0x2c, /* ......C........, */ \
	0x70,0xdc,0x2d,0xf6,0xad,0x10,0x7f,0xd8,0x80,0x9d,0xab,0x49,0xca,0x69,0x46,0x2c, /* p.-........I.iF, */ \
	0x25,0x85,0xdb,0x47,0x92,0x9e,0x44,0xbf,0x93,0x7b,0x7d,0x8b,0xdc,0x8e,0x4f,0x40, /* %..G..D..{}...O@ */ \
	0xd4,0x18,0xda,0x8a,0x6d,0x05,0x47,0x94,0x91,0x21,0x4b,0x70,0x8a,0x80,0xd7,0xb2, /* ....m.G..!Kp.... */ \
	0xbe,0x69,0x5e,0x69,0xac,0x5b,0xb7,0x6e,0xda,0xb4,0x69,0xf3,0xe7,0xcf,0x7f,0xf2, /* .i^i.[.n..i..... */ \
	0xc9,0x27,0x51,0xf7,0x1f,0xa2,0xf5,0x88,0xd8,0xb5,0x44,0x9c,0x78,0x5f,0x3c,0x37, /* .'Q.......D.x_<7 */ \
	0xee,0x3c,0x84,0xc8,0xe3,0xc1,0xc7,0x48,0x05,0xf2,0x7c,0x72,0xdc,0xef,0x70,0x02, /* .<.....H..|r..p. */ \
	0x7c,0x8b,0x3a,0x4e,0x60,0x5c,0x4c,0x67,0x64,0xbf,0xf2,0xc3,0x07,0x78,0xff,0x3a, /* |.:N`\Lgd....x.: */ \
	0x72,0xe4,0xc8,0x33,0xcf,0x3c,0xb3,0x70,0xe1,0xc2,0x8a,0x8a,0x8a,0xdc,0xdc,0xdc, /* r..3.<.p........ */ \
	0x82,0x82,0xc0,0x13,0x4b,0xcb,0x87,0x62,0x6d,0x9e,0x38,0xbc,0x46,0xbc,0x9d,0x25, /* ....K..bm.8.F..% */ \
	0xd2,0x07,0xb8,0x21,0x44,0xaa,0x7d,0x5c,0x9e,0x25,0xd4,0x73,0x5c,0xce,0xae,0x45, /* ...!D.}\.%.s\..E */ \
	0x1e,0x2a,0xea,0xb1,0x41,0x60,0x83,0xcb,0xff,0xb1,0x99,0xbb,0x36,0x6d,0xda,0x54, /* ....A`......6m.T */ \
	0x56,0x56,0x56,0x5a,0x5a,0x3a,0x7d,0xfa,0xf4,0xa5,0x4b,0x97,0xbe,0xfb,0xee,0xbb, /* VVVZZ:}...K..... */ \
	0x41,0x7d,0xb1,0xd5,0x10,0xbf,0x5e,0x20,0x2a,0x73,0xc5,0xac,0x0c,0x31,0x79,0xc8, /* A}....^ .s...1y. */ \
	0xe1,0xf1,0xfd,0xeb,0x53,0x43,0x1a,0x52,0x69,0x7f,0x0a,0x3f,0xfb,0xc6,0xd2,0x1e, /* ....SC.Ri..?.... */ \
	0x44,0xd1,0x28,0xaa,0x44,0x2a,0x40,0x50,0xa5,0x0f,0xef,0x39,0xf3,0x5c,0xba,0x74, /* D.(.D.@P...9.\.t */ \
	0x69,0xc5,0x8a,0x15,0x38,0xdf,0x2f,0x5f,0xbe,0x7c,0xde,0xbc,0x79,0x33,0x67,0xce, /* i...8./_.|..y3g. */ \
	0xbc,0x9d,0xbb,0x9b,0x0e,0xdc,0xb4,0xe7,0x8a,0x05,0x33,0xc4,0x4b,0x0f,0x7d,0x3e, /* ..........3.K.}> */ \
	0x2d,0xf1,0xd4,0x63,0x83,0xdc,0x0f,0x44,0xd4,0xa5,0x86,0x6d,0x4f,0xee,0xb7,0x09, /* -..c...D...mO... */ \
	0x7e,0xc1,0x59,0x08,0xe1,0x84,0xc3,0xd8,0xf3,0x5f,0xdf,0xbc,0x67,0x6b,0xaf,0xfd, /* ~.Y......_..gk.. */ \
	0xab,0xad,0xad,0x0d,0xf2,0x17,0x2d,0x5a,0x84,0xbf,0x10,0x77,0xee,0xfc,0xf2,0x13, /* ......-Z...w.... */ \
	0x4b,0xfd,0xb6,0x6b,0xc5,0xb3,0x4f,0x7d,0x67,0x62,0xd3,0xa4,0xe8,0x86,0x87,0xef, /* K..k..O}gb...... */ \
	0x71,0x4e,0x8c,0xda,0x35,0x69,0xd8,0x8e,0x97,0xfe,0xfe,0xf7,0xf6,0xa2,0x8f,0x3f, /* qN..5i.........? */ \
	0x6b,0xbb,0x7a,0xbb,0x5e,0x27,0x4f,0x9e,0xfc,0x52,0xc9,0xbe,0x72,0x3b,0xf9,0x5f, /* k.z.^'O..R..r;._ */ \
	0xd0,0xc5,0x27,0x5f,0xfe,0x71,0x81,0xcf,0x4d,0xa2,0x3c,0x24,0x9d,0x0c,0xfc,0xc9, /* ..'_.q..M.<$.... */ \
	0x19,0x07,0xc8,0xe8,0x0e,0xb1,0x65,0xdc,0x0c,0xa9,0xcd,0xbb,0x15,0xda,0xc6,0x20, /* ......e........  */ \
	0x84,0xa5,0xed,0xf3,0xbc,0xa8,0xf6,0xee,0x8c,0xa8,0xba,0xee,0xd8,0xb8,0xba,0xce, /* ................ */ \
	0xd8,0x8c,0xa2,0xce,0xc8,0x8c,0xa2,0xb6,0xc8,0x8c,0xc5,0xed,0x94,0x17,0x55,0x47, /* ..............UG */ \
	0x6f,0xc4,0x15,0xd0,0xad,0x8c,0x22,0xdb,0xcd,0x8c,0x28,0x5b,0x77,0x6c,0x94,0x6d, /* o....."...([wl.m */ \
	0x7e,0x6c,0x5c,0xed,0x9c,0xc8,0xb8,0x36,0xac,0x7d,0x40,0x16,0x64,0x4e,0x86,0xfc, /* ~l\....6.}@.dN.. */ \
	0xda,0x5b,0x14,0x52,0x2b,0x28,0xa4,0x0d,0xe3,0xde,0x10,0x9d,0x51,0x37,0x7a,0xff, /* .[.R+(......Q7z. */ \
	0x9d,0x62,0xde,0x9b,0x85,0x05,0x57,0xda,0x66,0xbe,0xbe,0xba,0x37,0xfb,0xea,0xde, /* .b....W.f...7... */ \
	0xec,0xab,0x7b,0xb3,0xff,0x7f,0xf7,0x66,0x66,0x39,0x5b,0x55,0x85,0x1d,0xa4,0xb4, /* ..{....ff9[U.... */ \
	0xca,0x7b,0x81,0xd6,0xab,0xd4,0x54,0x15,0x86,0xc9,0x02,0x45,0x32,0xb5,0xe8,0x2b, /* .{....T....E2..+ */ \
	0xbd,0xa9,0x57,0xaa,0x8d,0x98,0x18,0xf3,0x7e,0xcd,0x60,0x1e,0xcd,0xe2,0x4f,0xee, /* ..W.....~.`...O. */ \
	0x2c,0x34,0xbc,0x97,0x6f,0x26,0x4b,0x66,0x66,0x55,0x0f,0xd9,0x63,0xf4,0x26,0x33, /* ,4..o&KffU..c.&3 */ \
	0x87,0x3f,0x83,0xa7,0x07,0xed,0x68,0xf4,0x4a,0xd0,0xfc,0xe4,0xbb,0x1b,0x2a,0x15, /* .?....h.J....... */ \
	0xb6,0x90,0xeb,0x8a,0x5e,0xed,0xaf,0x40,0x73,0x93,0x44,0x1a,0x11,0x2c,0x4d,0xde, /* ....^..@s.D..,M. */ \
	0xaa,0x55,0x51,0xaf,0xd2,0x7c,0xaa,0x07,0xe9,0xe6,0x6a,0xc0,0x9f,0x27,0x1e,0x46, /* .UQ..|....j..'.F */ \
	0x16,0x5e,0xf5,0xd1,0xab,0x29,0xa0,0x34,0xa1,0x4f,0xb5,0x57,0x5d,0x2f,0x27,0x5d, /* .^...).4.O.W]/'] */ \
	0x24,0xef,0x69,0x1c,0xc8,0x52,0xb3,0xda,0xe8,0x34,0x4c,0x0b,0x9f,0xd5,0x2e,0xaf, /* $.i..R...4L..... */ \
	0xd7,0x7c,0xc8,0x1a,0xdf,0x6c,0xbd,0x87,0xe8,0xc2,0xcc,0xea,0xc6,0x30,0xa9,0xd4, /* .|...l.......0.. */ \
	0xc5,0x9e,0x21,0x0b,0x9d,0xa5,0xa6,0xf5,0xab,0x8d,0xcc,0x0e,0x87,0x91,0xc5,0xd5, /* ..!............. */ \
	0x4a,0xa7,0xf7,0x3f,0x39,0xeb,0x7d,0x82,0xc8,0x70,0x66,0x75,0x81,0x8e,0x8e,0x57, /* J..?9.}..pfu...W */ \
	0x82,0xd1,0xaf,0x28,0x3a,0x1b,0xad,0x47,0x25,0x74,0xf2,0x9a,0xa6,0x91,0x6f,0x46, /* ...(:..G%t....oF */ \
	0x61,0x6f,0xa3,0xd4,0xe2,0xbb,0x23,0x25,0x87,0xd3,0x6b,0x9a,0x6a,0xc3,0x59,0x2a, /* ao....#%..k.j.Y. */ \
	0x8d,0xc1,0xe6,0x2a,0xbc,0xe6,0x95,0xee,0x34,0xf5,0xbc,0x5a,0x28,0x65,0xb2,0xb5, /* ........4..Z(e.. */ \
	0x9d,0x52,0x87,0x00,0xe9,0xd5,0xea,0x82,0x94,0x1a,0x1c,0x60,0xf0,0x76,0x6f,0x34, /* .R.........`.vo4 */ \
	0xbc,0xdd,0x3d,0x86,0x53,0x1d,0x3f,0xdc,0xf0,0x8c,0x53,0x19,0x81,0x2e,0x22,0x4e, /* ..=.S.?...S..."N */ \
	0x34,0xf9,0x1f,0xbe,0x6b,0xa5,0x4e,0xe7,0x59,0xc5,0xc8,0x0c,0x46,0xa6,0x6c,0x70, /* 4...k.N.Y...F.lp */ \
	0x14,0x65,0x6a,0xa6,0x72,0x5e,0x23,0x36,0xb3,0x0a,0x32,0x5c,0xe4,0x0d,0x70,0x58, /* .ej.r^#6..2\..pX */ \
	0x66,0x07,0xa6,0x5e,0xe8,0x74,0xfa,0x3c,0xdc,0xcc,0xf1,0x15,0x56,0xda,0x55,0xad, /* f..^.t.<....V.U. */ \
	0x82,0x30,0x2c,0xab,0xfa,0x62,0xa1,0x9c,0x46,0x4d,0x87,0xb4,0x94,0xa7,0xb9,0x59, /* .0,..b..FM.....Y */ \
	0xce,0xd1,0x1b,0xa2,0x46,0x18,0x6a,0x0e,0x1c,0x8a,0x06,0x9f,0x1f,0x7c,0xc9,0x64, /* ....F.j......|.d */ \
	0x68,0xe8,0x1d,0xbe,0x4e,0xc3,0x43,0x9d,0x83,0xa2,0x3b,0xce,0x47,0x9b,0x3a,0x36, /* h...N.C...;.G.:6 */ \
	0xbb,0x7b,0x51,0xd9,0x9c,0x97,0x3a,0x2e,0x0c,0xea,0xb8,0xee,0xd5,0xc1,0xed,0x6e, /* .{Q...:........n */ \
	0xe8,0xa1,0xb2,0x4b,0xe8,0x6a,0x79,0x77,0xf9,0xf9,0xd9,0x5e,0x25,0x31,0xcd,0x86, /* ...K.jyw...^%1.. */ \
	0x06,0x93,0x6a,0x38,0x2e,0x32,0xaa,0xab,0xfb,0xc2,0x39,0xff,0x65,0xe6,0x71,0xb3, /* ..j8.2....9.e.q. */ \
	0x29,0x9d,0x8e,0x6a,0xdf,0xe2,0x0c,0x08,0x62,0x2f,0x9d,0xfc,0xe8,0xff,0xb7,0xce, /* )..j....b/...... */ \
	0x29,0xe6,0x01,0xa5,0x1f,0xdd,0xa6,0xd8,0xfe,0x82,0x7b,0x67,0x94,0xf0,0xa2,0xec, /* ).........{g.... */ \
	0xec,0xe2,0x1e,0x69,0x45,0xf2,0xae,0x58,0xde,0x46,0x4b,0xaa,0xae,0xfb,0x23,0xc2, /* ...iE..X.FK...#. */ \
	0x73,0x74,0x2f,0x42,0xb6,0x4b,0x74,0x5f,0xb1,0xf9,0xda,0x15,0x92,0xa9,0xa7,0xfb, /* st/B.Kt_........ */ \
	0x1c,0xbe,0x76,0xb6,0x2b,0x79,0x39,0x92,0x53,0xdd,0x72,0x9b,0x1d,0x2a,0xe4,0xbb, /* ..v.+y9.S.r..... */ \
	0x67,0xbc,0x32,0xbe,0x07,0xb7,0x7b,0xf5,0xf1,0xde,0x7f,0xf3,0xd4,0x58,0xcd,0x12, /* g.2...{......X.. */ \
	0x1e,0xd8,0x22,0x91,0x65,0x45,0xdc,0xb6,0x7b,0x5f,0x16,0x7b,0x8e,0x0d,0x9c,0xac, /* ..".eE..{_.{.... */ \
	0x87,0x64,0x2f,0xb1,0xe7,0xd8,0xc9,0x52,0x21,0x85,0x4a,0x64,0x59,0x9f,0x76,0x85, /* .d/....R!.JdY.v. */ \
	0xea,0x19,0x61,0xca,0xcc,0xd1,0xe7,0x4b,0x4a,0x4e,0x99,0x1a,0x48,0x29,0xe7,0x63, /* ..a....KJN..H).c */ \
	0xe7,0xb6,0x8f,0x9d,0x91,0x11,0xba,0x39,0x90,0xd4,0x53,0x5e,0xdf,0xdb,0xe5,0x14, /* .......9..S^.... */ \
	0x58,0x86,0xaa,0x79,0xb9,0xd4,0x0c,0x4a,0xb8,0x2a,0xa5,0x44,0xc8,0x09,0xa3,0x43, /* X..y...J...D...C */ \
	0x85,0x34,0x51,0x31,0xd8,0x8b,0x6c,0x3e,0x6b,0x4b,0xa3,0x61,0x63,0xf3,0xb3,0xaf, /* .4Q1..l>kK.ac... */ \
	0xad,0x88,0xdb,0x3e,0xfb,0x83,0x9d,0xdb,0xbe,0x1e,0x65,0x24,0xf9,0xfd,0xfc,0x17, /* ...>......e$.... */ \
	0x9e,0x3d,0xdf,0xf4,0xaf,0xae,0xcf,0xf7,0x0b,0x17,0xbf,0xb6,0x68,0x8b,0x42,0x14, /* .=..........h.B. */ \
	0x84,0x88,0x5b,0xb7,0x89,0xf3,0x9b,0xa1,0xb5,0xe2,0x96,0x85,0xe3,0xbc,0xfd,0xf3, /* ..[............. */ \
	0x8c,0xa8,0xf6,0x3f,0xaa,0x38,0xaf,0xef,0x1c,0x90,0x51,0xd4,0xc5,0xa0,0xe2,0x3c, /* ...?.8....Q....< */ \
	0xae,0x8e,0x6e,0xc5,0xd5,0x73,0x9c,0xe7,0xcb,0x38,0xcf,0x30,0xe3,0x7c,0x40,0x46, /* ..n..s...8.0.|@F */ \
	0x5b,0x7c,0x9f,0x38,0x6f,0x53,0x71,0x8e,0x71,0x01,0x7f,0x02,0xd6,0xb6,0x18,0x5d, /* [|.8oSq.q......] */ \
	0x96,0x22,0x00,0x00,0x07,0x00,0x00,0x00,0x8a,0x10,0x78,0x00,0x00,0x00,0x07,0x00, /* ."........x..... */ \
	0x00,0x00,0x6a,0x7b,0x62,0x00,0x00,0x00,0x02,0x00,0x00,0x00,0xcc,0x83,0xc4,0x00, /* ..j{b........... */ \
	0x00,0x00,0x0d,0x00,0x00,0x00,0x0a,0xa3,0x16,0x00,0x00,0x00,0x07,0x00,0x00,0x00, /* ................ */ \
	0x46,0xce,0x54,0x00,0x00,0x00,0x01,0x00,0x00,0x00,0xe6,0xd2,0xb6,0x00,0x00,0x00, /* F.T............. */ \
	0x01,0x00,0x00,0x00,0x6a,0xfd,0x00,0x00,0x00,0x00,0x02,0x00,0x00,0x00,0x3c,0x64, /* ....j.........<d */ \
	0x69,0x76,0x20,0x63,0x6c,0x61,0x73,0x73,0x3d,0x22,0x73,0x70,0x61,0x63,0x65,0x72, /* iv class="spacer */ \
	0x22,0x3e,0x26,0x6e,0x62,0x73,0x70,0x3b,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a, /* ">&nbsp;</div>.. */ \
	0x3c,0x64,0x69,0x76,0x20,0x69,0x64,0x3d,0x22,0x66,0x6f,0x6f,0x74,0x65,0x72,0x22, /* <div id="footer" */ \
	0x3e,0x43,0x6f,0x70,0x79,0x72,0x69,0x67,0x68,0x74,0x20,0x26,0x63,0x6f,0x70,0x79, /* >Copyright &copy */ \
	0x3b,0x20,0x32,0x30,0x31,0x35,0x20,0x4d,0x69,0x63,0x72,0x6f,0x63,0x68,0x69,0x70, /* ; 2015 Microchip */ \
	0x20,0x54,0x65,0x63,0x68,0x6e,0x6f,0x6c,0x6f,0x67,0x79,0x2c,0x20,0x49,0x6e,0x63, /*  Technology, Inc */ \
	0x2e,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x2f,0x64,0x69,0x76, /* .</div>....</div */ \
	0x3e,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x3c,0x2f,0x64, /* ></div></div></d */ \
	0x69,0x76,0x3e,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x2f,0x62, /* iv></div>....</b */ \
	0x6f,0x64,0x79,0x3e,0x0d,0x0a,0x3c,0x2f,0x68,0x74,0x6d,0x6c,0x3e,0x0d,0x0a,0x3c, /* ody>..</html>..< */ \
	0x21,0x44,0x4f,0x43,0x54,0x59,0x50,0x45,0x20,0x68,0x74,0x6d,0x6c,0x20,0x50,0x55, /* !DOCTYPE html PU */ \
	0x42,0x4c,0x49,0x43,0x20,0x22,0x2d,0x2f,0x2f,0x57,0x33,0x43,0x2f,0x2f,0x44,0x54, /* BLIC "-//W3C//DT */ \
	0x44,0x20,0x58,0x48,0x54,0x4d,0x4c,0x20,0x31,0x2e,0x30,0x20,0x53,0x74,0x72,0x69, /* D XHTML 1.0 Stri */ \
	0x63,0x74,0x2f,0x2f,0x45,0x4e,0x22,0x0d,0x0a,0x20,0x20,0x22,0x68,0x74,0x74,0x70, /* ct//EN"..  "http */ \
	0x3a,0x2f,0x2f,0x77,0x77,0x77,0x2e,0x77,0x33,0x2e,0x6f,0x72,0x67,0x2f,0x54,0x52, /* ://www.w3.org/TR */ \
	0x2f,0x78,0x68,0x74,0x6d,0x6c,0x31,0x2f,0x44,0x54,0x44,0x2f,0x78,0x68,0x74,0x6d, /* /xhtml1/DTD/xhtm */ \
	0x6c,0x31,0x2d,0x73,0x74,0x72,0x69,0x63,0x74,0x2e,0x64,0x74,0x64,0x22,0x3e,0x0d, /* l1-strict.dtd">. */ \
	0x0a,0x3c,0x68,0x74,0x6d,0x6c,0x20,0x78,0x6d,0x6c,0x6e,0x73,0x3d,0x22,0x68,0x74, /* .<html xmlns="ht */ \
	0x74,0x70,0x3a,0x2f,0x2f,0x77,0x77,0x77,0x2e,0x77,0x33,0x2e,0x6f,0x72,0x67,0x2f, /* tp://www.w3.org/ */ \
	0x31,0x39,0x39,0x39,0x2f,0x78,0x68,0x74,0x6d,0x6c,0x22,0x20,0x78,0x6d,0x6c,0x3a, /* 1999/xhtml" xml: */ \
	0x6c,0x61,0x6e,0x67,0x3d,0x22,0x65,0x6e,0x22,0x20,0x6c,0x61,0x6e,0x67,0x3d,0x22, /* lang="en" lang=" */ \
	0x65,0x6e,0x22,0x3e,0x0d,0x0a,0x3c,0x68,0x65,0x61,0x64,0x3e,0x0d,0x0a,0x20,0x20, /* en">..<head>..   */ \
	0x20,0x20,0x3c,0x74,0x69,0x74,0x6c,0x65,0x3e,0x57,0x69,0x2d,0x46,0x69,0x20,0x47, /*   <title>Wi-Fi G */ \
	0x20,0x44,0x65,0x6d,0x6f,0x20,0x42,0x6f,0x61,0x72,0x64,0x3c,0x2f,0x74,0x69,0x74, /*  Demo Board</tit */ \
	0x6c,0x65,0x3e,0x0d,0x0a,0x20,0x20,0x20,0x20,0x3c,0x6c,0x69,0x6e,0x6b,0x20,0x68, /* le>..    <link h */ \
	0x72,0x65,0x66,0x3d,0x22,0x2f,0x6d,0x63,0x68,0x70,0x2e,0x63,0x73,0x73,0x22,0x20, /* ref="/mchp.css"  */ \
	0x72,0x65,0x6c,0x3d,0x22,0x73,0x74,0x79,0x6c,0x65,0x73,0x68,0x65,0x65,0x74,0x22, /* rel="stylesheet" */ \
	0x20,0x74,0x79,0x70,0x65,0x3d,0x22,0x74,0x65,0x78,0x74,0x2f,0x63,0x73,0x73,0x22, /*  type="text/css" */ \
	0x20,0x2f,0x3e,0x0d,0x0a,0x20,0x20,0x20,0x20,0x3c,0x73,0x63,0x72,0x69,0x70,0x74, /*  />..    <script */ \
	0x20,0x73,0x72,0x63,0x3d,0x22,0x2f,0x6d,0x63,0x68,0x70,0x2e,0x6a,0x73,0x22,0x20, /*  src="/mchp.js"  */ \
	0x74,0x79,0x70,0x65,0x3d,0x22,0x74,0x65,0x78,0x74,0x2f,0x6a,0x61,0x76,0x61,0x73, /* type="text/javas */ \
	0x63,0x72,0x69,0x70,0x74,0x22,0x3e,0x3c,0x2f,0x73,0x63,0x72,0x69,0x70,0x74,0x3e, /* cript"></script> */ \
	0x0d,0x0a,0x3c,0x2f,0x68,0x65,0x61,0x64,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x62,0x6f, /* ..</head>....<bo */ \
	0x64,0x79,0x20,0x6f,0x6e,0x6c,0x6f,0x61,0x64,0x3d,0x22,0x6e,0x65,0x77,0x41,0x4a, /* dy onload="newAJ */ \
	0x41,0x58,0x43,0x6f,0x6d,0x6d,0x61,0x6e,0x64,0x28,0x27,0x73,0x74,0x61,0x74,0x75, /* AXCommand('statu */ \
	0x73,0x2e,0x78,0x6d,0x6c,0x27,0x29,0x3b,0x22,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x64, /* s.xml');">....<d */ \
	0x69,0x76,0x20,0x69,0x64,0x3d,0x22,0x73,0x68,0x61,0x64,0x6f,0x77,0x2d,0x6f,0x6e, /* iv id="shadow-on */ \
	0x65,0x22,0x3e,0x3c,0x64,0x69,0x76,0x20,0x69,0x64,0x3d,0x22,0x73,0x68,0x61,0x64, /* e"><div id="shad */ \
	0x6f,0x77,0x2d,0x74,0x77,0x6f,0x22,0x3e,0x3c,0x64,0x69,0x76,0x20,0x69,0x64,0x3d, /* ow-two"><div id= */ \
	0x22,0x73,0x68,0x61,0x64,0x6f,0x77,0x2d,0x74,0x68,0x72,0x65,0x65,0x22,0x3e,0x3c, /* "shadow-three">< */ \
	0x64,0x69,0x76,0x20,0x69,0x64,0x3d,0x22,0x73,0x68,0x61,0x64,0x6f,0x77,0x2d,0x66, /* div id="shadow-f */ \
	0x6f,0x75,0x72,0x22,0x3e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x69,0x64,0x3d,0x22, /* our">..<div id=" */ \
	0x70,0x61,0x67,0x65,0x22,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x73, /* page">....<div s */ \
	0x74,0x79,0x6c,0x65,0x3d,0x22,0x70,0x61,0x64,0x64,0x69,0x6e,0x67,0x3a,0x30,0x20, /* tyle="padding:0  */ \
	0x30,0x20,0x36,0x35,0x70,0x78,0x20,0x35,0x70,0x78,0x22,0x3e,0x3c,0x69,0x6d,0x67, /* 0 65px 5px"><img */ \
	0x20,0x73,0x72,0x63,0x3d,0x22,0x69,0x6d,0x61,0x67,0x65,0x73,0x2f,0x6d,0x63,0x68, /*  src="images/mch */ \
	0x70,0x2e,0x67,0x69,0x66,0x22,0x20,0x61,0x6c,0x74,0x3d,0x22,0x4d,0x69,0x63,0x72, /* p.gif" alt="Micr */ \
	0x6f,0x63,0x68,0x69,0x70,0x22,0x20,0x61,0x6c,0x69,0x67,0x6e,0x3d,0x22,0x6c,0x65, /* ochip" align="le */ \
	0x66,0x74,0x22,0x2f,0x3e,0x3c,0x69,0x6d,0x67,0x20,0x73,0x72,0x63,0x3d,0x22,0x69, /* ft"/><img src="i */ \
	0x6d,0x61,0x67,0x65,0x73,0x2f,0x68,0x61,0x72,0x6d,0x6f,0x6e,0x79,0x2e,0x67,0x69, /* mages/harmony.gi */ \
	0x66,0x22,0x20,0x61,0x6c,0x74,0x3d,0x22,0x48,0x61,0x72,0x6d,0x6f,0x6e,0x79,0x22, /* f" alt="Harmony" */ \
	0x20,0x61,0x6c,0x69,0x67,0x6e,0x3d,0x22,0x72,0x69,0x67,0x68,0x74,0x22,0x2f,0x3e, /*  align="right"/> */ \
	0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x69, /* </div>....<div i */ \
	0x64,0x3d,0x22,0x74,0x69,0x74,0x6c,0x65,0x22,0x3e,0x3c,0x64,0x69,0x76,0x20,0x63, /* d="title"><div c */ \
	0x6c,0x61,0x73,0x73,0x3d,0x22,0x72,0x69,0x67,0x68,0x74,0x22,0x3e,0x4d,0x69,0x63, /* lass="right">Mic */ \
	0x72,0x6f,0x63,0x68,0x69,0x70,0x20,0x57,0x69,0x2d,0x46,0x69,0x20,0x47,0x20,0x44, /* rochip Wi-Fi G D */ \
	0x65,0x6d,0x6f,0x20,0x41,0x70,0x70,0x6c,0x69,0x63,0x61,0x74,0x69,0x6f,0x6e,0x3c, /* emo Application< */ \
	0x2f,0x64,0x69,0x76,0x3e,0x3c,0x73,0x70,0x61,0x6e,0x20,0x69,0x64,0x3d,0x22,0x68, /* /div><span id="h */ \
	0x65,0x6c,0x6c,0x6f,0x22,0x3e,0x26,0x6e,0x62,0x73,0x70,0x3b,0x3c,0x2f,0x73,0x70, /* ello">&nbsp;</sp */ \
	0x61,0x6e,0x3e,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x64,0x69, /* an></div>....<di */ \
	0x76,0x20,0x69,0x64,0x3d,0x22,0x6d,0x65,0x6e,0x75,0x22,0x3e,0x0d,0x0a,0x20,0x20, /* v id="menu">..   */ \
	0x20,0x20,0x3c,0x61,0x20,0x68,0x72,0x65,0x66,0x3d,0x22,0x2f,0x69,0x6e,0x64,0x65, /*   <a href="/inde */ \
	0x78,0x2e,0x68,0x74,0x6d,0x22,0x3e,0x4f,0x76,0x65,0x72,0x76,0x69,0x65,0x77,0x3c, /* x.htm">Overview< */ \
	0x2f,0x61,0x3e,0x0d,0x0a,0x20,0x20,0x20,0x20,0x3c,0x61,0x20,0x68,0x72,0x65,0x66, /* /a>..    <a href */ \
	0x3d,0x22,0x2f,0x6d,0x72,0x66,0x32,0x34,0x77,0x67,0x2e,0x68,0x74,0x6d,0x22,0x3e, /* ="/mrf24wg.htm"> */ \
	0x4d,0x52,0x46,0x32,0x34,0x57,0x47,0x30,0x4d,0x41,0x2f,0x4d,0x42,0x3c,0x2f,0x61, /* MRF24WG0MA/MB</a */ \
	0x3e,0x0d,0x0a,0x20,0x20,0x20,0x20,0x3c,0x61,0x20,0x68,0x72,0x65,0x66,0x3d,0x22, /* >..    <a href=" */ \
	0x2f,0x63,0x6f,0x6e,0x66,0x69,0x67,0x75,0x72,0x65,0x2e,0x68,0x74,0x6d,0x22,0x3e, /* /configure.htm"> */ \
	0x4e,0x65,0x74,0x77,0x6f,0x72,0x6b,0x20,0x43,0x6f,0x6e,0x66,0x69,0x67,0x75,0x72, /* Network Configur */ \
	0x61,0x74,0x69,0x6f,0x6e,0x3c,0x2f,0x61,0x3e,0x0d,0x0a,0x3c,0x2f,0x64,0x69,0x76, /* ation</a>..</div */ \
	0x3e,0x0d,0x0a,0x7e,0x69,0x6e,0x63,0x3a,0x68,0x65,0x61,0x64,0x65,0x72,0x2e,0x69, /* >..~inc:header.i */ \
	0x6e,0x63,0x7e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x69,0x64,0x3d,0x22,0x63,0x6f, /* nc~..<div id="co */ \
	0x6e,0x74,0x65,0x6e,0x74,0x22,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20, /* ntent">....<div  */ \
	0x69,0x64,0x3d,0x22,0x73,0x74,0x61,0x74,0x75,0x73,0x22,0x3e,0x0d,0x0a,0x09,0x3c, /* id="status">...< */ \
	0x64,0x69,0x76,0x20,0x69,0x64,0x3d,0x22,0x6c,0x6f,0x61,0x64,0x69,0x6e,0x67,0x22, /* div id="loading" */ \
	0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x22,0x64,0x69,0x73,0x70,0x6c,0x61,0x79,0x3a, /*  style="display: */ \
	0x6e,0x6f,0x6e,0x65,0x22,0x3e,0x45,0x72,0x72,0x6f,0x72,0x3a,0x3c,0x62,0x72,0x20, /* none">Error:<br  */ \
	0x2f,0x3e,0x43,0x6f,0x6e,0x6e,0x65,0x63,0x74,0x69,0x6f,0x6e,0x20,0x74,0x6f,0x20, /* />Connection to  */ \
	0x64,0x65,0x6d,0x6f,0x20,0x62,0x6f,0x61,0x72,0x64,0x20,0x77,0x61,0x73,0x20,0x6c, /* demo board was l */ \
	0x6f,0x73,0x74,0x2e,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x09,0x3c,0x64,0x69, /* ost.</div>...<di */ \
	0x76,0x20,0x69,0x64,0x3d,0x22,0x64,0x69,0x73,0x70,0x6c,0x61,0x79,0x22,0x3e,0x0d, /* v id="display">. */ \
	0x0a,0x09,0x09,0x3c,0x73,0x70,0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x22, /* ...<span style=" */ \
	0x66,0x6c,0x6f,0x61,0x74,0x3a,0x72,0x69,0x67,0x68,0x74,0x3b,0x66,0x6f,0x6e,0x74, /* float:right;font */ \
	0x2d,0x73,0x69,0x7a,0x65,0x3a,0x39,0x70,0x78,0x3b,0x66,0x6f,0x6e,0x74,0x2d,0x77, /* -size:9px;font-w */ \
	0x65,0x69,0x67,0x68,0x74,0x3a,0x6e,0x6f,0x72,0x6d,0x61,0x6c,0x3b,0x70,0x61,0x64, /* eight:normal;pad */ \
	0x64,0x69,0x6e,0x67,0x2d,0x74,0x6f,0x70,0x3a,0x38,0x70,0x78,0x3b,0x74,0x65,0x78, /* ding-top:8px;tex */ \
	0x74,0x2d,0x69,0x6e,0x64,0x65,0x6e,0x74,0x3a,0x30,0x70,0x78,0x22,0x3e,0x28,0x63, /* t-indent:0px">(c */ \
	0x6c,0x69,0x63,0x6b,0x20,0x74,0x6f,0x20,0x74,0x6f,0x67,0x67,0x6c,0x65,0x29,0x3c, /* lick to toggle)< */ \
	0x2f,0x73,0x70,0x61,0x6e,0x3e,0x0d,0x0a,0x09,0x09,0x3c,0x70,0x3e,0x4c,0x45,0x44, /* /span>....<p>LED */ \
	0x73,0x3a,0x3c,0x62,0x72,0x20,0x2f,0x3e,0x3c,0x73,0x70,0x61,0x6e,0x20,0x63,0x6c, /* s:<br /><span cl */ \
	0x61,0x73,0x73,0x3d,0x22,0x6c,0x65,0x64,0x73,0x22,0x3e,0x0d,0x0a,0x09,0x09,0x3c, /* ass="leds">....< */ \
	0x61,0x20,0x69,0x64,0x3d,0x22,0x6c,0x65,0x64,0x30,0x22,0x3e,0x26,0x62,0x75,0x6c, /* a id="led0">&bul */ \
	0x6c,0x3b,0x3c,0x2f,0x61,0x3e,0x0d,0x0a,0x09,0x09,0x3c,0x61,0x20,0x69,0x64,0x3d, /* l;</a>....<a id= */ \
	0x22,0x6c,0x65,0x64,0x31,0x22,0x20,0x6f,0x6e,0x63,0x6c,0x69,0x63,0x6b,0x3d,0x22, /* "led1" onclick=" */ \
	0x6e,0x65,0x77,0x41,0x4a,0x41,0x58,0x43,0x6f,0x6d,0x6d,0x61,0x6e,0x64,0x28,0x27, /* newAJAXCommand(' */ \
	0x6c,0x65,0x64,0x73,0x2e,0x63,0x67,0x69,0x3f,0x6c,0x65,0x64,0x3d,0x31,0x27,0x29, /* leds.cgi?led=1') */ \
	0x3b,0x22,0x3e,0x26,0x62,0x75,0x6c,0x6c,0x3b,0x3c,0x2f,0x61,0x3e,0x0d,0x0a,0x09, /* ;">&bull;</a>... */ \
	0x09,0x3c,0x61,0x20,0x69,0x64,0x3d,0x22,0x6c,0x65,0x64,0x32,0x22,0x20,0x6f,0x6e, /* .<a id="led2" on */ \
	0x63,0x6c,0x69,0x63,0x6b,0x3d,0x22,0x6e,0x65,0x77,0x41,0x4a,0x41,0x58,0x43,0x6f, /* click="newAJAXCo */ \
	0x6d,0x6d,0x61,0x6e,0x64,0x28,0x27,0x6c,0x65,0x64,0x73,0x2e,0x63,0x67,0x69,0x3f, /* mmand('leds.cgi? */ \
	0x6c,0x65,0x64,0x3d,0x32,0x27,0x29,0x3b,0x22,0x3e,0x26,0x62,0x75,0x6c,0x6c,0x3b, /* led=2');">&bull; */ \
	0x3c,0x2f,0x61,0x3e,0x0d,0x0a,0x09,0x09,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x3c, /* </a>....</span>< */ \
	0x2f,0x70,0x3e,0x0d,0x0a,0x09,0x09,0x3c,0x70,0x3e,0x42,0x75,0x74,0x74,0x6f,0x6e, /* /p>....<p>Button */ \
	0x3a,0x3c,0x62,0x72,0x20,0x2f,0x3e,0x0d,0x0a,0x09,0x09,0x3c,0x73,0x70,0x61,0x6e, /* :<br />....<span */ \
	0x20,0x69,0x64,0x3d,0x22,0x62,0x74,0x6e,0x30,0x22,0x3e,0x3f,0x3c,0x2f,0x73,0x70, /*  id="btn0">?</sp */ \
	0x61,0x6e,0x3e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x09,0x3c,0x2f,0x64,0x69,0x76,0x3e, /* an></p>...</div> */ \
	0x0d,0x0a,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x68,0x31,0x3e, /* ..</div>....<h1> */ \
	0x57,0x65,0x6c,0x63,0x6f,0x6d,0x65,0x21,0x3c,0x2f,0x68,0x31,0x3e,0x0d,0x0a,0x0d, /* Welcome!</h1>... */ \
	0x0a,0x3c,0x70,0x3e,0x3c,0x2f,0x70,0x3e,0x59,0x6f,0x75,0x20,0x61,0x72,0x65,0x20, /* .<p></p>You are  */ \
	0x63,0x75,0x72,0x72,0x65,0x6e,0x74,0x6c,0x79,0x20,0x63,0x6f,0x6e,0x6e,0x65,0x63, /* currently connec */ \
	0x74,0x65,0x64,0x20,0x74,0x6f,0x3a,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c, /* ted to:</p>....< */ \
	0x74,0x61,0x62,0x6c,0x65,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x22,0x70,0x61,0x64, /* table style="pad */ \
	0x64,0x69,0x6e,0x67,0x2d,0x6c,0x65,0x66,0x74,0x3a,0x20,0x31,0x30,0x70,0x78,0x3b, /* ding-left: 10px; */ \
	0x22,0x3e,0x0d,0x0a,0x3c,0x74,0x72,0x3e,0x3c,0x74,0x64,0x3e,0x3c,0x62,0x3e,0x53, /* ">..<tr><td><b>S */ \
	0x53,0x49,0x44,0x3a,0x3c,0x2f,0x62,0x3e,0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x74,0x64, /* SID:</b></td><td */ \
	0x3e,0x26,0x6e,0x62,0x73,0x70,0x3b,0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x74,0x64,0x3e, /* >&nbsp;</td><td> */ \
	0x7e,0x73,0x73,0x69,0x64,0x7e,0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x2f,0x74,0x72,0x3e, /* ~ssid~</td></tr> */ \
	0x0d,0x0a,0x3c,0x74,0x72,0x3e,0x3c,0x74,0x64,0x3e,0x3c,0x62,0x3e,0x53,0x65,0x63, /* ..<tr><td><b>Sec */ \
	0x75,0x72,0x69,0x74,0x79,0x20,0x54,0x79,0x70,0x65,0x3a,0x3c,0x2f,0x62,0x3e,0x3c, /* urity Type:</b>< */ \
	0x2f,0x74,0x64,0x3e,0x3c,0x74,0x64,0x3e,0x26,0x6e,0x62,0x73,0x70,0x3b,0x3c,0x2f, /* /td><td>&nbsp;</ */ \
	0x74,0x64,0x3e,0x3c,0x74,0x64,0x3e,0x7e,0x63,0x75,0x72,0x72,0x50,0x72,0x69,0x76, /* td><td>~currPriv */ \
	0x61,0x63,0x79,0x7e,0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x2f,0x74,0x72,0x3e,0x0d,0x0a, /* acy~</td></tr>.. */ \
	0x3c,0x74,0x72,0x3e,0x3c,0x74,0x64,0x3e,0x3c,0x62,0x3e,0x57,0x4c,0x41,0x4e,0x20, /* <tr><td><b>WLAN  */ \
	0x54,0x79,0x70,0x65,0x3a,0x3c,0x2f,0x62,0x3e,0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x74, /* Type:</b></td><t */ \
	0x64,0x3e,0x26,0x6e,0x62,0x73,0x70,0x3b,0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x74,0x64, /* d>&nbsp;</td><td */ \
	0x3e,0x7e,0x63,0x75,0x72,0x72,0x57,0x4c,0x41,0x4e,0x7e,0x3c,0x2f,0x74,0x64,0x3e, /* >~currWLAN~</td> */ \
	0x3c,0x2f,0x74,0x72,0x3e,0x0d,0x0a,0x3c,0x74,0x72,0x3e,0x3c,0x74,0x64,0x3e,0x3c, /* </tr>..<tr><td>< */ \
	0x62,0x3e,0x49,0x50,0x20,0x41,0x64,0x64,0x72,0x65,0x73,0x73,0x3a,0x3c,0x2f,0x62, /* b>IP Address:</b */ \
	0x3e,0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x74,0x64,0x3e,0x26,0x6e,0x62,0x73,0x70,0x3b, /* ></td><td>&nbsp; */ \
	0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x74,0x64,0x3e,0x7e,0x69,0x70,0x61,0x64,0x64,0x72, /* </td><td>~ipaddr */ \
	0x7e,0x3c,0x2f,0x74,0x64,0x3e,0x3c,0x2f,0x74,0x72,0x3e,0x0d,0x0a,0x3c,0x74,0x72, /* ~</td></tr>..<tr */ \
	0x3e,0x3c,0x74,0x64,0x3e,0x3c,0x62,0x3e,0x4d,0x6f,0x64,0x75,0x6c,0x65,0x20,0x46, /* ><td><b>Module F */ \
	0x57,0x20,0x56,0x65,0x72,0x73,0x69,0x6f,0x6e,0x3a,0x3c,0x2f,0x62,0x3e,0x3c,0x2f, /* W Version:</b></ */ \
	0x74,0x64,0x3e,0x3c,0x74,0x64,0x3e,0x26,0x6e,0x62,0x73,0x70,0x3b,0x3c,0x2f,0x74, /* td><td>&nbsp;</t */ \
	0x64,0x3e,0x3c,0x74,0x64,0x3e,0x7e,0x66,0x77,0x76,0x65,0x72,0x7e,0x3c,0x2f,0x74, /* d><td>~fwver~</t */ \
	0x64,0x3e,0x3c,0x2f,0x74,0x72,0x3e,0x0d,0x0a,0x3c,0x2f,0x74,0x61,0x62,0x6c,0x65, /* d></tr>..</table */ \
	0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70,0x3e,0x4f,0x6e,0x20,0x74,0x68,0x65,0x20,0x72, /* >....<p>On the r */ \
	0x69,0x67,0x68,0x74,0x20,0x79,0x6f,0x75,0x27,0x6c,0x6c,0x20,0x73,0x65,0x65,0x20, /* ight you'll see  */ \
	0x74,0x68,0x65,0x20,0x63,0x75,0x72,0x72,0x65,0x6e,0x74,0x20,0x73,0x74,0x61,0x74, /* the current stat */ \
	0x75,0x73,0x20,0x6f,0x66,0x20,0x74,0x68,0x65,0x20,0x64,0x65,0x6d,0x6f,0x20,0x62, /* us of the demo b */ \
	0x6f,0x61,0x72,0x64,0x2e,0x20,0x20,0x46,0x6f,0x72,0x20,0x61,0x20,0x71,0x75,0x69, /* oard.  For a qui */ \
	0x63,0x6b,0x0d,0x0a,0x65,0x78,0x61,0x6d,0x70,0x6c,0x65,0x2c,0x20,0x63,0x6c,0x69, /* ck..example, cli */ \
	0x63,0x6b,0x20,0x74,0x68,0x65,0x20,0x4c,0x45,0x44,0x73,0x20,0x74,0x6f,0x20,0x74, /* ck the LEDs to t */ \
	0x6f,0x67,0x67,0x6c,0x65,0x20,0x74,0x68,0x65,0x20,0x6c,0x69,0x67,0x68,0x74,0x73, /* oggle the lights */ \
	0x20,0x6f,0x6e,0x20,0x74,0x68,0x65,0x20,0x62,0x6f,0x61,0x72,0x64,0x2e,0x20,0x20, /*  on the board.   */ \
	0x50,0x72,0x65,0x73,0x73,0x20,0x74,0x68,0x65,0x20,0x70,0x75,0x73,0x68,0x0d,0x0a, /* Press the push.. */ \
	0x62,0x75,0x74,0x74,0x6f,0x6e,0x20,0x61,0x6e,0x64,0x20,0x79,0x6f,0x75,0x27,0x6c, /* button and you'l */ \
	0x6c,0x20,0x73,0x65,0x65,0x20,0x74,0x68,0x65,0x20,0x42,0x75,0x74,0x74,0x6f,0x6e, /* l see the Button */ \
	0x20,0x53,0x74,0x61,0x74,0x75,0x73,0x20,0x75,0x70,0x64,0x61,0x74,0x65,0x20,0x69, /*  Status update i */ \
	0x6d,0x6d,0x65,0x64,0x69,0x61,0x74,0x65,0x6c,0x79,0x2e,0x20,0x20,0x54,0x68,0x69, /* mmediately.  Thi */ \
	0x73,0x20,0x65,0x78,0x61,0x6d,0x70,0x6c,0x65,0x73,0x20,0x75,0x73,0x65,0x73,0x20, /* s examples uses  */ \
	0x41,0x4a,0x41,0x58,0x0d,0x0a,0x74,0x65,0x63,0x68,0x6e,0x69,0x71,0x75,0x65,0x73, /* AJAX..techniques */ \
	0x20,0x74,0x6f,0x20,0x70,0x72,0x6f,0x76,0x69,0x64,0x65,0x20,0x72,0x65,0x61,0x6c, /*  to provide real */ \
	0x2d,0x74,0x69,0x6d,0x65,0x20,0x66,0x65,0x65,0x64,0x62,0x61,0x63,0x6b,0x2e,0x3c, /* -time feedback.< */ \
	0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70,0x3e,0x54,0x68,0x65,0x72,0x65,0x20, /* /p>....<p>There  */ \
	0x61,0x72,0x65,0x20,0x74,0x68,0x72,0x65,0x65,0x20,0x6d,0x65,0x6e,0x75,0x20,0x69, /* are three menu i */ \
	0x74,0x65,0x6d,0x73,0x20,0x6f,0x6e,0x20,0x74,0x68,0x65,0x20,0x6c,0x65,0x66,0x74, /* tems on the left */ \
	0x20,0x68,0x61,0x6e,0x64,0x20,0x73,0x69,0x64,0x65,0x2e,0x20,0x20,0x54,0x68,0x65, /*  hand side.  The */ \
	0x20,0x66,0x69,0x72,0x73,0x74,0x20,0x69,0x73,0x20,0x74,0x68,0x65,0x20,0x63,0x75, /*  first is the cu */ \
	0x72,0x72,0x65,0x6e,0x74,0x20,0x70,0x61,0x67,0x65,0x20,0x79,0x6f,0x75,0x20,0x73, /* rrent page you s */ \
	0x65,0x65,0x2c,0x0d,0x0a,0x77,0x68,0x69,0x63,0x68,0x20,0x73,0x68,0x6f,0x77,0x73, /* ee,..which shows */ \
	0x20,0x74,0x68,0x65,0x20,0x73,0x74,0x61,0x74,0x75,0x73,0x20,0x6f,0x66,0x20,0x74, /*  the status of t */ \
	0x68,0x65,0x20,0x4c,0x45,0x44,0x73,0x20,0x61,0x6e,0x64,0x20,0x70,0x75,0x73,0x68, /* he LEDs and push */ \
	0x20,0x62,0x75,0x74,0x74,0x6f,0x6e,0x2e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a, /*  button.</p>.... */ \
	0x3c,0x70,0x3e,0x54,0x68,0x65,0x20,0x73,0x65,0x63,0x6f,0x6e,0x64,0x20,0x6d,0x65, /* <p>The second me */ \
	0x6e,0x75,0x20,0x69,0x74,0x65,0x6d,0x20,0x28,0x57,0x69,0x2d,0x46,0x69,0x20,0x47, /* nu item (Wi-Fi G */ \
	0x20,0x44,0x65,0x6d,0x6f,0x29,0x2c,0x20,0x77,0x69,0x6c,0x6c,0x20,0x64,0x69,0x73, /*  Demo), will dis */ \
	0x70,0x6c,0x61,0x79,0x20,0x61,0x20,0x70,0x61,0x67,0x65,0x20,0x77,0x69,0x74,0x68, /* play a page with */ \
	0x20,0x69,0x6e,0x66,0x6f,0x72,0x6d,0x61,0x74,0x69,0x6f,0x6e,0x20,0x61,0x62,0x6f, /*  information abo */ \
	0x75,0x74,0x20,0x74,0x68,0x65,0x20,0x38,0x30,0x32,0x2e,0x31,0x31,0x62,0x2f,0x67, /* ut the 802.11b/g */ \
	0x20,0x52,0x46,0x20,0x54,0x72,0x61,0x6e,0x73,0x63,0x65,0x69,0x76,0x65,0x72,0x20, /*  RF Transceiver  */ \
	0x4d,0x6f,0x64,0x75,0x6c,0x65,0x20,0x62,0x65,0x69,0x6e,0x67,0x20,0x75,0x73,0x65, /* Module being use */ \
	0x64,0x20,0x66,0x6f,0x72,0x20,0x74,0x68,0x69,0x73,0x20,0x64,0x65,0x6d,0x6f,0x2e, /* d for this demo. */ \
	0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70,0x3e,0x54,0x68,0x65,0x20,0x74, /* </p>....<p>The t */ \
	0x68,0x69,0x72,0x64,0x20,0x6d,0x65,0x6e,0x75,0x20,0x69,0x74,0x65,0x6d,0x20,0x28, /* hird menu item ( */ \
	0x4e,0x65,0x74,0x77,0x6f,0x72,0x6b,0x20,0x43,0x6f,0x6e,0x66,0x69,0x67,0x75,0x72, /* Network Configur */ \
	0x61,0x74,0x69,0x6f,0x6e,0x29,0x2c,0x20,0x77,0x69,0x6c,0x6c,0x20,0x64,0x69,0x73, /* ation), will dis */ \
	0x70,0x6c,0x61,0x79,0x20,0x61,0x20,0x70,0x61,0x67,0x65,0x20,0x74,0x68,0x61,0x74, /* play a page that */ \
	0x20,0x77,0x69,0x6c,0x6c,0x20,0x61,0x6c,0x6c,0x6f,0x77,0x20,0x79,0x6f,0x75,0x20, /*  will allow you  */ \
	0x74,0x6f,0x20,0x73,0x63,0x61,0x6e,0x0d,0x0a,0x66,0x6f,0x72,0x20,0x6e,0x65,0x61, /* to scan..for nea */ \
	0x72,0x62,0x79,0x20,0x6e,0x65,0x74,0x77,0x6f,0x72,0x6b,0x73,0x2c,0x20,0x73,0x65, /* rby networks, se */ \
	0x65,0x20,0x74,0x68,0x65,0x6d,0x2c,0x20,0x61,0x6e,0x64,0x20,0x74,0x68,0x65,0x6e, /* e them, and then */ \
	0x20,0x63,0x6f,0x6e,0x6e,0x65,0x63,0x74,0x20,0x74,0x6f,0x20,0x61,0x6e,0x6f,0x74, /*  connect to anot */ \
	0x68,0x65,0x72,0x20,0x6e,0x65,0x74,0x77,0x6f,0x72,0x6b,0x2e,0x20,0x20,0x41,0x66, /* her network.  Af */ \
	0x74,0x65,0x72,0x20,0x74,0x68,0x65,0x20,0x61,0x74,0x74,0x65,0x6d,0x70,0x74,0x20, /* ter the attempt  */ \
	0x69,0x73,0x20,0x6d,0x61,0x64,0x65,0x0d,0x0a,0x74,0x6f,0x20,0x63,0x6f,0x6e,0x6e, /* is made..to conn */ \
	0x65,0x63,0x74,0x20,0x74,0x6f,0x20,0x74,0x68,0x65,0x20,0x6e,0x65,0x77,0x20,0x6e, /* ect to the new n */ \
	0x65,0x74,0x77,0x6f,0x72,0x6b,0x2c,0x20,0x79,0x6f,0x75,0x20,0x77,0x69,0x6c,0x6c, /* etwork, you will */ \
	0x20,0x68,0x61,0x76,0x65,0x20,0x74,0x6f,0x20,0x74,0x72,0x61,0x6e,0x73,0x69,0x74, /*  have to transit */ \
	0x69,0x6f,0x6e,0x20,0x79,0x6f,0x75,0x72,0x20,0x77,0x69,0x72,0x65,0x6c,0x65,0x73, /* ion your wireles */ \
	0x73,0x20,0x50,0x43,0x2c,0x20,0x6c,0x61,0x70,0x74,0x6f,0x70,0x2c,0x20,0x6f,0x72, /* s PC, laptop, or */ \
	0x20,0x68,0x61,0x6e,0x64,0x68,0x65,0x6c,0x64,0x0d,0x0a,0x77,0x69,0x72,0x65,0x6c, /*  handheld..wirel */ \
	0x65,0x73,0x73,0x20,0x64,0x65,0x76,0x69,0x63,0x65,0x20,0x74,0x6f,0x20,0x74,0x68, /* ess device to th */ \
	0x69,0x73,0x20,0x6e,0x65,0x77,0x20,0x6e,0x65,0x74,0x77,0x6f,0x72,0x6b,0x20,0x69, /* is new network i */ \
	0x6e,0x20,0x6f,0x72,0x64,0x65,0x72,0x20,0x74,0x6f,0x20,0x73,0x65,0x65,0x20,0x74, /* n order to see t */ \
	0x68,0x61,0x74,0x20,0x74,0x68,0x65,0x20,0x64,0x65,0x76,0x69,0x63,0x65,0x20,0x68, /* hat the device h */ \
	0x61,0x73,0x20,0x69,0x6e,0x64,0x65,0x65,0x64,0x20,0x63,0x68,0x61,0x6e,0x67,0x65, /* as indeed change */ \
	0x64,0x20,0x6e,0x65,0x74,0x77,0x6f,0x72,0x6b,0x73,0x2e,0x3c,0x2f,0x70,0x3e,0x0d, /* d networks.</p>. */ \
	0x0a,0x0d,0x0a,0x3c,0x68,0x32,0x3e,0x42,0x72,0x6f,0x77,0x73,0x65,0x72,0x2d,0x62, /* ...<h2>Browser-b */ \
	0x61,0x73,0x65,0x64,0x20,0x44,0x65,0x76,0x69,0x63,0x65,0x20,0x43,0x6f,0x6e,0x66, /* ased Device Conf */ \
	0x69,0x67,0x75,0x72,0x61,0x74,0x69,0x6f,0x6e,0x3c,0x2f,0x68,0x32,0x3e,0x0d,0x0a, /* iguration</h2>.. */ \
	0x0d,0x0a,0x3c,0x70,0x3e,0x54,0x68,0x69,0x73,0x20,0x73,0x68,0x6f,0x77,0x63,0x61, /* ..<p>This showca */ \
	0x73,0x65,0x73,0x20,0x68,0x6f,0x77,0x20,0x74,0x6f,0x20,0x63,0x6f,0x6e,0x66,0x69, /* ses how to confi */ \
	0x67,0x75,0x72,0x65,0x20,0x61,0x6e,0x64,0x20,0x70,0x72,0x6f,0x67,0x72,0x61,0x6d, /* gure and program */ \
	0x20,0x61,0x6e,0x20,0x65,0x6d,0x62,0x65,0x64,0x64,0x65,0x64,0x20,0x57,0x69,0x2d, /*  an embedded Wi- */ \
	0x46,0x69,0x20,0x64,0x65,0x76,0x69,0x63,0x65,0x20,0x74,0x68,0x61,0x74,0x20,0x64, /* Fi device that d */ \
	0x6f,0x65,0x73,0x20,0x6e,0x6f,0x74,0x0d,0x0a,0x68,0x61,0x76,0x65,0x20,0x61,0x20, /* oes not..have a  */ \
	0x6e,0x61,0x74,0x75,0x72,0x61,0x6c,0x20,0x6b,0x65,0x79,0x62,0x6f,0x61,0x72,0x64, /* natural keyboard */ \
	0x20,0x61,0x6e,0x64,0x20,0x73,0x63,0x72,0x65,0x65,0x6e,0x2e,0x20,0x20,0x42,0x79, /*  and screen.  By */ \
	0x20,0x75,0x73,0x69,0x6e,0x67,0x20,0x74,0x68,0x65,0x20,0x69,0x6e,0x74,0x65,0x72, /*  using the inter */ \
	0x6e,0x61,0x6c,0x20,0x77,0x65,0x62,0x20,0x73,0x65,0x72,0x76,0x65,0x72,0x20,0x74, /* nal web server t */ \
	0x68,0x61,0x74,0x20,0x61,0x63,0x63,0x6f,0x6d,0x70,0x61,0x6e,0x69,0x65,0x73,0x0d, /* hat accompanies. */ \
	0x0a,0x74,0x68,0x65,0x20,0x4d,0x69,0x63,0x72,0x6f,0x63,0x68,0x69,0x70,0x20,0x54, /* .the Microchip T */ \
	0x43,0x50,0x2f,0x49,0x50,0x20,0x73,0x74,0x61,0x63,0x6b,0x2c,0x20,0x65,0x6e,0x64, /* CP/IP stack, end */ \
	0x2d,0x75,0x73,0x65,0x72,0x73,0x20,0x63,0x61,0x6e,0x20,0x75,0x73,0x65,0x20,0x74, /* -users can use t */ \
	0x68,0x65,0x69,0x72,0x20,0x62,0x72,0x6f,0x77,0x73,0x65,0x72,0x20,0x61,0x73,0x20, /* heir browser as  */ \
	0x61,0x20,0x63,0x6f,0x6e,0x64,0x75,0x69,0x74,0x20,0x66,0x6f,0x72,0x20,0x70,0x72, /* a conduit for pr */ \
	0x6f,0x67,0x72,0x61,0x6d,0x6d,0x69,0x6e,0x67,0x0d,0x0a,0x74,0x68,0x65,0x20,0x64, /* ogramming..the d */ \
	0x65,0x76,0x69,0x63,0x65,0x20,0x77,0x69,0x74,0x68,0x20,0x74,0x68,0x65,0x20,0x63, /* evice with the c */ \
	0x6f,0x72,0x72,0x65,0x63,0x74,0x20,0x6e,0x65,0x74,0x77,0x6f,0x72,0x6b,0x20,0x70, /* orrect network p */ \
	0x61,0x72,0x61,0x6d,0x65,0x74,0x65,0x72,0x73,0x2e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a, /* arameters.</p>.. */ \
	0x0d,0x0a,0x3c,0x70,0x3e,0x3c,0x2f,0x70,0x3e,0x46,0x6f,0x72,0x20,0x61,0x20,0x77, /* ..<p></p>For a w */ \
	0x69,0x72,0x65,0x6c,0x65,0x73,0x73,0x20,0x6e,0x65,0x74,0x77,0x6f,0x72,0x6b,0x2c, /* ireless network, */ \
	0x20,0x61,0x6e,0x20,0x65,0x6e,0x64,0x2d,0x75,0x73,0x65,0x72,0x20,0x77,0x6f,0x75, /*  an end-user wou */ \
	0x6c,0x64,0x20,0x6e,0x65,0x65,0x64,0x20,0x74,0x6f,0x20,0x68,0x61,0x76,0x65,0x20, /* ld need to have  */ \
	0x6b,0x6e,0x6f,0x77,0x6c,0x65,0x64,0x67,0x65,0x20,0x6f,0x66,0x20,0x61,0x74,0x20, /* knowledge of at  */ \
	0x6c,0x65,0x61,0x73,0x74,0x20,0x74,0x68,0x65,0x20,0x66,0x6f,0x6c,0x6c,0x6f,0x77, /* least the follow */ \
	0x69,0x6e,0x67,0x20,0x69,0x6e,0x66,0x6f,0x72,0x6d,0x61,0x74,0x69,0x6f,0x6e,0x3a, /* ing information: */ \
	0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x3c,0x75,0x6c,0x3e,0x0d,0x0a,0x3c,0x6c,0x69,0x3e, /* </p>..<ul>..<li> */ \
	0x53,0x53,0x49,0x44,0x3c,0x2f,0x6c,0x69,0x3e,0x0d,0x0a,0x3c,0x6c,0x69,0x3e,0x53, /* SSID</li>..<li>S */ \
	0x65,0x63,0x75,0x72,0x69,0x74,0x79,0x20,0x54,0x79,0x70,0x65,0x20,0x28,0x4e,0x6f, /* ecurity Type (No */ \
	0x6e,0x65,0x2c,0x20,0x57,0x45,0x50,0x2c,0x20,0x57,0x50,0x41,0x2c,0x20,0x57,0x50, /* ne, WEP, WPA, WP */ \
	0x41,0x32,0x2c,0x20,0x57,0x50,0x41,0x2d,0x41,0x55,0x54,0x4f,0x2c,0x20,0x57,0x50, /* A2, WPA-AUTO, WP */ \
	0x53,0x29,0x3c,0x2f,0x6c,0x69,0x3e,0x0d,0x0a,0x3c,0x6c,0x69,0x3e,0x53,0x65,0x63, /* S)</li>..<li>Sec */ \
	0x75,0x72,0x69,0x74,0x79,0x20,0x4b,0x65,0x79,0x3c,0x2f,0x6c,0x69,0x3e,0x0d,0x0a, /* urity Key</li>.. */ \
	0x3c,0x2f,0x75,0x6c,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70,0x3e,0x41,0x73,0x20,0x70, /* </ul>....<p>As p */ \
	0x69,0x6f,0x6e,0x65,0x65,0x72,0x65,0x64,0x20,0x62,0x79,0x20,0x6d,0x6f,0x73,0x74, /* ioneered by most */ \
	0x20,0x6d,0x6f,0x64,0x65,0x72,0x6e,0x20,0x6f,0x70,0x65,0x72,0x61,0x74,0x69,0x6e, /*  modern operatin */ \
	0x67,0x20,0x73,0x79,0x73,0x74,0x65,0x6d,0x73,0x2c,0x20,0x74,0x68,0x65,0x20,0x61, /* g systems, the a */ \
	0x70,0x70,0x6c,0x69,0x63,0x61,0x74,0x69,0x6f,0x6e,0x20,0x61,0x6c,0x73,0x6f,0x20, /* pplication also  */ \
	0x68,0x61,0x73,0x20,0x74,0x68,0x65,0x20,0x61,0x62,0x69,0x6c,0x69,0x74,0x79,0x20, /* has the ability  */ \
	0x74,0x6f,0x20,0x73,0x63,0x61,0x6e,0x20,0x66,0x6f,0x72,0x20,0x0d,0x0a,0x61,0x6c, /* to scan for ..al */ \
	0x6c,0x20,0x6e,0x65,0x74,0x77,0x6f,0x72,0x6b,0x73,0x20,0x69,0x6e,0x20,0x74,0x68, /* l networks in th */ \
	0x65,0x20,0x76,0x69,0x63,0x69,0x6e,0x69,0x74,0x79,0x20,0x6f,0x66,0x20,0x74,0x68, /* e vicinity of th */ \
	0x65,0x20,0x64,0x65,0x76,0x69,0x63,0x65,0x2c,0x20,0x61,0x6e,0x64,0x20,0x64,0x69, /* e device, and di */ \
	0x73,0x70,0x6c,0x61,0x79,0x20,0x74,0x68,0x65,0x6d,0x20,0x74,0x6f,0x20,0x74,0x68, /* splay them to th */ \
	0x65,0x20,0x75,0x73,0x65,0x72,0x2e,0x20,0x20,0x54,0x68,0x65,0x20,0x75,0x73,0x65, /* e user.  The use */ \
	0x72,0x20,0x77,0x69,0x6c,0x6c,0x0d,0x0a,0x61,0x6c,0x73,0x6f,0x20,0x62,0x65,0x20, /* r will..also be  */ \
	0x67,0x69,0x76,0x65,0x6e,0x20,0x61,0x64,0x64,0x69,0x74,0x69,0x6f,0x6e,0x61,0x6c, /* given additional */ \
	0x20,0x69,0x6e,0x66,0x6f,0x72,0x6d,0x61,0x74,0x69,0x6f,0x6e,0x20,0x61,0x62,0x6f, /*  information abo */ \
	0x75,0x74,0x20,0x74,0x68,0x65,0x20,0x6e,0x65,0x74,0x77,0x6f,0x72,0x6b,0x20,0x73, /* ut the network s */ \
	0x75,0x63,0x68,0x20,0x61,0x73,0x20,0x77,0x68,0x65,0x74,0x68,0x65,0x72,0x20,0x73, /* uch as whether s */ \
	0x65,0x63,0x75,0x72,0x69,0x74,0x79,0x20,0x69,0x73,0x20,0x65,0x6e,0x61,0x62,0x6c, /* ecurity is enabl */ \
	0x65,0x64,0x0d,0x0a,0x6f,0x72,0x20,0x68,0x6f,0x77,0x20,0x66,0x61,0x72,0x20,0x61, /* ed..or how far a */ \
	0x77,0x61,0x79,0x20,0x74,0x68,0x65,0x20,0x6f,0x74,0x68,0x65,0x72,0x20,0x6e,0x65, /* way the other ne */ \
	0x74,0x77,0x6f,0x72,0x6b,0x20,0x69,0x73,0x2e,0x20,0x20,0x55,0x73,0x65,0x72,0x73, /* twork is.  Users */ \
	0x20,0x61,0x72,0x65,0x20,0x61,0x6c,0x73,0x6f,0x20,0x67,0x69,0x76,0x65,0x6e,0x20, /*  are also given  */ \
	0x74,0x68,0x65,0x20,0x6f,0x70,0x70,0x6f,0x72,0x74,0x75,0x6e,0x69,0x74,0x79,0x20, /* the opportunity  */ \
	0x74,0x6f,0x20,0x65,0x6e,0x74,0x65,0x72,0x20,0x61,0x6c,0x6c,0x20,0x74,0x68,0x65, /* to enter all the */ \
	0x0d,0x0a,0x6e,0x65,0x74,0x77,0x6f,0x72,0x6b,0x20,0x69,0x6e,0x66,0x6f,0x72,0x6d, /* ..network inform */ \
	0x61,0x74,0x69,0x6f,0x6e,0x20,0x6d,0x61,0x6e,0x75,0x61,0x6c,0x6c,0x79,0x2c,0x20, /* ation manually,  */ \
	0x77,0x68,0x69,0x63,0x68,0x20,0x69,0x73,0x20,0x72,0x65,0x71,0x75,0x69,0x72,0x65, /* which is require */ \
	0x64,0x20,0x77,0x68,0x65,0x6e,0x20,0x74,0x72,0x79,0x69,0x6e,0x67,0x20,0x74,0x6f, /* d when trying to */ \
	0x20,0x63,0x6f,0x6e,0x6e,0x65,0x63,0x74,0x20,0x74,0x6f,0x20,0x61,0x20,0x6e,0x65, /*  connect to a ne */ \
	0x74,0x77,0x6f,0x72,0x6b,0x20,0x77,0x69,0x74,0x68,0x20,0x61,0x20,0x0d,0x0a,0x68, /* twork with a ..h */ \
	0x69,0x64,0x64,0x65,0x6e,0x20,0x53,0x53,0x49,0x44,0x2e,0x3c,0x2f,0x70,0x3e,0x0d, /* idden SSID.</p>. */ \
	0x0a,0x0d,0x0a,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x20,0x3c,0x21,0x2d,0x2d,0x63,0x6f, /* ...</div> <!--co */ \
	0x6e,0x74,0x65,0x6e,0x74,0x2d,0x2d,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x73,0x63,0x72, /* ntent-->....<scr */ \
	0x69,0x70,0x74,0x20,0x74,0x79,0x70,0x65,0x3d,0x22,0x74,0x65,0x78,0x74,0x2f,0x6a, /* ipt type="text/j */ \
	0x61,0x76,0x61,0x73,0x63,0x72,0x69,0x70,0x74,0x22,0x3e,0x0d,0x0a,0x3c,0x21,0x2d, /* avascript">..<!- */ \
	0x2d,0x0d,0x0a,0x73,0x65,0x74,0x54,0x69,0x6d,0x65,0x6f,0x75,0x74,0x28,0x22,0x6e, /* -..setTimeout("n */ \
	0x65,0x77,0x41,0x4a,0x41,0x58,0x43,0x6f,0x6d,0x6d,0x61,0x6e,0x64,0x28,0x27,0x73, /* ewAJAXCommand('s */ \
	0x74,0x61,0x74,0x75,0x73,0x2e,0x78,0x6d,0x6c,0x27,0x2c,0x20,0x75,0x70,0x64,0x61, /* tatus.xml', upda */ \
	0x74,0x65,0x53,0x74,0x61,0x74,0x75,0x73,0x2c,0x20,0x74,0x72,0x75,0x65,0x29,0x22, /* teStatus, true)" */ \
	0x2c,0x35,0x30,0x30,0x29,0x3b,0x0d,0x0a,0x2f,0x2f,0x2d,0x2d,0x3e,0x0d,0x0a,0x3c, /* ,500);..//-->..< */ \
	0x2f,0x73,0x63,0x72,0x69,0x70,0x74,0x3e,0x0d,0x0a,0x7e,0x69,0x6e,0x63,0x3a,0x66, /* /script>..~inc:f */ \
	0x6f,0x6f,0x74,0x65,0x72,0x2e,0x69,0x6e,0x63,0x7e,0x0d,0x0a,0x53,0x75,0x63,0x63, /* ooter.inc~..Succ */ \
	0x65,0x73,0x73,0x21,0x20,0x7e,0x6c,0x65,0x64,0x28,0x30,0x29,0x7e,0x1f,0x8b,0x08, /* ess! ~led(0)~... */ \
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xb5,0x56,0x4d,0x8f,0xa3,0x38,0x10,0xbd,0xf7, /* ........VM..8... */ \
	0xaf,0x40,0x3d,0xd7,0x10,0x41,0x08,0x99,0x0c,0x7d,0x9a,0x5d,0x69,0x8f,0x73,0x9c, /* .@=..A...}.]i.s. */ \
	0xbb,0xc1,0x45,0xb0,0xda,0xc1,0xc8,0x36,0x93,0xcc,0xac,0xf6,0xbf,0x8f,0x8d,0xc1, /* ..E....6........ */ \
	0xb1,0x8d,0xe9,0x68,0x57,0xda,0x20,0xa5,0x3b,0xc6,0xf5,0xea,0xb9,0x3e,0x5e,0xb9, /* ...hW. .;....>^. */ \
	0x66,0xf8,0x67,0xf2,0xf7,0x4b,0xa2,0x3e,0x2d,0xeb,0x65,0xda,0xa2,0x2b,0xa1,0x3f, /* f.g..K.>-.e..+.? */ \
	0xab,0xe4,0x3b,0x70,0x8c,0x7a,0xb4,0x4b,0xbe,0x72,0x82,0xe8,0x2e,0x11,0xa8,0x17, /* ..;p.z.K.r...... */ \
	0xa9,0x00,0x4e,0xda,0xb7,0x69,0x73,0x8d,0x9a,0xf7,0x0b,0x67,0x63,0x8f,0xab,0xe4, /* ..N..is....gc... */ \
	0x53,0x59,0xeb,0xc7,0xbc,0xb8,0x22,0x7e,0x21,0x7d,0x95,0x64,0xc3,0x3d,0x41,0xa3, /* SY...."~!}.d.=A. */ \
	0x64,0x66,0x75,0x40,0x18,0x93,0xfe,0xa2,0x96,0xd5,0x73,0xd0,0xef,0xb2,0xb7,0x97, /* dfu@......s..... */ \
	0x7f,0x5e,0x5e,0x3e,0x89,0x0e,0x61,0x76,0x4b,0x59,0x0f,0x33,0x8b,0x1b,0xc1,0xb2, /* .^^>..avKY.3.... */ \
	0xab,0x92,0xcf,0x27,0xb5,0x69,0x76,0xc5,0x38,0x06,0x5e,0x25,0xb9,0xb2,0x12,0x8c, /* ...'.iv.8.^%.... */ \
	0x12,0xac,0x1c,0x96,0xa5,0xfb,0x2e,0x95,0x6c,0xa8,0x34,0x62,0x9c,0x80,0xe3,0x47, /* ........l.4b...G */ \
	0xde,0xd8,0xec,0x27,0x82,0x7a,0xac,0xf5,0x13,0x05,0x76,0x21,0x3a,0x0e,0xf0,0x01, /* ...'.z....v!:... */ \
	0xc8,0xf1,0xf8,0x0c,0xa1,0x65,0x23,0xdf,0x06,0x28,0x90,0x7e,0x36,0x31,0x06,0x74, /* .....e#..(.~61.t */ \
	0xf9,0xc0,0x7b,0x51,0x14,0x91,0xfc,0xb4,0x6d,0xbb,0x19,0x2e,0x9b,0x99,0x83,0x0d, /* ..{Q....m....... */ \
	0xf8,0x54,0x08,0x82,0xfc,0x02,0x05,0x9d,0x0d,0xd2,0xf1,0x2b,0xb1,0x5b,0x2b,0xe1, /* .T.........+.[+. */ \
	0x16,0x49,0x24,0xb5,0xdc,0x5c,0xff,0x7f,0x1c,0xcb,0xbf,0xb2,0x63,0xe0,0xef,0xe8, /* .I$..\......c... */ \
	0xb9,0xbb,0x01,0xb9,0x74,0xb2,0x52,0x0c,0x29,0x36,0xcb,0x0d,0xa3,0x8c,0xbb,0xe4, /* ....t.R.)6...... */ \
	0x4d,0x62,0xd3,0x9a,0x49,0xc9,0xae,0xca,0x6f,0xb9,0x00,0x74,0xb3,0x6d,0x7e,0xd2, /* Mb..I...o..t.m~. */ \
	0x2b,0x0f,0x26,0x7b,0xae,0xd7,0x17,0xc6,0x94,0x21,0xb5,0x67,0x5a,0x7a,0x73,0x2b, /* +.&{.....!.gZzs+ */ \
	0xad,0xc8,0xec,0xc1,0x25,0xdc,0x65,0x8a,0x28,0xb9,0xf4,0x76,0xa3,0x46,0xbb,0x42, /* ....%.e.(..v.F.B */ \
	0x3f,0xfa,0x28,0x14,0x5a,0x1f,0x24,0x2f,0x2d,0xc8,0x7c,0xc0,0x94,0x1b,0x52,0x26, /* ?.(.Z.$/-.|...R& */ \
	0xac,0x16,0x06,0xf9,0x65,0x9e,0x1f,0xad,0x1d,0x26,0x62,0xa0,0x48,0xb5,0x5e,0x4d, /* ....e....&b.H.^M */ \
	0x59,0xf3,0x1e,0xc9,0xa2,0x1b,0xc5,0x39,0x38,0xb7,0x8e,0x48,0x08,0xe2,0x7a,0x7e, /* Y......98..H..z~ */ \
	0x12,0xd7,0xb9,0x06,0x6c,0x18,0x1f,0xc5,0x63,0x23,0x3d,0xc5,0x01,0x43,0xc3,0x38, /* ....l...c#=..C.8 */ \
	0x92,0x84,0xa9,0x60,0xf4,0xaa,0x3f,0xdd,0x43,0x54,0x1d,0xfb,0x01,0x3c,0x96,0xea, /* ...`..?.CT...<.. */ \
	0xf3,0xd7,0xec,0x9c,0x9d,0xcd,0xde,0x46,0x11,0x80,0x5e,0xfa,0x27,0x2e,0x0f,0x36, /* .......F..^.'..6 */ \
	0x6f,0xeb,0x94,0x04,0xb1,0xcb,0x6d,0xec,0x16,0xa8,0x25,0x7c,0x4b,0x71,0x34,0x59, /* o.....m...%|Kq4Y */ \
	0xf6,0x94,0xb2,0xb5,0xf5,0x58,0x2f,0x08,0x78,0xe9,0x98,0x15,0x82,0x3a,0x10,0x70, /* .....X/.x....:.p */ \
	0x4a,0x42,0x98,0x2e,0x9f,0x11,0xe6,0x7a,0x34,0xcd,0x14,0x12,0xed,0x0e,0x31,0x55, /* JB.....z4.....1U */ \
	0x7d,0x9d,0x65,0xf5,0x75,0x97,0xbc,0x3e,0x14,0xf5,0x35,0x30,0x2d,0x22,0x4d,0x56, /* }.e.u..>..50-"MV */ \
	0xec,0xa7,0x36,0x5b,0x23,0x4e,0xfa,0xfc,0x31,0xde,0xc9,0xd3,0x0b,0x43,0x58,0xa7, /* ..6[#N..1....CX. */ \
	0x1d,0x23,0xd1,0x81,0x2b,0x1a,0x8b,0x74,0x3e,0x5a,0xeb,0xa1,0xdb,0xab,0x66,0x0b, /* .#..+..t>Z....f. */ \
	0x4f,0x3c,0x44,0x58,0xe7,0xff,0x9a,0xf5,0x5e,0x0c,0xa8,0x79,0x24,0x89,0x02,0xe2, /* O<DX....^..y$... */ \
	0xba,0x78,0x65,0x67,0x9c,0xb5,0x8c,0x49,0xfb,0xd6,0xf1,0x94,0xed,0xcf,0x70,0xf5, /* .xeg...I......p. */ \
	0x75,0xe3,0x74,0x3a,0xad,0xbb,0xba,0x51,0x4c,0x81,0x07,0xa7,0xd5,0x93,0xa2,0x9c, /* u.t:...QL....... */ \
	0x66,0x52,0xb2,0x6e,0x63,0x13,0xad,0x60,0x18,0x39,0x31,0x54,0x6d,0xa4,0x63,0x38, /* fR.nc..`.91Tm.c8 */ \
	0x79,0x9b,0x34,0x5e,0x22,0x39,0x8a,0xa0,0xcb,0x3f,0x3f,0xaf,0x79,0xd7,0x89,0xcb, /* y.4^"9...??.y... */ \
	0x6c,0x3d,0x03,0x3d,0x97,0x1b,0x8d,0xee,0x30,0x59,0xf2,0x62,0xfd,0x94,0xe6,0xa4, /* l=.=....0Y.b.... */ \
	0xea,0x3b,0xf7,0x95,0x8f,0xa8,0x82,0xef,0x15,0x44,0xba,0x66,0x92,0x79,0x90,0x7b, /* .;.......D.f.y.{ */ \
	0x0a,0x58,0x44,0xd2,0x7d,0x5c,0x26,0x81,0xb7,0x2f,0xec,0x59,0x8c,0x17,0x85,0x1f, /* .XD.}\&../.Y.... */ \
	0xb9,0xd0,0x2b,0x03,0x23,0x26,0x2b,0x6b,0xd3,0x78,0xcb,0x2e,0x00,0xdb,0x4d,0xbf, /* ..+.#&+k.x....M. */ \
	0x87,0x3b,0xba,0x0e,0x14,0x6a,0x76,0xf7,0xba,0xb5,0x9a,0x92,0xad,0x45,0x37,0xb1, /* .;...jv......E7. */ \
	0xff,0x6d,0xe9,0x67,0x2c,0xe6,0x85,0xa7,0x16,0xa6,0xa8,0xdc,0x9a,0x72,0xb4,0xd0, /* .m.g,........r.. */ \
	0xd0,0xd4,0x5c,0x1a,0x86,0x21,0xa6,0x06,0x7f,0xaa,0x7b,0x00,0x51,0xa7,0xfb,0x06, /* ..\..!....{.Q... */ \
	0xb7,0xdd,0xf2,0x63,0x97,0xb4,0xe4,0x0e,0x38,0x9d,0x2a,0x67,0xfe,0xb1,0x9c,0x08, /* ...c....8..g.... */ \
	0x78,0x43,0x44,0x74,0xc0,0xb6,0xf0,0xe5,0x6d,0x95,0x64,0x6f,0x6a,0xea,0x89,0x15, /* xCDt....m.doj... */ \
	0xa9,0x63,0xb3,0x7c,0x78,0xcc,0x00,0xa8,0x8b,0xd9,0x1d,0xe7,0x8c,0xfb,0x4a,0x17, /* .c.|x.........J. */ \
	0x62,0x44,0x2a,0xd7,0x67,0x85,0xf1,0xc7,0xce,0xbe,0x64,0xd9,0x2a,0x5b,0xf6,0x8a, /* bD..g.....d..[.. */ \
	0xe1,0x44,0xf8,0x31,0x6e,0xc3,0x01,0x51,0xce,0x2a,0xd4,0x12,0xa0,0x58,0x80,0xfc, /* .D.1n..Q.....X.. */ \
	0x7f,0x92,0x1d,0xcb,0xaa,0xf5,0x88,0xc9,0x8f,0xb0,0xc3,0xf4,0x11,0xb5,0x43,0xfd, /* ..............C. */ \
	0x77,0xbe,0x19,0x84,0x16,0x14,0xd5,0x40,0x63,0xe1,0x4d,0xf3,0x15,0x4d,0xa3,0x36, /* w......@c.M..M.6 */ \
	0x87,0x65,0x75,0x11,0x95,0xa2,0x7c,0x32,0xe9,0x07,0x26,0x88,0xe9,0x0b,0x54,0xab, /* .eu...|2..&...T. */ \
	0x88,0x8f,0x12,0x7c,0x1e,0xa4,0x1f,0xc6,0x60,0x3a,0x1f,0xd6,0x6c,0xa7,0x5d,0x7b, /* ...|....`:..l.]{ */ \
	0x71,0xf5,0x37,0xda,0x9b,0xb5,0xdd,0xa7,0xf3,0x85,0x38,0xa0,0x2d,0xc0,0x3d,0x07, /* q.7.......8.-.=. */ \
	0x31,0xd2,0x20,0x43,0xc9,0x7f,0x4c,0x51,0x78,0xdd,0xdd,0xd2,0xf8,0xad,0x3b,0x90, /* 1. C..LQx.....;. */ \
	0x5b,0xa6,0x00,0xb3,0x66,0xb0,0x77,0x7f,0x50,0xda,0x49,0x52,0x9f,0x62,0x66,0xed, /* [...f.w.P.IR.bf. */ \
	0x6c,0xd6,0x22,0x42,0xe3,0x86,0xf5,0x29,0x66,0xd8,0x2e,0xfe,0xc6,0x7e,0xc3,0x61, /* l."B...)f....~.a */ \
	0xd3,0x44,0xed,0xda,0xa9,0xf2,0x7e,0x03,0x8a,0xe8,0x62,0x9e,0xb2,0x0d,0x00,0x00, /* .D....~...b..... */ \
	0x1f,0x8b,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xed,0x3c,0x6b,0x97,0xda,0xc6, /* ...........<k... */ \
	0x92,0xdf,0x73,0x4e,0xfe,0x43,0x9b,0xdd,0x0d,0x70,0xcd,0x30,0xc0,0x3c,0xae,0xe3, /* ..sN.C...p.0.<.. */ \
	0xb9,0x93,0x1c,0x86,0x61,0x6c,0x92,0x31,0xb0,0xc0,0xc4,0xf1,0x49,0xb2,0x39,0x42, /* ....al.1....I.9B */ \
	0x6a,0x40,0xb6,0x50,0xeb,0x4a,0x62,0x18,0x4e,0xae,0xf7,0x47,0xec,0xbd,0x7f,0x62, /* j@.P.Jb.N..G...b */ \
	0xff,0xe5,0x56,0xf5,0x43,0x6a,0xbd,0x18,0x31,0xb6,0xf7,0x53,0x38,0xc7,0x1e,0x90, /* ..V.Cj..1..S8... */ \
	0xba,0xaa,0xab,0xaa,0xeb,0xd5,0xd5,0x8f,0xe3,0xbf,0x7c,0x8e,0xcf,0xd7,0x5f,0x91, /* ..........|..._. */ \
	0xbf,0x90,0x37,0xb6,0xe9,0x33,0x73,0x65,0x7b,0x64,0xd6,0x1b,0x1f,0x0f,0xc6,0x64, /* ..7..3se{d.....d */ \
	0x1a,0x1a,0xe6,0x07,0xf2,0x83,0x71,0x6f,0x04,0xa6,0x6f,0x7b,0x21,0xb9,0xb5,0xe7, /* ......qo..o{!... */ \
	0xbe,0xe1,0xef,0xb0,0xf5,0xe7,0xea,0x95,0xf7,0x3c,0x65,0x8b,0x70,0x6b,0xf8,0x14, /* .........<e.pk.. */ \
	0x3a,0x30,0xa9,0x1b,0x50,0xd2,0x5d,0xfa,0x94,0xae,0xa9,0x1b,0x46,0x4d,0x7a,0xcc, /* :0..P.].....FMz. */ \
	0xdb,0xf9,0xf6,0x72,0x15,0x92,0xff,0x25,0x9d,0x56,0xab,0x73,0xd4,0x69,0xb5,0x4f, /* ...r...%.V.s.i.O */ \
	0x74,0x92,0xa9,0xb9,0x72,0x99,0xc3,0x96,0x3b,0x32,0x70,0xcd,0x26,0x21,0x5d,0xc7, /* t...r...;2p.&!]. */ \
	0x21,0x1c,0x20,0xe0,0xf0,0x3e,0x0d,0xa8,0x7f,0x4f,0xad,0x66,0x84,0x31,0x86,0x75, /* !. ..>...O.f.1.u */ \
	0x44,0xaf,0x01,0x09,0x19,0xd9,0xb1,0x0d,0x09,0x57,0x54,0x80,0xe2,0x83,0x4d,0x40, /* D........WT...M@ */ \
	0x1b,0x64,0xcd,0x2c,0x7b,0xb1,0x6b,0x10,0x13,0xa8,0x68,0x10,0xc3,0xb5,0x38,0x06, /* .d.,{.k...h...8. */ \
	0xcb,0x0e,0x42,0xdf,0x9e,0x6f,0x42,0xfa,0x92,0xff,0xae,0xd9,0x75,0xc2,0x81,0x23, /* ..B..oB.....u..# */ \
	0x7e,0xb6,0x2b,0xea,0x12,0xba,0x9e,0x53,0xcb,0xa2,0x16,0x61,0x2e,0x31,0xb4,0x6e, /* ~.+....S...a.1.n */ \
	0xd7,0xfc,0x1b,0x73,0x43,0x9f,0x39,0x0e,0xf5,0x09,0xf3,0x39,0x16,0xfe,0xb1,0xec, /* ...sC.9....9.... */ \
	0xa5,0x1d,0x1a,0x0e,0x09,0xec,0xa5,0x0b,0x7f,0xb4,0x56,0x9e,0xcf,0xac,0x8d,0x19, /* ..........V..... */ \
	0x92,0xda,0x3f,0xaf,0xe9,0x3d,0x10,0xfe,0xaf,0x3a,0xf4,0x62,0x9b,0x2b,0x62,0x07, /* ..?..=...:.b.+b. */ \
	0x31,0xb8,0xed,0x86,0x74,0xe9,0x1b,0x21,0x74,0x0a,0x5f,0x99,0x92,0x2b,0xfd,0x9f, /* 1...t..!t._..+.. */ \
	0x40,0xc1,0x5f,0xa8,0xee,0x6a,0x36,0x50,0x3d,0x1a,0xde,0xbe,0x4b,0x52,0x6e,0xf9, /* @._..j6P=...KRn. */ \
	0xf6,0x3d,0xf4,0x16,0xb0,0x8d,0x6f,0x52,0xb2,0xb0,0x1d,0x10,0x0f,0x75,0xcd,0xce, /* .=....oR.....u.. */ \
	0x8b,0xf7,0xe7,0xad,0xa6,0x19,0x89,0x80,0x7f,0xa2,0xe7,0x2b,0xe2,0x31,0x1f,0x3b, /* ...........+.1.; */ \
	0x85,0x2e,0x0d,0xe2,0x32,0xf7,0x28,0xe6,0xd6,0xe2,0xd4,0xa2,0x38,0x91,0xa6,0x18, /* ....2.(.....8... */ \
	0x18,0x58,0x7b,0xbf,0x71,0xcd,0xd0,0x06,0xe9,0x6c,0xed,0x70,0x95,0x10,0x11,0x05, /* .X{.q....l.p.... */ \
	0x9a,0x7c,0x97,0x86,0xba,0x00,0x16,0xcc,0x47,0x52,0x63,0x0c,0x01,0x73,0x28,0xf1, /* .|......GRc..s(. */ \
	0x36,0xbe,0xc7,0x40,0x73,0xd8,0x82,0x33,0xef,0x2f,0x0c,0xd3,0x76,0x97,0x02,0x23, /* 6..@s..3./..v..# */ \
	0x32,0x96,0x83,0x29,0x56,0x85,0x77,0x30,0xe8,0xc1,0x8a,0x6d,0x1c,0x0b,0xf4,0x64, /* 2..)V.w0...m...d */ \
	0x01,0x7d,0x00,0xfd,0x08,0x24,0x15,0x83,0x18,0x4a,0x1d,0x89,0x61,0x9a,0x6c,0xed, /* .}...$...J..a.l. */ \
	0x19,0xee,0x0e,0x91,0x87,0x2b,0x29,0xf3,0x48,0x6a,0x48,0x9b,0x61,0x59,0x36,0x72, /* .....+).HjH.aY6r */ \
	0x03,0xc3,0x66,0xbb,0xf0,0x60,0x6d,0x70,0xde,0x7c,0xba,0x34,0x7c,0x0b,0xc1,0x40, /* ..f..`mp.|.4|..@ */ \
	0xc5,0x7c,0xa9,0x9a,0x91,0x1c,0xd9,0xdc,0xb1,0x97,0xbc,0x61,0x10,0x93,0x35,0x7b, /* .|.........a..5{ */ \
	0xdd,0x27,0xd3,0xd1,0xcd,0xec,0x6d,0x77,0xd2,0x27,0xdd,0xe1,0x35,0xb9,0x1e,0xf5, /* .'....mw.'..5... */ \
	0xee,0xde,0xf4,0x87,0xb3,0xee,0x6c,0x30,0x1a,0x12,0x7c,0x3a,0x9e,0x8c,0x7e,0x1a, /* ......l0..|:..~. */ \
	0x5c,0xf7,0xaf,0xc9,0x3f,0xbb,0x53,0x32,0x98,0xfe,0x8b,0xbc,0x1d,0xcc,0x5e,0x8f, /* \...?.S2......^. */ \
	0xee,0x66,0x1c,0x1e,0xe0,0x26,0xdd,0xe1,0xec,0x1d,0x19,0xdd,0x00,0xf8,0x3b,0xf2, /* .f...&........;. */ \
	0xe3,0x60,0x78,0xdd,0x20,0x7d,0x68,0xd1,0x9f,0x90,0xfe,0xcf,0xe3,0x49,0x7f,0x3a, /* .`x. }h......I.: */ \
	0x25,0xa3,0x09,0x19,0xbc,0x19,0xdf,0x0e,0xfa,0xf0,0x6a,0x30,0xec,0xdd,0xde,0x5d, /* %.........j0...] */ \
	0x0f,0x86,0xaf,0x12,0x68,0x6e,0x07,0x6f,0x06,0xa2,0xcb,0x06,0x47,0xa3,0xa3,0x7d, /* ....hn.o....G..} */ \
	0xd3,0x9f,0xf4,0x5e,0xc3,0x8f,0xee,0xd5,0xe0,0x76,0x30,0x7b,0xd7,0x20,0x37,0x83, /* ...^.....v0{. 7. */ \
	0xd9,0x10,0xd1,0xde,0x00,0xde,0x2e,0x07,0x1f,0x77,0x27,0xb3,0x41,0xef,0xee,0xb6, /* .........w'.A... */ \
	0x3b,0x21,0xe3,0xbb,0xc9,0x78,0x34,0xed,0x37,0xc8,0x6c,0x30,0xbb,0x15,0x2c,0x0d, /* ;!...x4.7.l0..,. */ \
	0x47,0xc3,0xa3,0xc1,0xf0,0x66,0x02,0x9d,0xf6,0x91,0xb5,0x26,0x10,0x01,0x0f,0x49, /* G....f.....&...I */ \
	0xff,0x27,0xf8,0x41,0xa6,0xaf,0xbb,0xb7,0xb7,0xc2,0x5a,0x07,0xbd,0xc9,0xa8,0xf7, /* .'.A......Z..... */ \
	0x1a,0xbc,0xd2,0x55,0x1f,0x28,0xea,0x5e,0x01,0x3c,0xef,0x03,0x08,0x02,0xb2,0x41, /* ...U.(.^.<.....A */ \
	0x06,0x40,0xc4,0x6d,0x83,0x4c,0xc7,0xfd,0xde,0x00,0xbf,0x00,0xaf,0x83,0x49,0xbf, /* .@.m.L........I. */ \
	0x37,0x03,0x06,0x85,0x03,0x19,0x0d,0xa7,0xfd,0xff,0xbc,0x83,0x66,0xf0,0x9a,0x5c, /* 7...........f..\ */ \
	0x77,0xdf,0x74,0x5f,0xf5,0xa7,0x0d,0x72,0x3b,0x9a,0xce,0x50,0x8a,0x40,0x37,0x97, /* w.t_...r;..P.@7. */ \
	0x05,0xff,0x7d,0xdd,0x9d,0x75,0x1b,0x00,0x01,0x5f,0x47,0x37,0x82,0x09,0xe8,0xfc, /* ..}..u..._G7.... */ \
	0x6e,0xc2,0x29,0x44,0xb6,0xa7,0x77,0x57,0x53,0xe0,0xe1,0x6e,0xd6,0x27,0xaf,0x46, /* n.)D..wWS..n.'.F */ \
	0xa3,0x6b,0xc0,0x33,0xeb,0xf7,0x5e,0x0f,0x47,0xb7,0xa3,0x57,0xef,0x10,0xcb,0xb4, /* .k.3..^.G..W.... */ \
	0x3f,0xf9,0x69,0xd0,0x43,0xfc,0x48,0x5f,0xef,0xb6,0x3b,0x78,0x33,0xe5,0x78,0xae, /* ?.i.C.H_..;x3.x. */ \
	0xde,0xc1,0xa8,0x0e,0x26,0xd7,0x42,0x2a,0xfd,0x29,0xa9,0xc5,0x32,0xbf,0xba,0x9b, /* ....&.B..)..2... */ \
	0x01,0xe7,0x33,0x21,0x6f,0x18,0xd2,0xd9,0x88,0x43,0x5f,0xf7,0x6f,0xfa,0x40,0xba, /* ..3!o....C_.o.@. */ \
	0xd2,0x88,0x49,0x7f,0x74,0x53,0xd7,0xf1,0x72,0x31,0x00,0xb7,0xfd,0x37,0xc3,0xc1, /* ..I.tS..r1...7.. */ \
	0x8c,0xf7,0x0e,0xac,0xce,0x26,0x03,0x40,0xc7,0x87,0x0c,0x1e,0x8c,0x10,0x4e,0x68, /* .....&.@......Nh */ \
	0x2a,0xe0,0xc6,0x91,0x40,0xde,0x80,0xba,0xb7,0xaf,0xfb,0x5c,0x19,0xba,0x53,0xa0, /* ....@......\..S. */ \
	0x18,0xfb,0x04,0xb5,0x42,0xad,0xbb,0xea,0x4e,0x07,0x53,0x64,0x94,0xa3,0xea,0xf6, /* ....B...N.Sd.... */ \
	0x66,0xc0,0xe0,0x68,0x22,0xd4,0x41,0xa3,0x78,0xd8,0x7f,0x75,0x3b,0x78,0xd5,0x1f, /* f..h".A.x..u;x.. */ \
	0xf6,0xfa,0x40,0xd1,0xd5,0xa4,0xdf,0xed,0xbd,0x46,0x20,0xa5,0x20,0x71,0xdf,0x6f, /* ..@......F . q.o */ \
	0x07,0xd3,0x7e,0xa4,0xd7,0x1c,0x4b,0x77,0x13,0xae,0xc0,0x58,0x92,0x9f,0x6b,0xf0, /* ..~...Kw...X..k. */ \
	0x58,0xea,0x7b,0x8f,0xad,0x55,0x00,0xf8,0xef,0xcf,0xf0,0x11,0x9d,0xae,0x77,0x64, /* X.{..U........wd */ \
	0x04,0x16,0x98,0xf8,0xb4,0x5b,0xc7,0x9d,0x6f,0x8f,0xdb,0x1d,0xfc,0xfe,0x06,0xfd, /* .....[..o....... */ \
	0xbc,0x0d,0x1e,0x0a,0x0d,0xf9,0xad,0x7d,0x63,0x93,0x57,0xe4,0x9a,0xae,0xd9,0x67, /* .......}c.W....g */ \
	0x8a,0x78,0xc7,0x5f,0x7f,0xf5,0xf5,0x57,0xc7,0xc7,0x80,0x12,0x3c,0xd4,0xda,0x76, /* .x._...W....<..v */ \
	0xc1,0xa7,0xf2,0x08,0x61,0x80,0x77,0xf8,0xfb,0x86,0x06,0x21,0x38,0x71,0x74,0x50, /* ....a.w....!8qtP */ \
	0x81,0x6d,0x51,0x1f,0xa8,0xa8,0x84,0xf6,0x1a,0xe3,0xc6,0x26,0xac,0x7c,0xfd,0xd5, /* .mQ........&.|.. */ \
	0xbd,0x01,0x7e,0x09,0x7e,0x8f,0x36,0x21,0x0c,0xfa,0x25,0x46,0xc1,0x56,0xeb,0x82, /* ..~.~.6!..%F.V.. */ \
	0x00,0xba,0x75,0x20,0xf1,0x4e,0x43,0x06,0x71,0x0e,0xd0,0x01,0xb2,0x0d,0xf7,0x85, /* ..u .NC.q....... */ \
	0xdd,0x1f,0xba,0x3f,0x13,0x7a,0x0f,0x82,0xe4,0xd1,0x0d,0x9c,0xbf,0x49,0x83,0x40, /* ...?.z.......I.@ */ \
	0x20,0x33,0xde,0x1b,0x0f,0xb7,0x10,0xc2,0x00,0x97,0x4b,0xb7,0xa4,0xeb,0xfb,0xc6, /*  3........K..... */ \
	0xae,0x56,0xbf,0xe0,0xb8,0x64,0x4a,0x10,0x08,0x84,0xe8,0x0b,0xdd,0x0d,0x84,0x31, /* .V...dJ........1 */ \
	0x1f,0x71,0x5a,0x0c,0x90,0x99,0x1b,0xdf,0x47,0x87,0x38,0xa7,0xe8,0xd2,0xc0,0x79, /* .qZ.....G.8....y */ \
	0x6e,0x5d,0x70,0x77,0x22,0x74,0xd2,0xc0,0x34,0x5c,0x02,0x71,0x31,0x64,0xdc,0xd1, /* n]pw"t..4\.q1d.. */ \
	0x1f,0x8b,0xfe,0xf0,0xe9,0x35,0xc2,0x5e,0x92,0x56,0xa2,0x17,0x85,0xcb,0x06,0xa9, /* .....5.^.V...... */ \
	0x08,0x67,0x09,0xbd,0x20,0xa6,0x79,0x10,0x70,0x1f,0x0a,0x28,0x0d,0x18,0x13,0x9f, /* .g.. .y.p..(.... */ \
	0xad,0xc5,0xa0,0x40,0x38,0xde,0x38,0xb4,0xa9,0xe1,0x46,0x14,0x57,0x41,0x16,0x35, /* ...@8.8...F.WA.5 */ \
	0x88,0x17,0x1d,0x3f,0xf2,0x6e,0x81,0x7c,0x7d,0xb6,0x83,0xb8,0x07,0xa4,0xd9,0xe0, /* ...?.n.|}....... */ \
	0xea,0x19,0x7f,0x03,0x31,0x61,0xcb,0xfc,0x0f,0xc0,0xa4,0x31,0x77,0xa8,0x86,0x92, /* ....1a.....1w... */ \
	0xbf,0x1e,0x8a,0xb7,0xfd,0x07,0xf0,0xf9,0x18,0xc2,0x2f,0x49,0xfb,0x42,0x0a,0x7b, /* ........../I.B.{ */ \
	0xe0,0x82,0x9b,0x07,0x85,0x45,0x79,0x73,0xf9,0xa1,0xa8,0x21,0x3a,0xac,0xb9,0x4f, /* .....Eys...!:..O */ \
	0x87,0x06,0x64,0xe3,0x3b,0x2f,0x39,0x1f,0xf0,0x85,0x87,0x44,0x53,0x08,0x1f,0xdf, /* ..d.;/9....DS... */ \
	0x61,0x18,0x32,0x40,0x03,0x7c,0xd1,0xc2,0x62,0xe6,0x86,0x07,0x98,0xc1,0x35,0xb6, /* a.2@.|..b.....5. */ \
	0x84,0x78,0xeb,0x34,0x90,0x52,0x83,0x2c,0x54,0x70,0x84,0xc7,0xa6,0x01,0x49,0x0d, /* .x.4.R.,Tp....I. */ \
	0x0f,0x69,0x20,0x63,0x8f,0x61,0x68,0xfa,0xf9,0xcd,0x2d,0xa9,0x31,0x4f,0x04,0x9c, /* .i c.ah...-.1O.. */ \
	0xba,0xc0,0xed,0x53,0x8f,0x1a,0x21,0x20,0xf6,0x41,0x09,0x42,0x26,0x7f,0xf3,0x70, /* ...S..! .A.B&..p */ \
	0x25,0x50,0xd8,0xc0,0xcb,0xc2,0x06,0xfa,0xa9,0xb3,0xcb,0x40,0x5b,0x46,0x68,0xbc, /* %P.........@[Fh. */ \
	0x84,0xc0,0x44,0xee,0x26,0xb7,0x18,0xda,0x19,0xf2,0x8d,0x89,0x0e,0x46,0x3c,0x06, /* ..D.&........F<. */ \
	0x03,0x4e,0x82,0xcd,0x7c,0x6d,0x87,0x18,0xe7,0x8d,0x80,0x8c,0xd1,0x4b,0x22,0x4c, /* .N..|m.......K"L */ \
	0x02,0x51,0x44,0x35,0x48,0x06,0x05,0xd3,0x13,0x72,0xa9,0x81,0x24,0x1a,0x31,0xef, /* .QD5H....r..$.1. */ \
	0x0d,0x49,0x5a,0x83,0x23,0x00,0xb0,0x3f,0x40,0xfe,0xf0,0x41,0x55,0x86,0x50,0xbd, /* .IZ.#..?@..AU.P. */ \
	0xf1,0x08,0x86,0x4a,0x36,0x7f,0x4f,0xcd,0x50,0xbc,0xc1,0x81,0x41,0x94,0xa0,0xba, /* ...J6.O.P...A... */ \
	0x52,0x6d,0x47,0xfc,0x2d,0xd7,0x5b,0xd5,0x00,0x04,0x3a,0x03,0x43,0xf1,0x65,0x0b, /* RmG.-.[...:.C.e. */ \
	0xf4,0x2a,0xd1,0x7b,0x09,0xdc,0xc4,0x21,0xb9,0xc4,0x81,0x49,0x3d,0x8f,0x68,0x83, /* ...{...!...I=.h. */ \
	0xb7,0xd1,0xf7,0x54,0x1b,0x29,0xcf,0x4b,0x49,0x7d,0xea,0x2d,0x9a,0xd5,0x84,0xfe, /* ...T.).KI}.-.... */ \
	0x1d,0x3b,0xdf,0x38,0x0e,0xd7,0x16,0xc9,0x53,0x0f,0xd4,0x18,0x1c,0x1c,0xc8,0x81, /* .;.8....S....... */ \
	0x04,0x14,0xfe,0x13,0xc6,0xc2,0x0d,0x5f,0xb4,0xb1,0x17,0xb5,0x2d,0x8c,0x0d,0xdb, /* ......._....-... */ \
	0x36,0x61,0x58,0x5f,0x87,0xa1,0x37,0x11,0x6f,0xeb,0xe2,0xb5,0x94,0x4e,0x41,0x67, /* 6aX_..7.o....NAg */ \
	0xc0,0x69,0x12,0x2a,0xe2,0x39,0x07,0xa0,0xc9,0x3c,0xea,0xd6,0x6a,0x28,0xf6,0xcb, /* .i...9...<..j(.. */ \
	0x4b,0xa4,0xb3,0xfe,0x7d,0xe5,0x55,0x7f,0x56,0x79,0x59,0xc1,0xf1,0xac,0x34,0x74, /* K...}.U.VyY...4t */ \
	0x39,0x35,0xb8,0x22,0xed,0x43,0x86,0xdc,0x70,0x5c,0xaa,0x11,0x9a,0xc7,0x82,0x6c, /* 95.".C..p\.....l */ \
	0x69,0xd5,0xc7,0x8c,0x0f,0x35,0x67,0xd0,0x3f,0x07,0x25,0xda,0x41,0xa6,0x56,0x5b, /* i....5g.?.%.A.V[ */ \
	0x1b,0x3b,0x50,0xa2,0xb3,0xe6,0x19,0xe1,0xb9,0x54,0x68,0x83,0xdd,0x81,0x66,0x31, /* .;P......Th...f1 */ \
	0xc9,0xe5,0x47,0xf1,0x87,0x3a,0xa0,0xdd,0xb1,0x40,0xba,0xa0,0x4e,0xf7,0xf4,0x67, /* ..G..:...@..N..g */ \
	0x31,0xda,0x65,0xe5,0x91,0x00,0xaa,0x55,0x78,0x5e,0x19,0x40,0xae,0xc6,0xc5,0x3b, /* 1.e....Ux^.@...; */ \
	0x9b,0x8d,0x2b,0x3a,0x53,0xd0,0x57,0x0a,0x4b,0x3d,0x7e,0xa9,0x75,0xf5,0xd9,0xa5, /* ..+:S.W.K=~.u... */ \
	0x59,0x4a,0xa2,0x9a,0x64,0x3e,0x2a,0x95,0x52,0x40,0x8e,0x11,0x84,0x3d,0xb0,0x6b, /* YJ..d>..R@...=.k */ \
	0xee,0x9f,0x94,0xf2,0x37,0x97,0x34,0xc4,0x2f,0xd2,0xa3,0x2b,0xb3,0x42,0x87,0x8e, /* ....7.4./..+.B.. */ \
	0x8e,0x1a,0x0d,0xcb,0x40,0x8f,0x2f,0x5e,0xa9,0x58,0xd0,0xf4,0x36,0xc1,0x4a,0xc9, /* ....@./^.X..6.J. */ \
	0x01,0x21,0x3f,0x4a,0x6f,0x77,0xcb,0x98,0x17,0x10,0x86,0x73,0x02,0xf4,0x20,0xc0, /* .!?Jow.....s.. . */ \
	0x2f,0xcf,0x65,0x53,0xf1,0xc5,0x52,0x81,0x0d,0xa4,0x09,0x7a,0xbe,0x03,0x97,0xc7, /* /.eS..R....z.... */ \
	0xbd,0x00,0x38,0x1e,0x54,0x74,0x1b,0x82,0x9a,0xe6,0x1b,0x3c,0x48,0xc3,0x11,0x41, /* ..8.Tt.....<H..A */ \
	0xad,0xae,0xe4,0x2b,0x5d,0xf9,0xd3,0xcd,0x1b,0xdf,0x53,0xc7,0xf0,0x60,0x96,0xa1, /* ...+].....S..`.. */ \
	0xb3,0x3d,0xc1,0xf8,0xc1,0x16,0x22,0xaa,0x44,0x71,0x4f,0x38,0x16,0xe0,0x0a,0xe8, /* .=....".DqO8.... */ \
	0x9d,0xef,0xf0,0x8f,0x00,0x80,0xe0,0x5f,0xb3,0x01,0x7b,0x24,0x14,0x87,0xba,0xcb, /* ......._..{$.... */ \
	0x70,0x75,0x41,0x6c,0xf2,0x1d,0xc4,0x17,0x62,0x1f,0x1d,0x65,0x35,0x30,0x26,0x3b, /* puAl....b..e50&; */ \
	0x02,0x0b,0x56,0xf6,0x22,0x69,0x85,0xa0,0x63,0xcf,0x64,0xc3,0x7a,0x52,0x01,0xd0, /* ..V."i..c.d.zR.. */ \
	0xd7,0xd8,0xee,0x86,0x6a,0x8d,0x25,0x1f,0xb9,0x63,0x4a,0x8e,0x54,0x87,0xda,0xe8, /* ....j.%..cJ.T... */ \
	0x47,0x1c,0xeb,0x26,0x08,0xde,0x1a,0xc2,0x0e,0xb5,0x50,0xf2,0x1a,0x19,0x0a,0x5a, /* G..&......P....Z */ \
	0x29,0x1c,0x46,0xd8,0x1d,0x4c,0xf8,0xc1,0x3f,0x5d,0x5e,0x92,0x53,0xf2,0xcd,0x37, /* ).F..L..?]^.S..7 */ \
	0x24,0xdd,0x24,0x80,0xb7,0x9b,0x00,0x5f,0x43,0xea,0x51,0x6c,0x1b,0xa2,0x63,0x3b, /* $.$...._C.Ql..c; */ \
	0x24,0x2b,0x03,0x43,0xa3,0xe6,0xec,0xb7,0x3e,0x44,0x1c,0x95,0x22,0x6c,0x9c,0x30, /* $+.C....>D.."l.0 */ \
	0x09,0x07,0x44,0x85,0x3b,0x8f,0xb2,0x98,0xb6,0x08,0xb4,0x8e,0x9d,0x56,0x95,0xde, /* ..D.;........V.. */ \
	0x54,0xeb,0xa9,0x1e,0x35,0xf1,0xc7,0x30,0x39,0x1c,0x8a,0x90,0x09,0xb6,0xdf,0x54, /* T...5..09......T */ \
	0xe1,0xb6,0xef,0xf0,0x69,0x5d,0xda,0x1a,0x3f,0x26,0x7f,0x2a,0x57,0xb4,0x9f,0x3c, /* ....i]..?&..W..< */ \
	0x11,0x22,0xab,0xa9,0x71,0xcd,0x21,0x55,0x75,0x8e,0xa3,0x29,0x09,0xb8,0xda,0x0d, /* ."..q.!Uu..).... */ \
	0xac,0x1c,0xbc,0x4d,0xdb,0x85,0x3f,0xaf,0x67,0x10,0xe3,0x2f,0x33,0xc3,0xa1,0xf8, /* ...M..?.g../3... */ \
	0x99,0xd1,0x87,0x30,0x4d,0x3f,0x0e,0x42,0x8d,0x27,0x30,0x5b,0x3b,0xc0,0xec,0x02, /* ...0M?.B.'0[;... */ \
	0x26,0xe3,0x10,0xfe,0xc1,0x60,0x31,0xb1,0x45,0x0f,0x05,0x96,0xe2,0x40,0x90,0xa8, /* &....`1.E....@.. */ \
	0xeb,0x2a,0xa3,0xcb,0x51,0xf5,0x62,0xcc,0x61,0x46,0x5f,0x4b,0x0b,0x28,0xd5,0x2a, /* ....Q.b.aF_K.(.. */ \
	0x1d,0xeb,0xd2,0xaa,0x50,0x0d,0x78,0x8a,0x8b,0xc1,0x12,0x93,0x2c,0x15,0xf4,0x1a, /* ....P.x.....,... */ \
	0xa8,0x0b,0x2e,0x52,0x17,0xb0,0x8c,0x2e,0xa8,0x2e,0x04,0x58,0x3d,0x2b,0xc6,0x54, /* ...R.......X=+.T */ \
	0x66,0xa1,0xda,0x8b,0x0c,0x23,0x2d,0xca,0xf8,0x91,0xc4,0x97,0x66,0x28,0x6b,0x7e, /* f....#-.....f(k~ */ \
	0x1f,0xf3,0xac,0xa9,0x7a,0x4f,0xc9,0xd6,0xb0,0x31,0xf7,0xe1,0xbe,0xb0,0x0d,0x91, /* ....zO...1...... */ \
	0x1c,0x60,0x2d,0xc9,0x0a,0x98,0x5b,0x94,0xb2,0x27,0xcc,0x4d,0xd9,0xf2,0x77,0x71, /* .`-...[..'.M..wq */ \
	0x0a,0xbf,0xdf,0x82,0xdc,0x7b,0xf6,0x41,0xd8,0xca,0x26,0xc0,0xa2,0x47,0xa2,0x44, /* .....{.A..&..G.D */ \
	0xc2,0x07,0xd0,0x76,0xbd,0xcd,0xd3,0x4d,0xe8,0x51,0x2d,0xcd,0x1a,0x14,0x0f,0x6c, /* ...v...M.Q-....l */ \
	0x8f,0x5b,0xca,0xa3,0x98,0x81,0xbd,0xae,0x43,0xfd,0x30,0xe2,0x2e,0xdb,0xc4,0xc0, /* .[......C.0..... */ \
	0xf7,0xb5,0x8a,0x1c,0x5b,0xb2,0x30,0x6c,0x70,0x6f,0xcd,0x5f,0xdd,0x1e,0x03,0x83, /* ....[.0lpo._.... */ \
	0x88,0xd2,0x61,0x0b,0x02,0x8f,0xc3,0x3c,0x9e,0x37,0xcf,0x99,0xe1,0x5b,0x30,0x34, /* ..a....<.7...[04 */ \
	0x01,0x71,0x18,0xb8,0xde,0x4a,0x0e,0xa1,0x7f,0x2a,0x3a,0x29,0xa5,0xe8,0x23,0xe5, /* .q...J....:)..#. */ \
	0x37,0x1a,0xe4,0xfd,0x06,0xc2,0xe4,0x07,0x4a,0x3d,0xae,0xf4,0xe0,0x3f,0xe2,0x86, /* 7.......J=...?.. */ \
	0xc9,0x8c,0x41,0x05,0xb5,0x8b,0x54,0x8a,0x82,0x59,0x2f,0xe6,0x0b,0x90,0x6e,0x04, /* ..A...T..Y/...n. */ \
	0xd4,0xb9,0xc7,0xc9,0xd2,0x12,0xe8,0xc4,0x0c,0xa4,0xdd,0xc2,0x79,0x2b,0x36,0x0a, /* ............y+6. */ \
	0x44,0x54,0x03,0x9b,0xa9,0x55,0xe2,0x9c,0xa0,0xd2,0x68,0xb7,0xf4,0x0c,0x64,0x6c, /* DT...U....h...dl */ \
	0xf8,0x81,0x9c,0x8b,0x3e,0xac,0x9d,0x89,0x9a,0x00,0xf9,0x34,0xdc,0xf8,0x2e,0x98, /* ....>......4.... */ \
	0x16,0x44,0x70,0x98,0xb4,0xc8,0xcc,0x4e,0xa6,0xc0,0xd1,0xdc,0x01,0x27,0x36,0x00, /* .Dp....N.....'6. */ \
	0x75,0xcd,0xe7,0x36,0x12,0x05,0xfe,0x88,0xc0,0x45,0x13,0x98,0xfb,0x3b,0x96,0x68, /* u..6.....E...;.h */ \
	0xc0,0xbf,0xa2,0x96,0x05,0xd4,0xf0,0xcd,0x15,0x3a,0x4e,0x2d,0x75,0x01,0xd7,0x0d, /* .........:N-u... */ \
	0x3d,0xfd,0x84,0x3e,0xb4,0x26,0x51,0x35,0x04,0x08,0x0c,0xc0,0x0a,0x66,0x97,0xf1, /* =..>.&Q5.....f.. */ \
	0x64,0x86,0xff,0xc4,0x20,0x2e,0x2d,0x93,0xbf,0x45,0x6b,0xac,0x6c,0xc4,0x34,0x8c, /* d... .-..Ek.l.4. */ \
	0x5a,0x15,0xf2,0x3d,0x69,0x91,0x97,0xa2,0x69,0xa4,0x5c,0xa1,0xbf,0xd3,0xcd,0x07, /* Z..=i...i.\..... */ \
	0x54,0x45,0xf6,0xa4,0x05,0x8e,0xe0,0x6a,0x37,0x33,0x96,0x43,0x03,0x72,0x02,0xde, /* TE.....j73.C.r.. */ \
	0x7b,0xfd,0x17,0x8e,0xe3,0xb7,0xe6,0xc2,0xf6,0x21,0x2d,0xc0,0xef,0x4d,0x17,0x66, /* {........!-..M.f */ \
	0x70,0x9c,0xd2,0x94,0x6e,0x09,0xd6,0xc9,0x27,0x22,0x4d,0x24,0x2c,0x69,0xeb,0x97, /* p...n...'"M$,i.. */ \
	0x5d,0x48,0x9b,0xe1,0x9a,0x01,0x33,0xd0,0xd0,0x5c,0xd5,0xa8,0x0f,0x2e,0xe9,0x8f, /* ]H....3..\...... */ \
	0x44,0x03,0xd4,0x1a,0x3e,0xd8,0xba,0x94,0xa7,0xa1,0xcf,0x93,0xaf,0x1a,0x84,0xd7, /* D...>........... */ \
	0x58,0xa6,0x90,0x5d,0xe2,0x03,0x94,0xe2,0x99,0xc6,0x15,0x7f,0x44,0x4e,0x23,0x09, /* X..]........DN#. */ \
	0x4a,0xec,0x15,0x7b,0x6d,0x2c,0x69,0x70,0x3c,0x37,0xfc,0xa3,0x0a,0x79,0xce,0x9b, /* J..{m,ip<7...y.. */ \
	0x3d,0x27,0x95,0xa6,0xe7,0x2e,0x2b,0x17,0xe9,0x3e,0x7d,0xba,0x06,0xcf,0xde,0x5b, /* ='....+..>}....[ */ \
	0x51,0xf3,0xc3,0xda,0xf0,0x3f,0xd4,0xe2,0x4e,0x79,0xee,0xc9,0xcd,0xfa,0xb2,0x30, /* Q....?..Ny.....0 */ \
	0x86,0x57,0xb1,0xc8,0x31,0xc3,0x46,0xd5,0x7a,0xbe,0x44,0x2b,0xe1,0x9c,0x59,0xbb, /* .W..1.F.z.D+..Y. */ \
	0x4a,0xfd,0x97,0xd6,0x6f,0x5a,0xce,0xea,0xb3,0x2d,0x16,0x2f,0x38,0xfa,0x26,0xfe, /* J...oZ...-./8.&. */ \
	0x88,0x78,0xc0,0x80,0xcd,0xb3,0xd1,0x36,0xe6,0x9f,0x7f,0xe3,0x2d,0xe3,0x84,0xf4, /* .x.....6....-... */ \
	0xf9,0xf3,0x6c,0x26,0x8a,0x2d,0x7e,0xb1,0x7f,0x13,0x89,0x21,0x1f,0x2c,0xc5,0x13, /* ..l&.-~....!.,.. */ \
	0x7c,0xaf,0x65,0xdf,0x46,0xdf,0x74,0x5f,0x91,0x6d,0x66,0x78,0x98,0xf4,0x0b,0x24, /* |.e.F.t_.mfx...$ */ \
	0x11,0xfb,0x26,0x9f,0xd2,0x62,0x0a,0x32,0x04,0x85,0xa8,0x55,0x2a,0x75,0xcd,0x05, /* ..&..b.2...U.u.. */ \
	0x64,0x07,0x93,0x82,0x9f,0xb0,0xc3,0x5d,0x0d,0x82,0x66,0x52,0xae,0x81,0x7c,0x13, /* d......]..fR..|. */ \
	0xb1,0x1d,0x40,0xa0,0x03,0xab,0x93,0x2d,0x35,0x0e,0x4d,0x03,0x8c,0xbe,0xf5,0x52, /* ..@....-5.M....R */ \
	0x1b,0x74,0x09,0x0a,0x22,0xaa,0xb8,0xac,0xa2,0xf1,0x30,0x07,0xe2,0x3e,0x5c,0x68, /* .t..".....0..>\h */ \
	0x60,0xed,0x02,0xb0,0x2d,0xf5,0xf6,0xc2,0x9d,0xbd,0xd4,0x7e,0x7c,0xab,0xff,0x68, /* `...-......~|..h */ \
	0x9f,0x14,0xa1,0xf4,0x8c,0x22,0x94,0x60,0xf4,0x06,0x64,0xbf,0x1a,0x20,0xb8,0x1e, /* .....".`..d.. .. */ \
	0x7b,0xed,0xb1,0x20,0x90,0x53,0x61,0x94,0x15,0x01,0x27,0x4c,0x9f,0xe5,0x63,0xf8, /* {.. .Sa...'L..c. */ \
	0x98,0x52,0x70,0x4d,0x7a,0x49,0x99,0xab,0x17,0x3f,0xd2,0xdd,0xd8,0x87,0xc9,0x76, /* .RpMzI...?.....v */ \
	0x88,0xf2,0xec,0xc1,0x48,0x25,0xa5,0xff,0x81,0xc6,0x82,0xc7,0xdf,0x20,0x8f,0xf3, /* ....H%....... .. */ \
	0xd3,0x49,0x5f,0x4e,0xb0,0x26,0x74,0xd9,0x7f,0xf0,0x6a,0x95,0xff,0xfa,0xa5,0x75, /* .I_N.&t...j....u */ \
	0xf4,0xad,0x71,0xb4,0xe8,0x1e,0xdd,0xfc,0xf6,0x47,0xbb,0xf5,0xf1,0xdf,0x21,0xc8, /* ..q......G....!. */ \
	0x22,0xe9,0x26,0xda,0x0a,0xd7,0xd3,0x15,0x7d,0x40,0x5c,0x0d,0xf0,0xed,0x62,0x05, /* ".&.....}@\...b. */ \
	0x0b,0xa3,0xb1,0x0a,0x1a,0x1a,0xe2,0x6e,0x1a,0x73,0xf3,0x8f,0xb3,0x1c,0x74,0xdd, /* .......n.s....t. */ \
	0x69,0x6f,0x30,0x10,0x08,0xcf,0x0a,0xf1,0xb5,0x3b,0x2f,0xf6,0x53,0xda,0x39,0xdf, /* io0......;/.S.9. */ \
	0x47,0x69,0xe7,0x7c,0x3f,0xe6,0x1c,0x52,0xdb,0x27,0xfb,0x69,0x6d,0x9f,0x14,0xa0, /* Gi.|?..R.'.im... */ \
	0xf4,0x8c,0x5c,0x7c,0x2f,0x1a,0xe7,0xc5,0x18,0x3d,0x23,0x08,0xbc,0x95,0x6f,0x60, /* ..\|/....=#...o` */ \
	0x34,0x7e,0x71,0x74,0x7e,0x02,0x0d,0x0c,0x1f,0x66,0xd5,0xd4,0x57,0xe8,0xb5,0x89, /* 4~qt~....f..W... */ \
	0xaf,0xef,0xbf,0x09,0x96,0x17,0x89,0x71,0x85,0x44,0xd2,0x70,0x6c,0x2b,0x2a,0x8c, /* .......q.D.pl+.. */ \
	0x46,0xde,0x53,0xe8,0x01,0x7a,0xd0,0x76,0xd6,0x85,0x40,0xa6,0x92,0x4a,0xdc,0xd6, /* F.S..z.v..@..J.. */ \
	0xc1,0x12,0xd5,0x7a,0xec,0x50,0x54,0x7b,0x8a,0x4b,0x6c,0x62,0x21,0xeb,0x6d,0x7f, /* ...z.PT{.Klb!.m. */ \
	0x8c,0xfd,0xe8,0xca,0xae,0xfa,0x88,0xbb,0x7f,0x3c,0xdd,0x14,0xf8,0x05,0x07,0xe8, /* .........<...... */ \
	0x9c,0x7f,0xf5,0x7f,0x75,0xd1,0x57,0xaf,0x23,0x86,0xd4,0x27,0x93,0xc9,0x41,0x37, /* ....u.W.#..'..A7 */ \
	0x00,0xea,0x09,0xfd,0x86,0xf6,0x71,0xc1,0x23,0x45,0x0c,0x32,0xcb,0x93,0xd8,0x32, /* ......q.#E.2...2 */ \
	0x29,0x2a,0x4f,0xbb,0x57,0x30,0x8d,0x05,0x87,0x6e,0x52,0x48,0xb5,0x02,0x98,0x44, /* ).O.W0...nRH...D */ \
	0x51,0xb1,0xb6,0xb9,0x64,0x64,0x8e,0x4b,0xe3,0xf0,0x75,0x8d,0xd9,0x4c,0x00,0x6e, /* Q...dd.K..u..L.n */ \
	0x10,0xcb,0xf8,0x90,0xaa,0xc2,0x3c,0x4b,0xd6,0x47,0x73,0xb1,0x0a,0x4f,0x2c,0x47, /* ......<K.Gs..O,G */ \
	0x19,0xe3,0x0b,0xa4,0xba,0xe9,0x9c,0x10,0x3f,0x2a,0x72,0xfd,0xfe,0xfb,0xdd,0xcd, /* ........?.r..... */ \
	0xdd,0xef,0xbf,0xa7,0xa5,0x9b,0x3f,0x41,0x8d,0x98,0x04,0x37,0x7c,0x10,0x8b,0x62, /* ......?A...7|..b */ \
	0x38,0x99,0xeb,0xec,0x38,0x9b,0x62,0xb5,0x1b,0x07,0x03,0xd4,0x70,0x4d,0x83,0x00, /* 8...8.b.....pM.. */ \
	0xa2,0x27,0xf2,0x0a,0xbc,0xe1,0xf3,0xfc,0x94,0x3d,0xa1,0x6b,0xed,0x8b,0x6c,0x03, /* .'.......=.k..l. */ \
	0x39,0xb6,0x40,0xdd,0x90,0xf1,0x31,0xe3,0xbd,0x52,0xeb,0x19,0x1f,0xea,0xcf,0x33, /* 9.@...1..R.....3 */ \
	0xaf,0x40,0xb4,0x26,0x5f,0xc7,0x9d,0x53,0xc2,0x89,0x69,0x48,0x59,0xe7,0x8d,0x07, /* .@.&_..S..iHY... */ \
	0x4a,0xac,0x26,0x5d,0x52,0x33,0xc4,0x8a,0x29,0xc0,0xf3,0xd4,0x6c,0x01,0xa3,0x42, /* J.&]R3..)...l..B */ \
	0xeb,0x58,0x04,0x51,0xef,0xbb,0x05,0x0d,0xb2,0x58,0xf1,0x53,0x53,0xee,0x63,0x1f, /* .X.Q.....X.SS.c. */ \
	0x5a,0xe1,0x5f,0xf2,0x5a,0xe4,0x4c,0x02,0x72,0xf8,0x2d,0x25,0xf5,0xa4,0xe4,0xa5, /* Z._.Z.L.r.-%.... */ \
	0xb1,0x62,0x3d,0x0e,0x15,0x15,0xf3,0x5c,0x93,0xf9,0x3e,0xa4,0xc8,0x44,0xa4,0x14, /* .b=....\..>..D.. */ \
	0xb9,0x83,0x91,0xc2,0xf3,0x1c,0x10,0x41,0x40,0x09,0xc8,0x1a,0x67,0x07,0x20,0x68, /* .......A@...g. h */ \
	0x6a,0xe3,0x8c,0xe1,0x65,0x49,0xd0,0x9a,0x51,0xc7,0xf8,0x00,0xaa,0x05,0xbe,0x17, /* j...eI..Q....... */ \
	0xfc,0xb0,0x61,0x51,0x13,0x12,0x34,0x47,0x39,0x4d,0xe6,0x97,0x45,0x34,0xaf,0x43, /* ..aQ..4G9M..E4.C */ \
	0x5c,0x00,0x3c,0xe0,0x70,0x85,0xb3,0x8c,0x7d,0x63,0x11,0x8a,0x8f,0x39,0x7a,0x99, /* \.<.p...}c...9z. */ \
	0xd1,0x2d,0xfc,0x14,0xc8,0x9b,0xab,0x0c,0x48,0x50,0x66,0x60,0x22,0x01,0x25,0xff, /* .-......HPf`".%. */ \
	0xf8,0x07,0x49,0x3d,0x84,0xa9,0x4b,0xce,0x20,0xee,0x41,0x8c,0x9f,0xa2,0xa4,0xb2, /* ..I=..K. .A..... */ \
	0x02,0xce,0xba,0x52,0x6f,0xf2,0x8a,0x0d,0xe7,0xfc,0xb4,0x55,0x24,0x9e,0x1c,0xfe, /* ...Ro......U$... */ \
	0x14,0x8f,0x79,0xb4,0x83,0xe4,0xb2,0xb4,0x77,0xce,0xeb,0x5f,0x92,0xf8,0x76,0xeb, /* ..y.....w.._..v. */ \
	0x74,0x0f,0xf5,0x25,0xd4,0xbc,0xf5,0xf8,0xb8,0x6a,0x3f,0x3f,0xe2,0xf6,0x18,0x5c, /* t..%.....j??...\ */ \
	0x76,0xd0,0xa2,0x51,0x9c,0x46,0x25,0x84,0xa3,0x62,0xe2,0x77,0x9f,0x18,0x12,0xe3, /* v..Q.F%..b.w.... */ \
	0x98,0xfd,0x67,0x54,0xfc,0x33,0x2a,0x1e,0x10,0x15,0x63,0xc5,0xf9,0x12,0xc1,0x51, /* ..gT.3....c....Q */ \
	0xc3,0x7e,0x58,0x8c,0x14,0x89,0x6b,0x5e,0xa0,0xfa,0x62,0x71,0x6a,0xdc,0xd5,0xc9, /* .~X...k^..bqj... */ \
	0xb5,0x18,0x15,0x01,0x6b,0x65,0xdc,0xd3,0x4f,0x88,0x5a,0xe3,0x18,0xa5,0x8a,0x5d, /* ....ke..O.Z....] */ \
	0x79,0x39,0x75,0xf3,0x4b,0x45,0x8f,0x2f,0xe6,0xc6,0x12,0xb3,0x41,0x31,0x9b,0x53, /* y9u.KE./....A1.S */ \
	0x65,0xb3,0xcb,0x52,0x1f,0xd1,0x94,0xc8,0xfa,0xaa,0xda,0xff,0x86,0xf2,0x02,0xdb, /* e..R............ */ \
	0x96,0x9b,0x20,0xc8,0x74,0x3a,0xb8,0x26,0x97,0x07,0x61,0x8d,0x67,0xa2,0x7c,0x3e, /* .. .t:.&..a.g.|> */ \
	0x2f,0x31,0xd5,0x6c,0x2b,0x59,0xcb,0x29,0x0c,0x1e,0x62,0x2f,0x09,0xc4,0x0f,0xcb, /* /1.l+Y.)..b/.... */ \
	0x0e,0xb0,0x36,0x62,0xa1,0xee,0xf1,0x05,0xd4,0x8c,0x83,0x06,0xaa,0x2c,0xe6,0x56, /* ..6b.........,.V */ \
	0x43,0x5c,0x9f,0x64,0x5b,0x6e,0x8f,0x7c,0x4d,0xd2,0x74,0x6c,0xd0,0x6d,0x5c,0x8c, /* C\.d[n.|M.tl.m\. */ \
	0x94,0xbb,0x4a,0xe4,0x8e,0x0f,0xe2,0x1a,0x60,0xc5,0xc9,0x49,0x38,0x5f,0x30,0xc3, /* ..J.....`..I8_0. */ \
	0x8d,0x7c,0x72,0x4b,0x8a,0xb3,0x03,0x9c,0xb8,0x6c,0x62,0xf0,0xdd,0x2b,0x5a,0x79, /* .|rK.....lb..+Zy */ \
	0x84,0x8b,0x3a,0x3d,0x00,0x62,0x77,0x02,0xc7,0x3e,0x06,0x8d,0x5a,0x67,0x76,0xd6, /* ..:=.bw..>..Zgv. */ \
	0x60,0xa3,0x54,0x03,0xdb,0x6a,0x06,0x9e,0x63,0x87,0xb5,0xca,0xaf,0xad,0x4e,0xab, /* `.T..j..c.....N. */ \
	0xd2,0x20,0x27,0xb1,0xa7,0xe6,0xf8,0x80,0x4a,0x8e,0x27,0x86,0x4a,0x96,0x8e,0xa2, /* . '.....J.'.J... */ \
	0x99,0x5c,0xb2,0x4d,0x5b,0x6f,0xb3,0x75,0x0c,0x37,0xaf,0x51,0xe7,0xb7,0xc4,0xa4, /* .\.M[o.u.7.Q.... */ \
	0x50,0xf4,0xa5,0x79,0x4a,0x4d,0xbc,0xa2,0x24,0x5f,0xe5,0x3a,0x00,0xa2,0x40,0x6b, /* P..yJM..$_.:..@k */ \
	0x04,0xf3,0x71,0xe8,0x02,0xfe,0x02,0xf6,0x0f,0xcf,0xaa,0x89,0xf2,0x51,0x4a,0x3e, /* ..q..........QJ> */ \
	0xca,0x54,0x84,0x3f,0x89,0xa8,0x49,0x14,0x41,0x0b,0xfb,0x94,0x11,0xd6,0x5c,0x31, /* .T.?..I.A.....\1 */ \
	0xdc,0xe1,0x29,0xb2,0x4d,0x62,0x58,0x2b,0x66,0x62,0xf6,0x67,0xbb,0x0b,0xdf,0xc0, /* ..).MbX+fb.g.... */ \
	0x2f,0x01,0x5b,0x18,0x1e,0x7e,0xd9,0x2e,0xbc,0x8e,0xb7,0x97,0x1c,0x65,0x2f,0xa9, /* /.[..~.......e/. */ \
	0x52,0x5f,0xb2,0x20,0xb7,0xa7,0xcc,0x17,0x1b,0x1f,0xf2,0x83,0x6d,0x9f,0x25,0x82, /* R_. ........m.%. */ \
	0x68,0x52,0x2d,0xf9,0x72,0xcd,0x9a,0x1a,0x2e,0x56,0xaf,0x0d,0x91,0x76,0x23,0x0c, /* hR-.r....V...v#. */ \
	0xba,0x35,0x54,0x58,0xfa,0x60,0x07,0x61,0x02,0x02,0x83,0x0e,0x38,0x3b,0xac,0xb8, /* .5TX.`.a....8;.. */ \
	0xc9,0x2d,0x62,0x52,0x2f,0x79,0x58,0x10,0x0a,0xc9,0x47,0x62,0x6d,0xb8,0x1b,0xd0, /* .-bR/yX...Gbm... */ \
	0xf7,0x5d,0x02,0x9a,0x6f,0x94,0xc2,0x4e,0x78,0x25,0x5f,0x99,0x6f,0xb3,0xd9,0x24, /* .]..o..Nx%_.o..$ */ \
	0x96,0xcf,0x3c,0x8b,0x6d,0x75,0x45,0x66,0xdb,0xe2,0x42,0x61,0x51,0x91,0x30,0x06, /* ..<.muEf..BaQ.0. */ \
	0xe7,0x0b,0xf6,0x28,0xc0,0xc1,0x7a,0xa9,0xcb,0x4b,0xd4,0x05,0xa5,0xc8,0x6a,0x15, /* ...(..z..K....j. */ \
	0x7b,0xbd,0x4c,0xac,0xc8,0x28,0x90,0x66,0xe0,0x9b,0xe8,0xef,0x65,0x81,0xd6,0x54, /* {.L..(.f....e..T */ \
	0x43,0xa1,0x4a,0xb3,0xf9,0x54,0xea,0x95,0x48,0x85,0x29,0x67,0xe5,0xa1,0xd0,0xa9, /* C.J..T..H.)g.... */ \
	0xa0,0xfe,0x45,0x29,0xe9,0x65,0x52,0x1f,0xdb,0x75,0xf2,0x3d,0xd0,0x83,0x3a,0x55, /* ..E).eR..u.=..:U */ \
	0x21,0x2f,0x49,0x85,0xab,0x59,0x45,0xdf,0x4b,0xf0,0xf6,0xe6,0xf7,0x49,0x5f,0xec, /* !/I..YE.K....I_. */ \
	0x2d,0x8d,0x55,0x20,0x89,0x42,0xcf,0x1a,0xcb,0xd1,0x20,0x7b,0xdc,0x63,0x28,0x9d, /* -.U .B.... {.c(. */ \
	0xa7,0x60,0x15,0xd4,0xef,0xc1,0x7a,0xf2,0x14,0xac,0xdc,0xbe,0xf6,0x61,0x3d,0x7d, /* .`....z......a=} */ \
	0x0a,0x56,0xdc,0x98,0x63,0x20,0x5a,0x01,0x5b,0x3c,0x9f,0x08,0x6c,0x4b,0x83,0x43, /* .V..c Z.[<..lK.C */ \
	0x9f,0x75,0xf1,0x38,0x90,0x36,0x09,0xb9,0x4c,0x94,0xa2,0x3d,0x5c,0x56,0x1a,0xb8, /* .u.8.6..L..=\V.. */ \
	0x71,0x65,0x34,0xe9,0x7e,0x45,0x30,0x55,0xc3,0x9c,0x6d,0x9c,0xb1,0x77,0x91,0x77, /* qe4.~E0U..m..w.w */ \
	0x17,0x17,0x5e,0x2f,0x4a,0x88,0x06,0xeb,0x69,0x31,0xb5,0x31,0x09,0x1f,0x75,0x67, /* ..^/J...i1.1..ug */ \
	0xad,0xb2,0x5a,0x95,0x0c,0xe7,0xba,0x9e,0x54,0xbe,0x8e,0x47,0x10,0xd0,0x31,0x88, /* ..Z.....T..G..1. */ \
	0x69,0x01,0x99,0xb3,0x07,0xb5,0x9d,0x5e,0xc5,0x85,0x04,0x34,0x64,0xbd,0x90,0x01, /* i......^...4d... */ \
	0x00,0x8d,0xd8,0x02,0x42,0xa1,0x6d,0xa1,0xbb,0xda,0x1a,0x6e,0x28,0x16,0xc6,0xc2, /* ....B.m....n(... */ \
	0x7c,0xc8,0x22,0xbf,0x7a,0x00,0xcf,0xfa,0x8a,0x51,0xac,0x68,0x39,0x93,0x32,0x89, /* |.".z....Q.h9.2. */ \
	0xed,0x03,0xc4,0x78,0xb6,0x58,0x34,0xc5,0x24,0xa3,0x96,0x5e,0x84,0x78,0x2c,0x63, /* ...x.X4.$..^.x,c */ \
	0x91,0xe9,0xcf,0x0f,0x4c,0x6e,0x61,0x9d,0x52,0x07,0xd2,0x20,0x2d,0xf5,0x29,0x91, /* ....Lna.R.. -.). */ \
	0xf5,0x68,0xc9,0xce,0x7b,0xc0,0xa3,0x52,0x9d,0xc4,0xae,0x46,0x3c,0x3f,0x02,0x9c, /* .h..{..R...F<?.. */ \
	0x88,0x35,0x21,0xe1,0xa7,0x57,0xb6,0x65,0x81,0x7f,0xc7,0x83,0x02,0x62,0x67,0x20, /* .5!..W.e.....bg  */ \
	0xe7,0x00,0xa9,0x40,0x1f,0xee,0xb3,0xcd,0x72,0x15,0x81,0x73,0x69,0xe3,0x89,0x02, /* ...@....r..si... */ \
	0x87,0xb7,0x8f,0xb5,0xd4,0x8e,0x57,0x0d,0x79,0x6e,0x59,0xbc,0x3c,0x05,0xc6,0xd3, /* ......W.ynY.<... */ \
	0xae,0x46,0xd3,0x71,0x22,0x92,0x8e,0x8b,0x08,0xf4,0xf9,0x3e,0x58,0x6a,0xe6,0x82, /* .F.q"......>Xj.. */ \
	0x26,0xd3,0x8c,0x9f,0x0c,0x27,0x95,0x78,0x4c,0x0c,0xcb,0x66,0xf9,0x44,0x05,0x57, /* &....'.xL..f.D.W */ \
	0x3b,0xbe,0x28,0x56,0xc5,0x76,0xed,0x28,0x64,0x47,0x6b,0x5e,0x2d,0xb1,0xe6,0x15, /* ;.(V.v.(dGk^-... */ \
	0x61,0xd9,0xbf,0xf0,0xa5,0xdc,0x10,0x6f,0x8a,0x8b,0x57,0x3c,0x38,0x50,0x7d,0x9e, /* a......o..W<8P}. */ \
	0x9d,0x4a,0xcc,0x25,0xc1,0xb8,0x9b,0x9a,0x1c,0x11,0x3b,0x95,0x91,0xeb,0x4b,0x2e, /* .J.%......;...K. */ \
	0x9a,0x26,0x7e,0xd4,0x44,0x0d,0xf2,0x8a,0x99,0x8e,0xc6,0xc9,0x85,0xe0,0x2e,0x17, /* .&~.D........... */ \
	0xb0,0x64,0x26,0x9d,0xb0,0x91,0x4c,0x2e,0x7c,0x68,0xba,0x2e,0xd5,0xf5,0x0e,0x8d, /* .d&...L.|h...... */ \
	0xbb,0x2f,0x26,0x8a,0x91,0xa6,0x4e,0xd8,0x26,0xc4,0x0d,0x78,0xfc,0xa3,0x5a,0x9a, /* ./&...N.&..x..Z. */ \
	0xcc,0x5d,0xd8,0xcb,0x8d,0x4f,0x9b,0xab,0x70,0xed,0x90,0x4a,0x3a,0x31,0xa8,0x1c, /* .]...O..p..J:1.. */ \
	0x92,0xd6,0x6b,0x8a,0x8e,0xee,0x45,0xd8,0x4a,0xa4,0xee,0x24,0xd6,0x76,0xc3,0xb2, /* ..k...E.J..$.v.. */ \
	0xc4,0xc2,0xa6,0x38,0x16,0x03,0xa1,0xe8,0x58,0x24,0x6b,0x01,0x07,0x01,0x04,0x0d, /* ...8....X$k..... */ \
	0x12,0xd2,0x87,0x50,0x6c,0x65,0xc1,0xf4,0x1c,0xd5,0x53,0x9e,0x89,0x91,0x1e,0x88, /* ...Ple....S..... */ \
	0xb7,0xc4,0x2d,0xdb,0xd2,0x55,0x45,0x6b,0x6c,0xb8,0x9c,0x1e,0x35,0x83,0x91,0x4f, /* ..-..UEkl...5..O */ \
	0xbc,0x90,0x7b,0xbb,0x21,0xdb,0x72,0xf1,0x18,0x12,0xe5,0xfb,0xea,0x57,0x90,0x3d, /* ..{.!.r......W.= */ \
	0x42,0x8f,0x22,0x7b,0xd0,0x8e,0xe9,0xc4,0xe6,0x15,0xd3,0x22,0x56,0xff,0xb1,0x43, /* B."{......."V..C */ \
	0xf0,0x4b,0xc7,0xf1,0x54,0x54,0x0d,0x72,0xc1,0xe6,0xf0,0x5a,0xfe,0x73,0x99,0x56, /* .K..TT.r...Z.s.V */ \
	0xe0,0x12,0x7f,0x3b,0x91,0x70,0xe7,0x35,0xcf,0x4f,0x21,0x65,0x8d,0x45,0x6d,0x62, /* ...;.p.5.O!e.Emb */ \
	0x17,0xeb,0xd0,0xaa,0xdc,0xc2,0xb7,0x69,0x44,0xfb,0xed,0xe5,0xe7,0xf3,0x2c,0x57, /* .......iD.....,W */ \
	0x57,0xc3,0x05,0x63,0x61,0x55,0x5b,0xae,0x56,0xb8,0x8b,0x97,0xac,0xb9,0x65,0x89, /* W..caU[.V.....e. */ \
	0xd9,0xaa,0xb6,0x5a,0x0d,0x06,0x06,0x52,0x00,0x5e,0xc4,0xcf,0xcb,0x36,0x39,0xfa, /* ...Z...R.^...69. */ \
	0x0e,0x0f,0x18,0x78,0x49,0xa3,0x13,0xf8,0x2c,0x18,0xf7,0x90,0x4e,0xd8,0x36,0x83, /* ...xI...,...N.6. */ \
	0xa1,0x44,0x54,0xe0,0x9c,0x23,0xd9,0x9f,0xb8,0x50,0x8f,0x28,0xd4,0x42,0x7d,0x86, /* .DT..#...P.(.B}. */ \
	0xf7,0xf6,0x9e,0x74,0x37,0xf4,0x2b,0xa9,0xb5,0xf4,0x76,0x13,0xa2,0x65,0x37,0x94, /* ...t7.+...v..e7. */ \
	0xc7,0x05,0xa1,0x77,0xdc,0x0a,0x5d,0x6d,0x90,0xea,0xd6,0xb6,0xc2,0xd5,0xcb,0x6f, /* ...w..]m.......o */ \
	0xe9,0xba,0x9a,0x4d,0xac,0x71,0xff,0xef,0xde,0x6e,0xac,0x44,0x37,0xbc,0x79,0xaa, /* ...M.q...n.D7.y. */ \
	0x1f,0x93,0x39,0x01,0xa8,0x55,0x55,0x4e,0x2b,0x93,0x4d,0xcb,0xac,0xe8,0x57,0xbb, /* ..9..UUN+.M...W. */ \
	0x68,0xb7,0xd5,0x7a,0x3e,0x75,0x9d,0xf2,0xd4,0xf1,0x13,0x27,0x88,0x6b,0xc0,0x0d, /* h..z>u.....'.k.. */ \
	0x6c,0xcf,0x5c,0x01,0xdf,0x27,0x40,0x63,0xb0,0x14,0x77,0x68,0xea,0x28,0x44,0x1f, /* l.\..'@c..wh.(D. */ \
	0x1d,0x7e,0xb5,0x14,0x08,0xa6,0x8b,0x5c,0xee,0x89,0x80,0xb3,0x17,0x84,0x07,0x3c, /* .~.....\.......< */ \
	0x84,0xe9,0x94,0x6b,0xcf,0x5c,0x5e,0x72,0x40,0x08,0xde,0x06,0x1c,0x24,0x24,0x24, /* ...k.\^r@....$$$ */ \
	0xd5,0xb4,0xfc,0x3b,0x09,0xf9,0xc7,0xd8,0x92,0x92,0xe6,0xba,0x93,0x18,0x28,0x1c, /* ...;..........(. */ \
	0xba,0x8c,0x76,0xa5,0x5b,0x74,0xb2,0xe3,0x05,0xed,0xf6,0x0e,0x57,0x46,0x67,0x3b, /* ..v.[t......WFg; */ \
	0x4f,0xd5,0xd9,0x93,0xc3,0x74,0xf6,0xa4,0xbc,0xce,0x9e,0x94,0xd3,0xd9,0x01,0x46, /* O....t.........F */ \
	0x19,0x70,0x94,0x1b,0x13,0xa6,0xfd,0xb4,0x48,0x79,0x4f,0x0f,0x53,0x5e,0x1e,0xba, /* .p......HyO.S^.. */ \
	0x0e,0x57,0xde,0x18,0xac,0xb4,0xf2,0x16,0x82,0x14,0x2b,0x6f,0x21,0x48,0xa4,0xbc, /* .W........+o!H.. */ \
	0x25,0xdb,0x6b,0xca,0xcb,0xdb,0x14,0x28,0xef,0x69,0x62,0x20,0x62,0x6c,0x19,0xe5, /* %.k....(.ib bl.. */ \
	0xed,0x64,0x54,0xf3,0x24,0xa3,0x66,0xe9,0x16,0xa7,0xb9,0xca,0xbb,0x57,0xab,0x32, /* .dT.$.f......W.2 */ \
	0xca,0x9b,0x56,0xaa,0x02,0xe5,0x4d,0xeb,0xc4,0xd9,0x61,0xaa,0x7b,0x56,0xa8,0xba, /* ..V...M...a.{V.. */ \
	0xd5,0xd3,0x8c,0xcc,0xce,0xca,0x6d,0xa1,0x52,0x89,0x1c,0x06,0xa1,0x78,0x3b,0x55, /* ......m.R....x;U */ \
	0xc4,0x56,0x5a,0x58,0x67,0xb9,0xc2,0xda,0xab,0xdb,0x19,0x61,0x9d,0x3e,0x4d,0x58, /* .VZXg......a.>MX */ \
	0xe7,0x87,0x09,0xeb,0xbc,0xac,0xb0,0x78,0x55,0x13,0x32,0xc1,0xc3,0x8d,0x2d,0x82, /* .......xU.2...-. */ \
	0x2a,0xb0,0x35,0xcc,0xf0,0xaa,0x65,0x00,0x6c,0x0b,0x9b,0xcb,0xd9,0x52,0x89,0xf6, /* ..5...e.l....R.. */ \
	0xca,0x32,0xcb,0x43,0xac,0x8d,0x07,0x91,0xd5,0x20,0xd8,0x49,0x27,0xa3,0x2d,0xe7, /* .2.C..... .I'.-. */ \
	0x89,0x91,0x8e,0xb0,0x64,0x0c,0xec,0x34,0xa3,0x11,0xe7,0xb9,0x1a,0xb1,0x57,0xb3, /* ....d..4......W. */ \
	0x33,0x1a,0x91,0x56,0xec,0x92,0x1a,0xf1,0xd7,0xc3,0x34,0xe2,0xaf,0x07,0x69,0x04, /* 3..V......4...i. */ \
	0xc5,0x48,0xba,0xa7,0x03,0x31,0x57,0x48,0xea,0x03,0x87,0x29,0x1a,0x2b,0x3e,0x9f, /* .H...1WH...).+>. */ \
	0x7d,0xac,0xb5,0xd4,0x84,0x82,0xb6,0xe2,0xc8,0x63,0x00,0x39,0xa2,0x3a,0xaf,0xc4, /* }........c.9.:.. */ \
	0x1f,0xd4,0xaa,0x43,0x98,0x75,0x20,0x60,0x6b,0x1f,0x54,0x3b,0x0d,0xf5,0xb6,0x3f, /* ...C.u `k.T;...? */ \
	0xce,0xfa,0xea,0x14,0x50,0x27,0x03,0x34,0xee,0x1e,0x8d,0xa7,0x3f,0x1e,0xc3,0xdf, /* ....P'.4....?... */ \
	0x0e,0x7e,0xc1,0xb3,0xd5,0x0c,0xd1,0x9c,0xa5,0xe2,0xb3,0x10,0x79,0x42,0xad,0x38, /* .~..........yB.8 */ \
	0xea,0xcc,0xd8,0xa7,0x35,0xea,0xaf,0xb9,0x1a,0xb5,0xd7,0xfc,0x33,0x1a,0x95,0xb6, /* ....5.......3... */ \
	0xfe,0x92,0x1a,0xf5,0xe2,0x30,0x8d,0x7a,0x51,0xac,0x51,0x27,0x19,0xfc,0x58,0xa6, /* .....0.zQ.Q'..X. */ \
	0xb9,0xe2,0xb3,0xa6,0x83,0x9c,0x4c,0x0c,0x96,0xab,0x2a,0xf1,0xeb,0x6a,0x29,0x28, /* ......L......j)( */ \
	0xe5,0x9b,0xe6,0x07,0xc0,0x44,0x51,0x1d,0x2b,0x56,0xe5,0x40,0xb4,0xc0,0x9e,0x28, /* .....DQ.+V.@...( */ \
	0x4f,0x65,0x63,0xfb,0x8b,0xc4,0xf8,0xc7,0x08,0x33,0x03,0x9a,0x56,0x93,0x17,0x49, /* Oec......3..V..I */ \
	0x35,0xe1,0xf3,0xa7,0x44,0x23,0x4c,0x55,0x75,0x2c,0xb9,0x2d,0x3a,0x8f,0xb6,0x38, /* 5...D#LUu,.-:..8 */ \
	0x79,0xb4,0xc5,0xe9,0xa3,0x2d,0xce,0x1e,0x6d,0x71,0x5e,0xb8,0x93,0x39,0xce,0xea, /* y....-..mq^..9.. */ \
	0x4b,0x2d,0x62,0xaa,0xc2,0x99,0x34,0x60,0x6d,0xa7,0xcd,0x49,0xde,0x36,0x93,0xfd, /* K-b...4`m..I.6.. */ \
	0x48,0x44,0x6d,0xb5,0xd6,0x29,0x24,0x2e,0xce,0xda,0x3e,0x91,0xb8,0xce,0xe1,0xc4, /* HDm..)$...>..... */ \
	0x3d,0xd5,0x45,0xe9,0x8c,0x94,0x5e,0x5c,0x4e,0x57,0xc3,0xba,0x96,0x45,0xde,0xda, /* =.E...^\NW...E.. */ \
	0x47,0x37,0x76,0x54,0x0a,0x1b,0x68,0xd7,0xaf,0x84,0x8c,0x4c,0xf1,0x56,0x82,0x99, /* G7vT..h....L.V.. */ \
	0xa8,0x88,0x3c,0xad,0x1f,0x4d,0x03,0x2c,0xc4,0x86,0xf5,0x09,0x8c,0xcc,0x0d,0xf4, /* ..<..M.,........ */ \
	0xd1,0x0d,0x3c,0x57,0xd0,0xe0,0xe5,0xc0,0xd4,0x99,0x01,0xdc,0xf0,0xff,0x65,0xce, /* ..<W..........e. */ \
	0x0c,0x3c,0xee,0x81,0xe3,0xe6,0x7c,0x95,0xb6,0xfc,0x32,0x9d,0x6a,0x9e,0x5a,0xa2, /* .<....|...2.j.Z. */ \
	0xe3,0x8f,0xd5,0xf2,0x9c,0x68,0x89,0x8b,0x73,0x39,0x8e,0x90,0xd7,0xf2,0x54,0x99, /* .....h..s9....T. */ \
	0x18,0x4f,0x5d,0x50,0x53,0xff,0xc9,0xe5,0x74,0x51,0x84,0x81,0xb9,0x6b,0xb6,0x09, /* .O]PS...tQ...k.. */ \
	0x28,0x9e,0xb1,0x03,0x54,0x15,0xbc,0xba,0xa0,0xc9,0x23,0x46,0xd3,0xdc,0xf8,0x01, /* (...T.....#F.... */ \
	0xf3,0x2f,0xab,0x1e,0xe3,0xf7,0xfc,0x54,0x2b,0xfb,0x90,0x44,0x2e,0x2f,0x5b,0x72, /* ./.....T+..D./[r */ \
	0xad,0x26,0xa5,0x73,0x40,0xad,0x25,0xaf,0xce,0x92,0x8a,0x66,0xed,0x96,0x16,0xce, /* .&.s@.%....f.... */ \
	0xca,0x17,0x5b,0x50,0x64,0xf5,0x2c,0x5d,0x25,0xab,0x2c,0x32,0x49,0x2a,0x3f,0xc4, /* ..[Pd.,]%.,2I.?. */ \
	0xa2,0x71,0x6a,0x80,0x1d,0x66,0x26,0x96,0x5f,0xe5,0xc6,0x38,0x3c,0xf9,0x9c,0xe3, /* .qj..f&._..8<... */ \
	0x10,0x32,0x75,0x0c,0x81,0xb3,0x4c,0x95,0x2e,0x0b,0xab,0x54,0x2e,0xb3,0x96,0x7b, /* .2u...L....T...{ */ \
	0x60,0x61,0x01,0x9b,0x7b,0x5b,0xbf,0xbc,0x20,0x44,0x63,0x29,0x88,0xf4,0xa1,0x23, /* `a..{[.. Dc)...# */ \
	0x6d,0x14,0x93,0xb3,0x2f,0x01,0x95,0x1d,0xae,0x92,0x75,0x85,0xec,0x34,0x5a,0xe7, /* m.../.....u..4Z. */ \
	0x3f,0xd6,0xe9,0xc2,0xe2,0x4f,0xde,0xcb,0xce,0xbe,0x97,0x27,0xfb,0x5e,0x6a,0x93, /* ?....O.....'.^j. */ \
	0x6e,0xee,0x6d,0xd2,0xe1,0xb0,0xe4,0x22,0x85,0x74,0xc6,0xc2,0x11,0x8b,0x2a,0x2e, /* n.m....".t...... */ \
	0xdf,0x3a,0xa3,0x4a,0xd1,0x8f,0xc3,0x47,0x4e,0x56,0x40,0x4f,0x95,0x73,0xfc,0xec, /* .:.J...GNV@O.s.. */ \
	0x27,0xb1,0xaa,0x9c,0xcf,0x6a,0xe9,0x93,0x58,0x4f,0x2a,0x69,0x97,0x28,0x67,0x27, /* '....j..XO.i.(g' */ \
	0xe3,0xb7,0xe7,0x83,0x5f,0x13,0x09,0x17,0xa7,0x32,0xc5,0x35,0xb8,0x8a,0x5b,0x63, /* ...._....2.5..[c */ \
	0xce,0xe7,0x41,0x15,0x14,0x8d,0x6b,0xeb,0xae,0x38,0xbd,0x70,0x16,0x5d,0xb9,0xf3, /* ..A...k..8.p.].. */ \
	0x1f,0xe4,0xb4,0x60,0xd1,0x2c,0xc6,0x88,0x3b,0xe4,0x9a,0x95,0xb4,0xed,0x29,0x14, /* ...`.,..;.....). */ \
	0xcf,0x9f,0x47,0xbd,0x3c,0xbe,0x5b,0x4b,0x2d,0xe3,0x46,0xc8,0x33,0x6c,0x6e,0x3c, /* ..G.<.[K-.F.3ln< */ \
	0x50,0x3a,0x3a,0xe5,0x57,0x0a,0xa8,0x73,0x8d,0x49,0x56,0x37,0xbe,0x33,0x36,0x30, /* P::.W..s.IV7.360 */ \
	0x15,0x21,0xf2,0x0a,0x10,0xf0,0x4c,0x3c,0x96,0x37,0x3d,0x78,0x2c,0x97,0xfd,0x23, /* .!....L<.7=x,..# */ \
	0x73,0x07,0xdf,0x35,0x14,0x3b,0xa5,0x24,0x1c,0x2e,0x05,0x8b,0x23,0xf9,0x35,0xf5, /* s..5.;.$....#.5. */ \
	0x04,0x77,0x90,0x0c,0x5c,0x8b,0x3e,0x8c,0x16,0xb5,0xea,0x71,0xb5,0x0e,0x51,0xa8, /* .w..\.>....q..Q. */ \
	0x1d,0x6b,0xbd,0x58,0xdf,0x57,0x68,0x2e,0x49,0x35,0xb1,0x68,0x56,0xad,0xa7,0x57, /* .k.X.Wh.I5.hV..W */ \
	0x1a,0x73,0x8f,0x80,0x72,0xad,0x83,0x38,0xd0,0xc2,0x4d,0x92,0x97,0x7c,0xfa,0x97, /* .s..r..8..M..|.. */ \
	0x5e,0x73,0x44,0x58,0x75,0x5d,0xd1,0xb3,0xcb,0xfc,0x93,0xa4,0xd0,0xf7,0xc6,0x0d, /* ^sDXu].......... */ \
	0x39,0x9e,0x0c,0xfc,0xfe,0xfe,0xf9,0xce,0xc0,0xfd,0x04,0xa8,0x0f,0xae,0x47,0xab, /* 9.............G. */ \
	0x5b,0x9c,0x82,0x20,0x3e,0x48,0x6b,0xf3,0x4d,0x49,0x72,0x67,0x68,0xc0,0xe0,0x77, /* [.. >Hk.MIrgh..w */ \
	0x00,0x83,0x19,0xdf,0x51,0x85,0x7b,0xea,0x56,0xb6,0x97,0x8f,0x54,0xe7,0xee,0x6f, /* ....Q.{.V...T..o */ \
	0xa4,0x7d,0x5e,0xd8,0xbb,0xa4,0xc0,0x33,0x2c,0xd2,0x22,0x73,0xba,0xc0,0x7b,0x49, /* .}^....3,."s..{I */ \
	0x02,0x79,0xab,0x08,0xf4,0xb0,0x62,0x41,0xce,0x6e,0x54,0xf5,0x49,0x1d,0x89,0xe6, /* .y....bA.nT.I... */ \
	0x52,0x6f,0x9a,0x4b,0xfb,0x7b,0x10,0x0a,0xf4,0x7c,0xd9,0xaa,0xc2,0xd8,0x4a,0x32, /* Ro.K.{...|....J2 */ \
	0x9a,0x21,0x9b,0x0a,0x3d,0x00,0x6a,0xd2,0xc7,0xa1,0xd5,0x67,0xdf,0xbe,0xf9,0x3d, /* .!..=.j....g...= */ \
	0x0c,0x3c,0x46,0xc7,0x13,0xc8,0xc8,0x7f,0xa1,0x1f,0x91,0xce,0x74,0xca,0x8d,0xa8, /* .<F.........t... */ \
	0x09,0x3a,0x00,0xe3,0xae,0xdb,0x55,0x43,0xee,0xd2,0xad,0x34,0xc8,0x59,0x2b,0xaf, /* .:....UC...4.Y+. */ \
	0xcb,0x82,0xfd,0xac,0x7b,0x0f,0x3f,0xe4,0xab,0x9d,0xac,0xa9,0x80,0xd6,0xa9,0x8d, /* ....{.?......... */ \
	0x70,0x85,0x67,0x63,0xf0,0x53,0x06,0x4b,0x91,0x81,0x05,0x52,0xbf,0xeb,0xf9,0xa6, /* p.gc.S.K...R.... */ \
	0xa1,0x3e,0xd1,0x76,0x50,0xcb,0x0e,0x3c,0xc7,0xd8,0xa9,0x8d,0x16,0xd1,0x7d,0x5f, /* .>.vP..<......}_ */ \
	0xc9,0x7d,0x2f,0xfc,0xe2,0xcf,0xc4,0xce,0xcf,0xbd,0xa8,0x4d,0xb1,0x51,0x96,0x2f, /* .}/........M.Q./ */ \
	0xca,0x16,0x37,0xd4,0xa6,0x09,0x8f,0x30,0xdc,0x28,0xf0,0x03,0x10,0x0d,0xee,0x0d, /* ..7....0.(...... */ \
	0x73,0xb7,0xb7,0x4d,0x20,0xb3,0x95,0xbd,0x8d,0x30,0xdd,0x16,0x62,0x3b,0x54,0xf5, /* s..M ....0..b;T. */ \
	0xa4,0xfe,0x6a,0xfe,0x3f,0x47,0x1e,0xb8,0xff,0x86,0x5f,0xb0,0xa3,0x9c,0x04,0xbf, /* ..j.?G...._..... */ \
	0x67,0x04,0xd7,0xd3,0x79,0xf0,0x07,0x81,0xfa,0x05,0x02,0xfd,0xd3,0x61,0x7c,0xa2, /* g...y........a|. */ \
	0xc3,0xc8,0x7b,0xfc,0xff,0xe2,0x2e,0x32,0x1a,0xa3,0x0f,0xe5,0xe5,0x13,0x23,0x1b, /* ..{....2......#. */ \
	0x8c,0xb0,0xb8,0x36,0xcc,0xc2,0x6d,0x1b,0x78,0x06,0xba,0xc1,0x2f,0x9c,0xe2,0x6a, /* ...6..m.x.../..j */ \
	0x24,0xae,0x0d,0x0a,0x88,0x07,0x63,0x4d,0x45,0x70,0xc2,0x23,0x26,0x3c,0x13,0x4c, /* $.....cMEp.#&<.L */ \
	0xde,0x39,0x98,0xfa,0xa4,0x28,0x6b,0x15,0x2a,0x99,0xbc,0x78,0x84,0x97,0x0a,0xf0, /* .9...(k....x.... */ \
	0x76,0x32,0x4c,0xdb,0x2c,0x48,0xd4,0x86,0x8c,0x74,0xc7,0x01,0xef,0x04,0x42,0x64, /* v2L.,H...t....Bd */ \
	0xf6,0x7a,0x91,0x82,0xb1,0x38,0x64,0x5f,0xbb,0x90,0x7e,0x0e,0xde,0xf2,0xe9,0x56, /* .z...8d_..~....V */ \
	0xe5,0x5a,0xfa,0x3a,0x4e,0xff,0x44,0x48,0x6b,0xcf,0xe9,0x11,0xed,0x6b,0x9e,0xe2, /* .Z.:N.DHk....k.. */ \
	0x66,0x52,0xd1,0x14,0xa6,0x4f,0xd5,0xb2,0x4e,0xa2,0x08,0x17,0xef,0xae,0x8a,0xe8, /* fR...O..N....... */ \
	0x01,0x65,0x90,0xbb,0xbd,0xf1,0xc6,0xc2,0x07,0xcc,0xc3,0xd0,0x6d,0xab,0xbb,0x8c, /* .e..........m... */ \
	0x6a,0x0f,0x0f,0x0f,0x4d,0xed,0x1f,0x59,0xda,0xf7,0xfc,0xa0,0x08,0x4f,0x07,0xf9, /* j...M..Y.....O.. */ \
	0xce,0xd0,0xdc,0xcd,0x34,0x3d,0x71,0xda,0x65,0x01,0x39,0x4d,0x28,0xe8,0x27,0xcc, /* ....4=q.e.9M(.'. */ \
	0xe4,0x7e,0x3f,0x79,0x47,0xd6,0xb3,0x38,0x2f,0x55,0x4f,0x53,0x12,0x2a,0x9c,0x7c, /* .~?yG..8/UOS...| */ \
	0xc8,0xa0,0x03,0x53,0x0f,0x51,0xb5,0x50,0x41,0x08,0x32,0x32,0xdc,0x8f,0x54,0xbd, /* ...S.Q.PA.22..T. */ \
	0x28,0x89,0xc7,0x61,0x86,0xc5,0x6f,0x95,0xca,0xe2,0xb1,0x5d,0xc7,0xce,0x62,0x4a, /* (..a..o....]..bJ */ \
	0xec,0x74,0x97,0xf2,0x4c,0x30,0xff,0xc6,0xf8,0x80,0x77,0x82,0xe1,0xe5,0xd4,0xc2, /* .t..L0....w..... */ \
	0xce,0x04,0x46,0x71,0x9f,0x31,0xbc,0x11,0x97,0x7c,0xc9,0xa7,0x25,0x4a,0x7f,0x7b, /* ..Fq.1...|..%J.{ */ \
	0x28,0x4c,0x73,0xfa,0x14,0x69,0xc5,0x5c,0x26,0xb8,0xb8,0xed,0x5f,0xb7,0x12,0x63, /* (Ls..i.\&..._..c */ \
	0x95,0xef,0x6c,0xc0,0xb0,0x30,0x01,0xc6,0x44,0xb8,0x9d,0xbe,0xf3,0xa8,0x98,0x23, /* ..l..0..D......# */ \
	0x0e,0xa4,0xca,0x4d,0xcc,0x61,0x78,0xa9,0x48,0x05,0xaf,0x80,0x4e,0x1c,0x0a,0xca, /* ...M.ax.H...N... */ \
	0x9e,0xfc,0x39,0x0c,0x63,0xf5,0xdf,0x2c,0xcb,0xca,0x63,0xac,0x5d,0x8e,0xb1,0xf6, /* ..9.c..,..c.]... */ \
	0x53,0x18,0x6b,0x67,0x19,0x63,0xbe,0xe1,0x2e,0xe9,0xd3,0x39,0xcb,0xa2,0x2c,0xe4, /* S.kg.c.....9..,. */ \
	0xac,0x53,0x8e,0xb3,0xce,0x53,0x38,0xeb,0x64,0x39,0x03,0x7b,0x7e,0x3a,0x5b,0x59, /* .S...S8.d9.{~:[Y */ \
	0x7c,0xf9,0x6c,0x09,0xff,0x58,0x46,0x19,0xe7,0xa1,0xab,0x94,0x71,0xe3,0x95,0x66, /* |.l..XF.....q..f */ \
	0x4d,0x40,0x25,0x6e,0x82,0xab,0x7e,0x73,0x6b,0xac,0xe7,0x96,0x71,0x51,0x7d,0x1a, /* M@%n..~sk...qQ}. */ \
	0x77,0x79,0x28,0x7f,0x52,0xb8,0x9e,0x50,0x87,0x4f,0xd4,0x7c,0xf2,0x42,0x90,0x46, /* wy(.R..P.O.|.B.F */ \
	0x54,0xee,0x8e,0xd4,0x82,0xc0,0x75,0x60,0x99,0x5e,0x2f,0x1d,0x09,0x74,0x3c,0xf9, /* T.....u`.^/..t<. */ \
	0x16,0xc8,0xca,0xd4,0x51,0x08,0x1e,0x91,0x89,0x8b,0x29,0xa9,0xfb,0x8a,0xc5,0x78, /* ....Q.....)....x */ \
	0x17,0xc5,0xc4,0x83,0x22,0x3d,0x1e,0x60,0xfb,0xc4,0x6a,0x8a,0xa0,0x46,0xa6,0x2b, /* ...."=.`..j..F.+ */ \
	0x33,0xbc,0xd9,0xd7,0x0e,0x92,0x49,0x92,0x4a,0x91,0x43,0xc3,0xc7,0x9b,0xbb,0xf0, /* 3.....I.J.C..... */ \
	0x36,0x5d,0x3c,0x94,0xcb,0x16,0x61,0x77,0x2c,0x38,0x8d,0x6b,0x1f,0x20,0xe5,0x25, /* 6]<...aw,8.k. .% */ \
	0x75,0xf1,0xf6,0xe5,0xd4,0x44,0x7f,0x65,0xf8,0x16,0xbf,0xd9,0x3e,0xd4,0xeb,0x00, /* u....D.e....>... */ \
	0xf1,0x59,0xb8,0xc2,0x7c,0x16,0xbf,0x5c,0xb6,0xab,0x89,0x2e,0x64,0x39,0x90,0xe1, /* .Y..|..\....d9.. */ \
	0xbd,0x5a,0x28,0x0a,0x7e,0xfd,0xaf,0x63,0x98,0x54,0xde,0x6a,0x47,0xb7,0xb2,0xaa, /* .Z(.~..c.T.jG... */ \
	0x67,0x2c,0xf0,0xe4,0x2d,0xe7,0x06,0xb8,0xc2,0x9b,0x8a,0x83,0x95,0x8a,0xcd,0x99, /* g,..-........... */ \
	0xaa,0x60,0xd4,0x83,0x7e,0x07,0xb4,0x38,0x55,0xac,0x4e,0x28,0xe8,0x65,0x0e,0xb9, /* .`..~..8U.N(.e.. */ \
	0x6e,0x10,0x0d,0xf2,0x67,0xc9,0x94,0x95,0xc5,0x44,0xd3,0x20,0xec,0x95,0xdf,0x8d, /* n...g....D. .... */ \
	0x7a,0xc7,0xc1,0xa0,0xbb,0xa2,0x4b,0xce,0x88,0xb8,0xe5,0xec,0xff,0x00,0xed,0xc0, /* z.....K......... */ \
	0x1d,0x6c,0xc8,0x63,0x00,0x00,0x7e,0x69,0x6e,0x63,0x3a,0x68,0x65,0x61,0x64,0x65, /* .l.c..~inc:heade */ \
	0x72,0x2e,0x69,0x6e,0x63,0x7e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x69,0x64,0x3d, /* r.inc~..<div id= */ \
	0x22,0x63,0x6f,0x6e,0x74,0x65,0x6e,0x74,0x22,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x68, /* "content">....<h */ \
	0x32,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x27,0x63,0x6f,0x6c,0x6f,0x72,0x3a,0x62, /* 2 style='color:b */ \
	0x6c,0x75,0x65,0x27,0x3e,0x49,0x45,0x45,0x45,0x20,0x38,0x30,0x32,0x2e,0x31,0x31, /* lue'>IEEE 802.11 */ \
	0x20,0x26,0x23,0x38,0x32,0x31,0x31,0x3b,0x20,0x57,0x69,0x2d,0x46,0x69,0x3c,0x73, /*  &#8211; Wi-Fi<s */ \
	0x75,0x70,0x3e,0x26,0x72,0x65,0x67,0x3b,0x3c,0x2f,0x73,0x75,0x70,0x3e,0x3c,0x2f, /* up>&reg;</sup></ */ \
	0x68,0x32,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x68,0x33,0x3e,0x4f,0x76,0x65,0x72,0x76, /* h2>....<h3>Overv */ \
	0x69,0x65,0x77,0x3c,0x2f,0x68,0x33,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70,0x3e,0x4d, /* iew</h3>....<p>M */ \
	0x69,0x63,0x72,0x6f,0x63,0x68,0x69,0x70,0x20,0x68,0x61,0x73,0x20,0x61,0x64,0x64, /* icrochip has add */ \
	0x65,0x64,0x20,0x38,0x30,0x32,0x2e,0x31,0x31,0x20,0x77,0x69,0x72,0x65,0x6c,0x65, /* ed 802.11 wirele */ \
	0x73,0x73,0x20,0x63,0x6f,0x6d,0x6d,0x75,0x6e,0x69,0x63,0x61,0x74,0x69,0x6f,0x6e, /* ss communication */ \
	0x73,0x20,0x74,0x6f,0x20,0x69,0x74,0x73,0x20,0x6c,0x69,0x6e,0x65,0x75,0x70,0x20, /* s to its lineup  */ \
	0x6f,0x66,0x20,0x77,0x69,0x72,0x65,0x6c,0x65,0x73,0x73,0x0d,0x0a,0x20,0x20,0x74, /* of wireless..  t */ \
	0x65,0x63,0x68,0x6e,0x6f,0x6c,0x6f,0x67,0x69,0x65,0x73,0x20,0x66,0x6f,0x72,0x20, /* echnologies for  */ \
	0x74,0x68,0x65,0x20,0x65,0x6d,0x62,0x65,0x64,0x64,0x65,0x64,0x20,0x6d,0x61,0x72, /* the embedded mar */ \
	0x6b,0x65,0x74,0x2e,0x20,0x4d,0x69,0x63,0x72,0x6f,0x63,0x68,0x69,0x70,0x20,0x68, /* ket. Microchip h */ \
	0x61,0x73,0x20,0x61,0x20,0x57,0x69,0x2d,0x46,0x69,0x20,0x50,0x49,0x43,0x74,0x61, /* as a Wi-Fi PICta */ \
	0x69,0x6c,0x20,0x64,0x65,0x76,0x65,0x6c,0x6f,0x70,0x6d,0x65,0x6e,0x74,0x0d,0x0a, /* il development.. */ \
	0x20,0x20,0x62,0x6f,0x61,0x72,0x64,0x20,0x74,0x68,0x61,0x74,0x20,0x61,0x64,0x64, /*   board that add */ \
	0x73,0x20,0x38,0x30,0x32,0x2e,0x31,0x31,0x20,0x63,0x61,0x70,0x61,0x62,0x69,0x6c, /* s 802.11 capabil */ \
	0x69,0x74,0x69,0x65,0x73,0x20,0x74,0x6f,0x20,0x4d,0x69,0x63,0x72,0x6f,0x63,0x68, /* ities to Microch */ \
	0x69,0x70,0x26,0x23,0x38,0x32,0x31,0x37,0x3b,0x73,0x20,0x64,0x65,0x76,0x65,0x6c, /* ip&#8217;s devel */ \
	0x6f,0x70,0x6d,0x65,0x6e,0x74,0x20,0x70,0x6c,0x61,0x74,0x66,0x6f,0x72,0x6d,0x73, /* opment platforms */ \
	0x0d,0x0a,0x20,0x20,0x66,0x6f,0x72,0x20,0x74,0x68,0x65,0x20,0x50,0x49,0x43,0x33, /* ..  for the PIC3 */ \
	0x32,0x20,0x66,0x61,0x6d,0x69,0x6c,0x79,0x20,0x6f,0x66,0x20,0x6d,0x69,0x63,0x72, /* 2 family of micr */ \
	0x6f,0x63,0x6f,0x6e,0x74,0x72,0x6f,0x6c,0x6c,0x65,0x72,0x73,0x2e,0x20,0x54,0x68, /* ocontrollers. Th */ \
	0x65,0x20,0x50,0x49,0x43,0x74,0x61,0x69,0x6c,0x20,0x64,0x65,0x76,0x65,0x6c,0x6f, /* e PICtail develo */ \
	0x70,0x6d,0x65,0x6e,0x74,0x20,0x62,0x6f,0x61,0x72,0x64,0x20,0x63,0x6f,0x6e,0x74, /* pment board cont */ \
	0x61,0x69,0x6e,0x73,0x0d,0x0a,0x20,0x20,0x74,0x68,0x65,0x20,0x4d,0x52,0x46,0x32, /* ains..  the MRF2 */ \
	0x34,0x57,0x47,0x30,0x4d,0x41,0x2f,0x4d,0x42,0x20,0x46,0x43,0x43,0x20,0x61,0x6e, /* 4WG0MA/MB FCC an */ \
	0x64,0x20,0x57,0x69,0x2d,0x46,0x69,0x20,0x63,0x65,0x72,0x74,0x69,0x66,0x69,0x65, /* d Wi-Fi certifie */ \
	0x64,0x20,0x6d,0x6f,0x64,0x75,0x6c,0x65,0x2e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x20, /* d module.</p>..  */ \
	0x20,0x0d,0x0a,0x3c,0x70,0x3e,0x54,0x68,0x65,0x20,0x57,0x69,0x26,0x23,0x38,0x32, /*  ..<p>The Wi&#82 */ \
	0x30,0x38,0x3b,0x46,0x69,0x20,0x50,0x49,0x43,0x74,0x61,0x69,0x6c,0x20,0x61,0x6c, /* 08;Fi PICtail al */ \
	0x6c,0x6f,0x77,0x73,0x20,0x64,0x65,0x73,0x69,0x67,0x6e,0x65,0x72,0x73,0x20,0x74, /* lows designers t */ \
	0x6f,0x20,0x71,0x75,0x69,0x63,0x6b,0x6c,0x79,0x20,0x63,0x72,0x65,0x61,0x74,0x65, /* o quickly create */ \
	0x20,0x61,0x20,0x64,0x69,0x72,0x65,0x63,0x74,0x0d,0x0a,0x20,0x20,0x63,0x6f,0x6e, /*  a direct..  con */ \
	0x6e,0x65,0x63,0x74,0x69,0x6f,0x6e,0x20,0x74,0x6f,0x20,0x74,0x68,0x65,0x20,0x49, /* nection to the I */ \
	0x6e,0x74,0x65,0x72,0x6e,0x65,0x74,0x20,0x62,0x79,0x20,0x73,0x65,0x61,0x6d,0x6c, /* nternet by seaml */ \
	0x65,0x73,0x73,0x6c,0x79,0x20,0x63,0x6f,0x6e,0x6e,0x65,0x63,0x74,0x69,0x6e,0x67, /* essly connecting */ \
	0x20,0x74,0x6f,0x20,0x73,0x74,0x61,0x6e,0x64,0x61,0x72,0x64,0x20,0x38,0x30,0x32, /*  to standard 802 */ \
	0x2e,0x31,0x31,0x62,0x2f,0x67,0x0d,0x0a,0x20,0x20,0x61,0x63,0x63,0x65,0x73,0x73, /* .11b/g..  access */ \
	0x20,0x70,0x6f,0x69,0x6e,0x74,0x73,0x2e,0x20,0x49,0x6e,0x20,0x6d,0x61,0x6e,0x61, /*  points. In mana */ \
	0x67,0x69,0x6e,0x67,0x20,0x74,0x68,0x65,0x20,0x63,0x6f,0x6e,0x6e,0x65,0x63,0x74, /* ging the connect */ \
	0x69,0x6f,0x6e,0x2c,0x20,0x74,0x68,0x65,0x20,0x4d,0x52,0x46,0x32,0x34,0x57,0x47, /* ion, the MRF24WG */ \
	0x30,0x4d,0x41,0x2f,0x4d,0x42,0x20,0x6d,0x6f,0x64,0x75,0x6c,0x65,0x20,0x63,0x6f, /* 0MA/MB module co */ \
	0x6e,0x74,0x72,0x6f,0x6c,0x73,0x20,0x74,0x68,0x65,0x0d,0x0a,0x20,0x20,0x4d,0x41, /* ntrols the..  MA */ \
	0x43,0x20,0x61,0x6e,0x64,0x20,0x62,0x61,0x73,0x65,0x62,0x61,0x6e,0x64,0x20,0x6c, /* C and baseband l */ \
	0x61,0x79,0x65,0x72,0x73,0x20,0x61,0x6e,0x64,0x20,0x69,0x73,0x20,0x63,0x6f,0x6e, /* ayers and is con */ \
	0x6e,0x65,0x63,0x74,0x65,0x64,0x20,0x74,0x6f,0x20,0x74,0x68,0x65,0x20,0x68,0x6f, /* nected to the ho */ \
	0x73,0x74,0x20,0x4d,0x43,0x55,0x20,0x76,0x69,0x61,0x20,0x61,0x6e,0x20,0x53,0x50, /* st MCU via an SP */ \
	0x49,0x20,0x70,0x6f,0x72,0x74,0x2e,0x20,0x54,0x68,0x65,0x0d,0x0a,0x20,0x20,0x33, /* I port. The..  3 */ \
	0x32,0x2d,0x62,0x69,0x74,0x20,0x4d,0x69,0x63,0x72,0x6f,0x63,0x68,0x69,0x70,0x20, /* 2-bit Microchip  */ \
	0x4d,0x43,0x55,0x20,0x74,0x68,0x61,0x74,0x20,0x72,0x65,0x73,0x69,0x64,0x65,0x73, /* MCU that resides */ \
	0x20,0x6f,0x6e,0x20,0x74,0x68,0x65,0x20,0x6d,0x69,0x63,0x72,0x6f,0x63,0x68,0x69, /*  on the microchi */ \
	0x70,0x20,0x64,0x65,0x76,0x65,0x6c,0x6f,0x70,0x6d,0x65,0x6e,0x74,0x20,0x62,0x6f, /* p development bo */ \
	0x61,0x72,0x64,0x20,0x63,0x6f,0x6e,0x74,0x72,0x6f,0x6c,0x73,0x0d,0x0a,0x20,0x20, /* ard controls..   */ \
	0x74,0x68,0x65,0x20,0x54,0x43,0x50,0x2f,0x49,0x50,0x20,0x6e,0x65,0x74,0x77,0x6f, /* the TCP/IP netwo */ \
	0x72,0x6b,0x69,0x6e,0x67,0x20,0x73,0x74,0x61,0x63,0x6b,0x20,0x61,0x6e,0x64,0x20, /* rking stack and  */ \
	0x72,0x75,0x6e,0x73,0x20,0x74,0x68,0x65,0x20,0x73,0x79,0x73,0x74,0x65,0x6d,0x20, /* runs the system  */ \
	0x61,0x70,0x70,0x6c,0x69,0x63,0x61,0x74,0x69,0x6f,0x6e,0x2e,0x3c,0x2f,0x70,0x3e, /* application.</p> */ \
	0x0d,0x0a,0x0d,0x0a,0x3c,0x68,0x33,0x3e,0x48,0x61,0x72,0x64,0x77,0x61,0x72,0x65, /* ....<h3>Hardware */ \
	0x20,0x53,0x6f,0x6c,0x75,0x74,0x69,0x6f,0x6e,0x73,0x3c,0x2f,0x68,0x33,0x3e,0x0d, /*  Solutions</h3>. */ \
	0x0a,0x0d,0x0a,0x3c,0x70,0x3e,0x3c,0x62,0x3e,0x57,0x69,0x2d,0x46,0x69,0x20,0x4d, /* ...<p><b>Wi-Fi M */ \
	0x6f,0x64,0x75,0x6c,0x65,0x73,0x3c,0x2f,0x62,0x3e,0x3c,0x62,0x72,0x3e,0x46,0x43, /* odules</b><br>FC */ \
	0x43,0x20,0x61,0x6e,0x64,0x20,0x45,0x54,0x53,0x49,0x20,0x63,0x65,0x72,0x74,0x69, /* C and ETSI certi */ \
	0x66,0x69,0x65,0x64,0x20,0x57,0x69,0x2d,0x46,0x69,0x20,0x6d,0x6f,0x64,0x75,0x6c, /* fied Wi-Fi modul */ \
	0x65,0x73,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x74,0x61,0x62,0x6c,0x65, /* es</p>....<table */ \
	0x3e,0x0d,0x0a,0x3c,0x74,0x72,0x3e,0x0d,0x0a,0x3c,0x74,0x64,0x3e,0x0d,0x0a,0x0d, /* >..<tr>..<td>... */ \
	0x0a,0x3c,0x70,0x3e,0x0d,0x0a,0x3c,0x73,0x70,0x61,0x6e,0x20,0x73,0x74,0x79,0x6c, /* .<p>..<span styl */ \
	0x65,0x3d,0x27,0x63,0x6f,0x6c,0x6f,0x72,0x3a,0x23,0x43,0x43,0x30,0x30,0x30,0x30, /* e='color:#CC0000 */ \
	0x27,0x3e,0x3c,0x62,0x3e,0x4d,0x52,0x46,0x32,0x34,0x57,0x47,0x30,0x4d,0x41,0x3c, /* '><b>MRF24WG0MA< */ \
	0x2f,0x62,0x3e,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x0d,0x0a,0x3c,0x73,0x70,0x61, /* /b></span>..<spa */ \
	0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x27,0x66,0x6f,0x6e,0x74,0x2d,0x73,0x69, /* n style='font-si */ \
	0x7a,0x65,0x3a,0x31,0x30,0x2e,0x30,0x70,0x74,0x3b,0x66,0x6f,0x6e,0x74,0x2d,0x66, /* ze:10.0pt;font-f */ \
	0x61,0x6d,0x69,0x6c,0x79,0x3a,0x22,0x54,0x61,0x68,0x6f,0x6d,0x61,0x22,0x2c,0x22, /* amily:"Tahoma"," */ \
	0x73,0x61,0x6e,0x73,0x2d,0x73,0x65,0x72,0x69,0x66,0x22,0x3b,0x63,0x6f,0x6c,0x6f, /* sans-serif";colo */ \
	0x72,0x3a,0x62,0x6c,0x75,0x65,0x27,0x3e,0x62,0x75,0x69,0x6c,0x74,0x2d,0x69,0x6e, /* r:blue'>built-in */ \
	0x20,0x50,0x43,0x42,0x20,0x61,0x6e,0x74,0x65,0x6e,0x6e,0x61,0x3c,0x2f,0x73,0x70, /*  PCB antenna</sp */ \
	0x61,0x6e,0x3e,0x0d,0x0a,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70,0x3e, /* an>..</p>....<p> */ \
	0x0d,0x0a,0x3c,0x73,0x70,0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x27,0x63, /* ..<span style='c */ \
	0x6f,0x6c,0x6f,0x72,0x3a,0x23,0x43,0x43,0x30,0x30,0x30,0x30,0x27,0x3e,0x3c,0x62, /* olor:#CC0000'><b */ \
	0x3e,0x4d,0x52,0x46,0x32,0x34,0x57,0x47,0x30,0x4d,0x42,0x3c,0x2f,0x62,0x3e,0x3c, /* >MRF24WG0MB</b>< */ \
	0x2f,0x73,0x70,0x61,0x6e,0x3e,0x0d,0x0a,0x3c,0x73,0x70,0x61,0x6e,0x20,0x73,0x74, /* /span>..<span st */ \
	0x79,0x6c,0x65,0x3d,0x27,0x66,0x6f,0x6e,0x74,0x2d,0x73,0x69,0x7a,0x65,0x3a,0x31, /* yle='font-size:1 */ \
	0x30,0x2e,0x30,0x70,0x74,0x3b,0x66,0x6f,0x6e,0x74,0x2d,0x66,0x61,0x6d,0x69,0x6c, /* 0.0pt;font-famil */ \
	0x79,0x3a,0x22,0x54,0x61,0x68,0x6f,0x6d,0x61,0x22,0x2c,0x22,0x73,0x61,0x6e,0x73, /* y:"Tahoma","sans */ \
	0x2d,0x73,0x65,0x72,0x69,0x66,0x22,0x3b,0x63,0x6f,0x6c,0x6f,0x72,0x3a,0x62,0x6c, /* -serif";color:bl */ \
	0x75,0x65,0x27,0x3e,0x73,0x75,0x70,0x70,0x6f,0x72,0x74,0x73,0x20,0x65,0x78,0x74, /* ue'>supports ext */ \
	0x65,0x72,0x6e,0x61,0x6c,0x20,0x61,0x6e,0x74,0x65,0x6e,0x6e,0x61,0x73,0x3c,0x2f, /* ernal antennas</ */ \
	0x73,0x70,0x61,0x6e,0x3e,0x0d,0x0a,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c, /* span>..</p>....< */ \
	0x2f,0x74,0x64,0x3e,0x0d,0x0a,0x3c,0x2f,0x74,0x72,0x3e,0x0d,0x0a,0x3c,0x2f,0x74, /* /td>..</tr>..</t */ \
	0x61,0x62,0x6c,0x65,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70,0x3e,0x3c,0x62,0x3e,0x3c, /* able>....<p><b>< */ \
	0x75,0x3e,0x3c,0x73,0x70,0x61,0x6e,0x3e,0x46,0x65,0x61,0x74,0x75,0x72,0x65,0x73, /* u><span>Features */ \
	0x3a,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x3c,0x2f,0x75,0x3e,0x3c,0x2f,0x62,0x3e, /* :</span></u></b> */ \
	0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x74,0x61,0x62,0x6c,0x65,0x3e,0x0d, /* </p>....<table>. */ \
	0x0a,0x3c,0x74,0x72,0x3e,0x0d,0x0a,0x3c,0x74,0x64,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c, /* .<tr>..<td>....< */ \
	0x64,0x69,0x76,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x27,0x6d,0x61,0x72,0x67,0x69, /* div style='margi */ \
	0x6e,0x2d,0x6c,0x65,0x66,0x74,0x3a,0x2e,0x32,0x35,0x69,0x6e,0x27,0x3e,0x0d,0x0a, /* n-left:.25in'>.. */ \
	0x3c,0x75,0x6c,0x3e,0x0d,0x0a,0x20,0x20,0x20,0x3c,0x6c,0x69,0x3e,0x3c,0x73,0x70, /* <ul>..   <li><sp */ \
	0x61,0x6e,0x3e,0x49,0x45,0x45,0x45,0x20,0x38,0x30,0x32,0x2e,0x31,0x31,0x62,0x2f, /* an>IEEE 802.11b/ */ \
	0x67,0x20,0x63,0x6f,0x6d,0x70,0x6c,0x69,0x61,0x6e,0x74,0x20,0x77,0x69,0x72,0x65, /* g compliant wire */ \
	0x6c,0x65,0x73,0x73,0x20,0x73,0x6f,0x6c,0x75,0x74,0x69,0x6f,0x6e,0x20,0x63,0x6f, /* less solution co */ \
	0x6d,0x70,0x61,0x74,0x69,0x62,0x6c,0x65,0x20,0x77,0x69,0x74,0x68,0x20,0x62,0x2f, /* mpatible with b/ */ \
	0x67,0x2f,0x6e,0x20,0x72,0x6f,0x75,0x74,0x65,0x72,0x73,0x2e,0x3c,0x2f,0x73,0x70, /* g/n routers.</sp */ \
	0x61,0x6e,0x3e,0x3c,0x2f,0x6c,0x69,0x3e,0x0d,0x0a,0x20,0x20,0x20,0x3c,0x6c,0x69, /* an></li>..   <li */ \
	0x3e,0x3c,0x73,0x70,0x61,0x6e,0x3e,0x43,0x6f,0x6d,0x70,0x61,0x74,0x69,0x62,0x6c, /* ><span>Compatibl */ \
	0x65,0x20,0x77,0x69,0x74,0x68,0x20,0x50,0x49,0x43,0x33,0x32,0x20,0x6d,0x69,0x63, /* e with PIC32 mic */ \
	0x72,0x6f,0x63,0x6f,0x6e,0x74,0x72,0x6f,0x6c,0x6c,0x65,0x72,0x73,0x2e,0x3c,0x2f, /* rocontrollers.</ */ \
	0x73,0x70,0x61,0x6e,0x3e,0x3c,0x2f,0x6c,0x69,0x3e,0x0d,0x0a,0x20,0x20,0x20,0x3c, /* span></li>..   < */ \
	0x6c,0x69,0x3e,0x3c,0x73,0x70,0x61,0x6e,0x3e,0x53,0x75,0x70,0x70,0x6f,0x72,0x74, /* li><span>Support */ \
	0x73,0x20,0x49,0x6e,0x66,0x72,0x61,0x73,0x74,0x72,0x75,0x63,0x74,0x75,0x72,0x65, /* s Infrastructure */ \
	0x20,0x28,0x63,0x6c,0x69,0x65,0x6e,0x74,0x29,0x2c,0x20,0x41,0x64,0x2d,0x48,0x6f, /*  (client), Ad-Ho */ \
	0x63,0x2c,0x20,0x61,0x6e,0x64,0x20,0x53,0x6f,0x66,0x74,0x20,0x41,0x50,0x20,0x6e, /* c, and Soft AP n */ \
	0x65,0x74,0x77,0x6f,0x72,0x6b,0x73,0x2e,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x3c, /* etworks.</span>< */ \
	0x2f,0x6c,0x69,0x3e,0x0d,0x0a,0x20,0x20,0x20,0x3c,0x6c,0x69,0x3e,0x3c,0x73,0x70, /* /li>..   <li><sp */ \
	0x61,0x6e,0x3e,0x4d,0x52,0x46,0x32,0x34,0x57,0x47,0x30,0x4d,0x41,0x2f,0x4d,0x42, /* an>MRF24WG0MA/MB */ \
	0x20,0x73,0x6d,0x61,0x6c,0x6c,0x20,0x66,0x6f,0x6f,0x74,0x70,0x72,0x69,0x6e,0x74, /*  small footprint */ \
	0x20,0x6d,0x6f,0x64,0x75,0x6c,0x65,0x20,0x69,0x6e,0x74,0x65,0x67,0x72,0x61,0x74, /*  module integrat */ \
	0x65,0x64,0x20,0x61,0x6e,0x74,0x65,0x6e,0x6e,0x61,0x2c,0x20,0x4d,0x41,0x43,0x2c, /* ed antenna, MAC, */ \
	0x20,0x42,0x61,0x73,0x65,0x62,0x61,0x6e,0x64,0x2c,0x20,0x52,0x46,0x20,0x61,0x6e, /*  Baseband, RF an */ \
	0x64,0x20,0x70,0x6f,0x77,0x65,0x72,0x20,0x61,0x6d,0x70,0x6c,0x69,0x66,0x69,0x65, /* d power amplifie */ \
	0x72,0x2e,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x3c,0x2f,0x6c,0x69,0x3e,0x0d,0x0a, /* r.</span></li>.. */ \
	0x20,0x20,0x20,0x3c,0x6c,0x69,0x3e,0x3c,0x73,0x70,0x61,0x6e,0x3e,0x4d,0x52,0x46, /*    <li><span>MRF */ \
	0x32,0x34,0x57,0x47,0x30,0x4d,0x41,0x2f,0x4d,0x42,0x20,0x6d,0x6f,0x64,0x75,0x6c, /* 24WG0MA/MB modul */ \
	0x65,0x20,0x69,0x73,0x20,0x46,0x43,0x43,0x2c,0x20,0x49,0x43,0x2c,0x20,0x57,0x69, /* e is FCC, IC, Wi */ \
	0x2d,0x46,0x69,0x20,0x63,0x65,0x72,0x74,0x69,0x66,0x69,0x65,0x64,0x2c,0x20,0x61, /* -Fi certified, a */ \
	0x6e,0x64,0x20,0x52,0x4f,0x48,0x53,0x2c,0x20,0x43,0x45,0x20,0x61,0x6e,0x64,0x20, /* nd ROHS, CE and  */ \
	0x45,0x54,0x53,0x49,0x20,0x63,0x6f,0x6d,0x70,0x6c,0x69,0x61,0x6e,0x74,0x2c,0x20, /* ETSI compliant,  */ \
	0x70,0x72,0x6f,0x76,0x69,0x64,0x69,0x6e,0x67,0x20,0x63,0x6f,0x6e,0x73,0x69,0x64, /* providing consid */ \
	0x65,0x72,0x61,0x62,0x6c,0x65,0x20,0x63,0x6f,0x73,0x74,0x20,0x73,0x61,0x76,0x69, /* erable cost savi */ \
	0x6e,0x67,0x73,0x20,0x61,0x6e,0x64,0x20,0x71,0x75,0x69,0x63,0x6b,0x20,0x74,0x69, /* ngs and quick ti */ \
	0x6d,0x65,0x2d,0x74,0x6f,0x2d,0x6d,0x61,0x72,0x6b,0x65,0x74,0x2e,0x3c,0x2f,0x73, /* me-to-market.</s */ \
	0x70,0x61,0x6e,0x3e,0x3c,0x2f,0x6c,0x69,0x3e,0x0d,0x0a,0x20,0x20,0x20,0x3c,0x6c, /* pan></li>..   <l */ \
	0x69,0x3e,0x3c,0x73,0x70,0x61,0x6e,0x3e,0x4c,0x69,0x63,0x65,0x6e,0x73,0x65,0x20, /* i><span>License  */ \
	0x46,0x72,0x65,0x65,0x20,0x54,0x43,0x50,0x2f,0x49,0x50,0x20,0x73,0x74,0x61,0x63, /* Free TCP/IP stac */ \
	0x6b,0x20,0x73,0x75,0x70,0x70,0x6f,0x72,0x74,0x69,0x6e,0x67,0x20,0x73,0x74,0x61, /* k supporting sta */ \
	0x6e,0x64,0x61,0x72,0x64,0x20,0x73,0x75,0x69,0x74,0x65,0x20,0x6f,0x66,0x20,0x49, /* ndard suite of I */ \
	0x6e,0x74,0x65,0x72,0x6e,0x65,0x74,0x20,0x53,0x65,0x72,0x76,0x69,0x63,0x65,0x73, /* nternet Services */ \
	0x2e,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x3c,0x2f,0x6c,0x69,0x3e,0x0d,0x0a,0x20, /* .</span></li>..  */ \
	0x20,0x20,0x3c,0x6c,0x69,0x3e,0x3c,0x73,0x70,0x61,0x6e,0x3e,0x50,0x72,0x6f,0x76, /*   <li><span>Prov */ \
	0x69,0x64,0x65,0x73,0x20,0x46,0x75,0x6c,0x6c,0x20,0x49,0x50,0x20,0x73,0x65,0x72, /* ides Full IP ser */ \
	0x76,0x69,0x63,0x65,0x20,0x66,0x75,0x6e,0x63,0x74,0x69,0x6f,0x6e,0x73,0x20,0x73, /* vice functions s */ \
	0x75,0x63,0x68,0x20,0x61,0x73,0x20,0x77,0x65,0x62,0x20,0x73,0x65,0x72,0x76,0x65, /* uch as web serve */ \
	0x72,0x2c,0x20,0x65,0x6d,0x61,0x69,0x6c,0x2c,0x20,0x46,0x54,0x50,0x2c,0x20,0x49, /* r, email, FTP, I */ \
	0x43,0x4d,0x50,0x2f,0x44,0x48,0x43,0x50,0x20,0x73,0x65,0x72,0x76,0x65,0x72,0x2f, /* CMP/DHCP server/ */ \
	0x63,0x6c,0x69,0x65,0x6e,0x74,0x73,0x2c,0x20,0x65,0x74,0x63,0x2e,0x20,0x3c,0x2f, /* clients, etc. </ */ \
	0x73,0x70,0x61,0x6e,0x3e,0x3c,0x2f,0x6c,0x69,0x3e,0x0d,0x0a,0x20,0x20,0x20,0x3c, /* span></li>..   < */ \
	0x6c,0x69,0x3e,0x3c,0x73,0x70,0x61,0x6e,0x3e,0x42,0x75,0x69,0x6c,0x74,0x2d,0x69, /* li><span>Built-i */ \
	0x6e,0x20,0x45,0x5a,0x43,0x6f,0x6e,0x66,0x69,0x67,0x20,0x61,0x70,0x70,0x6c,0x69, /* n EZConfig appli */ \
	0x63,0x61,0x74,0x69,0x6f,0x6e,0x20,0x74,0x6f,0x20,0x66,0x61,0x63,0x69,0x6c,0x69, /* cation to facili */ \
	0x74,0x61,0x74,0x65,0x20,0x6e,0x65,0x74,0x77,0x6f,0x72,0x6b,0x20,0x70,0x72,0x6f, /* tate network pro */ \
	0x76,0x69,0x73,0x69,0x6f,0x6e,0x69,0x6e,0x67,0x20,0x77,0x69,0x74,0x68,0x6f,0x75, /* visioning withou */ \
	0x74,0x20,0x61,0x20,0x6b,0x65,0x79,0x62,0x6f,0x61,0x72,0x64,0x20,0x6f,0x72,0x20, /* t a keyboard or  */ \
	0x64,0x69,0x73,0x70,0x6c,0x61,0x79,0x2e,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x3c, /* display.</span>< */ \
	0x2f,0x6c,0x69,0x3e,0x0d,0x0a,0x20,0x20,0x20,0x3c,0x6c,0x69,0x3e,0x3c,0x73,0x70, /* /li>..   <li><sp */ \
	0x61,0x6e,0x3e,0x42,0x75,0x69,0x6c,0x74,0x2d,0x69,0x6e,0x20,0x5a,0x65,0x72,0x6f, /* an>Built-in Zero */ \
	0x43,0x6f,0x6e,0x66,0x20,0x28,0x42,0x6f,0x6e,0x6a,0x6f,0x75,0x72,0x2c,0x20,0x41, /* Conf (Bonjour, A */ \
	0x76,0x61,0x68,0x69,0x29,0x20,0x61,0x70,0x70,0x6c,0x69,0x63,0x61,0x74,0x69,0x6f, /* vahi) applicatio */ \
	0x6e,0x20,0x74,0x6f,0x20,0x73,0x69,0x6d,0x70,0x6c,0x69,0x66,0x79,0x20,0x68,0x75, /* n to simplify hu */ \
	0x6d,0x61,0x6e,0x20,0x69,0x6e,0x74,0x65,0x72,0x61,0x63,0x74,0x69,0x6f,0x6e,0x2e, /* man interaction. */ \
	0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x3c,0x2f,0x6c,0x69,0x3e,0x0d,0x0a,0x20,0x20, /* </span></li>..   */ \
	0x20,0x3c,0x6c,0x69,0x3e,0x3c,0x73,0x70,0x61,0x6e,0x3e,0x53,0x75,0x70,0x70,0x6f, /*  <li><span>Suppo */ \
	0x72,0x74,0x73,0x20,0x57,0x45,0x50,0x2c,0x20,0x57,0x50,0x41,0x20,0x61,0x6e,0x64, /* rts WEP, WPA and */ \
	0x20,0x57,0x50,0x41,0x32,0x20,0x73,0x65,0x63,0x75,0x72,0x69,0x74,0x79,0x20,0x70, /*  WPA2 security p */ \
	0x72,0x6f,0x74,0x6f,0x63,0x6f,0x6c,0x73,0x20,0x6f,0x6e,0x20,0x6d,0x6f,0x64,0x75, /* rotocols on modu */ \
	0x6c,0x65,0x2e,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x3c,0x2f,0x6c,0x69,0x3e,0x0d, /* le.</span></li>. */ \
	0x0a,0x20,0x20,0x20,0x3c,0x6c,0x69,0x3e,0x3c,0x73,0x70,0x61,0x6e,0x3e,0x53,0x75, /* .   <li><span>Su */ \
	0x70,0x70,0x6f,0x72,0x74,0x73,0x20,0x57,0x50,0x53,0x2d,0x50,0x42,0x43,0x20,0x61, /* pports WPS-PBC a */ \
	0x6e,0x64,0x20,0x57,0x50,0x53,0x2d,0x50,0x49,0x4e,0x20,0x63,0x6f,0x6e,0x6e,0x65, /* nd WPS-PIN conne */ \
	0x63,0x74,0x69,0x6f,0x6e,0x20,0x6d,0x65,0x74,0x68,0x6f,0x64,0x73,0x2e,0x3c,0x2f, /* ction methods.</ */ \
	0x73,0x70,0x61,0x6e,0x3e,0x3c,0x2f,0x6c,0x69,0x3e,0x0d,0x0a,0x20,0x20,0x20,0x3c, /* span></li>..   < */ \
	0x6c,0x69,0x3e,0x3c,0x73,0x70,0x61,0x6e,0x3e,0x53,0x6f,0x6c,0x75,0x74,0x69,0x6f, /* li><span>Solutio */ \
	0x6e,0x73,0x20,0x61,0x73,0x20,0x73,0x69,0x6d,0x70,0x6c,0x65,0x20,0x61,0x73,0x20, /* ns as simple as  */ \
	0x61,0x20,0x73,0x69,0x6e,0x67,0x6c,0x65,0x20,0x50,0x49,0x43,0x20,0x70,0x6c,0x75, /* a single PIC plu */ \
	0x73,0x20,0x57,0x69,0x46,0x69,0x20,0x6d,0x6f,0x64,0x75,0x6c,0x65,0x20,0x77,0x69, /* s WiFi module wi */ \
	0x74,0x68,0x20,0x70,0x6f,0x77,0x65,0x72,0x20,0x61,0x6e,0x64,0x20,0x70,0x61,0x73, /* th power and pas */ \
	0x73,0x69,0x76,0x65,0x73,0x2e,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x3c,0x2f,0x6c, /* sives.</span></l */ \
	0x69,0x3e,0x0d,0x0a,0x3c,0x2f,0x75,0x6c,0x3e,0x0d,0x0a,0x3c,0x2f,0x64,0x69,0x76, /* i>..</ul>..</div */ \
	0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x2f,0x74,0x64,0x3e,0x0d,0x0a,0x3c,0x2f,0x74,0x72, /* >....</td>..</tr */ \
	0x3e,0x0d,0x0a,0x3c,0x2f,0x74,0x61,0x62,0x6c,0x65,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c, /* >..</table>....< */ \
	0x68,0x33,0x3e,0x53,0x6f,0x66,0x74,0x77,0x61,0x72,0x65,0x20,0x53,0x6f,0x6c,0x75, /* h3>Software Solu */ \
	0x74,0x69,0x6f,0x6e,0x73,0x3c,0x2f,0x68,0x33,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70, /* tions</h3>....<p */ \
	0x3e,0x0d,0x0a,0x54,0x43,0x50,0x2f,0x49,0x50,0x20,0x73,0x74,0x61,0x63,0x6b,0x20, /* >..TCP/IP stack  */ \
	0x77,0x68,0x69,0x63,0x68,0x20,0x73,0x75,0x70,0x70,0x6f,0x72,0x74,0x73,0x20,0x57, /* which supports W */ \
	0x69,0x2d,0x46,0x69,0x20,0x63,0x61,0x6e,0x20,0x62,0x65,0x20,0x66,0x6f,0x75,0x6e, /* i-Fi can be foun */ \
	0x64,0x20,0x69,0x6e,0x0d,0x0a,0x3c,0x62,0x3e,0x3c,0x73,0x70,0x61,0x6e,0x20,0x73, /* d in..<b><span s */ \
	0x74,0x79,0x6c,0x65,0x3d,0x27,0x63,0x6f,0x6c,0x6f,0x72,0x3a,0x23,0x43,0x43,0x30, /* tyle='color:#CC0 */ \
	0x30,0x30,0x30,0x27,0x3e,0x4d,0x50,0x4c,0x41,0x42,0x20,0x48,0x61,0x72,0x6d,0x6f, /* 000'>MPLAB Harmo */ \
	0x6e,0x79,0x20,0x49,0x6e,0x74,0x65,0x67,0x72,0x61,0x74,0x65,0x64,0x20,0x53,0x6f, /* ny Integrated So */ \
	0x66,0x74,0x77,0x61,0x72,0x65,0x20,0x46,0x72,0x61,0x6d,0x65,0x77,0x6f,0x72,0x6b, /* ftware Framework */ \
	0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x3c,0x2f,0x62,0x3e,0x0d,0x0a,0x2e,0x20,0x54, /* </span></b>... T */ \
	0x68,0x65,0x20,0x73,0x74,0x61,0x63,0x6b,0x20,0x69,0x6e,0x63,0x6c,0x75,0x64,0x65, /* he stack include */ \
	0x73,0x20,0x65,0x78,0x61,0x6d,0x70,0x6c,0x65,0x20,0x61,0x70,0x70,0x6c,0x69,0x63, /* s example applic */ \
	0x61,0x74,0x69,0x6f,0x6e,0x73,0x20,0x73,0x75,0x63,0x68,0x20,0x61,0x73,0x20,0x57, /* ations such as W */ \
	0x69,0x2d,0x46,0x69,0x20,0x64,0x65,0x6d,0x6f,0x73,0x20,0x77,0x69,0x74,0x68,0x20, /* i-Fi demos with  */ \
	0x45,0x5a,0x43,0x6f,0x6e,0x66,0x69,0x67,0x20,0x61,0x6e,0x64,0x20,0x5a,0x65,0x72, /* EZConfig and Zer */ \
	0x6f,0x43,0x6f,0x6e,0x66,0x20,0x66,0x75,0x6e,0x63,0x74,0x69,0x6f,0x6e,0x73,0x2e, /* oConf functions. */ \
	0x20,0x0d,0x0a,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x68,0x33,0x3e,0x38, /*  ..</p>....<h3>8 */ \
	0x30,0x32,0x2e,0x31,0x31,0x20,0x44,0x65,0x76,0x65,0x6c,0x6f,0x70,0x6d,0x65,0x6e, /* 02.11 Developmen */ \
	0x74,0x20,0x54,0x6f,0x6f,0x6c,0x73,0x3c,0x2f,0x68,0x33,0x3e,0x0d,0x0a,0x0d,0x0a, /* t Tools</h3>.... */ \
	0x3c,0x70,0x3e,0x4d,0x52,0x46,0x32,0x34,0x57,0x47,0x30,0x4d,0x41,0x2f,0x4d,0x42, /* <p>MRF24WG0MA/MB */ \
	0x20,0x57,0x69,0x46,0x69,0x20,0x50,0x69,0x63,0x74,0x61,0x69,0x6c,0x20,0x2f,0x20, /*  WiFi Pictail /  */ \
	0x50,0x69,0x63,0x74,0x61,0x69,0x6c,0x20,0x50,0x6c,0x75,0x73,0x20,0x70,0x72,0x6f, /* Pictail Plus pro */ \
	0x76,0x69,0x64,0x65,0x73,0x20,0x38,0x30,0x32,0x2e,0x31,0x31,0x20,0x63,0x6f,0x6e, /* vides 802.11 con */ \
	0x6e,0x65,0x63,0x74,0x69,0x76,0x69,0x74,0x79,0x20,0x75,0x73,0x69,0x6e,0x67,0x20, /* nectivity using  */ \
	0x50,0x49,0x43,0x20,0x6d,0x69,0x63,0x72,0x6f,0x63,0x6f,0x6e,0x74,0x72,0x6f,0x6c, /* PIC microcontrol */ \
	0x6c,0x65,0x72,0x73,0x20,0x6f,0x6e,0x20,0x4d,0x69,0x63,0x72,0x6f,0x63,0x68,0x69, /* lers on Microchi */ \
	0x70,0x26,0x23,0x38,0x32,0x31,0x37,0x3b,0x73,0x20,0x64,0x65,0x76,0x65,0x6c,0x6f, /* p&#8217;s develo */ \
	0x70,0x6d,0x65,0x6e,0x74,0x20,0x62,0x6f,0x61,0x72,0x64,0x73,0x2e,0x3c,0x2f,0x70, /* pment boards.</p */ \
	0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x70,0x3e,0x3c,0x62,0x3e,0x3c,0x75,0x3e,0x3c,0x73, /* >....<p><b><u><s */ \
	0x70,0x61,0x6e,0x3e,0x53,0x75,0x70,0x70,0x6f,0x72,0x74,0x65,0x64,0x20,0x44,0x65, /* pan>Supported De */ \
	0x76,0x65,0x6c,0x6f,0x70,0x6d,0x65,0x6e,0x74,0x20,0x54,0x6f,0x6f,0x6c,0x73,0x3a, /* velopment Tools: */ \
	0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x3c,0x2f,0x75,0x3e,0x3c,0x2f,0x62,0x3e,0x3c, /* </span></u></b>< */ \
	0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x74,0x61,0x62,0x6c,0x65,0x20,0x62,0x6f, /* /p>....<table bo */ \
	0x72,0x64,0x65,0x72,0x3d,0x30,0x20,0x63,0x65,0x6c,0x6c,0x73,0x70,0x61,0x63,0x69, /* rder=0 cellspaci */ \
	0x6e,0x67,0x3d,0x30,0x20,0x63,0x65,0x6c,0x6c,0x70,0x61,0x64,0x64,0x69,0x6e,0x67, /* ng=0 cellpadding */ \
	0x3d,0x30,0x3e,0x0d,0x0a,0x3c,0x74,0x72,0x3e,0x0d,0x0a,0x20,0x20,0x3c,0x74,0x64, /* =0>..<tr>..  <td */ \
	0x20,0x77,0x69,0x64,0x74,0x68,0x3d,0x32,0x32,0x30,0x20,0x76,0x61,0x6c,0x69,0x67, /*  width=220 valig */ \
	0x6e,0x3d,0x74,0x6f,0x70,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x27,0x77,0x69,0x64, /* n=top style='wid */ \
	0x74,0x68,0x3a,0x31,0x36,0x35,0x2e,0x30,0x70,0x74,0x3b,0x62,0x61,0x63,0x6b,0x67, /* th:165.0pt;backg */ \
	0x72,0x6f,0x75,0x6e,0x64,0x3a,0x23,0x45,0x35,0x46,0x32,0x46,0x46,0x3b,0x70,0x61, /* round:#E5F2FF;pa */ \
	0x64,0x64,0x69,0x6e,0x67,0x3a,0x0d,0x0a,0x20,0x20,0x30,0x69,0x6e,0x20,0x30,0x69, /* dding:..  0in 0i */ \
	0x6e,0x20,0x30,0x69,0x6e,0x20,0x30,0x69,0x6e,0x27,0x3e,0x0d,0x0a,0x20,0x20,0x3c, /* n 0in 0in'>..  < */ \
	0x70,0x3e,0x3c,0x62,0x3e,0x3c,0x73,0x70,0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65, /* p><b><span style */ \
	0x3d,0x27,0x66,0x6f,0x6e,0x74,0x2d,0x73,0x69,0x7a,0x65,0x3a,0x31,0x30,0x2e,0x30, /* ='font-size:10.0 */ \
	0x70,0x74,0x3b,0x66,0x6f,0x6e,0x74,0x2d,0x66,0x61,0x6d,0x69,0x6c,0x79,0x3a,0x22, /* pt;font-family:" */ \
	0x41,0x72,0x69,0x61,0x6c,0x22,0x2c,0x22,0x73,0x61,0x6e,0x73,0x2d,0x73,0x65,0x72, /* Arial","sans-ser */ \
	0x69,0x66,0x22,0x27,0x3e,0x33,0x32,0x2d,0x62,0x69,0x74,0x0d,0x0a,0x20,0x20,0x50, /* if"'>32-bit..  P */ \
	0x6c,0x61,0x74,0x66,0x6f,0x72,0x6d,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x3c,0x2f, /* latform</span></ */ \
	0x62,0x3e,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x20,0x20,0x3c,0x2f,0x74,0x64,0x3e,0x0d, /* b></p>..  </td>. */ \
	0x0a,0x0d,0x0a,0x20,0x20,0x3c,0x74,0x64,0x20,0x77,0x69,0x64,0x74,0x68,0x3d,0x35, /* ...  <td width=5 */ \
	0x35,0x32,0x20,0x76,0x61,0x6c,0x69,0x67,0x6e,0x3d,0x74,0x6f,0x70,0x20,0x73,0x74, /* 52 valign=top st */ \
	0x79,0x6c,0x65,0x3d,0x27,0x77,0x69,0x64,0x74,0x68,0x3a,0x35,0x2e,0x37,0x35,0x69, /* yle='width:5.75i */ \
	0x6e,0x3b,0x62,0x61,0x63,0x6b,0x67,0x72,0x6f,0x75,0x6e,0x64,0x3a,0x23,0x45,0x35, /* n;background:#E5 */ \
	0x46,0x32,0x46,0x46,0x3b,0x70,0x61,0x64,0x64,0x69,0x6e,0x67,0x3a,0x30,0x69,0x6e, /* F2FF;padding:0in */ \
	0x20,0x30,0x69,0x6e,0x20,0x30,0x69,0x6e,0x20,0x30,0x69,0x6e,0x27,0x3e,0x0d,0x0a, /*  0in 0in 0in'>.. */ \
	0x20,0x20,0x3c,0x64,0x69,0x76,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x27,0x6d,0x61, /*   <div style='ma */ \
	0x72,0x67,0x69,0x6e,0x2d,0x6c,0x65,0x66,0x74,0x3a,0x2e,0x35,0x69,0x6e,0x27,0x3e, /* rgin-left:.5in'> */ \
	0x0d,0x0a,0x0d,0x0a,0x20,0x20,0x3c,0x70,0x3e,0x0d,0x0a,0x20,0x20,0x3c,0x73,0x70, /* ....  <p>..  <sp */ \
	0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x27,0x66,0x6f,0x6e,0x74,0x2d,0x73, /* an style='font-s */ \
	0x69,0x7a,0x65,0x3a,0x31,0x30,0x2e,0x30,0x70,0x74,0x3b,0x66,0x6f,0x6e,0x74,0x2d, /* ize:10.0pt;font- */ \
	0x66,0x61,0x6d,0x69,0x6c,0x79,0x3a,0x22,0x41,0x72,0x69,0x61,0x6c,0x22,0x2c,0x22, /* family:"Arial"," */ \
	0x73,0x61,0x6e,0x73,0x2d,0x73,0x65,0x72,0x69,0x66,0x22,0x3b,0x63,0x6f,0x6c,0x6f, /* sans-serif";colo */ \
	0x72,0x3a,0x62,0x6c,0x75,0x65,0x27,0x3e,0x3c,0x73,0x70,0x61,0x6e,0x20,0x73,0x74, /* r:blue'><span st */ \
	0x79,0x6c,0x65,0x3d,0x27,0x63,0x6f,0x6c,0x6f,0x72,0x3a,0x23,0x43,0x43,0x30,0x30, /* yle='color:#CC00 */ \
	0x30,0x30,0x3b,0x74,0x65,0x78,0x74,0x2d,0x64,0x65,0x63,0x6f,0x72,0x61,0x74,0x69, /* 00;text-decorati */ \
	0x6f,0x6e,0x3a,0x6e,0x6f,0x6e,0x65,0x27,0x3e,0x57,0x69,0x2d,0x46,0x69,0x20,0x47, /* on:none'>Wi-Fi G */ \
	0x20,0x44,0x65,0x6d,0x6f,0x20,0x42,0x6f,0x61,0x72,0x64,0x3c,0x2f,0x73,0x70,0x61, /*  Demo Board</spa */ \
	0x6e,0x3e,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x0d,0x0a,0x20,0x20,0x3c,0x2f,0x70, /* n></span>..  </p */ \
	0x3e,0x0d,0x0a,0x0d,0x0a,0x20,0x20,0x3c,0x70,0x3e,0x0d,0x0a,0x20,0x20,0x3c,0x73, /* >....  <p>..  <s */ \
	0x70,0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x27,0x66,0x6f,0x6e,0x74,0x2d, /* pan style='font- */ \
	0x73,0x69,0x7a,0x65,0x3a,0x31,0x30,0x2e,0x30,0x70,0x74,0x3b,0x66,0x6f,0x6e,0x74, /* size:10.0pt;font */ \
	0x2d,0x66,0x61,0x6d,0x69,0x6c,0x79,0x3a,0x22,0x41,0x72,0x69,0x61,0x6c,0x22,0x2c, /* -family:"Arial", */ \
	0x22,0x73,0x61,0x6e,0x73,0x2d,0x73,0x65,0x72,0x69,0x66,0x22,0x3b,0x63,0x6f,0x6c, /* "sans-serif";col */ \
	0x6f,0x72,0x3a,0x62,0x6c,0x75,0x65,0x27,0x3e,0x3c,0x73,0x70,0x61,0x6e,0x20,0x73, /* or:blue'><span s */ \
	0x74,0x79,0x6c,0x65,0x3d,0x27,0x63,0x6f,0x6c,0x6f,0x72,0x3a,0x23,0x43,0x43,0x30, /* tyle='color:#CC0 */ \
	0x30,0x30,0x30,0x3b,0x74,0x65,0x78,0x74,0x2d,0x64,0x65,0x63,0x6f,0x72,0x61,0x74, /* 000;text-decorat */ \
	0x69,0x6f,0x6e,0x3a,0x6e,0x6f,0x6e,0x65,0x27,0x3e,0x50,0x49,0x43,0x33,0x32,0x4d, /* ion:none'>PIC32M */ \
	0x58,0x37,0x39,0x35,0x46,0x35,0x31,0x32,0x4c,0x20,0x50,0x49,0x4d,0x3c,0x2f,0x73, /* X795F512L PIM</s */ \
	0x70,0x61,0x6e,0x3e,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x0d,0x0a,0x20,0x20,0x3c, /* pan></span>..  < */ \
	0x62,0x3e,0x3c,0x73,0x70,0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x27,0x66, /* b><span style='f */ \
	0x6f,0x6e,0x74,0x2d,0x66,0x61,0x6d,0x69,0x6c,0x79,0x3a,0x22,0x41,0x72,0x69,0x61, /* ont-family:"Aria */ \
	0x6c,0x22,0x2c,0x22,0x73,0x61,0x6e,0x73,0x2d,0x73,0x65,0x72,0x69,0x66,0x22,0x27, /* l","sans-serif"' */ \
	0x3e,0x2b,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x3c,0x2f,0x62,0x3e,0x0d,0x0a,0x20, /* >+</span></b>..  */ \
	0x20,0x3c,0x73,0x70,0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x27,0x66,0x6f, /*  <span style='fo */ \
	0x6e,0x74,0x2d,0x73,0x69,0x7a,0x65,0x3a,0x31,0x30,0x2e,0x30,0x70,0x74,0x3b,0x66, /* nt-size:10.0pt;f */ \
	0x6f,0x6e,0x74,0x2d,0x66,0x61,0x6d,0x69,0x6c,0x79,0x3a,0x22,0x41,0x72,0x69,0x61, /* ont-family:"Aria */ \
	0x6c,0x22,0x2c,0x22,0x73,0x61,0x6e,0x73,0x2d,0x73,0x65,0x72,0x69,0x66,0x22,0x3b, /* l","sans-serif"; */ \
	0x63,0x6f,0x6c,0x6f,0x72,0x3a,0x62,0x6c,0x75,0x65,0x27,0x3e,0x3c,0x73,0x70,0x61, /* color:blue'><spa */ \
	0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x27,0x63,0x6f,0x6c,0x6f,0x72,0x3a,0x23, /* n style='color:# */ \
	0x43,0x43,0x30,0x30,0x30,0x30,0x3b,0x74,0x65,0x78,0x74,0x2d,0x64,0x65,0x63,0x6f, /* CC0000;text-deco */ \
	0x72,0x61,0x74,0x69,0x6f,0x6e,0x3a,0x6e,0x6f,0x6e,0x65,0x27,0x3e,0x45,0x78,0x70, /* ration:none'>Exp */ \
	0x6c,0x6f,0x72,0x65,0x72,0x20,0x31,0x36,0x20,0x44,0x65,0x76,0x65,0x6c,0x6f,0x70, /* lorer 16 Develop */ \
	0x6d,0x65,0x6e,0x74,0x20,0x42,0x6f,0x61,0x72,0x64,0x3c,0x2f,0x73,0x70,0x61,0x6e, /* ment Board</span */ \
	0x3e,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x0d,0x0a,0x20,0x20,0x3c,0x62,0x3e,0x3c, /* ></span>..  <b>< */ \
	0x73,0x70,0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x27,0x66,0x6f,0x6e,0x74, /* span style='font */ \
	0x2d,0x66,0x61,0x6d,0x69,0x6c,0x79,0x3a,0x22,0x41,0x72,0x69,0x61,0x6c,0x22,0x2c, /* -family:"Arial", */ \
	0x22,0x73,0x61,0x6e,0x73,0x2d,0x73,0x65,0x72,0x69,0x66,0x22,0x27,0x3e,0x2b,0x3c, /* "sans-serif"'>+< */ \
	0x2f,0x73,0x70,0x61,0x6e,0x3e,0x3c,0x2f,0x62,0x3e,0x0d,0x0a,0x20,0x20,0x3c,0x73, /* /span></b>..  <s */ \
	0x70,0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x27,0x66,0x6f,0x6e,0x74,0x2d, /* pan style='font- */ \
	0x73,0x69,0x7a,0x65,0x3a,0x31,0x30,0x2e,0x30,0x70,0x74,0x3b,0x66,0x6f,0x6e,0x74, /* size:10.0pt;font */ \
	0x2d,0x66,0x61,0x6d,0x69,0x6c,0x79,0x3a,0x22,0x41,0x72,0x69,0x61,0x6c,0x22,0x2c, /* -family:"Arial", */ \
	0x22,0x73,0x61,0x6e,0x73,0x2d,0x73,0x65,0x72,0x69,0x66,0x22,0x27,0x3e,0x20,0x3c, /* "sans-serif"'> < */ \
	0x73,0x70,0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x27,0x63,0x6f,0x6c,0x6f, /* span style='colo */ \
	0x72,0x3a,0x62,0x6c,0x75,0x65,0x27,0x3e,0x3c,0x73,0x70,0x61,0x6e,0x20,0x73,0x74, /* r:blue'><span st */ \
	0x79,0x6c,0x65,0x3d,0x27,0x63,0x6f,0x6c,0x6f,0x72,0x3a,0x23,0x43,0x43,0x30,0x30, /* yle='color:#CC00 */ \
	0x30,0x30,0x3b,0x74,0x65,0x78,0x74,0x2d,0x64,0x65,0x63,0x6f,0x72,0x61,0x74,0x69, /* 00;text-decorati */ \
	0x6f,0x6e,0x3a,0x6e,0x6f,0x6e,0x65,0x27,0x3e,0x41,0x43,0x31,0x36,0x34,0x31,0x34, /* on:none'>AC16414 */ \
	0x39,0x20,0x50,0x69,0x63,0x74,0x61,0x69,0x6c,0x20,0x2f,0x20,0x50,0x69,0x63,0x74, /* 9 Pictail / Pict */ \
	0x61,0x69,0x6c,0x20,0x50,0x6c,0x75,0x73,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x3c, /* ail Plus</span>< */ \
	0x2f,0x73,0x70,0x61,0x6e,0x3e,0x20,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x0d,0x0a, /* /span> </span>.. */ \
	0x20,0x20,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x20,0x20,0x3c,0x70,0x3e,0x0d, /*   </p>....  <p>. */ \
	0x0a,0x20,0x20,0x3c,0x73,0x70,0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x27, /* .  <span style=' */ \
	0x66,0x6f,0x6e,0x74,0x2d,0x73,0x69,0x7a,0x65,0x3a,0x31,0x30,0x2e,0x30,0x70,0x74, /* font-size:10.0pt */ \
	0x3b,0x66,0x6f,0x6e,0x74,0x2d,0x66,0x61,0x6d,0x69,0x6c,0x79,0x3a,0x22,0x41,0x72, /* ;font-family:"Ar */ \
	0x69,0x61,0x6c,0x22,0x2c,0x22,0x73,0x61,0x6e,0x73,0x2d,0x73,0x65,0x72,0x69,0x66, /* ial","sans-serif */ \
	0x22,0x3b,0x63,0x6f,0x6c,0x6f,0x72,0x3a,0x62,0x6c,0x75,0x65,0x27,0x3e,0x3c,0x73, /* ";color:blue'><s */ \
	0x70,0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x27,0x63,0x6f,0x6c,0x6f,0x72, /* pan style='color */ \
	0x3a,0x23,0x43,0x43,0x30,0x30,0x30,0x30,0x3b,0x74,0x65,0x78,0x74,0x2d,0x64,0x65, /* :#CC0000;text-de */ \
	0x63,0x6f,0x72,0x61,0x74,0x69,0x6f,0x6e,0x3a,0x6e,0x6f,0x6e,0x65,0x27,0x3e,0x50, /* coration:none'>P */ \
	0x49,0x43,0x33,0x32,0x4d,0x58,0x20,0x45,0x74,0x68,0x65,0x72,0x6e,0x65,0x74,0x20, /* IC32MX Ethernet  */ \
	0x53,0x74,0x61,0x72,0x74,0x65,0x72,0x20,0x4b,0x69,0x74,0x3c,0x2f,0x73,0x70,0x61, /* Starter Kit</spa */ \
	0x6e,0x3e,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x0d,0x0a,0x20,0x20,0x3c,0x62,0x3e, /* n></span>..  <b> */ \
	0x3c,0x73,0x70,0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x27,0x66,0x6f,0x6e, /* <span style='fon */ \
	0x74,0x2d,0x66,0x61,0x6d,0x69,0x6c,0x79,0x3a,0x22,0x41,0x72,0x69,0x61,0x6c,0x22, /* t-family:"Arial" */ \
	0x2c,0x22,0x73,0x61,0x6e,0x73,0x2d,0x73,0x65,0x72,0x69,0x66,0x22,0x27,0x3e,0x2b, /* ,"sans-serif"'>+ */ \
	0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x3c,0x2f,0x62,0x3e,0x0d,0x0a,0x20,0x20,0x3c, /* </span></b>..  < */ \
	0x73,0x70,0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x27,0x66,0x6f,0x6e,0x74, /* span style='font */ \
	0x2d,0x73,0x69,0x7a,0x65,0x3a,0x31,0x30,0x2e,0x30,0x70,0x74,0x3b,0x66,0x6f,0x6e, /* -size:10.0pt;fon */ \
	0x74,0x2d,0x66,0x61,0x6d,0x69,0x6c,0x79,0x3a,0x22,0x41,0x72,0x69,0x61,0x6c,0x22, /* t-family:"Arial" */ \
	0x2c,0x22,0x73,0x61,0x6e,0x73,0x2d,0x73,0x65,0x72,0x69,0x66,0x22,0x27,0x3e,0x20, /* ,"sans-serif"'>  */ \
	0x3c,0x73,0x70,0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x27,0x63,0x6f,0x6c, /* <span style='col */ \
	0x6f,0x72,0x3a,0x62,0x6c,0x75,0x65,0x27,0x3e,0x3c,0x73,0x70,0x61,0x6e,0x20,0x73, /* or:blue'><span s */ \
	0x74,0x79,0x6c,0x65,0x3d,0x27,0x63,0x6f,0x6c,0x6f,0x72,0x3a,0x23,0x43,0x43,0x30, /* tyle='color:#CC0 */ \
	0x30,0x30,0x30,0x3b,0x74,0x65,0x78,0x74,0x2d,0x64,0x65,0x63,0x6f,0x72,0x61,0x74, /* 000;text-decorat */ \
	0x69,0x6f,0x6e,0x3a,0x6e,0x6f,0x6e,0x65,0x27,0x3e,0x49,0x2f,0x4f,0x20,0x45,0x78, /* ion:none'>I/O Ex */ \
	0x70,0x61,0x6e,0x73,0x69,0x6f,0x6e,0x20,0x42,0x6f,0x61,0x72,0x64,0x3c,0x2f,0x73, /* pansion Board</s */ \
	0x70,0x61,0x6e,0x3e,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x20,0x3c,0x2f,0x73,0x70, /* pan></span> </sp */ \
	0x61,0x6e,0x3e,0x0d,0x0a,0x20,0x20,0x3c,0x62,0x3e,0x3c,0x73,0x70,0x61,0x6e,0x20, /* an>..  <b><span  */ \
	0x73,0x74,0x79,0x6c,0x65,0x3d,0x27,0x66,0x6f,0x6e,0x74,0x2d,0x66,0x61,0x6d,0x69, /* style='font-fami */ \
	0x6c,0x79,0x3a,0x22,0x41,0x72,0x69,0x61,0x6c,0x22,0x2c,0x22,0x73,0x61,0x6e,0x73, /* ly:"Arial","sans */ \
	0x2d,0x73,0x65,0x72,0x69,0x66,0x22,0x27,0x3e,0x2b,0x3c,0x2f,0x73,0x70,0x61,0x6e, /* -serif"'>+</span */ \
	0x3e,0x3c,0x2f,0x62,0x3e,0x0d,0x0a,0x20,0x20,0x3c,0x73,0x70,0x61,0x6e,0x20,0x73, /* ></b>..  <span s */ \
	0x74,0x79,0x6c,0x65,0x3d,0x27,0x66,0x6f,0x6e,0x74,0x2d,0x73,0x69,0x7a,0x65,0x3a, /* tyle='font-size: */ \
	0x31,0x30,0x2e,0x30,0x70,0x74,0x3b,0x66,0x6f,0x6e,0x74,0x2d,0x66,0x61,0x6d,0x69, /* 10.0pt;font-fami */ \
	0x6c,0x79,0x3a,0x22,0x41,0x72,0x69,0x61,0x6c,0x22,0x2c,0x22,0x73,0x61,0x6e,0x73, /* ly:"Arial","sans */ \
	0x2d,0x73,0x65,0x72,0x69,0x66,0x22,0x27,0x3e,0x20,0x3c,0x73,0x70,0x61,0x6e,0x20, /* -serif"'> <span  */ \
	0x73,0x74,0x79,0x6c,0x65,0x3d,0x27,0x63,0x6f,0x6c,0x6f,0x72,0x3a,0x62,0x6c,0x75, /* style='color:blu */ \
	0x65,0x27,0x3e,0x3c,0x73,0x70,0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x27, /* e'><span style=' */ \
	0x63,0x6f,0x6c,0x6f,0x72,0x3a,0x23,0x43,0x43,0x30,0x30,0x30,0x30,0x3b,0x74,0x65, /* color:#CC0000;te */ \
	0x78,0x74,0x2d,0x64,0x65,0x63,0x6f,0x72,0x61,0x74,0x69,0x6f,0x6e,0x3a,0x6e,0x6f, /* xt-decoration:no */ \
	0x6e,0x65,0x27,0x3e,0x41,0x43,0x31,0x36,0x34,0x31,0x34,0x39,0x20,0x50,0x69,0x63, /* ne'>AC164149 Pic */ \
	0x74,0x61,0x69,0x6c,0x20,0x2f,0x20,0x50,0x69,0x63,0x74,0x61,0x69,0x6c,0x20,0x50, /* tail / Pictail P */ \
	0x6c,0x75,0x73,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x3c,0x2f,0x73,0x70,0x61,0x6e, /* lus</span></span */ \
	0x3e,0x20,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x0d,0x0a,0x20,0x20,0x3c,0x2f,0x70, /* > </span>..  </p */ \
	0x3e,0x0d,0x0a,0x0d,0x0a,0x20,0x20,0x3c,0x70,0x3e,0x0d,0x0a,0x20,0x20,0x3c,0x73, /* >....  <p>..  <s */ \
	0x70,0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x27,0x66,0x6f,0x6e,0x74,0x2d, /* pan style='font- */ \
	0x73,0x69,0x7a,0x65,0x3a,0x31,0x30,0x2e,0x30,0x70,0x74,0x3b,0x66,0x6f,0x6e,0x74, /* size:10.0pt;font */ \
	0x2d,0x66,0x61,0x6d,0x69,0x6c,0x79,0x3a,0x22,0x41,0x72,0x69,0x61,0x6c,0x22,0x2c, /* -family:"Arial", */ \
	0x22,0x73,0x61,0x6e,0x73,0x2d,0x73,0x65,0x72,0x69,0x66,0x22,0x3b,0x63,0x6f,0x6c, /* "sans-serif";col */ \
	0x6f,0x72,0x3a,0x62,0x6c,0x75,0x65,0x27,0x3e,0x3c,0x73,0x70,0x61,0x6e,0x20,0x73, /* or:blue'><span s */ \
	0x74,0x79,0x6c,0x65,0x3d,0x27,0x63,0x6f,0x6c,0x6f,0x72,0x3a,0x23,0x43,0x43,0x30, /* tyle='color:#CC0 */ \
	0x30,0x30,0x30,0x3b,0x74,0x65,0x78,0x74,0x2d,0x64,0x65,0x63,0x6f,0x72,0x61,0x74, /* 000;text-decorat */ \
	0x69,0x6f,0x6e,0x3a,0x6e,0x6f,0x6e,0x65,0x27,0x3e,0x50,0x49,0x43,0x33,0x32,0x4d, /* ion:none'>PIC32M */ \
	0x5a,0x20,0x45,0x43,0x20,0x53,0x74,0x61,0x72,0x74,0x65,0x72,0x20,0x4b,0x69,0x74, /* Z EC Starter Kit */ \
	0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x0d,0x0a, /* </span></span>.. */ \
	0x20,0x20,0x3c,0x62,0x3e,0x3c,0x73,0x70,0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65, /*   <b><span style */ \
	0x3d,0x27,0x66,0x6f,0x6e,0x74,0x2d,0x66,0x61,0x6d,0x69,0x6c,0x79,0x3a,0x22,0x41, /* ='font-family:"A */ \
	0x72,0x69,0x61,0x6c,0x22,0x2c,0x22,0x73,0x61,0x6e,0x73,0x2d,0x73,0x65,0x72,0x69, /* rial","sans-seri */ \
	0x66,0x22,0x27,0x3e,0x2b,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x3c,0x2f,0x62,0x3e, /* f"'>+</span></b> */ \
	0x0d,0x0a,0x20,0x20,0x3c,0x73,0x70,0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d, /* ..  <span style= */ \
	0x27,0x66,0x6f,0x6e,0x74,0x2d,0x73,0x69,0x7a,0x65,0x3a,0x31,0x30,0x2e,0x30,0x70, /* 'font-size:10.0p */ \
	0x74,0x3b,0x66,0x6f,0x6e,0x74,0x2d,0x66,0x61,0x6d,0x69,0x6c,0x79,0x3a,0x22,0x41, /* t;font-family:"A */ \
	0x72,0x69,0x61,0x6c,0x22,0x2c,0x22,0x73,0x61,0x6e,0x73,0x2d,0x73,0x65,0x72,0x69, /* rial","sans-seri */ \
	0x66,0x22,0x27,0x3e,0x20,0x3c,0x73,0x70,0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65, /* f"'> <span style */ \
	0x3d,0x27,0x63,0x6f,0x6c,0x6f,0x72,0x3a,0x62,0x6c,0x75,0x65,0x27,0x3e,0x3c,0x73, /* ='color:blue'><s */ \
	0x70,0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x27,0x63,0x6f,0x6c,0x6f,0x72, /* pan style='color */ \
	0x3a,0x23,0x43,0x43,0x30,0x30,0x30,0x30,0x3b,0x74,0x65,0x78,0x74,0x2d,0x64,0x65, /* :#CC0000;text-de */ \
	0x63,0x6f,0x72,0x61,0x74,0x69,0x6f,0x6e,0x3a,0x6e,0x6f,0x6e,0x65,0x27,0x3e,0x50, /* coration:none'>P */ \
	0x49,0x43,0x33,0x32,0x4d,0x5a,0x20,0x45,0x43,0x20,0x41,0x64,0x61,0x70,0x74,0x6f, /* IC32MZ EC Adapto */ \
	0x72,0x20,0x42,0x6f,0x61,0x72,0x64,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x3c,0x2f, /* r Board</span></ */ \
	0x73,0x70,0x61,0x6e,0x3e,0x20,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x0d,0x0a,0x20, /* span> </span>..  */ \
	0x20,0x3c,0x62,0x3e,0x3c,0x73,0x70,0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d, /*  <b><span style= */ \
	0x27,0x66,0x6f,0x6e,0x74,0x2d,0x66,0x61,0x6d,0x69,0x6c,0x79,0x3a,0x22,0x41,0x72, /* 'font-family:"Ar */ \
	0x69,0x61,0x6c,0x22,0x2c,0x22,0x73,0x61,0x6e,0x73,0x2d,0x73,0x65,0x72,0x69,0x66, /* ial","sans-serif */ \
	0x22,0x27,0x3e,0x2b,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x3c,0x2f,0x62,0x3e,0x0d, /* "'>+</span></b>. */ \
	0x0a,0x20,0x20,0x3c,0x73,0x70,0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x27, /* .  <span style=' */ \
	0x66,0x6f,0x6e,0x74,0x2d,0x73,0x69,0x7a,0x65,0x3a,0x31,0x30,0x2e,0x30,0x70,0x74, /* font-size:10.0pt */ \
	0x3b,0x66,0x6f,0x6e,0x74,0x2d,0x66,0x61,0x6d,0x69,0x6c,0x79,0x3a,0x22,0x41,0x72, /* ;font-family:"Ar */ \
	0x69,0x61,0x6c,0x22,0x2c,0x22,0x73,0x61,0x6e,0x73,0x2d,0x73,0x65,0x72,0x69,0x66, /* ial","sans-serif */ \
	0x22,0x27,0x3e,0x20,0x3c,0x73,0x70,0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d, /* "'> <span style= */ \
	0x27,0x63,0x6f,0x6c,0x6f,0x72,0x3a,0x62,0x6c,0x75,0x65,0x27,0x3e,0x3c,0x73,0x70, /* 'color:blue'><sp */ \
	0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x27,0x63,0x6f,0x6c,0x6f,0x72,0x3a, /* an style='color: */ \
	0x23,0x43,0x43,0x30,0x30,0x30,0x30,0x3b,0x74,0x65,0x78,0x74,0x2d,0x64,0x65,0x63, /* #CC0000;text-dec */ \
	0x6f,0x72,0x61,0x74,0x69,0x6f,0x6e,0x3a,0x6e,0x6f,0x6e,0x65,0x27,0x3e,0x49,0x2f, /* oration:none'>I/ */ \
	0x4f,0x20,0x45,0x78,0x70,0x61,0x6e,0x73,0x69,0x6f,0x6e,0x20,0x42,0x6f,0x61,0x72, /* O Expansion Boar */ \
	0x64,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x20, /* d</span></span>  */ \
	0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x0d,0x0a,0x20,0x20,0x3c,0x62,0x3e,0x3c,0x73, /* </span>..  <b><s */ \
	0x70,0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x27,0x66,0x6f,0x6e,0x74,0x2d, /* pan style='font- */ \
	0x66,0x61,0x6d,0x69,0x6c,0x79,0x3a,0x22,0x41,0x72,0x69,0x61,0x6c,0x22,0x2c,0x22, /* family:"Arial"," */ \
	0x73,0x61,0x6e,0x73,0x2d,0x73,0x65,0x72,0x69,0x66,0x22,0x27,0x3e,0x2b,0x3c,0x2f, /* sans-serif"'>+</ */ \
	0x73,0x70,0x61,0x6e,0x3e,0x3c,0x2f,0x62,0x3e,0x0d,0x0a,0x20,0x20,0x3c,0x73,0x70, /* span></b>..  <sp */ \
	0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x27,0x66,0x6f,0x6e,0x74,0x2d,0x73, /* an style='font-s */ \
	0x69,0x7a,0x65,0x3a,0x31,0x30,0x2e,0x30,0x70,0x74,0x3b,0x66,0x6f,0x6e,0x74,0x2d, /* ize:10.0pt;font- */ \
	0x66,0x61,0x6d,0x69,0x6c,0x79,0x3a,0x22,0x41,0x72,0x69,0x61,0x6c,0x22,0x2c,0x22, /* family:"Arial"," */ \
	0x73,0x61,0x6e,0x73,0x2d,0x73,0x65,0x72,0x69,0x66,0x22,0x27,0x3e,0x20,0x3c,0x73, /* sans-serif"'> <s */ \
	0x70,0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x27,0x63,0x6f,0x6c,0x6f,0x72, /* pan style='color */ \
	0x3a,0x62,0x6c,0x75,0x65,0x27,0x3e,0x3c,0x73,0x70,0x61,0x6e,0x20,0x73,0x74,0x79, /* :blue'><span sty */ \
	0x6c,0x65,0x3d,0x27,0x63,0x6f,0x6c,0x6f,0x72,0x3a,0x23,0x43,0x43,0x30,0x30,0x30, /* le='color:#CC000 */ \
	0x30,0x3b,0x74,0x65,0x78,0x74,0x2d,0x64,0x65,0x63,0x6f,0x72,0x61,0x74,0x69,0x6f, /* 0;text-decoratio */ \
	0x6e,0x3a,0x6e,0x6f,0x6e,0x65,0x27,0x3e,0x41,0x43,0x31,0x36,0x34,0x31,0x34,0x39, /* n:none'>AC164149 */ \
	0x20,0x50,0x69,0x63,0x74,0x61,0x69,0x6c,0x20,0x2f,0x20,0x50,0x69,0x63,0x74,0x61, /*  Pictail / Picta */ \
	0x69,0x6c,0x20,0x50,0x6c,0x75,0x73,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x3c,0x2f, /* il Plus</span></ */ \
	0x73,0x70,0x61,0x6e,0x3e,0x20,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x0d,0x0a,0x20, /* span> </span>..  */ \
	0x20,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x20,0x20,0x3c,0x70,0x3e,0x0d,0x0a, /*  </p>....  <p>.. */ \
	0x20,0x20,0x3c,0x73,0x70,0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x27,0x66, /*   <span style='f */ \
	0x6f,0x6e,0x74,0x2d,0x73,0x69,0x7a,0x65,0x3a,0x31,0x30,0x2e,0x30,0x70,0x74,0x3b, /* ont-size:10.0pt; */ \
	0x66,0x6f,0x6e,0x74,0x2d,0x66,0x61,0x6d,0x69,0x6c,0x79,0x3a,0x22,0x41,0x72,0x69, /* font-family:"Ari */ \
	0x61,0x6c,0x22,0x2c,0x22,0x73,0x61,0x6e,0x73,0x2d,0x73,0x65,0x72,0x69,0x66,0x22, /* al","sans-serif" */ \
	0x3b,0x63,0x6f,0x6c,0x6f,0x72,0x3a,0x62,0x6c,0x75,0x65,0x27,0x3e,0x3c,0x73,0x70, /* ;color:blue'><sp */ \
	0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x27,0x63,0x6f,0x6c,0x6f,0x72,0x3a, /* an style='color: */ \
	0x23,0x43,0x43,0x30,0x30,0x30,0x30,0x3b,0x74,0x65,0x78,0x74,0x2d,0x64,0x65,0x63, /* #CC0000;text-dec */ \
	0x6f,0x72,0x61,0x74,0x69,0x6f,0x6e,0x3a,0x6e,0x6f,0x6e,0x65,0x27,0x3e,0x50,0x49, /* oration:none'>PI */ \
	0x43,0x33,0x32,0x4d,0x5a,0x20,0x45,0x43,0x20,0x53,0x74,0x61,0x72,0x74,0x65,0x72, /* C32MZ EC Starter */ \
	0x20,0x4b,0x69,0x74,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x3c,0x2f,0x73,0x70,0x61, /*  Kit</span></spa */ \
	0x6e,0x3e,0x0d,0x0a,0x20,0x20,0x3c,0x62,0x3e,0x3c,0x73,0x70,0x61,0x6e,0x20,0x73, /* n>..  <b><span s */ \
	0x74,0x79,0x6c,0x65,0x3d,0x27,0x66,0x6f,0x6e,0x74,0x2d,0x66,0x61,0x6d,0x69,0x6c, /* tyle='font-famil */ \
	0x79,0x3a,0x22,0x41,0x72,0x69,0x61,0x6c,0x22,0x2c,0x22,0x73,0x61,0x6e,0x73,0x2d, /* y:"Arial","sans- */ \
	0x73,0x65,0x72,0x69,0x66,0x22,0x27,0x3e,0x2b,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e, /* serif"'>+</span> */ \
	0x3c,0x2f,0x62,0x3e,0x0d,0x0a,0x20,0x20,0x3c,0x73,0x70,0x61,0x6e,0x20,0x73,0x74, /* </b>..  <span st */ \
	0x79,0x6c,0x65,0x3d,0x27,0x66,0x6f,0x6e,0x74,0x2d,0x73,0x69,0x7a,0x65,0x3a,0x31, /* yle='font-size:1 */ \
	0x30,0x2e,0x30,0x70,0x74,0x3b,0x66,0x6f,0x6e,0x74,0x2d,0x66,0x61,0x6d,0x69,0x6c, /* 0.0pt;font-famil */ \
	0x79,0x3a,0x22,0x41,0x72,0x69,0x61,0x6c,0x22,0x2c,0x22,0x73,0x61,0x6e,0x73,0x2d, /* y:"Arial","sans- */ \
	0x73,0x65,0x72,0x69,0x66,0x22,0x27,0x3e,0x20,0x3c,0x73,0x70,0x61,0x6e,0x20,0x73, /* serif"'> <span s */ \
	0x74,0x79,0x6c,0x65,0x3d,0x27,0x63,0x6f,0x6c,0x6f,0x72,0x3a,0x62,0x6c,0x75,0x65, /* tyle='color:blue */ \
	0x27,0x3e,0x3c,0x73,0x70,0x61,0x6e,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x27,0x63, /* '><span style='c */ \
	0x6f,0x6c,0x6f,0x72,0x3a,0x23,0x43,0x43,0x30,0x30,0x30,0x30,0x3b,0x74,0x65,0x78, /* olor:#CC0000;tex */ \
	0x74,0x2d,0x64,0x65,0x63,0x6f,0x72,0x61,0x74,0x69,0x6f,0x6e,0x3a,0x6e,0x6f,0x6e, /* t-decoration:non */ \
	0x65,0x27,0x3e,0x4d,0x75,0x6c,0x74,0x69,0x6d,0x65,0x64,0x69,0x61,0x20,0x45,0x78, /* e'>Multimedia Ex */ \
	0x70,0x61,0x6e,0x73,0x69,0x6f,0x6e,0x20,0x42,0x6f,0x61,0x72,0x64,0x20,0x28,0x4d, /* pansion Board (M */ \
	0x45,0x42,0x29,0x20,0x49,0x49,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x3c,0x2f,0x73, /* EB) II</span></s */ \
	0x70,0x61,0x6e,0x3e,0x20,0x3c,0x2f,0x73,0x70,0x61,0x6e,0x3e,0x0d,0x0a,0x20,0x20, /* pan> </span>..   */ \
	0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x20,0x20,0x3c,0x2f,0x64,0x69,0x76,0x3e, /* </p>....  </div> */ \
	0x0d,0x0a,0x20,0x20,0x3c,0x2f,0x74,0x64,0x3e,0x0d,0x0a,0x3c,0x2f,0x74,0x72,0x3e, /* ..  </td>..</tr> */ \
	0x0d,0x0a,0x3c,0x2f,0x74,0x61,0x62,0x6c,0x65,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x2f, /* ..</table>....</ */ \
	0x64,0x69,0x76,0x3e,0x3c,0x21,0x2d,0x2d,0x63,0x6f,0x6e,0x74,0x65,0x6e,0x74,0x2d, /* div><!--content- */ \
	0x2d,0x3e,0x0d,0x0a,0x7e,0x69,0x6e,0x63,0x3a,0x66,0x6f,0x6f,0x74,0x65,0x72,0x2e, /* ->..~inc:footer. */ \
	0x69,0x6e,0x63,0x7e,0x0d,0x0a,0x7e,0x69,0x6e,0x63,0x3a,0x68,0x65,0x61,0x64,0x65, /* inc~..~inc:heade */ \
	0x72,0x2e,0x69,0x6e,0x63,0x7e,0x0d,0x0a,0x3c,0x64,0x69,0x76,0x20,0x69,0x64,0x3d, /* r.inc~..<div id= */ \
	0x22,0x63,0x6f,0x6e,0x74,0x65,0x6e,0x74,0x22,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x68, /* "content">....<h */ \
	0x32,0x3e,0x52,0x65,0x63,0x6f,0x6e,0x6e,0x65,0x63,0x74,0x69,0x6f,0x6e,0x20,0x69, /* 2>Reconnection i */ \
	0x6e,0x20,0x50,0x72,0x6f,0x67,0x72,0x65,0x73,0x73,0x3c,0x2f,0x68,0x32,0x3e,0x0d, /* n Progress</h2>. */ \
	0x0a,0x0d,0x0a,0x3c,0x70,0x3e,0x41,0x20,0x63,0x6f,0x6e,0x6e,0x65,0x63,0x74,0x69, /* ...<p>A connecti */ \
	0x6f,0x6e,0x20,0x74,0x6f,0x20,0x61,0x6e,0x6f,0x74,0x68,0x65,0x72,0x20,0x6e,0x65, /* on to another ne */ \
	0x74,0x77,0x6f,0x72,0x6b,0x20,0x69,0x73,0x20,0x6e,0x6f,0x77,0x20,0x75,0x6e,0x64, /* twork is now und */ \
	0x65,0x72,0x77,0x61,0x79,0x21,0x20,0x20,0x59,0x6f,0x75,0x20,0x77,0x69,0x6c,0x6c, /* erway!  You will */ \
	0x20,0x6e,0x65,0x65,0x64,0x20,0x74,0x6f,0x20,0x63,0x6f,0x6e,0x6e,0x65,0x63,0x74, /*  need to connect */ \
	0x20,0x74,0x68,0x69,0x73,0x0d,0x0a,0x6c,0x61,0x70,0x74,0x6f,0x70,0x2f,0x50,0x43, /*  this..laptop/PC */ \
	0x2f,0x70,0x6f,0x72,0x74,0x61,0x62,0x6c,0x65,0x20,0x64,0x65,0x76,0x69,0x63,0x65, /* /portable device */ \
	0x20,0x74,0x6f,0x20,0x74,0x68,0x65,0x20,0x6e,0x65,0x77,0x20,0x6e,0x65,0x74,0x77, /*  to the new netw */ \
	0x6f,0x72,0x6b,0x20,0x28,0x26,0x71,0x75,0x6f,0x74,0x3b,0x7e,0x6e,0x65,0x78,0x74, /* ork (&quot;~next */ \
	0x53,0x53,0x49,0x44,0x7e,0x26,0x71,0x75,0x6f,0x74,0x3b,0x29,0x20,0x74,0x6f,0x20, /* SSID~&quot;) to  */ \
	0x72,0x65,0x67,0x61,0x69,0x6e,0x20,0x61,0x63,0x63,0x65,0x73,0x73,0x20,0x74,0x6f, /* regain access to */ \
	0x20,0x74,0x68,0x69,0x73,0x20,0x64,0x65,0x6d,0x6f,0x2e,0x3c,0x2f,0x70,0x3e,0x0d, /*  this demo.</p>. */ \
	0x0a,0x0d,0x0a,0x3c,0x70,0x3e,0x41,0x73,0x20,0x61,0x20,0x72,0x65,0x6d,0x69,0x6e, /* ...<p>As a remin */ \
	0x64,0x65,0x72,0x2c,0x20,0x74,0x68,0x69,0x73,0x20,0x69,0x73,0x20,0x74,0x68,0x65, /* der, this is the */ \
	0x20,0x6e,0x65,0x74,0x77,0x6f,0x72,0x6b,0x20,0x79,0x6f,0x75,0x20,0x77,0x65,0x72, /*  network you wer */ \
	0x65,0x20,0x6f,0x6e,0x3a,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x75,0x6c, /* e on:</p>....<ul */ \
	0x3e,0x0d,0x0a,0x20,0x3c,0x6c,0x69,0x3e,0x3c,0x62,0x3e,0x53,0x53,0x49,0x44,0x3a, /* >.. <li><b>SSID: */ \
	0x20,0x3c,0x2f,0x62,0x3e,0x26,0x71,0x75,0x6f,0x74,0x3b,0x7e,0x70,0x72,0x65,0x76, /*  </b>&quot;~prev */ \
	0x53,0x53,0x49,0x44,0x7e,0x26,0x71,0x75,0x6f,0x74,0x3b,0x3c,0x2f,0x6c,0x69,0x3e, /* SSID~&quot;</li> */ \
	0x0d,0x0a,0x20,0x3c,0x6c,0x69,0x3e,0x3c,0x62,0x3e,0x57,0x4c,0x41,0x4e,0x20,0x54, /* .. <li><b>WLAN T */ \
	0x79,0x70,0x65,0x3a,0x20,0x3c,0x2f,0x62,0x3e,0x7e,0x70,0x72,0x65,0x76,0x57,0x4c, /* ype: </b>~prevWL */ \
	0x41,0x4e,0x7e,0x3c,0x2f,0x6c,0x69,0x3e,0x0d,0x0a,0x3c,0x2f,0x75,0x6c,0x3e,0x0d, /* AN~</li>..</ul>. */ \
	0x0a,0x0d,0x0a,0x3c,0x70,0x3e,0x54,0x68,0x69,0x73,0x20,0x69,0x73,0x20,0x74,0x68, /* ...<p>This is th */ \
	0x65,0x20,0x6e,0x65,0x74,0x77,0x6f,0x72,0x6b,0x20,0x74,0x68,0x61,0x74,0x20,0x79, /* e network that y */ \
	0x6f,0x75,0x20,0x77,0x69,0x6c,0x6c,0x20,0x62,0x65,0x20,0x67,0x6f,0x69,0x6e,0x67, /* ou will be going */ \
	0x20,0x74,0x6f,0x3a,0x3c,0x2f,0x70,0x3e,0x0d,0x0a,0x0d,0x0a,0x3c,0x75,0x6c,0x3e, /*  to:</p>....<ul> */ \
	0x0d,0x0a,0x20,0x3c,0x6c,0x69,0x3e,0x3c,0x62,0x3e,0x53,0x53,0x49,0x44,0x3a,0x20, /* .. <li><b>SSID:  */ \
	0x3c,0x2f,0x62,0x3e,0x26,0x71,0x75,0x6f,0x74,0x3b,0x7e,0x6e,0x65,0x78,0x74,0x53, /* </b>&quot;~nextS */ \
	0x53,0x49,0x44,0x7e,0x26,0x71,0x75,0x6f,0x74,0x3b,0x3c,0x2f,0x6c,0x69,0x3e,0x0d, /* SID~&quot;</li>. */ \
	0x0a,0x20,0x3c,0x6c,0x69,0x3e,0x3c,0x62,0x3e,0x57,0x4c,0x41,0x4e,0x20,0x54,0x79, /* . <li><b>WLAN Ty */ \
	0x70,0x65,0x3a,0x20,0x3c,0x2f,0x62,0x3e,0x7e,0x6e,0x65,0x78,0x74,0x57,0x4c,0x41, /* pe: </b>~nextWLA */ \
	0x4e,0x7e,0x3c,0x2f,0x6c,0x69,0x3e,0x0d,0x0a,0x3c,0x2f,0x75,0x6c,0x3e,0x0d,0x0a, /* N~</li>..</ul>.. */ \
	0x0d,0x0a,0x3c,0x2f,0x64,0x69,0x76,0x3e,0x20,0x3c,0x21,0x2d,0x2d,0x63,0x6f,0x6e, /* ..</div> <!--con */ \
	0x74,0x65,0x6e,0x74,0x2d,0x2d,0x3e,0x0d,0x0a,0x7e,0x69,0x6e,0x63,0x3a,0x66,0x6f, /* tent-->..~inc:fo */ \
	0x6f,0x74,0x65,0x72,0x2e,0x69,0x6e,0x63,0x7e,0x0d,0x0a,0x53,0x75,0x63,0x63,0x65, /* oter.inc~..Succe */ \
	0x73,0x73,0x21,0x20,0x7e,0x73,0x63,0x61,0x6e,0x7e,0x3c,0x3f,0x78,0x6d,0x6c,0x20, /* ss! ~scan~<?xml  */ \
	0x76,0x65,0x72,0x73,0x69,0x6f,0x6e,0x3d,0x22,0x31,0x2e,0x30,0x22,0x20,0x65,0x6e, /* version="1.0" en */ \
	0x63,0x6f,0x64,0x69,0x6e,0x67,0x3d,0x22,0x75,0x74,0x66,0x2d,0x38,0x22,0x3f,0x3e, /* coding="utf-8"?> */ \
	0x0a,0x20,0x0a,0x20,0x3c,0x72,0x65,0x73,0x70,0x6f,0x6e,0x73,0x65,0x3e,0x0a,0x20, /* . . <response>.  */ \
	0x20,0x09,0x3c,0x73,0x63,0x61,0x6e,0x3e,0x7e,0x73,0x63,0x61,0x6e,0x7e,0x3c,0x2f, /*  .<scan>~scan~</ */ \
	0x73,0x63,0x61,0x6e,0x3e,0x0a,0x09,0x3c,0x76,0x65,0x72,0x3e,0x7e,0x66,0x77,0x76, /* scan>..<ver>~fwv */ \
	0x65,0x72,0x7e,0x3c,0x2f,0x76,0x65,0x72,0x3e,0x0a,0x09,0x3c,0x63,0x6f,0x75,0x6e, /* er~</ver>..<coun */ \
	0x74,0x3e,0x7e,0x62,0x73,0x73,0x43,0x6f,0x75,0x6e,0x74,0x7e,0x3c,0x2f,0x63,0x6f, /* t>~bssCount~</co */ \
	0x75,0x6e,0x74,0x3e,0x0a,0x09,0x3c,0x73,0x73,0x69,0x64,0x3e,0x7e,0x73,0x73,0x69, /* unt>..<ssid>~ssi */ \
	0x64,0x7e,0x3c,0x2f,0x73,0x73,0x69,0x64,0x3e,0x0a,0x09,0x0a,0x09,0x3c,0x62,0x73, /* d~</ssid>....<bs */ \
	0x73,0x3e,0x0a,0x09,0x09,0x3c,0x76,0x61,0x6c,0x69,0x64,0x3e,0x7e,0x76,0x61,0x6c, /* s>...<valid>~val */ \
	0x69,0x64,0x7e,0x3c,0x2f,0x76,0x61,0x6c,0x69,0x64,0x3e,0x0a,0x09,0x09,0x3c,0x6e, /* id~</valid>...<n */ \
	0x61,0x6d,0x65,0x3e,0x7e,0x6e,0x61,0x6d,0x65,0x7e,0x3c,0x2f,0x6e,0x61,0x6d,0x65, /* ame>~name~</name */ \
	0x3e,0x0a,0x09,0x09,0x3c,0x70,0x72,0x69,0x76,0x61,0x63,0x79,0x3e,0x7e,0x70,0x72, /* >...<privacy>~pr */ \
	0x69,0x76,0x61,0x63,0x79,0x7e,0x3c,0x2f,0x70,0x72,0x69,0x76,0x61,0x63,0x79,0x3e, /* ivacy~</privacy> */ \
	0x0a,0x09,0x09,0x3c,0x77,0x6c,0x61,0x6e,0x3e,0x7e,0x77,0x6c,0x61,0x6e,0x7e,0x3c, /* ...<wlan>~wlan~< */ \
	0x2f,0x77,0x6c,0x61,0x6e,0x3e,0x0a,0x09,0x09,0x3c,0x73,0x74,0x72,0x65,0x6e,0x67, /* /wlan>...<streng */ \
	0x74,0x68,0x3e,0x7e,0x73,0x74,0x72,0x65,0x6e,0x67,0x74,0x68,0x7e,0x3c,0x2f,0x73, /* th>~strength~</s */ \
	0x74,0x72,0x65,0x6e,0x67,0x74,0x68,0x3e,0x0a,0x09,0x3c,0x2f,0x62,0x73,0x73,0x3e, /* trength>..</bss> */ \
	0x0a,0x0a,0x09,0x3c,0x6c,0x65,0x64,0x30,0x3e,0x7e,0x6c,0x65,0x64,0x28,0x30,0x29, /* ...<led0>~led(0) */ \
	0x7e,0x3c,0x2f,0x6c,0x65,0x64,0x30,0x3e,0x0a,0x09,0x3c,0x6c,0x65,0x64,0x31,0x3e, /* ~</led0>..<led1> */ \
	0x7e,0x6c,0x65,0x64,0x28,0x31,0x29,0x7e,0x3c,0x2f,0x6c,0x65,0x64,0x31,0x3e,0x0a, /* ~led(1)~</led1>. */ \
	0x09,0x3c,0x6c,0x65,0x64,0x32,0x3e,0x7e,0x6c,0x65,0x64,0x28,0x32,0x29,0x7e,0x3c, /* .<led2>~led(2)~< */ \
	0x2f,0x6c,0x65,0x64,0x32,0x3e,0x0a,0x09,0x3c,0x62,0x74,0x6e,0x30,0x3e,0x7e,0x62, /* /led2>..<btn0>~b */ \
	0x74,0x6e,0x28,0x30,0x29,0x7e,0x3c,0x2f,0x62,0x74,0x6e,0x30,0x3e,0x0a,0x20,0x3c, /* tn(0)~</btn0>. < */ \
	0x2f,0x72,0x65,0x73,0x70,0x6f,0x6e,0x73,0x65,0x3e,0x0a,0x89,0x50,0x4e,0x47,0x0d, /* /response>..PNG. */ \
	0x0a,0x1a,0x0a,0x00,0x00,0x00,0x0d,0x49,0x48,0x44,0x52,0x00,0x00,0x00,0x13,0x00, /* .......IHDR..... */ \
	0x00,0x00,0x0f,0x08,0x03,0x00,0x00,0x00,0x31,0x9a,0x04,0x1e,0x00,0x00,0x00,0x19, /* ........1....... */ \
	0x74,0x45,0x58,0x74,0x53,0x6f,0x66,0x74,0x77,0x61,0x72,0x65,0x00,0x41,0x64,0x6f, /* tEXtSoftware.Ado */ \
	0x62,0x65,0x20,0x49,0x6d,0x61,0x67,0x65,0x52,0x65,0x61,0x64,0x79,0x71,0xc9,0x65, /* be ImageReadyq.e */ \
	0x3c,0x00,0x00,0x00,0x90,0x50,0x4c,0x54,0x45,0xef,0xef,0xef,0xd0,0xd0,0xd0,0xd1, /* <....PLTE....... */ \
	0xd1,0xd1,0xc9,0xc9,0xc9,0xe9,0xe9,0xe9,0xf9,0xf9,0xf9,0xbc,0xbc,0xbc,0xdc,0xdc, /* ................ */ \
	0xdc,0xf6,0xf6,0xf6,0xfb,0xfb,0xfb,0xfa,0xfa,0xfa,0xf4,0xf4,0xf4,0xcb,0xcb,0xcb, /* ................ */ \
	0xc8,0xc8,0xc8,0xdf,0xdf,0xdf,0xc5,0xc5,0xc5,0xd5,0xd5,0xd5,0xc2,0xc2,0xc2,0xcc, /* ................ */ \
	0xcc,0xcc,0xbf,0xbf,0xbf,0xf5,0xf5,0xf5,0xe0,0xe0,0xe0,0xd6,0xd6,0xd6,0xf8,0xf8, /* ................ */ \
	0xf8,0xca,0xca,0xca,0xea,0xea,0xea,0xe8,0xe8,0xe8,0xde,0xde,0xde,0xaf,0xaf,0xaf, /* ................ */ \
	0xe7,0xe7,0xe7,0xe5,0xe5,0xe5,0xc6,0xc6,0xc6,0xe4,0xe4,0xe4,0xe3,0xe3,0xe3,0xdd, /* ................ */ \
	0xdd,0xdd,0xf2,0xf2,0xf2,0xcd,0xcd,0xcd,0x60,0x60,0x60,0xee,0xee,0xee,0xdb,0xdb, /* ........```..... */ \
	0xdb,0xc3,0xc3,0xc3,0xd3,0xd3,0xd3,0xd4,0xd4,0xd4,0xbd,0xbd,0xbd,0xbe,0xbe,0xbe, /* ................ */ \
	0xfd,0xfd,0xfd,0xfe,0xfe,0xfe,0xff,0xff,0xff,0x44,0x39,0x7d,0x47,0x00,0x00,0x00, /* .........D9}G... */ \
	0xa4,0x49,0x44,0x41,0x54,0x78,0xda,0x64,0x90,0x57,0x0e,0x03,0x21,0x0c,0x05,0xe9, /* .IDATx.d.W..!... */ \
	0xdb,0x7b,0x4b,0xef,0x1d,0x1b,0xee,0x7f,0xbb,0x20,0x94,0x64,0xb3,0xda,0xf7,0x61, /* .{K...... .d...a */ \
	0x89,0x91,0x6c,0x8f,0x21,0xd6,0xc5,0xa0,0x8b,0x71,0xb1,0xfe,0x45,0x7c,0x3d,0xe7, /* ..l.!....q..E|=. */ \
	0xcf,0x74,0x51,0xbf,0xba,0xe4,0xc7,0x48,0xad,0x95,0xaa,0xf6,0x95,0x06,0xb8,0x10, /* .tQ....H........ */ \
	0xcf,0xcc,0x1d,0x34,0x5d,0x0d,0xae,0x57,0x0a,0x06,0x10,0x18,0xc7,0x7a,0xe0,0x37, /* ...4]..W.....z.7 */ \
	0x44,0xd9,0x26,0x61,0x6c,0x2c,0xe1,0xd0,0x3b,0x46,0xca,0xc8,0x6c,0x33,0xa5,0x5d, /* D.&al,..;F..l3.] */ \
	0xb8,0xb0,0x51,0x49,0xfc,0x3c,0xa4,0x5a,0xd3,0x7c,0xd7,0xb1,0x06,0x18,0x7e,0x76, /* ..QI.<.Z.|....~v */ \
	0x84,0x40,0x13,0xef,0xd2,0xb2,0x26,0xfc,0xba,0x0c,0x18,0x1f,0x69,0xca,0x0e,0x91, /* .@....&.....i... */ \
	0x95,0xa3,0x1f,0x66,0x0a,0x0a,0xd0,0xfc,0xdf,0x19,0x45,0x20,0x4d,0x7c,0x5a,0x4e, /* ...f......E M|ZN */ \
	0x18,0x62,0xb0,0x59,0x4f,0x6f,0x73,0xec,0x71,0x2d,0x66,0x0c,0x85,0x99,0xb3,0xf1, /* .b.YOos.q-f..... */ \
	0x5f,0xde,0x02,0x0c,0x00,0x5e,0x6c,0x28,0x41,0x61,0xb4,0x15,0x36,0x00,0x00,0x00, /* _....^l(Aa..6... */ \
	0x00,0x49,0x45,0x4e,0x44,0xae,0x42,0x60,0x82,0x89,0x50,0x4e,0x47,0x0d,0x0a,0x1a, /* .IEND.B`..PNG... */ \
	0x0a,0x00,0x00,0x00,0x0d,0x49,0x48,0x44,0x52,0x00,0x00,0x00,0x13,0x00,0x00,0x00, /* .....IHDR....... */ \
	0x0f,0x08,0x03,0x00,0x00,0x00,0x31,0x9a,0x04,0x1e,0x00,0x00,0x00,0x19,0x74,0x45, /* ......1.......tE */ \
	0x58,0x74,0x53,0x6f,0x66,0x74,0x77,0x61,0x72,0x65,0x00,0x41,0x64,0x6f,0x62,0x65, /* XtSoftware.Adobe */ \
	0x20,0x49,0x6d,0x61,0x67,0x65,0x52,0x65,0x61,0x64,0x79,0x71,0xc9,0x65,0x3c,0x00, /*  ImageReadyq.e<. */ \
	0x00,0x00,0xc6,0x50,0x4c,0x54,0x45,0xbe,0xbe,0xbe,0xf9,0xf9,0xf9,0xd1,0xd1,0xd1, /* ...PLTE......... */ \
	0xf3,0xf3,0xf3,0xbc,0xbc,0xbc,0xf6,0xf6,0xf6,0xd4,0xd4,0xd4,0xe0,0xe0,0xe0,0xbb, /* ................ */ \
	0xbb,0xbb,0x60,0x60,0x60,0xf5,0xf5,0xf5,0xf7,0xf7,0xf7,0xf8,0xf8,0xf8,0xc2,0xc2, /* ..```........... */ \
	0xc2,0xc6,0xc6,0xc6,0xe8,0xe8,0xe8,0xdc,0xdc,0xdc,0xc9,0xc9,0xc9,0xc7,0xc7,0xc7, /* ................ */ \
	0xcf,0xcf,0xcf,0xcc,0xcc,0xcc,0xec,0xec,0xec,0xcd,0xcd,0xcd,0xef,0xef,0xef,0xb5, /* ................ */ \
	0xb5,0xb5,0xdb,0xdb,0xdb,0xdf,0xdf,0xdf,0x82,0x82,0x82,0xd8,0xd8,0xd8,0xcb,0xcb, /* ................ */ \
	0xcb,0x71,0x71,0x71,0xae,0xae,0xae,0xed,0xed,0xed,0xc4,0xc4,0xc4,0x7a,0x7a,0x7a, /* .qqq.........zzz */ \
	0xba,0xba,0xba,0xce,0xce,0xce,0xf4,0xf4,0xf4,0x7c,0x7c,0x7c,0xf2,0xf2,0xf2,0xeb, /* .........|||.... */ \
	0xeb,0xeb,0xa4,0xa4,0xa4,0xb4,0xb4,0xb4,0xe7,0xe7,0xe7,0xe4,0xe4,0xe4,0x5e,0x5e, /* ..............^^ */ \
	0x5e,0x5d,0x5d,0x5d,0xc5,0xc5,0xc5,0xe9,0xe9,0xe9,0xe6,0xe6,0xe6,0xf1,0xf1,0xf1, /* ^]]]............ */ \
	0xd2,0xd2,0xd2,0xd6,0xd6,0xd6,0x80,0x80,0x80,0xca,0xca,0xca,0xbf,0xbf,0xbf,0x6e, /* ...............n */ \
	0x6e,0x6e,0xa3,0xa3,0xa3,0xd3,0xd3,0xd3,0xbd,0xbd,0xbd,0xfa,0xfa,0xfa,0xfc,0xfc, /* nn.............. */ \
	0xfc,0xfe,0xfe,0xfe,0xfd,0xfd,0xfd,0xfb,0xfb,0xfb,0xff,0xff,0xff,0x49,0x41,0x85, /* .............IA. */ \
	0x40,0x00,0x00,0x00,0xcf,0x49,0x44,0x41,0x54,0x78,0xda,0x3c,0xd0,0xd7,0x52,0x03, /* @....IDATx.<..R. */ \
	0x31,0x0c,0x05,0x50,0x6f,0xef,0xe9,0x8d,0x54,0x20,0x85,0x92,0x0a,0x01,0x12,0x58, /* 1..Po...T .....X */ \
	0xab,0xec,0xff,0xff,0x14,0xb2,0x77,0x12,0x3d,0xe8,0xe1,0xcc,0xd5,0xc8,0xb2,0x02, /* ......w.=....... */ \
	0x02,0x32,0x85,0x88,0xd2,0x2a,0x53,0x8a,0x8c,0xbd,0x44,0x61,0xef,0xa7,0x17,0x46, /* .2....S...Da...F */ \
	0x1e,0x59,0x03,0xa0,0xfe,0xac,0x2c,0xcb,0xa2,0x51,0x48,0x1f,0x0c,0xad,0xf1,0x34, /* .Y....,..QH....4 */ \
	0xf6,0xbb,0xcd,0x9c,0x90,0x9c,0x93,0xab,0x54,0x0b,0x2b,0xc5,0x7f,0xcb,0x46,0x1f, /* ........T.+...F. */ \
	0xc0,0x49,0xbd,0x40,0x13,0x3e,0xb6,0xd5,0x97,0xd8,0xeb,0x39,0xe3,0x8f,0x8e,0xef, /* .I.@.>.....9.... */ \
	0xcb,0x64,0x7b,0x8b,0x1c,0x0e,0x2b,0xa5,0x99,0xf3,0x55,0x1c,0x77,0xc7,0xbb,0x48, /* .d{...+...U.w..H */ \
	0x26,0x5d,0xb3,0x44,0x31,0xeb,0x4f,0x7f,0xe0,0xb1,0x6c,0xc7,0xd4,0xbd,0x04,0xc6, /* &].D1.O...l..... */ \
	0x24,0xc7,0x29,0x07,0xef,0xdf,0xf3,0xc9,0x28,0xc3,0xdc,0xbe,0xc5,0x61,0xd1,0xec, /* $.).....(....a.. */ \
	0xf9,0x90,0x5c,0x93,0xfd,0x86,0xb1,0x36,0x6d,0xf0,0xf8,0xeb,0xc1,0xfa,0xad,0x83, /* ..\....6m....... */ \
	0x77,0x93,0x02,0x7e,0x58,0xb4,0xe4,0xbe,0xfa,0x0e,0x6d,0x72,0x9a,0xa1,0x48,0x9e, /* w..~X.....mr..H. */ \
	0x6e,0x07,0xdb,0x1d,0x92,0x03,0x68,0x82,0xf9,0x87,0x9b,0x69,0x6b,0x12,0xa2,0xda, /* n.....h....ik... */ \
	0xfe,0x05,0x18,0x00,0xfe,0xce,0x34,0xaf,0x11,0x44,0xc9,0xf9,0x00,0x00,0x00,0x00, /* ......4..D...... */ \
	0x49,0x45,0x4e,0x44,0xae,0x42,0x60,0x82,0x89,0x50,0x4e,0x47,0x0d,0x0a,0x1a,0x0a, /* IEND.B`..PNG.... */ \
	0x00,0x00,0x00,0x0d,0x49,0x48,0x44,0x52,0x00,0x00,0x00,0x13,0x00,0x00,0x00,0x0f, /* ....IHDR........ */ \
	0x08,0x03,0x00,0x00,0x00,0x31,0x9a,0x04,0x1e,0x00,0x00,0x00,0x19,0x74,0x45,0x58, /* .....1.......tEX */ \
	0x74,0x53,0x6f,0x66,0x74,0x77,0x61,0x72,0x65,0x00,0x41,0x64,0x6f,0x62,0x65,0x20, /* tSoftware.Adobe  */ \
	0x49,0x6d,0x61,0x67,0x65,0x52,0x65,0x61,0x64,0x79,0x71,0xc9,0x65,0x3c,0x00,0x00, /* ImageReadyq.e<.. */ \
	0x00,0xcf,0x50,0x4c,0x54,0x45,0x61,0x61,0x61,0xfb,0xfb,0xfb,0x62,0x62,0x62,0xc7, /* ..PLTEaaa...bbb. */ \
	0xc7,0xc7,0xc2,0xc2,0xc2,0xe9,0xe9,0xe9,0xf5,0xf5,0xf5,0xed,0xed,0xed,0xd6,0xd6, /* ................ */ \
	0xd6,0x7c,0x7c,0x7c,0xce,0xce,0xce,0x8c,0x8c,0x8c,0xbe,0xbe,0xbe,0xbc,0xbc,0xbc, /* .|||............ */ \
	0xd4,0xd4,0xd4,0xf8,0xf8,0xf8,0xc8,0xc8,0xc8,0xe8,0xe8,0xe8,0xef,0xef,0xef,0xcc, /* ................ */ \
	0xcc,0xcc,0xf9,0xf9,0xf9,0xc9,0xc9,0xc9,0x8d,0x8d,0x8d,0xe0,0xe0,0xe0,0x7b,0x7b, /* ..............{{ */ \
	0x7b,0xea,0xea,0xea,0xdf,0xdf,0xdf,0xf6,0xf6,0xf6,0xaf,0xaf,0xaf,0x72,0x72,0x72, /* {............rrr */ \
	0xd1,0xd1,0xd1,0x82,0x82,0x82,0xc0,0xc0,0xc0,0xdd,0xdd,0xdd,0xd3,0xd3,0xd3,0xb4, /* ................ */ \
	0xb4,0xb4,0xdc,0xdc,0xdc,0xc6,0xc6,0xc6,0xd9,0xd9,0xd9,0x5d,0x5d,0x5d,0x83,0x83, /* ...........]]].. */ \
	0x83,0x8f,0x8f,0x8f,0xa4,0xa4,0xa4,0x8e,0x8e,0x8e,0xcb,0xcb,0xcb,0xcf,0xcf,0xcf, /* ................ */ \
	0xcd,0xcd,0xcd,0xc5,0xc5,0xc5,0x70,0x70,0x70,0xfa,0xfa,0xfa,0xf1,0xf1,0xf1,0xee, /* ......ppp....... */ \
	0xee,0xee,0xde,0xde,0xde,0xa5,0xa5,0xa5,0xd5,0xd5,0xd5,0xb3,0xb3,0xb3,0xb5,0xb5, /* ................ */ \
	0xb5,0xf7,0xf7,0xf7,0xd2,0xd2,0xd2,0xe1,0xe1,0xe1,0xb6,0xb6,0xb6,0xf3,0xf3,0xf3, /* ................ */ \
	0xc3,0xc3,0xc3,0x5e,0x5e,0x5e,0xbd,0xbd,0xbd,0xfc,0xfc,0xfc,0xfe,0xfe,0xfe,0xfd, /* ...^^^.......... */ \
	0xfd,0xfd,0xff,0xff,0xff,0x8c,0xa6,0x02,0x56,0x00,0x00,0x00,0xc5,0x49,0x44,0x41, /* ........V....IDA */ \
	0x54,0x78,0xda,0x4c,0xcf,0xd5,0x0e,0xc3,0x30,0x0c,0x05,0xd0,0x94,0xdb,0x51,0x07, /* Tx.L....0.....Q. */ \
	0x5d,0x61,0xcc,0xcc,0xcc,0x4d,0xec,0xfd,0xff,0x37,0xcd,0xe9,0x56,0x69,0xf7,0x25, /* ]a...M...7..Vi.% */ \
	0xd1,0x51,0x6c,0xc7,0x4c,0x50,0x50,0x08,0x00,0x04,0x99,0x37,0x85,0xa1,0x94,0x5d, /* .Ql.LPP....7...] */ \
	0x50,0xa8,0x54,0x2b,0xbd,0xe0,0xf9,0x35,0x22,0x6b,0xc1,0x79,0x5e,0x1f,0xea,0x9c, /* P.T+...5"k.y^... */ \
	0xe7,0x56,0xe5,0xe4,0x9d,0x32,0xe2,0x7c,0x59,0xf2,0xa8,0xce,0x2b,0xb5,0x38,0x1f, /* .V...2.|Y...+.8. */ \
	0x20,0x59,0x21,0xaf,0xed,0x01,0x8c,0x8c,0x9e,0x31,0x10,0xac,0x62,0xce,0x26,0xb3, /*  Y!......1..b.&. */ \
	0x6e,0x2e,0x16,0xc3,0x58,0xc6,0xa9,0x82,0x72,0x2a,0xcb,0x19,0xc2,0xcc,0x8e,0xd5, /* n...X...r....... */ \
	0xf9,0xb9,0xd3,0x9f,0xaa,0xb1,0x5f,0x4f,0xfa,0x21,0xda,0x2c,0x1b,0x01,0x9d,0x10, /* ......_O.!.,.... */ \
	0xf9,0xaa,0xfd,0x33,0xac,0x29,0xee,0xa3,0xdd,0x9c,0x5c,0xae,0xe2,0x9e,0xfe,0x0f, /* ...3.)....\..... */ \
	0x41,0x09,0x63,0xb6,0x61,0xb1,0xb3,0xc5,0xdf,0xff,0xc8,0x50,0x9b,0x99,0x68,0x1e, /* A.c.a......P..h. */ \
	0xb5,0x74,0x0f,0x1a,0x42,0x08,0xdd,0xc6,0x41,0xee,0xf7,0x4e,0xfb,0xd1,0x4b,0x78, /* .t..B...A..N..Kx */ \
	0xb1,0x35,0xa6,0x96,0xd4,0xca,0x18,0x20,0x2f,0x7f,0xf6,0x65,0x52,0x69,0x1f,0x01, /* .5..... /..eRi.. */ \
	0x06,0x00,0x81,0xbe,0x39,0x19,0xd0,0x7a,0x8f,0x4b,0x00,0x00,0x00,0x00,0x49,0x45, /* ....9..z.K....IE */ \
	0x4e,0x44,0xae,0x42,0x60,0x82,0x89,0x50,0x4e,0x47,0x0d,0x0a,0x1a,0x0a,0x00,0x00, /* ND.B`..PNG...... */ \
	0x00,0x0d,0x49,0x48,0x44,0x52,0x00,0x00,0x00,0x13,0x00,0x00,0x00,0x0f,0x08,0x03, /* ..IHDR.......... */ \
	0x00,0x00,0x00,0x31,0x9a,0x04,0x1e,0x00,0x00,0x00,0x19,0x74,0x45,0x58,0x74,0x53, /* ...1.......tEXtS */ \
	0x6f,0x66,0x74,0x77,0x61,0x72,0x65,0x00,0x41,0x64,0x6f,0x62,0x65,0x20,0x49,0x6d, /* oftware.Adobe Im */ \
	0x61,0x67,0x65,0x52,0x65,0x61,0x64,0x79,0x71,0xc9,0x65,0x3c,0x00,0x00,0x00,0xf0, /* ageReadyq.e<.... */ \
	0x50,0x4c,0x54,0x45,0x5d,0x5d,0x5d,0xf7,0xf7,0xf7,0x79,0x79,0x79,0x60,0x60,0x60, /* PLTE]]]...yyy``` */ \
	0xdc,0xdc,0xdc,0x8a,0x8a,0x8a,0xf3,0xf3,0xf3,0x62,0x62,0x62,0x7b,0x7b,0x7b,0xf1, /* .........bbb{{{. */ \
	0xf1,0xf1,0xf2,0xf2,0xf2,0xc7,0xc7,0xc7,0xd2,0xd2,0xd2,0xe6,0xe6,0xe6,0xac,0xac, /* ................ */ \
	0xac,0x8c,0x8c,0x8c,0xd7,0xd7,0xd7,0xa4,0xa4,0xa4,0x8d,0x8d,0x8d,0x73,0x73,0x73, /* .............sss */ \
	0xc9,0xc9,0xc9,0xb5,0xb5,0xb5,0x76,0x76,0x76,0xd8,0xd8,0xd8,0xa2,0xa2,0xa2,0xc4, /* ......vvv....... */ \
	0xc4,0xc4,0xfa,0xfa,0xfb,0x7f,0x7f,0x7f,0xca,0xca,0xca,0x6d,0x6d,0x6d,0xef,0xef, /* ...........mmm.. */ \
	0xef,0xe7,0xe7,0xe7,0x83,0x83,0x83,0x74,0x74,0x74,0x80,0x80,0x80,0xc5,0xc5,0xc5, /* .......ttt...... */ \
	0x6a,0x6a,0x6a,0x69,0x69,0x69,0x70,0x70,0x70,0xbf,0xbf,0xbf,0xd3,0xd3,0xd3,0xda, /* jjjiiippp....... */ \
	0xda,0xda,0x71,0x71,0x71,0x8b,0x8b,0x8b,0xe1,0xe1,0xe1,0xcc,0xcc,0xcc,0x8e,0x8e, /* ..qqq........... */ \
	0x8e,0x89,0x89,0x89,0xb1,0xb1,0xb1,0xc1,0xc1,0xc1,0x93,0x93,0x93,0xcd,0xcd,0xcd, /* ................ */ \
	0xbe,0xbe,0xbe,0xa8,0xa8,0xa8,0xd4,0xd4,0xd4,0xae,0xae,0xae,0x90,0x90,0x90,0xe5, /* ................ */ \
	0xe5,0xe5,0xe0,0xe0,0xe0,0xea,0xea,0xea,0x94,0x94,0x94,0xd9,0xd9,0xd9,0xf6,0xf6, /* ................ */ \
	0xf6,0x6e,0x6e,0x6e,0xc3,0xc3,0xc3,0xb2,0xb2,0xb2,0xb3,0xb3,0xb3,0x98,0x98,0x98, /* .nnn............ */ \
	0x5f,0x5f,0x5f,0x81,0x81,0x81,0x5e,0x5e,0x5e,0xfd,0xfd,0xfd,0xfe,0xfe,0xfe,0xf8, /* ___...^^^....... */ \
	0xf8,0xf8,0x5c,0x5c,0x5c,0xfc,0xfc,0xfc,0xfb,0xfb,0xfb,0xf9,0xf9,0xf9,0xfa,0xfa, /* ..\\\........... */ \
	0xfa,0xff,0xff,0xff,0xc2,0x2f,0xbf,0xb7,0x00,0x00,0x00,0xdb,0x49,0x44,0x41,0x54, /* ...../......IDAT */ \
	0x78,0xda,0x4c,0x90,0xe7,0x52,0x42,0x41,0x0c,0x85,0xf7,0x36,0x7a,0x57,0xb0,0x17, /* x.L..RBA...6zW.. */ \
	0xc0,0x86,0x54,0x05,0x7b,0x03,0x95,0xbd,0x77,0x37,0x85,0xf7,0x7f,0x1b,0x73,0x0b, /* ..T.{...w7....s. */ \
	0x33,0x66,0xf2,0xeb,0x9b,0x73,0x92,0x93,0x28,0x00,0x3e,0x64,0x62,0x46,0x06,0x08, /* 3f...s..(.>dbF.. */ \
	0xa3,0x4d,0x5c,0x0a,0x00,0x99,0xfd,0xda,0xb4,0x7b,0xb2,0x33,0x7c,0x1a,0xa5,0x8c, /* .M\......{.3|... */ \
	0x11,0x1f,0x8f,0xac,0xb5,0x97,0xb7,0x17,0x4a,0xe9,0xf3,0x8f,0x98,0xa1,0x69,0x5a, /* ........J.....iZ */ \
	0x1b,0x94,0x4f,0x11,0xb1,0x74,0xdc,0xd2,0xfa,0x01,0x44,0xf7,0x6e,0x3b,0x37,0xc4, /* ..O..t....D.n;7. */ \
	0x2f,0xe3,0xeb,0xf9,0x59,0x14,0xed,0xb9,0xfa,0x47,0x58,0xe5,0xb9,0x48,0x7d,0x57, /* /...Y....GX..H}W */ \
	0xdc,0x4a,0x15,0x76,0x37,0x9f,0xf7,0x0d,0x61,0xcc,0xa5,0xc0,0x7a,0xf5,0xd9,0x62, /* .J.v7...a...z..b */ \
	0x35,0xc9,0xeb,0x96,0x93,0xec,0x20,0xae,0x78,0x41,0x55,0x56,0x01,0xbc,0xd5,0xf3, /* 5..... .xAUV.... */ \
	0x8d,0x84,0x31,0x93,0xef,0xe4,0xbe,0x7b,0x57,0xeb,0xb6,0xc1,0xd7,0x24,0x0b,0x91, /* ..1....{W....$.. */ \
	0x21,0x72,0x5c,0xfb,0xfb,0xe5,0xa9,0x02,0xa6,0xf9,0x8c,0x43,0x52,0x07,0xfb,0x45, /* !r\........CR..E */ \
	0xcc,0x35,0xcb,0x61,0xc6,0x44,0xc6,0xd2,0x83,0x9a,0x1f,0x46,0xd9,0x6d,0x82,0x8c, /* .5.a.D.....F.m.. */ \
	0xcc,0xe4,0x3b,0xbd,0x84,0x7f,0x8c,0x62,0x86,0x55,0x79,0x41,0xe6,0x4d,0x55,0x92, /* ..;....b.UyA.MU. */ \
	0x08,0x61,0xeb,0xfd,0x13,0x60,0x00,0xe0,0x6f,0x42,0x10,0x81,0x5f,0xe9,0x1b,0x00, /* .a...`..oB.._... */ \
	0x00,0x00,0x00,0x49,0x45,0x4e,0x44,0xae,0x42,0x60,0x82,0x89,0x50,0x4e,0x47,0x0d, /* ...IEND.B`..PNG. */ \
	0x0a,0x1a,0x0a,0x00,0x00,0x00,0x0d,0x49,0x48,0x44,0x52,0x00,0x00,0x00,0x13,0x00, /* .......IHDR..... */ \
	0x00,0x00,0x0f,0x08,0x03,0x00,0x00,0x00,0x31,0x9a,0x04,0x1e,0x00,0x00,0x00,0x19, /* ........1....... */ \
	0x74,0x45,0x58,0x74,0x53,0x6f,0x66,0x74,0x77,0x61,0x72,0x65,0x00,0x41,0x64,0x6f, /* tEXtSoftware.Ado */ \
	0x62,0x65,0x20,0x49,0x6d,0x61,0x67,0x65,0x52,0x65,0x61,0x64,0x79,0x71,0xc9,0x65, /* be ImageReadyq.e */ \
	0x3c,0x00,0x00,0x00,0x06,0x50,0x4c,0x54,0x45,0xff,0xff,0xff,0x00,0x00,0x00,0x55, /* <....PLTE......U */ \
	0xc2,0xd3,0x7e,0x00,0x00,0x00,0x10,0x49,0x44,0x41,0x54,0x78,0xda,0x62,0x60,0x18, /* ..~....IDATx.b`. */ \
	0x05,0xc4,0x02,0x80,0x00,0x03,0x00,0x01,0x2c,0x00,0x01,0x6d,0xb7,0x50,0x6f,0x00, /* ........,..m.Po. */ \
	0x00,0x00,0x00,0x49,0x45,0x4e,0x44,0xae,0x42,0x60,0x82,0x89,0x50,0x4e,0x47,0x0d, /* ...IEND.B`..PNG. */ \
	0x0a,0x1a,0x0a,0x00,0x00,0x00,0x0d,0x49,0x48,0x44,0x52,0x00,0x00,0x00,0x13,0x00, /* .......IHDR..... */ \
	0x00,0x00,0x0f,0x08,0x03,0x00,0x00,0x00,0x31,0x9a,0x04,0x1e,0x00,0x00,0x00,0x19, /* ........1....... */ \
	0x74,0x45,0x58,0x74,0x53,0x6f,0x66,0x74,0x77,0x61,0x72,0x65,0x00,0x41,0x64,0x6f, /* tEXtSoftware.Ado */ \
	0x62,0x65,0x20,0x49,0x6d,0x61,0x67,0x65,0x52,0x65,0x61,0x64,0x79,0x71,0xc9,0x65, /* be ImageReadyq.e */ \
	0x3c,0x00,0x00,0x00,0x48,0x50,0x4c,0x54,0x45,0xf5,0xf5,0xf5,0xa3,0xa3,0xa4,0x89, /* <...HPLTE....... */ \
	0x89,0x8a,0x75,0x75,0x76,0xe3,0xe3,0xe3,0xd0,0xd0,0xd0,0xfc,0xfc,0xfc,0xc8,0xc8, /* ..uuv........... */ \
	0xc8,0xcf,0xcf,0xcf,0x9b,0x9b,0x9b,0xbe,0xbe,0xbe,0xac,0xac,0xad,0x6b,0x6b,0x6c, /* .............kkl */ \
	0x74,0x74,0x75,0x91,0x91,0x92,0xf4,0xf4,0xf4,0xab,0xac,0xac,0x89,0x89,0x89,0xb5, /* ttu............. */ \
	0xb5,0xb6,0x6c,0x6c,0x6c,0x6c,0x6c,0x6d,0xfd,0xfd,0xfd,0xfe,0xfe,0xfe,0xff,0xff, /* ..lllllm........ */ \
	0xff,0xa7,0x59,0x10,0xe4,0x00,0x00,0x00,0x7c,0x49,0x44,0x41,0x54,0x78,0xda,0x64, /* ..Y.....|IDATx.d */ \
	0x8f,0x89,0x0e,0x83,0x30,0x0c,0x43,0xd3,0x03,0xc6,0xd8,0xd8,0xc1,0x1c,0xf3,0xff, /* ....0.C......... */ \
	0x7f,0xba,0x04,0x95,0xb6,0x63,0x56,0x5b,0xa9,0x4f,0xce,0x61,0xd9,0xfe,0x25,0x76, /* .....cV[.O.a..%v */ \
	0x75,0xd4,0x43,0xa3,0x16,0x46,0x97,0xaa,0x3d,0x61,0xe2,0xe1,0xa3,0xfd,0x1d,0x5d, /* u.C..F..=a.....] */ \
	0x90,0xd8,0x7c,0x4e,0x98,0xf1,0x79,0x55,0xb6,0x13,0x4a,0x42,0x94,0xe6,0xcb,0x37, /* ..|N..yU..JB...7 */ \
	0xab,0x8f,0x40,0x66,0x9b,0x11,0xb1,0x32,0xe0,0x3e,0x9b,0xbb,0xb2,0x00,0xd8,0x79, /* ..@f...2.>.....y */ \
	0x78,0xdf,0xda,0xef,0xb9,0x00,0x48,0xd2,0x33,0xea,0x60,0x6c,0xd8,0xc7,0x77,0xfb, /* x.....H.3.`l..w. */ \
	0x5d,0x11,0x3c,0x47,0xc7,0x6c,0x91,0xb7,0x78,0x14,0xfd,0xc9,0xc1,0x12,0xa6,0xb0, /* ].<G.l..x....... */ \
	0xb3,0xbe,0x02,0x0c,0x00,0x1a,0x8c,0x16,0x6e,0xfa,0x1a,0x09,0x15,0x00,0x00,0x00, /* ........n....... */ \
	0x00,0x49,0x45,0x4e,0x44,0xae,0x42,0x60,0x82,0x1f,0x8b,0x08,0x00,0x00,0x00,0x00, /* .IEND.B`........ */ \
	0x00,0x00,0x00,0x45,0x57,0x69,0x58,0x53,0xd7,0xd6,0xde,0x19,0x38,0x24,0x10,0x20, /* ...EWiXS....8$.  */ \
	0x04,0xd4,0x30,0xa8,0x01,0x99,0x0f,0xda,0xc0,0x41,0x26,0x87,0x86,0x51,0xd0,0xa0, /* ..0......A&..Q.. */ \
	0x20,0xc6,0xaa,0xa8,0x25,0x0c,0x47,0x44,0x86,0xa0,0x88,0x48,0xab,0x3d,0x40,0x08, /*  ...%.GD...H.=@. */ \
	0xb3,0x06,0x64,0xc8,0x0e,0xb6,0x06,0xb1,0x54,0xf2,0xd9,0x1a,0x44,0x2d,0x5e,0x6d, /* ..d.....T...D-^m */ \
	0x0d,0xa3,0x80,0xa7,0x14,0xad,0xb1,0xda,0xa2,0x17,0x1c,0x2a,0x5a,0xab,0xd0,0xf6, /* ............Z... */ \
	0x56,0xab,0xb7,0xdd,0x5f,0xfa,0xfd,0xf9,0xd6,0xaf,0xbd,0xd7,0x7a,0x9e,0xfd,0xbe, /* V..._.......z... */ \
	0xeb,0x7d,0xd7,0x8f,0xb5,0xd7,0xc4,0xc7,0x86,0x86,0xc9,0xbf,0x04,0xab,0x81,0x02, /* .}.............. */ \
	0x00,0xb7,0x3f,0xd9,0x0c,0x00,0xfe,0x0b,0xfc,0x81,0x39,0xfe,0xc9,0x55,0xfe,0x73, /* ..?.......9..U.s */ \
	0x00,0x04,0x00,0x24,0x00,0x10,0x00,0x1a,0x00,0x04,0x70,0x00,0x70,0x02,0xe0,0x24, /* ...$......p.p..$ */ \
	0xc0,0x21,0xc0,0x69,0x80,0x23,0x20,0x03,0x40,0x46,0x00,0x19,0x09,0x64,0x10,0xc8, /* .!.i.# .@F...d.. */ \
	0x68,0x20,0x43,0x80,0x02,0x80,0x22,0x00,0x45,0x02,0x0a,0x02,0x8a,0x06,0x14,0x02, /* h C...".E....... */ \
	0x7a,0x00,0xf4,0x04,0xd0,0x93,0x40,0x0f,0x81,0x9e,0x06,0x7a,0x04,0x4c,0x00,0x98, /* z.....@....z.L.. */ \
	0x08,0x60,0x22,0x81,0x09,0x02,0x13,0x0d,0x4c,0xc8,0xfc,0x36,0x40,0x04,0x40,0x24, /* .`".....L..6@.@$ */ \
	0x40,0x10,0x20,0x1a,0x20,0xf3,0xc5,0x8c,0x4d,0x10,0x80,0x24,0x00,0x24,0x00,0x6d, /* @. . ...M..$.$.m */ \
	0xae,0x11,0x38,0x20,0x70,0x82,0xc0,0x49,0x02,0x87,0x04,0x4e,0x13,0x38,0x22,0x64, /* ..8 p..I...N.8"d */ \
	0x80,0x90,0x11,0x84,0x8c,0x24,0x64,0x90,0x90,0xd1,0x84,0x0c,0x11,0x14,0x20,0x28, /* .....$d....... ( */ \
	0x82,0xa0,0x48,0x82,0x82,0x04,0x45,0x13,0x14,0x22,0xf4,0x80,0xd0,0x13,0x84,0x9e, /* ..H...E.."...... */ \
	0x24,0xf4,0x90,0xd0,0xd3,0x84,0x1e,0x11,0x26,0x40,0x98,0x08,0xc2,0x44,0x12,0x26, /* $.......&@...D.& */ \
	0x48,0x98,0x68,0xc2,0x84,0x08,0x04,0x08,0x44,0x10,0x88,0x24,0x10,0x24,0x10,0x4d, /* H.h.....D..$.$.M */ \
	0x20,0x33,0x0f,0x73,0xdb,0x04,0x09,0x48,0x12,0x40,0x12,0xd0,0x66,0x5a,0x24,0x0e, /*  3.s...H.@..fZ$. */ \
	0x48,0x9c,0x20,0x71,0x92,0xc4,0x21,0x89,0xd3,0x24,0x8e,0x48,0x19,0x20,0x65,0x04, /* H. q..!..$.H. e. */ \
	0x29,0x23,0x49,0x19,0x24,0x65,0x34,0x29,0x43,0x24,0x05,0x48,0x8a,0x20,0x29,0x92, /* )#I.$e4)C$.H. ). */ \
	0xa4,0x20,0x49,0xd1,0x24,0x85,0x48,0x3d,0x20,0xf5,0x04,0xa9,0x27,0x49,0x3d,0x24, /* . I.$.H= ...'I=$ */ \
	0xf5,0x34,0xa9,0x47,0xa4,0x09,0x90,0x26,0x82,0x34,0x91,0xa4,0x09,0x92,0x26,0x9a, /* .4.G...&.4....&. */ \
	0x34,0x21,0x12,0x01,0x12,0x11,0x24,0x22,0x49,0x04,0x49,0x44,0x93,0xc8,0x2c,0x81, /* 4!....$"I.ID..,. */ \
	0x59,0x71,0x02,0x02,0x12,0x02,0x08,0x01,0x6d,0x56,0x04,0xe2,0x00,0xe2,0x04,0xc4, /* Yq......mV...... */ \
	0x49,0x88,0x43,0x88,0xd3,0x10,0x47,0x50,0x06,0xa0,0x8c,0x80,0x32,0x12,0xca,0x20, /* I.C...GP....2..  */ \
	0x94,0xd1,0x50,0x86,0x20,0x05,0x20,0x45,0x40,0x8a,0x84,0x14,0x84,0x14,0x0d,0x29, /* ..P. . E@......) */ \
	0x04,0xf5,0x00,0xea,0x09,0xa8,0x27,0xa1,0x1e,0x42,0x3d,0x0d,0xf5,0x08,0x9a,0x00, /* ......'..B=..... */ \
	0x34,0x11,0xd0,0x44,0x42,0x13,0x84,0x26,0x1a,0x9a,0x10,0x44,0x00,0x22,0x02,0x22, /* 4..DB..&...D."." */ \
	0x12,0x22,0x08,0x11,0x0d,0x91,0x59,0x7d,0xb3,0xd9,0x04,0x0d,0x48,0x1a,0x40,0x1a, /* ."....Y}....H.@. */ \
	0xd0,0x66,0x33,0x68,0x1c,0xd0,0x38,0x41,0xe3,0x24,0x8d,0x43,0x1a,0xa7,0x69,0x1c, /* .f3h..8A.$.C..i. */ \
	0xd1,0x32,0x40,0xcb,0x08,0x5a,0x46,0xd2,0x32,0x48,0xcb,0x68,0x5a,0x86,0x68,0x0a, /* .2@..ZF.2H.hZ.h. */ \
	0xd0,0x14,0x41,0x53,0x24,0x4d,0x41,0x9a,0xa2,0x69,0x0a,0xd1,0x7a,0x40,0xeb,0x09, /* ..AS$MA..i..z@.. */ \
	0x5a,0x4f,0xd2,0x7a,0x48,0xeb,0x69,0x5a,0x8f,0x68,0x13,0xa0,0x4d,0x04,0x6d,0x22, /* ZO.zH.iZ.h..M.m" */ \
	0x69,0x13,0xa4,0x4d,0x34,0x6d,0x42,0x34,0x02,0x34,0x22,0x68,0x44,0xd2,0x08,0xd2, /* i..M4mB4.4"hD... */ \
	0x88,0xa6,0x11,0xfa,0x67,0x10,0xcc,0x6e,0x98,0x25,0x31,0xf3,0x32,0x17,0xcd,0xa3, /* ....g..n.%1.2... */ \
	0x80,0x03,0x84,0x13,0x08,0x27,0x11,0x0e,0x11,0x4e,0x23,0x1c,0x21,0x19,0x40,0x32, /* .....'...N#.!.@2 */ \
	0x02,0xc9,0x48,0x24,0x83,0x48,0x46,0x23,0x19,0x42,0x14,0x40,0x14,0x81,0x28,0x12, /* ..H$.HF#.B.@..(. */ \
	0x51,0x10,0x51,0x34,0xa2,0x10,0xd2,0x03,0xa4,0x27,0x90,0x9e,0x44,0x7a,0x88,0xf4, /* Q.Q4.....'..Dz.. */ \
	0x34,0xd2,0x23,0x64,0x02,0xc8,0x44,0x20,0x13,0x89,0x4c,0x10,0x99,0x68,0x64,0xfa, /* 4.#d..D ..L..hd. */ \
	0x07,0xcc,0x3c,0x68,0x66,0xb7,0xcd,0x92,0x9b,0xfb,0xfe,0x3f,0xf0,0xff,0x0f,0x0e, /* ..<hf......?.... */ \
	0x02,0xaf,0xb8,0xae,0x71,0x06,0x5d,0x5f,0x39,0xc7,0xc1,0x6f,0xfb,0x88,0xa1,0x7d, /* ....q.]_9..o...} */ \
	0xa0,0x92,0xbf,0x64,0xed,0xf1,0xb8,0xee,0x93,0x43,0xb5,0x42,0x22,0x7b,0xd2,0x47, /* ...d.....C.B"{.G */ \
	0xdc,0xb4,0x26,0x54,0x3b,0x55,0xcc,0x33,0xa9,0x35,0x9d,0xc7,0xb4,0xec,0x93,0xb7, /* ..&T;U.3.5...... */ \
	0xa2,0x73,0x4e,0x04,0x66,0x62,0xd5,0x7d,0x4e,0xc5,0x82,0x47,0x62,0x8d,0xeb,0xbe, /* .sN.fb.}N..Gb... */ \
	0x67,0x93,0xd5,0xe2,0xa6,0xce,0x10,0xc5,0x61,0xd0,0x95,0x3a,0x5d,0x5a,0xb1,0xd8, /* g.......a..:]Z.. */ \
	0x7d,0xc1,0x83,0x50,0xbe,0x48,0xc2,0x0a,0x80,0x6c,0x57,0x85,0x88,0x65,0xe9,0xec, /* }..P.H...lW..e.. */ \
	0xb4,0xdb,0xaa,0xac,0xa6,0x40,0x32,0xbc,0x3a,0x8d,0x91,0x37,0x92,0x25,0x56,0x7d, /* .....@2.:..7.%V} */ \
	0x76,0xb7,0xc7,0xb5,0xd6,0xa9,0xcb,0x61,0xec,0x88,0x05,0x47,0x72,0x3f,0x92,0x4a, /* v......a...Gr?.J */ \
	0xdc,0xe4,0x10,0xaf,0x0c,0xc8,0x7b,0xa4,0x50,0x7b,0xc5,0x1e,0x61,0x65,0x05,0x7d, /* ......{.P{..ae.} */ \
	0x5a,0xc0,0x17,0x95,0x7a,0x1c,0x62,0x55,0x0f,0x19,0xdb,0x7d,0x55,0x76,0x09,0x96, /* Z...z.bU...}Uv.. */ \
	0x23,0x59,0x63,0x37,0x44,0x0e,0x3f,0x5c,0xd7,0x2c,0xf9,0x3a,0x40,0xa0,0xbf,0xe3, /* #Yc7D.?\.,.:@... */ \
	0x22,0x8a,0xc4,0xa9,0x8b,0x53,0x1d,0x9c,0x8f,0xa5,0x50,0xe1,0x9c,0xa3,0x8e,0x72, /* "....S....P....r */ \
	0x68,0x95,0x86,0x29,0xa6,0xe2,0xca,0xa3,0x62,0x6d,0x03,0x3e,0xe7,0xd6,0x70,0xd5, /* h..)....bm.>..p. */ \
	0xb1,0x77,0x79,0x46,0x55,0xc1,0xe4,0x16,0x86,0x5f,0xcf,0xdc,0x43,0xec,0x3f,0x7d, /* .wyFU...._..C.?} */ \
	0xdd,0x92,0x5f,0xeb,0x2d,0xac,0x25,0x75,0xd1,0x21,0x91,0xa7,0x6c,0x3b,0xd7,0x9f, /* .._.-.%u.!..l;.. */ \
	0x58,0xb9,0x6a,0x5d,0x91,0x18,0xbb,0x65,0xa9,0x55,0xd0,0x48,0x21,0xf2,0xad,0x17, /* X.j]...e.U.H!... */ \
	0x26,0xe8,0x32,0x74,0x6e,0xa1,0x64,0x36,0xf3,0x8b,0xb4,0x45,0x3a,0x18,0x14,0xbb, /* &.2tn.d6...E:... */ \
	0xfa,0xd7,0xb7,0xd7,0xa6,0x41,0xe9,0xd3,0xe3,0x03,0x76,0xb6,0x31,0x46,0xb9,0xd2, /* .....A....v.1F.. */ \
	0xe5,0x5b,0xd1,0x6f,0x75,0xde,0x50,0x54,0x55,0x97,0xcd,0xea,0x56,0xc5,0xdb,0x36, /* .[.ou.PTU...V..6 */ \
	0x85,0xce,0xa6,0xac,0x63,0xda,0x97,0x0f,0xe4,0xa6,0x55,0xb5,0x0f,0xdb,0x4c,0xed, /* ....c.....U...L. */ \
	0x76,0xe7,0x32,0xc3,0xd8,0xea,0x28,0xaf,0xb4,0xc1,0xc4,0xf9,0x87,0x7d,0x3e,0x99, /* v.2...(......}>. */ \
	0x37,0x66,0xd7,0xf6,0xbc,0xa3,0xc5,0x5e,0xac,0x77,0xbb,0xc7,0xd7,0x78,0x94,0xd7, /* 7f.....^.w...x.. */ \
	0xd5,0x5b,0xde,0x9e,0x8e,0xf5,0x9d,0x7c,0xda,0xa2,0xf2,0x7a,0xf2,0xcd,0xfc,0xf2, /* .[.....|...z.... */ \
	0xec,0x89,0x53,0x6e,0x51,0x4c,0x3b,0xff,0x96,0x81,0x92,0xb7,0xca,0x40,0x96,0xd7, /* ..SnQL;......@.. */ \
	0x82,0xe1,0x29,0x89,0xed,0xaa,0xce,0x2c,0xcf,0x35,0xf8,0xf8,0x79,0x3b,0x9f,0xd8, /* ..)....,.5..y;.. */ \
	0x4d,0xe0,0x1a,0x16,0x7b,0x65,0x4e,0xe5,0x32,0x7a,0xfc,0xa7,0xea,0xfa,0xd1,0xd0, /* M...{eN.2z...... */ \
	0x63,0xa3,0x47,0x2c,0x92,0x38,0x0e,0x41,0xef,0xdb,0x2b,0x35,0x81,0x13,0x3e,0x51, /* c.G,.8.A..+5..>Q */ \
	0xd2,0x8f,0xf5,0xab,0x7a,0xbe,0xf5,0x2a,0xfa,0xba,0xf0,0xf1,0x09,0xe7,0xa7,0x1d, /* ....z........... */ \
	0x9b,0x7d,0xde,0x28,0x99,0x96,0x96,0x4c,0xa6,0xdc,0xd2,0x35,0x57,0xf4,0x5b,0x7c, /* .}.(...L...5W.[| */ \
	0xbd,0x66,0xcb,0xab,0xba,0x95,0xa3,0xc5,0xbf,0xc6,0x36,0x33,0xdd,0x54,0x9a,0xad, /* .f........63.T.. */ \
	0x6d,0xce,0x9f,0xf1,0x7c,0xbc,0xed,0x07,0x44,0x3a,0xdb,0xbe,0xb9,0x61,0xaf,0xeb, /* m...|...D:...a.. */ \
	0x39,0x9b,0xa3,0x35,0xb5,0x7e,0x0d,0x74,0x69,0xbe,0x08,0x65,0xf9,0x7a,0x7d,0x9a, /* 9..5.~.ti..e.z}. */ \
	0x58,0xe2,0x1c,0x91,0x5d,0xd5,0x30,0x2f,0xd2,0xe3,0x8d,0xd8,0x2f,0x22,0x34,0xb1, /* X...].0/..../"4. */ \
	0x58,0x1d,0x98,0x55,0x57,0x8a,0x39,0xef,0x3e,0x2d,0x7f,0x2f,0x52,0xbb,0xa5,0x85, /* X..UW.9.>-./R... */ \
	0x1f,0x90,0xef,0xc3,0xfe,0xbc,0x69,0xbb,0x69,0xf8,0xce,0x0e,0x8b,0xf6,0xf6,0xc7, /* ......i.i....... */ \
	0x91,0x1e,0x9d,0xa7,0xb8,0xce,0x69,0x8e,0x95,0x6a,0x97,0xb4,0x1c,0x3c,0x29,0x6e, /* ......i..j...<)n */ \
	0xa6,0x82,0xb9,0xc4,0x55,0x2a,0xec,0x66,0xbb,0xee,0x17,0x3d,0x3c,0x7d,0x86,0xbb, /* ....U..f...=<}.. */ \
	0xed,0x15,0x77,0x35,0x9c,0x48,0xca,0xac,0x62,0x14,0x6e,0xe3,0x7b,0x32,0x5c,0x45, /* ..w5.H..b.n.{2\E */ \
	0x39,0x6d,0x94,0x67,0x13,0x37,0x59,0xba,0x7c,0x7f,0x14,0xef,0x27,0xdb,0x53,0x76, /* 9m.g.7Y.|...'.Sv */ \
	0xb9,0x56,0x99,0xee,0x03,0x67,0x97,0x75,0xdd,0x90,0x00,0x4e,0x90,0xa9,0x69,0x13, /* .V...g.u...N..i. */ \
	0x43,0x4c,0xf2,0x6d,0x19,0x89,0xd2,0xc4,0x40,0x82,0x2d,0x52,0xad,0x5b,0xb0,0x44, /* CL.m....@.-R.[.D */ \
	0x12,0x90,0xc1,0x90,0x3e,0x78,0x27,0x5a,0x55,0x13,0x5d,0x67,0x1f,0x23,0xee,0x5b, /* ....>x'ZU.]g.#.[ */ \
	0xb6,0x6b,0xd4,0x27,0xfd,0xa1,0xf8,0x93,0x0f,0x23,0xc7,0xc4,0xad,0x57,0xda,0xe9, /* .k.'.....#...W.. */ \
	0xfa,0x5d,0xb6,0x41,0x18,0xb0,0x14,0xba,0x4a,0x78,0x0f,0x9c,0x1f,0x61,0x20,0x4c, /* .].A....Jx...a L */ \
	0xfc,0x01,0x05,0x42,0x3c,0x44,0x51,0xfd,0x0c,0xf1,0xd6,0x89,0x8d,0xbe,0x6e,0xca, /* ...B<DQ.......n. */ \
	0x01,0x35,0xe6,0xfb,0x30,0x0a,0x80,0xa0,0xe6,0xa8,0x73,0xe9,0x41,0x94,0x82,0xb7, /* .5..0.....s.A... */ \
	0xcd,0x5a,0x19,0x2b,0xd7,0x38,0x3b,0x8e,0x6d,0xf4,0xce,0x16,0x50,0x20,0xd7,0x4e, /* .Z.+.8;.m...P .N */ \
	0x09,0x6e,0xb9,0x13,0xe8,0x3c,0xd7,0x67,0xd6,0x39,0xbb,0xd2,0xbe,0xc8,0x51,0x7e, /* .n...<.g.9....Q~ */ \
	0xcd,0xe5,0x40,0x69,0x99,0xd4,0xb7,0xbf,0xa9,0x2c,0xbe,0xac,0xb5,0xf8,0x57,0xc1, /* ..@i.....,....W. */ \
	0xc2,0xfc,0x9c,0x37,0x12,0x23,0x66,0xad,0x0b,0x8c,0x64,0x35,0xad,0x12,0x47,0xf8, /* ...7.#f...d5..G. */ \
	0x1f,0x58,0x38,0xe6,0xc1,0x09,0xb9,0xb2,0xa1,0x6a,0x47,0xe5,0x57,0x91,0xa0,0xcb, /* .X8......jG.W... */ \
	0xfa,0x14,0x6f,0xc4,0xd2,0x63,0x6a,0x64,0xf5,0xdf,0xfd,0x0d,0xe5,0x80,0xd1,0xd6, /* ..o..cjd........ */ \
	0x16,0x2b,0xe7,0xf8,0x9c,0x92,0x56,0xed,0xce,0x29,0x89,0xba,0x6b,0xf1,0x94,0x88, /* .+....V..)..k... */ \
	0x07,0xfe,0xa1,0x2b,0xec,0x83,0xda,0x8c,0x8c,0xca,0xc0,0x76,0xf6,0x9d,0xbc,0xcb, /* ...+.......v.... */ \
	0xb9,0x8d,0x1b,0xbb,0x1e,0x9e,0xb8,0x12,0xb1,0xfb,0x5b,0xf8,0xe2,0x6f,0x6a,0x04, /* ..........[..oj. */ \
	0xb2,0x27,0x83,0x22,0xf2,0x07,0x17,0x51,0x2c,0x8e,0xfd,0x80,0xa3,0x27,0xdb,0x77, /* .'."...Q,....'.w */ \
	0xdf,0x9c,0x95,0xe2,0xe6,0xe0,0x3c,0xe6,0xdc,0x82,0x47,0xd8,0xb0,0xb7,0xc3,0xef, /* ......<...G..... */ \
	0x17,0x81,0xd4,0xfb,0xf7,0xa2,0xbb,0x3b,0xbe,0xb3,0xb4,0x15,0xf0,0x0d,0x42,0x8f, /* .......;......B. */ \
	0x8c,0x3c,0x46,0x68,0xc3,0x3a,0xc5,0x82,0x0b,0x83,0xcf,0x97,0x5a,0x1e,0xfa,0xcd, /* .<Fh.:......Z... */ \
	0xc5,0xe7,0xb9,0x71,0x7e,0x82,0xb0,0x8f,0xdc,0x4f,0x0d,0x08,0xfa,0xff,0xe8,0x19, /* ...q~....O...... */ \
	0x5e,0x35,0x6e,0x13,0x3e,0x30,0xd8,0xd9,0xeb,0x5e,0xde,0x6a,0xa3,0x14,0x70,0xee, /* ^5n.>0...^.j..p. */ \
	0x1c,0x8f,0x48,0x03,0x80,0xb9,0xf9,0x27,0x51,0x3b,0x1e,0x67,0x0b,0x66,0xfb,0x4b, /* ..H....'Q;.g.f.K */ \
	0x4f,0x47,0xa4,0x77,0xfe,0x58,0xc9,0xd3,0x96,0xb1,0xca,0xa2,0x87,0x7c,0xed,0x27, /* OG.w.X.......|.' */ \
	0x2b,0x9d,0x91,0xa2,0xf5,0xea,0x77,0x09,0x4b,0xd3,0x57,0xb9,0x6e,0xae,0x9a,0x98, /* +.....w.K.W.n... */ \
	0xe8,0x0a,0x02,0x0a,0xd1,0x47,0x0d,0x7d,0xaf,0x3d,0x98,0x36,0xd6,0xce,0x0c,0xc7, /* .....G.}.=.6.... */ \
	0xf6,0x62,0x96,0x03,0xef,0x1a,0x63,0x85,0xeb,0x60,0xd2,0x98,0x31,0xba,0xe8,0x5c, /* .b....c..`..1..\ */ \
	0x07,0x2f,0x7c,0x2a,0x83,0x27,0x64,0xfd,0xfb,0x66,0xe7,0xeb,0x79,0x6c,0xd7,0xd4, /* ./|..'d..f..yl.. */ \
	0x95,0xcc,0x3b,0xb2,0x88,0x2d,0x9d,0x2b,0x9b,0x45,0x67,0xf7,0xa7,0x85,0x02,0x81, /* ..;..-.+.Eg..... */ \
	0x4d,0x60,0x1d,0xe5,0x66,0x4c,0x67,0x96,0xee,0xf8,0x59,0x70,0xae,0x8d,0x95,0xc5, /* M`..fLg...Yp.... */ \
	0x75,0x60,0x85,0x82,0xab,0x87,0x53,0xfb,0x33,0x94,0x71,0xa5,0x3e,0x6d,0x6b,0x2b, /* u`....S.3.q.>mk+ */ \
	0x98,0xd8,0x68,0xf5,0x4c,0xba,0x70,0x8f,0x6f,0x6c,0xca,0xb2,0xd3,0x7d,0xaa,0xa7, /* ..h.L.p.ol...}.. */ \
	0xe5,0xc2,0xaf,0x66,0x95,0xde,0x86,0x27,0xaa,0x35,0xb2,0x51,0x06,0x90,0x18,0xaf, /* ...f...'.5.Q.... */ \
	0x07,0x67,0x7e,0x89,0x7d,0x98,0xb7,0x38,0x0d,0x50,0x0c,0x97,0xd2,0xee,0xde,0x5f, /* .g~.}..8.P....._ */ \
	0x96,0xa8,0xd8,0x77,0xef,0xd9,0x6c,0x7c,0x75,0xb9,0xd3,0x75,0x0a,0x3b,0xd1,0x36, /* ...w..l|u..u.;.6 */ \
	0xcd,0xd0,0x3c,0xf0,0x1f,0xe2,0x88,0xaa,0x79,0xa3,0xd1,0xc3,0xb7,0x7f,0x33,0x50, /* ..<.....y.....3P */ \
	0xbe,0x1d,0xcc,0x04,0xdf,0x07,0x92,0x12,0x5f,0x0c,0x5b,0xf8,0x0e,0x20,0x22,0x3e, /* ........_.[.. "> */ \
	0xe5,0x19,0x64,0xf6,0xf2,0xac,0x7e,0x66,0x11,0x98,0xbc,0xfc,0xc3,0xe3,0xa1,0xdd, /* ..d...~f........ */ \
	0x82,0x28,0x61,0xa3,0x26,0x3a,0x50,0x19,0x30,0xec,0x7c,0x90,0x59,0xb3,0x7e,0x94, /* .(a.&:P.0.|.Y.~. */ \
	0xed,0x3a,0x29,0xe6,0xe6,0xb6,0xcb,0x13,0xdc,0xb4,0x7d,0x62,0x2b,0x01,0xaa,0xa9, /* .:).......}b+... */ \
	0x8d,0xf9,0xc5,0x41,0x98,0x5c,0x1e,0xf1,0xbc,0x88,0xba,0xed,0x5b,0x5e,0xfa,0xf1, /* ...A.\......[^.. */ \
	0x9b,0x41,0x2b,0xc7,0x83,0xac,0x2b,0x17,0xf2,0x35,0x44,0xef,0xe4,0x17,0x53,0x13, /* .A+...+..5D...S. */ \
	0x4d,0xf1,0xa1,0xd1,0x4e,0x2b,0x8e,0x33,0xe2,0xef,0x17,0x95,0x4b,0xd6,0xc6,0x1c, /* M...N+.3....K... */ \
	0x61,0xc6,0x63,0x23,0x87,0x53,0xd5,0x75,0x43,0x54,0xa1,0x25,0xf0,0x8d,0x69,0x0a, /* a.c#.S.uCT.%..i. */ \
	0xe0,0xc9,0x4f,0x4f,0xdb,0x64,0x77,0xdf,0x9d,0x0f,0x27,0x96,0xcb,0x33,0x98,0x0e, /* ..OO.dw...'..3.. */ \
	0x03,0x23,0x4a,0x8f,0xc0,0xe9,0xba,0xe7,0x1e,0x55,0xbb,0x58,0x77,0x6d,0x5e,0x04, /* .#J......U.Xwm^. */ \
	0x75,0x06,0x4c,0x06,0x7c,0xfa,0xd1,0x9b,0x3d,0x56,0xeb,0x23,0x95,0xe5,0x49,0xb9, /* u.L.|...=V.#..I. */ \
	0x9e,0xa0,0xe5,0x46,0x65,0x60,0x50,0x41,0xc0,0xed,0x3f,0xf9,0x8c,0x10,0x30,0xf4, /* ...Fe`PA..?...0. */ \
	0xc2,0x55,0xa7,0x0d,0x09,0x1a,0x8a,0xca,0x8f,0xe6,0xad,0xfd,0xb9,0x97,0xff,0xf2, /* .U.............. */ \
	0x97,0x7d,0x07,0xbe,0x28,0xe4,0x5e,0x95,0x58,0xd5,0x5f,0xad,0x9b,0xce,0xd4,0xaa, /* .}..(.^.X._..... */ \
	0xad,0x92,0x4b,0x5a,0xed,0xe3,0x7f,0x8f,0x14,0x1e,0x13,0xcf,0xe3,0x1b,0x33,0xd8, /* ..KZ..........3. */ \
	0xa1,0x7c,0xd6,0xe2,0xfe,0x19,0x0b,0x2f,0x36,0x5e,0x17,0x23,0x2d,0xfb,0x38,0xcd, /* .|...../6^.#-.8. */ \
	0xb1,0x23,0x5b,0x31,0x15,0xbb,0x2a,0xfc,0x76,0x3d,0x57,0xf3,0x3f,0xac,0xd5,0x0b, /* .#[1....v=W.?... */ \
	0xca,0xc1,0xca,0x54,0xd1,0xf4,0x8f,0x8f,0x5d,0xbf,0x51,0xb9,0xf4,0x4b,0x97,0xe6, /* ...T....].Q..K.. */ \
	0x67,0x3d,0x6f,0xbf,0xc7,0x9c,0x38,0x3f,0x16,0xfb,0x4d,0x5e,0xdf,0x0f,0xd7,0x7e, /* g=o...8?..M^...~ */ \
	0x14,0x88,0x47,0x94,0x33,0x0f,0x73,0x53,0x3f,0x70,0xd9,0xf1,0xaa,0x81,0xcb,0x44, /* ..G.3.sS?p.....D */ \
	0x8b,0x24,0x07,0x85,0x09,0x53,0x11,0x5f,0x78,0xcd,0xfb,0x23,0x53,0x29,0x7c,0x3a, /* .$...S._x..#S)|: */ \
	0x18,0xbd,0x74,0x6f,0x8d,0x76,0xa0,0xa4,0x67,0x7e,0xf8,0xc2,0xd8,0x70,0xef,0x6e, /* ..to.v..g~...p.n */ \
	0xce,0x27,0x5e,0x3e,0x0e,0xb7,0xcb,0xdd,0x03,0x22,0x4c,0x67,0x9e,0xf5,0xff,0x04, /* .'^>....."Lg.... */ \
	0x52,0x3b,0xb8,0xc9,0xc3,0xdf,0x37,0x7d,0xf9,0x66,0x16,0xcb,0xe3,0x09,0x87,0x41, /* R;....7}.f.....A */ \
	0x18,0x7f,0x0d,0x99,0xf0,0xf9,0xc2,0x7d,0x3b,0x92,0xc5,0x73,0xcd,0xf2,0xce,0xe8, /* .......};..s.... */ \
	0xd6,0x1c,0x69,0x9c,0x33,0x7b,0x82,0x7a,0x65,0xdb,0xb3,0x56,0x2b,0x92,0x02,0xf6, /* ..i.3{.ze..V+... */ \
	0xbf,0x8e,0x5e,0x5c,0x04,0x2c,0x2f,0x6e,0xc2,0x92,0x9d,0x35,0x0d,0x19,0x33,0x85, /* ..^\.,/n...5..3. */ \
	0x82,0x15,0x8f,0x87,0xc4,0x25,0x7d,0xb5,0xf1,0x41,0xc5,0x86,0x63,0xbd,0xca,0xf5, /* .....%}..A..c... */ \
	0x8b,0x8f,0xd7,0x0d,0x1e,0x2e,0x13,0xc9,0xf9,0x0d,0x37,0x6f,0x86,0xf3,0xd5,0xcb, /* ..........7o.... */ \
	0x15,0xc9,0x8e,0xab,0x8c,0xaf,0xc1,0x1f,0xc3,0xaa,0x61,0xdd,0x85,0x2f,0xcf,0xe4, /* ..........a../.. */ \
	0x7c,0x7f,0x3f,0xb8,0xfb,0xd0,0x14,0xa5,0xf2,0x48,0xc2,0x98,0xae,0x25,0x03,0x65, /* |.?......H...%.e */ \
	0xab,0x33,0x42,0xc2,0x44,0x8e,0xce,0x76,0x89,0x57,0x53,0x82,0x3d,0x19,0x2d,0xa3, /* .3B.D..v.WS.=.-. */ \
	0xb9,0x9e,0x96,0x91,0xc1,0x7f,0x67,0x67,0x08,0x1b,0xaa,0xd8,0x3b,0x97,0xb8,0x71, /* ......gg....;..q */ \
	0x63,0x33,0xd2,0x16,0x84,0x7f,0x15,0xe3,0xe2,0xde,0x57,0x1b,0xfb,0x3c,0xc8,0x30, /* c3........W..<.0 */ \
	0x91,0xc0,0x2f,0x8f,0x2c,0x04,0x29,0x3f,0x04,0x60,0xfd,0x69,0x5b,0x6d,0x55,0x7d, /* ../.,.)?.`.i[mU} */ \
	0x82,0x16,0xdd,0x26,0xad,0x4e,0x91,0x5f,0x75,0xa8,0x40,0x3d,0xcb,0x95,0x22,0x91, /* ...&.N._u.@=..". */ \
	0x4e,0x94,0x72,0x1e,0xcb,0x39,0x0f,0x8a,0x63,0x1c,0xfc,0x43,0xc1,0x12,0xd7,0xb4, /* N.r..9..c..C.... */ \
	0x9d,0xe0,0xe5,0x12,0x1b,0x69,0xc0,0x48,0x9f,0xf8,0x76,0xe3,0x62,0x57,0x89,0x96, /* .....i.H..v.bW.. */ \
	0xc5,0x1d,0x7a,0xac,0x86,0xf6,0x76,0x09,0x69,0x82,0x86,0xe2,0xc2,0x70,0x4f,0xfb, /* ..z...v.i....pO. */ \
	0xea,0x9d,0xc7,0x19,0x7d,0x9c,0x71,0xe5,0x8a,0xe2,0x06,0x6e,0x51,0xc9,0x83,0x7d, /* ....}.q....nQ..} */ \
	0xdd,0x1e,0x86,0x88,0xbc,0x11,0xf9,0x82,0xeb,0xf3,0xf6,0x70,0xde,0x76,0x18,0x26, /* ...........p.v.& */ \
	0xb7,0xbb,0xaa,0x2d,0xa8,0x36,0x66,0x44,0xba,0xed,0xb3,0x27,0xd3,0x37,0x3a,0x5f, /* ...-.6fD...'.7:_ */ \
	0xa4,0x86,0xad,0x57,0xbd,0x5b,0xee,0xa3,0x9e,0x9d,0x8b,0x15,0x5d,0x86,0x4b,0x23, /* ...W.[......].K# */ \
	0x26,0x8d,0x46,0x29,0x95,0x33,0xf2,0x56,0x88,0x25,0x6f,0xaa,0xb1,0x7f,0xdc,0x49, /* &.F).3.V.%o....I */ \
	0x08,0x2e,0xc7,0xfd,0xea,0x71,0x86,0x9e,0x2c,0xb4,0x1a,0x58,0xff,0xf4,0xd6,0xf8, /* .....q..,..X.... */ \
	0x8a,0x4c,0x61,0x96,0x32,0x2e,0xd2,0x2f,0x94,0x1b,0x93,0x39,0xd4,0x58,0xfe,0xae, /* .La.2../...9.X.. */ \
	0x17,0x15,0x75,0xb5,0xcf,0x2b,0x21,0xb0,0xa5,0x31,0x93,0x77,0xcc,0xc2,0x22,0x20, /* ..u..+!..1.w.."  */ \
	0xff,0xc7,0x07,0xe1,0xb4,0x81,0xef,0x31,0xbe,0xf9,0xde,0x8e,0xdb,0xd2,0x3b,0x5e, /* .......1......;^ */ \
	0xef,0x1d,0xb0,0x99,0x60,0xcc,0x06,0x3e,0x7d,0xfe,0x7c,0xf3,0xe1,0x97,0xea,0x1b, /* ....`..>}.|..... */ \
	0x4e,0x97,0x1e,0xed,0x68,0xb6,0xde,0x1d,0xef,0x13,0x32,0x7a,0x60,0x39,0xd7,0x4b, /* N...h.....2z`9.K */ \
	0xfb,0x41,0xc7,0xfb,0xbf,0x78,0x5d,0xc6,0xa6,0x7d,0x2a,0x32,0xda,0xb4,0xad,0x57, /* .A...x]..}.2...W */ \
	0x94,0xc2,0x6f,0x39,0x47,0xab,0x4a,0xd8,0x4e,0x2e,0x2f,0xcb,0x79,0x83,0x88,0x7d, /* ..o9G.J.N./.y..} */ \
	0xcf,0x46,0xb7,0x96,0x9f,0xc6,0x27,0xf3,0x63,0xf3,0x6e,0xda,0xf6,0x08,0x16,0xfd, /* .F....'.c.n..... */ \
	0xfd,0xd8,0x70,0xc5,0xe0,0xc2,0x3a,0xbe,0xf3,0x83,0xaf,0xdf,0xb3,0x8a,0x16,0x24, /* ..p...:........$ */ \
	0xa7,0xaf,0x3d,0xdf,0xdf,0x12,0x90,0xb4,0xc7,0xc3,0x69,0xa9,0xa7,0xea,0x66,0x73, /* ..=.......i...fs */ \
	0x41,0x6e,0x4b,0x23,0x14,0x5a,0x1e,0x19,0x14,0xc7,0xb5,0xf3,0x1c,0xf6,0x86,0xb9, /* AnK#.Z.......... */ \
	0x79,0x0c,0x8f,0xde,0xe2,0xdf,0xf7,0x1d,0x39,0xa3,0xdb,0x53,0x2f,0xbf,0x24,0x59, /* y.......9..S/.$Y */ \
	0xf6,0x8a,0x2c,0x35,0x32,0x2e,0x97,0x47,0x5f,0xda,0x98,0xa9,0xb9,0x7f,0x28,0xf1, /* ..,52..G_.....(. */ \
	0xbc,0x6f,0xf6,0xec,0xde,0x77,0x2c,0xc4,0x77,0x4b,0x67,0x5c,0x6e,0x5f,0x3a,0x13, /* .o...w,.wKg\n_:. */ \
	0x62,0x2b,0x8d,0xab,0x8b,0x79,0xc9,0x76,0x0c,0xfe,0xeb,0x77,0x89,0x8a,0x51,0x53, /* b+...y.v...w..QS */ \
	0x34,0xe9,0xd8,0x37,0x60,0x8c,0xfe,0x77,0xd1,0x77,0x49,0x3b,0x17,0xf6,0x78,0x96, /* 4..7`..w.wI;..x. */ \
	0xc7,0x16,0x54,0xdc,0xba,0x88,0x97,0xf9,0xe5,0x9f,0x1f,0xf9,0xf0,0x47,0x5e,0xc9, /* ..T..........G^. */ \
	0x15,0xcf,0xf0,0xeb,0xdc,0x54,0x63,0x61,0xca,0xf0,0x66,0x35,0x2b,0x74,0xf2,0x91, /* .....Tca..f5+t.. */ \
	0xc3,0x98,0xfa,0x89,0xa9,0x45,0xb5,0x66,0x97,0x97,0x72,0x0b,0x6f,0x65,0x5c,0x60, /* .....E.f..r.oe\` */ \
	0xf8,0xb5,0xe7,0xf5,0xfc,0x8e,0xe9,0xe0,0x6f,0xa2,0xcb,0x97,0xdc,0xe0,0xc8,0x3d, /* ........o......= */ \
	0xee,0x3f,0x61,0xc1,0x88,0xbb,0xd1,0xc1,0xdb,0x34,0xca,0x11,0xca,0xea,0xee,0xbd, /* .?a......4...... */ \
	0xdc,0x64,0x7f,0x2a,0xfc,0x81,0xc4,0x4f,0xea,0xe7,0x74,0xd2,0x42,0x70,0xf2,0xfd, /* .d.....O..t.Bp.. */ \
	0x6e,0xe9,0xba,0xc1,0x73,0xb9,0x80,0x54,0xb0,0xe6,0xb6,0xd7,0xf9,0x9e,0x59,0x3a, /* n...s..T......Y: */ \
	0x82,0xec,0xb6,0x9f,0xe0,0xa3,0xf5,0xef,0x8b,0x9a,0x63,0x42,0xd7,0xf0,0xf7,0x8d, /* ..........cB.... */ \
	0x13,0xb7,0xdc,0x79,0x1a,0xe1,0x99,0x97,0x31,0x43,0x2f,0x6d,0x57,0x0c,0x7d,0x34, /* ...y....1C/mW.}4 */ \
	0x5e,0xb8,0x8f,0x96,0x67,0x6d,0xfb,0xe1,0xf0,0x05,0x91,0x94,0xf1,0x6e,0x9b,0xd1, /* ^...gm.......n.. */ \
	0x31,0x6c,0x90,0x13,0xef,0x10,0xcc,0xbe,0x15,0x0c,0x13,0xb7,0x66,0x12,0xcb,0x5d, /* 1l..........f..] */ \
	0x3a,0xe2,0x3a,0x4e,0xda,0xad,0xd6,0x85,0x19,0x5b,0x85,0x35,0x85,0xfc,0xf6,0xd4, /* :.:N.....[.5.... */ \
	0x60,0xd8,0xce,0x7b,0xa1,0xe3,0xbe,0x98,0x70,0x3f,0x3f,0xc0,0x1f,0x93,0x70,0x1b, /* `..{....p??...p. */ \
	0x5f,0xcd,0x83,0x6a,0x41,0xd7,0x67,0xd8,0x15,0x95,0xa0,0xea,0x86,0x7f,0x47,0x60, /* _..jA.g.......G` */ \
	0x99,0x56,0x47,0x78,0x47,0x04,0xe8,0x0c,0x1f,0x41,0x77,0x87,0xb3,0x41,0x4e,0x57, /* .VGxG....Aw..ANW */ \
	0x0b,0x58,0x35,0x83,0x9c,0x41,0x63,0xbe,0xd7,0x74,0x8a,0x35,0xc3,0xaa,0x71,0x2a, /* .X5..Ac..t.5..q. */ \
	0x73,0x50,0x57,0x76,0xaa,0x51,0xe9,0x32,0x63,0x7f,0xa5,0x53,0xb9,0xfe,0xb5,0x32, /* sPWv.Q.2c..S...2 */ \
	0x51,0x58,0xb1,0x31,0xb4,0x62,0xd3,0x96,0x8a,0xcd,0xc5,0x15,0x5b,0x34,0x15,0xdb, /* QX.1.b......[4.. */ \
	0x7a,0x2b,0xb6,0xdf,0xa9,0xd8,0xf9,0xba,0x22,0x55,0xa8,0x4a,0x0b,0x55,0x65,0x6c, /* z+......"U.J.Uel */ \
	0x51,0x91,0xc5,0xaa,0x2c,0x8d,0x2a,0xbb,0x57,0xb5,0x7d,0xcb,0x47,0x39,0x55,0x4e, /* Q...,...W.}.G9UN */ \
	0x3a,0x35,0xf7,0xbf,0x17,0x37,0xcc,0x4f,0xda,0x6f,0xd5,0xc0,0xd3,0x4e,0xbd,0x03, /* :5...7.O.o...N.. */ \
	0xf9,0xc2,0xb3,0x21,0x5c,0xed,0x54,0xe6,0xbc,0xee,0xca,0x46,0xc5,0x86,0x05,0x2a, /* ...!\.T....F.... */ \
	0xd7,0xc4,0x27,0x2a,0xe7,0x6e,0xea,0x6c,0x13,0xb7,0xfe,0x3d,0xfb,0x10,0x24,0xd9, /* ..'..n.l...=..$. */ \
	0x6c,0x51,0x20,0xee,0x77,0xc7,0x70,0x3e,0x76,0xbf,0x80,0xff,0x86,0x8f,0x85,0x88, /* lQ .w.p>v....... */ \
	0xb9,0xed,0x95,0x55,0xf0,0x1c,0x7f,0xd4,0xfc,0x63,0x12,0xb1,0x70,0x05,0x2b,0xa1, /* ...U.....c..p.+. */ \
	0x97,0xef,0xd5,0x54,0xc3,0x2a,0xc5,0x46,0x0e,0xcc,0x37,0xaf,0xed,0x83,0xc0,0x2a, /* ...T...F..7..... */ \
	0xd1,0x9b,0xcb,0x8c,0x08,0x3e,0xcf,0x59,0x37,0xc6,0xda,0x0f,0x45,0x7e,0x97,0xe3, /* .....>.Y7...E~.. */ \
	0x78,0x0b,0x3a,0x79,0xeb,0xff,0x98,0x77,0xae,0x49,0x90,0xf8,0x9e,0xe7,0x31,0x35, /* x.:y...w.I....15 */ \
	0xf7,0x54,0xb9,0xc3,0x18,0xa8,0xed,0xfa,0x92,0x39,0xbe,0xb7,0xee,0x2b,0x0c,0xa4, /* .T.......9...+.. */ \
	0xf0,0xd7,0xc9,0x75,0xdc,0xf9,0x17,0xec,0x96,0xef,0x5d,0xf7,0xf6,0x14,0x2f,0xb1, /* ...u......].../. */ \
	0x5d,0x90,0xf8,0xfd,0x1e,0x69,0x50,0x42,0xa0,0x08,0xdb,0x7f,0x53,0xf0,0xaf,0xde, /* ]....iPB....S... */ \
	0x0d,0x7b,0xce,0x6d,0x38,0x61,0xa8,0x5d,0x16,0x95,0x32,0xd6,0x93,0xcc,0x2c,0xa8, /* .{.m8a.]..2...,. */ \
	0x3f,0x3d,0x2d,0xf8,0xd6,0xa7,0xd2,0x2b,0x94,0x37,0x21,0xc6,0x70,0x4a,0xa8,0xee, /* ?=-....+.7!.pJ.. */ \
	0xb5,0x87,0x80,0xa5,0x33,0x72,0xe4,0x0c,0xb0,0xb5,0x9b,0x79,0x2e,0x3a,0xc5,0xfa, /* ....3r.....y.:.. */ \
	0xa1,0xff,0x76,0x79,0xf5,0x53,0x47,0xc0,0x33,0xd4,0x86,0x00,0x16,0x03,0xec,0x37, /* ..vy.SG.3......7 */ \
	0x2f,0xb3,0xde,0x3d,0x7b,0xd3,0x81,0x03,0xbc,0x90,0x38,0xc6,0x01,0x72,0x7e,0xba, /* /..={.....8..r~. */ \
	0xda,0xbb,0xc6,0x7b,0x5f,0x10,0x92,0x35,0xa4,0x4c,0x00,0x26,0x03,0x64,0x96,0xfa, /* ...{_..5.L.&.d.. */ \
	0x4f,0xf0,0x59,0x01,0x53,0x75,0x0f,0x30,0xb0,0x70,0x39,0x17,0x4f,0x65,0xd5,0x8b, /* O.Y.Su.0.p9.Oe.. */ \
	0xf9,0x29,0x28,0x29,0xfa,0x0d,0x7f,0x1d,0xa6,0x2e,0x49,0x08,0x08,0x78,0xd6,0xa3, /* .)()......I..x.. */ \
	0xde,0x95,0x58,0x23,0xab,0xc4,0x52,0xf8,0xfe,0x27,0x40,0x30,0x83,0x8f,0xbd,0x15, /* ..X#..R..'@0.... */ \
	0x71,0x71,0xdd,0xb6,0xcc,0xf4,0xa4,0xbc,0xce,0xe4,0xd0,0x89,0xc6,0x27,0xad,0x55, /* qq...........'.U */ \
	0xb8,0x8e,0xa7,0x8d,0xe3,0x65,0x01,0x30,0xa6,0xc0,0x18,0xc0,0xdb,0x2f,0xcc,0x95, /* .....e.0...../.. */ \
	0xb3,0x5b,0x80,0x51,0xce,0x62,0xe3,0xce,0x41,0x05,0x36,0x36,0xd5,0xc8,0x2c,0xc2, /* .[.Q.b..A.66..,. */ \
	0xee,0x70,0x58,0x97,0x59,0x91,0xde,0x9f,0x36,0xbb,0x11,0x09,0x96,0x3a,0xe6,0xd1, /* .pX.Y...6....:.. */ \
	0x19,0x41,0x80,0x88,0x9b,0xd2,0xe0,0x3c,0x1e,0xc7,0x03,0x86,0x45,0x3b,0x7d,0x35, /* .A.....<....E;}5 */ \
	0x0b,0xf7,0x63,0x5d,0xa5,0xd8,0xa0,0x82,0x25,0xd7,0x09,0xeb,0x2f,0xd9,0x5d,0x2d, /* ..c]....%.../.]- */ \
	0x0c,0x1a,0xbf,0xd9,0x12,0xd7,0xc3,0x14,0x29,0x59,0x5b,0xbb,0xb6,0x1d,0x03,0x36, /* ........)Y[....6 */ \
	0xe5,0x97,0xea,0x32,0xc8,0x86,0xfa,0x39,0xac,0xf6,0xee,0xa2,0x14,0x83,0xdd,0x51, /* ...2...9.......Q */ \
	0x1f,0x0d,0x56,0xc8,0xda,0x6a,0xcf,0x3a,0xcd,0x90,0x9e,0xcd,0x4a,0x3a,0xd4,0xdd, /* ..V..j.:....J:.. */ \
	0xf4,0xc5,0x4c,0x5d,0xba,0x01,0xdf,0x19,0x7f,0xac,0x7f,0xa6,0xb1,0x33,0xab,0x7a, /* ..L].........3.z */ \
	0x99,0x3d,0x16,0x6e,0xf1,0x2e,0x33,0x62,0x83,0x58,0x1d,0x34,0x5e,0x1c,0x7e,0x73, /* .=.n..3b.X.4^.~s */ \
	0x44,0x0b,0x8d,0xe0,0x7e,0x59,0x01,0x33,0x82,0x2b,0x57,0x37,0x5b,0x73,0xbc,0xe5, /* D...~Y.3.+W7[s.. */ \
	0xea,0x86,0xf6,0x5d,0xe9,0x21,0x22,0x2c,0xcb,0x20,0xae,0xe7,0x63,0xce,0x61,0xd8, /* ...].!",. ..c.a. */ \
	0xc1,0x1b,0x2d,0xe3,0x1b,0x1b,0x56,0xa2,0xd3,0x75,0x36,0x80,0xcc,0x9b,0x10,0xa4, /* ..-...V..u6..... */ \
	0x29,0xea,0x07,0xa9,0x8f,0xfd,0xba,0x78,0xf2,0x4b,0x76,0x20,0xd5,0x49,0xae,0xd8, /* )......x.Kv .I.. */ \
	0x00,0x74,0xcc,0x83,0xdd,0x76,0xe9,0x22,0x6e,0x9a,0x68,0xbe,0xb5,0xd0,0x2a,0xd5, /* .t...v."n.h..... */ \
	0x8d,0x1f,0x32,0x85,0x21,0x8e,0xc3,0x8e,0xa7,0x0d,0xbb,0x4a,0xb9,0x1c,0x35,0x57, /* ..2.!......J..5W */ \
	0x2e,0xa9,0xbd,0xce,0xd9,0x1e,0xdf,0xc1,0xf3,0x4b,0xf5,0xce,0x33,0xd8,0x1d,0x1f, /* .........K..3... */ \
	0x69,0x1d,0xe1,0x04,0x1f,0x13,0x7b,0x58,0xb3,0x4e,0xfc,0xdc,0x5e,0xed,0x2f,0xf7, /* i.....{X.N..^./. */ \
	0x3e,0xf3,0xe7,0xae,0xc1,0xe9,0x70,0xc3,0x8c,0x80,0x27,0xe2,0x6a,0xf9,0x25,0x21, /* >.....p...'.j.%! */ \
	0x14,0xf6,0xc2,0xd7,0x6f,0xe8,0xcf,0x1a,0x63,0x10,0x77,0x7e,0x7c,0xca,0x99,0xad, /* ....o...c.w~|... */ \
	0xee,0x53,0xb0,0xb1,0xa5,0x5d,0xf3,0x6c,0x7f,0x3d,0x18,0x6b,0x7a,0xcb,0x67,0x4d, /* .S...].l.=.kz.gM */ \
	0x72,0xc1,0xd7,0x4c,0x10,0xe6,0x70,0xa2,0xf3,0x69,0xe5,0x67,0x61,0xed,0xd7,0x47, /* r..L..p..i.ga..G */ \
	0xc0,0xf6,0x83,0x6a,0xeb,0xd7,0x82,0x00,0x09,0x99,0x7f,0x9b,0x33,0x2e,0x2c,0x59, /* ...j........3.,Y */ \
	0xd9,0xc0,0x1d,0xf7,0xc1,0xa4,0xbe,0x9a,0x89,0x59,0x6d,0x27,0x5c,0xe0,0xfd,0x5d, /* .........Ym'\..] */ \
	0xcb,0xa1,0xad,0x89,0x59,0xb3,0xe4,0x86,0x63,0xc1,0xd8,0x60,0xe4,0x87,0x97,0x9a, /* ....Y...c..`.... */ \
	0x0d,0x9b,0xaa,0xc5,0x53,0xcd,0xac,0x6e,0x0b,0xa0,0xc0,0xac,0xbf,0x13,0xd4,0xcf, /* ....S..n........ */ \
	0xae,0x4b,0xbd,0x58,0xd7,0xd2,0xde,0x39,0xeb,0x04,0xce,0x67,0xea,0xce,0x9e,0xae, /* .K.X...9...g.... */ \
	0x36,0xf5,0x32,0xbf,0xef,0xb5,0x90,0xac,0x3d,0xe2,0xb6,0x5c,0xc3,0x2e,0xa8,0xee, /* 6.2.....=..\.... */ \
	0xbc,0xe2,0x04,0xf2,0x75,0x4c,0x27,0x6e,0x6d,0x27,0x00,0x0e,0x63,0xc1,0x93,0x3e, /* ....uL'nm'..c..> */ \
	0x2c,0xef,0xc7,0x82,0xff,0xfc,0xf9,0x19,0x76,0x8a,0xa7,0x2a,0x61,0x65,0xba,0x71, /* ,.......v...ae.q */ \
	0x15,0xda,0x35,0x6f,0x75,0xd5,0x64,0x04,0x6f,0xb7,0xae,0xf6,0xaf,0x8a,0x0f,0xe5, /* ..5ou.d.o....... */ \
	0xc6,0xa6,0x31,0x05,0x2b,0x05,0x38,0x8c,0xa6,0xfa,0x6b,0x0d,0x16,0xde,0x23,0x27, /* ..1.+.8...k...#' */ \
	0xe7,0x5e,0x57,0x6d,0x75,0x4b,0x5d,0xea,0xc6,0x0d,0x14,0xb7,0xff,0xb5,0x1c,0xb3, /* .^WmuK]......... */ \
	0x7e,0xb6,0x83,0x35,0x87,0x35,0x0b,0xdf,0xfd,0x93,0x43,0x2e,0x73,0xc3,0x96,0x36, /* ~..5.5....C.s..6 */ \
	0x90,0xe2,0xee,0xd6,0x31,0x75,0xc3,0xdc,0x96,0xfa,0xea,0x2e,0xe7,0xb4,0x09,0x50, /* ....1u.........P */ \
	0x28,0xdc,0x33,0x96,0xbe,0xf2,0xd8,0x6e,0xff,0xd3,0xd3,0x5d,0xcc,0x39,0xcd,0x44, /* (.3....n...].9.D */ \
	0x1c,0x4f,0x3e,0xb1,0xc9,0x58,0x54,0xaf,0x35,0xb5,0x1d,0xbd,0xf4,0x89,0xf3,0xee, /* .O>..XT.5....... */ \
	0xa4,0xc9,0x62,0xd7,0xaa,0x2a,0xcc,0x2f,0xb5,0x7a,0x73,0xc9,0xfc,0x4f,0x66,0xc4, /* ..b..../.zs..Of. */ \
	0xf9,0xc5,0x8b,0x07,0x28,0xd6,0x51,0x78,0xf6,0xef,0x37,0x67,0x81,0x8b,0x81,0xb9, /* ....(.Qx..7g.... */ \
	0xc2,0xc0,0x4e,0x31,0x60,0x1f,0x18,0x36,0x0a,0xf9,0x60,0xc5,0xff,0x02,0xd3,0x22, /* ..N1`..6..`...." */ \
	0xc0,0x8b,0xdf,0x10,0x00,0x00,0x89,0x50,0x4e,0x47,0x0d,0x0a,0x1a,0x0a,0x00,0x00, /* .......PNG...... */ \
	0x00,0x0d,0x49,0x48,0x44,0x52,0x00,0x00,0x00,0x13,0x00,0x00,0x00,0x0f,0x08,0x03, /* ..IHDR.......... */ \
	0x00,0x00,0x00,0x31,0x9a,0x04,0x1e,0x00,0x00,0x00,0x19,0x74,0x45,0x58,0x74,0x53, /* ...1.......tEXtS */ \
	0x6f,0x66,0x74,0x77,0x61,0x72,0x65,0x00,0x41,0x64,0x6f,0x62,0x65,0x20,0x49,0x6d, /* oftware.Adobe Im */ \
	0x61,0x67,0x65,0x52,0x65,0x61,0x64,0x79,0x71,0xc9,0x65,0x3c,0x00,0x00,0x00,0x39, /* ageReadyq.e<...9 */ \
	0x50,0x4c,0x54,0x45,0x81,0x81,0x81,0x5c,0x5c,0x5c,0x8b,0x8b,0x8b,0xc5,0xc5,0xc5, /* PLTE...\\\...... */ \
	0xbc,0xbc,0xbc,0x77,0x77,0x77,0x5e,0x5e,0x5e,0x78,0x78,0x78,0xb8,0xb8,0xb8,0xc6, /* ...www^^^xxx.... */ \
	0xc6,0xc6,0xb7,0xb7,0xb7,0xb5,0xb5,0xb5,0x8a,0x8a,0x8a,0x60,0x60,0x60,0xfd,0xfd, /* ...........```.. */ \
	0xfd,0xfb,0xfb,0xfb,0x5d,0x5d,0x5d,0xfc,0xfc,0xfc,0xff,0xff,0xff,0x81,0x07,0x29, /* ....]]]........) */ \
	0x88,0x00,0x00,0x00,0x6e,0x49,0x44,0x41,0x54,0x78,0xda,0x7c,0x90,0x0b,0x0e,0x80, /* ....nIDATx.|.... */ \
	0x20,0x0c,0x43,0xc7,0x4f,0xfc,0x6f,0xf3,0xfe,0x87,0xb5,0x10,0x74,0x18,0x8d,0x4d, /*  .C.O.o.....t..M */ \
	0x08,0xe4,0xa5,0x1d,0xdb,0xe8,0x78,0x8b,0x70,0x94,0x55,0x75,0x87,0x70,0x69,0x63, /* ......x.p.Uu.pic */ \
	0x05,0x4d,0x79,0xcb,0xe1,0xc1,0x38,0x88,0x5f,0xbc,0x04,0x24,0x8c,0xa5,0x15,0x51, /* .My...8._..$...Q */ \
	0x9f,0xcc,0x87,0xd7,0x30,0x83,0x8d,0x03,0x5b,0x96,0x55,0x22,0x58,0x14,0xee,0x7c, /* ....0...[.U"X..| */ \
	0x24,0x55,0x8e,0x94,0xef,0x7a,0x4e,0x9a,0x3a,0x9f,0xfc,0x32,0xcb,0x7e,0xf9,0xca, /* $U...zN.:..2.~.. */ \
	0x1f,0xa5,0x26,0xf5,0xfd,0x61,0x00,0x8c,0xcb,0x7d,0xcf,0x75,0x09,0x7a,0xed,0xe0, /* ..&..a...}.u.z.. */ \
	0x14,0x60,0x00,0x27,0x9e,0x11,0x7d,0x9d,0xca,0x9f,0xc1,0x00,0x00,0x00,0x00,0x49, /* .`.'..}........I */ \
	0x45,0x4e,0x44,0xae,0x42,0x60,0x82,0x1f,0x8b,0x08,0x00,0x00,0x00,0x00,0x00,0x00, /* END.B`.......... */ \
	0x00,0xad,0x8f,0xf9,0x4f,0x93,0x07,0x00,0x40,0xbf,0x1e,0x94,0x72,0x14,0x5a,0xb4, /* ....O...@...r.Z. */ \
	0xd0,0x72,0xd9,0x53,0x59,0x45,0x43,0x98,0x28,0xe0,0xd5,0xd2,0xd2,0x43,0x18,0xf9, /* .r.SYEC.(....C.. */ \
	0xc8,0x40,0x04,0x06,0x16,0x42,0x8b,0x32,0xc0,0x82,0x58,0x04,0xa7,0x2d,0x50,0x11, /* .@...B.2..X..-P. */ \
	0xb9,0x2a,0x47,0x05,0x0a,0x52,0x50,0xca,0x74,0x14,0x8b,0x12,0x04,0x65,0x0a,0xca, /* ..G..RP.t....e.. */ \
	0xa1,0x96,0xab,0xae,0x20,0x90,0x62,0x00,0x15,0x5c,0x16,0xae,0xb9,0x45,0xdd,0x70, /* .... .b..\...E.p */ \
	0xfd,0x16,0xb3,0x7f,0x61,0xef,0x87,0x97,0xbc,0x1f,0x1f,0x4f,0xc0,0xf5,0x0f,0x48, /* ....a......O...H */ \
	0xa8,0x05,0x18,0xc0,0x14,0x0d,0x90,0xc9,0x64,0x7d,0x7d,0x7d,0x16,0xac,0x1b,0xb4, /* ........d}}}.... */ \
	0xbe,0x01,0x4d,0xbc,0x58,0x5f,0x5f,0x97,0x48,0x24,0x13,0x13,0x13,0xd0,0xfc,0x22, /* ..M.X__.H$....." */ \
	0x16,0x8b,0xb5,0x90,0x18,0x16,0x9f,0x40,0x8d,0x46,0x03,0x82,0xa0,0x85,0x29,0x10, /* .......@.F....). */ \
	0x0a,0x85,0x24,0x12,0x49,0xa9,0x54,0xce,0xcf,0xcf,0x43,0xf2,0x42,0xbd,0x5e,0xef, /* ..$.I.T...C.B.^. */ \
	0xe3,0xe3,0x63,0x91,0x5d,0x84,0x34,0x2d,0x50,0xdf,0x13,0x0b,0x78,0xcc,0x22,0x91, /* ..c.].4-P...x.". */ \
	0x5a,0x84,0xc9,0x90,0xb2,0x1a,0x52,0xaa,0x20,0x7d,0xa7,0x45,0x92,0xcd,0x64,0x32, /* Z.....R. }.E..d2 */ \
	0x2d,0x80,0x3d,0x04,0x41,0x00,0x00,0xfc,0xe7,0xff,0x17,0xf2,0x5f,0x48,0x18,0x00, /* -.=.A......._H.. */ \
	0xd0,0x00,0xef,0x2f,0xf1,0xe5,0x09,0x40,0x41,0xcc,0x4a,0x09,0xdf,0xdb,0x55,0xf9, /* .../...@A.J...U. */ \
	0xac,0x25,0xf3,0x79,0x6a,0xa0,0xc6,0x78,0x33,0xeb,0x48,0x7b,0x8c,0x7e,0x46,0x27, /* .%.yj..x3.H{.~F' */ \
	0x1d,0x59,0xcd,0xbd,0x84,0x2c,0x61,0x63,0x19,0x35,0x56,0x0e,0x0e,0xaf,0x47,0xd2, /* .Y...,ac.5V...G. */ \
	0x7b,0xcb,0x10,0x25,0x4f,0x42,0xf5,0x97,0xdc,0x91,0x64,0x20,0xf1,0xec,0x26,0x14, /* {..%OB....d ..&. */ \
	0xe1,0x9c,0x24,0x55,0x88,0x6c,0x11,0x34,0x94,0x0d,0x46,0x5e,0x56,0x2e,0x40,0xdb, /* ..$U.l.4..F^V.@. */ \
	0x5d,0xac,0x12,0x39,0xd3,0x30,0x78,0x92,0xb2,0xbe,0x1e,0x59,0x50,0x5d,0x95,0x03, /* ]..9.0x....YP].. */ \
	0xb3,0x6a,0xd0,0xca,0x1a,0x9b,0x9a,0xec,0x5a,0x75,0xa7,0x6e,0xde,0x6a,0x72,0xff, /* .j......Zu.n.jr. */ \
	0xc6,0x8a,0x44,0x25,0x59,0xf3,0xac,0x30,0xf7,0x5a,0xda,0x75,0x88,0xd3,0x52,0x17, /* ..D%Y..0.Z.u..R. */ \
	0x8a,0x5b,0x95,0x1d,0x5a,0x0f,0xff,0x3e,0x04,0x47,0x1d,0x57,0x73,0x1d,0xc7,0xa9, /* .[..Z..>.G.Ws... */ \
	0xe7,0x1f,0xb5,0x6e,0x53,0x6c,0xa1,0x98,0x2b,0xa5,0x06,0x33,0x41,0xec,0x10,0x8a, /* ...nSl..+..3A... */ \
	0x32,0x51,0x9d,0x82,0xad,0x96,0x8d,0x2f,0xeb,0xd1,0x0a,0x3b,0xb3,0x19,0xa9,0x18, /* 2Q...../...;.... */ \
	0x78,0x4f,0x14,0x7b,0x86,0x74,0x99,0xa6,0xd8,0x63,0xa6,0x99,0xae,0xd3,0x11,0xba, /* xO.{.t...c...... */ \
	0xf1,0x7d,0x39,0x94,0xed,0x93,0xcf,0xe5,0xe0,0xa0,0x9c,0x05,0xc7,0xd2,0x17,0xdf, /* .}9............. */ \
	0x79,0xb3,0x70,0xe8,0x65,0x2e,0x3a,0x00,0xb8,0xfe,0xa6,0xaf,0x9c,0xc4,0x3a,0x44, /* y.p.e.:.......:D */ \
	0xc2,0xdf,0x4d,0x42,0xa0,0xd8,0xb6,0x04,0xaf,0xd9,0x3b,0x2c,0x79,0xf5,0xce,0xe8, /* ..MB......;,y... */ \
	0xfc,0x22,0x66,0x3e,0x15,0x2d,0x0b,0x22,0x64,0x71,0x88,0x5b,0xb4,0xa3,0x50,0xb9, /* ."f>.-."dq.[..P. */ \
	0xa3,0xd7,0x15,0x02,0xa8,0x6f,0x1e,0x10,0x92,0x29,0xae,0x0f,0x85,0xe2,0x82,0xca, /* .....o...)...... */ \
	0x52,0x2a,0x68,0x6b,0x03,0x9c,0xf9,0x6d,0x0f,0xb9,0xb7,0x29,0x8c,0x7d,0x6b,0xca, /* R.hk...m...).}k. */ \
	0xdd,0x00,0xc7,0x3f,0x08,0x3c,0x17,0x0d,0xdc,0x98,0x81,0x47,0xa4,0xe1,0x61,0x0b, /* ...?.<.....G..a. */ \
	0xf6,0x80,0xcd,0x85,0xf4,0xa1,0xc0,0x1b,0xfd,0x93,0x4d,0xe1,0x12,0x71,0xe0,0x1c, /* ..........M..q.. */ \
	0x7e,0xb1,0xdf,0xbe,0x90,0x06,0xce,0x0a,0x46,0x8a,0x76,0xb6,0x73,0x6d,0x32,0x79, /* ~.......F.v.sm2y */ \
	0x83,0xaa,0xb6,0xcb,0xac,0x44,0x6e,0xf9,0x12,0x8a,0xbf,0xf3,0x0a,0x32,0x76,0xe8, /* .....Dn......2v. */ \
	0x94,0xb9,0x92,0x6f,0x0f,0xd3,0x78,0xa4,0x65,0xdb,0x31,0xfc,0x8a,0x85,0xc6,0x66, /* ...o..x.e.1....f */ \
	0xaa,0x75,0x2b,0xbd,0xb6,0x30,0xec,0xda,0xd7,0x9d,0xd4,0x78,0xd7,0xed,0x2c,0xf2, /* .u+..0.....x..,. */ \
	0xef,0x89,0xb1,0xe4,0xc8,0xd8,0xa3,0x18,0xdf,0x95,0xa9,0xc7,0x89,0x3b,0x0e,0xc7, /* .............;.. */ \
	0xb6,0x11,0xd7,0x96,0x93,0xef,0xff,0x48,0x6e,0x67,0x2f,0xac,0x0d,0xf8,0xda,0xaf, /* .......Hng/..... */ \
	0x33,0x74,0x59,0x83,0x3e,0xcc,0x14,0xda,0xed,0xe3,0x2e,0x81,0x9b,0x99,0xf0,0x2c, /* 3tY.>.........., */ \
	0xfe,0x6d,0x27,0xd6,0x8a,0x77,0x67,0x0c,0x65,0x7a,0xac,0xe0,0x57,0x91,0xc2,0x37, /* .m'..wg.ez..W..7 */ \
	0x63,0x74,0x78,0xc8,0x91,0x7c,0xf8,0xfa,0xb8,0xe2,0x51,0xf6,0x87,0xdc,0x8d,0xde, /* ctx..|....Q..... */ \
	0xee,0xd8,0xa2,0x03,0xc1,0x93,0x47,0x1b,0xa3,0x9d,0x1f,0xa3,0xae,0x8a,0x5f,0x61, /* ......G......._a */ \
	0xac,0x8f,0xe5,0x04,0x7f,0x27,0x9a,0x3b,0xeb,0x90,0x52,0xa8,0x48,0x88,0xbb,0x8f, /* .....'.;..R.H... */ \
	0xdf,0x56,0xc0,0x09,0x65,0xf3,0x0e,0x68,0x55,0xcd,0xd0,0x74,0xdc,0x27,0x8f,0x4c, /* .V..e..hU..t.'.L */ \
	0x97,0x83,0x22,0xdd,0xfb,0x46,0xee,0x92,0x3f,0x62,0x0e,0xb1,0x7c,0x5f,0xb5,0x90, /* .."..F..?b..|_.. */ \
	0xb3,0x58,0xe6,0x37,0x9b,0x04,0x44,0x1a,0xaf,0xe3,0x70,0x89,0x7b,0x9b,0xd3,0xf6, /* .X.7..D...p.{... */ \
	0x19,0xba,0x2b,0x0a,0x93,0x49,0x1d,0x63,0x59,0xd6,0x7e,0x93,0x09,0x68,0xd7,0x15, /* ..+..I.cY.~..h.. */ \
	0x6d,0x1e,0xf1,0x2e,0x36,0x83,0x88,0xa4,0x19,0x93,0xcb,0xc1,0xcf,0x27,0xde,0x27, /* m...6........'.' */ \
	0x8a,0x30,0x86,0xa1,0xd7,0x05,0xc4,0xab,0x4f,0x45,0xe7,0x0e,0xc4,0x7b,0xd5,0x10, /* .0......OE...{.. */ \
	0x3f,0x48,0x10,0xaf,0xe2,0x3d,0x6a,0x5f,0x34,0x84,0xf7,0x23,0x05,0x1c,0x55,0x10, /* ?H...=j_4..#..U. */ \
	0xf8,0xa7,0x1a,0xfb,0x55,0x4c,0xce,0x94,0xe8,0x98,0x74,0x76,0x2a,0x7b,0x9f,0xd3, /* ....UL....tv.{.. */ \
	0xa2,0x9a,0x7b,0xdc,0xb9,0xe2,0x28,0x9c,0x5e,0x27,0x6a,0x16,0x5f,0x8e,0x04,0x87, /* ..{...(.^'j._... */ \
	0x51,0x98,0x0a,0x42,0xbe,0xf5,0x3f,0xaa,0x9e,0x28,0x7f,0xd1,0x67,0x3f,0x64,0x03, /* Q..B..?..(..g?d. */ \
	0x8d,0xb3,0xb7,0x2c,0xb6,0xb7,0x4c,0xf8,0xa2,0x04,0xdc,0xed,0xf5,0xf2,0x2a,0x03, /* ...,..L......... */ \
	0x55,0x4b,0x2d,0xd9,0xff,0xe4,0x26,0x2f,0xa3,0xc8,0x10,0x9c,0x07,0xa7,0xec,0xe5, /* UK-...&/........ */ \
	0xbc,0x05,0xa8,0x6a,0x98,0x3a,0xbc,0x51,0x40,0x1b,0x4c,0x99,0xa9,0x00,0x01,0xfd, /* ...j.:.Q@.L..... */ \
	0xb8,0x3c,0xbb,0x8e,0xdb,0x79,0x52,0x6d,0x13,0x72,0x3e,0xd5,0xb6,0xff,0x2e,0x90, /* .<...yRm.r>..... */ \
	0xa4,0x15,0x14,0x53,0xdd,0xcd,0xb8,0x8e,0x1a,0x24,0xcd,0x04,0x5b,0x0b,0x78,0xce, /* ...S.....$..[.x. */ \
	0x10,0x1b,0x7c,0x7b,0x57,0x42,0x88,0xba,0x93,0x2d,0x44,0xc1,0x11,0x97,0x96,0xd3, /* ..|{WB...-D..... */ \
	0x70,0xaf,0x2b,0x90,0xb6,0x9c,0x06,0x3c,0xe5,0x87,0x99,0x9a,0xce,0x44,0xa6,0x64, /* p.+....<.....D.d */ \
	0xd2,0x4b,0x9a,0x23,0x53,0xe2,0xa6,0x55,0xdb,0xff,0x4e,0xa1,0x37,0xfc,0x74,0xcd, /* .K.#S..U..N.7.t. */ \
	0xd3,0xb0,0xfa,0x30,0xd8,0x98,0x1b,0xa5,0xfe,0x7c,0x87,0x58,0x8a,0x38,0x17,0x27, /* ...0.....|.X.8.' */ \
	0xc9,0xd3,0xd4,0xb7,0x6e,0x75,0x46,0xf6,0x2c,0xb8,0x99,0x53,0x97,0x23,0xcf,0x36, /* ....nuF.,..S.#.6 */ \
	0x70,0x39,0x3d,0x1f,0xdb,0xda,0xc2,0xe1,0x6d,0xf8,0x7b,0xb6,0x0e,0x19,0x75,0xfd, /* p9=.....m.{...u. */ \
	0xdd,0xf4,0x3b,0xd3,0x15,0x85,0xa5,0x9f,0x04,0x75,0x5c,0x5c,0x82,0x69,0x57,0xc8, /* ..;......u\\.iW. */ \
	0xe8,0x0f,0xfd,0xa3,0x41,0x5b,0x37,0xe4,0xcf,0x4c,0x7b,0x98,0x95,0x3c,0xdf,0xec, /* ....A[7..L{..<.. */ \
	0x88,0x31,0x58,0xb4,0x28,0x22,0x0f,0x74,0xc3,0xa7,0x85,0xc1,0xcf,0xcf,0x28,0xbe, /* .1X.(".t......(. */ \
	0x6d,0xdd,0x4f,0x77,0xf2,0xe3,0x1f,0x99,0x5b,0xd2,0xb4,0x73,0xe3,0x0e,0xc6,0xb0, /* m.Ow....[..s.... */ \
	0x11,0x67,0x56,0x15,0xe1,0x21,0x4e,0x94,0xf4,0x20,0x29,0xe7,0x69,0xd7,0xf4,0x89, /* .gV..!N.. ).i... */ \
	0xa8,0x5d,0x8e,0xda,0x8d,0x67,0x6f,0x4e,0x78,0x10,0x1a,0xae,0x7d,0x98,0xe3,0xa5, /* .]...goNx...}... */ \
	0xfe,0x31,0x47,0xcb,0xed,0x12,0xf0,0x75,0x14,0xe3,0x6a,0x37,0xce,0xbc,0xc0,0xbb, /* .1G....u..j7.... */ \
	0x8c,0x8a,0x32,0x87,0xa7,0xcf,0xcb,0x76,0xec,0x46,0x8e,0x74,0x28,0xf2,0x7b,0x5e, /* ..2....v.F.t(.{^ */ \
	0x17,0xf7,0xfd,0xe2,0x4f,0x86,0x03,0xe8,0x80,0xb7,0x15,0xa1,0xe9,0x97,0x10,0x0f, /* ....O........... */ \
	0xe2,0x2f,0x04,0x58,0x6b,0xf6,0xec,0x66,0x56,0x35,0xd6,0x1c,0xaa,0x76,0xef,0xf0, /* ./.Xk..fV5...v.. */ \
	0x12,0xb2,0xde,0xb5,0xd6,0x7b,0x0e,0x13,0x50,0x01,0xc2,0xbc,0xa5,0xf6,0xe9,0x74, /* .....{..P......t */ \
	0xfb,0xcd,0xd5,0x9e,0x77,0xb7,0x37,0xd7,0x7e,0xfe,0xe8,0x19,0x8c,0x05,0xf6,0xff, /* ....w.7.~....... */ \
	0x0b,0xa6,0x2b,0xee,0xb4,0xef,0x04,0x00,0x00                                     /* ..+......        */


};
</#if><#-- CONFIG_DRV_WIFI_HTTP_CUSTOM_TEMPLATE -->

/**************************************
 * MPFS2 C linkable symbols
 **************************************/
// The entire data array is defined as a single variable to 
// ensure that the linker does not reorder the data chunks in Flash when compiler 
// optimizations are turned on.
struct MEDIA_STORAGE_PARTITION_INFO
{
	const char*     partName;           // name that identifies the partition
										// valid names: "mpfs2", "tcpip_storage";
	unsigned long   partStartOffset;    // the absolute starting offset on that media 
	unsigned long   partSize;           // size of the partition, in bytes
} MPFS_IMAGE_PARTITION_INFO = 
{
	"mpfs2",
	(unsigned long)NVM_MEDIA_DATA,
	sizeof(NVM_MEDIA_DATA),
};

/**************************************************************
 * End of MPFS
 **************************************************************/
